import{S as Oa,i as Ma,s as Na,e as n,k as m,w,t as r,M as La,c as s,d as o,m as h,a,x as y,h as i,b as d,N as Sa,G as e,g as p,y as D,q as T,o as x,B as $,v as Ra,L as qs}from"../../chunks/vendor-hf-doc-builder.js";import{T as Fa}from"../../chunks/Tip-hf-doc-builder.js";import{D as X}from"../../chunks/Docstring-hf-doc-builder.js";import{C as Fs}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as Ge}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as As}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function Ua(z){let f,v,_,u,b;return u=new Fs({props:{code:`from transformers import DetaConfig, DetaModel

# Initializing a DETA SenseTime/deformable-detr style configuration
configuration = DetaConfig()

# Initializing a model (with random weights) from the SenseTime/deformable-detr style configuration
model = DetaModel(configuration)

# Accessing the model configuration
configuration = model.config`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> DetaConfig, DetaModel

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a DETA SenseTime/deformable-detr style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = DetaConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a model (with random weights) from the SenseTime/deformable-detr style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = DetaModel(configuration)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Accessing the model configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = model.config`}}),{c(){f=n("p"),v=r("Examples:"),_=m(),w(u.$$.fragment)},l(c){f=s(c,"P",{});var g=a(f);v=i(g,"Examples:"),g.forEach(o),_=h(c),y(u.$$.fragment,c)},m(c,g){p(c,f,g),e(f,v),p(c,_,g),D(u,c,g),b=!0},p:qs,i(c){b||(T(u.$$.fragment,c),b=!0)},o(c){x(u.$$.fragment,c),b=!1},d(c){c&&o(f),c&&o(_),$(u,c)}}}function Ha(z){let f,v,_,u,b;return{c(){f=n("p"),v=r("Although the recipe for forward pass needs to be defined within this function, one should call the "),_=n("code"),u=r("Module"),b=r(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(c){f=s(c,"P",{});var g=a(f);v=i(g,"Although the recipe for forward pass needs to be defined within this function, one should call the "),_=s(g,"CODE",{});var A=a(_);u=i(A,"Module"),A.forEach(o),b=i(g,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),g.forEach(o)},m(c,g){p(c,f,g),e(f,v),e(f,_),e(_,u),e(f,b)},d(c){c&&o(f)}}}function Wa(z){let f,v,_,u,b;return u=new Fs({props:{code:`from transformers import AutoImageProcessor, DetaModel
from PIL import Image
import requests

url = "http://images.cocodataset.org/val2017/000000039769.jpg"
image = Image.open(requests.get(url, stream=True).raw)

image_processor = AutoImageProcessor.from_pretrained("jozhang97/deta-swin-large-o365")
model = DetaModel.from_pretrained("jozhang97/deta-swin-large-o365", two_stage=False)

inputs = image_processor(images=image, return_tensors="pt")

outputs = model(**inputs)

last_hidden_states = outputs.last_hidden_state
list(last_hidden_states.shape)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoImageProcessor, DetaModel
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests

<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;http://images.cocodataset.org/val2017/000000039769.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)

<span class="hljs-meta">&gt;&gt;&gt; </span>image_processor = AutoImageProcessor.from_pretrained(<span class="hljs-string">&quot;jozhang97/deta-swin-large-o365&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = DetaModel.from_pretrained(<span class="hljs-string">&quot;jozhang97/deta-swin-large-o365&quot;</span>, two_stage=<span class="hljs-literal">False</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = image_processor(images=image, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span>last_hidden_states = outputs.last_hidden_state
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">list</span>(last_hidden_states.shape)
[<span class="hljs-number">1</span>, <span class="hljs-number">900</span>, <span class="hljs-number">256</span>]`}}),{c(){f=n("p"),v=r("Examples:"),_=m(),w(u.$$.fragment)},l(c){f=s(c,"P",{});var g=a(f);v=i(g,"Examples:"),g.forEach(o),_=h(c),y(u.$$.fragment,c)},m(c,g){p(c,f,g),e(f,v),p(c,_,g),D(u,c,g),b=!0},p:qs,i(c){b||(T(u.$$.fragment,c),b=!0)},o(c){x(u.$$.fragment,c),b=!1},d(c){c&&o(f),c&&o(_),$(u,c)}}}function Va(z){let f,v,_,u,b;return{c(){f=n("p"),v=r("Although the recipe for forward pass needs to be defined within this function, one should call the "),_=n("code"),u=r("Module"),b=r(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(c){f=s(c,"P",{});var g=a(f);v=i(g,"Although the recipe for forward pass needs to be defined within this function, one should call the "),_=s(g,"CODE",{});var A=a(_);u=i(A,"Module"),A.forEach(o),b=i(g,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),g.forEach(o)},m(c,g){p(c,f,g),e(f,v),e(f,_),e(_,u),e(f,b)},d(c){c&&o(f)}}}function Ba(z){let f,v,_,u,b;return u=new Fs({props:{code:`from transformers import AutoImageProcessor, DetaForObjectDetection
from PIL import Image
import requests

url = "http://images.cocodataset.org/val2017/000000039769.jpg"
image = Image.open(requests.get(url, stream=True).raw)

image_processor = AutoImageProcessor.from_pretrained("jozhang97/deta-swin-large")
model = DetaForObjectDetection.from_pretrained("jozhang97/deta-swin-large")

inputs = image_processor(images=image, return_tensors="pt")
outputs = model(**inputs)

# convert outputs (bounding boxes and class logits) to COCO API
target_sizes = torch.tensor([image.size[::-1]])
results = image_processor.post_process_object_detection(outputs, threshold=0.5, target_sizes=target_sizes)[
    0
]
for score, label, box in zip(results["scores"], results["labels"], results["boxes"]):
    box = [round(i, 2) for i in box.tolist()]
    print(
        f"Detected {model.config.id2label[label.item()]} with confidence "
        f"{round(score.item(), 3)} at location {box}"
    )`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoImageProcessor, DetaForObjectDetection
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests

<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;http://images.cocodataset.org/val2017/000000039769.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)

<span class="hljs-meta">&gt;&gt;&gt; </span>image_processor = AutoImageProcessor.from_pretrained(<span class="hljs-string">&quot;jozhang97/deta-swin-large&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = DetaForObjectDetection.from_pretrained(<span class="hljs-string">&quot;jozhang97/deta-swin-large&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = image_processor(images=image, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># convert outputs (bounding boxes and class logits) to COCO API</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>target_sizes = torch.tensor([image.size[::-<span class="hljs-number">1</span>]])
<span class="hljs-meta">&gt;&gt;&gt; </span>results = image_processor.post_process_object_detection(outputs, threshold=<span class="hljs-number">0.5</span>, target_sizes=target_sizes)[
<span class="hljs-meta">... </span>    <span class="hljs-number">0</span>
<span class="hljs-meta">... </span>]
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">for</span> score, label, box <span class="hljs-keyword">in</span> <span class="hljs-built_in">zip</span>(results[<span class="hljs-string">&quot;scores&quot;</span>], results[<span class="hljs-string">&quot;labels&quot;</span>], results[<span class="hljs-string">&quot;boxes&quot;</span>]):
<span class="hljs-meta">... </span>    box = [<span class="hljs-built_in">round</span>(i, <span class="hljs-number">2</span>) <span class="hljs-keyword">for</span> i <span class="hljs-keyword">in</span> box.tolist()]
<span class="hljs-meta">... </span>    <span class="hljs-built_in">print</span>(
<span class="hljs-meta">... </span>        <span class="hljs-string">f&quot;Detected <span class="hljs-subst">{model.config.id2label[label.item()]}</span> with confidence &quot;</span>
<span class="hljs-meta">... </span>        <span class="hljs-string">f&quot;<span class="hljs-subst">{<span class="hljs-built_in">round</span>(score.item(), <span class="hljs-number">3</span>)}</span> at location <span class="hljs-subst">{box}</span>&quot;</span>
<span class="hljs-meta">... </span>    )
Detected cat <span class="hljs-keyword">with</span> confidence <span class="hljs-number">0.683</span> at location [<span class="hljs-number">345.85</span>, <span class="hljs-number">23.68</span>, <span class="hljs-number">639.86</span>, <span class="hljs-number">372.83</span>]
Detected cat <span class="hljs-keyword">with</span> confidence <span class="hljs-number">0.683</span> at location [<span class="hljs-number">8.8</span>, <span class="hljs-number">52.49</span>, <span class="hljs-number">316.93</span>, <span class="hljs-number">473.45</span>]
Detected remote <span class="hljs-keyword">with</span> confidence <span class="hljs-number">0.568</span> at location [<span class="hljs-number">40.02</span>, <span class="hljs-number">73.75</span>, <span class="hljs-number">175.96</span>, <span class="hljs-number">117.33</span>]
Detected remote <span class="hljs-keyword">with</span> confidence <span class="hljs-number">0.546</span> at location [<span class="hljs-number">333.68</span>, <span class="hljs-number">77.13</span>, <span class="hljs-number">370.12</span>, <span class="hljs-number">187.51</span>]`}}),{c(){f=n("p"),v=r("Examples:"),_=m(),w(u.$$.fragment)},l(c){f=s(c,"P",{});var g=a(f);v=i(g,"Examples:"),g.forEach(o),_=h(c),y(u.$$.fragment,c)},m(c,g){p(c,f,g),e(f,v),p(c,_,g),D(u,c,g),b=!0},p:qs,i(c){b||(T(u.$$.fragment,c),b=!0)},o(c){x(u.$$.fragment,c),b=!1},d(c){c&&o(f),c&&o(_),$(u,c)}}}function Ja(z){let f,v,_,u,b,c,g,A,Co,Vt,L,K,Dt,_e,Io,Tt,Ao,Bt,q,qo,be,Fo,Oo,Ze,Mo,No,Jt,Xe,Lo,Gt,Ke,xt,So,Zt,Ye,Ro,Xt,Qe,ve,Uo,et,Ho,Wo,Kt,Y,Os,Yt,Q,Vo,tt,Bo,Jo,Qt,F,Go,we,Zo,Xo,ye,Ko,Yo,eo,S,ee,$t,De,Qo,jt,en,to,ot,tn,oo,te,Te,on,xe,nn,sn,an,nt,rn,st,dn,no,at,cn,so,R,oe,Pt,$e,ln,Et,mn,ao,j,je,hn,U,pn,rt,fn,un,Pe,gn,_n,bn,H,vn,it,wn,yn,dt,Dn,Tn,xn,ne,$n,se,Ee,jn,W,Pn,ct,En,kn,kt,zn,Cn,ro,V,ae,zt,ke,In,Ct,An,io,k,ze,qn,It,Fn,On,re,Ce,Mn,At,Nn,Ln,ie,Ie,Sn,Ae,Rn,lt,Un,Hn,co,B,de,qt,qe,Wn,Ft,Vn,lo,P,Fe,Bn,Ot,Jn,Gn,Oe,Zn,mt,Xn,Kn,Yn,Me,Qn,Ne,es,ts,os,C,Le,ns,J,ss,ht,as,rs,Mt,is,ds,cs,ce,ls,le,mo,G,me,Nt,Se,ms,Lt,hs,ho,E,Re,ps,St,fs,us,Ue,gs,pt,_s,bs,vs,He,ws,We,ys,Ds,Ts,I,Ve,xs,Z,$s,ft,js,Ps,Rt,Es,ks,zs,he,Cs,pe,po;return c=new Ge({}),_e=new Ge({}),De=new Ge({}),$e=new Ge({}),je=new X({props:{name:"class transformers.DetaConfig",anchor:"transformers.DetaConfig",parameters:[{name:"backbone_config",val:" = None"},{name:"num_queries",val:" = 900"},{name:"max_position_embeddings",val:" = 2048"},{name:"encoder_layers",val:" = 6"},{name:"encoder_ffn_dim",val:" = 2048"},{name:"encoder_attention_heads",val:" = 8"},{name:"decoder_layers",val:" = 6"},{name:"decoder_ffn_dim",val:" = 1024"},{name:"decoder_attention_heads",val:" = 8"},{name:"encoder_layerdrop",val:" = 0.0"},{name:"is_encoder_decoder",val:" = True"},{name:"activation_function",val:" = 'relu'"},{name:"d_model",val:" = 256"},{name:"dropout",val:" = 0.1"},{name:"attention_dropout",val:" = 0.0"},{name:"activation_dropout",val:" = 0.0"},{name:"init_std",val:" = 0.02"},{name:"init_xavier_std",val:" = 1.0"},{name:"return_intermediate",val:" = True"},{name:"auxiliary_loss",val:" = False"},{name:"position_embedding_type",val:" = 'sine'"},{name:"num_feature_levels",val:" = 5"},{name:"encoder_n_points",val:" = 4"},{name:"decoder_n_points",val:" = 4"},{name:"two_stage",val:" = True"},{name:"two_stage_num_proposals",val:" = 300"},{name:"with_box_refine",val:" = True"},{name:"assign_first_stage",val:" = True"},{name:"class_cost",val:" = 1"},{name:"bbox_cost",val:" = 5"},{name:"giou_cost",val:" = 2"},{name:"mask_loss_coefficient",val:" = 1"},{name:"dice_loss_coefficient",val:" = 1"},{name:"bbox_loss_coefficient",val:" = 5"},{name:"giou_loss_coefficient",val:" = 2"},{name:"eos_coefficient",val:" = 0.1"},{name:"focal_alpha",val:" = 0.25"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.DetaConfig.backbone_config",description:`<strong>backbone_config</strong> (<code>PretrainedConfig</code> or <code>dict</code>, <em>optional</em>, defaults to <code>ResNetConfig()</code>) &#x2014;
The configuration of the backbone model.`,name:"backbone_config"},{anchor:"transformers.DetaConfig.num_queries",description:`<strong>num_queries</strong> (<code>int</code>, <em>optional</em>, defaults to 900) &#x2014;
Number of object queries, i.e. detection slots. This is the maximal number of objects <a href="/docs/transformers/pr_18559/en/model_doc/deta#transformers.DetaModel">DetaModel</a> can
detect in a single image. In case <code>two_stage</code> is set to <code>True</code>, we use <code>two_stage_num_proposals</code> instead.`,name:"num_queries"},{anchor:"transformers.DetaConfig.d_model",description:`<strong>d_model</strong> (<code>int</code>, <em>optional</em>, defaults to 256) &#x2014;
Dimension of the layers.`,name:"d_model"},{anchor:"transformers.DetaConfig.encoder_layers",description:`<strong>encoder_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 6) &#x2014;
Number of encoder layers.`,name:"encoder_layers"},{anchor:"transformers.DetaConfig.decoder_layers",description:`<strong>decoder_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 6) &#x2014;
Number of decoder layers.`,name:"decoder_layers"},{anchor:"transformers.DetaConfig.encoder_attention_heads",description:`<strong>encoder_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 8) &#x2014;
Number of attention heads for each attention layer in the Transformer encoder.`,name:"encoder_attention_heads"},{anchor:"transformers.DetaConfig.decoder_attention_heads",description:`<strong>decoder_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 8) &#x2014;
Number of attention heads for each attention layer in the Transformer decoder.`,name:"decoder_attention_heads"},{anchor:"transformers.DetaConfig.decoder_ffn_dim",description:`<strong>decoder_ffn_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 2048) &#x2014;
Dimension of the &#x201C;intermediate&#x201D; (often named feed-forward) layer in decoder.`,name:"decoder_ffn_dim"},{anchor:"transformers.DetaConfig.encoder_ffn_dim",description:`<strong>encoder_ffn_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 2048) &#x2014;
Dimension of the &#x201C;intermediate&#x201D; (often named feed-forward) layer in decoder.`,name:"encoder_ffn_dim"},{anchor:"transformers.DetaConfig.activation_function",description:`<strong>activation_function</strong> (<code>str</code> or <code>function</code>, <em>optional</em>, defaults to <code>&quot;relu&quot;</code>) &#x2014;
The non-linear activation function (function or string) in the encoder and pooler. If string, <code>&quot;gelu&quot;</code>,
<code>&quot;relu&quot;</code>, <code>&quot;silu&quot;</code> and <code>&quot;gelu_new&quot;</code> are supported.`,name:"activation_function"},{anchor:"transformers.DetaConfig.dropout",description:`<strong>dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
The dropout probability for all fully connected layers in the embeddings, encoder, and pooler.`,name:"dropout"},{anchor:"transformers.DetaConfig.attention_dropout",description:`<strong>attention_dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout ratio for the attention probabilities.`,name:"attention_dropout"},{anchor:"transformers.DetaConfig.activation_dropout",description:`<strong>activation_dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout ratio for activations inside the fully connected layer.`,name:"activation_dropout"},{anchor:"transformers.DetaConfig.init_std",description:`<strong>init_std</strong> (<code>float</code>, <em>optional</em>, defaults to 0.02) &#x2014;
The standard deviation of the truncated_normal_initializer for initializing all weight matrices.`,name:"init_std"},{anchor:"transformers.DetaConfig.init_xavier_std",description:`<strong>init_xavier_std</strong> (<code>float</code>, <em>optional</em>, defaults to 1) &#x2014;
The scaling factor used for the Xavier initialization gain in the HM Attention map module.
encoder_layerdrop &#x2014; (<code>float</code>, <em>optional</em>, defaults to 0.0):
The LayerDrop probability for the encoder. See the [LayerDrop paper](see <a href="https://arxiv.org/abs/1909.11556" rel="nofollow">https://arxiv.org/abs/1909.11556</a>)
for more details.`,name:"init_xavier_std"},{anchor:"transformers.DetaConfig.auxiliary_loss",description:`<strong>auxiliary_loss</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether auxiliary decoding losses (loss at each decoder layer) are to be used.`,name:"auxiliary_loss"},{anchor:"transformers.DetaConfig.position_embedding_type",description:`<strong>position_embedding_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;sine&quot;</code>) &#x2014;
Type of position embeddings to be used on top of the image features. One of <code>&quot;sine&quot;</code> or <code>&quot;learned&quot;</code>.`,name:"position_embedding_type"},{anchor:"transformers.DetaConfig.class_cost",description:`<strong>class_cost</strong> (<code>float</code>, <em>optional</em>, defaults to 1) &#x2014;
Relative weight of the classification error in the Hungarian matching cost.`,name:"class_cost"},{anchor:"transformers.DetaConfig.bbox_cost",description:`<strong>bbox_cost</strong> (<code>float</code>, <em>optional</em>, defaults to 5) &#x2014;
Relative weight of the L1 error of the bounding box coordinates in the Hungarian matching cost.`,name:"bbox_cost"},{anchor:"transformers.DetaConfig.giou_cost",description:`<strong>giou_cost</strong> (<code>float</code>, <em>optional</em>, defaults to 2) &#x2014;
Relative weight of the generalized IoU loss of the bounding box in the Hungarian matching cost.`,name:"giou_cost"},{anchor:"transformers.DetaConfig.mask_loss_coefficient",description:`<strong>mask_loss_coefficient</strong> (<code>float</code>, <em>optional</em>, defaults to 1) &#x2014;
Relative weight of the Focal loss in the panoptic segmentation loss.`,name:"mask_loss_coefficient"},{anchor:"transformers.DetaConfig.dice_loss_coefficient",description:`<strong>dice_loss_coefficient</strong> (<code>float</code>, <em>optional</em>, defaults to 1) &#x2014;
Relative weight of the DICE/F-1 loss in the panoptic segmentation loss.`,name:"dice_loss_coefficient"},{anchor:"transformers.DetaConfig.bbox_loss_coefficient",description:`<strong>bbox_loss_coefficient</strong> (<code>float</code>, <em>optional</em>, defaults to 5) &#x2014;
Relative weight of the L1 bounding box loss in the object detection loss.`,name:"bbox_loss_coefficient"},{anchor:"transformers.DetaConfig.giou_loss_coefficient",description:`<strong>giou_loss_coefficient</strong> (<code>float</code>, <em>optional</em>, defaults to 2) &#x2014;
Relative weight of the generalized IoU loss in the object detection loss.`,name:"giou_loss_coefficient"},{anchor:"transformers.DetaConfig.eos_coefficient",description:`<strong>eos_coefficient</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
Relative classification weight of the &#x2018;no-object&#x2019; class in the object detection loss.`,name:"eos_coefficient"},{anchor:"transformers.DetaConfig.num_feature_levels",description:`<strong>num_feature_levels</strong> (<code>int</code>, <em>optional</em>, defaults to 5) &#x2014;
The number of input feature levels.`,name:"num_feature_levels"},{anchor:"transformers.DetaConfig.encoder_n_points",description:`<strong>encoder_n_points</strong> (<code>int</code>, <em>optional</em>, defaults to 4) &#x2014;
The number of sampled keys in each feature level for each attention head in the encoder.`,name:"encoder_n_points"},{anchor:"transformers.DetaConfig.decoder_n_points",description:`<strong>decoder_n_points</strong> (<code>int</code>, <em>optional</em>, defaults to 4) &#x2014;
The number of sampled keys in each feature level for each attention head in the decoder.`,name:"decoder_n_points"},{anchor:"transformers.DetaConfig.two_stage",description:`<strong>two_stage</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to apply a two-stage deformable DETR, where the region proposals are also generated by a variant of
DETA, which are further fed into the decoder for iterative bounding box refinement.`,name:"two_stage"},{anchor:"transformers.DetaConfig.two_stage_num_proposals",description:`<strong>two_stage_num_proposals</strong> (<code>int</code>, <em>optional</em>, defaults to 300) &#x2014;
The number of region proposals to be generated, in case <code>two_stage</code> is set to <code>True</code>.`,name:"two_stage_num_proposals"},{anchor:"transformers.DetaConfig.with_box_refine",description:`<strong>with_box_refine</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to apply iterative bounding box refinement, where each decoder layer refines the bounding boxes
based on the predictions from the previous layer.`,name:"with_box_refine"},{anchor:"transformers.DetaConfig.focal_alpha",description:`<strong>focal_alpha</strong> (<code>float</code>, <em>optional</em>, defaults to 0.25) &#x2014;
Alpha parameter in the focal loss.`,name:"focal_alpha"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/deta/configuration_deta.py#L31"}}),ne=new As({props:{anchor:"transformers.DetaConfig.example",$$slots:{default:[Ua]},$$scope:{ctx:z}}}),Ee=new X({props:{name:"to_dict",anchor:"transformers.DetaConfig.to_dict",parameters:[],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/deta/configuration_deta.py#L234"}}),ke=new Ge({}),ze=new X({props:{name:"class transformers.DetaImageProcessor",anchor:"transformers.DetaImageProcessor",parameters:[{name:"format",val:": typing.Union[str, transformers.models.deta.image_processing_deta.AnnotionFormat] = <AnnotionFormat.COCO_DETECTION: 'coco_detection'>"},{name:"do_resize",val:": bool = True"},{name:"size",val:": typing.Dict[str, int] = None"},{name:"resample",val:": Resampling = <Resampling.BILINEAR: 2>"},{name:"do_rescale",val:": bool = True"},{name:"rescale_factor",val:": typing.Union[int, float] = 0.00392156862745098"},{name:"do_normalize",val:": bool = True"},{name:"image_mean",val:": typing.Union[float, typing.List[float]] = None"},{name:"image_std",val:": typing.Union[float, typing.List[float]] = None"},{name:"do_pad",val:": bool = True"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.DetaImageProcessor.format",description:`<strong>format</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;coco_detection&quot;</code>) &#x2014;
Data format of the annotations. One of &#x201C;coco_detection&#x201D; or &#x201C;coco_panoptic&#x201D;.`,name:"format"},{anchor:"transformers.DetaImageProcessor.do_resize",description:`<strong>do_resize</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Controls whether to resize the image&#x2019;s (height, width) dimensions to the specified <code>size</code>. Can be
overridden by the <code>do_resize</code> parameter in the <code>preprocess</code> method.`,name:"do_resize"},{anchor:"transformers.DetaImageProcessor.size",description:`<strong>size</strong> (<code>Dict[str, int]</code> <em>optional</em>, defaults to <code>{&quot;shortest_edge&quot; -- 800, &quot;longest_edge&quot;: 1333}</code>):
Size of the image&#x2019;s (height, width) dimensions after resizing. Can be overridden by the <code>size</code> parameter in
the <code>preprocess</code> method.`,name:"size"},{anchor:"transformers.DetaImageProcessor.resample",description:`<strong>resample</strong> (<code>PILImageResampling</code>, <em>optional</em>, defaults to <code>PILImageResampling.BILINEAR</code>) &#x2014;
Resampling filter to use if resizing the image.`,name:"resample"},{anchor:"transformers.DetaImageProcessor.do_rescale",description:`<strong>do_rescale</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Controls whether to rescale the image by the specified scale <code>rescale_factor</code>. Can be overridden by the
<code>do_rescale</code> parameter in the <code>preprocess</code> method.`,name:"do_rescale"},{anchor:"transformers.DetaImageProcessor.rescale_factor",description:`<strong>rescale_factor</strong> (<code>int</code> or <code>float</code>, <em>optional</em>, defaults to <code>1/255</code>) &#x2014;
Scale factor to use if rescaling the image. Can be overridden by the <code>rescale_factor</code> parameter in the
<code>preprocess</code> method.
do_normalize &#x2014;
Controls whether to normalize the image. Can be overridden by the <code>do_normalize</code> parameter in the
<code>preprocess</code> method.`,name:"rescale_factor"},{anchor:"transformers.DetaImageProcessor.image_mean",description:`<strong>image_mean</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to <code>IMAGENET_DEFAULT_MEAN</code>) &#x2014;
Mean values to use when normalizing the image. Can be a single value or a list of values, one for each
channel. Can be overridden by the <code>image_mean</code> parameter in the <code>preprocess</code> method.`,name:"image_mean"},{anchor:"transformers.DetaImageProcessor.image_std",description:`<strong>image_std</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to <code>IMAGENET_DEFAULT_STD</code>) &#x2014;
Standard deviation values to use when normalizing the image. Can be a single value or a list of values, one
for each channel. Can be overridden by the <code>image_std</code> parameter in the <code>preprocess</code> method.`,name:"image_std"},{anchor:"transformers.DetaImageProcessor.do_pad",description:`<strong>do_pad</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Controls whether to pad the image to the largest image in a batch and create a pixel mask. Can be
overridden by the <code>do_pad</code> parameter in the <code>preprocess</code> method.`,name:"do_pad"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/deta/image_processing_deta.py#L449"}}),Ce=new X({props:{name:"preprocess",anchor:"transformers.DetaImageProcessor.preprocess",parameters:[{name:"images",val:": typing.Union[ForwardRef('PIL.Image.Image'), numpy.ndarray, ForwardRef('torch.Tensor'), typing.List[ForwardRef('PIL.Image.Image')], typing.List[numpy.ndarray], typing.List[ForwardRef('torch.Tensor')]]"},{name:"annotations",val:": typing.Union[typing.List[typing.Dict], typing.List[typing.List[typing.Dict]], NoneType] = None"},{name:"return_segmentation_masks",val:": bool = None"},{name:"masks_path",val:": typing.Union[str, pathlib.Path, NoneType] = None"},{name:"do_resize",val:": typing.Optional[bool] = None"},{name:"size",val:": typing.Union[typing.Dict[str, int], NoneType] = None"},{name:"resample",val:" = None"},{name:"do_rescale",val:": typing.Optional[bool] = None"},{name:"rescale_factor",val:": typing.Union[int, float, NoneType] = None"},{name:"do_normalize",val:": typing.Optional[bool] = None"},{name:"image_mean",val:": typing.Union[float, typing.List[float], NoneType] = None"},{name:"image_std",val:": typing.Union[float, typing.List[float], NoneType] = None"},{name:"do_pad",val:": typing.Optional[bool] = None"},{name:"format",val:": typing.Union[str, transformers.models.deta.image_processing_deta.AnnotionFormat, NoneType] = None"},{name:"return_tensors",val:": typing.Union[str, transformers.utils.generic.TensorType, NoneType] = None"},{name:"data_format",val:": typing.Union[str, transformers.image_utils.ChannelDimension] = <ChannelDimension.FIRST: 'channels_first'>"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.DetaImageProcessor.preprocess.images",description:`<strong>images</strong> (<code>ImageInput</code>) &#x2014;
Image or batch of images to preprocess.`,name:"images"},{anchor:"transformers.DetaImageProcessor.preprocess.annotations",description:`<strong>annotations</strong> (<code>List[Dict]</code> or <code>List[List[Dict]]</code>, <em>optional</em>) &#x2014;
List of annotations associated with the image or batch of images. If annotionation is for object
detection, the annotations should be a dictionary with the following keys:<ul>
<li>&#x201C;image_id&#x201D; (<code>int</code>): The image id.</li>
<li>&#x201C;annotations&#x201D; (<code>List[Dict]</code>): List of annotations for an image. Each annotation should be a
dictionary. An image can have no annotations, in which case the list should be empty.
If annotionation is for segmentation, the annotations should be a dictionary with the following keys:</li>
<li>&#x201C;image_id&#x201D; (<code>int</code>): The image id.</li>
<li>&#x201C;segments_info&#x201D; (<code>List[Dict]</code>): List of segments for an image. Each segment should be a dictionary.
An image can have no segments, in which case the list should be empty.</li>
<li>&#x201C;file_name&#x201D; (<code>str</code>): The file name of the image.</li>
</ul>`,name:"annotations"},{anchor:"transformers.DetaImageProcessor.preprocess.return_segmentation_masks",description:`<strong>return_segmentation_masks</strong> (<code>bool</code>, <em>optional</em>, defaults to self.return_segmentation_masks) &#x2014;
Whether to return segmentation masks.`,name:"return_segmentation_masks"},{anchor:"transformers.DetaImageProcessor.preprocess.masks_path",description:`<strong>masks_path</strong> (<code>str</code> or <code>pathlib.Path</code>, <em>optional</em>) &#x2014;
Path to the directory containing the segmentation masks.`,name:"masks_path"},{anchor:"transformers.DetaImageProcessor.preprocess.do_resize",description:`<strong>do_resize</strong> (<code>bool</code>, <em>optional</em>, defaults to self.do_resize) &#x2014;
Whether to resize the image.`,name:"do_resize"},{anchor:"transformers.DetaImageProcessor.preprocess.size",description:`<strong>size</strong> (<code>Dict[str, int]</code>, <em>optional</em>, defaults to self.size) &#x2014;
Size of the image after resizing.`,name:"size"},{anchor:"transformers.DetaImageProcessor.preprocess.resample",description:`<strong>resample</strong> (<code>PILImageResampling</code>, <em>optional</em>, defaults to self.resample) &#x2014;
Resampling filter to use when resizing the image.`,name:"resample"},{anchor:"transformers.DetaImageProcessor.preprocess.do_rescale",description:`<strong>do_rescale</strong> (<code>bool</code>, <em>optional</em>, defaults to self.do_rescale) &#x2014;
Whether to rescale the image.`,name:"do_rescale"},{anchor:"transformers.DetaImageProcessor.preprocess.rescale_factor",description:`<strong>rescale_factor</strong> (<code>float</code>, <em>optional</em>, defaults to self.rescale_factor) &#x2014;
Rescale factor to use when rescaling the image.`,name:"rescale_factor"},{anchor:"transformers.DetaImageProcessor.preprocess.do_normalize",description:`<strong>do_normalize</strong> (<code>bool</code>, <em>optional</em>, defaults to self.do_normalize) &#x2014;
Whether to normalize the image.`,name:"do_normalize"},{anchor:"transformers.DetaImageProcessor.preprocess.image_mean",description:`<strong>image_mean</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to self.image_mean) &#x2014;
Mean to use when normalizing the image.`,name:"image_mean"},{anchor:"transformers.DetaImageProcessor.preprocess.image_std",description:`<strong>image_std</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to self.image_std) &#x2014;
Standard deviation to use when normalizing the image.`,name:"image_std"},{anchor:"transformers.DetaImageProcessor.preprocess.do_pad",description:`<strong>do_pad</strong> (<code>bool</code>, <em>optional</em>, defaults to self.do_pad) &#x2014;
Whether to pad the image.`,name:"do_pad"},{anchor:"transformers.DetaImageProcessor.preprocess.format",description:`<strong>format</strong> (<code>str</code> or <code>AnnotionFormat</code>, <em>optional</em>, defaults to self.format) &#x2014;
Format of the annotations.`,name:"format"},{anchor:"transformers.DetaImageProcessor.preprocess.return_tensors",description:`<strong>return_tensors</strong> (<code>str</code> or <code>TensorType</code>, <em>optional</em>, defaults to self.return_tensors) &#x2014;
Type of tensors to return. If <code>None</code>, will return the list of images.`,name:"return_tensors"},{anchor:"transformers.DetaImageProcessor.preprocess.data_format",description:`<strong>data_format</strong> (<code>str</code> or <code>ChannelDimension</code>, <em>optional</em>, defaults to self.data_format) &#x2014;
The channel dimension format of the image. If not provided, it will be the same as the input image.`,name:"data_format"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/deta/image_processing_deta.py#L739"}}),Ie=new X({props:{name:"post_process_object_detection",anchor:"transformers.DetaImageProcessor.post_process_object_detection",parameters:[{name:"outputs",val:""},{name:"threshold",val:": float = 0.5"},{name:"target_sizes",val:": typing.Union[transformers.utils.generic.TensorType, typing.List[typing.Tuple]] = None"},{name:"nms_threshold",val:": float = 0.7"}],parametersDescription:[{anchor:"transformers.DetaImageProcessor.post_process_object_detection.outputs",description:`<strong>outputs</strong> (<code>DetrObjectDetectionOutput</code>) &#x2014;
Raw outputs of the model.`,name:"outputs"},{anchor:"transformers.DetaImageProcessor.post_process_object_detection.threshold",description:`<strong>threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.5) &#x2014;
Score threshold to keep object detection predictions.`,name:"threshold"},{anchor:"transformers.DetaImageProcessor.post_process_object_detection.target_sizes",description:`<strong>target_sizes</strong> (<code>torch.Tensor</code> or <code>List[Tuple[int, int]]</code>, <em>optional</em>) &#x2014;
Tensor of shape <code>(batch_size, 2)</code> or list of tuples (<code>Tuple[int, int]</code>) containing the target size
(height, width) of each image in the batch. If left to None, predictions will not be resized.`,name:"target_sizes"},{anchor:"transformers.DetaImageProcessor.post_process_object_detection.nms_threshold",description:`<strong>nms_threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.7) &#x2014;
NMS threshold.`,name:"nms_threshold"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/deta/image_processing_deta.py#L936",returnDescription:`
<p>A list of dictionaries, each dictionary containing the scores, labels and boxes for an image
in the batch as predicted by the model.</p>
`,returnType:`
<p><code>List[Dict]</code></p>
`}}),qe=new Ge({}),Fe=new X({props:{name:"class transformers.DetaModel",anchor:"transformers.DetaModel",parameters:[{name:"config",val:": DetaConfig"}],parametersDescription:[{anchor:"transformers.DetaModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/deta#transformers.DetaConfig">DetaConfig</a>) &#x2014;
Model configuration class with all the parameters of the model. Initializing with a config file does not
load the weights associated with the model, only the configuration. Check out the
<a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/deta/modeling_deta.py#L1359"}}),Le=new X({props:{name:"forward",anchor:"transformers.DetaModel.forward",parameters:[{name:"pixel_values",val:""},{name:"pixel_mask",val:" = None"},{name:"decoder_attention_mask",val:" = None"},{name:"encoder_outputs",val:" = None"},{name:"inputs_embeds",val:" = None"},{name:"decoder_inputs_embeds",val:" = None"},{name:"output_attentions",val:" = None"},{name:"output_hidden_states",val:" = None"},{name:"return_dict",val:" = None"}],parametersDescription:[{anchor:"transformers.DetaModel.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Padding will be ignored by default should you provide it.</p>
<p>Pixel values can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoImageProcessor">AutoImageProcessor</a>. See <code>AutoImageProcessor.__call__()</code> for details.`,name:"pixel_values"},{anchor:"transformers.DetaModel.forward.pixel_mask",description:`<strong>pixel_mask</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, height, width)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding pixel values. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for pixels that are real (i.e. <strong>not masked</strong>),</li>
<li>0 for pixels that are padding (i.e. <strong>masked</strong>).</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"pixel_mask"},{anchor:"transformers.DetaModel.forward.decoder_attention_mask",description:`<strong>decoder_attention_mask</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, num_queries)</code>, <em>optional</em>) &#x2014;
Not used by default. Can be used to mask object queries.`,name:"decoder_attention_mask"},{anchor:"transformers.DetaModel.forward.encoder_outputs",description:`<strong>encoder_outputs</strong> (<code>tuple(tuple(torch.FloatTensor)</code>, <em>optional</em>) &#x2014;
Tuple consists of (<code>last_hidden_state</code>, <em>optional</em>: <code>hidden_states</code>, <em>optional</em>: <code>attentions</code>)
<code>last_hidden_state</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) is a sequence of
hidden-states at the output of the last layer of the encoder. Used in the cross-attention of the decoder.`,name:"encoder_outputs"},{anchor:"transformers.DetaModel.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing the flattened feature map (output of the backbone + projection layer), you
can choose to directly pass a flattened representation of an image.`,name:"inputs_embeds"},{anchor:"transformers.DetaModel.forward.decoder_inputs_embeds",description:`<strong>decoder_inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of initializing the queries with a tensor of zeros, you can choose to directly pass an
embedded representation.`,name:"decoder_inputs_embeds"},{anchor:"transformers.DetaModel.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.DetaModel.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.DetaModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/deta/modeling_deta.py#L1524",returnDescription:`
<p>A <code>transformers.models.deta.modeling_deta.DetaModelOutput</code> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/deta#transformers.DetaConfig"
>DetaConfig</a>) and inputs.</p>
<ul>
<li><strong>init_reference_points</strong> (<code>torch.FloatTensor</code> of shape  <code>(batch_size, num_queries, 4)</code>) \u2014 Initial reference points sent through the Transformer decoder.</li>
<li><strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the decoder of the model.</li>
<li><strong>intermediate_hidden_states</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, config.decoder_layers, num_queries, hidden_size)</code>) \u2014 Stacked intermediate hidden states (output of each layer of the decoder).</li>
<li><strong>intermediate_reference_points</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, config.decoder_layers, num_queries, 4)</code>) \u2014 Stacked intermediate reference points (reference points of each layer of the decoder).</li>
<li><strong>decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, num_queries, hidden_size)</code>. Hidden-states of the decoder at the output of each layer
plus the initial embedding outputs.</li>
<li><strong>decoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, num_queries, num_queries)</code>. Attentions weights of the decoder, after the attention softmax, used to compute the weighted
average in the self-attention heads.</li>
<li><strong>cross_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_queries, num_heads, 4, 4)</code>.
Attentions weights of the decoder\u2019s cross-attention layer, after the attention softmax, used to compute the
weighted average in the cross-attention heads.</li>
<li><strong>encoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) \u2014 Sequence of hidden-states at the output of the last layer of the encoder of the model.</li>
<li><strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the encoder at the output of each
layer plus the initial embedding outputs.</li>
<li><strong>encoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_queries, num_heads, 4, 4)</code>.
Attentions weights of the encoder, after the attention softmax, used to compute the weighted average in the
self-attention heads.</li>
<li><strong>enc_outputs_class</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, config.num_labels)</code>, <em>optional</em>, returned when <code>config.with_box_refine=True</code> and <code>config.two_stage=True</code>) \u2014 Predicted bounding boxes scores where the top <code>config.two_stage_num_proposals</code> scoring bounding boxes are
picked as region proposals in the first stage. Output of bounding box binary classification (i.e.
foreground and background).</li>
<li><strong>enc_outputs_coord_logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, 4)</code>, <em>optional</em>, returned when <code>config.with_box_refine=True</code> and <code>config.two_stage=True</code>) \u2014 Logits of predicted bounding boxes coordinates in the first stage.</li>
</ul>
`,returnType:`
<p><code>transformers.models.deta.modeling_deta.DetaModelOutput</code> or <code>tuple(torch.FloatTensor)</code></p>
`}}),ce=new Fa({props:{$$slots:{default:[Ha]},$$scope:{ctx:z}}}),le=new As({props:{anchor:"transformers.DetaModel.forward.example",$$slots:{default:[Wa]},$$scope:{ctx:z}}}),Se=new Ge({}),Re=new X({props:{name:"class transformers.DetaForObjectDetection",anchor:"transformers.DetaForObjectDetection",parameters:[{name:"config",val:": DetaConfig"}],parametersDescription:[{anchor:"transformers.DetaForObjectDetection.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/deta#transformers.DetaConfig">DetaConfig</a>) &#x2014;
Model configuration class with all the parameters of the model. Initializing with a config file does not
load the weights associated with the model, only the configuration. Check out the
<a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/deta/modeling_deta.py#L1776"}}),Ve=new X({props:{name:"forward",anchor:"transformers.DetaForObjectDetection.forward",parameters:[{name:"pixel_values",val:""},{name:"pixel_mask",val:" = None"},{name:"decoder_attention_mask",val:" = None"},{name:"encoder_outputs",val:" = None"},{name:"inputs_embeds",val:" = None"},{name:"decoder_inputs_embeds",val:" = None"},{name:"labels",val:" = None"},{name:"output_attentions",val:" = None"},{name:"output_hidden_states",val:" = None"},{name:"return_dict",val:" = None"}],parametersDescription:[{anchor:"transformers.DetaForObjectDetection.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Padding will be ignored by default should you provide it.</p>
<p>Pixel values can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoImageProcessor">AutoImageProcessor</a>. See <code>AutoImageProcessor.__call__()</code> for details.`,name:"pixel_values"},{anchor:"transformers.DetaForObjectDetection.forward.pixel_mask",description:`<strong>pixel_mask</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, height, width)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding pixel values. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for pixels that are real (i.e. <strong>not masked</strong>),</li>
<li>0 for pixels that are padding (i.e. <strong>masked</strong>).</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"pixel_mask"},{anchor:"transformers.DetaForObjectDetection.forward.decoder_attention_mask",description:`<strong>decoder_attention_mask</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, num_queries)</code>, <em>optional</em>) &#x2014;
Not used by default. Can be used to mask object queries.`,name:"decoder_attention_mask"},{anchor:"transformers.DetaForObjectDetection.forward.encoder_outputs",description:`<strong>encoder_outputs</strong> (<code>tuple(tuple(torch.FloatTensor)</code>, <em>optional</em>) &#x2014;
Tuple consists of (<code>last_hidden_state</code>, <em>optional</em>: <code>hidden_states</code>, <em>optional</em>: <code>attentions</code>)
<code>last_hidden_state</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) is a sequence of
hidden-states at the output of the last layer of the encoder. Used in the cross-attention of the decoder.`,name:"encoder_outputs"},{anchor:"transformers.DetaForObjectDetection.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing the flattened feature map (output of the backbone + projection layer), you
can choose to directly pass a flattened representation of an image.`,name:"inputs_embeds"},{anchor:"transformers.DetaForObjectDetection.forward.decoder_inputs_embeds",description:`<strong>decoder_inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of initializing the queries with a tensor of zeros, you can choose to directly pass an
embedded representation.`,name:"decoder_inputs_embeds"},{anchor:"transformers.DetaForObjectDetection.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.DetaForObjectDetection.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.DetaForObjectDetection.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.DetaForObjectDetection.forward.labels",description:`<strong>labels</strong> (<code>List[Dict]</code> of len <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for computing the bipartite matching loss. List of dicts, each dictionary containing at least the
following 2 keys: &#x2018;class_labels&#x2019; and &#x2018;boxes&#x2019; (the class labels and bounding boxes of an image in the batch
respectively). The class labels themselves should be a <code>torch.LongTensor</code> of len <code>(number of bounding boxes in the image,)</code> and the boxes a <code>torch.FloatTensor</code> of shape <code>(number of bounding boxes in the image, 4)</code>.`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/deta/modeling_deta.py#L1829",returnDescription:`
<p>A <code>transformers.models.deta.modeling_deta.DetaObjectDetectionOutput</code> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/deta#transformers.DetaConfig"
>DetaConfig</a>) and inputs.</p>
<ul>
<li><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> are provided)) \u2014 Total loss as a linear combination of a negative log-likehood (cross-entropy) for class prediction and a
bounding box loss. The latter is defined as a linear combination of the L1 loss and the generalized
scale-invariant IoU loss.</li>
<li><strong>loss_dict</strong> (<code>Dict</code>, <em>optional</em>) \u2014 A dictionary containing the individual losses. Useful for logging.</li>
<li><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, num_classes + 1)</code>) \u2014 Classification logits (including no-object) for all queries.</li>
<li><strong>pred_boxes</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, 4)</code>) \u2014 Normalized boxes coordinates for all queries, represented as (center_x, center_y, width, height). These
values are normalized in [0, 1], relative to the size of each individual image in the batch (disregarding
possible padding). You can use <code>~DetaProcessor.post_process_object_detection</code> to retrieve the
unnormalized bounding boxes.</li>
<li><strong>auxiliary_outputs</strong> (<code>list[Dict]</code>, <em>optional</em>) \u2014 Optional, only returned when auxilary losses are activated (i.e. <code>config.auxiliary_loss</code> is set to <code>True</code>)
and labels are provided. It is a list of dictionaries containing the two above keys (<code>logits</code> and
<code>pred_boxes</code>) for each decoder layer.</li>
<li><strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, hidden_size)</code>, <em>optional</em>) \u2014 Sequence of hidden-states at the output of the last layer of the decoder of the model.</li>
<li><strong>decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, num_queries, hidden_size)</code>. Hidden-states of the decoder at the output of each layer
plus the initial embedding outputs.</li>
<li><strong>decoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, num_queries, num_queries)</code>. Attentions weights of the decoder, after the attention softmax, used to compute the weighted
average in the self-attention heads.</li>
<li><strong>cross_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_queries, num_heads, 4, 4)</code>.
Attentions weights of the decoder\u2019s cross-attention layer, after the attention softmax, used to compute the
weighted average in the cross-attention heads.</li>
<li><strong>encoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) \u2014 Sequence of hidden-states at the output of the last layer of the encoder of the model.</li>
<li><strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the encoder at the output of each
layer plus the initial embedding outputs.</li>
<li><strong>encoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, sequence_length, num_heads, 4, 4)</code>. Attentions weights of the encoder, after the attention softmax, used to compute the weighted average
in the self-attention heads.</li>
<li><strong>intermediate_hidden_states</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, config.decoder_layers, num_queries, hidden_size)</code>) \u2014 Stacked intermediate hidden states (output of each layer of the decoder).</li>
<li><strong>intermediate_reference_points</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, config.decoder_layers, num_queries, 4)</code>) \u2014 Stacked intermediate reference points (reference points of each layer of the decoder).</li>
<li><strong>init_reference_points</strong> (<code>torch.FloatTensor</code> of shape  <code>(batch_size, num_queries, 4)</code>) \u2014 Initial reference points sent through the Transformer decoder.</li>
<li><strong>enc_outputs_class</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, config.num_labels)</code>, <em>optional</em>, returned when <code>config.with_box_refine=True</code> and <code>config.two_stage=True</code>) \u2014 Predicted bounding boxes scores where the top <code>config.two_stage_num_proposals</code> scoring bounding boxes are
picked as region proposals in the first stage. Output of bounding box binary classification (i.e.
foreground and background).</li>
<li><strong>enc_outputs_coord_logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, 4)</code>, <em>optional</em>, returned when <code>config.with_box_refine=True</code> and <code>config.two_stage=True</code>) \u2014 Logits of predicted bounding boxes coordinates in the first stage.</li>
</ul>
`,returnType:`
<p><code>transformers.models.deta.modeling_deta.DetaObjectDetectionOutput</code> or <code>tuple(torch.FloatTensor)</code></p>
`}}),he=new Fa({props:{$$slots:{default:[Va]},$$scope:{ctx:z}}}),pe=new As({props:{anchor:"transformers.DetaForObjectDetection.forward.example",$$slots:{default:[Ba]},$$scope:{ctx:z}}}),{c(){f=n("meta"),v=m(),_=n("h1"),u=n("a"),b=n("span"),w(c.$$.fragment),g=m(),A=n("span"),Co=r("DETA"),Vt=m(),L=n("h2"),K=n("a"),Dt=n("span"),w(_e.$$.fragment),Io=m(),Tt=n("span"),Ao=r("Overview"),Bt=m(),q=n("p"),qo=r("The DETA model was proposed in "),be=n("a"),Fo=r("NMS Strikes Back"),Oo=r(` by Jeffrey Ouyang-Zhang, Jang Hyun Cho, Xingyi Zhou, Philipp Kr\xE4henb\xFChl.
DETA (short for Detection Transformers with Assignment) improves `),Ze=n("a"),Mo=r("Deformable DETR"),No=r(` by replacing the one-to-one bipartite Hungarian matching loss
with one-to-many label assignments used in traditional detectors with non-maximum suppression (NMS). This leads to significant gains of up to 2.5 mAP.`),Jt=m(),Xe=n("p"),Lo=r("The abstract from the paper is the following:"),Gt=m(),Ke=n("p"),xt=n("em"),So=r("Detection Transformer (DETR) directly transforms queries to unique objects by using one-to-one bipartite matching during training and enables end-to-end object detection. Recently, these models have surpassed traditional detectors on COCO with undeniable elegance. However, they differ from traditional detectors in multiple designs, including model architecture and training schedules, and thus the effectiveness of one-to-one matching is not fully understood. In this work, we conduct a strict comparison between the one-to-one Hungarian matching in DETRs and the one-to-many label assignments in traditional detectors with non-maximum supervision (NMS). Surprisingly, we observe one-to-many assignments with NMS consistently outperform standard one-to-one matching under the same setting, with a significant gain of up to 2.5 mAP. Our detector that trains Deformable-DETR with traditional IoU-based label assignment achieved 50.2 COCO mAP within 12 epochs (1x schedule) with ResNet50 backbone, outperforming all existing traditional or transformer-based detectors in this setting. On multiple datasets, schedules, and architectures, we consistently show bipartite matching is unnecessary for performant detection transformers. Furthermore, we attribute the success of detection transformers to their expressive transformer architecture."),Zt=m(),Ye=n("p"),Ro=r("Tips:"),Xt=m(),Qe=n("ul"),ve=n("li"),Uo=r("One can use "),et=n("a"),Ho=r("DetaImageProcessor"),Wo=r(" to prepare images and optional targets for the model."),Kt=m(),Y=n("img"),Yt=m(),Q=n("small"),Vo=r("DETA overview. Taken from the "),tt=n("a"),Bo=r("original paper"),Jo=r("."),Qt=m(),F=n("p"),Go=r("This model was contributed by "),we=n("a"),Zo=r("nielsr"),Xo=r(`.
The original code can be found `),ye=n("a"),Ko=r("here"),Yo=r("."),eo=m(),S=n("h2"),ee=n("a"),$t=n("span"),w(De.$$.fragment),Qo=m(),jt=n("span"),en=r("Resources"),to=m(),ot=n("p"),tn=r("A list of official Hugging Face and community (indicated by \u{1F30E}) resources to help you get started with DETA."),oo=m(),te=n("ul"),Te=n("li"),on=r("Demo notebooks for DETA can be found "),xe=n("a"),nn=r("here"),sn=r("."),an=m(),nt=n("li"),rn=r("See also: "),st=n("a"),dn=r("Object detection task guide"),no=m(),at=n("p"),cn=r("If you\u2019re interested in submitting a resource to be included here, please feel free to open a Pull Request and we\u2019ll review it! The resource should ideally demonstrate something new instead of duplicating an existing resource."),so=m(),R=n("h2"),oe=n("a"),Pt=n("span"),w($e.$$.fragment),ln=m(),Et=n("span"),mn=r("DetaConfig"),ao=m(),j=n("div"),w(je.$$.fragment),hn=m(),U=n("p"),pn=r("This is the configuration class to store the configuration of a "),rt=n("a"),fn=r("DetaModel"),un=r(`. It is used to instantiate a DETA
model according to the specified arguments, defining the model architecture. Instantiating a configuration with the
defaults will yield a similar configuration to that of the DETA
`),Pe=n("a"),gn=r("SenseTime/deformable-detr"),_n=r(" architecture."),bn=m(),H=n("p"),vn=r("Configuration objects inherit from "),it=n("a"),wn=r("PretrainedConfig"),yn=r(` and can be used to control the model outputs. Read the
documentation from `),dt=n("a"),Dn=r("PretrainedConfig"),Tn=r(" for more information."),xn=m(),w(ne.$$.fragment),$n=m(),se=n("div"),w(Ee.$$.fragment),jn=m(),W=n("p"),Pn=r("Serializes this instance to a Python dictionary. Override the default "),ct=n("a"),En=r("to_dict()"),kn=r(`. Returns:
`),kt=n("code"),zn=r("Dict[str, any]"),Cn=r(": Dictionary of all the attributes that make up this configuration instance,"),ro=m(),V=n("h2"),ae=n("a"),zt=n("span"),w(ke.$$.fragment),In=m(),Ct=n("span"),An=r("DetaImageProcessor"),io=m(),k=n("div"),w(ze.$$.fragment),qn=m(),It=n("p"),Fn=r("Constructs a Deformable DETR image processor."),On=m(),re=n("div"),w(Ce.$$.fragment),Mn=m(),At=n("p"),Nn=r("Preprocess an image or a batch of images so that it can be used by the model."),Ln=m(),ie=n("div"),w(Ie.$$.fragment),Sn=m(),Ae=n("p"),Rn=r("Converts the output of "),lt=n("a"),Un=r("DetaForObjectDetection"),Hn=r(` into final bounding boxes in (top_left_x, top_left_y,
bottom_right_x, bottom_right_y) format. Only supports PyTorch.`),co=m(),B=n("h2"),de=n("a"),qt=n("span"),w(qe.$$.fragment),Wn=m(),Ft=n("span"),Vn=r("DetaModel"),lo=m(),P=n("div"),w(Fe.$$.fragment),Bn=m(),Ot=n("p"),Jn=r(`The bare DETA Model (consisting of a backbone and encoder-decoder Transformer) outputting raw hidden-states without
any specific head on top.`),Gn=m(),Oe=n("p"),Zn=r("This model inherits from "),mt=n("a"),Xn=r("PreTrainedModel"),Kn=r(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Yn=m(),Me=n("p"),Qn=r("This model is also a PyTorch "),Ne=n("a"),es=r("torch.nn.Module"),ts=r(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),os=m(),C=n("div"),w(Le.$$.fragment),ns=m(),J=n("p"),ss=r("The "),ht=n("a"),as=r("DetaModel"),rs=r(" forward method, overrides the "),Mt=n("code"),is=r("__call__"),ds=r(" special method."),cs=m(),w(ce.$$.fragment),ls=m(),w(le.$$.fragment),mo=m(),G=n("h2"),me=n("a"),Nt=n("span"),w(Se.$$.fragment),ms=m(),Lt=n("span"),hs=r("DetaForObjectDetection"),ho=m(),E=n("div"),w(Re.$$.fragment),ps=m(),St=n("p"),fs=r(`DETA Model (consisting of a backbone and encoder-decoder Transformer) with object detection heads on top, for tasks
such as COCO detection.`),us=m(),Ue=n("p"),gs=r("This model inherits from "),pt=n("a"),_s=r("PreTrainedModel"),bs=r(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),vs=m(),He=n("p"),ws=r("This model is also a PyTorch "),We=n("a"),ys=r("torch.nn.Module"),Ds=r(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),Ts=m(),I=n("div"),w(Ve.$$.fragment),xs=m(),Z=n("p"),$s=r("The "),ft=n("a"),js=r("DetaForObjectDetection"),Ps=r(" forward method, overrides the "),Rt=n("code"),Es=r("__call__"),ks=r(" special method."),zs=m(),w(he.$$.fragment),Cs=m(),w(pe.$$.fragment),this.h()},l(t){const l=La('[data-svelte="svelte-1phssyn"]',document.head);f=s(l,"META",{name:!0,content:!0}),l.forEach(o),v=h(t),_=s(t,"H1",{class:!0});var Be=a(_);u=s(Be,"A",{id:!0,class:!0,href:!0});var Ut=a(u);b=s(Ut,"SPAN",{});var Ht=a(b);y(c.$$.fragment,Ht),Ht.forEach(o),Ut.forEach(o),g=h(Be),A=s(Be,"SPAN",{});var Wt=a(A);Co=i(Wt,"DETA"),Wt.forEach(o),Be.forEach(o),Vt=h(t),L=s(t,"H2",{class:!0});var Je=a(L);K=s(Je,"A",{id:!0,class:!0,href:!0});var Ms=a(K);Dt=s(Ms,"SPAN",{});var Ns=a(Dt);y(_e.$$.fragment,Ns),Ns.forEach(o),Ms.forEach(o),Io=h(Je),Tt=s(Je,"SPAN",{});var Ls=a(Tt);Ao=i(Ls,"Overview"),Ls.forEach(o),Je.forEach(o),Bt=h(t),q=s(t,"P",{});var ut=a(q);qo=i(ut,"The DETA model was proposed in "),be=s(ut,"A",{href:!0,rel:!0});var Ss=a(be);Fo=i(Ss,"NMS Strikes Back"),Ss.forEach(o),Oo=i(ut,` by Jeffrey Ouyang-Zhang, Jang Hyun Cho, Xingyi Zhou, Philipp Kr\xE4henb\xFChl.
DETA (short for Detection Transformers with Assignment) improves `),Ze=s(ut,"A",{href:!0});var Rs=a(Ze);Mo=i(Rs,"Deformable DETR"),Rs.forEach(o),No=i(ut,` by replacing the one-to-one bipartite Hungarian matching loss
with one-to-many label assignments used in traditional detectors with non-maximum suppression (NMS). This leads to significant gains of up to 2.5 mAP.`),ut.forEach(o),Jt=h(t),Xe=s(t,"P",{});var Us=a(Xe);Lo=i(Us,"The abstract from the paper is the following:"),Us.forEach(o),Gt=h(t),Ke=s(t,"P",{});var Hs=a(Ke);xt=s(Hs,"EM",{});var Ws=a(xt);So=i(Ws,"Detection Transformer (DETR) directly transforms queries to unique objects by using one-to-one bipartite matching during training and enables end-to-end object detection. Recently, these models have surpassed traditional detectors on COCO with undeniable elegance. However, they differ from traditional detectors in multiple designs, including model architecture and training schedules, and thus the effectiveness of one-to-one matching is not fully understood. In this work, we conduct a strict comparison between the one-to-one Hungarian matching in DETRs and the one-to-many label assignments in traditional detectors with non-maximum supervision (NMS). Surprisingly, we observe one-to-many assignments with NMS consistently outperform standard one-to-one matching under the same setting, with a significant gain of up to 2.5 mAP. Our detector that trains Deformable-DETR with traditional IoU-based label assignment achieved 50.2 COCO mAP within 12 epochs (1x schedule) with ResNet50 backbone, outperforming all existing traditional or transformer-based detectors in this setting. On multiple datasets, schedules, and architectures, we consistently show bipartite matching is unnecessary for performant detection transformers. Furthermore, we attribute the success of detection transformers to their expressive transformer architecture."),Ws.forEach(o),Hs.forEach(o),Zt=h(t),Ye=s(t,"P",{});var Vs=a(Ye);Ro=i(Vs,"Tips:"),Vs.forEach(o),Xt=h(t),Qe=s(t,"UL",{});var Bs=a(Qe);ve=s(Bs,"LI",{});var fo=a(ve);Uo=i(fo,"One can use "),et=s(fo,"A",{href:!0});var Js=a(et);Ho=i(Js,"DetaImageProcessor"),Js.forEach(o),Wo=i(fo," to prepare images and optional targets for the model."),fo.forEach(o),Bs.forEach(o),Kt=h(t),Y=s(t,"IMG",{src:!0,alt:!0,width:!0}),Yt=h(t),Q=s(t,"SMALL",{});var uo=a(Q);Vo=i(uo,"DETA overview. Taken from the "),tt=s(uo,"A",{href:!0});var Gs=a(tt);Bo=i(Gs,"original paper"),Gs.forEach(o),Jo=i(uo,"."),uo.forEach(o),Qt=h(t),F=s(t,"P",{});var gt=a(F);Go=i(gt,"This model was contributed by "),we=s(gt,"A",{href:!0,rel:!0});var Zs=a(we);Zo=i(Zs,"nielsr"),Zs.forEach(o),Xo=i(gt,`.
The original code can be found `),ye=s(gt,"A",{href:!0,rel:!0});var Xs=a(ye);Ko=i(Xs,"here"),Xs.forEach(o),Yo=i(gt,"."),gt.forEach(o),eo=h(t),S=s(t,"H2",{class:!0});var go=a(S);ee=s(go,"A",{id:!0,class:!0,href:!0});var Ks=a(ee);$t=s(Ks,"SPAN",{});var Ys=a($t);y(De.$$.fragment,Ys),Ys.forEach(o),Ks.forEach(o),Qo=h(go),jt=s(go,"SPAN",{});var Qs=a(jt);en=i(Qs,"Resources"),Qs.forEach(o),go.forEach(o),to=h(t),ot=s(t,"P",{});var ea=a(ot);tn=i(ea,"A list of official Hugging Face and community (indicated by \u{1F30E}) resources to help you get started with DETA."),ea.forEach(o),oo=h(t),te=s(t,"UL",{});var _o=a(te);Te=s(_o,"LI",{});var bo=a(Te);on=i(bo,"Demo notebooks for DETA can be found "),xe=s(bo,"A",{href:!0,rel:!0});var ta=a(xe);nn=i(ta,"here"),ta.forEach(o),sn=i(bo,"."),bo.forEach(o),an=h(_o),nt=s(_o,"LI",{});var Is=a(nt);rn=i(Is,"See also: "),st=s(Is,"A",{href:!0});var oa=a(st);dn=i(oa,"Object detection task guide"),oa.forEach(o),Is.forEach(o),_o.forEach(o),no=h(t),at=s(t,"P",{});var na=a(at);cn=i(na,"If you\u2019re interested in submitting a resource to be included here, please feel free to open a Pull Request and we\u2019ll review it! The resource should ideally demonstrate something new instead of duplicating an existing resource."),na.forEach(o),so=h(t),R=s(t,"H2",{class:!0});var vo=a(R);oe=s(vo,"A",{id:!0,class:!0,href:!0});var sa=a(oe);Pt=s(sa,"SPAN",{});var aa=a(Pt);y($e.$$.fragment,aa),aa.forEach(o),sa.forEach(o),ln=h(vo),Et=s(vo,"SPAN",{});var ra=a(Et);mn=i(ra,"DetaConfig"),ra.forEach(o),vo.forEach(o),ao=h(t),j=s(t,"DIV",{class:!0});var O=a(j);y(je.$$.fragment,O),hn=h(O),U=s(O,"P",{});var _t=a(U);pn=i(_t,"This is the configuration class to store the configuration of a "),rt=s(_t,"A",{href:!0});var ia=a(rt);fn=i(ia,"DetaModel"),ia.forEach(o),un=i(_t,`. It is used to instantiate a DETA
model according to the specified arguments, defining the model architecture. Instantiating a configuration with the
defaults will yield a similar configuration to that of the DETA
`),Pe=s(_t,"A",{href:!0,rel:!0});var da=a(Pe);gn=i(da,"SenseTime/deformable-detr"),da.forEach(o),_n=i(_t," architecture."),_t.forEach(o),bn=h(O),H=s(O,"P",{});var bt=a(H);vn=i(bt,"Configuration objects inherit from "),it=s(bt,"A",{href:!0});var ca=a(it);wn=i(ca,"PretrainedConfig"),ca.forEach(o),yn=i(bt,` and can be used to control the model outputs. Read the
documentation from `),dt=s(bt,"A",{href:!0});var la=a(dt);Dn=i(la,"PretrainedConfig"),la.forEach(o),Tn=i(bt," for more information."),bt.forEach(o),xn=h(O),y(ne.$$.fragment,O),$n=h(O),se=s(O,"DIV",{class:!0});var wo=a(se);y(Ee.$$.fragment,wo),jn=h(wo),W=s(wo,"P",{});var vt=a(W);Pn=i(vt,"Serializes this instance to a Python dictionary. Override the default "),ct=s(vt,"A",{href:!0});var ma=a(ct);En=i(ma,"to_dict()"),ma.forEach(o),kn=i(vt,`. Returns:
`),kt=s(vt,"CODE",{});var ha=a(kt);zn=i(ha,"Dict[str, any]"),ha.forEach(o),Cn=i(vt,": Dictionary of all the attributes that make up this configuration instance,"),vt.forEach(o),wo.forEach(o),O.forEach(o),ro=h(t),V=s(t,"H2",{class:!0});var yo=a(V);ae=s(yo,"A",{id:!0,class:!0,href:!0});var pa=a(ae);zt=s(pa,"SPAN",{});var fa=a(zt);y(ke.$$.fragment,fa),fa.forEach(o),pa.forEach(o),In=h(yo),Ct=s(yo,"SPAN",{});var ua=a(Ct);An=i(ua,"DetaImageProcessor"),ua.forEach(o),yo.forEach(o),io=h(t),k=s(t,"DIV",{class:!0});var fe=a(k);y(ze.$$.fragment,fe),qn=h(fe),It=s(fe,"P",{});var ga=a(It);Fn=i(ga,"Constructs a Deformable DETR image processor."),ga.forEach(o),On=h(fe),re=s(fe,"DIV",{class:!0});var Do=a(re);y(Ce.$$.fragment,Do),Mn=h(Do),At=s(Do,"P",{});var _a=a(At);Nn=i(_a,"Preprocess an image or a batch of images so that it can be used by the model."),_a.forEach(o),Do.forEach(o),Ln=h(fe),ie=s(fe,"DIV",{class:!0});var To=a(ie);y(Ie.$$.fragment,To),Sn=h(To),Ae=s(To,"P",{});var xo=a(Ae);Rn=i(xo,"Converts the output of "),lt=s(xo,"A",{href:!0});var ba=a(lt);Un=i(ba,"DetaForObjectDetection"),ba.forEach(o),Hn=i(xo,` into final bounding boxes in (top_left_x, top_left_y,
bottom_right_x, bottom_right_y) format. Only supports PyTorch.`),xo.forEach(o),To.forEach(o),fe.forEach(o),co=h(t),B=s(t,"H2",{class:!0});var $o=a(B);de=s($o,"A",{id:!0,class:!0,href:!0});var va=a(de);qt=s(va,"SPAN",{});var wa=a(qt);y(qe.$$.fragment,wa),wa.forEach(o),va.forEach(o),Wn=h($o),Ft=s($o,"SPAN",{});var ya=a(Ft);Vn=i(ya,"DetaModel"),ya.forEach(o),$o.forEach(o),lo=h(t),P=s(t,"DIV",{class:!0});var M=a(P);y(Fe.$$.fragment,M),Bn=h(M),Ot=s(M,"P",{});var Da=a(Ot);Jn=i(Da,`The bare DETA Model (consisting of a backbone and encoder-decoder Transformer) outputting raw hidden-states without
any specific head on top.`),Da.forEach(o),Gn=h(M),Oe=s(M,"P",{});var jo=a(Oe);Zn=i(jo,"This model inherits from "),mt=s(jo,"A",{href:!0});var Ta=a(mt);Xn=i(Ta,"PreTrainedModel"),Ta.forEach(o),Kn=i(jo,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),jo.forEach(o),Yn=h(M),Me=s(M,"P",{});var Po=a(Me);Qn=i(Po,"This model is also a PyTorch "),Ne=s(Po,"A",{href:!0,rel:!0});var xa=a(Ne);es=i(xa,"torch.nn.Module"),xa.forEach(o),ts=i(Po,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),Po.forEach(o),os=h(M),C=s(M,"DIV",{class:!0});var ue=a(C);y(Le.$$.fragment,ue),ns=h(ue),J=s(ue,"P",{});var wt=a(J);ss=i(wt,"The "),ht=s(wt,"A",{href:!0});var $a=a(ht);as=i($a,"DetaModel"),$a.forEach(o),rs=i(wt," forward method, overrides the "),Mt=s(wt,"CODE",{});var ja=a(Mt);is=i(ja,"__call__"),ja.forEach(o),ds=i(wt," special method."),wt.forEach(o),cs=h(ue),y(ce.$$.fragment,ue),ls=h(ue),y(le.$$.fragment,ue),ue.forEach(o),M.forEach(o),mo=h(t),G=s(t,"H2",{class:!0});var Eo=a(G);me=s(Eo,"A",{id:!0,class:!0,href:!0});var Pa=a(me);Nt=s(Pa,"SPAN",{});var Ea=a(Nt);y(Se.$$.fragment,Ea),Ea.forEach(o),Pa.forEach(o),ms=h(Eo),Lt=s(Eo,"SPAN",{});var ka=a(Lt);hs=i(ka,"DetaForObjectDetection"),ka.forEach(o),Eo.forEach(o),ho=h(t),E=s(t,"DIV",{class:!0});var N=a(E);y(Re.$$.fragment,N),ps=h(N),St=s(N,"P",{});var za=a(St);fs=i(za,`DETA Model (consisting of a backbone and encoder-decoder Transformer) with object detection heads on top, for tasks
such as COCO detection.`),za.forEach(o),us=h(N),Ue=s(N,"P",{});var ko=a(Ue);gs=i(ko,"This model inherits from "),pt=s(ko,"A",{href:!0});var Ca=a(pt);_s=i(Ca,"PreTrainedModel"),Ca.forEach(o),bs=i(ko,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),ko.forEach(o),vs=h(N),He=s(N,"P",{});var zo=a(He);ws=i(zo,"This model is also a PyTorch "),We=s(zo,"A",{href:!0,rel:!0});var Ia=a(We);ys=i(Ia,"torch.nn.Module"),Ia.forEach(o),Ds=i(zo,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),zo.forEach(o),Ts=h(N),I=s(N,"DIV",{class:!0});var ge=a(I);y(Ve.$$.fragment,ge),xs=h(ge),Z=s(ge,"P",{});var yt=a(Z);$s=i(yt,"The "),ft=s(yt,"A",{href:!0});var Aa=a(ft);js=i(Aa,"DetaForObjectDetection"),Aa.forEach(o),Ps=i(yt," forward method, overrides the "),Rt=s(yt,"CODE",{});var qa=a(Rt);Es=i(qa,"__call__"),qa.forEach(o),ks=i(yt," special method."),yt.forEach(o),zs=h(ge),y(he.$$.fragment,ge),Cs=h(ge),y(pe.$$.fragment,ge),ge.forEach(o),N.forEach(o),this.h()},h(){d(f,"name","hf:doc:metadata"),d(f,"content",JSON.stringify(Ga)),d(u,"id","deta"),d(u,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(u,"href","#deta"),d(_,"class","relative group"),d(K,"id","overview"),d(K,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(K,"href","#overview"),d(L,"class","relative group"),d(be,"href","https://arxiv.org/abs/2212.06137"),d(be,"rel","nofollow"),d(Ze,"href","deformable_detr"),d(et,"href","/docs/transformers/pr_18559/en/model_doc/deta#transformers.DetaImageProcessor"),Sa(Y.src,Os="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/transformers/model_doc/deta_architecture.jpg")||d(Y,"src",Os),d(Y,"alt","drawing"),d(Y,"width","600"),d(tt,"href","https://arxiv.org/abs/2212.06137"),d(we,"href","https://huggingface.co/nielsr"),d(we,"rel","nofollow"),d(ye,"href","https://github.com/jozhang97/DETA"),d(ye,"rel","nofollow"),d(ee,"id","resources"),d(ee,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(ee,"href","#resources"),d(S,"class","relative group"),d(xe,"href","https://github.com/NielsRogge/Transformers-Tutorials/tree/master/DETA"),d(xe,"rel","nofollow"),d(st,"href","../tasks/object_detection"),d(oe,"id","transformers.DetaConfig"),d(oe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(oe,"href","#transformers.DetaConfig"),d(R,"class","relative group"),d(rt,"href","/docs/transformers/pr_18559/en/model_doc/deta#transformers.DetaModel"),d(Pe,"href","https://huggingface.co/SenseTime/deformable-detr"),d(Pe,"rel","nofollow"),d(it,"href","/docs/transformers/pr_18559/en/main_classes/configuration#transformers.PretrainedConfig"),d(dt,"href","/docs/transformers/pr_18559/en/main_classes/configuration#transformers.PretrainedConfig"),d(ct,"href","/docs/transformers/pr_18559/en/main_classes/configuration#transformers.PretrainedConfig.to_dict"),d(se,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(j,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ae,"id","transformers.DetaImageProcessor"),d(ae,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(ae,"href","#transformers.DetaImageProcessor"),d(V,"class","relative group"),d(re,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(lt,"href","/docs/transformers/pr_18559/en/model_doc/deta#transformers.DetaForObjectDetection"),d(ie,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(k,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(de,"id","transformers.DetaModel"),d(de,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(de,"href","#transformers.DetaModel"),d(B,"class","relative group"),d(mt,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel"),d(Ne,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),d(Ne,"rel","nofollow"),d(ht,"href","/docs/transformers/pr_18559/en/model_doc/deta#transformers.DetaModel"),d(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(P,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(me,"id","transformers.DetaForObjectDetection"),d(me,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(me,"href","#transformers.DetaForObjectDetection"),d(G,"class","relative group"),d(pt,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel"),d(We,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),d(We,"rel","nofollow"),d(ft,"href","/docs/transformers/pr_18559/en/model_doc/deta#transformers.DetaForObjectDetection"),d(I,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(E,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,l){e(document.head,f),p(t,v,l),p(t,_,l),e(_,u),e(u,b),D(c,b,null),e(_,g),e(_,A),e(A,Co),p(t,Vt,l),p(t,L,l),e(L,K),e(K,Dt),D(_e,Dt,null),e(L,Io),e(L,Tt),e(Tt,Ao),p(t,Bt,l),p(t,q,l),e(q,qo),e(q,be),e(be,Fo),e(q,Oo),e(q,Ze),e(Ze,Mo),e(q,No),p(t,Jt,l),p(t,Xe,l),e(Xe,Lo),p(t,Gt,l),p(t,Ke,l),e(Ke,xt),e(xt,So),p(t,Zt,l),p(t,Ye,l),e(Ye,Ro),p(t,Xt,l),p(t,Qe,l),e(Qe,ve),e(ve,Uo),e(ve,et),e(et,Ho),e(ve,Wo),p(t,Kt,l),p(t,Y,l),p(t,Yt,l),p(t,Q,l),e(Q,Vo),e(Q,tt),e(tt,Bo),e(Q,Jo),p(t,Qt,l),p(t,F,l),e(F,Go),e(F,we),e(we,Zo),e(F,Xo),e(F,ye),e(ye,Ko),e(F,Yo),p(t,eo,l),p(t,S,l),e(S,ee),e(ee,$t),D(De,$t,null),e(S,Qo),e(S,jt),e(jt,en),p(t,to,l),p(t,ot,l),e(ot,tn),p(t,oo,l),p(t,te,l),e(te,Te),e(Te,on),e(Te,xe),e(xe,nn),e(Te,sn),e(te,an),e(te,nt),e(nt,rn),e(nt,st),e(st,dn),p(t,no,l),p(t,at,l),e(at,cn),p(t,so,l),p(t,R,l),e(R,oe),e(oe,Pt),D($e,Pt,null),e(R,ln),e(R,Et),e(Et,mn),p(t,ao,l),p(t,j,l),D(je,j,null),e(j,hn),e(j,U),e(U,pn),e(U,rt),e(rt,fn),e(U,un),e(U,Pe),e(Pe,gn),e(U,_n),e(j,bn),e(j,H),e(H,vn),e(H,it),e(it,wn),e(H,yn),e(H,dt),e(dt,Dn),e(H,Tn),e(j,xn),D(ne,j,null),e(j,$n),e(j,se),D(Ee,se,null),e(se,jn),e(se,W),e(W,Pn),e(W,ct),e(ct,En),e(W,kn),e(W,kt),e(kt,zn),e(W,Cn),p(t,ro,l),p(t,V,l),e(V,ae),e(ae,zt),D(ke,zt,null),e(V,In),e(V,Ct),e(Ct,An),p(t,io,l),p(t,k,l),D(ze,k,null),e(k,qn),e(k,It),e(It,Fn),e(k,On),e(k,re),D(Ce,re,null),e(re,Mn),e(re,At),e(At,Nn),e(k,Ln),e(k,ie),D(Ie,ie,null),e(ie,Sn),e(ie,Ae),e(Ae,Rn),e(Ae,lt),e(lt,Un),e(Ae,Hn),p(t,co,l),p(t,B,l),e(B,de),e(de,qt),D(qe,qt,null),e(B,Wn),e(B,Ft),e(Ft,Vn),p(t,lo,l),p(t,P,l),D(Fe,P,null),e(P,Bn),e(P,Ot),e(Ot,Jn),e(P,Gn),e(P,Oe),e(Oe,Zn),e(Oe,mt),e(mt,Xn),e(Oe,Kn),e(P,Yn),e(P,Me),e(Me,Qn),e(Me,Ne),e(Ne,es),e(Me,ts),e(P,os),e(P,C),D(Le,C,null),e(C,ns),e(C,J),e(J,ss),e(J,ht),e(ht,as),e(J,rs),e(J,Mt),e(Mt,is),e(J,ds),e(C,cs),D(ce,C,null),e(C,ls),D(le,C,null),p(t,mo,l),p(t,G,l),e(G,me),e(me,Nt),D(Se,Nt,null),e(G,ms),e(G,Lt),e(Lt,hs),p(t,ho,l),p(t,E,l),D(Re,E,null),e(E,ps),e(E,St),e(St,fs),e(E,us),e(E,Ue),e(Ue,gs),e(Ue,pt),e(pt,_s),e(Ue,bs),e(E,vs),e(E,He),e(He,ws),e(He,We),e(We,ys),e(He,Ds),e(E,Ts),e(E,I),D(Ve,I,null),e(I,xs),e(I,Z),e(Z,$s),e(Z,ft),e(ft,js),e(Z,Ps),e(Z,Rt),e(Rt,Es),e(Z,ks),e(I,zs),D(he,I,null),e(I,Cs),D(pe,I,null),po=!0},p(t,[l]){const Be={};l&2&&(Be.$$scope={dirty:l,ctx:t}),ne.$set(Be);const Ut={};l&2&&(Ut.$$scope={dirty:l,ctx:t}),ce.$set(Ut);const Ht={};l&2&&(Ht.$$scope={dirty:l,ctx:t}),le.$set(Ht);const Wt={};l&2&&(Wt.$$scope={dirty:l,ctx:t}),he.$set(Wt);const Je={};l&2&&(Je.$$scope={dirty:l,ctx:t}),pe.$set(Je)},i(t){po||(T(c.$$.fragment,t),T(_e.$$.fragment,t),T(De.$$.fragment,t),T($e.$$.fragment,t),T(je.$$.fragment,t),T(ne.$$.fragment,t),T(Ee.$$.fragment,t),T(ke.$$.fragment,t),T(ze.$$.fragment,t),T(Ce.$$.fragment,t),T(Ie.$$.fragment,t),T(qe.$$.fragment,t),T(Fe.$$.fragment,t),T(Le.$$.fragment,t),T(ce.$$.fragment,t),T(le.$$.fragment,t),T(Se.$$.fragment,t),T(Re.$$.fragment,t),T(Ve.$$.fragment,t),T(he.$$.fragment,t),T(pe.$$.fragment,t),po=!0)},o(t){x(c.$$.fragment,t),x(_e.$$.fragment,t),x(De.$$.fragment,t),x($e.$$.fragment,t),x(je.$$.fragment,t),x(ne.$$.fragment,t),x(Ee.$$.fragment,t),x(ke.$$.fragment,t),x(ze.$$.fragment,t),x(Ce.$$.fragment,t),x(Ie.$$.fragment,t),x(qe.$$.fragment,t),x(Fe.$$.fragment,t),x(Le.$$.fragment,t),x(ce.$$.fragment,t),x(le.$$.fragment,t),x(Se.$$.fragment,t),x(Re.$$.fragment,t),x(Ve.$$.fragment,t),x(he.$$.fragment,t),x(pe.$$.fragment,t),po=!1},d(t){o(f),t&&o(v),t&&o(_),$(c),t&&o(Vt),t&&o(L),$(_e),t&&o(Bt),t&&o(q),t&&o(Jt),t&&o(Xe),t&&o(Gt),t&&o(Ke),t&&o(Zt),t&&o(Ye),t&&o(Xt),t&&o(Qe),t&&o(Kt),t&&o(Y),t&&o(Yt),t&&o(Q),t&&o(Qt),t&&o(F),t&&o(eo),t&&o(S),$(De),t&&o(to),t&&o(ot),t&&o(oo),t&&o(te),t&&o(no),t&&o(at),t&&o(so),t&&o(R),$($e),t&&o(ao),t&&o(j),$(je),$(ne),$(Ee),t&&o(ro),t&&o(V),$(ke),t&&o(io),t&&o(k),$(ze),$(Ce),$(Ie),t&&o(co),t&&o(B),$(qe),t&&o(lo),t&&o(P),$(Fe),$(Le),$(ce),$(le),t&&o(mo),t&&o(G),$(Se),t&&o(ho),t&&o(E),$(Re),$(Ve),$(he),$(pe)}}}const Ga={local:"deta",sections:[{local:"overview",title:"Overview"},{local:"resources",title:"Resources"},{local:"transformers.DetaConfig",title:"DetaConfig"},{local:"transformers.DetaImageProcessor",title:"DetaImageProcessor"},{local:"transformers.DetaModel",title:"DetaModel"},{local:"transformers.DetaForObjectDetection",title:"DetaForObjectDetection"}],title:"DETA"};function Za(z){return Ra(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class or extends Oa{constructor(f){super();Ma(this,f,Za,Ja,Na,{})}}export{or as default,Ga as metadata};
