import{S as Zd,i as ec,s as tc,e as n,k as p,w as b,t as i,M as oc,c as s,d as t,m as h,a as r,x as k,h as l,b as c,G as e,g as T,y,q as w,o as P,B as $,v as nc,L as nt}from"../../chunks/vendor-hf-doc-builder.js";import{T as jo}from"../../chunks/Tip-hf-doc-builder.js";import{D as S}from"../../chunks/Docstring-hf-doc-builder.js";import{C as be}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as R}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as ot}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function sc(N){let d,v,f,m,_;return m=new be({props:{code:`from transformers import GPTNeoConfig, GPTNeoModel

# Initializing a GPTNeo EleutherAI/gpt-neo-1.3B style configuration
configuration = GPTNeoConfig()

# Initializing a model (with random weights) from the EleutherAI/gpt-neo-1.3B style configuration
model = GPTNeoModel(configuration)

# Accessing the model configuration
configuration = model.config`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> GPTNeoConfig, GPTNeoModel

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a GPTNeo EleutherAI/gpt-neo-1.3B style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = GPTNeoConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a model (with random weights) from the EleutherAI/gpt-neo-1.3B style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = GPTNeoModel(configuration)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Accessing the model configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = model.config`}}),{c(){d=n("p"),v=i("Example:"),f=p(),b(m.$$.fragment)},l(a){d=s(a,"P",{});var u=r(d);v=l(u,"Example:"),u.forEach(t),f=h(a),k(m.$$.fragment,a)},m(a,u){T(a,d,u),e(d,v),T(a,f,u),y(m,a,u),_=!0},p:nt,i(a){_||(w(m.$$.fragment,a),_=!0)},o(a){P(m.$$.fragment,a),_=!1},d(a){a&&t(d),a&&t(f),$(m,a)}}}function ac(N){let d,v,f,m,_;return{c(){d=n("p"),v=i("Although the recipe for forward pass needs to be defined within this function, one should call the "),f=n("code"),m=i("Module"),_=i(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(a){d=s(a,"P",{});var u=r(d);v=l(u,"Although the recipe for forward pass needs to be defined within this function, one should call the "),f=s(u,"CODE",{});var x=r(f);m=l(x,"Module"),x.forEach(t),_=l(u,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),u.forEach(t)},m(a,u){T(a,d,u),e(d,v),e(d,f),e(f,m),e(d,_)},d(a){a&&t(d)}}}function rc(N){let d,v,f,m,_;return m=new be({props:{code:`from transformers import AutoTokenizer, GPTNeoModel
import torch

tokenizer = AutoTokenizer.from_pretrained("EleutherAI/gpt-neo-1.3B")
model = GPTNeoModel.from_pretrained("EleutherAI/gpt-neo-1.3B")

inputs = tokenizer("Hello, my dog is cute", return_tensors="pt")
outputs = model(**inputs)

last_hidden_states = outputs.last_hidden_state`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, GPTNeoModel
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-neo-1.3B&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = GPTNeoModel.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-neo-1.3B&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span>last_hidden_states = outputs.last_hidden_state`}}),{c(){d=n("p"),v=i("Example:"),f=p(),b(m.$$.fragment)},l(a){d=s(a,"P",{});var u=r(d);v=l(u,"Example:"),u.forEach(t),f=h(a),k(m.$$.fragment,a)},m(a,u){T(a,d,u),e(d,v),T(a,f,u),y(m,a,u),_=!0},p:nt,i(a){_||(w(m.$$.fragment,a),_=!0)},o(a){P(m.$$.fragment,a),_=!1},d(a){a&&t(d),a&&t(f),$(m,a)}}}function ic(N){let d,v,f,m,_;return{c(){d=n("p"),v=i("Although the recipe for forward pass needs to be defined within this function, one should call the "),f=n("code"),m=i("Module"),_=i(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(a){d=s(a,"P",{});var u=r(d);v=l(u,"Although the recipe for forward pass needs to be defined within this function, one should call the "),f=s(u,"CODE",{});var x=r(f);m=l(x,"Module"),x.forEach(t),_=l(u,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),u.forEach(t)},m(a,u){T(a,d,u),e(d,v),e(d,f),e(f,m),e(d,_)},d(a){a&&t(d)}}}function lc(N){let d,v,f,m,_;return m=new be({props:{code:`import torch
from transformers import AutoTokenizer, GPTNeoForCausalLM

tokenizer = AutoTokenizer.from_pretrained("EleutherAI/gpt-neo-1.3B")
model = GPTNeoForCausalLM.from_pretrained("EleutherAI/gpt-neo-1.3B")

inputs = tokenizer("Hello, my dog is cute", return_tensors="pt")
outputs = model(**inputs, labels=inputs["input_ids"])
loss = outputs.loss
logits = outputs.logits`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, GPTNeoForCausalLM

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-neo-1.3B&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = GPTNeoForCausalLM.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-neo-1.3B&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs, labels=inputs[<span class="hljs-string">&quot;input_ids&quot;</span>])
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = outputs.loss
<span class="hljs-meta">&gt;&gt;&gt; </span>logits = outputs.logits`}}),{c(){d=n("p"),v=i("Example:"),f=p(),b(m.$$.fragment)},l(a){d=s(a,"P",{});var u=r(d);v=l(u,"Example:"),u.forEach(t),f=h(a),k(m.$$.fragment,a)},m(a,u){T(a,d,u),e(d,v),T(a,f,u),y(m,a,u),_=!0},p:nt,i(a){_||(w(m.$$.fragment,a),_=!0)},o(a){P(m.$$.fragment,a),_=!1},d(a){a&&t(d),a&&t(f),$(m,a)}}}function dc(N){let d,v,f,m,_;return{c(){d=n("p"),v=i("Although the recipe for forward pass needs to be defined within this function, one should call the "),f=n("code"),m=i("Module"),_=i(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(a){d=s(a,"P",{});var u=r(d);v=l(u,"Although the recipe for forward pass needs to be defined within this function, one should call the "),f=s(u,"CODE",{});var x=r(f);m=l(x,"Module"),x.forEach(t),_=l(u,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),u.forEach(t)},m(a,u){T(a,d,u),e(d,v),e(d,f),e(f,m),e(d,_)},d(a){a&&t(d)}}}function cc(N){let d,v,f,m,_;return m=new be({props:{code:`import torch
from transformers import AutoTokenizer, GPTNeoForSequenceClassification

tokenizer = AutoTokenizer.from_pretrained("EleutherAI/gpt-neo-1.3B")
model = GPTNeoForSequenceClassification.from_pretrained("EleutherAI/gpt-neo-1.3B")

inputs = tokenizer("Hello, my dog is cute", return_tensors="pt")

with torch.no_grad():
    logits = model(**inputs).logits

predicted_class_id = logits.argmax().item()

# To train a model on \`num_labels\` classes, you can pass \`num_labels=num_labels\` to \`.from_pretrained(...)\`
num_labels = len(model.config.id2label)
model = GPTNeoForSequenceClassification.from_pretrained("EleutherAI/gpt-neo-1.3B", num_labels=num_labels)

labels = torch.tensor([1])
loss = model(**inputs, labels=labels).loss`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, GPTNeoForSequenceClassification

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-neo-1.3B&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = GPTNeoForSequenceClassification.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-neo-1.3B&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    logits = model(**inputs).logits

<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_class_id = logits.argmax().item()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># To train a model on \`num_labels\` classes, you can pass \`num_labels=num_labels\` to \`.from_pretrained(...)\`</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>num_labels = <span class="hljs-built_in">len</span>(model.config.id2label)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = GPTNeoForSequenceClassification.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-neo-1.3B&quot;</span>, num_labels=num_labels)

<span class="hljs-meta">&gt;&gt;&gt; </span>labels = torch.tensor([<span class="hljs-number">1</span>])
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = model(**inputs, labels=labels).loss`}}),{c(){d=n("p"),v=i("Example of single-label classification:"),f=p(),b(m.$$.fragment)},l(a){d=s(a,"P",{});var u=r(d);v=l(u,"Example of single-label classification:"),u.forEach(t),f=h(a),k(m.$$.fragment,a)},m(a,u){T(a,d,u),e(d,v),T(a,f,u),y(m,a,u),_=!0},p:nt,i(a){_||(w(m.$$.fragment,a),_=!0)},o(a){P(m.$$.fragment,a),_=!1},d(a){a&&t(d),a&&t(f),$(m,a)}}}function pc(N){let d,v,f,m,_;return m=new be({props:{code:`import torch
from transformers import AutoTokenizer, GPTNeoForSequenceClassification

tokenizer = AutoTokenizer.from_pretrained("EleutherAI/gpt-neo-1.3B")
model = GPTNeoForSequenceClassification.from_pretrained("EleutherAI/gpt-neo-1.3B", problem_type="multi_label_classification")

inputs = tokenizer("Hello, my dog is cute", return_tensors="pt")

with torch.no_grad():
    logits = model(**inputs).logits

predicted_class_ids = torch.arange(0, logits.shape[-1])[torch.sigmoid(logits).squeeze(dim=0) > 0.5]

# To train a model on \`num_labels\` classes, you can pass \`num_labels=num_labels\` to \`.from_pretrained(...)\`
num_labels = len(model.config.id2label)
model = GPTNeoForSequenceClassification.from_pretrained(
    "EleutherAI/gpt-neo-1.3B", num_labels=num_labels, problem_type="multi_label_classification"
)

labels = torch.sum(
    torch.nn.functional.one_hot(predicted_class_ids[None, :].clone(), num_classes=num_labels), dim=1
).to(torch.float)
loss = model(**inputs, labels=labels).loss`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, GPTNeoForSequenceClassification

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-neo-1.3B&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = GPTNeoForSequenceClassification.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-neo-1.3B&quot;</span>, problem_type=<span class="hljs-string">&quot;multi_label_classification&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    logits = model(**inputs).logits

<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_class_ids = torch.arange(<span class="hljs-number">0</span>, logits.shape[-<span class="hljs-number">1</span>])[torch.sigmoid(logits).squeeze(dim=<span class="hljs-number">0</span>) &gt; <span class="hljs-number">0.5</span>]

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># To train a model on \`num_labels\` classes, you can pass \`num_labels=num_labels\` to \`.from_pretrained(...)\`</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>num_labels = <span class="hljs-built_in">len</span>(model.config.id2label)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = GPTNeoForSequenceClassification.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;EleutherAI/gpt-neo-1.3B&quot;</span>, num_labels=num_labels, problem_type=<span class="hljs-string">&quot;multi_label_classification&quot;</span>
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>labels = torch.<span class="hljs-built_in">sum</span>(
<span class="hljs-meta">... </span>    torch.nn.functional.one_hot(predicted_class_ids[<span class="hljs-literal">None</span>, :].clone(), num_classes=num_labels), dim=<span class="hljs-number">1</span>
<span class="hljs-meta">... </span>).to(torch.<span class="hljs-built_in">float</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = model(**inputs, labels=labels).loss`}}),{c(){d=n("p"),v=i("Example of multi-label classification:"),f=p(),b(m.$$.fragment)},l(a){d=s(a,"P",{});var u=r(d);v=l(u,"Example of multi-label classification:"),u.forEach(t),f=h(a),k(m.$$.fragment,a)},m(a,u){T(a,d,u),e(d,v),T(a,f,u),y(m,a,u),_=!0},p:nt,i(a){_||(w(m.$$.fragment,a),_=!0)},o(a){P(m.$$.fragment,a),_=!1},d(a){a&&t(d),a&&t(f),$(m,a)}}}function hc(N){let d,v,f,m,_;return{c(){d=n("p"),v=i("Although the recipe for forward pass needs to be defined within this function, one should call the "),f=n("code"),m=i("Module"),_=i(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(a){d=s(a,"P",{});var u=r(d);v=l(u,"Although the recipe for forward pass needs to be defined within this function, one should call the "),f=s(u,"CODE",{});var x=r(f);m=l(x,"Module"),x.forEach(t),_=l(u,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),u.forEach(t)},m(a,u){T(a,d,u),e(d,v),e(d,f),e(f,m),e(d,_)},d(a){a&&t(d)}}}function uc(N){let d,v,f,m,_;return m=new be({props:{code:`from transformers import AutoTokenizer, GPTNeoForTokenClassification
import torch

tokenizer = AutoTokenizer.from_pretrained("EleutherAI/gpt-neo-125m")
model = GPTNeoForTokenClassification.from_pretrained("EleutherAI/gpt-neo-125m")

inputs = tokenizer(
    "HuggingFace is a company based in Paris and New York", add_special_tokens=False, return_tensors="pt"
)

with torch.no_grad():
    logits = model(**inputs).logits

predicted_token_class_ids = logits.argmax(-1)

# Note that tokens are classified rather then input words which means that
# there might be more predicted token classes than words.
# Multiple token classes might account for the same word
predicted_tokens_classes = [model.config.id2label[t.item()] for t in predicted_token_class_ids[0]]

labels = predicted_token_class_ids
loss = model(**inputs, labels=labels).loss
round(loss.item(), 2)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, GPTNeoForTokenClassification
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-neo-125m&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = GPTNeoForTokenClassification.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-neo-125m&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;HuggingFace is a company based in Paris and New York&quot;</span>, add_special_tokens=<span class="hljs-literal">False</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    logits = model(**inputs).logits

<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_token_class_ids = logits.argmax(-<span class="hljs-number">1</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Note that tokens are classified rather then input words which means that</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># there might be more predicted token classes than words.</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Multiple token classes might account for the same word</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_tokens_classes = [model.config.id2label[t.item()] <span class="hljs-keyword">for</span> t <span class="hljs-keyword">in</span> predicted_token_class_ids[<span class="hljs-number">0</span>]]

<span class="hljs-meta">&gt;&gt;&gt; </span>labels = predicted_token_class_ids
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = model(**inputs, labels=labels).loss
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">round</span>(loss.item(), <span class="hljs-number">2</span>)
<span class="hljs-number">0.25</span>`}}),{c(){d=n("p"),v=i("Example:"),f=p(),b(m.$$.fragment)},l(a){d=s(a,"P",{});var u=r(d);v=l(u,"Example:"),u.forEach(t),f=h(a),k(m.$$.fragment,a)},m(a,u){T(a,d,u),e(d,v),T(a,f,u),y(m,a,u),_=!0},p:nt,i(a){_||(w(m.$$.fragment,a),_=!0)},o(a){P(m.$$.fragment,a),_=!1},d(a){a&&t(d),a&&t(f),$(m,a)}}}function mc(N){let d,v,f,m,_;return{c(){d=n("p"),v=i("Although the recipe for forward pass needs to be defined within this function, one should call the "),f=n("code"),m=i("Module"),_=i(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(a){d=s(a,"P",{});var u=r(d);v=l(u,"Although the recipe for forward pass needs to be defined within this function, one should call the "),f=s(u,"CODE",{});var x=r(f);m=l(x,"Module"),x.forEach(t),_=l(u,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),u.forEach(t)},m(a,u){T(a,d,u),e(d,v),e(d,f),e(f,m),e(d,_)},d(a){a&&t(d)}}}function fc(N){let d,v,f,m,_;return m=new be({props:{code:`from transformers import AutoTokenizer, FlaxGPTNeoModel

tokenizer = AutoTokenizer.from_pretrained("EleutherAI/gpt-neo-1.3B")
model = FlaxGPTNeoModel.from_pretrained("EleutherAI/gpt-neo-1.3B")

inputs = tokenizer("Hello, my dog is cute", return_tensors="jax")
outputs = model(**inputs)

last_hidden_states = outputs.last_hidden_state`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, FlaxGPTNeoModel

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-neo-1.3B&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = FlaxGPTNeoModel.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-neo-1.3B&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;jax&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span>last_hidden_states = outputs.last_hidden_state`}}),{c(){d=n("p"),v=i("Example:"),f=p(),b(m.$$.fragment)},l(a){d=s(a,"P",{});var u=r(d);v=l(u,"Example:"),u.forEach(t),f=h(a),k(m.$$.fragment,a)},m(a,u){T(a,d,u),e(d,v),T(a,f,u),y(m,a,u),_=!0},p:nt,i(a){_||(w(m.$$.fragment,a),_=!0)},o(a){P(m.$$.fragment,a),_=!1},d(a){a&&t(d),a&&t(f),$(m,a)}}}function gc(N){let d,v,f,m,_;return{c(){d=n("p"),v=i("Although the recipe for forward pass needs to be defined within this function, one should call the "),f=n("code"),m=i("Module"),_=i(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(a){d=s(a,"P",{});var u=r(d);v=l(u,"Although the recipe for forward pass needs to be defined within this function, one should call the "),f=s(u,"CODE",{});var x=r(f);m=l(x,"Module"),x.forEach(t),_=l(u,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),u.forEach(t)},m(a,u){T(a,d,u),e(d,v),e(d,f),e(f,m),e(d,_)},d(a){a&&t(d)}}}function _c(N){let d,v,f,m,_;return m=new be({props:{code:`from transformers import AutoTokenizer, FlaxGPTNeoForCausalLM

tokenizer = AutoTokenizer.from_pretrained("EleutherAI/gpt-neo-1.3B")
model = FlaxGPTNeoForCausalLM.from_pretrained("EleutherAI/gpt-neo-1.3B")

inputs = tokenizer("Hello, my dog is cute", return_tensors="np")
outputs = model(**inputs)

# retrieve logts for next token
next_token_logits = outputs.logits[:, -1]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, FlaxGPTNeoForCausalLM

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-neo-1.3B&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = FlaxGPTNeoForCausalLM.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-neo-1.3B&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;np&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># retrieve logts for next token</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>next_token_logits = outputs.logits[:, -<span class="hljs-number">1</span>]`}}),{c(){d=n("p"),v=i("Example:"),f=p(),b(m.$$.fragment)},l(a){d=s(a,"P",{});var u=r(d);v=l(u,"Example:"),u.forEach(t),f=h(a),k(m.$$.fragment,a)},m(a,u){T(a,d,u),e(d,v),T(a,f,u),y(m,a,u),_=!0},p:nt,i(a){_||(w(m.$$.fragment,a),_=!0)},o(a){P(m.$$.fragment,a),_=!1},d(a){a&&t(d),a&&t(f),$(m,a)}}}function Tc(N){let d,v,f,m,_,a,u,x,As,Wn,te,ke,qo,st,Is,Ao,Ls,Hn,X,Os,at,Ss,Ds,rt,Bs,Ws,Un,io,Hs,Vn,ye,Us,it,Vs,Js,Jn,oe,we,Io,lt,Rs,Lo,Xs,Rn,Pe,Ks,Oo,Ys,Qs,Xn,dt,Kn,ne,$e,So,ct,Zs,Do,ea,Yn,Ne,Bo,lo,ta,oa,Wo,co,na,Qn,se,xe,Ho,pt,sa,Uo,aa,Zn,L,ht,ra,ae,ia,po,la,da,ut,ca,pa,ha,re,ua,ho,ma,fa,uo,ga,_a,Ta,Fe,es,ie,Ge,Vo,mt,va,Jo,ba,ts,M,ft,ka,Ro,ya,wa,gt,Pa,mo,$a,Na,xa,_t,Fa,Tt,Ga,Ca,Ma,D,vt,Ea,le,za,fo,ja,qa,Xo,Aa,Ia,La,Ce,Oa,Me,os,de,Ee,Ko,bt,Sa,Yo,Da,ns,E,kt,Ba,Qo,Wa,Ha,yt,Ua,go,Va,Ja,Ra,wt,Xa,Pt,Ka,Ya,Qa,B,$t,Za,ce,er,_o,tr,or,Zo,nr,sr,ar,ze,rr,je,ss,pe,qe,en,Nt,ir,tn,lr,as,F,xt,dr,on,cr,pr,To,vo,hr,ur,mr,O,fr,nn,gr,_r,sn,Tr,vr,an,br,kr,rn,yr,wr,Pr,Ft,$r,bo,Nr,xr,Fr,Gt,Gr,Ct,Cr,Mr,Er,j,Mt,zr,he,jr,ko,qr,Ar,ln,Ir,Lr,Or,Ae,Sr,Ie,Dr,Le,rs,ue,Oe,dn,Et,Br,cn,Wr,is,z,zt,Hr,pn,Ur,Vr,jt,Jr,yo,Rr,Xr,Kr,qt,Yr,At,Qr,Zr,ei,W,It,ti,me,oi,wo,ni,si,hn,ai,ri,ii,Se,li,De,ls,fe,Be,un,Lt,di,mn,ci,ds,G,Ot,pi,fn,hi,ui,St,mi,Po,fi,gi,_i,Dt,Ti,Bt,vi,bi,ki,gn,yi,wi,V,_n,Wt,Pi,$i,Tn,Ht,Ni,xi,vn,Ut,Fi,Gi,bn,Vt,Ci,Mi,H,Jt,Ei,ge,zi,kn,ji,qi,yn,Ai,Ii,Li,We,Oi,He,cs,_e,Ue,wn,Rt,Si,Pn,Di,ps,C,Xt,Bi,$n,Wi,Hi,Kt,Ui,$o,Vi,Ji,Ri,Yt,Xi,Qt,Ki,Yi,Qi,Nn,Zi,el,J,xn,Zt,tl,ol,Fn,eo,nl,sl,Gn,to,al,rl,Cn,oo,il,ll,U,no,dl,Te,cl,Mn,pl,hl,En,ul,ml,fl,Ve,gl,Je,hs;return a=new R({}),st=new R({}),lt=new R({}),dt=new be({props:{code:`from transformers import GPTNeoForCausalLM, GPT2Tokenizer

model = GPTNeoForCausalLM.from_pretrained("EleutherAI/gpt-neo-1.3B")
tokenizer = GPT2Tokenizer.from_pretrained("EleutherAI/gpt-neo-1.3B")

prompt = (
    "In a shocking finding, scientists discovered a herd of unicorns living in a remote, "
    "previously unexplored valley, in the Andes Mountains. Even more surprising to the "
    "researchers was the fact that the unicorns spoke perfect English."
)

input_ids = tokenizer(prompt, return_tensors="pt").input_ids

gen_tokens = model.generate(
    input_ids,
    do_sample=True,
    temperature=0.9,
    max_length=100,
)
gen_text = tokenizer.batch_decode(gen_tokens)[0]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> GPTNeoForCausalLM, GPT2Tokenizer

<span class="hljs-meta">&gt;&gt;&gt; </span>model = GPTNeoForCausalLM.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-neo-1.3B&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = GPT2Tokenizer.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-neo-1.3B&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = (
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;In a shocking finding, scientists discovered a herd of unicorns living in a remote, &quot;</span>
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;previously unexplored valley, in the Andes Mountains. Even more surprising to the &quot;</span>
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;researchers was the fact that the unicorns spoke perfect English.&quot;</span>
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>input_ids = tokenizer(prompt, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).input_ids

<span class="hljs-meta">&gt;&gt;&gt; </span>gen_tokens = model.generate(
<span class="hljs-meta">... </span>    input_ids,
<span class="hljs-meta">... </span>    do_sample=<span class="hljs-literal">True</span>,
<span class="hljs-meta">... </span>    temperature=<span class="hljs-number">0.9</span>,
<span class="hljs-meta">... </span>    max_length=<span class="hljs-number">100</span>,
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>gen_text = tokenizer.batch_decode(gen_tokens)[<span class="hljs-number">0</span>]`}}),ct=new R({}),pt=new R({}),ht=new S({props:{name:"class transformers.GPTNeoConfig",anchor:"transformers.GPTNeoConfig",parameters:[{name:"vocab_size",val:" = 50257"},{name:"max_position_embeddings",val:" = 2048"},{name:"hidden_size",val:" = 2048"},{name:"num_layers",val:" = 24"},{name:"attention_types",val:" = [[['global', 'local'], 12]]"},{name:"num_heads",val:" = 16"},{name:"intermediate_size",val:" = None"},{name:"window_size",val:" = 256"},{name:"activation_function",val:" = 'gelu_new'"},{name:"resid_dropout",val:" = 0.0"},{name:"embed_dropout",val:" = 0.0"},{name:"attention_dropout",val:" = 0.0"},{name:"classifier_dropout",val:" = 0.1"},{name:"layer_norm_epsilon",val:" = 1e-05"},{name:"initializer_range",val:" = 0.02"},{name:"use_cache",val:" = True"},{name:"bos_token_id",val:" = 50256"},{name:"eos_token_id",val:" = 50256"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.GPTNeoConfig.vocab_size",description:`<strong>vocab_size</strong> (<code>int</code>, <em>optional</em>, defaults to 50257) &#x2014;
Vocabulary size of the GPT Neo model. Defines the number of different tokens that can be represented by the
<code>inputs_ids</code> passed when calling <a href="/docs/transformers/pr_18559/en/model_doc/gpt_neo#transformers.GPTNeoModel">GPTNeoModel</a>. Vocabulary size of the model. Defines the different
tokens that can be represented by the <em>inputs_ids</em> passed to the forward method of <a href="/docs/transformers/pr_18559/en/model_doc/gpt_neo#transformers.GPTNeoModel">GPTNeoModel</a>.`,name:"vocab_size"},{anchor:"transformers.GPTNeoConfig.attention_types",description:`<strong>attention_types</strong> (<code>List</code>, <em>optional</em>, defaults to <code>[[[&quot;global&quot;, &quot;local&quot;], 12]]</code>) &#x2014;
The type of attention for each layer in a <code>List</code> of the following format <code>[[[&quot;attention_type&quot;], num_layerss]]</code> e.g. for a 24 layer model <code>[[[&quot;global&quot;], 24]]</code> or <code>[[[&quot;global&quot;, &quot;local&quot;], 12]]</code> Choose the
value of <code>attention_type</code> from <code>[&quot;global&quot;, &quot;local&quot;]</code>`,name:"attention_types"},{anchor:"transformers.GPTNeoConfig.hidden_size",description:`<strong>hidden_size</strong> (<code>int</code>, <em>optional</em>, defaults to 2048) &#x2014;
Dimensionality of the encoder layers and the pooler layer.`,name:"hidden_size"},{anchor:"transformers.GPTNeoConfig.num_layers",description:`<strong>num_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 24) &#x2014;
Number of hidden layers in the Transformer encoder.`,name:"num_layers"},{anchor:"transformers.GPTNeoConfig.num_heads",description:`<strong>num_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 16) &#x2014;
Number of attention heads for each attention layer in the Transformer encoder.`,name:"num_heads"},{anchor:"transformers.GPTNeoConfig.intermediate_size",description:`<strong>intermediate_size</strong> (<code>int</code>, <em>optional</em>, defaults to 8192) &#x2014;
Dimensionality of the &#x201C;intermediate&#x201D; (i.e., feed-forward) layer in the Transformer encoder.`,name:"intermediate_size"},{anchor:"transformers.GPTNeoConfig.activation_function",description:`<strong>activation_function</strong> (<code>str</code> or <code>function</code>, <em>optional</em>, defaults to <code>&quot;gelu_new&quot;</code>) &#x2014;
The non-linear activation function (function or string) in the encoder and pooler. If string, <code>&quot;gelu&quot;</code>,
<code>&quot;relu&quot;</code>, <code>&quot;selu&quot;</code> and <code>&quot;gelu_new&quot;</code> are supported.`,name:"activation_function"},{anchor:"transformers.GPTNeoConfig.embed_dropout",description:`<strong>embed_dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout probabilitiy for all fully connected layers in the embeddings, encoder, and pooler.`,name:"embed_dropout"},{anchor:"transformers.GPTNeoConfig.attention_dropout",description:`<strong>attention_dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout ratio for the attention probabilities.`,name:"attention_dropout"},{anchor:"transformers.GPTNeoConfig.classifier_dropout",description:`<strong>classifier_dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
Argument used when doing token classification, used in the model <a href="/docs/transformers/pr_18559/en/model_doc/gpt_neo#transformers.GPTNeoForTokenClassification">GPTNeoForTokenClassification</a>.</p>
<p>The dropout ratio for the hidden layer.`,name:"classifier_dropout"},{anchor:"transformers.GPTNeoConfig.max_position_embeddings",description:`<strong>max_position_embeddings</strong> (<code>int</code>, <em>optional</em>, defaults to 2048) &#x2014;
The maximum sequence length that this model might ever be used with. Typically set this to something large
just in case (e.g., 512 or 1024 or 2048).`,name:"max_position_embeddings"},{anchor:"transformers.GPTNeoConfig.type_vocab_size",description:`<strong>type_vocab_size</strong> (<code>int</code>, <em>optional</em>, defaults to 2) &#x2014;
The vocabulary size of the <code>token_type_ids</code> passed when calling <a href="/docs/transformers/pr_18559/en/model_doc/gpt_neo#transformers.GPTNeoModel">GPTNeoModel</a>.`,name:"type_vocab_size"},{anchor:"transformers.GPTNeoConfig.initializer_range",description:`<strong>initializer_range</strong> (<code>float</code>, <em>optional</em>, defaults to 0.02) &#x2014;
The standard deviation of the truncated_normal_initializer for initializing all weight matrices.`,name:"initializer_range"},{anchor:"transformers.GPTNeoConfig.layer_norm_epsilon",description:`<strong>layer_norm_epsilon</strong> (<code>float</code>, <em>optional</em>, defaults to 1e-5) &#x2014;
The epsilon used by the layer normalization layers.`,name:"layer_norm_epsilon"},{anchor:"transformers.GPTNeoConfig.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not the model should return the last key/values attentions (not used by all models). Only
relevant if <code>config.is_decoder=True</code>.`,name:"use_cache"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/gpt_neo/configuration_gpt_neo.py#L34"}}),Fe=new ot({props:{anchor:"transformers.GPTNeoConfig.example",$$slots:{default:[sc]},$$scope:{ctx:N}}}),mt=new R({}),ft=new S({props:{name:"class transformers.GPTNeoModel",anchor:"transformers.GPTNeoModel",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.GPTNeoModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/gpt_neo#transformers.GPTNeoConfig">GPTNeoConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/gpt_neo/modeling_gpt_neo.py#L475"}}),vt=new S({props:{name:"forward",anchor:"transformers.GPTNeoModel.forward",parameters:[{name:"input_ids",val:": typing.Optional[torch.Tensor] = None"},{name:"past_key_values",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"attention_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"token_type_ids",val:": typing.Optional[torch.Tensor] = None"},{name:"position_ids",val:": typing.Optional[torch.Tensor] = None"},{name:"head_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"inputs_embeds",val:": typing.Optional[torch.Tensor] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.GPTNeoModel.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, input_ids_length)</code>) &#x2014;
<code>input_ids_length</code> = <code>sequence_length</code> if <code>past_key_values</code> is <code>None</code> else
<code>past_key_values[0][0].shape[-2]</code> (<code>sequence_length</code> of input past key value states). Indices of input
sequence tokens in the vocabulary.</p>
<p>If <code>past_key_values</code> is used, only <code>input_ids</code> that do not have their past calculated should be passed as
<code>input_ids</code>.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.GPTNeoModel.forward.past_key_values",description:`<strong>past_key_values</strong> (<code>Tuple[Tuple[torch.Tensor]]</code> of length <code>config.num_layers</code>) &#x2014;
Contains precomputed hidden-states (key and values in the attention blocks) as computed by the model (see
<code>past_key_values</code> output below). Can be used to speed up sequential decoding. The <code>input_ids</code> which have
their past given to this model should not be passed as <code>input_ids</code> as they have already been computed.`,name:"past_key_values"},{anchor:"transformers.GPTNeoModel.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.GPTNeoModel.forward.token_type_ids",description:`<strong>token_type_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, input_ids_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.GPTNeoModel.forward.position_ids",description:`<strong>position_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.</p>
<p><a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.GPTNeoModel.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.GPTNeoModel.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.</p>
<p>If <code>past_key_values</code> is used, optionally only the last <code>inputs_embeds</code> have to be input (see
<code>past_key_values</code>).`,name:"inputs_embeds"},{anchor:"transformers.GPTNeoModel.forward.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set to <code>True</code>, <code>past_key_values</code> key value states are returned and can be used to speed up decoding (see
<code>past_key_values</code>).`,name:"use_cache"},{anchor:"transformers.GPTNeoModel.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.GPTNeoModel.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.GPTNeoModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/gpt_neo/modeling_gpt_neo.py#L496",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_outputs.BaseModelOutputWithPastAndCrossAttentions"
>transformers.modeling_outputs.BaseModelOutputWithPastAndCrossAttentions</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/gpt_neo#transformers.GPTNeoConfig"
>GPTNeoConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the model.</p>
<p>If <code>past_key_values</code> is used only the last hidden-state of the sequences of shape <code>(batch_size, 1, hidden_size)</code> is output.</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 Tuple of <code>tuple(torch.FloatTensor)</code> of length <code>config.n_layers</code>, with each tuple having 2 tensors of shape
<code>(batch_size, num_heads, sequence_length, embed_size_per_head)</code>) and optionally if
<code>config.is_encoder_decoder=True</code> 2 additional tensors of shape <code>(batch_size, num_heads, encoder_sequence_length, embed_size_per_head)</code>.</p>
<p>Contains pre-computed hidden-states (key and values in the self-attention blocks and optionally if
<code>config.is_encoder_decoder=True</code> in the cross-attention blocks) that can be used (see <code>past_key_values</code>
input) to speed up sequential decoding.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
<li>
<p><strong>cross_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> and <code>config.add_cross_attention=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights of the decoder\u2019s cross-attention layer, after the attention softmax, used to compute the
weighted average in the cross-attention heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_outputs.BaseModelOutputWithPastAndCrossAttentions"
>transformers.modeling_outputs.BaseModelOutputWithPastAndCrossAttentions</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),Ce=new jo({props:{$$slots:{default:[ac]},$$scope:{ctx:N}}}),Me=new ot({props:{anchor:"transformers.GPTNeoModel.forward.example",$$slots:{default:[rc]},$$scope:{ctx:N}}}),bt=new R({}),kt=new S({props:{name:"class transformers.GPTNeoForCausalLM",anchor:"transformers.GPTNeoForCausalLM",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.GPTNeoForCausalLM.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/gpt_neo#transformers.GPTNeoConfig">GPTNeoConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/gpt_neo/modeling_gpt_neo.py#L663"}}),$t=new S({props:{name:"forward",anchor:"transformers.GPTNeoForCausalLM.forward",parameters:[{name:"input_ids",val:": typing.Optional[torch.Tensor] = None"},{name:"past_key_values",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"attention_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"token_type_ids",val:": typing.Optional[torch.Tensor] = None"},{name:"position_ids",val:": typing.Optional[torch.Tensor] = None"},{name:"head_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"inputs_embeds",val:": typing.Optional[torch.Tensor] = None"},{name:"labels",val:": typing.Optional[torch.Tensor] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.GPTNeoForCausalLM.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, input_ids_length)</code>) &#x2014;
<code>input_ids_length</code> = <code>sequence_length</code> if <code>past_key_values</code> is <code>None</code> else
<code>past_key_values[0][0].shape[-2]</code> (<code>sequence_length</code> of input past key value states). Indices of input
sequence tokens in the vocabulary.</p>
<p>If <code>past_key_values</code> is used, only <code>input_ids</code> that do not have their past calculated should be passed as
<code>input_ids</code>.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.GPTNeoForCausalLM.forward.past_key_values",description:`<strong>past_key_values</strong> (<code>Tuple[Tuple[torch.Tensor]]</code> of length <code>config.num_layers</code>) &#x2014;
Contains precomputed hidden-states (key and values in the attention blocks) as computed by the model (see
<code>past_key_values</code> output below). Can be used to speed up sequential decoding. The <code>input_ids</code> which have
their past given to this model should not be passed as <code>input_ids</code> as they have already been computed.`,name:"past_key_values"},{anchor:"transformers.GPTNeoForCausalLM.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.GPTNeoForCausalLM.forward.token_type_ids",description:`<strong>token_type_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, input_ids_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.GPTNeoForCausalLM.forward.position_ids",description:`<strong>position_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.</p>
<p><a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.GPTNeoForCausalLM.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.GPTNeoForCausalLM.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.</p>
<p>If <code>past_key_values</code> is used, optionally only the last <code>inputs_embeds</code> have to be input (see
<code>past_key_values</code>).`,name:"inputs_embeds"},{anchor:"transformers.GPTNeoForCausalLM.forward.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set to <code>True</code>, <code>past_key_values</code> key value states are returned and can be used to speed up decoding (see
<code>past_key_values</code>).`,name:"use_cache"},{anchor:"transformers.GPTNeoForCausalLM.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.GPTNeoForCausalLM.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.GPTNeoForCausalLM.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.GPTNeoForCausalLM.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Labels for language modeling. Note that the labels <strong>are shifted</strong> inside the model, i.e. you can set
<code>labels = input_ids</code> Indices are selected in <code>[-100, 0, ..., config.vocab_size]</code> All labels set to <code>-100</code>
are ignored (masked), the loss is only computed for labels in <code>[0, ..., config.vocab_size]</code>`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/gpt_neo/modeling_gpt_neo.py#L713",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_outputs.CausalLMOutputWithCrossAttentions"
>transformers.modeling_outputs.CausalLMOutputWithCrossAttentions</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/gpt_neo#transformers.GPTNeoConfig"
>GPTNeoConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Language modeling loss (for next-token prediction).</p>
</li>
<li>
<p><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head (scores for each vocabulary token before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
<li>
<p><strong>cross_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Cross attentions weights after the attention softmax, used to compute the weighted average in the
cross-attention heads.</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> tuples of length <code>config.n_layers</code>, with each tuple containing the cached key,
value states of the self-attention and the cross-attention layers if model is used in encoder-decoder
setting. Only relevant if <code>config.is_decoder = True</code>.</p>
<p>Contains pre-computed hidden-states (key and values in the attention blocks) that can be used (see
<code>past_key_values</code> input) to speed up sequential decoding.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_outputs.CausalLMOutputWithCrossAttentions"
>transformers.modeling_outputs.CausalLMOutputWithCrossAttentions</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),ze=new jo({props:{$$slots:{default:[ic]},$$scope:{ctx:N}}}),je=new ot({props:{anchor:"transformers.GPTNeoForCausalLM.forward.example",$$slots:{default:[lc]},$$scope:{ctx:N}}}),Nt=new R({}),xt=new S({props:{name:"class transformers.GPTNeoForSequenceClassification",anchor:"transformers.GPTNeoForSequenceClassification",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.GPTNeoForSequenceClassification.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/gpt_neo#transformers.GPTNeoConfig">GPTNeoConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/gpt_neo/modeling_gpt_neo.py#L819"}}),Mt=new S({props:{name:"forward",anchor:"transformers.GPTNeoForSequenceClassification.forward",parameters:[{name:"input_ids",val:": typing.Optional[torch.Tensor] = None"},{name:"past_key_values",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"attention_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"token_type_ids",val:": typing.Optional[torch.Tensor] = None"},{name:"position_ids",val:": typing.Optional[torch.Tensor] = None"},{name:"head_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"inputs_embeds",val:": typing.Optional[torch.Tensor] = None"},{name:"labels",val:": typing.Optional[torch.Tensor] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.GPTNeoForSequenceClassification.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, input_ids_length)</code>) &#x2014;
<code>input_ids_length</code> = <code>sequence_length</code> if <code>past_key_values</code> is <code>None</code> else
<code>past_key_values[0][0].shape[-2]</code> (<code>sequence_length</code> of input past key value states). Indices of input
sequence tokens in the vocabulary.</p>
<p>If <code>past_key_values</code> is used, only <code>input_ids</code> that do not have their past calculated should be passed as
<code>input_ids</code>.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.GPTNeoForSequenceClassification.forward.past_key_values",description:`<strong>past_key_values</strong> (<code>Tuple[Tuple[torch.Tensor]]</code> of length <code>config.num_layers</code>) &#x2014;
Contains precomputed hidden-states (key and values in the attention blocks) as computed by the model (see
<code>past_key_values</code> output below). Can be used to speed up sequential decoding. The <code>input_ids</code> which have
their past given to this model should not be passed as <code>input_ids</code> as they have already been computed.`,name:"past_key_values"},{anchor:"transformers.GPTNeoForSequenceClassification.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.GPTNeoForSequenceClassification.forward.token_type_ids",description:`<strong>token_type_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, input_ids_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.GPTNeoForSequenceClassification.forward.position_ids",description:`<strong>position_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.</p>
<p><a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.GPTNeoForSequenceClassification.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.GPTNeoForSequenceClassification.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.</p>
<p>If <code>past_key_values</code> is used, optionally only the last <code>inputs_embeds</code> have to be input (see
<code>past_key_values</code>).`,name:"inputs_embeds"},{anchor:"transformers.GPTNeoForSequenceClassification.forward.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set to <code>True</code>, <code>past_key_values</code> key value states are returned and can be used to speed up decoding (see
<code>past_key_values</code>).`,name:"use_cache"},{anchor:"transformers.GPTNeoForSequenceClassification.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.GPTNeoForSequenceClassification.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.GPTNeoForSequenceClassification.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.GPTNeoForSequenceClassification.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for computing the sequence classification/regression loss. Indices should be in <code>[0, ..., config.num_labels - 1]</code>. If <code>config.num_labels == 1</code> a regression loss is computed (Mean-Square loss), If
<code>config.num_labels &gt; 1</code> a classification loss is computed (Cross-Entropy).`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/gpt_neo/modeling_gpt_neo.py#L831",returnDescription:`
<p>A <code>transformers.modeling_outputs.SequenceClassifierOutputWithPast</code> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/gpt_neo#transformers.GPTNeoConfig"
>GPTNeoConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Classification (or regression if config.num_labels==1) loss.</p>
</li>
<li>
<p><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, config.num_labels)</code>) \u2014 Classification (or regression if config.num_labels==1) scores (before SoftMax).</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 Tuple of <code>tuple(torch.FloatTensor)</code> of length <code>config.n_layers</code>, with each tuple having 2 tensors of shape
<code>(batch_size, num_heads, sequence_length, embed_size_per_head)</code>)</p>
<p>Contains pre-computed hidden-states (key and values in the self-attention blocks) that can be used (see
<code>past_key_values</code> input) to speed up sequential decoding.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><code>transformers.modeling_outputs.SequenceClassifierOutputWithPast</code> or <code>tuple(torch.FloatTensor)</code></p>
`}}),Ae=new jo({props:{$$slots:{default:[dc]},$$scope:{ctx:N}}}),Ie=new ot({props:{anchor:"transformers.GPTNeoForSequenceClassification.forward.example",$$slots:{default:[cc]},$$scope:{ctx:N}}}),Le=new ot({props:{anchor:"transformers.GPTNeoForSequenceClassification.forward.example-2",$$slots:{default:[pc]},$$scope:{ctx:N}}}),Et=new R({}),zt=new S({props:{name:"class transformers.GPTNeoForTokenClassification",anchor:"transformers.GPTNeoForTokenClassification",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.GPTNeoForTokenClassification.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/gpt_neo#transformers.GPTNeoConfig">GPTNeoConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/gpt_neo/modeling_gpt_neo.py#L939"}}),It=new S({props:{name:"forward",anchor:"transformers.GPTNeoForTokenClassification.forward",parameters:[{name:"input_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"past_key_values",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.Tensor]]] = None"},{name:"attention_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"token_type_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"position_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"head_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"inputs_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"labels",val:": typing.Optional[torch.LongTensor] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.GPTNeoForTokenClassification.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, input_ids_length)</code>) &#x2014;
<code>input_ids_length</code> = <code>sequence_length</code> if <code>past_key_values</code> is <code>None</code> else
<code>past_key_values[0][0].shape[-2]</code> (<code>sequence_length</code> of input past key value states). Indices of input
sequence tokens in the vocabulary.</p>
<p>If <code>past_key_values</code> is used, only <code>input_ids</code> that do not have their past calculated should be passed as
<code>input_ids</code>.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.GPTNeoForTokenClassification.forward.past_key_values",description:`<strong>past_key_values</strong> (<code>Tuple[Tuple[torch.Tensor]]</code> of length <code>config.num_layers</code>) &#x2014;
Contains precomputed hidden-states (key and values in the attention blocks) as computed by the model (see
<code>past_key_values</code> output below). Can be used to speed up sequential decoding. The <code>input_ids</code> which have
their past given to this model should not be passed as <code>input_ids</code> as they have already been computed.`,name:"past_key_values"},{anchor:"transformers.GPTNeoForTokenClassification.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.GPTNeoForTokenClassification.forward.token_type_ids",description:`<strong>token_type_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, input_ids_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.GPTNeoForTokenClassification.forward.position_ids",description:`<strong>position_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.</p>
<p><a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.GPTNeoForTokenClassification.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.GPTNeoForTokenClassification.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.</p>
<p>If <code>past_key_values</code> is used, optionally only the last <code>inputs_embeds</code> have to be input (see
<code>past_key_values</code>).`,name:"inputs_embeds"},{anchor:"transformers.GPTNeoForTokenClassification.forward.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set to <code>True</code>, <code>past_key_values</code> key value states are returned and can be used to speed up decoding (see
<code>past_key_values</code>).`,name:"use_cache"},{anchor:"transformers.GPTNeoForTokenClassification.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.GPTNeoForTokenClassification.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.GPTNeoForTokenClassification.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.GPTNeoForTokenClassification.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Labels for computing the sequence classification/regression loss. Indices should be in <code>[0, ..., config.num_labels - 1]</code>. If <code>config.num_labels == 1</code> a regression loss is computed (Mean-Square loss), If
<code>config.num_labels &gt; 1</code> a classification loss is computed (Cross-Entropy).`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/gpt_neo/modeling_gpt_neo.py#L951",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_outputs.TokenClassifierOutput"
>transformers.modeling_outputs.TokenClassifierOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/gpt_neo#transformers.GPTNeoConfig"
>GPTNeoConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided)  \u2014 Classification loss.</p>
</li>
<li>
<p><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, config.num_labels)</code>) \u2014 Classification scores (before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_outputs.TokenClassifierOutput"
>transformers.modeling_outputs.TokenClassifierOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),Se=new jo({props:{$$slots:{default:[hc]},$$scope:{ctx:N}}}),De=new ot({props:{anchor:"transformers.GPTNeoForTokenClassification.forward.example",$$slots:{default:[uc]},$$scope:{ctx:N}}}),Lt=new R({}),Ot=new S({props:{name:"class transformers.FlaxGPTNeoModel",anchor:"transformers.FlaxGPTNeoModel",parameters:[{name:"config",val:": GPTNeoConfig"},{name:"input_shape",val:": typing.Tuple = (1, 1)"},{name:"seed",val:": int = 0"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"},{name:"_do_init",val:": bool = True"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.FlaxGPTNeoModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/gpt_neo#transformers.GPTNeoConfig">GPTNeoConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"},{anchor:"transformers.FlaxGPTNeoModel.dtype",description:`<strong>dtype</strong> (<code>jax.numpy.dtype</code>, <em>optional</em>, defaults to <code>jax.numpy.float32</code>) &#x2014;
The data type of the computation. Can be one of <code>jax.numpy.float32</code>, <code>jax.numpy.float16</code> (on GPUs) and
<code>jax.numpy.bfloat16</code> (on TPUs).</p>
<p>This can be used to enable mixed-precision training or half-precision inference on GPUs or TPUs. If
specified all the computation will be performed with the given <code>dtype</code>.</p>
<p><strong>Note that this only specifies the dtype of the computation and does not influence the dtype of model
parameters.</strong></p>
<p>If you wish to change the dtype of the model parameters, see <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel.to_fp16">to_fp16()</a> and
<a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel.to_bf16">to_bf16()</a>.`,name:"dtype"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/gpt_neo/modeling_flax_gpt_neo.py#L591"}}),Jt=new S({props:{name:"__call__",anchor:"transformers.FlaxGPTNeoModel.__call__",parameters:[{name:"input_ids",val:""},{name:"attention_mask",val:" = None"},{name:"position_ids",val:" = None"},{name:"params",val:": dict = None"},{name:"past_key_values",val:": dict = None"},{name:"dropout_rng",val:": PRNGKey = None"},{name:"train",val:": bool = False"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.FlaxGPTNeoModel.__call__.input_ids",description:`<strong>input_ids</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, input_ids_length)</code>) &#x2014;
<code>input_ids_length</code> = <code>sequence_length</code>. Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.FlaxGPTNeoModel.__call__.attention_mask",description:`<strong>attention_mask</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.FlaxGPTNeoModel.__call__.position_ids",description:`<strong>position_ids</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.`,name:"position_ids"},{anchor:"transformers.FlaxGPTNeoModel.__call__.past_key_values",description:`<strong>past_key_values</strong> (<code>Dict[str, np.ndarray]</code>, <em>optional</em>, returned by <code>init_cache</code> or when passing previous <code>past_key_values</code>) &#x2014;
Dictionary of pre-computed hidden-states (key and values in the attention blocks) that can be used for fast
auto-regressive decoding. Pre-computed key and value hidden-states are of shape <em>[batch_size, max_length]</em>.`,name:"past_key_values"},{anchor:"transformers.FlaxGPTNeoModel.__call__.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.FlaxGPTNeoModel.__call__.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.FlaxGPTNeoModel.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/gpt_neo/modeling_flax_gpt_neo.py#L401",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_flax_outputs.FlaxBaseModelOutput"
>transformers.modeling_flax_outputs.FlaxBaseModelOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/gpt_neo#transformers.GPTNeoConfig"
>GPTNeoConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>last_hidden_state</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the model.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_flax_outputs.FlaxBaseModelOutput"
>transformers.modeling_flax_outputs.FlaxBaseModelOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),We=new jo({props:{$$slots:{default:[mc]},$$scope:{ctx:N}}}),He=new ot({props:{anchor:"transformers.FlaxGPTNeoModel.__call__.example",$$slots:{default:[fc]},$$scope:{ctx:N}}}),Rt=new R({}),Xt=new S({props:{name:"class transformers.FlaxGPTNeoForCausalLM",anchor:"transformers.FlaxGPTNeoForCausalLM",parameters:[{name:"config",val:": GPTNeoConfig"},{name:"input_shape",val:": typing.Tuple = (1, 1)"},{name:"seed",val:": int = 0"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"},{name:"_do_init",val:": bool = True"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.FlaxGPTNeoForCausalLM.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/gpt_neo#transformers.GPTNeoConfig">GPTNeoConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"},{anchor:"transformers.FlaxGPTNeoForCausalLM.dtype",description:`<strong>dtype</strong> (<code>jax.numpy.dtype</code>, <em>optional</em>, defaults to <code>jax.numpy.float32</code>) &#x2014;
The data type of the computation. Can be one of <code>jax.numpy.float32</code>, <code>jax.numpy.float16</code> (on GPUs) and
<code>jax.numpy.bfloat16</code> (on TPUs).</p>
<p>This can be used to enable mixed-precision training or half-precision inference on GPUs or TPUs. If
specified all the computation will be performed with the given <code>dtype</code>.</p>
<p><strong>Note that this only specifies the dtype of the computation and does not influence the dtype of model
parameters.</strong></p>
<p>If you wish to change the dtype of the model parameters, see <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel.to_fp16">to_fp16()</a> and
<a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel.to_bf16">to_bf16()</a>.`,name:"dtype"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/gpt_neo/modeling_flax_gpt_neo.py#L654"}}),no=new S({props:{name:"__call__",anchor:"transformers.FlaxGPTNeoForCausalLM.__call__",parameters:[{name:"input_ids",val:""},{name:"attention_mask",val:" = None"},{name:"position_ids",val:" = None"},{name:"params",val:": dict = None"},{name:"past_key_values",val:": dict = None"},{name:"dropout_rng",val:": PRNGKey = None"},{name:"train",val:": bool = False"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.FlaxGPTNeoForCausalLM.__call__.input_ids",description:`<strong>input_ids</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, input_ids_length)</code>) &#x2014;
<code>input_ids_length</code> = <code>sequence_length</code>. Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.FlaxGPTNeoForCausalLM.__call__.attention_mask",description:`<strong>attention_mask</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.FlaxGPTNeoForCausalLM.__call__.position_ids",description:`<strong>position_ids</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.`,name:"position_ids"},{anchor:"transformers.FlaxGPTNeoForCausalLM.__call__.past_key_values",description:`<strong>past_key_values</strong> (<code>Dict[str, np.ndarray]</code>, <em>optional</em>, returned by <code>init_cache</code> or when passing previous <code>past_key_values</code>) &#x2014;
Dictionary of pre-computed hidden-states (key and values in the attention blocks) that can be used for fast
auto-regressive decoding. Pre-computed key and value hidden-states are of shape <em>[batch_size, max_length]</em>.`,name:"past_key_values"},{anchor:"transformers.FlaxGPTNeoForCausalLM.__call__.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.FlaxGPTNeoForCausalLM.__call__.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.FlaxGPTNeoForCausalLM.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/gpt_neo/modeling_flax_gpt_neo.py#L401",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_flax_outputs.FlaxMaskedLMOutput"
>transformers.modeling_flax_outputs.FlaxMaskedLMOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/gpt_neo#transformers.GPTNeoConfig"
>GPTNeoConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>logits</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head (scores for each vocabulary token before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_flax_outputs.FlaxMaskedLMOutput"
>transformers.modeling_flax_outputs.FlaxMaskedLMOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),Ve=new jo({props:{$$slots:{default:[gc]},$$scope:{ctx:N}}}),Je=new ot({props:{anchor:"transformers.FlaxGPTNeoForCausalLM.__call__.example",$$slots:{default:[_c]},$$scope:{ctx:N}}}),{c(){d=n("meta"),v=p(),f=n("h1"),m=n("a"),_=n("span"),b(a.$$.fragment),u=p(),x=n("span"),As=i("GPT Neo"),Wn=p(),te=n("h2"),ke=n("a"),qo=n("span"),b(st.$$.fragment),Is=p(),Ao=n("span"),Ls=i("Overview"),Hn=p(),X=n("p"),Os=i("The GPTNeo model was released in the "),at=n("a"),Ss=i("EleutherAI/gpt-neo"),Ds=i(` repository by Sid
Black, Stella Biderman, Leo Gao, Phil Wang and Connor Leahy. It is a GPT2 like causal language model trained on the
`),rt=n("a"),Bs=i("Pile"),Ws=i(" dataset."),Un=p(),io=n("p"),Hs=i(`The architecture is similar to GPT2 except that GPT Neo uses local attention in every other layer with a window size of
256 tokens.`),Vn=p(),ye=n("p"),Us=i("This model was contributed by "),it=n("a"),Vs=i("valhalla"),Js=i("."),Jn=p(),oe=n("h3"),we=n("a"),Io=n("span"),b(lt.$$.fragment),Rs=p(),Lo=n("span"),Xs=i("Generation"),Rn=p(),Pe=n("p"),Ks=i("The "),Oo=n("code"),Ys=i("generate()"),Qs=i(" method can be used to generate text using GPT Neo model."),Xn=p(),b(dt.$$.fragment),Kn=p(),ne=n("h2"),$e=n("a"),So=n("span"),b(ct.$$.fragment),Zs=p(),Do=n("span"),ea=i("Documentation resources"),Yn=p(),Ne=n("ul"),Bo=n("li"),lo=n("a"),ta=i("Text classification task guide"),oa=p(),Wo=n("li"),co=n("a"),na=i("Causal language modeling task guide"),Qn=p(),se=n("h2"),xe=n("a"),Ho=n("span"),b(pt.$$.fragment),sa=p(),Uo=n("span"),aa=i("GPTNeoConfig"),Zn=p(),L=n("div"),b(ht.$$.fragment),ra=p(),ae=n("p"),ia=i("This is the configuration class to store the configuration of a "),po=n("a"),la=i("GPTNeoModel"),da=i(`. It is used to instantiate a GPT
Neo model according to the specified arguments, defining the model architecture. Instantiating a configuration with
the defaults will yield a similar configuration to that of the GPTNeo
`),ut=n("a"),ca=i("EleutherAI/gpt-neo-1.3B"),pa=i(" architecture."),ha=p(),re=n("p"),ua=i("Configuration objects inherit from "),ho=n("a"),ma=i("PretrainedConfig"),fa=i(` and can be used to control the model outputs. Read the
documentation from `),uo=n("a"),ga=i("PretrainedConfig"),_a=i(" for more information."),Ta=p(),b(Fe.$$.fragment),es=p(),ie=n("h2"),Ge=n("a"),Vo=n("span"),b(mt.$$.fragment),va=p(),Jo=n("span"),ba=i("GPTNeoModel"),ts=p(),M=n("div"),b(ft.$$.fragment),ka=p(),Ro=n("p"),ya=i("The bare GPT Neo Model transformer outputting raw hidden-states without any specific head on top."),wa=p(),gt=n("p"),Pa=i("This model inherits from "),mo=n("a"),$a=i("PreTrainedModel"),Na=i(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),xa=p(),_t=n("p"),Fa=i("This model is also a PyTorch "),Tt=n("a"),Ga=i("torch.nn.Module"),Ca=i(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),Ma=p(),D=n("div"),b(vt.$$.fragment),Ea=p(),le=n("p"),za=i("The "),fo=n("a"),ja=i("GPTNeoModel"),qa=i(" forward method, overrides the "),Xo=n("code"),Aa=i("__call__"),Ia=i(" special method."),La=p(),b(Ce.$$.fragment),Oa=p(),b(Me.$$.fragment),os=p(),de=n("h2"),Ee=n("a"),Ko=n("span"),b(bt.$$.fragment),Sa=p(),Yo=n("span"),Da=i("GPTNeoForCausalLM"),ns=p(),E=n("div"),b(kt.$$.fragment),Ba=p(),Qo=n("p"),Wa=i(`The GPT Neo Model transformer with a language modeling head on top (linear layer with weights tied to the input
embeddings).`),Ha=p(),yt=n("p"),Ua=i("This model inherits from "),go=n("a"),Va=i("PreTrainedModel"),Ja=i(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Ra=p(),wt=n("p"),Xa=i("This model is also a PyTorch "),Pt=n("a"),Ka=i("torch.nn.Module"),Ya=i(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),Qa=p(),B=n("div"),b($t.$$.fragment),Za=p(),ce=n("p"),er=i("The "),_o=n("a"),tr=i("GPTNeoForCausalLM"),or=i(" forward method, overrides the "),Zo=n("code"),nr=i("__call__"),sr=i(" special method."),ar=p(),b(ze.$$.fragment),rr=p(),b(je.$$.fragment),ss=p(),pe=n("h2"),qe=n("a"),en=n("span"),b(Nt.$$.fragment),ir=p(),tn=n("span"),lr=i("GPTNeoForSequenceClassification"),as=p(),F=n("div"),b(xt.$$.fragment),dr=p(),on=n("p"),cr=i("The GPTNeo Model transformer with a sequence classification head on top (linear layer)."),pr=p(),To=n("p"),vo=n("a"),hr=i("GPTNeoForSequenceClassification"),ur=i(` uses the last token in order to do the classification, as other causal models
(e.g. GPT-1) do.`),mr=p(),O=n("p"),fr=i(`Since it does classification on the last token, it requires to know the position of the last token. If a
`),nn=n("code"),gr=i("pad_token_id"),_r=i(` is defined in the configuration, it finds the last token that is not a padding token in each row. If
no `),sn=n("code"),Tr=i("pad_token_id"),vr=i(` is defined, it simply takes the last value in each row of the batch. Since it cannot guess the
padding tokens when `),an=n("code"),br=i("inputs_embeds"),kr=i(" are passed instead of "),rn=n("code"),yr=i("input_ids"),wr=i(`, it does the same (take the last value in
each row of the batch).`),Pr=p(),Ft=n("p"),$r=i("This model inherits from "),bo=n("a"),Nr=i("PreTrainedModel"),xr=i(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Fr=p(),Gt=n("p"),Gr=i("This model is also a PyTorch "),Ct=n("a"),Cr=i("torch.nn.Module"),Mr=i(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),Er=p(),j=n("div"),b(Mt.$$.fragment),zr=p(),he=n("p"),jr=i("The "),ko=n("a"),qr=i("GPTNeoForSequenceClassification"),Ar=i(" forward method, overrides the "),ln=n("code"),Ir=i("__call__"),Lr=i(" special method."),Or=p(),b(Ae.$$.fragment),Sr=p(),b(Ie.$$.fragment),Dr=p(),b(Le.$$.fragment),rs=p(),ue=n("h2"),Oe=n("a"),dn=n("span"),b(Et.$$.fragment),Br=p(),cn=n("span"),Wr=i("GPTNeoForTokenClassification"),is=p(),z=n("div"),b(zt.$$.fragment),Hr=p(),pn=n("p"),Ur=i(`GPT Neo model with a token classification head on top (a linear layer on top of the hidden-states output) e.g. for
Named-Entity-Recognition (NER) tasks.`),Vr=p(),jt=n("p"),Jr=i("This model inherits from "),yo=n("a"),Rr=i("PreTrainedModel"),Xr=i(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Kr=p(),qt=n("p"),Yr=i("This model is also a PyTorch "),At=n("a"),Qr=i("torch.nn.Module"),Zr=i(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),ei=p(),W=n("div"),b(It.$$.fragment),ti=p(),me=n("p"),oi=i("The "),wo=n("a"),ni=i("GPTNeoForTokenClassification"),si=i(" forward method, overrides the "),hn=n("code"),ai=i("__call__"),ri=i(" special method."),ii=p(),b(Se.$$.fragment),li=p(),b(De.$$.fragment),ls=p(),fe=n("h2"),Be=n("a"),un=n("span"),b(Lt.$$.fragment),di=p(),mn=n("span"),ci=i("FlaxGPTNeoModel"),ds=p(),G=n("div"),b(Ot.$$.fragment),pi=p(),fn=n("p"),hi=i("The bare GPTNeo Model transformer outputting raw hidden-states without any specific head on top."),ui=p(),St=n("p"),mi=i("This model inherits from "),Po=n("a"),fi=i("FlaxPreTrainedModel"),gi=i(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),_i=p(),Dt=n("p"),Ti=i(`This model is also a Flax Linen
`),Bt=n("a"),vi=i("flax.nn.Module"),bi=i(` subclass. Use it as a
regular Flax Module and refer to the Flax documentation for all matter related to general usage and behavior.`),ki=p(),gn=n("p"),yi=i("Finally, this model supports inherent JAX features such as:"),wi=p(),V=n("ul"),_n=n("li"),Wt=n("a"),Pi=i("Just-In-Time (JIT) compilation"),$i=p(),Tn=n("li"),Ht=n("a"),Ni=i("Automatic Differentiation"),xi=p(),vn=n("li"),Ut=n("a"),Fi=i("Vectorization"),Gi=p(),bn=n("li"),Vt=n("a"),Ci=i("Parallelization"),Mi=p(),H=n("div"),b(Jt.$$.fragment),Ei=p(),ge=n("p"),zi=i("The "),kn=n("code"),ji=i("FlaxGPTNeoPreTrainedModel"),qi=i(" forward method, overrides the "),yn=n("code"),Ai=i("__call__"),Ii=i(" special method."),Li=p(),b(We.$$.fragment),Oi=p(),b(He.$$.fragment),cs=p(),_e=n("h2"),Ue=n("a"),wn=n("span"),b(Rt.$$.fragment),Si=p(),Pn=n("span"),Di=i("FlaxGPTNeoForCausalLM"),ps=p(),C=n("div"),b(Xt.$$.fragment),Bi=p(),$n=n("p"),Wi=i(`The GPTNeo Model transformer with a language modeling head on top (linear layer with weights tied to the input
embeddings).`),Hi=p(),Kt=n("p"),Ui=i("This model inherits from "),$o=n("a"),Vi=i("FlaxPreTrainedModel"),Ji=i(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Ri=p(),Yt=n("p"),Xi=i(`This model is also a Flax Linen
`),Qt=n("a"),Ki=i("flax.nn.Module"),Yi=i(` subclass. Use it as a
regular Flax Module and refer to the Flax documentation for all matter related to general usage and behavior.`),Qi=p(),Nn=n("p"),Zi=i("Finally, this model supports inherent JAX features such as:"),el=p(),J=n("ul"),xn=n("li"),Zt=n("a"),tl=i("Just-In-Time (JIT) compilation"),ol=p(),Fn=n("li"),eo=n("a"),nl=i("Automatic Differentiation"),sl=p(),Gn=n("li"),to=n("a"),al=i("Vectorization"),rl=p(),Cn=n("li"),oo=n("a"),il=i("Parallelization"),ll=p(),U=n("div"),b(no.$$.fragment),dl=p(),Te=n("p"),cl=i("The "),Mn=n("code"),pl=i("FlaxGPTNeoPreTrainedModel"),hl=i(" forward method, overrides the "),En=n("code"),ul=i("__call__"),ml=i(" special method."),fl=p(),b(Ve.$$.fragment),gl=p(),b(Je.$$.fragment),this.h()},l(o){const g=oc('[data-svelte="svelte-1phssyn"]',document.head);d=s(g,"META",{name:!0,content:!0}),g.forEach(t),v=h(o),f=s(o,"H1",{class:!0});var so=r(f);m=s(so,"A",{id:!0,class:!0,href:!0});var zn=r(m);_=s(zn,"SPAN",{});var jn=r(_);k(a.$$.fragment,jn),jn.forEach(t),zn.forEach(t),u=h(so),x=s(so,"SPAN",{});var qn=r(x);As=l(qn,"GPT Neo"),qn.forEach(t),so.forEach(t),Wn=h(o),te=s(o,"H2",{class:!0});var ao=r(te);ke=s(ao,"A",{id:!0,class:!0,href:!0});var An=r(ke);qo=s(An,"SPAN",{});var In=r(qo);k(st.$$.fragment,In),In.forEach(t),An.forEach(t),Is=h(ao),Ao=s(ao,"SPAN",{});var Ln=r(Ao);Ls=l(Ln,"Overview"),Ln.forEach(t),ao.forEach(t),Hn=h(o),X=s(o,"P",{});var ve=r(X);Os=l(ve,"The GPTNeo model was released in the "),at=s(ve,"A",{href:!0,rel:!0});var On=r(at);Ss=l(On,"EleutherAI/gpt-neo"),On.forEach(t),Ds=l(ve,` repository by Sid
Black, Stella Biderman, Leo Gao, Phil Wang and Connor Leahy. It is a GPT2 like causal language model trained on the
`),rt=s(ve,"A",{href:!0,rel:!0});var Sn=r(rt);Bs=l(Sn,"Pile"),Sn.forEach(t),Ws=l(ve," dataset."),ve.forEach(t),Un=h(o),io=s(o,"P",{});var Dn=r(io);Hs=l(Dn,`The architecture is similar to GPT2 except that GPT Neo uses local attention in every other layer with a window size of
256 tokens.`),Dn.forEach(t),Vn=h(o),ye=s(o,"P",{});var ro=r(ye);Us=l(ro,"This model was contributed by "),it=s(ro,"A",{href:!0,rel:!0});var Bn=r(it);Vs=l(Bn,"valhalla"),Bn.forEach(t),Js=l(ro,"."),ro.forEach(t),Jn=h(o),oe=s(o,"H3",{class:!0});var us=r(oe);we=s(us,"A",{id:!0,class:!0,href:!0});var Tl=r(we);Io=s(Tl,"SPAN",{});var vl=r(Io);k(lt.$$.fragment,vl),vl.forEach(t),Tl.forEach(t),Rs=h(us),Lo=s(us,"SPAN",{});var bl=r(Lo);Xs=l(bl,"Generation"),bl.forEach(t),us.forEach(t),Rn=h(o),Pe=s(o,"P",{});var ms=r(Pe);Ks=l(ms,"The "),Oo=s(ms,"CODE",{});var kl=r(Oo);Ys=l(kl,"generate()"),kl.forEach(t),Qs=l(ms," method can be used to generate text using GPT Neo model."),ms.forEach(t),Xn=h(o),k(dt.$$.fragment,o),Kn=h(o),ne=s(o,"H2",{class:!0});var fs=r(ne);$e=s(fs,"A",{id:!0,class:!0,href:!0});var yl=r($e);So=s(yl,"SPAN",{});var wl=r(So);k(ct.$$.fragment,wl),wl.forEach(t),yl.forEach(t),Zs=h(fs),Do=s(fs,"SPAN",{});var Pl=r(Do);ea=l(Pl,"Documentation resources"),Pl.forEach(t),fs.forEach(t),Yn=h(o),Ne=s(o,"UL",{});var gs=r(Ne);Bo=s(gs,"LI",{});var $l=r(Bo);lo=s($l,"A",{href:!0});var Nl=r(lo);ta=l(Nl,"Text classification task guide"),Nl.forEach(t),$l.forEach(t),oa=h(gs),Wo=s(gs,"LI",{});var xl=r(Wo);co=s(xl,"A",{href:!0});var Fl=r(co);na=l(Fl,"Causal language modeling task guide"),Fl.forEach(t),xl.forEach(t),gs.forEach(t),Qn=h(o),se=s(o,"H2",{class:!0});var _s=r(se);xe=s(_s,"A",{id:!0,class:!0,href:!0});var Gl=r(xe);Ho=s(Gl,"SPAN",{});var Cl=r(Ho);k(pt.$$.fragment,Cl),Cl.forEach(t),Gl.forEach(t),sa=h(_s),Uo=s(_s,"SPAN",{});var Ml=r(Uo);aa=l(Ml,"GPTNeoConfig"),Ml.forEach(t),_s.forEach(t),Zn=h(o),L=s(o,"DIV",{class:!0});var Re=r(L);k(ht.$$.fragment,Re),ra=h(Re),ae=s(Re,"P",{});var No=r(ae);ia=l(No,"This is the configuration class to store the configuration of a "),po=s(No,"A",{href:!0});var El=r(po);la=l(El,"GPTNeoModel"),El.forEach(t),da=l(No,`. It is used to instantiate a GPT
Neo model according to the specified arguments, defining the model architecture. Instantiating a configuration with
the defaults will yield a similar configuration to that of the GPTNeo
`),ut=s(No,"A",{href:!0,rel:!0});var zl=r(ut);ca=l(zl,"EleutherAI/gpt-neo-1.3B"),zl.forEach(t),pa=l(No," architecture."),No.forEach(t),ha=h(Re),re=s(Re,"P",{});var xo=r(re);ua=l(xo,"Configuration objects inherit from "),ho=s(xo,"A",{href:!0});var jl=r(ho);ma=l(jl,"PretrainedConfig"),jl.forEach(t),fa=l(xo,` and can be used to control the model outputs. Read the
documentation from `),uo=s(xo,"A",{href:!0});var ql=r(uo);ga=l(ql,"PretrainedConfig"),ql.forEach(t),_a=l(xo," for more information."),xo.forEach(t),Ta=h(Re),k(Fe.$$.fragment,Re),Re.forEach(t),es=h(o),ie=s(o,"H2",{class:!0});var Ts=r(ie);Ge=s(Ts,"A",{id:!0,class:!0,href:!0});var Al=r(Ge);Vo=s(Al,"SPAN",{});var Il=r(Vo);k(mt.$$.fragment,Il),Il.forEach(t),Al.forEach(t),va=h(Ts),Jo=s(Ts,"SPAN",{});var Ll=r(Jo);ba=l(Ll,"GPTNeoModel"),Ll.forEach(t),Ts.forEach(t),ts=h(o),M=s(o,"DIV",{class:!0});var K=r(M);k(ft.$$.fragment,K),ka=h(K),Ro=s(K,"P",{});var Ol=r(Ro);ya=l(Ol,"The bare GPT Neo Model transformer outputting raw hidden-states without any specific head on top."),Ol.forEach(t),wa=h(K),gt=s(K,"P",{});var vs=r(gt);Pa=l(vs,"This model inherits from "),mo=s(vs,"A",{href:!0});var Sl=r(mo);$a=l(Sl,"PreTrainedModel"),Sl.forEach(t),Na=l(vs,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),vs.forEach(t),xa=h(K),_t=s(K,"P",{});var bs=r(_t);Fa=l(bs,"This model is also a PyTorch "),Tt=s(bs,"A",{href:!0,rel:!0});var Dl=r(Tt);Ga=l(Dl,"torch.nn.Module"),Dl.forEach(t),Ca=l(bs,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),bs.forEach(t),Ma=h(K),D=s(K,"DIV",{class:!0});var Xe=r(D);k(vt.$$.fragment,Xe),Ea=h(Xe),le=s(Xe,"P",{});var Fo=r(le);za=l(Fo,"The "),fo=s(Fo,"A",{href:!0});var Bl=r(fo);ja=l(Bl,"GPTNeoModel"),Bl.forEach(t),qa=l(Fo," forward method, overrides the "),Xo=s(Fo,"CODE",{});var Wl=r(Xo);Aa=l(Wl,"__call__"),Wl.forEach(t),Ia=l(Fo," special method."),Fo.forEach(t),La=h(Xe),k(Ce.$$.fragment,Xe),Oa=h(Xe),k(Me.$$.fragment,Xe),Xe.forEach(t),K.forEach(t),os=h(o),de=s(o,"H2",{class:!0});var ks=r(de);Ee=s(ks,"A",{id:!0,class:!0,href:!0});var Hl=r(Ee);Ko=s(Hl,"SPAN",{});var Ul=r(Ko);k(bt.$$.fragment,Ul),Ul.forEach(t),Hl.forEach(t),Sa=h(ks),Yo=s(ks,"SPAN",{});var Vl=r(Yo);Da=l(Vl,"GPTNeoForCausalLM"),Vl.forEach(t),ks.forEach(t),ns=h(o),E=s(o,"DIV",{class:!0});var Y=r(E);k(kt.$$.fragment,Y),Ba=h(Y),Qo=s(Y,"P",{});var Jl=r(Qo);Wa=l(Jl,`The GPT Neo Model transformer with a language modeling head on top (linear layer with weights tied to the input
embeddings).`),Jl.forEach(t),Ha=h(Y),yt=s(Y,"P",{});var ys=r(yt);Ua=l(ys,"This model inherits from "),go=s(ys,"A",{href:!0});var Rl=r(go);Va=l(Rl,"PreTrainedModel"),Rl.forEach(t),Ja=l(ys,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),ys.forEach(t),Ra=h(Y),wt=s(Y,"P",{});var ws=r(wt);Xa=l(ws,"This model is also a PyTorch "),Pt=s(ws,"A",{href:!0,rel:!0});var Xl=r(Pt);Ka=l(Xl,"torch.nn.Module"),Xl.forEach(t),Ya=l(ws,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),ws.forEach(t),Qa=h(Y),B=s(Y,"DIV",{class:!0});var Ke=r(B);k($t.$$.fragment,Ke),Za=h(Ke),ce=s(Ke,"P",{});var Go=r(ce);er=l(Go,"The "),_o=s(Go,"A",{href:!0});var Kl=r(_o);tr=l(Kl,"GPTNeoForCausalLM"),Kl.forEach(t),or=l(Go," forward method, overrides the "),Zo=s(Go,"CODE",{});var Yl=r(Zo);nr=l(Yl,"__call__"),Yl.forEach(t),sr=l(Go," special method."),Go.forEach(t),ar=h(Ke),k(ze.$$.fragment,Ke),rr=h(Ke),k(je.$$.fragment,Ke),Ke.forEach(t),Y.forEach(t),ss=h(o),pe=s(o,"H2",{class:!0});var Ps=r(pe);qe=s(Ps,"A",{id:!0,class:!0,href:!0});var Ql=r(qe);en=s(Ql,"SPAN",{});var Zl=r(en);k(Nt.$$.fragment,Zl),Zl.forEach(t),Ql.forEach(t),ir=h(Ps),tn=s(Ps,"SPAN",{});var ed=r(tn);lr=l(ed,"GPTNeoForSequenceClassification"),ed.forEach(t),Ps.forEach(t),as=h(o),F=s(o,"DIV",{class:!0});var q=r(F);k(xt.$$.fragment,q),dr=h(q),on=s(q,"P",{});var td=r(on);cr=l(td,"The GPTNeo Model transformer with a sequence classification head on top (linear layer)."),td.forEach(t),pr=h(q),To=s(q,"P",{});var _l=r(To);vo=s(_l,"A",{href:!0});var od=r(vo);hr=l(od,"GPTNeoForSequenceClassification"),od.forEach(t),ur=l(_l,` uses the last token in order to do the classification, as other causal models
(e.g. GPT-1) do.`),_l.forEach(t),mr=h(q),O=s(q,"P",{});var Q=r(O);fr=l(Q,`Since it does classification on the last token, it requires to know the position of the last token. If a
`),nn=s(Q,"CODE",{});var nd=r(nn);gr=l(nd,"pad_token_id"),nd.forEach(t),_r=l(Q,` is defined in the configuration, it finds the last token that is not a padding token in each row. If
no `),sn=s(Q,"CODE",{});var sd=r(sn);Tr=l(sd,"pad_token_id"),sd.forEach(t),vr=l(Q,` is defined, it simply takes the last value in each row of the batch. Since it cannot guess the
padding tokens when `),an=s(Q,"CODE",{});var ad=r(an);br=l(ad,"inputs_embeds"),ad.forEach(t),kr=l(Q," are passed instead of "),rn=s(Q,"CODE",{});var rd=r(rn);yr=l(rd,"input_ids"),rd.forEach(t),wr=l(Q,`, it does the same (take the last value in
each row of the batch).`),Q.forEach(t),Pr=h(q),Ft=s(q,"P",{});var $s=r(Ft);$r=l($s,"This model inherits from "),bo=s($s,"A",{href:!0});var id=r(bo);Nr=l(id,"PreTrainedModel"),id.forEach(t),xr=l($s,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),$s.forEach(t),Fr=h(q),Gt=s(q,"P",{});var Ns=r(Gt);Gr=l(Ns,"This model is also a PyTorch "),Ct=s(Ns,"A",{href:!0,rel:!0});var ld=r(Ct);Cr=l(ld,"torch.nn.Module"),ld.forEach(t),Mr=l(Ns,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),Ns.forEach(t),Er=h(q),j=s(q,"DIV",{class:!0});var Z=r(j);k(Mt.$$.fragment,Z),zr=h(Z),he=s(Z,"P",{});var Co=r(he);jr=l(Co,"The "),ko=s(Co,"A",{href:!0});var dd=r(ko);qr=l(dd,"GPTNeoForSequenceClassification"),dd.forEach(t),Ar=l(Co," forward method, overrides the "),ln=s(Co,"CODE",{});var cd=r(ln);Ir=l(cd,"__call__"),cd.forEach(t),Lr=l(Co," special method."),Co.forEach(t),Or=h(Z),k(Ae.$$.fragment,Z),Sr=h(Z),k(Ie.$$.fragment,Z),Dr=h(Z),k(Le.$$.fragment,Z),Z.forEach(t),q.forEach(t),rs=h(o),ue=s(o,"H2",{class:!0});var xs=r(ue);Oe=s(xs,"A",{id:!0,class:!0,href:!0});var pd=r(Oe);dn=s(pd,"SPAN",{});var hd=r(dn);k(Et.$$.fragment,hd),hd.forEach(t),pd.forEach(t),Br=h(xs),cn=s(xs,"SPAN",{});var ud=r(cn);Wr=l(ud,"GPTNeoForTokenClassification"),ud.forEach(t),xs.forEach(t),is=h(o),z=s(o,"DIV",{class:!0});var ee=r(z);k(zt.$$.fragment,ee),Hr=h(ee),pn=s(ee,"P",{});var md=r(pn);Ur=l(md,`GPT Neo model with a token classification head on top (a linear layer on top of the hidden-states output) e.g. for
Named-Entity-Recognition (NER) tasks.`),md.forEach(t),Vr=h(ee),jt=s(ee,"P",{});var Fs=r(jt);Jr=l(Fs,"This model inherits from "),yo=s(Fs,"A",{href:!0});var fd=r(yo);Rr=l(fd,"PreTrainedModel"),fd.forEach(t),Xr=l(Fs,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Fs.forEach(t),Kr=h(ee),qt=s(ee,"P",{});var Gs=r(qt);Yr=l(Gs,"This model is also a PyTorch "),At=s(Gs,"A",{href:!0,rel:!0});var gd=r(At);Qr=l(gd,"torch.nn.Module"),gd.forEach(t),Zr=l(Gs,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),Gs.forEach(t),ei=h(ee),W=s(ee,"DIV",{class:!0});var Ye=r(W);k(It.$$.fragment,Ye),ti=h(Ye),me=s(Ye,"P",{});var Mo=r(me);oi=l(Mo,"The "),wo=s(Mo,"A",{href:!0});var _d=r(wo);ni=l(_d,"GPTNeoForTokenClassification"),_d.forEach(t),si=l(Mo," forward method, overrides the "),hn=s(Mo,"CODE",{});var Td=r(hn);ai=l(Td,"__call__"),Td.forEach(t),ri=l(Mo," special method."),Mo.forEach(t),ii=h(Ye),k(Se.$$.fragment,Ye),li=h(Ye),k(De.$$.fragment,Ye),Ye.forEach(t),ee.forEach(t),ls=h(o),fe=s(o,"H2",{class:!0});var Cs=r(fe);Be=s(Cs,"A",{id:!0,class:!0,href:!0});var vd=r(Be);un=s(vd,"SPAN",{});var bd=r(un);k(Lt.$$.fragment,bd),bd.forEach(t),vd.forEach(t),di=h(Cs),mn=s(Cs,"SPAN",{});var kd=r(mn);ci=l(kd,"FlaxGPTNeoModel"),kd.forEach(t),Cs.forEach(t),ds=h(o),G=s(o,"DIV",{class:!0});var A=r(G);k(Ot.$$.fragment,A),pi=h(A),fn=s(A,"P",{});var yd=r(fn);hi=l(yd,"The bare GPTNeo Model transformer outputting raw hidden-states without any specific head on top."),yd.forEach(t),ui=h(A),St=s(A,"P",{});var Ms=r(St);mi=l(Ms,"This model inherits from "),Po=s(Ms,"A",{href:!0});var wd=r(Po);fi=l(wd,"FlaxPreTrainedModel"),wd.forEach(t),gi=l(Ms,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Ms.forEach(t),_i=h(A),Dt=s(A,"P",{});var Es=r(Dt);Ti=l(Es,`This model is also a Flax Linen
`),Bt=s(Es,"A",{href:!0,rel:!0});var Pd=r(Bt);vi=l(Pd,"flax.nn.Module"),Pd.forEach(t),bi=l(Es,` subclass. Use it as a
regular Flax Module and refer to the Flax documentation for all matter related to general usage and behavior.`),Es.forEach(t),ki=h(A),gn=s(A,"P",{});var $d=r(gn);yi=l($d,"Finally, this model supports inherent JAX features such as:"),$d.forEach(t),wi=h(A),V=s(A,"UL",{});var Qe=r(V);_n=s(Qe,"LI",{});var Nd=r(_n);Wt=s(Nd,"A",{href:!0,rel:!0});var xd=r(Wt);Pi=l(xd,"Just-In-Time (JIT) compilation"),xd.forEach(t),Nd.forEach(t),$i=h(Qe),Tn=s(Qe,"LI",{});var Fd=r(Tn);Ht=s(Fd,"A",{href:!0,rel:!0});var Gd=r(Ht);Ni=l(Gd,"Automatic Differentiation"),Gd.forEach(t),Fd.forEach(t),xi=h(Qe),vn=s(Qe,"LI",{});var Cd=r(vn);Ut=s(Cd,"A",{href:!0,rel:!0});var Md=r(Ut);Fi=l(Md,"Vectorization"),Md.forEach(t),Cd.forEach(t),Gi=h(Qe),bn=s(Qe,"LI",{});var Ed=r(bn);Vt=s(Ed,"A",{href:!0,rel:!0});var zd=r(Vt);Ci=l(zd,"Parallelization"),zd.forEach(t),Ed.forEach(t),Qe.forEach(t),Mi=h(A),H=s(A,"DIV",{class:!0});var Ze=r(H);k(Jt.$$.fragment,Ze),Ei=h(Ze),ge=s(Ze,"P",{});var Eo=r(ge);zi=l(Eo,"The "),kn=s(Eo,"CODE",{});var jd=r(kn);ji=l(jd,"FlaxGPTNeoPreTrainedModel"),jd.forEach(t),qi=l(Eo," forward method, overrides the "),yn=s(Eo,"CODE",{});var qd=r(yn);Ai=l(qd,"__call__"),qd.forEach(t),Ii=l(Eo," special method."),Eo.forEach(t),Li=h(Ze),k(We.$$.fragment,Ze),Oi=h(Ze),k(He.$$.fragment,Ze),Ze.forEach(t),A.forEach(t),cs=h(o),_e=s(o,"H2",{class:!0});var zs=r(_e);Ue=s(zs,"A",{id:!0,class:!0,href:!0});var Ad=r(Ue);wn=s(Ad,"SPAN",{});var Id=r(wn);k(Rt.$$.fragment,Id),Id.forEach(t),Ad.forEach(t),Si=h(zs),Pn=s(zs,"SPAN",{});var Ld=r(Pn);Di=l(Ld,"FlaxGPTNeoForCausalLM"),Ld.forEach(t),zs.forEach(t),ps=h(o),C=s(o,"DIV",{class:!0});var I=r(C);k(Xt.$$.fragment,I),Bi=h(I),$n=s(I,"P",{});var Od=r($n);Wi=l(Od,`The GPTNeo Model transformer with a language modeling head on top (linear layer with weights tied to the input
embeddings).`),Od.forEach(t),Hi=h(I),Kt=s(I,"P",{});var js=r(Kt);Ui=l(js,"This model inherits from "),$o=s(js,"A",{href:!0});var Sd=r($o);Vi=l(Sd,"FlaxPreTrainedModel"),Sd.forEach(t),Ji=l(js,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),js.forEach(t),Ri=h(I),Yt=s(I,"P",{});var qs=r(Yt);Xi=l(qs,`This model is also a Flax Linen
`),Qt=s(qs,"A",{href:!0,rel:!0});var Dd=r(Qt);Ki=l(Dd,"flax.nn.Module"),Dd.forEach(t),Yi=l(qs,` subclass. Use it as a
regular Flax Module and refer to the Flax documentation for all matter related to general usage and behavior.`),qs.forEach(t),Qi=h(I),Nn=s(I,"P",{});var Bd=r(Nn);Zi=l(Bd,"Finally, this model supports inherent JAX features such as:"),Bd.forEach(t),el=h(I),J=s(I,"UL",{});var et=r(J);xn=s(et,"LI",{});var Wd=r(xn);Zt=s(Wd,"A",{href:!0,rel:!0});var Hd=r(Zt);tl=l(Hd,"Just-In-Time (JIT) compilation"),Hd.forEach(t),Wd.forEach(t),ol=h(et),Fn=s(et,"LI",{});var Ud=r(Fn);eo=s(Ud,"A",{href:!0,rel:!0});var Vd=r(eo);nl=l(Vd,"Automatic Differentiation"),Vd.forEach(t),Ud.forEach(t),sl=h(et),Gn=s(et,"LI",{});var Jd=r(Gn);to=s(Jd,"A",{href:!0,rel:!0});var Rd=r(to);al=l(Rd,"Vectorization"),Rd.forEach(t),Jd.forEach(t),rl=h(et),Cn=s(et,"LI",{});var Xd=r(Cn);oo=s(Xd,"A",{href:!0,rel:!0});var Kd=r(oo);il=l(Kd,"Parallelization"),Kd.forEach(t),Xd.forEach(t),et.forEach(t),ll=h(I),U=s(I,"DIV",{class:!0});var tt=r(U);k(no.$$.fragment,tt),dl=h(tt),Te=s(tt,"P",{});var zo=r(Te);cl=l(zo,"The "),Mn=s(zo,"CODE",{});var Yd=r(Mn);pl=l(Yd,"FlaxGPTNeoPreTrainedModel"),Yd.forEach(t),hl=l(zo," forward method, overrides the "),En=s(zo,"CODE",{});var Qd=r(En);ul=l(Qd,"__call__"),Qd.forEach(t),ml=l(zo," special method."),zo.forEach(t),fl=h(tt),k(Ve.$$.fragment,tt),gl=h(tt),k(Je.$$.fragment,tt),tt.forEach(t),I.forEach(t),this.h()},h(){c(d,"name","hf:doc:metadata"),c(d,"content",JSON.stringify(vc)),c(m,"id","gpt-neo"),c(m,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(m,"href","#gpt-neo"),c(f,"class","relative group"),c(ke,"id","overview"),c(ke,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(ke,"href","#overview"),c(te,"class","relative group"),c(at,"href","https://github.com/EleutherAI/gpt-neo"),c(at,"rel","nofollow"),c(rt,"href","https://pile.eleuther.ai/"),c(rt,"rel","nofollow"),c(it,"href","https://huggingface.co/valhalla"),c(it,"rel","nofollow"),c(we,"id","generation"),c(we,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(we,"href","#generation"),c(oe,"class","relative group"),c($e,"id","documentation-resources"),c($e,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c($e,"href","#documentation-resources"),c(ne,"class","relative group"),c(lo,"href","../tasks/sequence_classification"),c(co,"href","../tasks/language_modeling"),c(xe,"id","transformers.GPTNeoConfig"),c(xe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(xe,"href","#transformers.GPTNeoConfig"),c(se,"class","relative group"),c(po,"href","/docs/transformers/pr_18559/en/model_doc/gpt_neo#transformers.GPTNeoModel"),c(ut,"href","https://huggingface.co/EleutherAI/gpt-neo-1.3B"),c(ut,"rel","nofollow"),c(ho,"href","/docs/transformers/pr_18559/en/main_classes/configuration#transformers.PretrainedConfig"),c(uo,"href","/docs/transformers/pr_18559/en/main_classes/configuration#transformers.PretrainedConfig"),c(L,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Ge,"id","transformers.GPTNeoModel"),c(Ge,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Ge,"href","#transformers.GPTNeoModel"),c(ie,"class","relative group"),c(mo,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel"),c(Tt,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),c(Tt,"rel","nofollow"),c(fo,"href","/docs/transformers/pr_18559/en/model_doc/gpt_neo#transformers.GPTNeoModel"),c(D,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Ee,"id","transformers.GPTNeoForCausalLM"),c(Ee,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Ee,"href","#transformers.GPTNeoForCausalLM"),c(de,"class","relative group"),c(go,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel"),c(Pt,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),c(Pt,"rel","nofollow"),c(_o,"href","/docs/transformers/pr_18559/en/model_doc/gpt_neo#transformers.GPTNeoForCausalLM"),c(B,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(E,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(qe,"id","transformers.GPTNeoForSequenceClassification"),c(qe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(qe,"href","#transformers.GPTNeoForSequenceClassification"),c(pe,"class","relative group"),c(vo,"href","/docs/transformers/pr_18559/en/model_doc/gpt_neo#transformers.GPTNeoForSequenceClassification"),c(bo,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel"),c(Ct,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),c(Ct,"rel","nofollow"),c(ko,"href","/docs/transformers/pr_18559/en/model_doc/gpt_neo#transformers.GPTNeoForSequenceClassification"),c(j,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(F,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Oe,"id","transformers.GPTNeoForTokenClassification"),c(Oe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Oe,"href","#transformers.GPTNeoForTokenClassification"),c(ue,"class","relative group"),c(yo,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel"),c(At,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),c(At,"rel","nofollow"),c(wo,"href","/docs/transformers/pr_18559/en/model_doc/gpt_neo#transformers.GPTNeoForTokenClassification"),c(W,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Be,"id","transformers.FlaxGPTNeoModel"),c(Be,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Be,"href","#transformers.FlaxGPTNeoModel"),c(fe,"class","relative group"),c(Po,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel"),c(Bt,"href","https://flax.readthedocs.io/en/latest/_autosummary/flax.nn.module.html"),c(Bt,"rel","nofollow"),c(Wt,"href","https://jax.readthedocs.io/en/latest/jax.html#just-in-time-compilation-jit"),c(Wt,"rel","nofollow"),c(Ht,"href","https://jax.readthedocs.io/en/latest/jax.html#automatic-differentiation"),c(Ht,"rel","nofollow"),c(Ut,"href","https://jax.readthedocs.io/en/latest/jax.html#vectorization-vmap"),c(Ut,"rel","nofollow"),c(Vt,"href","https://jax.readthedocs.io/en/latest/jax.html#parallelization-pmap"),c(Vt,"rel","nofollow"),c(H,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(G,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Ue,"id","transformers.FlaxGPTNeoForCausalLM"),c(Ue,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Ue,"href","#transformers.FlaxGPTNeoForCausalLM"),c(_e,"class","relative group"),c($o,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel"),c(Qt,"href","https://flax.readthedocs.io/en/latest/_autosummary/flax.nn.module.html"),c(Qt,"rel","nofollow"),c(Zt,"href","https://jax.readthedocs.io/en/latest/jax.html#just-in-time-compilation-jit"),c(Zt,"rel","nofollow"),c(eo,"href","https://jax.readthedocs.io/en/latest/jax.html#automatic-differentiation"),c(eo,"rel","nofollow"),c(to,"href","https://jax.readthedocs.io/en/latest/jax.html#vectorization-vmap"),c(to,"rel","nofollow"),c(oo,"href","https://jax.readthedocs.io/en/latest/jax.html#parallelization-pmap"),c(oo,"rel","nofollow"),c(U,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(o,g){e(document.head,d),T(o,v,g),T(o,f,g),e(f,m),e(m,_),y(a,_,null),e(f,u),e(f,x),e(x,As),T(o,Wn,g),T(o,te,g),e(te,ke),e(ke,qo),y(st,qo,null),e(te,Is),e(te,Ao),e(Ao,Ls),T(o,Hn,g),T(o,X,g),e(X,Os),e(X,at),e(at,Ss),e(X,Ds),e(X,rt),e(rt,Bs),e(X,Ws),T(o,Un,g),T(o,io,g),e(io,Hs),T(o,Vn,g),T(o,ye,g),e(ye,Us),e(ye,it),e(it,Vs),e(ye,Js),T(o,Jn,g),T(o,oe,g),e(oe,we),e(we,Io),y(lt,Io,null),e(oe,Rs),e(oe,Lo),e(Lo,Xs),T(o,Rn,g),T(o,Pe,g),e(Pe,Ks),e(Pe,Oo),e(Oo,Ys),e(Pe,Qs),T(o,Xn,g),y(dt,o,g),T(o,Kn,g),T(o,ne,g),e(ne,$e),e($e,So),y(ct,So,null),e(ne,Zs),e(ne,Do),e(Do,ea),T(o,Yn,g),T(o,Ne,g),e(Ne,Bo),e(Bo,lo),e(lo,ta),e(Ne,oa),e(Ne,Wo),e(Wo,co),e(co,na),T(o,Qn,g),T(o,se,g),e(se,xe),e(xe,Ho),y(pt,Ho,null),e(se,sa),e(se,Uo),e(Uo,aa),T(o,Zn,g),T(o,L,g),y(ht,L,null),e(L,ra),e(L,ae),e(ae,ia),e(ae,po),e(po,la),e(ae,da),e(ae,ut),e(ut,ca),e(ae,pa),e(L,ha),e(L,re),e(re,ua),e(re,ho),e(ho,ma),e(re,fa),e(re,uo),e(uo,ga),e(re,_a),e(L,Ta),y(Fe,L,null),T(o,es,g),T(o,ie,g),e(ie,Ge),e(Ge,Vo),y(mt,Vo,null),e(ie,va),e(ie,Jo),e(Jo,ba),T(o,ts,g),T(o,M,g),y(ft,M,null),e(M,ka),e(M,Ro),e(Ro,ya),e(M,wa),e(M,gt),e(gt,Pa),e(gt,mo),e(mo,$a),e(gt,Na),e(M,xa),e(M,_t),e(_t,Fa),e(_t,Tt),e(Tt,Ga),e(_t,Ca),e(M,Ma),e(M,D),y(vt,D,null),e(D,Ea),e(D,le),e(le,za),e(le,fo),e(fo,ja),e(le,qa),e(le,Xo),e(Xo,Aa),e(le,Ia),e(D,La),y(Ce,D,null),e(D,Oa),y(Me,D,null),T(o,os,g),T(o,de,g),e(de,Ee),e(Ee,Ko),y(bt,Ko,null),e(de,Sa),e(de,Yo),e(Yo,Da),T(o,ns,g),T(o,E,g),y(kt,E,null),e(E,Ba),e(E,Qo),e(Qo,Wa),e(E,Ha),e(E,yt),e(yt,Ua),e(yt,go),e(go,Va),e(yt,Ja),e(E,Ra),e(E,wt),e(wt,Xa),e(wt,Pt),e(Pt,Ka),e(wt,Ya),e(E,Qa),e(E,B),y($t,B,null),e(B,Za),e(B,ce),e(ce,er),e(ce,_o),e(_o,tr),e(ce,or),e(ce,Zo),e(Zo,nr),e(ce,sr),e(B,ar),y(ze,B,null),e(B,rr),y(je,B,null),T(o,ss,g),T(o,pe,g),e(pe,qe),e(qe,en),y(Nt,en,null),e(pe,ir),e(pe,tn),e(tn,lr),T(o,as,g),T(o,F,g),y(xt,F,null),e(F,dr),e(F,on),e(on,cr),e(F,pr),e(F,To),e(To,vo),e(vo,hr),e(To,ur),e(F,mr),e(F,O),e(O,fr),e(O,nn),e(nn,gr),e(O,_r),e(O,sn),e(sn,Tr),e(O,vr),e(O,an),e(an,br),e(O,kr),e(O,rn),e(rn,yr),e(O,wr),e(F,Pr),e(F,Ft),e(Ft,$r),e(Ft,bo),e(bo,Nr),e(Ft,xr),e(F,Fr),e(F,Gt),e(Gt,Gr),e(Gt,Ct),e(Ct,Cr),e(Gt,Mr),e(F,Er),e(F,j),y(Mt,j,null),e(j,zr),e(j,he),e(he,jr),e(he,ko),e(ko,qr),e(he,Ar),e(he,ln),e(ln,Ir),e(he,Lr),e(j,Or),y(Ae,j,null),e(j,Sr),y(Ie,j,null),e(j,Dr),y(Le,j,null),T(o,rs,g),T(o,ue,g),e(ue,Oe),e(Oe,dn),y(Et,dn,null),e(ue,Br),e(ue,cn),e(cn,Wr),T(o,is,g),T(o,z,g),y(zt,z,null),e(z,Hr),e(z,pn),e(pn,Ur),e(z,Vr),e(z,jt),e(jt,Jr),e(jt,yo),e(yo,Rr),e(jt,Xr),e(z,Kr),e(z,qt),e(qt,Yr),e(qt,At),e(At,Qr),e(qt,Zr),e(z,ei),e(z,W),y(It,W,null),e(W,ti),e(W,me),e(me,oi),e(me,wo),e(wo,ni),e(me,si),e(me,hn),e(hn,ai),e(me,ri),e(W,ii),y(Se,W,null),e(W,li),y(De,W,null),T(o,ls,g),T(o,fe,g),e(fe,Be),e(Be,un),y(Lt,un,null),e(fe,di),e(fe,mn),e(mn,ci),T(o,ds,g),T(o,G,g),y(Ot,G,null),e(G,pi),e(G,fn),e(fn,hi),e(G,ui),e(G,St),e(St,mi),e(St,Po),e(Po,fi),e(St,gi),e(G,_i),e(G,Dt),e(Dt,Ti),e(Dt,Bt),e(Bt,vi),e(Dt,bi),e(G,ki),e(G,gn),e(gn,yi),e(G,wi),e(G,V),e(V,_n),e(_n,Wt),e(Wt,Pi),e(V,$i),e(V,Tn),e(Tn,Ht),e(Ht,Ni),e(V,xi),e(V,vn),e(vn,Ut),e(Ut,Fi),e(V,Gi),e(V,bn),e(bn,Vt),e(Vt,Ci),e(G,Mi),e(G,H),y(Jt,H,null),e(H,Ei),e(H,ge),e(ge,zi),e(ge,kn),e(kn,ji),e(ge,qi),e(ge,yn),e(yn,Ai),e(ge,Ii),e(H,Li),y(We,H,null),e(H,Oi),y(He,H,null),T(o,cs,g),T(o,_e,g),e(_e,Ue),e(Ue,wn),y(Rt,wn,null),e(_e,Si),e(_e,Pn),e(Pn,Di),T(o,ps,g),T(o,C,g),y(Xt,C,null),e(C,Bi),e(C,$n),e($n,Wi),e(C,Hi),e(C,Kt),e(Kt,Ui),e(Kt,$o),e($o,Vi),e(Kt,Ji),e(C,Ri),e(C,Yt),e(Yt,Xi),e(Yt,Qt),e(Qt,Ki),e(Yt,Yi),e(C,Qi),e(C,Nn),e(Nn,Zi),e(C,el),e(C,J),e(J,xn),e(xn,Zt),e(Zt,tl),e(J,ol),e(J,Fn),e(Fn,eo),e(eo,nl),e(J,sl),e(J,Gn),e(Gn,to),e(to,al),e(J,rl),e(J,Cn),e(Cn,oo),e(oo,il),e(C,ll),e(C,U),y(no,U,null),e(U,dl),e(U,Te),e(Te,cl),e(Te,Mn),e(Mn,pl),e(Te,hl),e(Te,En),e(En,ul),e(Te,ml),e(U,fl),y(Ve,U,null),e(U,gl),y(Je,U,null),hs=!0},p(o,[g]){const so={};g&2&&(so.$$scope={dirty:g,ctx:o}),Fe.$set(so);const zn={};g&2&&(zn.$$scope={dirty:g,ctx:o}),Ce.$set(zn);const jn={};g&2&&(jn.$$scope={dirty:g,ctx:o}),Me.$set(jn);const qn={};g&2&&(qn.$$scope={dirty:g,ctx:o}),ze.$set(qn);const ao={};g&2&&(ao.$$scope={dirty:g,ctx:o}),je.$set(ao);const An={};g&2&&(An.$$scope={dirty:g,ctx:o}),Ae.$set(An);const In={};g&2&&(In.$$scope={dirty:g,ctx:o}),Ie.$set(In);const Ln={};g&2&&(Ln.$$scope={dirty:g,ctx:o}),Le.$set(Ln);const ve={};g&2&&(ve.$$scope={dirty:g,ctx:o}),Se.$set(ve);const On={};g&2&&(On.$$scope={dirty:g,ctx:o}),De.$set(On);const Sn={};g&2&&(Sn.$$scope={dirty:g,ctx:o}),We.$set(Sn);const Dn={};g&2&&(Dn.$$scope={dirty:g,ctx:o}),He.$set(Dn);const ro={};g&2&&(ro.$$scope={dirty:g,ctx:o}),Ve.$set(ro);const Bn={};g&2&&(Bn.$$scope={dirty:g,ctx:o}),Je.$set(Bn)},i(o){hs||(w(a.$$.fragment,o),w(st.$$.fragment,o),w(lt.$$.fragment,o),w(dt.$$.fragment,o),w(ct.$$.fragment,o),w(pt.$$.fragment,o),w(ht.$$.fragment,o),w(Fe.$$.fragment,o),w(mt.$$.fragment,o),w(ft.$$.fragment,o),w(vt.$$.fragment,o),w(Ce.$$.fragment,o),w(Me.$$.fragment,o),w(bt.$$.fragment,o),w(kt.$$.fragment,o),w($t.$$.fragment,o),w(ze.$$.fragment,o),w(je.$$.fragment,o),w(Nt.$$.fragment,o),w(xt.$$.fragment,o),w(Mt.$$.fragment,o),w(Ae.$$.fragment,o),w(Ie.$$.fragment,o),w(Le.$$.fragment,o),w(Et.$$.fragment,o),w(zt.$$.fragment,o),w(It.$$.fragment,o),w(Se.$$.fragment,o),w(De.$$.fragment,o),w(Lt.$$.fragment,o),w(Ot.$$.fragment,o),w(Jt.$$.fragment,o),w(We.$$.fragment,o),w(He.$$.fragment,o),w(Rt.$$.fragment,o),w(Xt.$$.fragment,o),w(no.$$.fragment,o),w(Ve.$$.fragment,o),w(Je.$$.fragment,o),hs=!0)},o(o){P(a.$$.fragment,o),P(st.$$.fragment,o),P(lt.$$.fragment,o),P(dt.$$.fragment,o),P(ct.$$.fragment,o),P(pt.$$.fragment,o),P(ht.$$.fragment,o),P(Fe.$$.fragment,o),P(mt.$$.fragment,o),P(ft.$$.fragment,o),P(vt.$$.fragment,o),P(Ce.$$.fragment,o),P(Me.$$.fragment,o),P(bt.$$.fragment,o),P(kt.$$.fragment,o),P($t.$$.fragment,o),P(ze.$$.fragment,o),P(je.$$.fragment,o),P(Nt.$$.fragment,o),P(xt.$$.fragment,o),P(Mt.$$.fragment,o),P(Ae.$$.fragment,o),P(Ie.$$.fragment,o),P(Le.$$.fragment,o),P(Et.$$.fragment,o),P(zt.$$.fragment,o),P(It.$$.fragment,o),P(Se.$$.fragment,o),P(De.$$.fragment,o),P(Lt.$$.fragment,o),P(Ot.$$.fragment,o),P(Jt.$$.fragment,o),P(We.$$.fragment,o),P(He.$$.fragment,o),P(Rt.$$.fragment,o),P(Xt.$$.fragment,o),P(no.$$.fragment,o),P(Ve.$$.fragment,o),P(Je.$$.fragment,o),hs=!1},d(o){t(d),o&&t(v),o&&t(f),$(a),o&&t(Wn),o&&t(te),$(st),o&&t(Hn),o&&t(X),o&&t(Un),o&&t(io),o&&t(Vn),o&&t(ye),o&&t(Jn),o&&t(oe),$(lt),o&&t(Rn),o&&t(Pe),o&&t(Xn),$(dt,o),o&&t(Kn),o&&t(ne),$(ct),o&&t(Yn),o&&t(Ne),o&&t(Qn),o&&t(se),$(pt),o&&t(Zn),o&&t(L),$(ht),$(Fe),o&&t(es),o&&t(ie),$(mt),o&&t(ts),o&&t(M),$(ft),$(vt),$(Ce),$(Me),o&&t(os),o&&t(de),$(bt),o&&t(ns),o&&t(E),$(kt),$($t),$(ze),$(je),o&&t(ss),o&&t(pe),$(Nt),o&&t(as),o&&t(F),$(xt),$(Mt),$(Ae),$(Ie),$(Le),o&&t(rs),o&&t(ue),$(Et),o&&t(is),o&&t(z),$(zt),$(It),$(Se),$(De),o&&t(ls),o&&t(fe),$(Lt),o&&t(ds),o&&t(G),$(Ot),$(Jt),$(We),$(He),o&&t(cs),o&&t(_e),$(Rt),o&&t(ps),o&&t(C),$(Xt),$(no),$(Ve),$(Je)}}}const vc={local:"gpt-neo",sections:[{local:"overview",sections:[{local:"generation",title:"Generation"}],title:"Overview"},{local:"documentation-resources",title:"Documentation resources"},{local:"transformers.GPTNeoConfig",title:"GPTNeoConfig"},{local:"transformers.GPTNeoModel",title:"GPTNeoModel"},{local:"transformers.GPTNeoForCausalLM",title:"GPTNeoForCausalLM"},{local:"transformers.GPTNeoForSequenceClassification",title:"GPTNeoForSequenceClassification"},{local:"transformers.GPTNeoForTokenClassification",title:"GPTNeoForTokenClassification"},{local:"transformers.FlaxGPTNeoModel",title:"FlaxGPTNeoModel"},{local:"transformers.FlaxGPTNeoForCausalLM",title:"FlaxGPTNeoForCausalLM"}],title:"GPT Neo"};function bc(N){return nc(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class xc extends Zd{constructor(d){super();ec(this,d,bc,Tc,tc,{})}}export{xc as default,vc as metadata};
