import{S as nv,i as rv,s as iv,e as n,k as m,w,t as s,M as lv,c as r,d as t,m as h,a as i,x as y,h as a,b as c,N as dv,G as e,g as _,y as $,q as T,o as k,B as x,v as cv,L as _t}from"../../chunks/vendor-hf-doc-builder.js";import{T as He}from"../../chunks/Tip-hf-doc-builder.js";import{D as L}from"../../chunks/Docstring-hf-doc-builder.js";import{C as bt}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as ze}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as gt}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";import{P as pv}from"../../chunks/PipelineTag-hf-doc-builder.js";function mv(B){let d,v,u,f,b;return f=new bt({props:{code:`from transformers import BeitConfig, BeitModel

# Initializing a BEiT beit-base-patch16-224-pt22k style configuration
configuration = BeitConfig()

# Initializing a model (with random weights) from the beit-base-patch16-224-pt22k style configuration
model = BeitModel(configuration)

# Accessing the model configuration
configuration = model.config`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> BeitConfig, BeitModel

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a BEiT beit-base-patch16-224-pt22k style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = BeitConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a model (with random weights) from the beit-base-patch16-224-pt22k style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = BeitModel(configuration)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Accessing the model configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = model.config`}}),{c(){d=n("p"),v=s("Example:"),u=m(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var p=i(d);v=a(p,"Example:"),p.forEach(t),u=h(l),y(f.$$.fragment,l)},m(l,p){_(l,d,p),e(d,v),_(l,u,p),$(f,l,p),b=!0},p:_t,i(l){b||(T(f.$$.fragment,l),b=!0)},o(l){k(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(u),x(f,l)}}}function hv(B){let d,v,u,f,b;return{c(){d=n("p"),v=s("Although the recipe for forward pass needs to be defined within this function, one should call the "),u=n("code"),f=s("Module"),b=s(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=r(l,"P",{});var p=i(d);v=a(p,"Although the recipe for forward pass needs to be defined within this function, one should call the "),u=r(p,"CODE",{});var E=i(u);f=a(E,"Module"),E.forEach(t),b=a(p,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),p.forEach(t)},m(l,p){_(l,d,p),e(d,v),e(d,u),e(u,f),e(d,b)},d(l){l&&t(d)}}}function fv(B){let d,v,u,f,b;return f=new bt({props:{code:`from transformers import AutoImageProcessor, BeitModel
import torch
from datasets import load_dataset

dataset = load_dataset("huggingface/cats-image")
image = dataset["test"]["image"][0]

image_processor = AutoImageProcessor.from_pretrained("microsoft/beit-base-patch16-224-pt22k")
model = BeitModel.from_pretrained("microsoft/beit-base-patch16-224-pt22k")

inputs = image_processor(image, return_tensors="pt")

with torch.no_grad():
    outputs = model(**inputs)

last_hidden_states = outputs.last_hidden_state
list(last_hidden_states.shape)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoImageProcessor, BeitModel
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset

<span class="hljs-meta">&gt;&gt;&gt; </span>dataset = load_dataset(<span class="hljs-string">&quot;huggingface/cats-image&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = dataset[<span class="hljs-string">&quot;test&quot;</span>][<span class="hljs-string">&quot;image&quot;</span>][<span class="hljs-number">0</span>]

<span class="hljs-meta">&gt;&gt;&gt; </span>image_processor = AutoImageProcessor.from_pretrained(<span class="hljs-string">&quot;microsoft/beit-base-patch16-224-pt22k&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = BeitModel.from_pretrained(<span class="hljs-string">&quot;microsoft/beit-base-patch16-224-pt22k&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = image_processor(image, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span>last_hidden_states = outputs.last_hidden_state
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">list</span>(last_hidden_states.shape)
[<span class="hljs-number">1</span>, <span class="hljs-number">197</span>, <span class="hljs-number">768</span>]`}}),{c(){d=n("p"),v=s("Example:"),u=m(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var p=i(d);v=a(p,"Example:"),p.forEach(t),u=h(l),y(f.$$.fragment,l)},m(l,p){_(l,d,p),e(d,v),_(l,u,p),$(f,l,p),b=!0},p:_t,i(l){b||(T(f.$$.fragment,l),b=!0)},o(l){k(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(u),x(f,l)}}}function uv(B){let d,v,u,f,b;return{c(){d=n("p"),v=s("Although the recipe for forward pass needs to be defined within this function, one should call the "),u=n("code"),f=s("Module"),b=s(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=r(l,"P",{});var p=i(d);v=a(p,"Although the recipe for forward pass needs to be defined within this function, one should call the "),u=r(p,"CODE",{});var E=i(u);f=a(E,"Module"),E.forEach(t),b=a(p,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),p.forEach(t)},m(l,p){_(l,d,p),e(d,v),e(d,u),e(u,f),e(d,b)},d(l){l&&t(d)}}}function gv(B){let d,v,u,f,b;return f=new bt({props:{code:`from transformers import AutoImageProcessor, BeitForMaskedImageModeling
import torch
from PIL import Image
import requests

url = "http://images.cocodataset.org/val2017/000000039769.jpg"
image = Image.open(requests.get(url, stream=True).raw)

image_processor = AutoImageProcessor.from_pretrained("microsoft/beit-base-patch16-224-pt22k")
model = BeitForMaskedImageModeling.from_pretrained("microsoft/beit-base-patch16-224-pt22k")

num_patches = (model.config.image_size // model.config.patch_size) ** 2
pixel_values = image_processor(images=image, return_tensors="pt").pixel_values
# create random boolean mask of shape (batch_size, num_patches)
bool_masked_pos = torch.randint(low=0, high=2, size=(1, num_patches)).bool()

outputs = model(pixel_values, bool_masked_pos=bool_masked_pos)
loss, logits = outputs.loss, outputs.logits
list(logits.shape)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoImageProcessor, BeitForMaskedImageModeling
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests

<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;http://images.cocodataset.org/val2017/000000039769.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)

<span class="hljs-meta">&gt;&gt;&gt; </span>image_processor = AutoImageProcessor.from_pretrained(<span class="hljs-string">&quot;microsoft/beit-base-patch16-224-pt22k&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = BeitForMaskedImageModeling.from_pretrained(<span class="hljs-string">&quot;microsoft/beit-base-patch16-224-pt22k&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>num_patches = (model.config.image_size // model.config.patch_size) ** <span class="hljs-number">2</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pixel_values = image_processor(images=image, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).pixel_values
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># create random boolean mask of shape (batch_size, num_patches)</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>bool_masked_pos = torch.randint(low=<span class="hljs-number">0</span>, high=<span class="hljs-number">2</span>, size=(<span class="hljs-number">1</span>, num_patches)).<span class="hljs-built_in">bool</span>()

<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(pixel_values, bool_masked_pos=bool_masked_pos)
<span class="hljs-meta">&gt;&gt;&gt; </span>loss, logits = outputs.loss, outputs.logits
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">list</span>(logits.shape)
[<span class="hljs-number">1</span>, <span class="hljs-number">196</span>, <span class="hljs-number">8192</span>]`}}),{c(){d=n("p"),v=s("Examples:"),u=m(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var p=i(d);v=a(p,"Examples:"),p.forEach(t),u=h(l),y(f.$$.fragment,l)},m(l,p){_(l,d,p),e(d,v),_(l,u,p),$(f,l,p),b=!0},p:_t,i(l){b||(T(f.$$.fragment,l),b=!0)},o(l){k(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(u),x(f,l)}}}function _v(B){let d,v,u,f,b;return{c(){d=n("p"),v=s("Although the recipe for forward pass needs to be defined within this function, one should call the "),u=n("code"),f=s("Module"),b=s(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=r(l,"P",{});var p=i(d);v=a(p,"Although the recipe for forward pass needs to be defined within this function, one should call the "),u=r(p,"CODE",{});var E=i(u);f=a(E,"Module"),E.forEach(t),b=a(p,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),p.forEach(t)},m(l,p){_(l,d,p),e(d,v),e(d,u),e(u,f),e(d,b)},d(l){l&&t(d)}}}function bv(B){let d,v,u,f,b;return f=new bt({props:{code:`from transformers import AutoImageProcessor, BeitForImageClassification
import torch
from datasets import load_dataset

dataset = load_dataset("huggingface/cats-image")
image = dataset["test"]["image"][0]

image_processor = AutoImageProcessor.from_pretrained("microsoft/beit-base-patch16-224")
model = BeitForImageClassification.from_pretrained("microsoft/beit-base-patch16-224")

inputs = image_processor(image, return_tensors="pt")

with torch.no_grad():
    logits = model(**inputs).logits

# model predicts one of the 1000 ImageNet classes
predicted_label = logits.argmax(-1).item()
print(model.config.id2label[predicted_label])`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoImageProcessor, BeitForImageClassification
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset

<span class="hljs-meta">&gt;&gt;&gt; </span>dataset = load_dataset(<span class="hljs-string">&quot;huggingface/cats-image&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = dataset[<span class="hljs-string">&quot;test&quot;</span>][<span class="hljs-string">&quot;image&quot;</span>][<span class="hljs-number">0</span>]

<span class="hljs-meta">&gt;&gt;&gt; </span>image_processor = AutoImageProcessor.from_pretrained(<span class="hljs-string">&quot;microsoft/beit-base-patch16-224&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = BeitForImageClassification.from_pretrained(<span class="hljs-string">&quot;microsoft/beit-base-patch16-224&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = image_processor(image, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    logits = model(**inputs).logits

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># model predicts one of the 1000 ImageNet classes</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_label = logits.argmax(-<span class="hljs-number">1</span>).item()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(model.config.id2label[predicted_label])
tabby, tabby cat`}}),{c(){d=n("p"),v=s("Example:"),u=m(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var p=i(d);v=a(p,"Example:"),p.forEach(t),u=h(l),y(f.$$.fragment,l)},m(l,p){_(l,d,p),e(d,v),_(l,u,p),$(f,l,p),b=!0},p:_t,i(l){b||(T(f.$$.fragment,l),b=!0)},o(l){k(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(u),x(f,l)}}}function vv(B){let d,v,u,f,b;return{c(){d=n("p"),v=s("Although the recipe for forward pass needs to be defined within this function, one should call the "),u=n("code"),f=s("Module"),b=s(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=r(l,"P",{});var p=i(d);v=a(p,"Although the recipe for forward pass needs to be defined within this function, one should call the "),u=r(p,"CODE",{});var E=i(u);f=a(E,"Module"),E.forEach(t),b=a(p,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),p.forEach(t)},m(l,p){_(l,d,p),e(d,v),e(d,u),e(u,f),e(d,b)},d(l){l&&t(d)}}}function wv(B){let d,v,u,f,b;return f=new bt({props:{code:`from transformers import AutoImageProcessor, BeitForSemanticSegmentation
from PIL import Image
import requests

url = "http://images.cocodataset.org/val2017/000000039769.jpg"
image = Image.open(requests.get(url, stream=True).raw)

image_processor = AutoImageProcessor.from_pretrained("microsoft/beit-base-finetuned-ade-640-640")
model = BeitForSemanticSegmentation.from_pretrained("microsoft/beit-base-finetuned-ade-640-640")

inputs = image_processor(images=image, return_tensors="pt")
outputs = model(**inputs)
# logits are of shape (batch_size, num_labels, height, width)
logits = outputs.logits`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoImageProcessor, BeitForSemanticSegmentation
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests

<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;http://images.cocodataset.org/val2017/000000039769.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)

<span class="hljs-meta">&gt;&gt;&gt; </span>image_processor = AutoImageProcessor.from_pretrained(<span class="hljs-string">&quot;microsoft/beit-base-finetuned-ade-640-640&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = BeitForSemanticSegmentation.from_pretrained(<span class="hljs-string">&quot;microsoft/beit-base-finetuned-ade-640-640&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = image_processor(images=image, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># logits are of shape (batch_size, num_labels, height, width)</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>logits = outputs.logits`}}),{c(){d=n("p"),v=s("Examples:"),u=m(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var p=i(d);v=a(p,"Examples:"),p.forEach(t),u=h(l),y(f.$$.fragment,l)},m(l,p){_(l,d,p),e(d,v),_(l,u,p),$(f,l,p),b=!0},p:_t,i(l){b||(T(f.$$.fragment,l),b=!0)},o(l){k(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(u),x(f,l)}}}function yv(B){let d,v,u,f,b;return{c(){d=n("p"),v=s("Although the recipe for forward pass needs to be defined within this function, one should call the "),u=n("code"),f=s("Module"),b=s(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=r(l,"P",{});var p=i(d);v=a(p,"Although the recipe for forward pass needs to be defined within this function, one should call the "),u=r(p,"CODE",{});var E=i(u);f=a(E,"Module"),E.forEach(t),b=a(p,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),p.forEach(t)},m(l,p){_(l,d,p),e(d,v),e(d,u),e(u,f),e(d,b)},d(l){l&&t(d)}}}function $v(B){let d,v,u,f,b;return f=new bt({props:{code:`from transformers import AutoImageProcessor, FlaxBeitModel
from PIL import Image
import requests

url = "http://images.cocodataset.org/val2017/000000039769.jpg"
image = Image.open(requests.get(url, stream=True).raw)

image_processor = AutoImageProcessor.from_pretrained("microsoft/beit-base-patch16-224-pt22k-ft22k")
model = FlaxBeitModel.from_pretrained("microsoft/beit-base-patch16-224-pt22k-ft22k")

inputs = image_processor(images=image, return_tensors="np")
outputs = model(**inputs)
last_hidden_states = outputs.last_hidden_state`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoImageProcessor, FlaxBeitModel
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests

<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;http://images.cocodataset.org/val2017/000000039769.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)

<span class="hljs-meta">&gt;&gt;&gt; </span>image_processor = AutoImageProcessor.from_pretrained(<span class="hljs-string">&quot;microsoft/beit-base-patch16-224-pt22k-ft22k&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = FlaxBeitModel.from_pretrained(<span class="hljs-string">&quot;microsoft/beit-base-patch16-224-pt22k-ft22k&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = image_processor(images=image, return_tensors=<span class="hljs-string">&quot;np&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)
<span class="hljs-meta">&gt;&gt;&gt; </span>last_hidden_states = outputs.last_hidden_state`}}),{c(){d=n("p"),v=s("Examples:"),u=m(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var p=i(d);v=a(p,"Examples:"),p.forEach(t),u=h(l),y(f.$$.fragment,l)},m(l,p){_(l,d,p),e(d,v),_(l,u,p),$(f,l,p),b=!0},p:_t,i(l){b||(T(f.$$.fragment,l),b=!0)},o(l){k(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(u),x(f,l)}}}function Tv(B){let d,v,u,f,b;return{c(){d=n("p"),v=s("Although the recipe for forward pass needs to be defined within this function, one should call the "),u=n("code"),f=s("Module"),b=s(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=r(l,"P",{});var p=i(d);v=a(p,"Although the recipe for forward pass needs to be defined within this function, one should call the "),u=r(p,"CODE",{});var E=i(u);f=a(E,"Module"),E.forEach(t),b=a(p,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),p.forEach(t)},m(l,p){_(l,d,p),e(d,v),e(d,u),e(u,f),e(d,b)},d(l){l&&t(d)}}}function kv(B){let d,v,u,f,b;return f=new bt({props:{code:`from transformers import AutoImageProcessor, BeitForMaskedImageModeling
from PIL import Image
import requests

url = "http://images.cocodataset.org/val2017/000000039769.jpg"
image = Image.open(requests.get(url, stream=True).raw)

image_processor = AutoImageProcessor.from_pretrained("microsoft/beit-base-patch16-224-pt22k")
model = BeitForMaskedImageModeling.from_pretrained("microsoft/beit-base-patch16-224-pt22k")

inputs = image_processor(images=image, return_tensors="np")
outputs = model(**inputs)
logits = outputs.logits`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoImageProcessor, BeitForMaskedImageModeling
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests

<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;http://images.cocodataset.org/val2017/000000039769.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)

<span class="hljs-meta">&gt;&gt;&gt; </span>image_processor = AutoImageProcessor.from_pretrained(<span class="hljs-string">&quot;microsoft/beit-base-patch16-224-pt22k&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = BeitForMaskedImageModeling.from_pretrained(<span class="hljs-string">&quot;microsoft/beit-base-patch16-224-pt22k&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = image_processor(images=image, return_tensors=<span class="hljs-string">&quot;np&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)
<span class="hljs-meta">&gt;&gt;&gt; </span>logits = outputs.logits`}}),{c(){d=n("p"),v=s("Examples:"),u=m(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var p=i(d);v=a(p,"Examples:"),p.forEach(t),u=h(l),y(f.$$.fragment,l)},m(l,p){_(l,d,p),e(d,v),_(l,u,p),$(f,l,p),b=!0},p:_t,i(l){b||(T(f.$$.fragment,l),b=!0)},o(l){k(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(u),x(f,l)}}}function xv(B){let d,v,u,f,b;return{c(){d=n("p"),v=s("Although the recipe for forward pass needs to be defined within this function, one should call the "),u=n("code"),f=s("Module"),b=s(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=r(l,"P",{});var p=i(d);v=a(p,"Although the recipe for forward pass needs to be defined within this function, one should call the "),u=r(p,"CODE",{});var E=i(u);f=a(E,"Module"),E.forEach(t),b=a(p,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),p.forEach(t)},m(l,p){_(l,d,p),e(d,v),e(d,u),e(u,f),e(d,b)},d(l){l&&t(d)}}}function Fv(B){let d,v,u,f,b;return f=new bt({props:{code:`from transformers import AutoImageProcessor, FlaxBeitForImageClassification
from PIL import Image
import requests

url = "http://images.cocodataset.org/val2017/000000039769.jpg"
image = Image.open(requests.get(url, stream=True).raw)

image_processor = AutoImageProcessor.from_pretrained("microsoft/beit-base-patch16-224")
model = FlaxBeitForImageClassification.from_pretrained("microsoft/beit-base-patch16-224")

inputs = image_processor(images=image, return_tensors="np")
outputs = model(**inputs)
logits = outputs.logits
# model predicts one of the 1000 ImageNet classes
predicted_class_idx = logits.argmax(-1).item()
print("Predicted class:", model.config.id2label[predicted_class_idx])`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoImageProcessor, FlaxBeitForImageClassification
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests

<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;http://images.cocodataset.org/val2017/000000039769.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)

<span class="hljs-meta">&gt;&gt;&gt; </span>image_processor = AutoImageProcessor.from_pretrained(<span class="hljs-string">&quot;microsoft/beit-base-patch16-224&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = FlaxBeitForImageClassification.from_pretrained(<span class="hljs-string">&quot;microsoft/beit-base-patch16-224&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = image_processor(images=image, return_tensors=<span class="hljs-string">&quot;np&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)
<span class="hljs-meta">&gt;&gt;&gt; </span>logits = outputs.logits
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># model predicts one of the 1000 ImageNet classes</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_class_idx = logits.argmax(-<span class="hljs-number">1</span>).item()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;Predicted class:&quot;</span>, model.config.id2label[predicted_class_idx])`}}),{c(){d=n("p"),v=s("Example:"),u=m(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var p=i(d);v=a(p,"Example:"),p.forEach(t),u=h(l),y(f.$$.fragment,l)},m(l,p){_(l,d,p),e(d,v),_(l,u,p),$(f,l,p),b=!0},p:_t,i(l){b||(T(f.$$.fragment,l),b=!0)},o(l){k(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(u),x(f,l)}}}function Ev(B){let d,v,u,f,b,l,p,E,pe,re,F,Y,U,Z,me,K,he,ie,O,fe,ee,H,ue,te,J,ge,oe,_e,z,le,V,be,de,W,ne,ve,A,se,G,ce,q,j,we,ae,C,ye,R,$e,Te,S,ke,xe;return{c(){d=n("p"),v=s("TensorFlow models and layers in "),u=n("code"),f=s("transformers"),b=s(" accept two formats as input:"),l=m(),p=n("ul"),E=n("li"),pe=s("having all inputs as keyword arguments (like PyTorch models), or"),re=m(),F=n("li"),Y=s(`having all inputs as a list, tuple or dict in the first positional argument.
The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),U=n("code"),Z=s("model.fit()"),me=s(` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),K=n("code"),he=s("model.fit()"),ie=s(` supports! If, however, you want to use the second
format outside of Keras methods like `),O=n("code"),fe=s("fit()"),ee=s(" and "),H=n("code"),ue=s("predict()"),te=s(`, such as when creating your own layers or models with
the Keras `),J=n("code"),ge=s("Functional"),oe=s(` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),_e=m(),z=n("li"),le=s("a single Tensor with "),V=n("code"),be=s("pixel_values"),de=s(" only and nothing else: "),W=n("code"),ne=s("model(pixel_values)"),ve=m(),A=n("li"),se=s(`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),G=n("code"),ce=s("model([pixel_values, attention_mask])"),q=s(" or "),j=n("code"),we=s("model([pixel_values, attention_mask, token_type_ids])"),ae=m(),C=n("li"),ye=s(`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),R=n("code"),$e=s('model({"pixel_values": pixel_values, "token_type_ids": token_type_ids})'),Te=s(` Note that when creating models and layers
with `),S=n("a"),ke=s("subclassing"),xe=s(` then you don\u2019t need to
worry about any of this, as you can just pass inputs like you would to any other Python function!`),this.h()},l(M){d=r(M,"P",{});var D=i(d);v=a(D,"TensorFlow models and layers in "),u=r(D,"CODE",{});var Se=i(u);f=a(Se,"transformers"),Se.forEach(t),b=a(D," accept two formats as input:"),D.forEach(t),l=h(M),p=r(M,"UL",{});var P=i(p);E=r(P,"LI",{});var De=i(E);pe=a(De,"having all inputs as keyword arguments (like PyTorch models), or"),De.forEach(t),re=h(P),F=r(P,"LI",{});var I=i(F);Y=a(I,`having all inputs as a list, tuple or dict in the first positional argument.
The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),U=r(I,"CODE",{});var Ce=i(U);Z=a(Ce,"model.fit()"),Ce.forEach(t),me=a(I,` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),K=r(I,"CODE",{});var Oe=i(K);he=a(Oe,"model.fit()"),Oe.forEach(t),ie=a(I,` supports! If, however, you want to use the second
format outside of Keras methods like `),O=r(I,"CODE",{});var qe=i(O);fe=a(qe,"fit()"),qe.forEach(t),ee=a(I," and "),H=r(I,"CODE",{});var Ae=i(H);ue=a(Ae,"predict()"),Ae.forEach(t),te=a(I,`, such as when creating your own layers or models with
the Keras `),J=r(I,"CODE",{});var Ne=i(J);ge=a(Ne,"Functional"),Ne.forEach(t),oe=a(I,` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),I.forEach(t),_e=h(P),z=r(P,"LI",{});var X=i(z);le=a(X,"a single Tensor with "),V=r(X,"CODE",{});var Le=i(V);be=a(Le,"pixel_values"),Le.forEach(t),de=a(X," only and nothing else: "),W=r(X,"CODE",{});var Fe=i(W);ne=a(Fe,"model(pixel_values)"),Fe.forEach(t),X.forEach(t),ve=h(P),A=r(P,"LI",{});var Q=i(A);se=a(Q,`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),G=r(Q,"CODE",{});var Ee=i(G);ce=a(Ee,"model([pixel_values, attention_mask])"),Ee.forEach(t),q=a(Q," or "),j=r(Q,"CODE",{});var Ve=i(j);we=a(Ve,"model([pixel_values, attention_mask, token_type_ids])"),Ve.forEach(t),Q.forEach(t),ae=h(P),C=r(P,"LI",{});var N=i(C);ye=a(N,`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),R=r(N,"CODE",{});var We=i(R);$e=a(We,'model({"pixel_values": pixel_values, "token_type_ids": token_type_ids})'),We.forEach(t),Te=a(N,` Note that when creating models and layers
with `),S=r(N,"A",{href:!0,rel:!0});var Be=i(S);ke=a(Be,"subclassing"),Be.forEach(t),xe=a(N,` then you don\u2019t need to
worry about any of this, as you can just pass inputs like you would to any other Python function!`),N.forEach(t),P.forEach(t),this.h()},h(){c(S,"href","https://keras.io/guides/making_new_layers_and_models_via_subclassing/"),c(S,"rel","nofollow")},m(M,D){_(M,d,D),e(d,v),e(d,u),e(u,f),e(d,b),_(M,l,D),_(M,p,D),e(p,E),e(E,pe),e(p,re),e(p,F),e(F,Y),e(F,U),e(U,Z),e(F,me),e(F,K),e(K,he),e(F,ie),e(F,O),e(O,fe),e(F,ee),e(F,H),e(H,ue),e(F,te),e(F,J),e(J,ge),e(F,oe),e(p,_e),e(p,z),e(z,le),e(z,V),e(V,be),e(z,de),e(z,W),e(W,ne),e(p,ve),e(p,A),e(A,se),e(A,G),e(G,ce),e(A,q),e(A,j),e(j,we),e(p,ae),e(p,C),e(C,ye),e(C,R),e(R,$e),e(C,Te),e(C,S),e(S,ke),e(C,xe)},d(M){M&&t(d),M&&t(l),M&&t(p)}}}function Bv(B){let d,v,u,f,b;return{c(){d=n("p"),v=s("Although the recipe for forward pass needs to be defined within this function, one should call the "),u=n("code"),f=s("Module"),b=s(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=r(l,"P",{});var p=i(d);v=a(p,"Although the recipe for forward pass needs to be defined within this function, one should call the "),u=r(p,"CODE",{});var E=i(u);f=a(E,"Module"),E.forEach(t),b=a(p,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),p.forEach(t)},m(l,p){_(l,d,p),e(d,v),e(d,u),e(u,f),e(d,b)},d(l){l&&t(d)}}}function Iv(B){let d,v,u,f,b;return f=new bt({props:{code:`from transformers import AutoImageProcessor, TFBeitModel
from datasets import load_dataset

dataset = load_dataset("huggingface/cats-image")
image = dataset["test"]["image"][0]

image_processor = AutoImageProcessor.from_pretrained("microsoft/beit-base-patch16-224-pt22k")
model = TFBeitModel.from_pretrained("microsoft/beit-base-patch16-224-pt22k")

inputs = image_processor(image, return_tensors="tf")
outputs = model(**inputs)

last_hidden_states = outputs.last_hidden_state
list(last_hidden_states.shape)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoImageProcessor, TFBeitModel
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset

<span class="hljs-meta">&gt;&gt;&gt; </span>dataset = load_dataset(<span class="hljs-string">&quot;huggingface/cats-image&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = dataset[<span class="hljs-string">&quot;test&quot;</span>][<span class="hljs-string">&quot;image&quot;</span>][<span class="hljs-number">0</span>]

<span class="hljs-meta">&gt;&gt;&gt; </span>image_processor = AutoImageProcessor.from_pretrained(<span class="hljs-string">&quot;microsoft/beit-base-patch16-224-pt22k&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFBeitModel.from_pretrained(<span class="hljs-string">&quot;microsoft/beit-base-patch16-224-pt22k&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = image_processor(image, return_tensors=<span class="hljs-string">&quot;tf&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span>last_hidden_states = outputs.last_hidden_state
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">list</span>(last_hidden_states.shape)
[<span class="hljs-number">1</span>, <span class="hljs-number">197</span>, <span class="hljs-number">768</span>]`}}),{c(){d=n("p"),v=s("Example:"),u=m(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var p=i(d);v=a(p,"Example:"),p.forEach(t),u=h(l),y(f.$$.fragment,l)},m(l,p){_(l,d,p),e(d,v),_(l,u,p),$(f,l,p),b=!0},p:_t,i(l){b||(T(f.$$.fragment,l),b=!0)},o(l){k(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(u),x(f,l)}}}function Mv(B){let d,v,u,f,b,l,p,E,pe,re,F,Y,U,Z,me,K,he,ie,O,fe,ee,H,ue,te,J,ge,oe,_e,z,le,V,be,de,W,ne,ve,A,se,G,ce,q,j,we,ae,C,ye,R,$e,Te,S,ke,xe;return{c(){d=n("p"),v=s("TensorFlow models and layers in "),u=n("code"),f=s("transformers"),b=s(" accept two formats as input:"),l=m(),p=n("ul"),E=n("li"),pe=s("having all inputs as keyword arguments (like PyTorch models), or"),re=m(),F=n("li"),Y=s(`having all inputs as a list, tuple or dict in the first positional argument.
The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),U=n("code"),Z=s("model.fit()"),me=s(` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),K=n("code"),he=s("model.fit()"),ie=s(` supports! If, however, you want to use the second
format outside of Keras methods like `),O=n("code"),fe=s("fit()"),ee=s(" and "),H=n("code"),ue=s("predict()"),te=s(`, such as when creating your own layers or models with
the Keras `),J=n("code"),ge=s("Functional"),oe=s(` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),_e=m(),z=n("li"),le=s("a single Tensor with "),V=n("code"),be=s("pixel_values"),de=s(" only and nothing else: "),W=n("code"),ne=s("model(pixel_values)"),ve=m(),A=n("li"),se=s(`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),G=n("code"),ce=s("model([pixel_values, attention_mask])"),q=s(" or "),j=n("code"),we=s("model([pixel_values, attention_mask, token_type_ids])"),ae=m(),C=n("li"),ye=s(`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),R=n("code"),$e=s('model({"pixel_values": pixel_values, "token_type_ids": token_type_ids})'),Te=s(` Note that when creating models and layers
with `),S=n("a"),ke=s("subclassing"),xe=s(` then you don\u2019t need to
worry about any of this, as you can just pass inputs like you would to any other Python function!`),this.h()},l(M){d=r(M,"P",{});var D=i(d);v=a(D,"TensorFlow models and layers in "),u=r(D,"CODE",{});var Se=i(u);f=a(Se,"transformers"),Se.forEach(t),b=a(D," accept two formats as input:"),D.forEach(t),l=h(M),p=r(M,"UL",{});var P=i(p);E=r(P,"LI",{});var De=i(E);pe=a(De,"having all inputs as keyword arguments (like PyTorch models), or"),De.forEach(t),re=h(P),F=r(P,"LI",{});var I=i(F);Y=a(I,`having all inputs as a list, tuple or dict in the first positional argument.
The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),U=r(I,"CODE",{});var Ce=i(U);Z=a(Ce,"model.fit()"),Ce.forEach(t),me=a(I,` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),K=r(I,"CODE",{});var Oe=i(K);he=a(Oe,"model.fit()"),Oe.forEach(t),ie=a(I,` supports! If, however, you want to use the second
format outside of Keras methods like `),O=r(I,"CODE",{});var qe=i(O);fe=a(qe,"fit()"),qe.forEach(t),ee=a(I," and "),H=r(I,"CODE",{});var Ae=i(H);ue=a(Ae,"predict()"),Ae.forEach(t),te=a(I,`, such as when creating your own layers or models with
the Keras `),J=r(I,"CODE",{});var Ne=i(J);ge=a(Ne,"Functional"),Ne.forEach(t),oe=a(I,` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),I.forEach(t),_e=h(P),z=r(P,"LI",{});var X=i(z);le=a(X,"a single Tensor with "),V=r(X,"CODE",{});var Le=i(V);be=a(Le,"pixel_values"),Le.forEach(t),de=a(X," only and nothing else: "),W=r(X,"CODE",{});var Fe=i(W);ne=a(Fe,"model(pixel_values)"),Fe.forEach(t),X.forEach(t),ve=h(P),A=r(P,"LI",{});var Q=i(A);se=a(Q,`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),G=r(Q,"CODE",{});var Ee=i(G);ce=a(Ee,"model([pixel_values, attention_mask])"),Ee.forEach(t),q=a(Q," or "),j=r(Q,"CODE",{});var Ve=i(j);we=a(Ve,"model([pixel_values, attention_mask, token_type_ids])"),Ve.forEach(t),Q.forEach(t),ae=h(P),C=r(P,"LI",{});var N=i(C);ye=a(N,`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),R=r(N,"CODE",{});var We=i(R);$e=a(We,'model({"pixel_values": pixel_values, "token_type_ids": token_type_ids})'),We.forEach(t),Te=a(N,` Note that when creating models and layers
with `),S=r(N,"A",{href:!0,rel:!0});var Be=i(S);ke=a(Be,"subclassing"),Be.forEach(t),xe=a(N,` then you don\u2019t need to
worry about any of this, as you can just pass inputs like you would to any other Python function!`),N.forEach(t),P.forEach(t),this.h()},h(){c(S,"href","https://keras.io/guides/making_new_layers_and_models_via_subclassing/"),c(S,"rel","nofollow")},m(M,D){_(M,d,D),e(d,v),e(d,u),e(u,f),e(d,b),_(M,l,D),_(M,p,D),e(p,E),e(E,pe),e(p,re),e(p,F),e(F,Y),e(F,U),e(U,Z),e(F,me),e(F,K),e(K,he),e(F,ie),e(F,O),e(O,fe),e(F,ee),e(F,H),e(H,ue),e(F,te),e(F,J),e(J,ge),e(F,oe),e(p,_e),e(p,z),e(z,le),e(z,V),e(V,be),e(z,de),e(z,W),e(W,ne),e(p,ve),e(p,A),e(A,se),e(A,G),e(G,ce),e(A,q),e(A,j),e(j,we),e(p,ae),e(p,C),e(C,ye),e(C,R),e(R,$e),e(C,Te),e(C,S),e(S,ke),e(C,xe)},d(M){M&&t(d),M&&t(l),M&&t(p)}}}function Pv(B){let d,v,u,f,b;return{c(){d=n("p"),v=s("Although the recipe for forward pass needs to be defined within this function, one should call the "),u=n("code"),f=s("Module"),b=s(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=r(l,"P",{});var p=i(d);v=a(p,"Although the recipe for forward pass needs to be defined within this function, one should call the "),u=r(p,"CODE",{});var E=i(u);f=a(E,"Module"),E.forEach(t),b=a(p,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),p.forEach(t)},m(l,p){_(l,d,p),e(d,v),e(d,u),e(u,f),e(d,b)},d(l){l&&t(d)}}}function jv(B){let d,v,u,f,b;return f=new bt({props:{code:`from transformers import AutoTokenizer, TFBeitForMaskedImageModeling
import tensorflow as tf

tokenizer = AutoTokenizer.from_pretrained("microsoft/beit-base-patch16-224")
model = TFBeitForMaskedImageModeling.from_pretrained("microsoft/beit-base-patch16-224")

inputs = tokenizer("Hello, my dog is cute", return_tensors="tf")
outputs = model(inputs)

last_hidden_states = outputs.last_hidden_state`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, TFBeitForMaskedImageModeling
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> tensorflow <span class="hljs-keyword">as</span> tf

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;microsoft/beit-base-patch16-224&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFBeitForMaskedImageModeling.from_pretrained(<span class="hljs-string">&quot;microsoft/beit-base-patch16-224&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;tf&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span>last_hidden_states = outputs.last_hidden_state`}}),{c(){d=n("p"),v=s("Example:"),u=m(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var p=i(d);v=a(p,"Example:"),p.forEach(t),u=h(l),y(f.$$.fragment,l)},m(l,p){_(l,d,p),e(d,v),_(l,u,p),$(f,l,p),b=!0},p:_t,i(l){b||(T(f.$$.fragment,l),b=!0)},o(l){k(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(u),x(f,l)}}}function Cv(B){let d,v,u,f,b,l,p,E,pe,re,F,Y,U,Z,me,K,he,ie,O,fe,ee,H,ue,te,J,ge,oe,_e,z,le,V,be,de,W,ne,ve,A,se,G,ce,q,j,we,ae,C,ye,R,$e,Te,S,ke,xe;return{c(){d=n("p"),v=s("TensorFlow models and layers in "),u=n("code"),f=s("transformers"),b=s(" accept two formats as input:"),l=m(),p=n("ul"),E=n("li"),pe=s("having all inputs as keyword arguments (like PyTorch models), or"),re=m(),F=n("li"),Y=s(`having all inputs as a list, tuple or dict in the first positional argument.
The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),U=n("code"),Z=s("model.fit()"),me=s(` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),K=n("code"),he=s("model.fit()"),ie=s(` supports! If, however, you want to use the second
format outside of Keras methods like `),O=n("code"),fe=s("fit()"),ee=s(" and "),H=n("code"),ue=s("predict()"),te=s(`, such as when creating your own layers or models with
the Keras `),J=n("code"),ge=s("Functional"),oe=s(` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),_e=m(),z=n("li"),le=s("a single Tensor with "),V=n("code"),be=s("pixel_values"),de=s(" only and nothing else: "),W=n("code"),ne=s("model(pixel_values)"),ve=m(),A=n("li"),se=s(`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),G=n("code"),ce=s("model([pixel_values, attention_mask])"),q=s(" or "),j=n("code"),we=s("model([pixel_values, attention_mask, token_type_ids])"),ae=m(),C=n("li"),ye=s(`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),R=n("code"),$e=s('model({"pixel_values": pixel_values, "token_type_ids": token_type_ids})'),Te=s(` Note that when creating models and layers
with `),S=n("a"),ke=s("subclassing"),xe=s(` then you don\u2019t need to
worry about any of this, as you can just pass inputs like you would to any other Python function!`),this.h()},l(M){d=r(M,"P",{});var D=i(d);v=a(D,"TensorFlow models and layers in "),u=r(D,"CODE",{});var Se=i(u);f=a(Se,"transformers"),Se.forEach(t),b=a(D," accept two formats as input:"),D.forEach(t),l=h(M),p=r(M,"UL",{});var P=i(p);E=r(P,"LI",{});var De=i(E);pe=a(De,"having all inputs as keyword arguments (like PyTorch models), or"),De.forEach(t),re=h(P),F=r(P,"LI",{});var I=i(F);Y=a(I,`having all inputs as a list, tuple or dict in the first positional argument.
The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),U=r(I,"CODE",{});var Ce=i(U);Z=a(Ce,"model.fit()"),Ce.forEach(t),me=a(I,` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),K=r(I,"CODE",{});var Oe=i(K);he=a(Oe,"model.fit()"),Oe.forEach(t),ie=a(I,` supports! If, however, you want to use the second
format outside of Keras methods like `),O=r(I,"CODE",{});var qe=i(O);fe=a(qe,"fit()"),qe.forEach(t),ee=a(I," and "),H=r(I,"CODE",{});var Ae=i(H);ue=a(Ae,"predict()"),Ae.forEach(t),te=a(I,`, such as when creating your own layers or models with
the Keras `),J=r(I,"CODE",{});var Ne=i(J);ge=a(Ne,"Functional"),Ne.forEach(t),oe=a(I,` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),I.forEach(t),_e=h(P),z=r(P,"LI",{});var X=i(z);le=a(X,"a single Tensor with "),V=r(X,"CODE",{});var Le=i(V);be=a(Le,"pixel_values"),Le.forEach(t),de=a(X," only and nothing else: "),W=r(X,"CODE",{});var Fe=i(W);ne=a(Fe,"model(pixel_values)"),Fe.forEach(t),X.forEach(t),ve=h(P),A=r(P,"LI",{});var Q=i(A);se=a(Q,`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),G=r(Q,"CODE",{});var Ee=i(G);ce=a(Ee,"model([pixel_values, attention_mask])"),Ee.forEach(t),q=a(Q," or "),j=r(Q,"CODE",{});var Ve=i(j);we=a(Ve,"model([pixel_values, attention_mask, token_type_ids])"),Ve.forEach(t),Q.forEach(t),ae=h(P),C=r(P,"LI",{});var N=i(C);ye=a(N,`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),R=r(N,"CODE",{});var We=i(R);$e=a(We,'model({"pixel_values": pixel_values, "token_type_ids": token_type_ids})'),We.forEach(t),Te=a(N,` Note that when creating models and layers
with `),S=r(N,"A",{href:!0,rel:!0});var Be=i(S);ke=a(Be,"subclassing"),Be.forEach(t),xe=a(N,` then you don\u2019t need to
worry about any of this, as you can just pass inputs like you would to any other Python function!`),N.forEach(t),P.forEach(t),this.h()},h(){c(S,"href","https://keras.io/guides/making_new_layers_and_models_via_subclassing/"),c(S,"rel","nofollow")},m(M,D){_(M,d,D),e(d,v),e(d,u),e(u,f),e(d,b),_(M,l,D),_(M,p,D),e(p,E),e(E,pe),e(p,re),e(p,F),e(F,Y),e(F,U),e(U,Z),e(F,me),e(F,K),e(K,he),e(F,ie),e(F,O),e(O,fe),e(F,ee),e(F,H),e(H,ue),e(F,te),e(F,J),e(J,ge),e(F,oe),e(p,_e),e(p,z),e(z,le),e(z,V),e(V,be),e(z,de),e(z,W),e(W,ne),e(p,ve),e(p,A),e(A,se),e(A,G),e(G,ce),e(A,q),e(A,j),e(j,we),e(p,ae),e(p,C),e(C,ye),e(C,R),e(R,$e),e(C,Te),e(C,S),e(S,ke),e(C,xe)},d(M){M&&t(d),M&&t(l),M&&t(p)}}}function Av(B){let d,v,u,f,b;return{c(){d=n("p"),v=s("Although the recipe for forward pass needs to be defined within this function, one should call the "),u=n("code"),f=s("Module"),b=s(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=r(l,"P",{});var p=i(d);v=a(p,"Although the recipe for forward pass needs to be defined within this function, one should call the "),u=r(p,"CODE",{});var E=i(u);f=a(E,"Module"),E.forEach(t),b=a(p,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),p.forEach(t)},m(l,p){_(l,d,p),e(d,v),e(d,u),e(u,f),e(d,b)},d(l){l&&t(d)}}}function zv(B){let d,v,u,f,b;return f=new bt({props:{code:`from transformers import AutoImageProcessor, TFBeitForImageClassification
import tensorflow as tf
from datasets import load_dataset

dataset = load_dataset("huggingface/cats-image")
image = dataset["test"]["image"][0]

image_processor = AutoImageProcessor.from_pretrained("microsoft/beit-base-patch16-224")
model = TFBeitForImageClassification.from_pretrained("microsoft/beit-base-patch16-224")

inputs = image_processor(image, return_tensors="tf")
logits = model(**inputs).logits

# model predicts one of the 1000 ImageNet classes
predicted_label = int(tf.math.argmax(logits, axis=-1))
print(model.config.id2label[predicted_label])`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoImageProcessor, TFBeitForImageClassification
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> tensorflow <span class="hljs-keyword">as</span> tf
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset

<span class="hljs-meta">&gt;&gt;&gt; </span>dataset = load_dataset(<span class="hljs-string">&quot;huggingface/cats-image&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = dataset[<span class="hljs-string">&quot;test&quot;</span>][<span class="hljs-string">&quot;image&quot;</span>][<span class="hljs-number">0</span>]

<span class="hljs-meta">&gt;&gt;&gt; </span>image_processor = AutoImageProcessor.from_pretrained(<span class="hljs-string">&quot;microsoft/beit-base-patch16-224&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFBeitForImageClassification.from_pretrained(<span class="hljs-string">&quot;microsoft/beit-base-patch16-224&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = image_processor(image, return_tensors=<span class="hljs-string">&quot;tf&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>logits = model(**inputs).logits

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># model predicts one of the 1000 ImageNet classes</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_label = <span class="hljs-built_in">int</span>(tf.math.argmax(logits, axis=-<span class="hljs-number">1</span>))
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(model.config.id2label[predicted_label])
tabby, tabby cat`}}),{c(){d=n("p"),v=s("Example:"),u=m(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var p=i(d);v=a(p,"Example:"),p.forEach(t),u=h(l),y(f.$$.fragment,l)},m(l,p){_(l,d,p),e(d,v),_(l,u,p),$(f,l,p),b=!0},p:_t,i(l){b||(T(f.$$.fragment,l),b=!0)},o(l){k(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(u),x(f,l)}}}function Sv(B){let d,v,u,f,b,l,p,E,pe,re,F,Y,U,Z,me,K,he,ie,O,fe,ee,H,ue,te,J,ge,oe,_e,z,le,V,be,de,W,ne,ve,A,se,G,ce,q,j,we,ae,C,ye,R,$e,Te,S,ke,xe;return{c(){d=n("p"),v=s("TensorFlow models and layers in "),u=n("code"),f=s("transformers"),b=s(" accept two formats as input:"),l=m(),p=n("ul"),E=n("li"),pe=s("having all inputs as keyword arguments (like PyTorch models), or"),re=m(),F=n("li"),Y=s(`having all inputs as a list, tuple or dict in the first positional argument.
The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),U=n("code"),Z=s("model.fit()"),me=s(` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),K=n("code"),he=s("model.fit()"),ie=s(` supports! If, however, you want to use the second
format outside of Keras methods like `),O=n("code"),fe=s("fit()"),ee=s(" and "),H=n("code"),ue=s("predict()"),te=s(`, such as when creating your own layers or models with
the Keras `),J=n("code"),ge=s("Functional"),oe=s(` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),_e=m(),z=n("li"),le=s("a single Tensor with "),V=n("code"),be=s("pixel_values"),de=s(" only and nothing else: "),W=n("code"),ne=s("model(pixel_values)"),ve=m(),A=n("li"),se=s(`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),G=n("code"),ce=s("model([pixel_values, attention_mask])"),q=s(" or "),j=n("code"),we=s("model([pixel_values, attention_mask, token_type_ids])"),ae=m(),C=n("li"),ye=s(`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),R=n("code"),$e=s('model({"pixel_values": pixel_values, "token_type_ids": token_type_ids})'),Te=s(` Note that when creating models and layers
with `),S=n("a"),ke=s("subclassing"),xe=s(` then you don\u2019t need to
worry about any of this, as you can just pass inputs like you would to any other Python function!`),this.h()},l(M){d=r(M,"P",{});var D=i(d);v=a(D,"TensorFlow models and layers in "),u=r(D,"CODE",{});var Se=i(u);f=a(Se,"transformers"),Se.forEach(t),b=a(D," accept two formats as input:"),D.forEach(t),l=h(M),p=r(M,"UL",{});var P=i(p);E=r(P,"LI",{});var De=i(E);pe=a(De,"having all inputs as keyword arguments (like PyTorch models), or"),De.forEach(t),re=h(P),F=r(P,"LI",{});var I=i(F);Y=a(I,`having all inputs as a list, tuple or dict in the first positional argument.
The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),U=r(I,"CODE",{});var Ce=i(U);Z=a(Ce,"model.fit()"),Ce.forEach(t),me=a(I,` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),K=r(I,"CODE",{});var Oe=i(K);he=a(Oe,"model.fit()"),Oe.forEach(t),ie=a(I,` supports! If, however, you want to use the second
format outside of Keras methods like `),O=r(I,"CODE",{});var qe=i(O);fe=a(qe,"fit()"),qe.forEach(t),ee=a(I," and "),H=r(I,"CODE",{});var Ae=i(H);ue=a(Ae,"predict()"),Ae.forEach(t),te=a(I,`, such as when creating your own layers or models with
the Keras `),J=r(I,"CODE",{});var Ne=i(J);ge=a(Ne,"Functional"),Ne.forEach(t),oe=a(I,` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),I.forEach(t),_e=h(P),z=r(P,"LI",{});var X=i(z);le=a(X,"a single Tensor with "),V=r(X,"CODE",{});var Le=i(V);be=a(Le,"pixel_values"),Le.forEach(t),de=a(X," only and nothing else: "),W=r(X,"CODE",{});var Fe=i(W);ne=a(Fe,"model(pixel_values)"),Fe.forEach(t),X.forEach(t),ve=h(P),A=r(P,"LI",{});var Q=i(A);se=a(Q,`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),G=r(Q,"CODE",{});var Ee=i(G);ce=a(Ee,"model([pixel_values, attention_mask])"),Ee.forEach(t),q=a(Q," or "),j=r(Q,"CODE",{});var Ve=i(j);we=a(Ve,"model([pixel_values, attention_mask, token_type_ids])"),Ve.forEach(t),Q.forEach(t),ae=h(P),C=r(P,"LI",{});var N=i(C);ye=a(N,`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),R=r(N,"CODE",{});var We=i(R);$e=a(We,'model({"pixel_values": pixel_values, "token_type_ids": token_type_ids})'),We.forEach(t),Te=a(N,` Note that when creating models and layers
with `),S=r(N,"A",{href:!0,rel:!0});var Be=i(S);ke=a(Be,"subclassing"),Be.forEach(t),xe=a(N,` then you don\u2019t need to
worry about any of this, as you can just pass inputs like you would to any other Python function!`),N.forEach(t),P.forEach(t),this.h()},h(){c(S,"href","https://keras.io/guides/making_new_layers_and_models_via_subclassing/"),c(S,"rel","nofollow")},m(M,D){_(M,d,D),e(d,v),e(d,u),e(u,f),e(d,b),_(M,l,D),_(M,p,D),e(p,E),e(E,pe),e(p,re),e(p,F),e(F,Y),e(F,U),e(U,Z),e(F,me),e(F,K),e(K,he),e(F,ie),e(F,O),e(O,fe),e(F,ee),e(F,H),e(H,ue),e(F,te),e(F,J),e(J,ge),e(F,oe),e(p,_e),e(p,z),e(z,le),e(z,V),e(V,be),e(z,de),e(z,W),e(W,ne),e(p,ve),e(p,A),e(A,se),e(A,G),e(G,ce),e(A,q),e(A,j),e(j,we),e(p,ae),e(p,C),e(C,ye),e(C,R),e(R,$e),e(C,Te),e(C,S),e(S,ke),e(C,xe)},d(M){M&&t(d),M&&t(l),M&&t(p)}}}function Dv(B){let d,v,u,f,b;return{c(){d=n("p"),v=s("Although the recipe for forward pass needs to be defined within this function, one should call the "),u=n("code"),f=s("Module"),b=s(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=r(l,"P",{});var p=i(d);v=a(p,"Although the recipe for forward pass needs to be defined within this function, one should call the "),u=r(p,"CODE",{});var E=i(u);f=a(E,"Module"),E.forEach(t),b=a(p,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),p.forEach(t)},m(l,p){_(l,d,p),e(d,v),e(d,u),e(u,f),e(d,b)},d(l){l&&t(d)}}}function Ov(B){let d,v,u,f,b;return f=new bt({props:{code:`from transformers import AutoImageProcessor, TFBeitForSemanticSegmentation
from PIL import Image
import requests

url = "http://images.cocodataset.org/val2017/000000039769.jpg"
image = Image.open(requests.get(url, stream=True).raw)
image_processor = AutoImageProcessor.from_pretrained("microsoft/beit-base-patch16-224-pt22k-ft22k")
model = TFBeitForSemanticSegmentation.from_pretrained("microsoft/beit-base-patch16-224-pt22k-ft22k")
inputs = image_processor(images=image, return_tensors="tf")
outputs = model(**inputs)
# logits are of shape (batch_size, num_labels, height, width)
logits = outputs.logits`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoImageProcessor, TFBeitForSemanticSegmentation
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests

<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;http://images.cocodataset.org/val2017/000000039769.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)
<span class="hljs-meta">&gt;&gt;&gt; </span>image_processor = AutoImageProcessor.from_pretrained(<span class="hljs-string">&quot;microsoft/beit-base-patch16-224-pt22k-ft22k&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFBeitForSemanticSegmentation.from_pretrained(<span class="hljs-string">&quot;microsoft/beit-base-patch16-224-pt22k-ft22k&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = image_processor(images=image, return_tensors=<span class="hljs-string">&quot;tf&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># logits are of shape (batch_size, num_labels, height, width)</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>logits = outputs.logits`}}),{c(){d=n("p"),v=s("Examples:"),u=m(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var p=i(d);v=a(p,"Examples:"),p.forEach(t),u=h(l),y(f.$$.fragment,l)},m(l,p){_(l,d,p),e(d,v),_(l,u,p),$(f,l,p),b=!0},p:_t,i(l){b||(T(f.$$.fragment,l),b=!0)},o(l){k(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(u),x(f,l)}}}function qv(B){let d,v,u,f,b,l,p,E,pe,re,F,Y,U,Z,me,K,he,ie,O,fe,ee,H,ue,te,J,ge,oe,_e,z,le,V,be,de,W,ne,ve,A,se,G,ce,q,j,we,ae,C,ye,R,$e,Te,S,ke,xe,M,D,Se,P,De,I,Ce,Oe,qe,Ae,Ne,X,Le,Fe,Q,Ee,Ve,N,We,Be,Vd,Tn,Wd,Rd,Ud,zt,Kd,Er,Hd,Jd,Ps,Gd,Xd,Qd,St,Yd,js,Zd,ec,Cs,tc,oc,sc,Ze,ac,Br,nc,rc,Ir,ic,lc,kn,dc,cc,Mr,pc,mc,bl,bo,ag,vl,As,hc,xn,fc,wl,Je,uc,zs,gc,_c,Ss,bc,vc,Ds,wc,yc,Os,$c,Tc,yl,Dt,vo,Pr,qs,kc,jr,xc,$l,Fn,Fc,Tl,Ns,kl,wo,Bt,En,Ec,Bc,Ls,Ic,Mc,Vs,Pc,jc,Cc,Bn,Ac,In,zc,xl,Mn,Cr,Sc,Fl,Pn,Ar,jn,Dc,El,Cn,Oc,Bl,Ot,yo,zr,Ws,qc,Sr,Nc,Il,qt,Rs,Lc,Us,Vc,An,Wc,Rc,Ml,Nt,Ks,Uc,Hs,Kc,zn,Hc,Jc,Pl,Lt,$o,Dr,Js,Gc,Or,Xc,jl,vt,Gs,Qc,Vt,Yc,Sn,Zc,ep,Xs,tp,op,sp,To,Cl,Wt,ko,qr,Qs,ap,Nr,np,Al,wt,Ys,rp,Dn,Zs,ip,xo,ea,lp,ta,dp,On,cp,pp,zl,Rt,Fo,Lr,oa,mp,Vr,hp,Sl,et,sa,fp,Wr,up,gp,Eo,aa,_p,Rr,bp,vp,Bo,na,wp,ra,yp,qn,$p,Tp,Dl,Ut,Io,Ur,ia,kp,Kr,xp,Ol,yt,la,Fp,da,Ep,ca,Bp,Ip,Mp,rt,pa,Pp,Kt,jp,Nn,Cp,Ap,Hr,zp,Sp,Dp,Mo,Op,Po,ql,Ht,jo,Jr,ma,qp,Gr,Np,Nl,$t,ha,Lp,Tt,Vp,Ln,Wp,Rp,Vn,Up,Kp,fa,Hp,Jp,Gp,it,ua,Xp,Jt,Qp,Wn,Yp,Zp,Xr,em,tm,om,Co,sm,Ao,Ll,Gt,zo,Qr,ga,am,Yr,nm,Vl,tt,_a,rm,Zr,im,lm,ba,dm,va,cm,pm,mm,lt,wa,hm,Xt,fm,Rn,um,gm,ei,_m,bm,vm,So,wm,Do,Wl,Qt,Oo,ti,ya,ym,oi,$m,Rl,ot,$a,Tm,si,km,xm,Ta,Fm,ka,Em,Bm,Im,dt,xa,Mm,Yt,Pm,Un,jm,Cm,ai,Am,zm,Sm,qo,Dm,No,Ul,Zt,Lo,ni,Fa,Om,ri,qm,Kl,Ie,Ea,Nm,ii,Lm,Vm,Ba,Wm,Kn,Rm,Um,Km,Ia,Hm,Ma,Jm,Gm,Xm,li,Qm,Ym,kt,di,Pa,Zm,eh,ci,ja,th,oh,pi,Ca,sh,ah,mi,Aa,nh,rh,ct,za,ih,eo,lh,hi,dh,ch,fi,ph,mh,hh,Vo,fh,Wo,Hl,to,Ro,ui,Sa,uh,gi,gh,Jl,Me,Da,_h,_i,bh,vh,Oa,wh,Hn,yh,$h,Th,qa,kh,Na,xh,Fh,Eh,bi,Bh,Ih,xt,vi,La,Mh,Ph,wi,Va,jh,Ch,yi,Wa,Ah,zh,$i,Ra,Sh,Dh,Ge,Ua,Oh,oo,qh,Ti,Nh,Lh,ki,Vh,Wh,Rh,Uo,Uh,so,Kh,xi,Hh,Jh,Fi,Gh,Xh,Qh,Ko,Gl,ao,Ho,Ei,Ka,Yh,Bi,Zh,Xl,Pe,Ha,ef,Ii,tf,of,Ja,sf,Jn,af,nf,rf,Ga,lf,Xa,df,cf,pf,Mi,mf,hf,Ft,Pi,Qa,ff,uf,ji,Ya,gf,_f,Ci,Za,bf,vf,Ai,en,wf,yf,pt,tn,$f,no,Tf,zi,kf,xf,Si,Ff,Ef,Bf,Jo,If,Go,Ql,ro,Xo,Di,on,Mf,Oi,Pf,Yl,st,sn,jf,io,Cf,Gn,Af,zf,an,Sf,Df,Of,Qo,qf,mt,nn,Nf,lo,Lf,Xn,Vf,Wf,qi,Rf,Uf,Kf,Yo,Hf,Zo,Zl,co,es,Ni,rn,Jf,Li,Gf,ed,at,ln,Xf,nt,Qf,Qn,Yf,Zf,Yn,eu,tu,Zn,ou,su,dn,au,nu,ru,ts,iu,ht,cn,lu,po,du,er,cu,pu,Vi,mu,hu,fu,os,uu,ss,td,mo,as,Wi,pn,gu,Ri,_u,od,Re,mn,bu,Ui,vu,wu,ho,yu,tr,$u,Tu,hn,ku,xu,Fu,ns,Eu,ft,fn,Bu,fo,Iu,or,Mu,Pu,Ki,ju,Cu,Au,rs,zu,is,sd,uo,ls,Hi,un,Su,Ji,Du,ad,Ue,gn,Ou,Gi,qu,Nu,go,Lu,sr,Vu,Wu,_n,Ru,Uu,Ku,ds,Hu,ut,bn,Ju,_o,Gu,ar,Xu,Qu,Xi,Yu,Zu,eg,cs,tg,ps,nd;return l=new ze({}),Z=new ze({}),qs=new ze({}),Ns=new pv({props:{pipeline:"image-classification"}}),Ws=new ze({}),Rs=new L({props:{name:"class transformers.models.beit.modeling_beit.BeitModelOutputWithPooling",anchor:"transformers.models.beit.modeling_beit.BeitModelOutputWithPooling",parameters:[{name:"last_hidden_state",val:": FloatTensor = None"},{name:"pooler_output",val:": FloatTensor = None"},{name:"hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"}],parametersDescription:[{anchor:"transformers.models.beit.modeling_beit.BeitModelOutputWithPooling.last_hidden_state",description:`<strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) &#x2014;
Sequence of hidden-states at the output of the last layer of the model.`,name:"last_hidden_state"},{anchor:"transformers.models.beit.modeling_beit.BeitModelOutputWithPooling.pooler_output",description:`<strong>pooler_output</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, hidden_size)</code>) &#x2014;
Average of the last layer hidden states of the patch tokens (excluding the <em>[CLS]</em> token) if
<em>config.use_mean_pooling</em> is set to True. If set to False, then the final hidden state of the <em>[CLS]</em> token
will be returned.`,name:"pooler_output"},{anchor:"transformers.models.beit.modeling_beit.BeitModelOutputWithPooling.hidden_states",description:`<strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.`,name:"hidden_states"},{anchor:"transformers.models.beit.modeling_beit.BeitModelOutputWithPooling.attentions",description:`<strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.`,name:"attentions"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/beit/modeling_beit.py#L68"}}),Ks=new L({props:{name:"class transformers.models.beit.modeling_flax_beit.FlaxBeitModelOutputWithPooling",anchor:"transformers.models.beit.modeling_flax_beit.FlaxBeitModelOutputWithPooling",parameters:[{name:"last_hidden_state",val:": ndarray = None"},{name:"pooler_output",val:": ndarray = None"},{name:"hidden_states",val:": typing.Optional[typing.Tuple[jax._src.numpy.ndarray.ndarray]] = None"},{name:"attentions",val:": typing.Optional[typing.Tuple[jax._src.numpy.ndarray.ndarray]] = None"}],parametersDescription:[{anchor:"transformers.models.beit.modeling_flax_beit.FlaxBeitModelOutputWithPooling.last_hidden_state",description:`<strong>last_hidden_state</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) &#x2014;
Sequence of hidden-states at the output of the last layer of the model.`,name:"last_hidden_state"},{anchor:"transformers.models.beit.modeling_flax_beit.FlaxBeitModelOutputWithPooling.pooler_output",description:`<strong>pooler_output</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, hidden_size)</code>) &#x2014;
Average of the last layer hidden states of the patch tokens (excluding the <em>[CLS]</em> token) if
<em>config.use_mean_pooling</em> is set to True. If set to False, then the final hidden state of the <em>[CLS]</em> token
will be returned.`,name:"pooler_output"},{anchor:"transformers.models.beit.modeling_flax_beit.FlaxBeitModelOutputWithPooling.hidden_states",description:`<strong>hidden_states</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>jnp.ndarray</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the model at the output of each layer plus
the initial embedding outputs.`,name:"hidden_states"},{anchor:"transformers.models.beit.modeling_flax_beit.FlaxBeitModelOutputWithPooling.attentions",description:`<strong>attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights after the attention softmax, used to compute the weighted average in
the self-attention heads.`,name:"attentions"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/beit/modeling_flax_beit.py#L45"}}),Js=new ze({}),Gs=new L({props:{name:"class transformers.BeitConfig",anchor:"transformers.BeitConfig",parameters:[{name:"vocab_size",val:" = 8192"},{name:"hidden_size",val:" = 768"},{name:"num_hidden_layers",val:" = 12"},{name:"num_attention_heads",val:" = 12"},{name:"intermediate_size",val:" = 3072"},{name:"hidden_act",val:" = 'gelu'"},{name:"hidden_dropout_prob",val:" = 0.0"},{name:"attention_probs_dropout_prob",val:" = 0.0"},{name:"initializer_range",val:" = 0.02"},{name:"layer_norm_eps",val:" = 1e-12"},{name:"image_size",val:" = 224"},{name:"patch_size",val:" = 16"},{name:"num_channels",val:" = 3"},{name:"use_mask_token",val:" = False"},{name:"use_absolute_position_embeddings",val:" = False"},{name:"use_relative_position_bias",val:" = False"},{name:"use_shared_relative_position_bias",val:" = False"},{name:"layer_scale_init_value",val:" = 0.1"},{name:"drop_path_rate",val:" = 0.1"},{name:"use_mean_pooling",val:" = True"},{name:"out_indices",val:" = [3, 5, 7, 11]"},{name:"pool_scales",val:" = [1, 2, 3, 6]"},{name:"use_auxiliary_head",val:" = True"},{name:"auxiliary_loss_weight",val:" = 0.4"},{name:"auxiliary_channels",val:" = 256"},{name:"auxiliary_num_convs",val:" = 1"},{name:"auxiliary_concat_input",val:" = False"},{name:"semantic_loss_ignore_index",val:" = 255"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.BeitConfig.vocab_size",description:`<strong>vocab_size</strong> (<code>int</code>, <em>optional</em>, defaults to 8092) &#x2014;
Vocabulary size of the BEiT model. Defines the number of different image tokens that can be used during
pre-training.`,name:"vocab_size"},{anchor:"transformers.BeitConfig.hidden_size",description:`<strong>hidden_size</strong> (<code>int</code>, <em>optional</em>, defaults to 768) &#x2014;
Dimensionality of the encoder layers and the pooler layer.`,name:"hidden_size"},{anchor:"transformers.BeitConfig.num_hidden_layers",description:`<strong>num_hidden_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 12) &#x2014;
Number of hidden layers in the Transformer encoder.`,name:"num_hidden_layers"},{anchor:"transformers.BeitConfig.num_attention_heads",description:`<strong>num_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 12) &#x2014;
Number of attention heads for each attention layer in the Transformer encoder.`,name:"num_attention_heads"},{anchor:"transformers.BeitConfig.intermediate_size",description:`<strong>intermediate_size</strong> (<code>int</code>, <em>optional</em>, defaults to 3072) &#x2014;
Dimensionality of the &#x201C;intermediate&#x201D; (i.e., feed-forward) layer in the Transformer encoder.`,name:"intermediate_size"},{anchor:"transformers.BeitConfig.hidden_act",description:`<strong>hidden_act</strong> (<code>str</code> or <code>function</code>, <em>optional</em>, defaults to <code>&quot;gelu&quot;</code>) &#x2014;
The non-linear activation function (function or string) in the encoder and pooler. If string, <code>&quot;gelu&quot;</code>,
<code>&quot;relu&quot;</code>, <code>&quot;selu&quot;</code> and <code>&quot;gelu_new&quot;</code> are supported.`,name:"hidden_act"},{anchor:"transformers.BeitConfig.hidden_dropout_prob",description:`<strong>hidden_dropout_prob</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout probability for all fully connected layers in the embeddings, encoder, and pooler.`,name:"hidden_dropout_prob"},{anchor:"transformers.BeitConfig.attention_probs_dropout_prob",description:`<strong>attention_probs_dropout_prob</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout ratio for the attention probabilities.`,name:"attention_probs_dropout_prob"},{anchor:"transformers.BeitConfig.initializer_range",description:`<strong>initializer_range</strong> (<code>float</code>, <em>optional</em>, defaults to 0.02) &#x2014;
The standard deviation of the truncated_normal_initializer for initializing all weight matrices.`,name:"initializer_range"},{anchor:"transformers.BeitConfig.layer_norm_eps",description:`<strong>layer_norm_eps</strong> (<code>float</code>, <em>optional</em>, defaults to 1e-12) &#x2014;
The epsilon used by the layer normalization layers.`,name:"layer_norm_eps"},{anchor:"transformers.BeitConfig.image_size",description:`<strong>image_size</strong> (<code>int</code>, <em>optional</em>, defaults to 224) &#x2014;
The size (resolution) of each image.`,name:"image_size"},{anchor:"transformers.BeitConfig.patch_size",description:`<strong>patch_size</strong> (<code>int</code>, <em>optional</em>, defaults to 16) &#x2014;
The size (resolution) of each patch.`,name:"patch_size"},{anchor:"transformers.BeitConfig.num_channels",description:`<strong>num_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 3) &#x2014;
The number of input channels.`,name:"num_channels"},{anchor:"transformers.BeitConfig.use_mask_token",description:`<strong>use_mask_token</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to use a mask token for masked image modeling.`,name:"use_mask_token"},{anchor:"transformers.BeitConfig.use_absolute_position_embeddings",description:`<strong>use_absolute_position_embeddings</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to use BERT-style absolute position embeddings.`,name:"use_absolute_position_embeddings"},{anchor:"transformers.BeitConfig.use_relative_position_bias",description:`<strong>use_relative_position_bias</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to use T5-style relative position embeddings in the self-attention layers.`,name:"use_relative_position_bias"},{anchor:"transformers.BeitConfig.use_shared_relative_position_bias",description:`<strong>use_shared_relative_position_bias</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to use the same relative position embeddings across all self-attention layers of the Transformer.`,name:"use_shared_relative_position_bias"},{anchor:"transformers.BeitConfig.layer_scale_init_value",description:`<strong>layer_scale_init_value</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
Scale to use in the self-attention layers. 0.1 for base, 1e-5 for large. Set 0 to disable layer scale.`,name:"layer_scale_init_value"},{anchor:"transformers.BeitConfig.drop_path_rate",description:`<strong>drop_path_rate</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
Stochastic depth rate per sample (when applied in the main path of residual layers).`,name:"drop_path_rate"},{anchor:"transformers.BeitConfig.use_mean_pooling",description:`<strong>use_mean_pooling</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to mean pool the final hidden states of the patches instead of using the final hidden state of the
CLS token, before applying the classification head.`,name:"use_mean_pooling"},{anchor:"transformers.BeitConfig.out_indices",description:`<strong>out_indices</strong> (<code>List[int]</code>, <em>optional</em>, defaults to <code>[3, 5, 7, 11]</code>) &#x2014;
Indices of the feature maps to use for semantic segmentation.`,name:"out_indices"},{anchor:"transformers.BeitConfig.pool_scales",description:`<strong>pool_scales</strong> (<code>Tuple[int]</code>, <em>optional</em>, defaults to <code>[1, 2, 3, 6]</code>) &#x2014;
Pooling scales used in Pooling Pyramid Module applied on the last feature map.`,name:"pool_scales"},{anchor:"transformers.BeitConfig.use_auxiliary_head",description:`<strong>use_auxiliary_head</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to use an auxiliary head during training.`,name:"use_auxiliary_head"},{anchor:"transformers.BeitConfig.auxiliary_loss_weight",description:`<strong>auxiliary_loss_weight</strong> (<code>float</code>, <em>optional</em>, defaults to 0.4) &#x2014;
Weight of the cross-entropy loss of the auxiliary head.`,name:"auxiliary_loss_weight"},{anchor:"transformers.BeitConfig.auxiliary_channels",description:`<strong>auxiliary_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 256) &#x2014;
Number of channels to use in the auxiliary head.`,name:"auxiliary_channels"},{anchor:"transformers.BeitConfig.auxiliary_num_convs",description:`<strong>auxiliary_num_convs</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
Number of convolutional layers to use in the auxiliary head.`,name:"auxiliary_num_convs"},{anchor:"transformers.BeitConfig.auxiliary_concat_input",description:`<strong>auxiliary_concat_input</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to concatenate the output of the auxiliary head with the input before the classification layer.`,name:"auxiliary_concat_input"},{anchor:"transformers.BeitConfig.semantic_loss_ignore_index",description:`<strong>semantic_loss_ignore_index</strong> (<code>int</code>, <em>optional</em>, defaults to 255) &#x2014;
The index that is ignored by the loss function of the semantic segmentation model.`,name:"semantic_loss_ignore_index"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/beit/configuration_beit.py#L36"}}),To=new gt({props:{anchor:"transformers.BeitConfig.example",$$slots:{default:[mv]},$$scope:{ctx:B}}}),Qs=new ze({}),Ys=new L({props:{name:"class transformers.BeitFeatureExtractor",anchor:"transformers.BeitFeatureExtractor",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/beit/feature_extraction_beit.py#L26"}}),Zs=new L({props:{name:"__call__",anchor:"transformers.BeitFeatureExtractor.__call__",parameters:[{name:"images",val:""},{name:"segmentation_maps",val:" = None"},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/beit/image_processing_beit.py#L356"}}),ea=new L({props:{name:"post_process_semantic_segmentation",anchor:"transformers.BeitFeatureExtractor.post_process_semantic_segmentation",parameters:[{name:"outputs",val:""},{name:"target_sizes",val:": typing.List[typing.Tuple] = None"}],parametersDescription:[{anchor:"transformers.BeitFeatureExtractor.post_process_semantic_segmentation.outputs",description:`<strong>outputs</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitForSemanticSegmentation">BeitForSemanticSegmentation</a>) &#x2014;
Raw outputs of the model.`,name:"outputs"},{anchor:"transformers.BeitFeatureExtractor.post_process_semantic_segmentation.target_sizes",description:`<strong>target_sizes</strong> (<code>List[Tuple]</code> of length <code>batch_size</code>, <em>optional</em>) &#x2014;
List of tuples corresponding to the requested final size (height, width) of each prediction. If left to
None, predictions will not be resized.`,name:"target_sizes"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/beit/image_processing_beit.py#L503",returnDescription:`
<p><code>List[torch.Tensor]</code> of length <code>batch_size</code>, where each item is a semantic
segmentation map of shape (height, width) corresponding to the target_sizes entry (if <code>target_sizes</code> is
specified). Each entry of each <code>torch.Tensor</code> correspond to a semantic class id.</p>
`,returnType:`
<p>semantic_segmentation</p>
`}}),oa=new ze({}),sa=new L({props:{name:"class transformers.BeitImageProcessor",anchor:"transformers.BeitImageProcessor",parameters:[{name:"do_resize",val:": bool = True"},{name:"size",val:": typing.Dict[str, int] = None"},{name:"resample",val:": Resampling = <Resampling.BICUBIC: 3>"},{name:"do_center_crop",val:": bool = True"},{name:"crop_size",val:": typing.Dict[str, int] = None"},{name:"rescale_factor",val:": typing.Union[int, float] = 0.00392156862745098"},{name:"do_rescale",val:": bool = True"},{name:"do_normalize",val:": bool = True"},{name:"image_mean",val:": typing.Union[float, typing.List[float], NoneType] = None"},{name:"image_std",val:": typing.Union[float, typing.List[float], NoneType] = None"},{name:"do_reduce_labels",val:": bool = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.BeitImageProcessor.do_resize",description:`<strong>do_resize</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to resize the image&#x2019;s (height, width) dimensions to the specified <code>size</code>. Can be overridden by the
<code>do_resize</code> parameter in the <code>preprocess</code> method.`,name:"do_resize"},{anchor:"transformers.BeitImageProcessor.size",description:`<strong>size</strong> (<code>Dict[str, int]</code> <em>optional</em>, defaults to <code>{&quot;height&quot; -- 256, &quot;width&quot;: 256}</code>):
Size of the output image after resizing. Can be overridden by the <code>size</code> parameter in the <code>preprocess</code>
method.`,name:"size"},{anchor:"transformers.BeitImageProcessor.resample",description:`<strong>resample</strong> (<code>PILImageResampling</code>, <em>optional</em>, defaults to <code>PILImageResampling.BICUBIC</code>) &#x2014;
Resampling filter to use if resizing the image. Can be overridden by the <code>resample</code> parameter in the
<code>preprocess</code> method.`,name:"resample"},{anchor:"transformers.BeitImageProcessor.do_center_crop",description:`<strong>do_center_crop</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to center crop the image. If the input size is smaller than <code>crop_size</code> along any edge, the image
is padded with 0&#x2019;s and then center cropped. Can be overridden by the <code>do_center_crop</code> parameter in the
<code>preprocess</code> method.`,name:"do_center_crop"},{anchor:"transformers.BeitImageProcessor.crop_size",description:`<strong>crop_size</strong> (<code>Dict[str, int]</code>, <em>optional</em>, defaults to <code>{&quot;height&quot; -- 224, &quot;width&quot;: 224}</code>):
Desired output size when applying center-cropping. Only has an effect if <code>do_center_crop</code> is set to <code>True</code>.
Can be overridden by the <code>crop_size</code> parameter in the <code>preprocess</code> method.`,name:"crop_size"},{anchor:"transformers.BeitImageProcessor.do_rescale",description:`<strong>do_rescale</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to rescale the image by the specified scale <code>rescale_factor</code>. Can be overridden by the <code>do_rescale</code>
parameter in the <code>preprocess</code> method.`,name:"do_rescale"},{anchor:"transformers.BeitImageProcessor.rescale_factor",description:`<strong>rescale_factor</strong> (<code>int</code> or <code>float</code>, <em>optional</em>, defaults to <code>1/255</code>) &#x2014;
Scale factor to use if rescaling the image. Can be overridden by the <code>rescale_factor</code> parameter in the
<code>preprocess</code> method.`,name:"rescale_factor"},{anchor:"transformers.BeitImageProcessor.do_normalize",description:`<strong>do_normalize</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to normalize the image. Can be overridden by the <code>do_normalize</code> parameter in the <code>preprocess</code>
method.`,name:"do_normalize"},{anchor:"transformers.BeitImageProcessor.image_mean",description:`<strong>image_mean</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to <code>IMAGENET_STANDARD_MEAN</code>) &#x2014;
The mean to use if normalizing the image. This is a float or list of floats of length of the number of
channels of the image. Can be overridden by the <code>image_mean</code> parameter in the <code>preprocess</code> method.`,name:"image_mean"},{anchor:"transformers.BeitImageProcessor.image_std",description:`<strong>image_std</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to <code>IMAGENET_STANDARD_STD</code>) &#x2014;
The standard deviation to use if normalizing the image. This is a float or list of floats of length of the
number of channels of the image. Can be overridden by the <code>image_std</code> parameter in the <code>preprocess</code> method.`,name:"image_std"},{anchor:"transformers.BeitImageProcessor.do_reduce_labels",description:`<strong>do_reduce_labels</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to reduce all label values of segmentation maps by 1. Usually used for datasets where 0 is
used for background, and background itself is not included in all classes of a dataset (e.g. ADE20k). The
background label will be replaced by 255. Can be overridden by the <code>do_reduce_labels</code> parameter in the
<code>preprocess</code> method.`,name:"do_reduce_labels"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/beit/image_processing_beit.py#L47"}}),aa=new L({props:{name:"preprocess",anchor:"transformers.BeitImageProcessor.preprocess",parameters:[{name:"images",val:": typing.Union[ForwardRef('PIL.Image.Image'), numpy.ndarray, ForwardRef('torch.Tensor'), typing.List[ForwardRef('PIL.Image.Image')], typing.List[numpy.ndarray], typing.List[ForwardRef('torch.Tensor')]]"},{name:"segmentation_maps",val:": typing.Union[ForwardRef('PIL.Image.Image'), numpy.ndarray, ForwardRef('torch.Tensor'), typing.List[ForwardRef('PIL.Image.Image')], typing.List[numpy.ndarray], typing.List[ForwardRef('torch.Tensor')], NoneType] = None"},{name:"do_resize",val:": bool = None"},{name:"size",val:": typing.Dict[str, int] = None"},{name:"resample",val:": Resampling = None"},{name:"do_center_crop",val:": bool = None"},{name:"crop_size",val:": typing.Dict[str, int] = None"},{name:"do_rescale",val:": bool = None"},{name:"rescale_factor",val:": float = None"},{name:"do_normalize",val:": bool = None"},{name:"image_mean",val:": typing.Union[float, typing.List[float], NoneType] = None"},{name:"image_std",val:": typing.Union[float, typing.List[float], NoneType] = None"},{name:"do_reduce_labels",val:": typing.Optional[bool] = None"},{name:"return_tensors",val:": typing.Union[str, transformers.utils.generic.TensorType, NoneType] = None"},{name:"data_format",val:": ChannelDimension = <ChannelDimension.FIRST: 'channels_first'>"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.BeitImageProcessor.preprocess.images",description:`<strong>images</strong> (<code>ImageInput</code>) &#x2014;
Image to preprocess.`,name:"images"},{anchor:"transformers.BeitImageProcessor.preprocess.do_resize",description:`<strong>do_resize</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>self.do_resize</code>) &#x2014;
Whether to resize the image.`,name:"do_resize"},{anchor:"transformers.BeitImageProcessor.preprocess.size",description:`<strong>size</strong> (<code>Dict[str, int]</code>, <em>optional</em>, defaults to <code>self.size</code>) &#x2014;
Size of the image after resizing.`,name:"size"},{anchor:"transformers.BeitImageProcessor.preprocess.resample",description:`<strong>resample</strong> (<code>int</code>, <em>optional</em>, defaults to <code>self.resample</code>) &#x2014;
Resampling filter to use if resizing the image. This can be one of the enum <code>PILImageResampling</code>, Only
has an effect if <code>do_resize</code> is set to <code>True</code>.`,name:"resample"},{anchor:"transformers.BeitImageProcessor.preprocess.do_center_crop",description:`<strong>do_center_crop</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>self.do_center_crop</code>) &#x2014;
Whether to center crop the image.`,name:"do_center_crop"},{anchor:"transformers.BeitImageProcessor.preprocess.crop_size",description:`<strong>crop_size</strong> (<code>Dict[str, int]</code>, <em>optional</em>, defaults to <code>self.crop_size</code>) &#x2014;
Size of the image after center crop. If one edge the image is smaller than <code>crop_size</code>, it will be
padded with zeros and then cropped`,name:"crop_size"},{anchor:"transformers.BeitImageProcessor.preprocess.do_rescale",description:`<strong>do_rescale</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>self.do_rescale</code>) &#x2014;
Whether to rescale the image values between [0 - 1].`,name:"do_rescale"},{anchor:"transformers.BeitImageProcessor.preprocess.rescale_factor",description:`<strong>rescale_factor</strong> (<code>float</code>, <em>optional</em>, defaults to <code>self.rescale_factor</code>) &#x2014;
Rescale factor to rescale the image by if <code>do_rescale</code> is set to <code>True</code>.`,name:"rescale_factor"},{anchor:"transformers.BeitImageProcessor.preprocess.do_normalize",description:`<strong>do_normalize</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>self.do_normalize</code>) &#x2014;
Whether to normalize the image.`,name:"do_normalize"},{anchor:"transformers.BeitImageProcessor.preprocess.image_mean",description:`<strong>image_mean</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to <code>self.image_mean</code>) &#x2014;
Image mean.`,name:"image_mean"},{anchor:"transformers.BeitImageProcessor.preprocess.image_std",description:`<strong>image_std</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to <code>self.image_std</code>) &#x2014;
Image standard deviation.`,name:"image_std"},{anchor:"transformers.BeitImageProcessor.preprocess.do_reduce_labels",description:`<strong>do_reduce_labels</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>self.do_reduce_labels</code>) &#x2014;
Whether or not to reduce all label values of segmentation maps by 1. Usually used for datasets where 0
is used for background, and background itself is not included in all classes of a dataset (e.g.
ADE20k). The background label will be replaced by 255.`,name:"do_reduce_labels"},{anchor:"transformers.BeitImageProcessor.preprocess.return_tensors",description:`<strong>return_tensors</strong> (<code>str</code> or <code>TensorType</code>, <em>optional</em>) &#x2014;
The type of tensors to return. Can be one of:<ul>
<li>Unset: Return a list of <code>np.ndarray</code>.</li>
<li><code>TensorType.TENSORFLOW</code> or <code>&apos;tf&apos;</code>: Return a batch of type <code>tf.Tensor</code>.</li>
<li><code>TensorType.PYTORCH</code> or <code>&apos;pt&apos;</code>: Return a batch of type <code>torch.Tensor</code>.</li>
<li><code>TensorType.NUMPY</code> or <code>&apos;np&apos;</code>: Return a batch of type <code>np.ndarray</code>.</li>
<li><code>TensorType.JAX</code> or <code>&apos;jax&apos;</code>: Return a batch of type <code>jax.numpy.ndarray</code>.</li>
</ul>`,name:"return_tensors"},{anchor:"transformers.BeitImageProcessor.preprocess.data_format",description:`<strong>data_format</strong> (<code>ChannelDimension</code> or <code>str</code>, <em>optional</em>, defaults to <code>ChannelDimension.FIRST</code>) &#x2014;
The channel dimension format for the output image. Can be one of:<ul>
<li><code>ChannelDimension.FIRST</code>: image in (num_channels, height, width) format.</li>
<li><code>ChannelDimension.LAST</code>: image in (height, width, num_channels) format.</li>
</ul>`,name:"data_format"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/beit/image_processing_beit.py#L361"}}),na=new L({props:{name:"post_process_semantic_segmentation",anchor:"transformers.BeitImageProcessor.post_process_semantic_segmentation",parameters:[{name:"outputs",val:""},{name:"target_sizes",val:": typing.List[typing.Tuple] = None"}],parametersDescription:[{anchor:"transformers.BeitImageProcessor.post_process_semantic_segmentation.outputs",description:`<strong>outputs</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitForSemanticSegmentation">BeitForSemanticSegmentation</a>) &#x2014;
Raw outputs of the model.`,name:"outputs"},{anchor:"transformers.BeitImageProcessor.post_process_semantic_segmentation.target_sizes",description:`<strong>target_sizes</strong> (<code>List[Tuple]</code> of length <code>batch_size</code>, <em>optional</em>) &#x2014;
List of tuples corresponding to the requested final size (height, width) of each prediction. If left to
None, predictions will not be resized.`,name:"target_sizes"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/beit/image_processing_beit.py#L503",returnDescription:`
<p><code>List[torch.Tensor]</code> of length <code>batch_size</code>, where each item is a semantic
segmentation map of shape (height, width) corresponding to the target_sizes entry (if <code>target_sizes</code> is
specified). Each entry of each <code>torch.Tensor</code> correspond to a semantic class id.</p>
`,returnType:`
<p>semantic_segmentation</p>
`}}),ia=new ze({}),la=new L({props:{name:"class transformers.BeitModel",anchor:"transformers.BeitModel",parameters:[{name:"config",val:": BeitConfig"},{name:"add_pooling_layer",val:": bool = True"}],parametersDescription:[{anchor:"transformers.BeitModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitConfig">BeitConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/beit/modeling_beit.py#L618"}}),pa=new L({props:{name:"forward",anchor:"transformers.BeitModel.forward",parameters:[{name:"pixel_values",val:": typing.Optional[torch.Tensor] = None"},{name:"bool_masked_pos",val:": typing.Optional[torch.BoolTensor] = None"},{name:"head_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.BeitModel.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Pixel values can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoImageProcessor">AutoImageProcessor</a>. See
<a href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitFeatureExtractor.__call__">BeitImageProcessor.<strong>call</strong>()</a> for details.`,name:"pixel_values"},{anchor:"transformers.BeitModel.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.BeitModel.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.BeitModel.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.BeitModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.BeitModel.forward.bool_masked_pos",description:`<strong>bool_masked_pos</strong> (<code>torch.BoolTensor</code> of shape <code>(batch_size, num_patches)</code>, <em>optional</em>) &#x2014;
Boolean masked positions. Indicates which patches are masked (1) and which aren&#x2019;t (0).`,name:"bool_masked_pos"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/beit/modeling_beit.py#L645",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.models.beit.modeling_beit.BeitModelOutputWithPooling"
>transformers.models.beit.modeling_beit.BeitModelOutputWithPooling</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitConfig"
>BeitConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the model.</p>
</li>
<li>
<p><strong>pooler_output</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, hidden_size)</code>) \u2014 Average of the last layer hidden states of the patch tokens (excluding the <em>[CLS]</em> token) if
<em>config.use_mean_pooling</em> is set to True. If set to False, then the final hidden state of the <em>[CLS]</em> token
will be returned.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.models.beit.modeling_beit.BeitModelOutputWithPooling"
>transformers.models.beit.modeling_beit.BeitModelOutputWithPooling</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),Mo=new He({props:{$$slots:{default:[hv]},$$scope:{ctx:B}}}),Po=new gt({props:{anchor:"transformers.BeitModel.forward.example",$$slots:{default:[fv]},$$scope:{ctx:B}}}),ma=new ze({}),ha=new L({props:{name:"class transformers.BeitForMaskedImageModeling",anchor:"transformers.BeitForMaskedImageModeling",parameters:[{name:"config",val:": BeitConfig"}],parametersDescription:[{anchor:"transformers.BeitForMaskedImageModeling.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitConfig">BeitConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/beit/modeling_beit.py#L733"}}),ua=new L({props:{name:"forward",anchor:"transformers.BeitForMaskedImageModeling.forward",parameters:[{name:"pixel_values",val:": typing.Optional[torch.Tensor] = None"},{name:"bool_masked_pos",val:": typing.Optional[torch.BoolTensor] = None"},{name:"head_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"labels",val:": typing.Optional[torch.Tensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.BeitForMaskedImageModeling.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Pixel values can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoImageProcessor">AutoImageProcessor</a>. See
<a href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitFeatureExtractor.__call__">BeitImageProcessor.<strong>call</strong>()</a> for details.`,name:"pixel_values"},{anchor:"transformers.BeitForMaskedImageModeling.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.BeitForMaskedImageModeling.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.BeitForMaskedImageModeling.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.BeitForMaskedImageModeling.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.BeitForMaskedImageModeling.forward.bool_masked_pos",description:`<strong>bool_masked_pos</strong> (<code>torch.BoolTensor</code> of shape <code>(batch_size, num_patches)</code>) &#x2014;
Boolean masked positions. Indicates which patches are masked (1) and which aren&#x2019;t (0).`,name:"bool_masked_pos"},{anchor:"transformers.BeitForMaskedImageModeling.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for computing the image classification/regression loss. Indices should be in <code>[0, ..., config.num_labels - 1]</code>. If <code>config.num_labels == 1</code> a regression loss is computed (Mean-Square loss), If
<code>config.num_labels &gt; 1</code> a classification loss is computed (Cross-Entropy).`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/beit/modeling_beit.py#L747",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_outputs.MaskedLMOutput"
>transformers.modeling_outputs.MaskedLMOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitConfig"
>BeitConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Masked language modeling (MLM) loss.</p>
</li>
<li>
<p><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head (scores for each vocabulary token before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_outputs.MaskedLMOutput"
>transformers.modeling_outputs.MaskedLMOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),Co=new He({props:{$$slots:{default:[uv]},$$scope:{ctx:B}}}),Ao=new gt({props:{anchor:"transformers.BeitForMaskedImageModeling.forward.example",$$slots:{default:[gv]},$$scope:{ctx:B}}}),ga=new ze({}),_a=new L({props:{name:"class transformers.BeitForImageClassification",anchor:"transformers.BeitForImageClassification",parameters:[{name:"config",val:": BeitConfig"}],parametersDescription:[{anchor:"transformers.BeitForImageClassification.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitConfig">BeitConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/beit/modeling_beit.py#L833"}}),wa=new L({props:{name:"forward",anchor:"transformers.BeitForImageClassification.forward",parameters:[{name:"pixel_values",val:": typing.Optional[torch.Tensor] = None"},{name:"head_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"labels",val:": typing.Optional[torch.Tensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.BeitForImageClassification.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Pixel values can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoImageProcessor">AutoImageProcessor</a>. See
<a href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitFeatureExtractor.__call__">BeitImageProcessor.<strong>call</strong>()</a> for details.`,name:"pixel_values"},{anchor:"transformers.BeitForImageClassification.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.BeitForImageClassification.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.BeitForImageClassification.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.BeitForImageClassification.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.BeitForImageClassification.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for computing the image classification/regression loss. Indices should be in <code>[0, ..., config.num_labels - 1]</code>. If <code>config.num_labels == 1</code> a regression loss is computed (Mean-Square loss), If
<code>config.num_labels &gt; 1</code> a classification loss is computed (Cross-Entropy).`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/beit/modeling_beit.py#L846",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_outputs.ImageClassifierOutput"
>transformers.modeling_outputs.ImageClassifierOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitConfig"
>BeitConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Classification (or regression if config.num_labels==1) loss.</p>
</li>
<li>
<p><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, config.num_labels)</code>) \u2014 Classification (or regression if config.num_labels==1) scores (before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each stage) of shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states
(also called feature maps) of the model at the output of each stage.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, patch_size, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_outputs.ImageClassifierOutput"
>transformers.modeling_outputs.ImageClassifierOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),So=new He({props:{$$slots:{default:[_v]},$$scope:{ctx:B}}}),Do=new gt({props:{anchor:"transformers.BeitForImageClassification.forward.example",$$slots:{default:[bv]},$$scope:{ctx:B}}}),ya=new ze({}),$a=new L({props:{name:"class transformers.BeitForSemanticSegmentation",anchor:"transformers.BeitForSemanticSegmentation",parameters:[{name:"config",val:": BeitConfig"}],parametersDescription:[{anchor:"transformers.BeitForSemanticSegmentation.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitConfig">BeitConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/beit/modeling_beit.py#L1156"}}),xa=new L({props:{name:"forward",anchor:"transformers.BeitForSemanticSegmentation.forward",parameters:[{name:"pixel_values",val:": typing.Optional[torch.Tensor] = None"},{name:"head_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"labels",val:": typing.Optional[torch.Tensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.BeitForSemanticSegmentation.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Pixel values can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoImageProcessor">AutoImageProcessor</a>. See
<a href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitFeatureExtractor.__call__">BeitImageProcessor.<strong>call</strong>()</a> for details.`,name:"pixel_values"},{anchor:"transformers.BeitForSemanticSegmentation.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.BeitForSemanticSegmentation.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.BeitForSemanticSegmentation.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.BeitForSemanticSegmentation.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.BeitForSemanticSegmentation.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, height, width)</code>, <em>optional</em>) &#x2014;
Ground truth semantic segmentation maps for computing the loss. Indices should be in <code>[0, ..., config.num_labels - 1]</code>. If <code>config.num_labels &gt; 1</code>, a classification loss is computed (Cross-Entropy).`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/beit/modeling_beit.py#L1200",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_outputs.SemanticSegmenterOutput"
>transformers.modeling_outputs.SemanticSegmenterOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitConfig"
>BeitConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Classification (or regression if config.num_labels==1) loss.</p>
</li>
<li>
<p><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, config.num_labels, logits_height, logits_width)</code>) \u2014 Classification scores for each pixel.</p>
<Tip warning={true}>
<p>The logits returned do not necessarily have the same size as the <code>pixel_values</code> passed as inputs. This is
to avoid doing two interpolations and lose some quality when a user needs to resize the logits to the
original image size as post-processing. You should always check your logits shape and resize as needed.</p>
</Tip>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, patch_size, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, patch_size, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_outputs.SemanticSegmenterOutput"
>transformers.modeling_outputs.SemanticSegmenterOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),qo=new He({props:{$$slots:{default:[vv]},$$scope:{ctx:B}}}),No=new gt({props:{anchor:"transformers.BeitForSemanticSegmentation.forward.example",$$slots:{default:[wv]},$$scope:{ctx:B}}}),Fa=new ze({}),Ea=new L({props:{name:"class transformers.FlaxBeitModel",anchor:"transformers.FlaxBeitModel",parameters:[{name:"config",val:": BeitConfig"},{name:"input_shape",val:" = None"},{name:"seed",val:": int = 0"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"},{name:"_do_init",val:": bool = True"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.FlaxBeitModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitConfig">BeitConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"},{anchor:"transformers.FlaxBeitModel.dtype",description:`<strong>dtype</strong> (<code>jax.numpy.dtype</code>, <em>optional</em>, defaults to <code>jax.numpy.float32</code>) &#x2014;
The data type of the computation. Can be one of <code>jax.numpy.float32</code>, <code>jax.numpy.float16</code> (on GPUs) and
<code>jax.numpy.bfloat16</code> (on TPUs).</p>
<p>This can be used to enable mixed-precision training or half-precision inference on GPUs or TPUs. If
specified all the computation will be performed with the given <code>dtype</code>.</p>
<p><strong>Note that this only specifies the dtype of the computation and does not influence the dtype of model
parameters.</strong></p>
<p>If you wish to change the dtype of the model parameters, see <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel.to_fp16">to_fp16()</a> and
<a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel.to_bf16">to_bf16()</a>.`,name:"dtype"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/beit/modeling_flax_beit.py#L744"}}),za=new L({props:{name:"__call__",anchor:"transformers.FlaxBeitModel.__call__",parameters:[{name:"pixel_values",val:""},{name:"bool_masked_pos",val:" = None"},{name:"params",val:": dict = None"},{name:"dropout_rng",val:": PRNGKey = None"},{name:"train",val:": bool = False"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/beit/modeling_flax_beit.py#L631",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.models.beit.modeling_flax_beit.FlaxBeitModelOutputWithPooling"
>transformers.models.beit.modeling_flax_beit.FlaxBeitModelOutputWithPooling</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<code>&lt;class 'transformers.models.beit.configuration_beit.BeitConfig'&gt;</code>) and inputs.</p>
<ul>
<li><strong>last_hidden_state</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the model.</li>
<li><strong>pooler_output</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, hidden_size)</code>) \u2014 Average of the last layer hidden states of the patch tokens (excluding the <em>[CLS]</em> token) if
<em>config.use_mean_pooling</em> is set to True. If set to False, then the final hidden state of the <em>[CLS]</em> token
will be returned.</li>
<li><strong>hidden_states</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the model at the output of each layer plus
the initial embedding outputs.</li>
<li><strong>attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights after the attention softmax, used to compute the weighted average in
the self-attention heads.</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.models.beit.modeling_flax_beit.FlaxBeitModelOutputWithPooling"
>transformers.models.beit.modeling_flax_beit.FlaxBeitModelOutputWithPooling</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),Vo=new He({props:{$$slots:{default:[yv]},$$scope:{ctx:B}}}),Wo=new gt({props:{anchor:"transformers.FlaxBeitModel.__call__.example",$$slots:{default:[$v]},$$scope:{ctx:B}}}),Sa=new ze({}),Da=new L({props:{name:"class transformers.FlaxBeitForMaskedImageModeling",anchor:"transformers.FlaxBeitForMaskedImageModeling",parameters:[{name:"config",val:": BeitConfig"},{name:"input_shape",val:" = None"},{name:"seed",val:": int = 0"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"},{name:"_do_init",val:": bool = True"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.FlaxBeitForMaskedImageModeling.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitConfig">BeitConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"},{anchor:"transformers.FlaxBeitForMaskedImageModeling.dtype",description:`<strong>dtype</strong> (<code>jax.numpy.dtype</code>, <em>optional</em>, defaults to <code>jax.numpy.float32</code>) &#x2014;
The data type of the computation. Can be one of <code>jax.numpy.float32</code>, <code>jax.numpy.float16</code> (on GPUs) and
<code>jax.numpy.bfloat16</code> (on TPUs).</p>
<p>This can be used to enable mixed-precision training or half-precision inference on GPUs or TPUs. If
specified all the computation will be performed with the given <code>dtype</code>.</p>
<p><strong>Note that this only specifies the dtype of the computation and does not influence the dtype of model
parameters.</strong></p>
<p>If you wish to change the dtype of the model parameters, see <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel.to_fp16">to_fp16()</a> and
<a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel.to_bf16">to_bf16()</a>.`,name:"dtype"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/beit/modeling_flax_beit.py#L828"}}),Ua=new L({props:{name:"__call__",anchor:"transformers.FlaxBeitForMaskedImageModeling.__call__",parameters:[{name:"pixel_values",val:""},{name:"bool_masked_pos",val:" = None"},{name:"params",val:": dict = None"},{name:"dropout_rng",val:": PRNGKey = None"},{name:"train",val:": bool = False"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/beit/modeling_flax_beit.py#L631",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_flax_outputs.FlaxMaskedLMOutput"
>transformers.modeling_flax_outputs.FlaxMaskedLMOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<code>&lt;class 'transformers.models.beit.configuration_beit.BeitConfig'&gt;</code>) and inputs.</p>
<ul>
<li>
<p><strong>logits</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head (scores for each vocabulary token before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_flax_outputs.FlaxMaskedLMOutput"
>transformers.modeling_flax_outputs.FlaxMaskedLMOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),Uo=new He({props:{$$slots:{default:[Tv]},$$scope:{ctx:B}}}),Ko=new gt({props:{anchor:"transformers.FlaxBeitForMaskedImageModeling.__call__.example",$$slots:{default:[kv]},$$scope:{ctx:B}}}),Ka=new ze({}),Ha=new L({props:{name:"class transformers.FlaxBeitForImageClassification",anchor:"transformers.FlaxBeitForImageClassification",parameters:[{name:"config",val:": BeitConfig"},{name:"input_shape",val:" = None"},{name:"seed",val:": int = 0"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"},{name:"_do_init",val:": bool = True"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.FlaxBeitForImageClassification.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitConfig">BeitConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"},{anchor:"transformers.FlaxBeitForImageClassification.dtype",description:`<strong>dtype</strong> (<code>jax.numpy.dtype</code>, <em>optional</em>, defaults to <code>jax.numpy.float32</code>) &#x2014;
The data type of the computation. Can be one of <code>jax.numpy.float32</code>, <code>jax.numpy.float16</code> (on GPUs) and
<code>jax.numpy.bfloat16</code> (on TPUs).</p>
<p>This can be used to enable mixed-precision training or half-precision inference on GPUs or TPUs. If
specified all the computation will be performed with the given <code>dtype</code>.</p>
<p><strong>Note that this only specifies the dtype of the computation and does not influence the dtype of model
parameters.</strong></p>
<p>If you wish to change the dtype of the model parameters, see <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel.to_fp16">to_fp16()</a> and
<a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel.to_bf16">to_bf16()</a>.`,name:"dtype"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/beit/modeling_flax_beit.py#L915"}}),tn=new L({props:{name:"__call__",anchor:"transformers.FlaxBeitForImageClassification.__call__",parameters:[{name:"pixel_values",val:""},{name:"bool_masked_pos",val:" = None"},{name:"params",val:": dict = None"},{name:"dropout_rng",val:": PRNGKey = None"},{name:"train",val:": bool = False"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/beit/modeling_flax_beit.py#L631",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_flax_outputs.FlaxSequenceClassifierOutput"
>transformers.modeling_flax_outputs.FlaxSequenceClassifierOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<code>&lt;class 'transformers.models.beit.configuration_beit.BeitConfig'&gt;</code>) and inputs.</p>
<ul>
<li>
<p><strong>logits</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, config.num_labels)</code>) \u2014 Classification (or regression if config.num_labels==1) scores (before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_flax_outputs.FlaxSequenceClassifierOutput"
>transformers.modeling_flax_outputs.FlaxSequenceClassifierOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),Jo=new He({props:{$$slots:{default:[xv]},$$scope:{ctx:B}}}),Go=new gt({props:{anchor:"transformers.FlaxBeitForImageClassification.__call__.example",$$slots:{default:[Fv]},$$scope:{ctx:B}}}),on=new ze({}),sn=new L({props:{name:"class transformers.TFBeitModel",anchor:"transformers.TFBeitModel",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TFBeitModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitConfig">BeitConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.TFPreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/beit/modeling_tf_beit.py#L861"}}),Qo=new He({props:{$$slots:{default:[Ev]},$$scope:{ctx:B}}}),nn=new L({props:{name:"call",anchor:"transformers.TFBeitModel.call",parameters:[{name:"pixel_values",val:": typing.Union[typing.List[tensorflow.python.framework.ops.Tensor], typing.List[numpy.ndarray], typing.List[keras.engine.keras_tensor.KerasTensor], typing.Dict[str, tensorflow.python.framework.ops.Tensor], typing.Dict[str, numpy.ndarray], typing.Dict[str, keras.engine.keras_tensor.KerasTensor], tensorflow.python.framework.ops.Tensor, numpy.ndarray, keras.engine.keras_tensor.KerasTensor, NoneType] = None"},{name:"bool_masked_pos",val:": typing.Optional[tensorflow.python.framework.ops.Tensor] = None"},{name:"head_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"training",val:": bool = False"}],parametersDescription:[{anchor:"transformers.TFBeitModel.call.pixel_values",description:`<strong>pixel_values</strong> (<code>np.ndarray</code>, <code>tf.Tensor</code>, <code>List[tf.Tensor]</code> \`<code>Dict[str, tf.Tensor]</code> or <code>Dict[str, np.ndarray]</code> and each example must have the shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Pixel values can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitImageProcessor">BeitImageProcessor</a>. See
<a href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitFeatureExtractor.__call__">BeitImageProcessor.<strong>call</strong>()</a> for details.`,name:"pixel_values"},{anchor:"transformers.TFBeitModel.call.head_mask",description:`<strong>head_mask</strong> (<code>np.ndarray</code> or <code>tf.Tensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.TFBeitModel.call.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.TFBeitModel.call.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.TFBeitModel.call.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple. This argument can be used
in eager mode, in graph mode the value will always be set to True.`,name:"return_dict"},{anchor:"transformers.TFBeitModel.call.training",description:`<strong>training</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to use the model in training mode (some modules like dropout modules have different
behaviors between training and evaluation).`,name:"training"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/beit/modeling_tf_beit.py#L871",returnDescription:`
<p>A <code>transformers.models.beit.modeling_tf_beit.TFBeitModelOutputWithPooling</code> or a tuple of <code>tf.Tensor</code> (if
<code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various elements depending on the
configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitConfig"
>BeitConfig</a>) and inputs.</p>
<ul>
<li><strong>last_hidden_state</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the model.</li>
<li><strong>pooler_output</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, hidden_size)</code>) \u2014 Average of the last layer hidden states of the patch tokens (excluding the <em>[CLS]</em> token) if
<em>config.use_mean_pooling</em> is set to True. If set to False, then the final hidden state of the <em>[CLS]</em> token
will be returned.</li>
<li><strong>hidden_states</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the model at the output of each layer plus
the initial embedding outputs.</li>
<li><strong>attentions</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights after the attention softmax, used to compute the weighted average in
the self-attention heads.</li>
</ul>
`,returnType:`
<p><code>transformers.models.beit.modeling_tf_beit.TFBeitModelOutputWithPooling</code> or <code>tuple(tf.Tensor)</code></p>
`}}),Yo=new He({props:{$$slots:{default:[Bv]},$$scope:{ctx:B}}}),Zo=new gt({props:{anchor:"transformers.TFBeitModel.call.example",$$slots:{default:[Iv]},$$scope:{ctx:B}}}),rn=new ze({}),ln=new L({props:{name:"class transformers.TFBeitForMaskedImageModeling",anchor:"transformers.TFBeitForMaskedImageModeling",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TFBeitForMaskedImageModeling.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitConfig">BeitConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.TFPreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/beit/modeling_tf_beit.py#L922"}}),ts=new He({props:{$$slots:{default:[Mv]},$$scope:{ctx:B}}}),cn=new L({props:{name:"call",anchor:"transformers.TFBeitForMaskedImageModeling.call",parameters:[{name:"pixel_values",val:": typing.Union[typing.List[tensorflow.python.framework.ops.Tensor], typing.List[numpy.ndarray], typing.List[keras.engine.keras_tensor.KerasTensor], typing.Dict[str, tensorflow.python.framework.ops.Tensor], typing.Dict[str, numpy.ndarray], typing.Dict[str, keras.engine.keras_tensor.KerasTensor], tensorflow.python.framework.ops.Tensor, numpy.ndarray, keras.engine.keras_tensor.KerasTensor, NoneType] = None"},{name:"bool_masked_pos",val:": typing.Optional[tensorflow.python.framework.ops.Tensor] = None"},{name:"head_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"labels",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"training",val:": typing.Optional[bool] = False"}],parametersDescription:[{anchor:"transformers.TFBeitForMaskedImageModeling.call.pixel_values",description:`<strong>pixel_values</strong> (<code>np.ndarray</code>, <code>tf.Tensor</code>, <code>List[tf.Tensor]</code> \`<code>Dict[str, tf.Tensor]</code> or <code>Dict[str, np.ndarray]</code> and each example must have the shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Pixel values can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitImageProcessor">BeitImageProcessor</a>. See
<a href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitFeatureExtractor.__call__">BeitImageProcessor.<strong>call</strong>()</a> for details.`,name:"pixel_values"},{anchor:"transformers.TFBeitForMaskedImageModeling.call.head_mask",description:`<strong>head_mask</strong> (<code>np.ndarray</code> or <code>tf.Tensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.TFBeitForMaskedImageModeling.call.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.TFBeitForMaskedImageModeling.call.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.TFBeitForMaskedImageModeling.call.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple. This argument can be used
in eager mode, in graph mode the value will always be set to True.`,name:"return_dict"},{anchor:"transformers.TFBeitForMaskedImageModeling.call.training",description:`<strong>training</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to use the model in training mode (some modules like dropout modules have different
behaviors between training and evaluation).`,name:"training"},{anchor:"transformers.TFBeitForMaskedImageModeling.call.labels",description:`<strong>labels</strong> (<code>tf.Tensor</code> or <code>np.ndarray</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for computing the image classification/regression loss. Indices should be in <code>[0, ..., config.num_labels - 1]</code>. If <code>config.num_labels == 1</code> a regression loss is computed (Mean-Square loss), If
<code>config.num_labels &gt; 1</code> a classification loss is computed (Cross-Entropy).`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/beit/modeling_tf_beit.py#L937",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_tf_outputs.TFMaskedLMOutput"
>transformers.modeling_tf_outputs.TFMaskedLMOutput</a> or a tuple of <code>tf.Tensor</code> (if
<code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various elements depending on the
configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitConfig"
>BeitConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>tf.Tensor</code> of shape <code>(n,)</code>, <em>optional</em>, where n is the number of non-masked labels, returned when <code>labels</code> is provided) \u2014 Masked language modeling (MLM) loss.</p>
</li>
<li>
<p><strong>logits</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head (scores for each vocabulary token before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_tf_outputs.TFMaskedLMOutput"
>transformers.modeling_tf_outputs.TFMaskedLMOutput</a> or <code>tuple(tf.Tensor)</code></p>
`}}),os=new He({props:{$$slots:{default:[Pv]},$$scope:{ctx:B}}}),ss=new gt({props:{anchor:"transformers.TFBeitForMaskedImageModeling.call.example",$$slots:{default:[jv]},$$scope:{ctx:B}}}),pn=new ze({}),mn=new L({props:{name:"class transformers.TFBeitForImageClassification",anchor:"transformers.TFBeitForImageClassification",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TFBeitForImageClassification.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitConfig">BeitConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.TFPreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/beit/modeling_tf_beit.py#L1009"}}),ns=new He({props:{$$slots:{default:[Cv]},$$scope:{ctx:B}}}),fn=new L({props:{name:"call",anchor:"transformers.TFBeitForImageClassification.call",parameters:[{name:"pixel_values",val:": typing.Union[typing.List[tensorflow.python.framework.ops.Tensor], typing.List[numpy.ndarray], typing.List[keras.engine.keras_tensor.KerasTensor], typing.Dict[str, tensorflow.python.framework.ops.Tensor], typing.Dict[str, numpy.ndarray], typing.Dict[str, keras.engine.keras_tensor.KerasTensor], tensorflow.python.framework.ops.Tensor, numpy.ndarray, keras.engine.keras_tensor.KerasTensor, NoneType] = None"},{name:"head_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"labels",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"training",val:": typing.Optional[bool] = False"}],parametersDescription:[{anchor:"transformers.TFBeitForImageClassification.call.pixel_values",description:`<strong>pixel_values</strong> (<code>np.ndarray</code>, <code>tf.Tensor</code>, <code>List[tf.Tensor]</code> \`<code>Dict[str, tf.Tensor]</code> or <code>Dict[str, np.ndarray]</code> and each example must have the shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Pixel values can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitImageProcessor">BeitImageProcessor</a>. See
<a href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitFeatureExtractor.__call__">BeitImageProcessor.<strong>call</strong>()</a> for details.`,name:"pixel_values"},{anchor:"transformers.TFBeitForImageClassification.call.head_mask",description:`<strong>head_mask</strong> (<code>np.ndarray</code> or <code>tf.Tensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.TFBeitForImageClassification.call.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.TFBeitForImageClassification.call.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.TFBeitForImageClassification.call.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple. This argument can be used
in eager mode, in graph mode the value will always be set to True.`,name:"return_dict"},{anchor:"transformers.TFBeitForImageClassification.call.training",description:`<strong>training</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to use the model in training mode (some modules like dropout modules have different
behaviors between training and evaluation).`,name:"training"},{anchor:"transformers.TFBeitForImageClassification.call.labels",description:`<strong>labels</strong> (<code>tf.Tensor</code> or <code>np.ndarray</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for computing the image classification/regression loss. Indices should be in <code>[0, ..., config.num_labels - 1]</code>. If <code>config.num_labels == 1</code> a regression loss is computed (Mean-Square loss), If
<code>config.num_labels &gt; 1</code> a classification loss is computed (Cross-Entropy).`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/beit/modeling_tf_beit.py#L1023",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_tf_outputs.TFSequenceClassifierOutput"
>transformers.modeling_tf_outputs.TFSequenceClassifierOutput</a> or a tuple of <code>tf.Tensor</code> (if
<code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various elements depending on the
configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitConfig"
>BeitConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, )</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Classification (or regression if config.num_labels==1) loss.</p>
</li>
<li>
<p><strong>logits</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, config.num_labels)</code>) \u2014 Classification (or regression if config.num_labels==1) scores (before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_tf_outputs.TFSequenceClassifierOutput"
>transformers.modeling_tf_outputs.TFSequenceClassifierOutput</a> or <code>tuple(tf.Tensor)</code></p>
`}}),rs=new He({props:{$$slots:{default:[Av]},$$scope:{ctx:B}}}),is=new gt({props:{anchor:"transformers.TFBeitForImageClassification.call.example",$$slots:{default:[zv]},$$scope:{ctx:B}}}),un=new ze({}),gn=new L({props:{name:"class transformers.TFBeitForSemanticSegmentation",anchor:"transformers.TFBeitForSemanticSegmentation",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TFBeitForSemanticSegmentation.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitConfig">BeitConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.TFPreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/beit/modeling_tf_beit.py#L1388"}}),ds=new He({props:{$$slots:{default:[Sv]},$$scope:{ctx:B}}}),bn=new L({props:{name:"call",anchor:"transformers.TFBeitForSemanticSegmentation.call",parameters:[{name:"pixel_values",val:": typing.Optional[tensorflow.python.framework.ops.Tensor] = None"},{name:"head_mask",val:": typing.Optional[tensorflow.python.framework.ops.Tensor] = None"},{name:"labels",val:": typing.Optional[tensorflow.python.framework.ops.Tensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.TFBeitForSemanticSegmentation.call.pixel_values",description:`<strong>pixel_values</strong> (<code>np.ndarray</code>, <code>tf.Tensor</code>, <code>List[tf.Tensor]</code> \`<code>Dict[str, tf.Tensor]</code> or <code>Dict[str, np.ndarray]</code> and each example must have the shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Pixel values can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitImageProcessor">BeitImageProcessor</a>. See
<a href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitFeatureExtractor.__call__">BeitImageProcessor.<strong>call</strong>()</a> for details.`,name:"pixel_values"},{anchor:"transformers.TFBeitForSemanticSegmentation.call.head_mask",description:`<strong>head_mask</strong> (<code>np.ndarray</code> or <code>tf.Tensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.TFBeitForSemanticSegmentation.call.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.TFBeitForSemanticSegmentation.call.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.TFBeitForSemanticSegmentation.call.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple. This argument can be used
in eager mode, in graph mode the value will always be set to True.`,name:"return_dict"},{anchor:"transformers.TFBeitForSemanticSegmentation.call.training",description:`<strong>training</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to use the model in training mode (some modules like dropout modules have different
behaviors between training and evaluation).`,name:"training"},{anchor:"transformers.TFBeitForSemanticSegmentation.call.labels",description:`<strong>labels</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, height, width)</code>, <em>optional</em>) &#x2014;
Ground truth semantic segmentation maps for computing the loss. Indices should be in <code>[0, ..., config.num_labels - 1]</code>. If <code>config.num_labels &gt; 1</code>, a classification loss is computed (Cross-Entropy).`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/beit/modeling_tf_beit.py#L1439",returnDescription:`
<p>A <code>transformers.modeling_tf_outputs.TFSemanticSegmenterOutput</code> or a tuple of <code>tf.Tensor</code> (if
<code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various elements depending on the
configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitConfig"
>BeitConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>tf.Tensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Classification (or regression if config.num_labels==1) loss.</p>
</li>
<li>
<p><strong>logits</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, config.num_labels, logits_height, logits_width)</code>) \u2014 Classification scores for each pixel.</p>
<Tip warning={true}>
<p>The logits returned do not necessarily have the same size as the <code>pixel_values</code> passed as inputs. This is
to avoid doing two interpolations and lose some quality when a user needs to resize the logits to the
original image size as post-processing. You should always check your logits shape and resize as needed.</p>
</Tip>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for the output of the embeddings, if the model has an embedding layer, + one for
the output of each layer) of shape <code>(batch_size, patch_size, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for each layer) of shape <code>(batch_size, num_heads, patch_size, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><code>transformers.modeling_tf_outputs.TFSemanticSegmenterOutput</code> or <code>tuple(tf.Tensor)</code></p>
`}}),cs=new He({props:{$$slots:{default:[Dv]},$$scope:{ctx:B}}}),ps=new gt({props:{anchor:"transformers.TFBeitForSemanticSegmentation.call.example",$$slots:{default:[Ov]},$$scope:{ctx:B}}}),{c(){d=n("meta"),v=m(),u=n("h1"),f=n("a"),b=n("span"),w(l.$$.fragment),p=m(),E=n("span"),pe=s("BEiT"),re=m(),F=n("h2"),Y=n("a"),U=n("span"),w(Z.$$.fragment),me=m(),K=n("span"),he=s("Overview"),ie=m(),O=n("p"),fe=s("The BEiT model was proposed in "),ee=n("a"),H=s("BEiT: BERT Pre-Training of Image Transformers"),ue=s(` by
Hangbo Bao, Li Dong and Furu Wei. Inspired by BERT, BEiT is the first paper that makes self-supervised pre-training of
Vision Transformers (ViTs) outperform supervised pre-training. Rather than pre-training the model to predict the class
of an image (as done in the `),te=n("a"),J=s("original ViT paper"),ge=s(`), BEiT models are pre-trained to
predict visual tokens from the codebook of OpenAI\u2019s `),oe=n("a"),_e=s("DALL-E model"),z=s(` given masked
patches.`),le=m(),V=n("p"),be=s("The abstract from the paper is the following:"),de=m(),W=n("p"),ne=n("em"),ve=s(`We introduce a self-supervised vision representation model BEiT, which stands for Bidirectional Encoder representation
from Image Transformers. Following BERT developed in the natural language processing area, we propose a masked image
modeling task to pretrain vision Transformers. Specifically, each image has two views in our pre-training, i.e, image
patches (such as 16x16 pixels), and visual tokens (i.e., discrete tokens). We first \u201Ctokenize\u201D the original image into
visual tokens. Then we randomly mask some image patches and fed them into the backbone Transformer. The pre-training
objective is to recover the original visual tokens based on the corrupted image patches. After pre-training BEiT, we
directly fine-tune the model parameters on downstream tasks by appending task layers upon the pretrained encoder.
Experimental results on image classification and semantic segmentation show that our model achieves competitive results
with previous pre-training methods. For example, base-size BEiT achieves 83.2% top-1 accuracy on ImageNet-1K,
significantly outperforming from-scratch DeiT training (81.8%) with the same setup. Moreover, large-size BEiT obtains
86.3% only using ImageNet-1K, even outperforming ViT-L with supervised pre-training on ImageNet-22K (85.2%).`),A=m(),se=n("p"),G=s("Tips:"),ce=m(),q=n("ul"),j=n("li"),we=s(`BEiT models are regular Vision Transformers, but pre-trained in a self-supervised way rather than supervised. They
outperform both the `),ae=n("a"),C=s("original model (ViT)"),ye=s(" as well as "),R=n("a"),$e=s("Data-efficient Image Transformers (DeiT)"),Te=s(` when fine-tuned on ImageNet-1K and CIFAR-100. You can check out demo notebooks regarding inference as well as
fine-tuning on custom data `),S=n("a"),ke=s("here"),xe=s(` (you can just replace
`),M=n("a"),D=s("ViTFeatureExtractor"),Se=s(" by "),P=n("a"),De=s("BeitImageProcessor"),I=s(` and
`),Ce=n("a"),Oe=s("ViTForImageClassification"),qe=s(" by "),Ae=n("a"),Ne=s("BeitForImageClassification"),X=s(")."),Le=m(),Fe=n("li"),Q=s(`There\u2019s also a demo notebook available which showcases how to combine DALL-E\u2019s image tokenizer with BEiT for
performing masked image modeling. You can find it `),Ee=n("a"),Ve=s("here"),N=s("."),We=m(),Be=n("li"),Vd=s(`As the BEiT models expect each image to be of the same size (resolution), one can use
`),Tn=n("a"),Wd=s("BeitImageProcessor"),Rd=s(" to resize (or rescale) and normalize images for the model."),Ud=m(),zt=n("li"),Kd=s(`Both the patch resolution and image resolution used during pre-training or fine-tuning are reflected in the name of
each checkpoint. For example, `),Er=n("code"),Hd=s("microsoft/beit-base-patch16-224"),Jd=s(` refers to a base-sized architecture with patch
resolution of 16x16 and fine-tuning resolution of 224x224. All checkpoints can be found on the `),Ps=n("a"),Gd=s("hub"),Xd=s("."),Qd=m(),St=n("li"),Yd=s("The available checkpoints are either (1) pre-trained on "),js=n("a"),Zd=s("ImageNet-22k"),ec=s(` (a collection of
14 million images and 22k classes) only, (2) also fine-tuned on ImageNet-22k or (3) also fine-tuned on `),Cs=n("a"),tc=s("ImageNet-1k"),oc=s(` (also referred to as ILSVRC 2012, a collection of 1.3 million
images and 1,000 classes).`),sc=m(),Ze=n("li"),ac=s(`BEiT uses relative position embeddings, inspired by the T5 model. During pre-training, the authors shared the
relative position bias among the several self-attention layers. During fine-tuning, each layer\u2019s relative position
bias is initialized with the shared relative position bias obtained after pre-training. Note that, if one wants to
pre-train a model from scratch, one needs to either set the `),Br=n("code"),nc=s("use_relative_position_bias"),rc=s(` or the
`),Ir=n("code"),ic=s("use_relative_position_bias"),lc=s(" attribute of "),kn=n("a"),dc=s("BeitConfig"),cc=s(" to "),Mr=n("code"),pc=s("True"),mc=s(` in order to add
position embeddings.`),bl=m(),bo=n("img"),vl=m(),As=n("small"),hc=s("BEiT pre-training. Taken from the "),xn=n("a"),fc=s("original paper."),wl=m(),Je=n("p"),uc=s("This model was contributed by "),zs=n("a"),gc=s("nielsr"),_c=s(`. The JAX/FLAX version of this model was
contributed by `),Ss=n("a"),bc=s("kamalkraj"),vc=s(". The TF version of this model was contributed by "),Ds=n("a"),wc=s("MadElf1337"),yc=s(" The original code can be found "),Os=n("a"),$c=s("here"),Tc=s("."),yl=m(),Dt=n("h2"),vo=n("a"),Pr=n("span"),w(qs.$$.fragment),kc=m(),jr=n("span"),xc=s("Resources"),$l=m(),Fn=n("p"),Fc=s("A list of official Hugging Face and community (indicated by \u{1F30E}) resources to help you get started with BEiT."),Tl=m(),w(Ns.$$.fragment),kl=m(),wo=n("ul"),Bt=n("li"),En=n("a"),Ec=s("BeitForImageClassification"),Bc=s(" is supported by this "),Ls=n("a"),Ic=s("example script"),Mc=s(" and "),Vs=n("a"),Pc=s("notebook"),jc=s("."),Cc=m(),Bn=n("li"),Ac=s("See also: "),In=n("a"),zc=s("Image classification task guide"),xl=m(),Mn=n("p"),Cr=n("strong"),Sc=s("Semantic segmentation"),Fl=m(),Pn=n("ul"),Ar=n("li"),jn=n("a"),Dc=s("Semantic segmentation task guide"),El=m(),Cn=n("p"),Oc=s("If you\u2019re interested in submitting a resource to be included here, please feel free to open a Pull Request and we\u2019ll review it! The resource should ideally demonstrate something new instead of duplicating an existing resource."),Bl=m(),Ot=n("h2"),yo=n("a"),zr=n("span"),w(Ws.$$.fragment),qc=m(),Sr=n("span"),Nc=s("BEiT specific outputs"),Il=m(),qt=n("div"),w(Rs.$$.fragment),Lc=m(),Us=n("p"),Vc=s("Class for outputs of "),An=n("a"),Wc=s("BeitModel"),Rc=s("."),Ml=m(),Nt=n("div"),w(Ks.$$.fragment),Uc=m(),Hs=n("p"),Kc=s("Class for outputs of "),zn=n("a"),Hc=s("FlaxBeitModel"),Jc=s("."),Pl=m(),Lt=n("h2"),$o=n("a"),Dr=n("span"),w(Js.$$.fragment),Gc=m(),Or=n("span"),Xc=s("BeitConfig"),jl=m(),vt=n("div"),w(Gs.$$.fragment),Qc=m(),Vt=n("p"),Yc=s("This is the configuration class to store the configuration of a "),Sn=n("a"),Zc=s("BeitModel"),ep=s(`. It is used to instantiate an BEiT
model according to the specified arguments, defining the model architecture. Instantiating a configuration with the
defaults will yield a similar configuration to that of the BEiT
`),Xs=n("a"),tp=s("microsoft/beit-base-patch16-224-pt22k"),op=s(" architecture."),sp=m(),w(To.$$.fragment),Cl=m(),Wt=n("h2"),ko=n("a"),qr=n("span"),w(Qs.$$.fragment),ap=m(),Nr=n("span"),np=s("BeitFeatureExtractor"),Al=m(),wt=n("div"),w(Ys.$$.fragment),rp=m(),Dn=n("div"),w(Zs.$$.fragment),ip=m(),xo=n("div"),w(ea.$$.fragment),lp=m(),ta=n("p"),dp=s("Converts the output of "),On=n("a"),cp=s("BeitForSemanticSegmentation"),pp=s(" into semantic segmentation maps. Only supports PyTorch."),zl=m(),Rt=n("h2"),Fo=n("a"),Lr=n("span"),w(oa.$$.fragment),mp=m(),Vr=n("span"),hp=s("BeitImageProcessor"),Sl=m(),et=n("div"),w(sa.$$.fragment),fp=m(),Wr=n("p"),up=s("Constructs a BEiT image processor."),gp=m(),Eo=n("div"),w(aa.$$.fragment),_p=m(),Rr=n("p"),bp=s("Preprocess an image or batch of images."),vp=m(),Bo=n("div"),w(na.$$.fragment),wp=m(),ra=n("p"),yp=s("Converts the output of "),qn=n("a"),$p=s("BeitForSemanticSegmentation"),Tp=s(" into semantic segmentation maps. Only supports PyTorch."),Dl=m(),Ut=n("h2"),Io=n("a"),Ur=n("span"),w(ia.$$.fragment),kp=m(),Kr=n("span"),xp=s("BeitModel"),Ol=m(),yt=n("div"),w(la.$$.fragment),Fp=m(),da=n("p"),Ep=s(`The bare Beit Model transformer outputting raw hidden-states without any specific head on top.
This model is a PyTorch `),ca=n("a"),Bp=s("torch.nn.Module"),Ip=s(` subclass. Use it
as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Mp=m(),rt=n("div"),w(pa.$$.fragment),Pp=m(),Kt=n("p"),jp=s("The "),Nn=n("a"),Cp=s("BeitModel"),Ap=s(" forward method, overrides the "),Hr=n("code"),zp=s("__call__"),Sp=s(" special method."),Dp=m(),w(Mo.$$.fragment),Op=m(),w(Po.$$.fragment),ql=m(),Ht=n("h2"),jo=n("a"),Jr=n("span"),w(ma.$$.fragment),qp=m(),Gr=n("span"),Np=s("BeitForMaskedImageModeling"),Nl=m(),$t=n("div"),w(ha.$$.fragment),Lp=m(),Tt=n("p"),Vp=s(`Beit Model transformer with a \u2018language\u2019 modeling head on top. BEiT does masked image modeling by predicting
visual tokens of a Vector-Quantize Variational Autoencoder (VQ-VAE), whereas other vision models like ViT and DeiT
predict RGB pixel values. As a result, this class is incompatible with `),Ln=n("a"),Wp=s("AutoModelForMaskedImageModeling"),Rp=s(`, so you
will need to use `),Vn=n("a"),Up=s("BeitForMaskedImageModeling"),Kp=s(` directly if you wish to do masked image modeling with BEiT.
This model is a PyTorch `),fa=n("a"),Hp=s("torch.nn.Module"),Jp=s(` subclass. Use it
as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Gp=m(),it=n("div"),w(ua.$$.fragment),Xp=m(),Jt=n("p"),Qp=s("The "),Wn=n("a"),Yp=s("BeitForMaskedImageModeling"),Zp=s(" forward method, overrides the "),Xr=n("code"),em=s("__call__"),tm=s(" special method."),om=m(),w(Co.$$.fragment),sm=m(),w(Ao.$$.fragment),Ll=m(),Gt=n("h2"),zo=n("a"),Qr=n("span"),w(ga.$$.fragment),am=m(),Yr=n("span"),nm=s("BeitForImageClassification"),Vl=m(),tt=n("div"),w(_a.$$.fragment),rm=m(),Zr=n("p"),im=s(`Beit Model transformer with an image classification head on top (a linear layer on top of the average of the final
hidden states of the patch tokens) e.g. for ImageNet.`),lm=m(),ba=n("p"),dm=s("This model is a PyTorch "),va=n("a"),cm=s("torch.nn.Module"),pm=s(` subclass. Use it
as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),mm=m(),lt=n("div"),w(wa.$$.fragment),hm=m(),Xt=n("p"),fm=s("The "),Rn=n("a"),um=s("BeitForImageClassification"),gm=s(" forward method, overrides the "),ei=n("code"),_m=s("__call__"),bm=s(" special method."),vm=m(),w(So.$$.fragment),wm=m(),w(Do.$$.fragment),Wl=m(),Qt=n("h2"),Oo=n("a"),ti=n("span"),w(ya.$$.fragment),ym=m(),oi=n("span"),$m=s("BeitForSemanticSegmentation"),Rl=m(),ot=n("div"),w($a.$$.fragment),Tm=m(),si=n("p"),km=s("Beit Model transformer with a semantic segmentation head on top e.g. for ADE20k, CityScapes."),xm=m(),Ta=n("p"),Fm=s("This model is a PyTorch "),ka=n("a"),Em=s("torch.nn.Module"),Bm=s(` subclass. Use it
as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Im=m(),dt=n("div"),w(xa.$$.fragment),Mm=m(),Yt=n("p"),Pm=s("The "),Un=n("a"),jm=s("BeitForSemanticSegmentation"),Cm=s(" forward method, overrides the "),ai=n("code"),Am=s("__call__"),zm=s(" special method."),Sm=m(),w(qo.$$.fragment),Dm=m(),w(No.$$.fragment),Ul=m(),Zt=n("h2"),Lo=n("a"),ni=n("span"),w(Fa.$$.fragment),Om=m(),ri=n("span"),qm=s("FlaxBeitModel"),Kl=m(),Ie=n("div"),w(Ea.$$.fragment),Nm=m(),ii=n("p"),Lm=s("The bare Beit Model transformer outputting raw hidden-states without any specific head on top."),Vm=m(),Ba=n("p"),Wm=s("This model inherits from "),Kn=n("a"),Rm=s("FlaxPreTrainedModel"),Um=s(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading, saving and converting weights from PyTorch models)`),Km=m(),Ia=n("p"),Hm=s("This model is also a Flax Linen "),Ma=n("a"),Jm=s("flax.linen.Module"),Gm=s(`
subclass. Use it as a regular Flax linen Module and refer to the Flax documentation for all matter related to
general usage and behavior.`),Xm=m(),li=n("p"),Qm=s("Finally, this model supports inherent JAX features such as:"),Ym=m(),kt=n("ul"),di=n("li"),Pa=n("a"),Zm=s("Just-In-Time (JIT) compilation"),eh=m(),ci=n("li"),ja=n("a"),th=s("Automatic Differentiation"),oh=m(),pi=n("li"),Ca=n("a"),sh=s("Vectorization"),ah=m(),mi=n("li"),Aa=n("a"),nh=s("Parallelization"),rh=m(),ct=n("div"),w(za.$$.fragment),ih=m(),eo=n("p"),lh=s("The "),hi=n("code"),dh=s("FlaxBeitPreTrainedModel"),ch=s(" forward method, overrides the "),fi=n("code"),ph=s("__call__"),mh=s(" special method."),hh=m(),w(Vo.$$.fragment),fh=m(),w(Wo.$$.fragment),Hl=m(),to=n("h2"),Ro=n("a"),ui=n("span"),w(Sa.$$.fragment),uh=m(),gi=n("span"),gh=s("FlaxBeitForMaskedImageModeling"),Jl=m(),Me=n("div"),w(Da.$$.fragment),_h=m(),_i=n("p"),bh=s("Beit Model transformer with a \u2018language\u2019 modeling head on top (to predict visual tokens)."),vh=m(),Oa=n("p"),wh=s("This model inherits from "),Hn=n("a"),yh=s("FlaxPreTrainedModel"),$h=s(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading, saving and converting weights from PyTorch models)`),Th=m(),qa=n("p"),kh=s("This model is also a Flax Linen "),Na=n("a"),xh=s("flax.linen.Module"),Fh=s(`
subclass. Use it as a regular Flax linen Module and refer to the Flax documentation for all matter related to
general usage and behavior.`),Eh=m(),bi=n("p"),Bh=s("Finally, this model supports inherent JAX features such as:"),Ih=m(),xt=n("ul"),vi=n("li"),La=n("a"),Mh=s("Just-In-Time (JIT) compilation"),Ph=m(),wi=n("li"),Va=n("a"),jh=s("Automatic Differentiation"),Ch=m(),yi=n("li"),Wa=n("a"),Ah=s("Vectorization"),zh=m(),$i=n("li"),Ra=n("a"),Sh=s("Parallelization"),Dh=m(),Ge=n("div"),w(Ua.$$.fragment),Oh=m(),oo=n("p"),qh=s("The "),Ti=n("code"),Nh=s("FlaxBeitPreTrainedModel"),Lh=s(" forward method, overrides the "),ki=n("code"),Vh=s("__call__"),Wh=s(" special method."),Rh=m(),w(Uo.$$.fragment),Uh=m(),so=n("p"),Kh=s("bool_masked_pos ("),xi=n("code"),Hh=s("numpy.ndarray"),Jh=s(" of shape "),Fi=n("code"),Gh=s("(batch_size, num_patches)"),Xh=s(`):
Boolean masked positions. Indicates which patches are masked (1) and which aren\u2019t (0).`),Qh=m(),w(Ko.$$.fragment),Gl=m(),ao=n("h2"),Ho=n("a"),Ei=n("span"),w(Ka.$$.fragment),Yh=m(),Bi=n("span"),Zh=s("FlaxBeitForImageClassification"),Xl=m(),Pe=n("div"),w(Ha.$$.fragment),ef=m(),Ii=n("p"),tf=s(`Beit Model transformer with an image classification head on top (a linear layer on top of the average of the final
hidden states of the patch tokens) e.g. for ImageNet.`),of=m(),Ja=n("p"),sf=s("This model inherits from "),Jn=n("a"),af=s("FlaxPreTrainedModel"),nf=s(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading, saving and converting weights from PyTorch models)`),rf=m(),Ga=n("p"),lf=s("This model is also a Flax Linen "),Xa=n("a"),df=s("flax.linen.Module"),cf=s(`
subclass. Use it as a regular Flax linen Module and refer to the Flax documentation for all matter related to
general usage and behavior.`),pf=m(),Mi=n("p"),mf=s("Finally, this model supports inherent JAX features such as:"),hf=m(),Ft=n("ul"),Pi=n("li"),Qa=n("a"),ff=s("Just-In-Time (JIT) compilation"),uf=m(),ji=n("li"),Ya=n("a"),gf=s("Automatic Differentiation"),_f=m(),Ci=n("li"),Za=n("a"),bf=s("Vectorization"),vf=m(),Ai=n("li"),en=n("a"),wf=s("Parallelization"),yf=m(),pt=n("div"),w(tn.$$.fragment),$f=m(),no=n("p"),Tf=s("The "),zi=n("code"),kf=s("FlaxBeitPreTrainedModel"),xf=s(" forward method, overrides the "),Si=n("code"),Ff=s("__call__"),Ef=s(" special method."),Bf=m(),w(Jo.$$.fragment),If=m(),w(Go.$$.fragment),Ql=m(),ro=n("h2"),Xo=n("a"),Di=n("span"),w(on.$$.fragment),Mf=m(),Oi=n("span"),Pf=s("TFBeitModel"),Yl=m(),st=n("div"),w(sn.$$.fragment),jf=m(),io=n("p"),Cf=s(`The bare BEIT Model transformer outputting raw hidden-states without any specific head on top.
This model inherits from `),Gn=n("a"),Af=s("TFPreTrainedModel"),zf=s(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.). This model is also a `),an=n("a"),Sf=s("tf.keras.Model"),Df=s(` subclass.
Use it as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general
usage and behavior.`),Of=m(),w(Qo.$$.fragment),qf=m(),mt=n("div"),w(nn.$$.fragment),Nf=m(),lo=n("p"),Lf=s("The "),Xn=n("a"),Vf=s("TFBeitModel"),Wf=s(" forward method, overrides the "),qi=n("code"),Rf=s("__call__"),Uf=s(" special method."),Kf=m(),w(Yo.$$.fragment),Hf=m(),w(Zo.$$.fragment),Zl=m(),co=n("h2"),es=n("a"),Ni=n("span"),w(rn.$$.fragment),Jf=m(),Li=n("span"),Gf=s("TFBeitForMaskedImageModeling"),ed=m(),at=n("div"),w(ln.$$.fragment),Xf=m(),nt=n("p"),Qf=s(`Beit Model transformer with a \u2018language\u2019 modeling head on top. BEiT does masked image modeling by predicting
visual tokens of a Vector-Quantize Variational Autoencoder (VQ-VAE), whereas other vision models like ViT and DeiT
predict RGB pixel values. As a result, this class is incompatible with `),Qn=n("a"),Yf=s("AutoModelForMaskedImageModeling"),Zf=s(`, so you
will need to use `),Yn=n("a"),eu=s("BeitForMaskedImageModeling"),tu=s(` directly if you wish to do masked image modeling with BEiT.
This model inherits from `),Zn=n("a"),ou=s("TFPreTrainedModel"),su=s(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.). This model is also a `),dn=n("a"),au=s("tf.keras.Model"),nu=s(` subclass.
Use it as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general
usage and behavior.`),ru=m(),w(ts.$$.fragment),iu=m(),ht=n("div"),w(cn.$$.fragment),lu=m(),po=n("p"),du=s("The "),er=n("a"),cu=s("TFBeitForMaskedImageModeling"),pu=s(" forward method, overrides the "),Vi=n("code"),mu=s("__call__"),hu=s(" special method."),fu=m(),w(os.$$.fragment),uu=m(),w(ss.$$.fragment),td=m(),mo=n("h2"),as=n("a"),Wi=n("span"),w(pn.$$.fragment),gu=m(),Ri=n("span"),_u=s("TFBeitForImageClassification"),od=m(),Re=n("div"),w(mn.$$.fragment),bu=m(),Ui=n("p"),vu=s(`Beit Model transformer with an image classification head on top (a linear layer on top of the average of the final
hidden states of the patch tokens) e.g. for ImageNet.`),wu=m(),ho=n("p"),yu=s("This model inherits from "),tr=n("a"),$u=s("TFPreTrainedModel"),Tu=s(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.). This model is also a `),hn=n("a"),ku=s("tf.keras.Model"),xu=s(` subclass.
Use it as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general
usage and behavior.`),Fu=m(),w(ns.$$.fragment),Eu=m(),ft=n("div"),w(fn.$$.fragment),Bu=m(),fo=n("p"),Iu=s("The "),or=n("a"),Mu=s("TFBeitForImageClassification"),Pu=s(" forward method, overrides the "),Ki=n("code"),ju=s("__call__"),Cu=s(" special method."),Au=m(),w(rs.$$.fragment),zu=m(),w(is.$$.fragment),sd=m(),uo=n("h2"),ls=n("a"),Hi=n("span"),w(un.$$.fragment),Su=m(),Ji=n("span"),Du=s("TFBeitForSemanticSegmentation"),ad=m(),Ue=n("div"),w(gn.$$.fragment),Ou=m(),Gi=n("p"),qu=s("Beit Model transformer with a semantic segmentation head on top e.g. for ADE20k, CityScapes."),Nu=m(),go=n("p"),Lu=s("This model inherits from "),sr=n("a"),Vu=s("TFPreTrainedModel"),Wu=s(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.). This model is also a `),_n=n("a"),Ru=s("tf.keras.Model"),Uu=s(` subclass.
Use it as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general
usage and behavior.`),Ku=m(),w(ds.$$.fragment),Hu=m(),ut=n("div"),w(bn.$$.fragment),Ju=m(),_o=n("p"),Gu=s("The "),ar=n("a"),Xu=s("TFBeitForSemanticSegmentation"),Qu=s(" forward method, overrides the "),Xi=n("code"),Yu=s("__call__"),Zu=s(" special method."),eg=m(),w(cs.$$.fragment),tg=m(),w(ps.$$.fragment),this.h()},l(o){const g=lv('[data-svelte="svelte-1phssyn"]',document.head);d=r(g,"META",{name:!0,content:!0}),g.forEach(t),v=h(o),u=r(o,"H1",{class:!0});var vn=i(u);f=r(vn,"A",{id:!0,class:!0,href:!0});var Qi=i(f);b=r(Qi,"SPAN",{});var Yi=i(b);y(l.$$.fragment,Yi),Yi.forEach(t),Qi.forEach(t),p=h(vn),E=r(vn,"SPAN",{});var Zi=i(E);pe=a(Zi,"BEiT"),Zi.forEach(t),vn.forEach(t),re=h(o),F=r(o,"H2",{class:!0});var wn=i(F);Y=r(wn,"A",{id:!0,class:!0,href:!0});var el=i(Y);U=r(el,"SPAN",{});var tl=i(U);y(Z.$$.fragment,tl),tl.forEach(t),el.forEach(t),me=h(wn),K=r(wn,"SPAN",{});var ol=i(K);he=a(ol,"Overview"),ol.forEach(t),wn.forEach(t),ie=h(o),O=r(o,"P",{});var Et=i(O);fe=a(Et,"The BEiT model was proposed in "),ee=r(Et,"A",{href:!0,rel:!0});var sl=i(ee);H=a(sl,"BEiT: BERT Pre-Training of Image Transformers"),sl.forEach(t),ue=a(Et,` by
Hangbo Bao, Li Dong and Furu Wei. Inspired by BERT, BEiT is the first paper that makes self-supervised pre-training of
Vision Transformers (ViTs) outperform supervised pre-training. Rather than pre-training the model to predict the class
of an image (as done in the `),te=r(Et,"A",{href:!0,rel:!0});var al=i(te);J=a(al,"original ViT paper"),al.forEach(t),ge=a(Et,`), BEiT models are pre-trained to
predict visual tokens from the codebook of OpenAI\u2019s `),oe=r(Et,"A",{href:!0,rel:!0});var nl=i(oe);_e=a(nl,"DALL-E model"),nl.forEach(t),z=a(Et,` given masked
patches.`),Et.forEach(t),le=h(o),V=r(o,"P",{});var rl=i(V);be=a(rl,"The abstract from the paper is the following:"),rl.forEach(t),de=h(o),W=r(o,"P",{});var il=i(W);ne=r(il,"EM",{});var ll=i(ne);ve=a(ll,`We introduce a self-supervised vision representation model BEiT, which stands for Bidirectional Encoder representation
from Image Transformers. Following BERT developed in the natural language processing area, we propose a masked image
modeling task to pretrain vision Transformers. Specifically, each image has two views in our pre-training, i.e, image
patches (such as 16x16 pixels), and visual tokens (i.e., discrete tokens). We first \u201Ctokenize\u201D the original image into
visual tokens. Then we randomly mask some image patches and fed them into the backbone Transformer. The pre-training
objective is to recover the original visual tokens based on the corrupted image patches. After pre-training BEiT, we
directly fine-tune the model parameters on downstream tasks by appending task layers upon the pretrained encoder.
Experimental results on image classification and semantic segmentation show that our model achieves competitive results
with previous pre-training methods. For example, base-size BEiT achieves 83.2% top-1 accuracy on ImageNet-1K,
significantly outperforming from-scratch DeiT training (81.8%) with the same setup. Moreover, large-size BEiT obtains
86.3% only using ImageNet-1K, even outperforming ViT-L with supervised pre-training on ImageNet-22K (85.2%).`),ll.forEach(t),il.forEach(t),A=h(o),se=r(o,"P",{});var dl=i(se);G=a(dl,"Tips:"),dl.forEach(t),ce=h(o),q=r(o,"UL",{});var Ke=i(q);j=r(Ke,"LI",{});var je=i(j);we=a(je,`BEiT models are regular Vision Transformers, but pre-trained in a self-supervised way rather than supervised. They
outperform both the `),ae=r(je,"A",{href:!0});var cl=i(ae);C=a(cl,"original model (ViT)"),cl.forEach(t),ye=a(je," as well as "),R=r(je,"A",{href:!0});var pl=i(R);$e=a(pl,"Data-efficient Image Transformers (DeiT)"),pl.forEach(t),Te=a(je,` when fine-tuned on ImageNet-1K and CIFAR-100. You can check out demo notebooks regarding inference as well as
fine-tuning on custom data `),S=r(je,"A",{href:!0,rel:!0});var ml=i(S);ke=a(ml,"here"),ml.forEach(t),xe=a(je,` (you can just replace
`),M=r(je,"A",{href:!0});var hl=i(M);D=a(hl,"ViTFeatureExtractor"),hl.forEach(t),Se=a(je," by "),P=r(je,"A",{href:!0});var fl=i(P);De=a(fl,"BeitImageProcessor"),fl.forEach(t),I=a(je,` and
`),Ce=r(je,"A",{href:!0});var ul=i(Ce);Oe=a(ul,"ViTForImageClassification"),ul.forEach(t),qe=a(je," by "),Ae=r(je,"A",{href:!0});var gl=i(Ae);Ne=a(gl,"BeitForImageClassification"),gl.forEach(t),X=a(je,")."),je.forEach(t),Le=h(Ke),Fe=r(Ke,"LI",{});var yn=i(Fe);Q=a(yn,`There\u2019s also a demo notebook available which showcases how to combine DALL-E\u2019s image tokenizer with BEiT for
performing masked image modeling. You can find it `),Ee=r(yn,"A",{href:!0,rel:!0});var _l=i(Ee);Ve=a(_l,"here"),_l.forEach(t),N=a(yn,"."),yn.forEach(t),We=h(Ke),Be=r(Ke,"LI",{});var rd=i(Be);Vd=a(rd,`As the BEiT models expect each image to be of the same size (resolution), one can use
`),Tn=r(rd,"A",{href:!0});var ng=i(Tn);Wd=a(ng,"BeitImageProcessor"),ng.forEach(t),Rd=a(rd," to resize (or rescale) and normalize images for the model."),rd.forEach(t),Ud=h(Ke),zt=r(Ke,"LI",{});var nr=i(zt);Kd=a(nr,`Both the patch resolution and image resolution used during pre-training or fine-tuning are reflected in the name of
each checkpoint. For example, `),Er=r(nr,"CODE",{});var rg=i(Er);Hd=a(rg,"microsoft/beit-base-patch16-224"),rg.forEach(t),Jd=a(nr,` refers to a base-sized architecture with patch
resolution of 16x16 and fine-tuning resolution of 224x224. All checkpoints can be found on the `),Ps=r(nr,"A",{href:!0,rel:!0});var ig=i(Ps);Gd=a(ig,"hub"),ig.forEach(t),Xd=a(nr,"."),nr.forEach(t),Qd=h(Ke),St=r(Ke,"LI",{});var rr=i(St);Yd=a(rr,"The available checkpoints are either (1) pre-trained on "),js=r(rr,"A",{href:!0,rel:!0});var lg=i(js);Zd=a(lg,"ImageNet-22k"),lg.forEach(t),ec=a(rr,` (a collection of
14 million images and 22k classes) only, (2) also fine-tuned on ImageNet-22k or (3) also fine-tuned on `),Cs=r(rr,"A",{href:!0,rel:!0});var dg=i(Cs);tc=a(dg,"ImageNet-1k"),dg.forEach(t),oc=a(rr,` (also referred to as ILSVRC 2012, a collection of 1.3 million
images and 1,000 classes).`),rr.forEach(t),sc=h(Ke),Ze=r(Ke,"LI",{});var It=i(Ze);ac=a(It,`BEiT uses relative position embeddings, inspired by the T5 model. During pre-training, the authors shared the
relative position bias among the several self-attention layers. During fine-tuning, each layer\u2019s relative position
bias is initialized with the shared relative position bias obtained after pre-training. Note that, if one wants to
pre-train a model from scratch, one needs to either set the `),Br=r(It,"CODE",{});var cg=i(Br);nc=a(cg,"use_relative_position_bias"),cg.forEach(t),rc=a(It,` or the
`),Ir=r(It,"CODE",{});var pg=i(Ir);ic=a(pg,"use_relative_position_bias"),pg.forEach(t),lc=a(It," attribute of "),kn=r(It,"A",{href:!0});var mg=i(kn);dc=a(mg,"BeitConfig"),mg.forEach(t),cc=a(It," to "),Mr=r(It,"CODE",{});var hg=i(Mr);pc=a(hg,"True"),hg.forEach(t),mc=a(It,` in order to add
position embeddings.`),It.forEach(t),Ke.forEach(t),bl=h(o),bo=r(o,"IMG",{src:!0,alt:!0,width:!0}),vl=h(o),As=r(o,"SMALL",{});var og=i(As);hc=a(og,"BEiT pre-training. Taken from the "),xn=r(og,"A",{href:!0});var fg=i(xn);fc=a(fg,"original paper."),fg.forEach(t),og.forEach(t),wl=h(o),Je=r(o,"P",{});var Mt=i(Je);uc=a(Mt,"This model was contributed by "),zs=r(Mt,"A",{href:!0,rel:!0});var ug=i(zs);gc=a(ug,"nielsr"),ug.forEach(t),_c=a(Mt,`. The JAX/FLAX version of this model was
contributed by `),Ss=r(Mt,"A",{href:!0,rel:!0});var gg=i(Ss);bc=a(gg,"kamalkraj"),gg.forEach(t),vc=a(Mt,". The TF version of this model was contributed by "),Ds=r(Mt,"A",{href:!0,rel:!0});var _g=i(Ds);wc=a(_g,"MadElf1337"),_g.forEach(t),yc=a(Mt," The original code can be found "),Os=r(Mt,"A",{href:!0,rel:!0});var bg=i(Os);$c=a(bg,"here"),bg.forEach(t),Tc=a(Mt,"."),Mt.forEach(t),yl=h(o),Dt=r(o,"H2",{class:!0});var id=i(Dt);vo=r(id,"A",{id:!0,class:!0,href:!0});var vg=i(vo);Pr=r(vg,"SPAN",{});var wg=i(Pr);y(qs.$$.fragment,wg),wg.forEach(t),vg.forEach(t),kc=h(id),jr=r(id,"SPAN",{});var yg=i(jr);xc=a(yg,"Resources"),yg.forEach(t),id.forEach(t),$l=h(o),Fn=r(o,"P",{});var $g=i(Fn);Fc=a($g,"A list of official Hugging Face and community (indicated by \u{1F30E}) resources to help you get started with BEiT."),$g.forEach(t),Tl=h(o),y(Ns.$$.fragment,o),kl=h(o),wo=r(o,"UL",{});var ld=i(wo);Bt=r(ld,"LI",{});var $n=i(Bt);En=r($n,"A",{href:!0});var Tg=i(En);Ec=a(Tg,"BeitForImageClassification"),Tg.forEach(t),Bc=a($n," is supported by this "),Ls=r($n,"A",{href:!0,rel:!0});var kg=i(Ls);Ic=a(kg,"example script"),kg.forEach(t),Mc=a($n," and "),Vs=r($n,"A",{href:!0,rel:!0});var xg=i(Vs);Pc=a(xg,"notebook"),xg.forEach(t),jc=a($n,"."),$n.forEach(t),Cc=h(ld),Bn=r(ld,"LI",{});var sg=i(Bn);Ac=a(sg,"See also: "),In=r(sg,"A",{href:!0});var Fg=i(In);zc=a(Fg,"Image classification task guide"),Fg.forEach(t),sg.forEach(t),ld.forEach(t),xl=h(o),Mn=r(o,"P",{});var Eg=i(Mn);Cr=r(Eg,"STRONG",{});var Bg=i(Cr);Sc=a(Bg,"Semantic segmentation"),Bg.forEach(t),Eg.forEach(t),Fl=h(o),Pn=r(o,"UL",{});var Ig=i(Pn);Ar=r(Ig,"LI",{});var Mg=i(Ar);jn=r(Mg,"A",{href:!0});var Pg=i(jn);Dc=a(Pg,"Semantic segmentation task guide"),Pg.forEach(t),Mg.forEach(t),Ig.forEach(t),El=h(o),Cn=r(o,"P",{});var jg=i(Cn);Oc=a(jg,"If you\u2019re interested in submitting a resource to be included here, please feel free to open a Pull Request and we\u2019ll review it! The resource should ideally demonstrate something new instead of duplicating an existing resource."),jg.forEach(t),Bl=h(o),Ot=r(o,"H2",{class:!0});var dd=i(Ot);yo=r(dd,"A",{id:!0,class:!0,href:!0});var Cg=i(yo);zr=r(Cg,"SPAN",{});var Ag=i(zr);y(Ws.$$.fragment,Ag),Ag.forEach(t),Cg.forEach(t),qc=h(dd),Sr=r(dd,"SPAN",{});var zg=i(Sr);Nc=a(zg,"BEiT specific outputs"),zg.forEach(t),dd.forEach(t),Il=h(o),qt=r(o,"DIV",{class:!0});var cd=i(qt);y(Rs.$$.fragment,cd),Lc=h(cd),Us=r(cd,"P",{});var pd=i(Us);Vc=a(pd,"Class for outputs of "),An=r(pd,"A",{href:!0});var Sg=i(An);Wc=a(Sg,"BeitModel"),Sg.forEach(t),Rc=a(pd,"."),pd.forEach(t),cd.forEach(t),Ml=h(o),Nt=r(o,"DIV",{class:!0});var md=i(Nt);y(Ks.$$.fragment,md),Uc=h(md),Hs=r(md,"P",{});var hd=i(Hs);Kc=a(hd,"Class for outputs of "),zn=r(hd,"A",{href:!0});var Dg=i(zn);Hc=a(Dg,"FlaxBeitModel"),Dg.forEach(t),Jc=a(hd,"."),hd.forEach(t),md.forEach(t),Pl=h(o),Lt=r(o,"H2",{class:!0});var fd=i(Lt);$o=r(fd,"A",{id:!0,class:!0,href:!0});var Og=i($o);Dr=r(Og,"SPAN",{});var qg=i(Dr);y(Js.$$.fragment,qg),qg.forEach(t),Og.forEach(t),Gc=h(fd),Or=r(fd,"SPAN",{});var Ng=i(Or);Xc=a(Ng,"BeitConfig"),Ng.forEach(t),fd.forEach(t),jl=h(o),vt=r(o,"DIV",{class:!0});var ir=i(vt);y(Gs.$$.fragment,ir),Qc=h(ir),Vt=r(ir,"P",{});var lr=i(Vt);Yc=a(lr,"This is the configuration class to store the configuration of a "),Sn=r(lr,"A",{href:!0});var Lg=i(Sn);Zc=a(Lg,"BeitModel"),Lg.forEach(t),ep=a(lr,`. It is used to instantiate an BEiT
model according to the specified arguments, defining the model architecture. Instantiating a configuration with the
defaults will yield a similar configuration to that of the BEiT
`),Xs=r(lr,"A",{href:!0,rel:!0});var Vg=i(Xs);tp=a(Vg,"microsoft/beit-base-patch16-224-pt22k"),Vg.forEach(t),op=a(lr," architecture."),lr.forEach(t),sp=h(ir),y(To.$$.fragment,ir),ir.forEach(t),Cl=h(o),Wt=r(o,"H2",{class:!0});var ud=i(Wt);ko=r(ud,"A",{id:!0,class:!0,href:!0});var Wg=i(ko);qr=r(Wg,"SPAN",{});var Rg=i(qr);y(Qs.$$.fragment,Rg),Rg.forEach(t),Wg.forEach(t),ap=h(ud),Nr=r(ud,"SPAN",{});var Ug=i(Nr);np=a(Ug,"BeitFeatureExtractor"),Ug.forEach(t),ud.forEach(t),Al=h(o),wt=r(o,"DIV",{class:!0});var dr=i(wt);y(Ys.$$.fragment,dr),rp=h(dr),Dn=r(dr,"DIV",{class:!0});var Kg=i(Dn);y(Zs.$$.fragment,Kg),Kg.forEach(t),ip=h(dr),xo=r(dr,"DIV",{class:!0});var gd=i(xo);y(ea.$$.fragment,gd),lp=h(gd),ta=r(gd,"P",{});var _d=i(ta);dp=a(_d,"Converts the output of "),On=r(_d,"A",{href:!0});var Hg=i(On);cp=a(Hg,"BeitForSemanticSegmentation"),Hg.forEach(t),pp=a(_d," into semantic segmentation maps. Only supports PyTorch."),_d.forEach(t),gd.forEach(t),dr.forEach(t),zl=h(o),Rt=r(o,"H2",{class:!0});var bd=i(Rt);Fo=r(bd,"A",{id:!0,class:!0,href:!0});var Jg=i(Fo);Lr=r(Jg,"SPAN",{});var Gg=i(Lr);y(oa.$$.fragment,Gg),Gg.forEach(t),Jg.forEach(t),mp=h(bd),Vr=r(bd,"SPAN",{});var Xg=i(Vr);hp=a(Xg,"BeitImageProcessor"),Xg.forEach(t),bd.forEach(t),Sl=h(o),et=r(o,"DIV",{class:!0});var ms=i(et);y(sa.$$.fragment,ms),fp=h(ms),Wr=r(ms,"P",{});var Qg=i(Wr);up=a(Qg,"Constructs a BEiT image processor."),Qg.forEach(t),gp=h(ms),Eo=r(ms,"DIV",{class:!0});var vd=i(Eo);y(aa.$$.fragment,vd),_p=h(vd),Rr=r(vd,"P",{});var Yg=i(Rr);bp=a(Yg,"Preprocess an image or batch of images."),Yg.forEach(t),vd.forEach(t),vp=h(ms),Bo=r(ms,"DIV",{class:!0});var wd=i(Bo);y(na.$$.fragment,wd),wp=h(wd),ra=r(wd,"P",{});var yd=i(ra);yp=a(yd,"Converts the output of "),qn=r(yd,"A",{href:!0});var Zg=i(qn);$p=a(Zg,"BeitForSemanticSegmentation"),Zg.forEach(t),Tp=a(yd," into semantic segmentation maps. Only supports PyTorch."),yd.forEach(t),wd.forEach(t),ms.forEach(t),Dl=h(o),Ut=r(o,"H2",{class:!0});var $d=i(Ut);Io=r($d,"A",{id:!0,class:!0,href:!0});var e_=i(Io);Ur=r(e_,"SPAN",{});var t_=i(Ur);y(ia.$$.fragment,t_),t_.forEach(t),e_.forEach(t),kp=h($d),Kr=r($d,"SPAN",{});var o_=i(Kr);xp=a(o_,"BeitModel"),o_.forEach(t),$d.forEach(t),Ol=h(o),yt=r(o,"DIV",{class:!0});var cr=i(yt);y(la.$$.fragment,cr),Fp=h(cr),da=r(cr,"P",{});var Td=i(da);Ep=a(Td,`The bare Beit Model transformer outputting raw hidden-states without any specific head on top.
This model is a PyTorch `),ca=r(Td,"A",{href:!0,rel:!0});var s_=i(ca);Bp=a(s_,"torch.nn.Module"),s_.forEach(t),Ip=a(Td,` subclass. Use it
as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Td.forEach(t),Mp=h(cr),rt=r(cr,"DIV",{class:!0});var hs=i(rt);y(pa.$$.fragment,hs),Pp=h(hs),Kt=r(hs,"P",{});var pr=i(Kt);jp=a(pr,"The "),Nn=r(pr,"A",{href:!0});var a_=i(Nn);Cp=a(a_,"BeitModel"),a_.forEach(t),Ap=a(pr," forward method, overrides the "),Hr=r(pr,"CODE",{});var n_=i(Hr);zp=a(n_,"__call__"),n_.forEach(t),Sp=a(pr," special method."),pr.forEach(t),Dp=h(hs),y(Mo.$$.fragment,hs),Op=h(hs),y(Po.$$.fragment,hs),hs.forEach(t),cr.forEach(t),ql=h(o),Ht=r(o,"H2",{class:!0});var kd=i(Ht);jo=r(kd,"A",{id:!0,class:!0,href:!0});var r_=i(jo);Jr=r(r_,"SPAN",{});var i_=i(Jr);y(ma.$$.fragment,i_),i_.forEach(t),r_.forEach(t),qp=h(kd),Gr=r(kd,"SPAN",{});var l_=i(Gr);Np=a(l_,"BeitForMaskedImageModeling"),l_.forEach(t),kd.forEach(t),Nl=h(o),$t=r(o,"DIV",{class:!0});var mr=i($t);y(ha.$$.fragment,mr),Lp=h(mr),Tt=r(mr,"P",{});var fs=i(Tt);Vp=a(fs,`Beit Model transformer with a \u2018language\u2019 modeling head on top. BEiT does masked image modeling by predicting
visual tokens of a Vector-Quantize Variational Autoencoder (VQ-VAE), whereas other vision models like ViT and DeiT
predict RGB pixel values. As a result, this class is incompatible with `),Ln=r(fs,"A",{href:!0});var d_=i(Ln);Wp=a(d_,"AutoModelForMaskedImageModeling"),d_.forEach(t),Rp=a(fs,`, so you
will need to use `),Vn=r(fs,"A",{href:!0});var c_=i(Vn);Up=a(c_,"BeitForMaskedImageModeling"),c_.forEach(t),Kp=a(fs,` directly if you wish to do masked image modeling with BEiT.
This model is a PyTorch `),fa=r(fs,"A",{href:!0,rel:!0});var p_=i(fa);Hp=a(p_,"torch.nn.Module"),p_.forEach(t),Jp=a(fs,` subclass. Use it
as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),fs.forEach(t),Gp=h(mr),it=r(mr,"DIV",{class:!0});var us=i(it);y(ua.$$.fragment,us),Xp=h(us),Jt=r(us,"P",{});var hr=i(Jt);Qp=a(hr,"The "),Wn=r(hr,"A",{href:!0});var m_=i(Wn);Yp=a(m_,"BeitForMaskedImageModeling"),m_.forEach(t),Zp=a(hr," forward method, overrides the "),Xr=r(hr,"CODE",{});var h_=i(Xr);em=a(h_,"__call__"),h_.forEach(t),tm=a(hr," special method."),hr.forEach(t),om=h(us),y(Co.$$.fragment,us),sm=h(us),y(Ao.$$.fragment,us),us.forEach(t),mr.forEach(t),Ll=h(o),Gt=r(o,"H2",{class:!0});var xd=i(Gt);zo=r(xd,"A",{id:!0,class:!0,href:!0});var f_=i(zo);Qr=r(f_,"SPAN",{});var u_=i(Qr);y(ga.$$.fragment,u_),u_.forEach(t),f_.forEach(t),am=h(xd),Yr=r(xd,"SPAN",{});var g_=i(Yr);nm=a(g_,"BeitForImageClassification"),g_.forEach(t),xd.forEach(t),Vl=h(o),tt=r(o,"DIV",{class:!0});var gs=i(tt);y(_a.$$.fragment,gs),rm=h(gs),Zr=r(gs,"P",{});var __=i(Zr);im=a(__,`Beit Model transformer with an image classification head on top (a linear layer on top of the average of the final
hidden states of the patch tokens) e.g. for ImageNet.`),__.forEach(t),lm=h(gs),ba=r(gs,"P",{});var Fd=i(ba);dm=a(Fd,"This model is a PyTorch "),va=r(Fd,"A",{href:!0,rel:!0});var b_=i(va);cm=a(b_,"torch.nn.Module"),b_.forEach(t),pm=a(Fd,` subclass. Use it
as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Fd.forEach(t),mm=h(gs),lt=r(gs,"DIV",{class:!0});var _s=i(lt);y(wa.$$.fragment,_s),hm=h(_s),Xt=r(_s,"P",{});var fr=i(Xt);fm=a(fr,"The "),Rn=r(fr,"A",{href:!0});var v_=i(Rn);um=a(v_,"BeitForImageClassification"),v_.forEach(t),gm=a(fr," forward method, overrides the "),ei=r(fr,"CODE",{});var w_=i(ei);_m=a(w_,"__call__"),w_.forEach(t),bm=a(fr," special method."),fr.forEach(t),vm=h(_s),y(So.$$.fragment,_s),wm=h(_s),y(Do.$$.fragment,_s),_s.forEach(t),gs.forEach(t),Wl=h(o),Qt=r(o,"H2",{class:!0});var Ed=i(Qt);Oo=r(Ed,"A",{id:!0,class:!0,href:!0});var y_=i(Oo);ti=r(y_,"SPAN",{});var $_=i(ti);y(ya.$$.fragment,$_),$_.forEach(t),y_.forEach(t),ym=h(Ed),oi=r(Ed,"SPAN",{});var T_=i(oi);$m=a(T_,"BeitForSemanticSegmentation"),T_.forEach(t),Ed.forEach(t),Rl=h(o),ot=r(o,"DIV",{class:!0});var bs=i(ot);y($a.$$.fragment,bs),Tm=h(bs),si=r(bs,"P",{});var k_=i(si);km=a(k_,"Beit Model transformer with a semantic segmentation head on top e.g. for ADE20k, CityScapes."),k_.forEach(t),xm=h(bs),Ta=r(bs,"P",{});var Bd=i(Ta);Fm=a(Bd,"This model is a PyTorch "),ka=r(Bd,"A",{href:!0,rel:!0});var x_=i(ka);Em=a(x_,"torch.nn.Module"),x_.forEach(t),Bm=a(Bd,` subclass. Use it
as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Bd.forEach(t),Im=h(bs),dt=r(bs,"DIV",{class:!0});var vs=i(dt);y(xa.$$.fragment,vs),Mm=h(vs),Yt=r(vs,"P",{});var ur=i(Yt);Pm=a(ur,"The "),Un=r(ur,"A",{href:!0});var F_=i(Un);jm=a(F_,"BeitForSemanticSegmentation"),F_.forEach(t),Cm=a(ur," forward method, overrides the "),ai=r(ur,"CODE",{});var E_=i(ai);Am=a(E_,"__call__"),E_.forEach(t),zm=a(ur," special method."),ur.forEach(t),Sm=h(vs),y(qo.$$.fragment,vs),Dm=h(vs),y(No.$$.fragment,vs),vs.forEach(t),bs.forEach(t),Ul=h(o),Zt=r(o,"H2",{class:!0});var Id=i(Zt);Lo=r(Id,"A",{id:!0,class:!0,href:!0});var B_=i(Lo);ni=r(B_,"SPAN",{});var I_=i(ni);y(Fa.$$.fragment,I_),I_.forEach(t),B_.forEach(t),Om=h(Id),ri=r(Id,"SPAN",{});var M_=i(ri);qm=a(M_,"FlaxBeitModel"),M_.forEach(t),Id.forEach(t),Kl=h(o),Ie=r(o,"DIV",{class:!0});var Xe=i(Ie);y(Ea.$$.fragment,Xe),Nm=h(Xe),ii=r(Xe,"P",{});var P_=i(ii);Lm=a(P_,"The bare Beit Model transformer outputting raw hidden-states without any specific head on top."),P_.forEach(t),Vm=h(Xe),Ba=r(Xe,"P",{});var Md=i(Ba);Wm=a(Md,"This model inherits from "),Kn=r(Md,"A",{href:!0});var j_=i(Kn);Rm=a(j_,"FlaxPreTrainedModel"),j_.forEach(t),Um=a(Md,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading, saving and converting weights from PyTorch models)`),Md.forEach(t),Km=h(Xe),Ia=r(Xe,"P",{});var Pd=i(Ia);Hm=a(Pd,"This model is also a Flax Linen "),Ma=r(Pd,"A",{href:!0,rel:!0});var C_=i(Ma);Jm=a(C_,"flax.linen.Module"),C_.forEach(t),Gm=a(Pd,`
subclass. Use it as a regular Flax linen Module and refer to the Flax documentation for all matter related to
general usage and behavior.`),Pd.forEach(t),Xm=h(Xe),li=r(Xe,"P",{});var A_=i(li);Qm=a(A_,"Finally, this model supports inherent JAX features such as:"),A_.forEach(t),Ym=h(Xe),kt=r(Xe,"UL",{});var ws=i(kt);di=r(ws,"LI",{});var z_=i(di);Pa=r(z_,"A",{href:!0,rel:!0});var S_=i(Pa);Zm=a(S_,"Just-In-Time (JIT) compilation"),S_.forEach(t),z_.forEach(t),eh=h(ws),ci=r(ws,"LI",{});var D_=i(ci);ja=r(D_,"A",{href:!0,rel:!0});var O_=i(ja);th=a(O_,"Automatic Differentiation"),O_.forEach(t),D_.forEach(t),oh=h(ws),pi=r(ws,"LI",{});var q_=i(pi);Ca=r(q_,"A",{href:!0,rel:!0});var N_=i(Ca);sh=a(N_,"Vectorization"),N_.forEach(t),q_.forEach(t),ah=h(ws),mi=r(ws,"LI",{});var L_=i(mi);Aa=r(L_,"A",{href:!0,rel:!0});var V_=i(Aa);nh=a(V_,"Parallelization"),V_.forEach(t),L_.forEach(t),ws.forEach(t),rh=h(Xe),ct=r(Xe,"DIV",{class:!0});var ys=i(ct);y(za.$$.fragment,ys),ih=h(ys),eo=r(ys,"P",{});var gr=i(eo);lh=a(gr,"The "),hi=r(gr,"CODE",{});var W_=i(hi);dh=a(W_,"FlaxBeitPreTrainedModel"),W_.forEach(t),ch=a(gr," forward method, overrides the "),fi=r(gr,"CODE",{});var R_=i(fi);ph=a(R_,"__call__"),R_.forEach(t),mh=a(gr," special method."),gr.forEach(t),hh=h(ys),y(Vo.$$.fragment,ys),fh=h(ys),y(Wo.$$.fragment,ys),ys.forEach(t),Xe.forEach(t),Hl=h(o),to=r(o,"H2",{class:!0});var jd=i(to);Ro=r(jd,"A",{id:!0,class:!0,href:!0});var U_=i(Ro);ui=r(U_,"SPAN",{});var K_=i(ui);y(Sa.$$.fragment,K_),K_.forEach(t),U_.forEach(t),uh=h(jd),gi=r(jd,"SPAN",{});var H_=i(gi);gh=a(H_,"FlaxBeitForMaskedImageModeling"),H_.forEach(t),jd.forEach(t),Jl=h(o),Me=r(o,"DIV",{class:!0});var Qe=i(Me);y(Da.$$.fragment,Qe),_h=h(Qe),_i=r(Qe,"P",{});var J_=i(_i);bh=a(J_,"Beit Model transformer with a \u2018language\u2019 modeling head on top (to predict visual tokens)."),J_.forEach(t),vh=h(Qe),Oa=r(Qe,"P",{});var Cd=i(Oa);wh=a(Cd,"This model inherits from "),Hn=r(Cd,"A",{href:!0});var G_=i(Hn);yh=a(G_,"FlaxPreTrainedModel"),G_.forEach(t),$h=a(Cd,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading, saving and converting weights from PyTorch models)`),Cd.forEach(t),Th=h(Qe),qa=r(Qe,"P",{});var Ad=i(qa);kh=a(Ad,"This model is also a Flax Linen "),Na=r(Ad,"A",{href:!0,rel:!0});var X_=i(Na);xh=a(X_,"flax.linen.Module"),X_.forEach(t),Fh=a(Ad,`
subclass. Use it as a regular Flax linen Module and refer to the Flax documentation for all matter related to
general usage and behavior.`),Ad.forEach(t),Eh=h(Qe),bi=r(Qe,"P",{});var Q_=i(bi);Bh=a(Q_,"Finally, this model supports inherent JAX features such as:"),Q_.forEach(t),Ih=h(Qe),xt=r(Qe,"UL",{});var $s=i(xt);vi=r($s,"LI",{});var Y_=i(vi);La=r(Y_,"A",{href:!0,rel:!0});var Z_=i(La);Mh=a(Z_,"Just-In-Time (JIT) compilation"),Z_.forEach(t),Y_.forEach(t),Ph=h($s),wi=r($s,"LI",{});var eb=i(wi);Va=r(eb,"A",{href:!0,rel:!0});var tb=i(Va);jh=a(tb,"Automatic Differentiation"),tb.forEach(t),eb.forEach(t),Ch=h($s),yi=r($s,"LI",{});var ob=i(yi);Wa=r(ob,"A",{href:!0,rel:!0});var sb=i(Wa);Ah=a(sb,"Vectorization"),sb.forEach(t),ob.forEach(t),zh=h($s),$i=r($s,"LI",{});var ab=i($i);Ra=r(ab,"A",{href:!0,rel:!0});var nb=i(Ra);Sh=a(nb,"Parallelization"),nb.forEach(t),ab.forEach(t),$s.forEach(t),Dh=h(Qe),Ge=r(Qe,"DIV",{class:!0});var Pt=i(Ge);y(Ua.$$.fragment,Pt),Oh=h(Pt),oo=r(Pt,"P",{});var _r=i(oo);qh=a(_r,"The "),Ti=r(_r,"CODE",{});var rb=i(Ti);Nh=a(rb,"FlaxBeitPreTrainedModel"),rb.forEach(t),Lh=a(_r," forward method, overrides the "),ki=r(_r,"CODE",{});var ib=i(ki);Vh=a(ib,"__call__"),ib.forEach(t),Wh=a(_r," special method."),_r.forEach(t),Rh=h(Pt),y(Uo.$$.fragment,Pt),Uh=h(Pt),so=r(Pt,"P",{});var br=i(so);Kh=a(br,"bool_masked_pos ("),xi=r(br,"CODE",{});var lb=i(xi);Hh=a(lb,"numpy.ndarray"),lb.forEach(t),Jh=a(br," of shape "),Fi=r(br,"CODE",{});var db=i(Fi);Gh=a(db,"(batch_size, num_patches)"),db.forEach(t),Xh=a(br,`):
Boolean masked positions. Indicates which patches are masked (1) and which aren\u2019t (0).`),br.forEach(t),Qh=h(Pt),y(Ko.$$.fragment,Pt),Pt.forEach(t),Qe.forEach(t),Gl=h(o),ao=r(o,"H2",{class:!0});var zd=i(ao);Ho=r(zd,"A",{id:!0,class:!0,href:!0});var cb=i(Ho);Ei=r(cb,"SPAN",{});var pb=i(Ei);y(Ka.$$.fragment,pb),pb.forEach(t),cb.forEach(t),Yh=h(zd),Bi=r(zd,"SPAN",{});var mb=i(Bi);Zh=a(mb,"FlaxBeitForImageClassification"),mb.forEach(t),zd.forEach(t),Xl=h(o),Pe=r(o,"DIV",{class:!0});var Ye=i(Pe);y(Ha.$$.fragment,Ye),ef=h(Ye),Ii=r(Ye,"P",{});var hb=i(Ii);tf=a(hb,`Beit Model transformer with an image classification head on top (a linear layer on top of the average of the final
hidden states of the patch tokens) e.g. for ImageNet.`),hb.forEach(t),of=h(Ye),Ja=r(Ye,"P",{});var Sd=i(Ja);sf=a(Sd,"This model inherits from "),Jn=r(Sd,"A",{href:!0});var fb=i(Jn);af=a(fb,"FlaxPreTrainedModel"),fb.forEach(t),nf=a(Sd,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading, saving and converting weights from PyTorch models)`),Sd.forEach(t),rf=h(Ye),Ga=r(Ye,"P",{});var Dd=i(Ga);lf=a(Dd,"This model is also a Flax Linen "),Xa=r(Dd,"A",{href:!0,rel:!0});var ub=i(Xa);df=a(ub,"flax.linen.Module"),ub.forEach(t),cf=a(Dd,`
subclass. Use it as a regular Flax linen Module and refer to the Flax documentation for all matter related to
general usage and behavior.`),Dd.forEach(t),pf=h(Ye),Mi=r(Ye,"P",{});var gb=i(Mi);mf=a(gb,"Finally, this model supports inherent JAX features such as:"),gb.forEach(t),hf=h(Ye),Ft=r(Ye,"UL",{});var Ts=i(Ft);Pi=r(Ts,"LI",{});var _b=i(Pi);Qa=r(_b,"A",{href:!0,rel:!0});var bb=i(Qa);ff=a(bb,"Just-In-Time (JIT) compilation"),bb.forEach(t),_b.forEach(t),uf=h(Ts),ji=r(Ts,"LI",{});var vb=i(ji);Ya=r(vb,"A",{href:!0,rel:!0});var wb=i(Ya);gf=a(wb,"Automatic Differentiation"),wb.forEach(t),vb.forEach(t),_f=h(Ts),Ci=r(Ts,"LI",{});var yb=i(Ci);Za=r(yb,"A",{href:!0,rel:!0});var $b=i(Za);bf=a($b,"Vectorization"),$b.forEach(t),yb.forEach(t),vf=h(Ts),Ai=r(Ts,"LI",{});var Tb=i(Ai);en=r(Tb,"A",{href:!0,rel:!0});var kb=i(en);wf=a(kb,"Parallelization"),kb.forEach(t),Tb.forEach(t),Ts.forEach(t),yf=h(Ye),pt=r(Ye,"DIV",{class:!0});var ks=i(pt);y(tn.$$.fragment,ks),$f=h(ks),no=r(ks,"P",{});var vr=i(no);Tf=a(vr,"The "),zi=r(vr,"CODE",{});var xb=i(zi);kf=a(xb,"FlaxBeitPreTrainedModel"),xb.forEach(t),xf=a(vr," forward method, overrides the "),Si=r(vr,"CODE",{});var Fb=i(Si);Ff=a(Fb,"__call__"),Fb.forEach(t),Ef=a(vr," special method."),vr.forEach(t),Bf=h(ks),y(Jo.$$.fragment,ks),If=h(ks),y(Go.$$.fragment,ks),ks.forEach(t),Ye.forEach(t),Ql=h(o),ro=r(o,"H2",{class:!0});var Od=i(ro);Xo=r(Od,"A",{id:!0,class:!0,href:!0});var Eb=i(Xo);Di=r(Eb,"SPAN",{});var Bb=i(Di);y(on.$$.fragment,Bb),Bb.forEach(t),Eb.forEach(t),Mf=h(Od),Oi=r(Od,"SPAN",{});var Ib=i(Oi);Pf=a(Ib,"TFBeitModel"),Ib.forEach(t),Od.forEach(t),Yl=h(o),st=r(o,"DIV",{class:!0});var xs=i(st);y(sn.$$.fragment,xs),jf=h(xs),io=r(xs,"P",{});var wr=i(io);Cf=a(wr,`The bare BEIT Model transformer outputting raw hidden-states without any specific head on top.
This model inherits from `),Gn=r(wr,"A",{href:!0});var Mb=i(Gn);Af=a(Mb,"TFPreTrainedModel"),Mb.forEach(t),zf=a(wr,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.). This model is also a `),an=r(wr,"A",{href:!0,rel:!0});var Pb=i(an);Sf=a(Pb,"tf.keras.Model"),Pb.forEach(t),Df=a(wr,` subclass.
Use it as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general
usage and behavior.`),wr.forEach(t),Of=h(xs),y(Qo.$$.fragment,xs),qf=h(xs),mt=r(xs,"DIV",{class:!0});var Fs=i(mt);y(nn.$$.fragment,Fs),Nf=h(Fs),lo=r(Fs,"P",{});var yr=i(lo);Lf=a(yr,"The "),Xn=r(yr,"A",{href:!0});var jb=i(Xn);Vf=a(jb,"TFBeitModel"),jb.forEach(t),Wf=a(yr," forward method, overrides the "),qi=r(yr,"CODE",{});var Cb=i(qi);Rf=a(Cb,"__call__"),Cb.forEach(t),Uf=a(yr," special method."),yr.forEach(t),Kf=h(Fs),y(Yo.$$.fragment,Fs),Hf=h(Fs),y(Zo.$$.fragment,Fs),Fs.forEach(t),xs.forEach(t),Zl=h(o),co=r(o,"H2",{class:!0});var qd=i(co);es=r(qd,"A",{id:!0,class:!0,href:!0});var Ab=i(es);Ni=r(Ab,"SPAN",{});var zb=i(Ni);y(rn.$$.fragment,zb),zb.forEach(t),Ab.forEach(t),Jf=h(qd),Li=r(qd,"SPAN",{});var Sb=i(Li);Gf=a(Sb,"TFBeitForMaskedImageModeling"),Sb.forEach(t),qd.forEach(t),ed=h(o),at=r(o,"DIV",{class:!0});var Es=i(at);y(ln.$$.fragment,Es),Xf=h(Es),nt=r(Es,"P",{});var jt=i(nt);Qf=a(jt,`Beit Model transformer with a \u2018language\u2019 modeling head on top. BEiT does masked image modeling by predicting
visual tokens of a Vector-Quantize Variational Autoencoder (VQ-VAE), whereas other vision models like ViT and DeiT
predict RGB pixel values. As a result, this class is incompatible with `),Qn=r(jt,"A",{href:!0});var Db=i(Qn);Yf=a(Db,"AutoModelForMaskedImageModeling"),Db.forEach(t),Zf=a(jt,`, so you
will need to use `),Yn=r(jt,"A",{href:!0});var Ob=i(Yn);eu=a(Ob,"BeitForMaskedImageModeling"),Ob.forEach(t),tu=a(jt,` directly if you wish to do masked image modeling with BEiT.
This model inherits from `),Zn=r(jt,"A",{href:!0});var qb=i(Zn);ou=a(qb,"TFPreTrainedModel"),qb.forEach(t),su=a(jt,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.). This model is also a `),dn=r(jt,"A",{href:!0,rel:!0});var Nb=i(dn);au=a(Nb,"tf.keras.Model"),Nb.forEach(t),nu=a(jt,` subclass.
Use it as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general
usage and behavior.`),jt.forEach(t),ru=h(Es),y(ts.$$.fragment,Es),iu=h(Es),ht=r(Es,"DIV",{class:!0});var Bs=i(ht);y(cn.$$.fragment,Bs),lu=h(Bs),po=r(Bs,"P",{});var $r=i(po);du=a($r,"The "),er=r($r,"A",{href:!0});var Lb=i(er);cu=a(Lb,"TFBeitForMaskedImageModeling"),Lb.forEach(t),pu=a($r," forward method, overrides the "),Vi=r($r,"CODE",{});var Vb=i(Vi);mu=a(Vb,"__call__"),Vb.forEach(t),hu=a($r," special method."),$r.forEach(t),fu=h(Bs),y(os.$$.fragment,Bs),uu=h(Bs),y(ss.$$.fragment,Bs),Bs.forEach(t),Es.forEach(t),td=h(o),mo=r(o,"H2",{class:!0});var Nd=i(mo);as=r(Nd,"A",{id:!0,class:!0,href:!0});var Wb=i(as);Wi=r(Wb,"SPAN",{});var Rb=i(Wi);y(pn.$$.fragment,Rb),Rb.forEach(t),Wb.forEach(t),gu=h(Nd),Ri=r(Nd,"SPAN",{});var Ub=i(Ri);_u=a(Ub,"TFBeitForImageClassification"),Ub.forEach(t),Nd.forEach(t),od=h(o),Re=r(o,"DIV",{class:!0});var Ct=i(Re);y(mn.$$.fragment,Ct),bu=h(Ct),Ui=r(Ct,"P",{});var Kb=i(Ui);vu=a(Kb,`Beit Model transformer with an image classification head on top (a linear layer on top of the average of the final
hidden states of the patch tokens) e.g. for ImageNet.`),Kb.forEach(t),wu=h(Ct),ho=r(Ct,"P",{});var Tr=i(ho);yu=a(Tr,"This model inherits from "),tr=r(Tr,"A",{href:!0});var Hb=i(tr);$u=a(Hb,"TFPreTrainedModel"),Hb.forEach(t),Tu=a(Tr,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.). This model is also a `),hn=r(Tr,"A",{href:!0,rel:!0});var Jb=i(hn);ku=a(Jb,"tf.keras.Model"),Jb.forEach(t),xu=a(Tr,` subclass.
Use it as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general
usage and behavior.`),Tr.forEach(t),Fu=h(Ct),y(ns.$$.fragment,Ct),Eu=h(Ct),ft=r(Ct,"DIV",{class:!0});var Is=i(ft);y(fn.$$.fragment,Is),Bu=h(Is),fo=r(Is,"P",{});var kr=i(fo);Iu=a(kr,"The "),or=r(kr,"A",{href:!0});var Gb=i(or);Mu=a(Gb,"TFBeitForImageClassification"),Gb.forEach(t),Pu=a(kr," forward method, overrides the "),Ki=r(kr,"CODE",{});var Xb=i(Ki);ju=a(Xb,"__call__"),Xb.forEach(t),Cu=a(kr," special method."),kr.forEach(t),Au=h(Is),y(rs.$$.fragment,Is),zu=h(Is),y(is.$$.fragment,Is),Is.forEach(t),Ct.forEach(t),sd=h(o),uo=r(o,"H2",{class:!0});var Ld=i(uo);ls=r(Ld,"A",{id:!0,class:!0,href:!0});var Qb=i(ls);Hi=r(Qb,"SPAN",{});var Yb=i(Hi);y(un.$$.fragment,Yb),Yb.forEach(t),Qb.forEach(t),Su=h(Ld),Ji=r(Ld,"SPAN",{});var Zb=i(Ji);Du=a(Zb,"TFBeitForSemanticSegmentation"),Zb.forEach(t),Ld.forEach(t),ad=h(o),Ue=r(o,"DIV",{class:!0});var At=i(Ue);y(gn.$$.fragment,At),Ou=h(At),Gi=r(At,"P",{});var ev=i(Gi);qu=a(ev,"Beit Model transformer with a semantic segmentation head on top e.g. for ADE20k, CityScapes."),ev.forEach(t),Nu=h(At),go=r(At,"P",{});var xr=i(go);Lu=a(xr,"This model inherits from "),sr=r(xr,"A",{href:!0});var tv=i(sr);Vu=a(tv,"TFPreTrainedModel"),tv.forEach(t),Wu=a(xr,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.). This model is also a `),_n=r(xr,"A",{href:!0,rel:!0});var ov=i(_n);Ru=a(ov,"tf.keras.Model"),ov.forEach(t),Uu=a(xr,` subclass.
Use it as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general
usage and behavior.`),xr.forEach(t),Ku=h(At),y(ds.$$.fragment,At),Hu=h(At),ut=r(At,"DIV",{class:!0});var Ms=i(ut);y(bn.$$.fragment,Ms),Ju=h(Ms),_o=r(Ms,"P",{});var Fr=i(_o);Gu=a(Fr,"The "),ar=r(Fr,"A",{href:!0});var sv=i(ar);Xu=a(sv,"TFBeitForSemanticSegmentation"),sv.forEach(t),Qu=a(Fr," forward method, overrides the "),Xi=r(Fr,"CODE",{});var av=i(Xi);Yu=a(av,"__call__"),av.forEach(t),Zu=a(Fr," special method."),Fr.forEach(t),eg=h(Ms),y(cs.$$.fragment,Ms),tg=h(Ms),y(ps.$$.fragment,Ms),Ms.forEach(t),At.forEach(t),this.h()},h(){c(d,"name","hf:doc:metadata"),c(d,"content",JSON.stringify(Nv)),c(f,"id","beit"),c(f,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(f,"href","#beit"),c(u,"class","relative group"),c(Y,"id","overview"),c(Y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Y,"href","#overview"),c(F,"class","relative group"),c(ee,"href","https://arxiv.org/abs/2106.08254"),c(ee,"rel","nofollow"),c(te,"href","https://arxiv.org/abs/2010.11929"),c(te,"rel","nofollow"),c(oe,"href","https://arxiv.org/abs/2102.12092"),c(oe,"rel","nofollow"),c(ae,"href","vit"),c(R,"href","deit"),c(S,"href","https://github.com/NielsRogge/Transformers-Tutorials/tree/master/VisionTransformer"),c(S,"rel","nofollow"),c(M,"href","/docs/transformers/pr_18559/en/model_doc/vit#transformers.ViTFeatureExtractor"),c(P,"href","/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitImageProcessor"),c(Ce,"href","/docs/transformers/pr_18559/en/model_doc/vit#transformers.ViTForImageClassification"),c(Ae,"href","/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitForImageClassification"),c(Ee,"href","https://github.com/NielsRogge/Transformers-Tutorials/tree/master/BEiT"),c(Ee,"rel","nofollow"),c(Tn,"href","/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitImageProcessor"),c(Ps,"href","https://huggingface.co/models?search=microsoft/beit"),c(Ps,"rel","nofollow"),c(js,"href","http://www.image-net.org/"),c(js,"rel","nofollow"),c(Cs,"href","http://www.image-net.org/challenges/LSVRC/2012/"),c(Cs,"rel","nofollow"),c(kn,"href","/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitConfig"),dv(bo.src,ag="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/transformers/model_doc/beit_architecture.jpg")||c(bo,"src",ag),c(bo,"alt","drawing"),c(bo,"width","600"),c(xn,"href","https://arxiv.org/abs/2106.08254"),c(zs,"href","https://huggingface.co/nielsr"),c(zs,"rel","nofollow"),c(Ss,"href","https://huggingface.co/kamalkraj"),c(Ss,"rel","nofollow"),c(Ds,"href","https://huggingface.co/MadElf1337"),c(Ds,"rel","nofollow"),c(Os,"href","https://github.com/microsoft/unilm/tree/master/beit"),c(Os,"rel","nofollow"),c(vo,"id","resources"),c(vo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(vo,"href","#resources"),c(Dt,"class","relative group"),c(En,"href","/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitForImageClassification"),c(Ls,"href","https://github.com/huggingface/transformers/tree/main/examples/pytorch/image-classification"),c(Ls,"rel","nofollow"),c(Vs,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/examples/image_classification.ipynb"),c(Vs,"rel","nofollow"),c(In,"href","../tasks/image_classification"),c(jn,"href","../tasks/semantic_segmentation"),c(yo,"id","transformers.models.beit.modeling_beit.BeitModelOutputWithPooling"),c(yo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(yo,"href","#transformers.models.beit.modeling_beit.BeitModelOutputWithPooling"),c(Ot,"class","relative group"),c(An,"href","/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitModel"),c(qt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(zn,"href","/docs/transformers/pr_18559/en/model_doc/beit#transformers.FlaxBeitModel"),c(Nt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c($o,"id","transformers.BeitConfig"),c($o,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c($o,"href","#transformers.BeitConfig"),c(Lt,"class","relative group"),c(Sn,"href","/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitModel"),c(Xs,"href","https://huggingface.co/microsoft/beit-base-patch16-224-pt22k"),c(Xs,"rel","nofollow"),c(vt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ko,"id","transformers.BeitFeatureExtractor"),c(ko,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(ko,"href","#transformers.BeitFeatureExtractor"),c(Wt,"class","relative group"),c(Dn,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(On,"href","/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitForSemanticSegmentation"),c(xo,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(wt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Fo,"id","transformers.BeitImageProcessor"),c(Fo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Fo,"href","#transformers.BeitImageProcessor"),c(Rt,"class","relative group"),c(Eo,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(qn,"href","/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitForSemanticSegmentation"),c(Bo,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(et,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Io,"id","transformers.BeitModel"),c(Io,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Io,"href","#transformers.BeitModel"),c(Ut,"class","relative group"),c(ca,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),c(ca,"rel","nofollow"),c(Nn,"href","/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitModel"),c(rt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(yt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(jo,"id","transformers.BeitForMaskedImageModeling"),c(jo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(jo,"href","#transformers.BeitForMaskedImageModeling"),c(Ht,"class","relative group"),c(Ln,"href","/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoModelForMaskedImageModeling"),c(Vn,"href","/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitForMaskedImageModeling"),c(fa,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),c(fa,"rel","nofollow"),c(Wn,"href","/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitForMaskedImageModeling"),c(it,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c($t,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(zo,"id","transformers.BeitForImageClassification"),c(zo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(zo,"href","#transformers.BeitForImageClassification"),c(Gt,"class","relative group"),c(va,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),c(va,"rel","nofollow"),c(Rn,"href","/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitForImageClassification"),c(lt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(tt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Oo,"id","transformers.BeitForSemanticSegmentation"),c(Oo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Oo,"href","#transformers.BeitForSemanticSegmentation"),c(Qt,"class","relative group"),c(ka,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),c(ka,"rel","nofollow"),c(Un,"href","/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitForSemanticSegmentation"),c(dt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ot,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Lo,"id","transformers.FlaxBeitModel"),c(Lo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Lo,"href","#transformers.FlaxBeitModel"),c(Zt,"class","relative group"),c(Kn,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel"),c(Ma,"href","https://flax.readthedocs.io/en/latest/flax.linen.html#module"),c(Ma,"rel","nofollow"),c(Pa,"href","https://jax.readthedocs.io/en/latest/jax.html#just-in-time-compilation-jit"),c(Pa,"rel","nofollow"),c(ja,"href","https://jax.readthedocs.io/en/latest/jax.html#automatic-differentiation"),c(ja,"rel","nofollow"),c(Ca,"href","https://jax.readthedocs.io/en/latest/jax.html#vectorization-vmap"),c(Ca,"rel","nofollow"),c(Aa,"href","https://jax.readthedocs.io/en/latest/jax.html#parallelization-pmap"),c(Aa,"rel","nofollow"),c(ct,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Ie,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Ro,"id","transformers.FlaxBeitForMaskedImageModeling"),c(Ro,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Ro,"href","#transformers.FlaxBeitForMaskedImageModeling"),c(to,"class","relative group"),c(Hn,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel"),c(Na,"href","https://flax.readthedocs.io/en/latest/flax.linen.html#module"),c(Na,"rel","nofollow"),c(La,"href","https://jax.readthedocs.io/en/latest/jax.html#just-in-time-compilation-jit"),c(La,"rel","nofollow"),c(Va,"href","https://jax.readthedocs.io/en/latest/jax.html#automatic-differentiation"),c(Va,"rel","nofollow"),c(Wa,"href","https://jax.readthedocs.io/en/latest/jax.html#vectorization-vmap"),c(Wa,"rel","nofollow"),c(Ra,"href","https://jax.readthedocs.io/en/latest/jax.html#parallelization-pmap"),c(Ra,"rel","nofollow"),c(Ge,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Me,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Ho,"id","transformers.FlaxBeitForImageClassification"),c(Ho,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Ho,"href","#transformers.FlaxBeitForImageClassification"),c(ao,"class","relative group"),c(Jn,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel"),c(Xa,"href","https://flax.readthedocs.io/en/latest/flax.linen.html#module"),c(Xa,"rel","nofollow"),c(Qa,"href","https://jax.readthedocs.io/en/latest/jax.html#just-in-time-compilation-jit"),c(Qa,"rel","nofollow"),c(Ya,"href","https://jax.readthedocs.io/en/latest/jax.html#automatic-differentiation"),c(Ya,"rel","nofollow"),c(Za,"href","https://jax.readthedocs.io/en/latest/jax.html#vectorization-vmap"),c(Za,"rel","nofollow"),c(en,"href","https://jax.readthedocs.io/en/latest/jax.html#parallelization-pmap"),c(en,"rel","nofollow"),c(pt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Pe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Xo,"id","transformers.TFBeitModel"),c(Xo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Xo,"href","#transformers.TFBeitModel"),c(ro,"class","relative group"),c(Gn,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.TFPreTrainedModel"),c(an,"href","https://www.tensorflow.org/api_docs/python/tf/keras/Model"),c(an,"rel","nofollow"),c(Xn,"href","/docs/transformers/pr_18559/en/model_doc/beit#transformers.TFBeitModel"),c(mt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(st,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(es,"id","transformers.TFBeitForMaskedImageModeling"),c(es,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(es,"href","#transformers.TFBeitForMaskedImageModeling"),c(co,"class","relative group"),c(Qn,"href","/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoModelForMaskedImageModeling"),c(Yn,"href","/docs/transformers/pr_18559/en/model_doc/beit#transformers.BeitForMaskedImageModeling"),c(Zn,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.TFPreTrainedModel"),c(dn,"href","https://www.tensorflow.org/api_docs/python/tf/keras/Model"),c(dn,"rel","nofollow"),c(er,"href","/docs/transformers/pr_18559/en/model_doc/beit#transformers.TFBeitForMaskedImageModeling"),c(ht,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(at,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(as,"id","transformers.TFBeitForImageClassification"),c(as,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(as,"href","#transformers.TFBeitForImageClassification"),c(mo,"class","relative group"),c(tr,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.TFPreTrainedModel"),c(hn,"href","https://www.tensorflow.org/api_docs/python/tf/keras/Model"),c(hn,"rel","nofollow"),c(or,"href","/docs/transformers/pr_18559/en/model_doc/beit#transformers.TFBeitForImageClassification"),c(ft,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Re,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ls,"id","transformers.TFBeitForSemanticSegmentation"),c(ls,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(ls,"href","#transformers.TFBeitForSemanticSegmentation"),c(uo,"class","relative group"),c(sr,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.TFPreTrainedModel"),c(_n,"href","https://www.tensorflow.org/api_docs/python/tf/keras/Model"),c(_n,"rel","nofollow"),c(ar,"href","/docs/transformers/pr_18559/en/model_doc/beit#transformers.TFBeitForSemanticSegmentation"),c(ut,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Ue,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(o,g){e(document.head,d),_(o,v,g),_(o,u,g),e(u,f),e(f,b),$(l,b,null),e(u,p),e(u,E),e(E,pe),_(o,re,g),_(o,F,g),e(F,Y),e(Y,U),$(Z,U,null),e(F,me),e(F,K),e(K,he),_(o,ie,g),_(o,O,g),e(O,fe),e(O,ee),e(ee,H),e(O,ue),e(O,te),e(te,J),e(O,ge),e(O,oe),e(oe,_e),e(O,z),_(o,le,g),_(o,V,g),e(V,be),_(o,de,g),_(o,W,g),e(W,ne),e(ne,ve),_(o,A,g),_(o,se,g),e(se,G),_(o,ce,g),_(o,q,g),e(q,j),e(j,we),e(j,ae),e(ae,C),e(j,ye),e(j,R),e(R,$e),e(j,Te),e(j,S),e(S,ke),e(j,xe),e(j,M),e(M,D),e(j,Se),e(j,P),e(P,De),e(j,I),e(j,Ce),e(Ce,Oe),e(j,qe),e(j,Ae),e(Ae,Ne),e(j,X),e(q,Le),e(q,Fe),e(Fe,Q),e(Fe,Ee),e(Ee,Ve),e(Fe,N),e(q,We),e(q,Be),e(Be,Vd),e(Be,Tn),e(Tn,Wd),e(Be,Rd),e(q,Ud),e(q,zt),e(zt,Kd),e(zt,Er),e(Er,Hd),e(zt,Jd),e(zt,Ps),e(Ps,Gd),e(zt,Xd),e(q,Qd),e(q,St),e(St,Yd),e(St,js),e(js,Zd),e(St,ec),e(St,Cs),e(Cs,tc),e(St,oc),e(q,sc),e(q,Ze),e(Ze,ac),e(Ze,Br),e(Br,nc),e(Ze,rc),e(Ze,Ir),e(Ir,ic),e(Ze,lc),e(Ze,kn),e(kn,dc),e(Ze,cc),e(Ze,Mr),e(Mr,pc),e(Ze,mc),_(o,bl,g),_(o,bo,g),_(o,vl,g),_(o,As,g),e(As,hc),e(As,xn),e(xn,fc),_(o,wl,g),_(o,Je,g),e(Je,uc),e(Je,zs),e(zs,gc),e(Je,_c),e(Je,Ss),e(Ss,bc),e(Je,vc),e(Je,Ds),e(Ds,wc),e(Je,yc),e(Je,Os),e(Os,$c),e(Je,Tc),_(o,yl,g),_(o,Dt,g),e(Dt,vo),e(vo,Pr),$(qs,Pr,null),e(Dt,kc),e(Dt,jr),e(jr,xc),_(o,$l,g),_(o,Fn,g),e(Fn,Fc),_(o,Tl,g),$(Ns,o,g),_(o,kl,g),_(o,wo,g),e(wo,Bt),e(Bt,En),e(En,Ec),e(Bt,Bc),e(Bt,Ls),e(Ls,Ic),e(Bt,Mc),e(Bt,Vs),e(Vs,Pc),e(Bt,jc),e(wo,Cc),e(wo,Bn),e(Bn,Ac),e(Bn,In),e(In,zc),_(o,xl,g),_(o,Mn,g),e(Mn,Cr),e(Cr,Sc),_(o,Fl,g),_(o,Pn,g),e(Pn,Ar),e(Ar,jn),e(jn,Dc),_(o,El,g),_(o,Cn,g),e(Cn,Oc),_(o,Bl,g),_(o,Ot,g),e(Ot,yo),e(yo,zr),$(Ws,zr,null),e(Ot,qc),e(Ot,Sr),e(Sr,Nc),_(o,Il,g),_(o,qt,g),$(Rs,qt,null),e(qt,Lc),e(qt,Us),e(Us,Vc),e(Us,An),e(An,Wc),e(Us,Rc),_(o,Ml,g),_(o,Nt,g),$(Ks,Nt,null),e(Nt,Uc),e(Nt,Hs),e(Hs,Kc),e(Hs,zn),e(zn,Hc),e(Hs,Jc),_(o,Pl,g),_(o,Lt,g),e(Lt,$o),e($o,Dr),$(Js,Dr,null),e(Lt,Gc),e(Lt,Or),e(Or,Xc),_(o,jl,g),_(o,vt,g),$(Gs,vt,null),e(vt,Qc),e(vt,Vt),e(Vt,Yc),e(Vt,Sn),e(Sn,Zc),e(Vt,ep),e(Vt,Xs),e(Xs,tp),e(Vt,op),e(vt,sp),$(To,vt,null),_(o,Cl,g),_(o,Wt,g),e(Wt,ko),e(ko,qr),$(Qs,qr,null),e(Wt,ap),e(Wt,Nr),e(Nr,np),_(o,Al,g),_(o,wt,g),$(Ys,wt,null),e(wt,rp),e(wt,Dn),$(Zs,Dn,null),e(wt,ip),e(wt,xo),$(ea,xo,null),e(xo,lp),e(xo,ta),e(ta,dp),e(ta,On),e(On,cp),e(ta,pp),_(o,zl,g),_(o,Rt,g),e(Rt,Fo),e(Fo,Lr),$(oa,Lr,null),e(Rt,mp),e(Rt,Vr),e(Vr,hp),_(o,Sl,g),_(o,et,g),$(sa,et,null),e(et,fp),e(et,Wr),e(Wr,up),e(et,gp),e(et,Eo),$(aa,Eo,null),e(Eo,_p),e(Eo,Rr),e(Rr,bp),e(et,vp),e(et,Bo),$(na,Bo,null),e(Bo,wp),e(Bo,ra),e(ra,yp),e(ra,qn),e(qn,$p),e(ra,Tp),_(o,Dl,g),_(o,Ut,g),e(Ut,Io),e(Io,Ur),$(ia,Ur,null),e(Ut,kp),e(Ut,Kr),e(Kr,xp),_(o,Ol,g),_(o,yt,g),$(la,yt,null),e(yt,Fp),e(yt,da),e(da,Ep),e(da,ca),e(ca,Bp),e(da,Ip),e(yt,Mp),e(yt,rt),$(pa,rt,null),e(rt,Pp),e(rt,Kt),e(Kt,jp),e(Kt,Nn),e(Nn,Cp),e(Kt,Ap),e(Kt,Hr),e(Hr,zp),e(Kt,Sp),e(rt,Dp),$(Mo,rt,null),e(rt,Op),$(Po,rt,null),_(o,ql,g),_(o,Ht,g),e(Ht,jo),e(jo,Jr),$(ma,Jr,null),e(Ht,qp),e(Ht,Gr),e(Gr,Np),_(o,Nl,g),_(o,$t,g),$(ha,$t,null),e($t,Lp),e($t,Tt),e(Tt,Vp),e(Tt,Ln),e(Ln,Wp),e(Tt,Rp),e(Tt,Vn),e(Vn,Up),e(Tt,Kp),e(Tt,fa),e(fa,Hp),e(Tt,Jp),e($t,Gp),e($t,it),$(ua,it,null),e(it,Xp),e(it,Jt),e(Jt,Qp),e(Jt,Wn),e(Wn,Yp),e(Jt,Zp),e(Jt,Xr),e(Xr,em),e(Jt,tm),e(it,om),$(Co,it,null),e(it,sm),$(Ao,it,null),_(o,Ll,g),_(o,Gt,g),e(Gt,zo),e(zo,Qr),$(ga,Qr,null),e(Gt,am),e(Gt,Yr),e(Yr,nm),_(o,Vl,g),_(o,tt,g),$(_a,tt,null),e(tt,rm),e(tt,Zr),e(Zr,im),e(tt,lm),e(tt,ba),e(ba,dm),e(ba,va),e(va,cm),e(ba,pm),e(tt,mm),e(tt,lt),$(wa,lt,null),e(lt,hm),e(lt,Xt),e(Xt,fm),e(Xt,Rn),e(Rn,um),e(Xt,gm),e(Xt,ei),e(ei,_m),e(Xt,bm),e(lt,vm),$(So,lt,null),e(lt,wm),$(Do,lt,null),_(o,Wl,g),_(o,Qt,g),e(Qt,Oo),e(Oo,ti),$(ya,ti,null),e(Qt,ym),e(Qt,oi),e(oi,$m),_(o,Rl,g),_(o,ot,g),$($a,ot,null),e(ot,Tm),e(ot,si),e(si,km),e(ot,xm),e(ot,Ta),e(Ta,Fm),e(Ta,ka),e(ka,Em),e(Ta,Bm),e(ot,Im),e(ot,dt),$(xa,dt,null),e(dt,Mm),e(dt,Yt),e(Yt,Pm),e(Yt,Un),e(Un,jm),e(Yt,Cm),e(Yt,ai),e(ai,Am),e(Yt,zm),e(dt,Sm),$(qo,dt,null),e(dt,Dm),$(No,dt,null),_(o,Ul,g),_(o,Zt,g),e(Zt,Lo),e(Lo,ni),$(Fa,ni,null),e(Zt,Om),e(Zt,ri),e(ri,qm),_(o,Kl,g),_(o,Ie,g),$(Ea,Ie,null),e(Ie,Nm),e(Ie,ii),e(ii,Lm),e(Ie,Vm),e(Ie,Ba),e(Ba,Wm),e(Ba,Kn),e(Kn,Rm),e(Ba,Um),e(Ie,Km),e(Ie,Ia),e(Ia,Hm),e(Ia,Ma),e(Ma,Jm),e(Ia,Gm),e(Ie,Xm),e(Ie,li),e(li,Qm),e(Ie,Ym),e(Ie,kt),e(kt,di),e(di,Pa),e(Pa,Zm),e(kt,eh),e(kt,ci),e(ci,ja),e(ja,th),e(kt,oh),e(kt,pi),e(pi,Ca),e(Ca,sh),e(kt,ah),e(kt,mi),e(mi,Aa),e(Aa,nh),e(Ie,rh),e(Ie,ct),$(za,ct,null),e(ct,ih),e(ct,eo),e(eo,lh),e(eo,hi),e(hi,dh),e(eo,ch),e(eo,fi),e(fi,ph),e(eo,mh),e(ct,hh),$(Vo,ct,null),e(ct,fh),$(Wo,ct,null),_(o,Hl,g),_(o,to,g),e(to,Ro),e(Ro,ui),$(Sa,ui,null),e(to,uh),e(to,gi),e(gi,gh),_(o,Jl,g),_(o,Me,g),$(Da,Me,null),e(Me,_h),e(Me,_i),e(_i,bh),e(Me,vh),e(Me,Oa),e(Oa,wh),e(Oa,Hn),e(Hn,yh),e(Oa,$h),e(Me,Th),e(Me,qa),e(qa,kh),e(qa,Na),e(Na,xh),e(qa,Fh),e(Me,Eh),e(Me,bi),e(bi,Bh),e(Me,Ih),e(Me,xt),e(xt,vi),e(vi,La),e(La,Mh),e(xt,Ph),e(xt,wi),e(wi,Va),e(Va,jh),e(xt,Ch),e(xt,yi),e(yi,Wa),e(Wa,Ah),e(xt,zh),e(xt,$i),e($i,Ra),e(Ra,Sh),e(Me,Dh),e(Me,Ge),$(Ua,Ge,null),e(Ge,Oh),e(Ge,oo),e(oo,qh),e(oo,Ti),e(Ti,Nh),e(oo,Lh),e(oo,ki),e(ki,Vh),e(oo,Wh),e(Ge,Rh),$(Uo,Ge,null),e(Ge,Uh),e(Ge,so),e(so,Kh),e(so,xi),e(xi,Hh),e(so,Jh),e(so,Fi),e(Fi,Gh),e(so,Xh),e(Ge,Qh),$(Ko,Ge,null),_(o,Gl,g),_(o,ao,g),e(ao,Ho),e(Ho,Ei),$(Ka,Ei,null),e(ao,Yh),e(ao,Bi),e(Bi,Zh),_(o,Xl,g),_(o,Pe,g),$(Ha,Pe,null),e(Pe,ef),e(Pe,Ii),e(Ii,tf),e(Pe,of),e(Pe,Ja),e(Ja,sf),e(Ja,Jn),e(Jn,af),e(Ja,nf),e(Pe,rf),e(Pe,Ga),e(Ga,lf),e(Ga,Xa),e(Xa,df),e(Ga,cf),e(Pe,pf),e(Pe,Mi),e(Mi,mf),e(Pe,hf),e(Pe,Ft),e(Ft,Pi),e(Pi,Qa),e(Qa,ff),e(Ft,uf),e(Ft,ji),e(ji,Ya),e(Ya,gf),e(Ft,_f),e(Ft,Ci),e(Ci,Za),e(Za,bf),e(Ft,vf),e(Ft,Ai),e(Ai,en),e(en,wf),e(Pe,yf),e(Pe,pt),$(tn,pt,null),e(pt,$f),e(pt,no),e(no,Tf),e(no,zi),e(zi,kf),e(no,xf),e(no,Si),e(Si,Ff),e(no,Ef),e(pt,Bf),$(Jo,pt,null),e(pt,If),$(Go,pt,null),_(o,Ql,g),_(o,ro,g),e(ro,Xo),e(Xo,Di),$(on,Di,null),e(ro,Mf),e(ro,Oi),e(Oi,Pf),_(o,Yl,g),_(o,st,g),$(sn,st,null),e(st,jf),e(st,io),e(io,Cf),e(io,Gn),e(Gn,Af),e(io,zf),e(io,an),e(an,Sf),e(io,Df),e(st,Of),$(Qo,st,null),e(st,qf),e(st,mt),$(nn,mt,null),e(mt,Nf),e(mt,lo),e(lo,Lf),e(lo,Xn),e(Xn,Vf),e(lo,Wf),e(lo,qi),e(qi,Rf),e(lo,Uf),e(mt,Kf),$(Yo,mt,null),e(mt,Hf),$(Zo,mt,null),_(o,Zl,g),_(o,co,g),e(co,es),e(es,Ni),$(rn,Ni,null),e(co,Jf),e(co,Li),e(Li,Gf),_(o,ed,g),_(o,at,g),$(ln,at,null),e(at,Xf),e(at,nt),e(nt,Qf),e(nt,Qn),e(Qn,Yf),e(nt,Zf),e(nt,Yn),e(Yn,eu),e(nt,tu),e(nt,Zn),e(Zn,ou),e(nt,su),e(nt,dn),e(dn,au),e(nt,nu),e(at,ru),$(ts,at,null),e(at,iu),e(at,ht),$(cn,ht,null),e(ht,lu),e(ht,po),e(po,du),e(po,er),e(er,cu),e(po,pu),e(po,Vi),e(Vi,mu),e(po,hu),e(ht,fu),$(os,ht,null),e(ht,uu),$(ss,ht,null),_(o,td,g),_(o,mo,g),e(mo,as),e(as,Wi),$(pn,Wi,null),e(mo,gu),e(mo,Ri),e(Ri,_u),_(o,od,g),_(o,Re,g),$(mn,Re,null),e(Re,bu),e(Re,Ui),e(Ui,vu),e(Re,wu),e(Re,ho),e(ho,yu),e(ho,tr),e(tr,$u),e(ho,Tu),e(ho,hn),e(hn,ku),e(ho,xu),e(Re,Fu),$(ns,Re,null),e(Re,Eu),e(Re,ft),$(fn,ft,null),e(ft,Bu),e(ft,fo),e(fo,Iu),e(fo,or),e(or,Mu),e(fo,Pu),e(fo,Ki),e(Ki,ju),e(fo,Cu),e(ft,Au),$(rs,ft,null),e(ft,zu),$(is,ft,null),_(o,sd,g),_(o,uo,g),e(uo,ls),e(ls,Hi),$(un,Hi,null),e(uo,Su),e(uo,Ji),e(Ji,Du),_(o,ad,g),_(o,Ue,g),$(gn,Ue,null),e(Ue,Ou),e(Ue,Gi),e(Gi,qu),e(Ue,Nu),e(Ue,go),e(go,Lu),e(go,sr),e(sr,Vu),e(go,Wu),e(go,_n),e(_n,Ru),e(go,Uu),e(Ue,Ku),$(ds,Ue,null),e(Ue,Hu),e(Ue,ut),$(bn,ut,null),e(ut,Ju),e(ut,_o),e(_o,Gu),e(_o,ar),e(ar,Xu),e(_o,Qu),e(_o,Xi),e(Xi,Yu),e(_o,Zu),e(ut,eg),$(cs,ut,null),e(ut,tg),$(ps,ut,null),nd=!0},p(o,[g]){const vn={};g&2&&(vn.$$scope={dirty:g,ctx:o}),To.$set(vn);const Qi={};g&2&&(Qi.$$scope={dirty:g,ctx:o}),Mo.$set(Qi);const Yi={};g&2&&(Yi.$$scope={dirty:g,ctx:o}),Po.$set(Yi);const Zi={};g&2&&(Zi.$$scope={dirty:g,ctx:o}),Co.$set(Zi);const wn={};g&2&&(wn.$$scope={dirty:g,ctx:o}),Ao.$set(wn);const el={};g&2&&(el.$$scope={dirty:g,ctx:o}),So.$set(el);const tl={};g&2&&(tl.$$scope={dirty:g,ctx:o}),Do.$set(tl);const ol={};g&2&&(ol.$$scope={dirty:g,ctx:o}),qo.$set(ol);const Et={};g&2&&(Et.$$scope={dirty:g,ctx:o}),No.$set(Et);const sl={};g&2&&(sl.$$scope={dirty:g,ctx:o}),Vo.$set(sl);const al={};g&2&&(al.$$scope={dirty:g,ctx:o}),Wo.$set(al);const nl={};g&2&&(nl.$$scope={dirty:g,ctx:o}),Uo.$set(nl);const rl={};g&2&&(rl.$$scope={dirty:g,ctx:o}),Ko.$set(rl);const il={};g&2&&(il.$$scope={dirty:g,ctx:o}),Jo.$set(il);const ll={};g&2&&(ll.$$scope={dirty:g,ctx:o}),Go.$set(ll);const dl={};g&2&&(dl.$$scope={dirty:g,ctx:o}),Qo.$set(dl);const Ke={};g&2&&(Ke.$$scope={dirty:g,ctx:o}),Yo.$set(Ke);const je={};g&2&&(je.$$scope={dirty:g,ctx:o}),Zo.$set(je);const cl={};g&2&&(cl.$$scope={dirty:g,ctx:o}),ts.$set(cl);const pl={};g&2&&(pl.$$scope={dirty:g,ctx:o}),os.$set(pl);const ml={};g&2&&(ml.$$scope={dirty:g,ctx:o}),ss.$set(ml);const hl={};g&2&&(hl.$$scope={dirty:g,ctx:o}),ns.$set(hl);const fl={};g&2&&(fl.$$scope={dirty:g,ctx:o}),rs.$set(fl);const ul={};g&2&&(ul.$$scope={dirty:g,ctx:o}),is.$set(ul);const gl={};g&2&&(gl.$$scope={dirty:g,ctx:o}),ds.$set(gl);const yn={};g&2&&(yn.$$scope={dirty:g,ctx:o}),cs.$set(yn);const _l={};g&2&&(_l.$$scope={dirty:g,ctx:o}),ps.$set(_l)},i(o){nd||(T(l.$$.fragment,o),T(Z.$$.fragment,o),T(qs.$$.fragment,o),T(Ns.$$.fragment,o),T(Ws.$$.fragment,o),T(Rs.$$.fragment,o),T(Ks.$$.fragment,o),T(Js.$$.fragment,o),T(Gs.$$.fragment,o),T(To.$$.fragment,o),T(Qs.$$.fragment,o),T(Ys.$$.fragment,o),T(Zs.$$.fragment,o),T(ea.$$.fragment,o),T(oa.$$.fragment,o),T(sa.$$.fragment,o),T(aa.$$.fragment,o),T(na.$$.fragment,o),T(ia.$$.fragment,o),T(la.$$.fragment,o),T(pa.$$.fragment,o),T(Mo.$$.fragment,o),T(Po.$$.fragment,o),T(ma.$$.fragment,o),T(ha.$$.fragment,o),T(ua.$$.fragment,o),T(Co.$$.fragment,o),T(Ao.$$.fragment,o),T(ga.$$.fragment,o),T(_a.$$.fragment,o),T(wa.$$.fragment,o),T(So.$$.fragment,o),T(Do.$$.fragment,o),T(ya.$$.fragment,o),T($a.$$.fragment,o),T(xa.$$.fragment,o),T(qo.$$.fragment,o),T(No.$$.fragment,o),T(Fa.$$.fragment,o),T(Ea.$$.fragment,o),T(za.$$.fragment,o),T(Vo.$$.fragment,o),T(Wo.$$.fragment,o),T(Sa.$$.fragment,o),T(Da.$$.fragment,o),T(Ua.$$.fragment,o),T(Uo.$$.fragment,o),T(Ko.$$.fragment,o),T(Ka.$$.fragment,o),T(Ha.$$.fragment,o),T(tn.$$.fragment,o),T(Jo.$$.fragment,o),T(Go.$$.fragment,o),T(on.$$.fragment,o),T(sn.$$.fragment,o),T(Qo.$$.fragment,o),T(nn.$$.fragment,o),T(Yo.$$.fragment,o),T(Zo.$$.fragment,o),T(rn.$$.fragment,o),T(ln.$$.fragment,o),T(ts.$$.fragment,o),T(cn.$$.fragment,o),T(os.$$.fragment,o),T(ss.$$.fragment,o),T(pn.$$.fragment,o),T(mn.$$.fragment,o),T(ns.$$.fragment,o),T(fn.$$.fragment,o),T(rs.$$.fragment,o),T(is.$$.fragment,o),T(un.$$.fragment,o),T(gn.$$.fragment,o),T(ds.$$.fragment,o),T(bn.$$.fragment,o),T(cs.$$.fragment,o),T(ps.$$.fragment,o),nd=!0)},o(o){k(l.$$.fragment,o),k(Z.$$.fragment,o),k(qs.$$.fragment,o),k(Ns.$$.fragment,o),k(Ws.$$.fragment,o),k(Rs.$$.fragment,o),k(Ks.$$.fragment,o),k(Js.$$.fragment,o),k(Gs.$$.fragment,o),k(To.$$.fragment,o),k(Qs.$$.fragment,o),k(Ys.$$.fragment,o),k(Zs.$$.fragment,o),k(ea.$$.fragment,o),k(oa.$$.fragment,o),k(sa.$$.fragment,o),k(aa.$$.fragment,o),k(na.$$.fragment,o),k(ia.$$.fragment,o),k(la.$$.fragment,o),k(pa.$$.fragment,o),k(Mo.$$.fragment,o),k(Po.$$.fragment,o),k(ma.$$.fragment,o),k(ha.$$.fragment,o),k(ua.$$.fragment,o),k(Co.$$.fragment,o),k(Ao.$$.fragment,o),k(ga.$$.fragment,o),k(_a.$$.fragment,o),k(wa.$$.fragment,o),k(So.$$.fragment,o),k(Do.$$.fragment,o),k(ya.$$.fragment,o),k($a.$$.fragment,o),k(xa.$$.fragment,o),k(qo.$$.fragment,o),k(No.$$.fragment,o),k(Fa.$$.fragment,o),k(Ea.$$.fragment,o),k(za.$$.fragment,o),k(Vo.$$.fragment,o),k(Wo.$$.fragment,o),k(Sa.$$.fragment,o),k(Da.$$.fragment,o),k(Ua.$$.fragment,o),k(Uo.$$.fragment,o),k(Ko.$$.fragment,o),k(Ka.$$.fragment,o),k(Ha.$$.fragment,o),k(tn.$$.fragment,o),k(Jo.$$.fragment,o),k(Go.$$.fragment,o),k(on.$$.fragment,o),k(sn.$$.fragment,o),k(Qo.$$.fragment,o),k(nn.$$.fragment,o),k(Yo.$$.fragment,o),k(Zo.$$.fragment,o),k(rn.$$.fragment,o),k(ln.$$.fragment,o),k(ts.$$.fragment,o),k(cn.$$.fragment,o),k(os.$$.fragment,o),k(ss.$$.fragment,o),k(pn.$$.fragment,o),k(mn.$$.fragment,o),k(ns.$$.fragment,o),k(fn.$$.fragment,o),k(rs.$$.fragment,o),k(is.$$.fragment,o),k(un.$$.fragment,o),k(gn.$$.fragment,o),k(ds.$$.fragment,o),k(bn.$$.fragment,o),k(cs.$$.fragment,o),k(ps.$$.fragment,o),nd=!1},d(o){t(d),o&&t(v),o&&t(u),x(l),o&&t(re),o&&t(F),x(Z),o&&t(ie),o&&t(O),o&&t(le),o&&t(V),o&&t(de),o&&t(W),o&&t(A),o&&t(se),o&&t(ce),o&&t(q),o&&t(bl),o&&t(bo),o&&t(vl),o&&t(As),o&&t(wl),o&&t(Je),o&&t(yl),o&&t(Dt),x(qs),o&&t($l),o&&t(Fn),o&&t(Tl),x(Ns,o),o&&t(kl),o&&t(wo),o&&t(xl),o&&t(Mn),o&&t(Fl),o&&t(Pn),o&&t(El),o&&t(Cn),o&&t(Bl),o&&t(Ot),x(Ws),o&&t(Il),o&&t(qt),x(Rs),o&&t(Ml),o&&t(Nt),x(Ks),o&&t(Pl),o&&t(Lt),x(Js),o&&t(jl),o&&t(vt),x(Gs),x(To),o&&t(Cl),o&&t(Wt),x(Qs),o&&t(Al),o&&t(wt),x(Ys),x(Zs),x(ea),o&&t(zl),o&&t(Rt),x(oa),o&&t(Sl),o&&t(et),x(sa),x(aa),x(na),o&&t(Dl),o&&t(Ut),x(ia),o&&t(Ol),o&&t(yt),x(la),x(pa),x(Mo),x(Po),o&&t(ql),o&&t(Ht),x(ma),o&&t(Nl),o&&t($t),x(ha),x(ua),x(Co),x(Ao),o&&t(Ll),o&&t(Gt),x(ga),o&&t(Vl),o&&t(tt),x(_a),x(wa),x(So),x(Do),o&&t(Wl),o&&t(Qt),x(ya),o&&t(Rl),o&&t(ot),x($a),x(xa),x(qo),x(No),o&&t(Ul),o&&t(Zt),x(Fa),o&&t(Kl),o&&t(Ie),x(Ea),x(za),x(Vo),x(Wo),o&&t(Hl),o&&t(to),x(Sa),o&&t(Jl),o&&t(Me),x(Da),x(Ua),x(Uo),x(Ko),o&&t(Gl),o&&t(ao),x(Ka),o&&t(Xl),o&&t(Pe),x(Ha),x(tn),x(Jo),x(Go),o&&t(Ql),o&&t(ro),x(on),o&&t(Yl),o&&t(st),x(sn),x(Qo),x(nn),x(Yo),x(Zo),o&&t(Zl),o&&t(co),x(rn),o&&t(ed),o&&t(at),x(ln),x(ts),x(cn),x(os),x(ss),o&&t(td),o&&t(mo),x(pn),o&&t(od),o&&t(Re),x(mn),x(ns),x(fn),x(rs),x(is),o&&t(sd),o&&t(uo),x(un),o&&t(ad),o&&t(Ue),x(gn),x(ds),x(bn),x(cs),x(ps)}}}const Nv={local:"beit",sections:[{local:"overview",title:"Overview"},{local:"resources",title:"Resources"},{local:"transformers.models.beit.modeling_beit.BeitModelOutputWithPooling",title:"BEiT specific outputs"},{local:"transformers.BeitConfig",title:"BeitConfig"},{local:"transformers.BeitFeatureExtractor",title:"BeitFeatureExtractor"},{local:"transformers.BeitImageProcessor",title:"BeitImageProcessor"},{local:"transformers.BeitModel",title:"BeitModel"},{local:"transformers.BeitForMaskedImageModeling",title:"BeitForMaskedImageModeling"},{local:"transformers.BeitForImageClassification",title:"BeitForImageClassification"},{local:"transformers.BeitForSemanticSegmentation",title:"BeitForSemanticSegmentation"},{local:"transformers.FlaxBeitModel",title:"FlaxBeitModel"},{local:"transformers.FlaxBeitForMaskedImageModeling",title:"FlaxBeitForMaskedImageModeling"},{local:"transformers.FlaxBeitForImageClassification",title:"FlaxBeitForImageClassification"},{local:"transformers.TFBeitModel",title:"TFBeitModel"},{local:"transformers.TFBeitForMaskedImageModeling",title:"TFBeitForMaskedImageModeling"},{local:"transformers.TFBeitForImageClassification",title:"TFBeitForImageClassification"},{local:"transformers.TFBeitForSemanticSegmentation",title:"TFBeitForSemanticSegmentation"}],title:"BEiT"};function Lv(B){return cv(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Gv extends nv{constructor(d){super();rv(this,d,Lv,qv,iv,{})}}export{Gv as default,Nv as metadata};
