import{S as E8,i as R8,s as X8,e as s,k as p,w as y,t as o,M as z8,c as a,d as t,m as h,a as r,x as w,h as n,b as c,N as x8,G as e,g,y as T,q as M,o as $,B as L,v as C8,L as Ie}from"../../chunks/vendor-hf-doc-builder.js";import{T as Ae}from"../../chunks/Tip-hf-doc-builder.js";import{D as I}from"../../chunks/Docstring-hf-doc-builder.js";import{C as De}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as Ne}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as Oe}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";import{P as bg}from"../../chunks/PipelineTag-hf-doc-builder.js";function q8(E){let d,k,m,f,b;return f=new De({props:{code:`from transformers import XLMRobertaConfig, XLMRobertaModel

# Initializing a XLM-RoBERTa xlm-roberta-base style configuration
configuration = XLMRobertaConfig()

# Initializing a model (with random weights) from the xlm-roberta-base style configuration
model = XLMRobertaModel(configuration)

# Accessing the model configuration
configuration = model.config`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> XLMRobertaConfig, XLMRobertaModel

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a XLM-RoBERTa xlm-roberta-base style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = XLMRobertaConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a model (with random weights) from the xlm-roberta-base style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = XLMRobertaModel(configuration)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Accessing the model configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = model.config`}}),{c(){d=s("p"),k=o("Examples:"),m=p(),y(f.$$.fragment)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Examples:"),u.forEach(t),m=h(l),w(f.$$.fragment,l)},m(l,u){g(l,d,u),e(d,k),g(l,m,u),T(f,l,u),b=!0},p:Ie,i(l){b||(M(f.$$.fragment,l),b=!0)},o(l){$(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(m),L(f,l)}}}function j8(E){let d,k,m,f,b;return{c(){d=s("p"),k=o("Although the recipe for forward pass needs to be defined within this function, one should call the "),m=s("code"),f=o("Module"),b=o(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Although the recipe for forward pass needs to be defined within this function, one should call the "),m=a(u,"CODE",{});var R=r(m);f=n(R,"Module"),R.forEach(t),b=n(u,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),u.forEach(t)},m(l,u){g(l,d,u),e(d,k),e(d,m),e(m,f),e(d,b)},d(l){l&&t(d)}}}function A8(E){let d,k,m,f,b;return f=new De({props:{code:`from transformers import AutoTokenizer, XLMRobertaModel
import torch

tokenizer = AutoTokenizer.from_pretrained("xlm-roberta-base")
model = XLMRobertaModel.from_pretrained("xlm-roberta-base")

inputs = tokenizer("Hello, my dog is cute", return_tensors="pt")
outputs = model(**inputs)

last_hidden_states = outputs.last_hidden_state`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, XLMRobertaModel
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;xlm-roberta-base&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = XLMRobertaModel.from_pretrained(<span class="hljs-string">&quot;xlm-roberta-base&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span>last_hidden_states = outputs.last_hidden_state`}}),{c(){d=s("p"),k=o("Example:"),m=p(),y(f.$$.fragment)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Example:"),u.forEach(t),m=h(l),w(f.$$.fragment,l)},m(l,u){g(l,d,u),e(d,k),g(l,m,u),T(f,l,u),b=!0},p:Ie,i(l){b||(M(f.$$.fragment,l),b=!0)},o(l){$(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(m),L(f,l)}}}function P8(E){let d,k,m,f,b;return{c(){d=s("p"),k=o("Although the recipe for forward pass needs to be defined within this function, one should call the "),m=s("code"),f=o("Module"),b=o(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Although the recipe for forward pass needs to be defined within this function, one should call the "),m=a(u,"CODE",{});var R=r(m);f=n(R,"Module"),R.forEach(t),b=n(u,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),u.forEach(t)},m(l,u){g(l,d,u),e(d,k),e(d,m),e(m,f),e(d,b)},d(l){l&&t(d)}}}function N8(E){let d,k,m,f,b;return f=new De({props:{code:`from transformers import AutoTokenizer, XLMRobertaForCausalLM, AutoConfig
import torch

tokenizer = AutoTokenizer.from_pretrained("roberta-base")
config = AutoConfig.from_pretrained("roberta-base")
config.is_decoder = True
model = XLMRobertaForCausalLM.from_pretrained("roberta-base", config=config)

inputs = tokenizer("Hello, my dog is cute", return_tensors="pt")
outputs = model(**inputs)

prediction_logits = outputs.logits`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, XLMRobertaForCausalLM, AutoConfig
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;roberta-base&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>config = AutoConfig.from_pretrained(<span class="hljs-string">&quot;roberta-base&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>config.is_decoder = <span class="hljs-literal">True</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = XLMRobertaForCausalLM.from_pretrained(<span class="hljs-string">&quot;roberta-base&quot;</span>, config=config)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span>prediction_logits = outputs.logits`}}),{c(){d=s("p"),k=o("Example:"),m=p(),y(f.$$.fragment)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Example:"),u.forEach(t),m=h(l),w(f.$$.fragment,l)},m(l,u){g(l,d,u),e(d,k),g(l,m,u),T(f,l,u),b=!0},p:Ie,i(l){b||(M(f.$$.fragment,l),b=!0)},o(l){$(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(m),L(f,l)}}}function O8(E){let d,k,m,f,b;return{c(){d=s("p"),k=o("Although the recipe for forward pass needs to be defined within this function, one should call the "),m=s("code"),f=o("Module"),b=o(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Although the recipe for forward pass needs to be defined within this function, one should call the "),m=a(u,"CODE",{});var R=r(m);f=n(R,"Module"),R.forEach(t),b=n(u,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),u.forEach(t)},m(l,u){g(l,d,u),e(d,k),e(d,m),e(m,f),e(d,b)},d(l){l&&t(d)}}}function I8(E){let d,k,m,f,b;return f=new De({props:{code:`from transformers import AutoTokenizer, XLMRobertaForMaskedLM
import torch

tokenizer = AutoTokenizer.from_pretrained("xlm-roberta-base")
model = XLMRobertaForMaskedLM.from_pretrained("xlm-roberta-base")

inputs = tokenizer("The capital of France is <mask>.", return_tensors="pt")

with torch.no_grad():
    logits = model(**inputs).logits

# retrieve index of <mask>
mask_token_index = (inputs.input_ids == tokenizer.mask_token_id)[0].nonzero(as_tuple=True)[0]

predicted_token_id = logits[0, mask_token_index].argmax(axis=-1)
tokenizer.decode(predicted_token_id)

labels = tokenizer("The capital of France is Paris.", return_tensors="pt")["input_ids"]
# mask labels of non-<mask> tokens
labels = torch.where(inputs.input_ids == tokenizer.mask_token_id, labels, -100)

outputs = model(**inputs, labels=labels)
round(outputs.loss.item(), 2)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, XLMRobertaForMaskedLM
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;xlm-roberta-base&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = XLMRobertaForMaskedLM.from_pretrained(<span class="hljs-string">&quot;xlm-roberta-base&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;The capital of France is &lt;mask&gt;.&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    logits = model(**inputs).logits

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># retrieve index of &lt;mask&gt;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>mask_token_index = (inputs.input_ids == tokenizer.mask_token_id)[<span class="hljs-number">0</span>].nonzero(as_tuple=<span class="hljs-literal">True</span>)[<span class="hljs-number">0</span>]

<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_token_id = logits[<span class="hljs-number">0</span>, mask_token_index].argmax(axis=-<span class="hljs-number">1</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer.decode(predicted_token_id)
<span class="hljs-string">&#x27; Paris&#x27;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>labels = tokenizer(<span class="hljs-string">&quot;The capital of France is Paris.&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)[<span class="hljs-string">&quot;input_ids&quot;</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># mask labels of non-&lt;mask&gt; tokens</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>labels = torch.where(inputs.input_ids == tokenizer.mask_token_id, labels, -<span class="hljs-number">100</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs, labels=labels)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">round</span>(outputs.loss.item(), <span class="hljs-number">2</span>)
<span class="hljs-number">0.1</span>`}}),{c(){d=s("p"),k=o("Example:"),m=p(),y(f.$$.fragment)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Example:"),u.forEach(t),m=h(l),w(f.$$.fragment,l)},m(l,u){g(l,d,u),e(d,k),g(l,m,u),T(f,l,u),b=!0},p:Ie,i(l){b||(M(f.$$.fragment,l),b=!0)},o(l){$(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(m),L(f,l)}}}function D8(E){let d,k,m,f,b;return{c(){d=s("p"),k=o("Although the recipe for forward pass needs to be defined within this function, one should call the "),m=s("code"),f=o("Module"),b=o(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Although the recipe for forward pass needs to be defined within this function, one should call the "),m=a(u,"CODE",{});var R=r(m);f=n(R,"Module"),R.forEach(t),b=n(u,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),u.forEach(t)},m(l,u){g(l,d,u),e(d,k),e(d,m),e(m,f),e(d,b)},d(l){l&&t(d)}}}function S8(E){let d,k,m,f,b;return f=new De({props:{code:`import torch
from transformers import AutoTokenizer, XLMRobertaForSequenceClassification

tokenizer = AutoTokenizer.from_pretrained("cardiffnlp/twitter-roberta-base-emotion")
model = XLMRobertaForSequenceClassification.from_pretrained("cardiffnlp/twitter-roberta-base-emotion")

inputs = tokenizer("Hello, my dog is cute", return_tensors="pt")

with torch.no_grad():
    logits = model(**inputs).logits

predicted_class_id = logits.argmax().item()
model.config.id2label[predicted_class_id]

# To train a model on \`num_labels\` classes, you can pass \`num_labels=num_labels\` to \`.from_pretrained(...)\`
num_labels = len(model.config.id2label)
model = XLMRobertaForSequenceClassification.from_pretrained("cardiffnlp/twitter-roberta-base-emotion", num_labels=num_labels)

labels = torch.tensor([1])
loss = model(**inputs, labels=labels).loss
round(loss.item(), 2)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, XLMRobertaForSequenceClassification

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;cardiffnlp/twitter-roberta-base-emotion&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = XLMRobertaForSequenceClassification.from_pretrained(<span class="hljs-string">&quot;cardiffnlp/twitter-roberta-base-emotion&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    logits = model(**inputs).logits

<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_class_id = logits.argmax().item()
<span class="hljs-meta">&gt;&gt;&gt; </span>model.config.id2label[predicted_class_id]
<span class="hljs-string">&#x27;optimism&#x27;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># To train a model on \`num_labels\` classes, you can pass \`num_labels=num_labels\` to \`.from_pretrained(...)\`</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>num_labels = <span class="hljs-built_in">len</span>(model.config.id2label)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = XLMRobertaForSequenceClassification.from_pretrained(<span class="hljs-string">&quot;cardiffnlp/twitter-roberta-base-emotion&quot;</span>, num_labels=num_labels)

<span class="hljs-meta">&gt;&gt;&gt; </span>labels = torch.tensor([<span class="hljs-number">1</span>])
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = model(**inputs, labels=labels).loss
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">round</span>(loss.item(), <span class="hljs-number">2</span>)
<span class="hljs-number">0.08</span>`}}),{c(){d=s("p"),k=o("Example of single-label classification:"),m=p(),y(f.$$.fragment)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Example of single-label classification:"),u.forEach(t),m=h(l),w(f.$$.fragment,l)},m(l,u){g(l,d,u),e(d,k),g(l,m,u),T(f,l,u),b=!0},p:Ie,i(l){b||(M(f.$$.fragment,l),b=!0)},o(l){$(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(m),L(f,l)}}}function W8(E){let d,k,m,f,b;return f=new De({props:{code:`import torch
from transformers import AutoTokenizer, XLMRobertaForSequenceClassification

tokenizer = AutoTokenizer.from_pretrained("cardiffnlp/twitter-roberta-base-emotion")
model = XLMRobertaForSequenceClassification.from_pretrained("cardiffnlp/twitter-roberta-base-emotion", problem_type="multi_label_classification")

inputs = tokenizer("Hello, my dog is cute", return_tensors="pt")

with torch.no_grad():
    logits = model(**inputs).logits

predicted_class_ids = torch.arange(0, logits.shape[-1])[torch.sigmoid(logits).squeeze(dim=0) > 0.5]

# To train a model on \`num_labels\` classes, you can pass \`num_labels=num_labels\` to \`.from_pretrained(...)\`
num_labels = len(model.config.id2label)
model = XLMRobertaForSequenceClassification.from_pretrained(
    "cardiffnlp/twitter-roberta-base-emotion", num_labels=num_labels, problem_type="multi_label_classification"
)

labels = torch.sum(
    torch.nn.functional.one_hot(predicted_class_ids[None, :].clone(), num_classes=num_labels), dim=1
).to(torch.float)
loss = model(**inputs, labels=labels).loss`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, XLMRobertaForSequenceClassification

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;cardiffnlp/twitter-roberta-base-emotion&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = XLMRobertaForSequenceClassification.from_pretrained(<span class="hljs-string">&quot;cardiffnlp/twitter-roberta-base-emotion&quot;</span>, problem_type=<span class="hljs-string">&quot;multi_label_classification&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    logits = model(**inputs).logits

<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_class_ids = torch.arange(<span class="hljs-number">0</span>, logits.shape[-<span class="hljs-number">1</span>])[torch.sigmoid(logits).squeeze(dim=<span class="hljs-number">0</span>) &gt; <span class="hljs-number">0.5</span>]

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># To train a model on \`num_labels\` classes, you can pass \`num_labels=num_labels\` to \`.from_pretrained(...)\`</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>num_labels = <span class="hljs-built_in">len</span>(model.config.id2label)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = XLMRobertaForSequenceClassification.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;cardiffnlp/twitter-roberta-base-emotion&quot;</span>, num_labels=num_labels, problem_type=<span class="hljs-string">&quot;multi_label_classification&quot;</span>
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>labels = torch.<span class="hljs-built_in">sum</span>(
<span class="hljs-meta">... </span>    torch.nn.functional.one_hot(predicted_class_ids[<span class="hljs-literal">None</span>, :].clone(), num_classes=num_labels), dim=<span class="hljs-number">1</span>
<span class="hljs-meta">... </span>).to(torch.<span class="hljs-built_in">float</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = model(**inputs, labels=labels).loss`}}),{c(){d=s("p"),k=o("Example of multi-label classification:"),m=p(),y(f.$$.fragment)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Example of multi-label classification:"),u.forEach(t),m=h(l),w(f.$$.fragment,l)},m(l,u){g(l,d,u),e(d,k),g(l,m,u),T(f,l,u),b=!0},p:Ie,i(l){b||(M(f.$$.fragment,l),b=!0)},o(l){$(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(m),L(f,l)}}}function U8(E){let d,k,m,f,b;return{c(){d=s("p"),k=o("Although the recipe for forward pass needs to be defined within this function, one should call the "),m=s("code"),f=o("Module"),b=o(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Although the recipe for forward pass needs to be defined within this function, one should call the "),m=a(u,"CODE",{});var R=r(m);f=n(R,"Module"),R.forEach(t),b=n(u,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),u.forEach(t)},m(l,u){g(l,d,u),e(d,k),e(d,m),e(m,f),e(d,b)},d(l){l&&t(d)}}}function B8(E){let d,k,m,f,b;return f=new De({props:{code:`from transformers import AutoTokenizer, XLMRobertaForMultipleChoice
import torch

tokenizer = AutoTokenizer.from_pretrained("xlm-roberta-base")
model = XLMRobertaForMultipleChoice.from_pretrained("xlm-roberta-base")

prompt = "In Italy, pizza served in formal settings, such as at a restaurant, is presented unsliced."
choice0 = "It is eaten with a fork and a knife."
choice1 = "It is eaten while held in the hand."
labels = torch.tensor(0).unsqueeze(0)  # choice0 is correct (according to Wikipedia ;)), batch size 1

encoding = tokenizer([prompt, prompt], [choice0, choice1], return_tensors="pt", padding=True)
outputs = model(**{k: v.unsqueeze(0) for k, v in encoding.items()}, labels=labels)  # batch size is 1

# the linear classifier still needs to be trained
loss = outputs.loss
logits = outputs.logits`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, XLMRobertaForMultipleChoice
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;xlm-roberta-base&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = XLMRobertaForMultipleChoice.from_pretrained(<span class="hljs-string">&quot;xlm-roberta-base&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&quot;In Italy, pizza served in formal settings, such as at a restaurant, is presented unsliced.&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>choice0 = <span class="hljs-string">&quot;It is eaten with a fork and a knife.&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>choice1 = <span class="hljs-string">&quot;It is eaten while held in the hand.&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>labels = torch.tensor(<span class="hljs-number">0</span>).unsqueeze(<span class="hljs-number">0</span>)  <span class="hljs-comment"># choice0 is correct (according to Wikipedia ;)), batch size 1</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>encoding = tokenizer([prompt, prompt], [choice0, choice1], return_tensors=<span class="hljs-string">&quot;pt&quot;</span>, padding=<span class="hljs-literal">True</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**{k: v.unsqueeze(<span class="hljs-number">0</span>) <span class="hljs-keyword">for</span> k, v <span class="hljs-keyword">in</span> encoding.items()}, labels=labels)  <span class="hljs-comment"># batch size is 1</span>

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># the linear classifier still needs to be trained</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = outputs.loss
<span class="hljs-meta">&gt;&gt;&gt; </span>logits = outputs.logits`}}),{c(){d=s("p"),k=o("Example:"),m=p(),y(f.$$.fragment)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Example:"),u.forEach(t),m=h(l),w(f.$$.fragment,l)},m(l,u){g(l,d,u),e(d,k),g(l,m,u),T(f,l,u),b=!0},p:Ie,i(l){b||(M(f.$$.fragment,l),b=!0)},o(l){$(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(m),L(f,l)}}}function H8(E){let d,k,m,f,b;return{c(){d=s("p"),k=o("Although the recipe for forward pass needs to be defined within this function, one should call the "),m=s("code"),f=o("Module"),b=o(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Although the recipe for forward pass needs to be defined within this function, one should call the "),m=a(u,"CODE",{});var R=r(m);f=n(R,"Module"),R.forEach(t),b=n(u,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),u.forEach(t)},m(l,u){g(l,d,u),e(d,k),e(d,m),e(m,f),e(d,b)},d(l){l&&t(d)}}}function Q8(E){let d,k,m,f,b;return f=new De({props:{code:`from transformers import AutoTokenizer, XLMRobertaForTokenClassification
import torch

tokenizer = AutoTokenizer.from_pretrained("Jean-Baptiste/roberta-large-ner-english")
model = XLMRobertaForTokenClassification.from_pretrained("Jean-Baptiste/roberta-large-ner-english")

inputs = tokenizer(
    "HuggingFace is a company based in Paris and New York", add_special_tokens=False, return_tensors="pt"
)

with torch.no_grad():
    logits = model(**inputs).logits

predicted_token_class_ids = logits.argmax(-1)

# Note that tokens are classified rather then input words which means that
# there might be more predicted token classes than words.
# Multiple token classes might account for the same word
predicted_tokens_classes = [model.config.id2label[t.item()] for t in predicted_token_class_ids[0]]
predicted_tokens_classes

labels = predicted_token_class_ids
loss = model(**inputs, labels=labels).loss
round(loss.item(), 2)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, XLMRobertaForTokenClassification
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;Jean-Baptiste/roberta-large-ner-english&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = XLMRobertaForTokenClassification.from_pretrained(<span class="hljs-string">&quot;Jean-Baptiste/roberta-large-ner-english&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;HuggingFace is a company based in Paris and New York&quot;</span>, add_special_tokens=<span class="hljs-literal">False</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    logits = model(**inputs).logits

<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_token_class_ids = logits.argmax(-<span class="hljs-number">1</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Note that tokens are classified rather then input words which means that</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># there might be more predicted token classes than words.</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Multiple token classes might account for the same word</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_tokens_classes = [model.config.id2label[t.item()] <span class="hljs-keyword">for</span> t <span class="hljs-keyword">in</span> predicted_token_class_ids[<span class="hljs-number">0</span>]]
<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_tokens_classes
[<span class="hljs-string">&#x27;O&#x27;</span>, <span class="hljs-string">&#x27;ORG&#x27;</span>, <span class="hljs-string">&#x27;ORG&#x27;</span>, <span class="hljs-string">&#x27;O&#x27;</span>, <span class="hljs-string">&#x27;O&#x27;</span>, <span class="hljs-string">&#x27;O&#x27;</span>, <span class="hljs-string">&#x27;O&#x27;</span>, <span class="hljs-string">&#x27;O&#x27;</span>, <span class="hljs-string">&#x27;LOC&#x27;</span>, <span class="hljs-string">&#x27;O&#x27;</span>, <span class="hljs-string">&#x27;LOC&#x27;</span>, <span class="hljs-string">&#x27;LOC&#x27;</span>]

<span class="hljs-meta">&gt;&gt;&gt; </span>labels = predicted_token_class_ids
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = model(**inputs, labels=labels).loss
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">round</span>(loss.item(), <span class="hljs-number">2</span>)
<span class="hljs-number">0.01</span>`}}),{c(){d=s("p"),k=o("Example:"),m=p(),y(f.$$.fragment)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Example:"),u.forEach(t),m=h(l),w(f.$$.fragment,l)},m(l,u){g(l,d,u),e(d,k),g(l,m,u),T(f,l,u),b=!0},p:Ie,i(l){b||(M(f.$$.fragment,l),b=!0)},o(l){$(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(m),L(f,l)}}}function K8(E){let d,k,m,f,b;return{c(){d=s("p"),k=o("Although the recipe for forward pass needs to be defined within this function, one should call the "),m=s("code"),f=o("Module"),b=o(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Although the recipe for forward pass needs to be defined within this function, one should call the "),m=a(u,"CODE",{});var R=r(m);f=n(R,"Module"),R.forEach(t),b=n(u,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),u.forEach(t)},m(l,u){g(l,d,u),e(d,k),e(d,m),e(m,f),e(d,b)},d(l){l&&t(d)}}}function V8(E){let d,k,m,f,b;return f=new De({props:{code:`from transformers import AutoTokenizer, XLMRobertaForQuestionAnswering
import torch

tokenizer = AutoTokenizer.from_pretrained("deepset/roberta-base-squad2")
model = XLMRobertaForQuestionAnswering.from_pretrained("deepset/roberta-base-squad2")

question, text = "Who was Jim Henson?", "Jim Henson was a nice puppet"

inputs = tokenizer(question, text, return_tensors="pt")
with torch.no_grad():
    outputs = model(**inputs)

answer_start_index = outputs.start_logits.argmax()
answer_end_index = outputs.end_logits.argmax()

predict_answer_tokens = inputs.input_ids[0, answer_start_index : answer_end_index + 1]
tokenizer.decode(predict_answer_tokens, skip_special_tokens=True)

# target is "nice puppet"
target_start_index = torch.tensor([14])
target_end_index = torch.tensor([15])

outputs = model(**inputs, start_positions=target_start_index, end_positions=target_end_index)
loss = outputs.loss
round(loss.item(), 2)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, XLMRobertaForQuestionAnswering
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;deepset/roberta-base-squad2&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = XLMRobertaForQuestionAnswering.from_pretrained(<span class="hljs-string">&quot;deepset/roberta-base-squad2&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>question, text = <span class="hljs-string">&quot;Who was Jim Henson?&quot;</span>, <span class="hljs-string">&quot;Jim Henson was a nice puppet&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(question, text, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span>answer_start_index = outputs.start_logits.argmax()
<span class="hljs-meta">&gt;&gt;&gt; </span>answer_end_index = outputs.end_logits.argmax()

<span class="hljs-meta">&gt;&gt;&gt; </span>predict_answer_tokens = inputs.input_ids[<span class="hljs-number">0</span>, answer_start_index : answer_end_index + <span class="hljs-number">1</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer.decode(predict_answer_tokens, skip_special_tokens=<span class="hljs-literal">True</span>)
<span class="hljs-string">&#x27; puppet&#x27;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># target is &quot;nice puppet&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>target_start_index = torch.tensor([<span class="hljs-number">14</span>])
<span class="hljs-meta">&gt;&gt;&gt; </span>target_end_index = torch.tensor([<span class="hljs-number">15</span>])

<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs, start_positions=target_start_index, end_positions=target_end_index)
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = outputs.loss
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">round</span>(loss.item(), <span class="hljs-number">2</span>)
<span class="hljs-number">0.86</span>`}}),{c(){d=s("p"),k=o("Example:"),m=p(),y(f.$$.fragment)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Example:"),u.forEach(t),m=h(l),w(f.$$.fragment,l)},m(l,u){g(l,d,u),e(d,k),g(l,m,u),T(f,l,u),b=!0},p:Ie,i(l){b||(M(f.$$.fragment,l),b=!0)},o(l){$(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(m),L(f,l)}}}function J8(E){let d,k,m,f,b,l,u,R,ke,fe,O,ce,te,F,ve,W,pe,Ce,K,ae,re,U,ie,ye,B,we,ge,D,Te,le,oe,z,j,he,J,_e,ue,H,Me,be,q,$e,V,ne,de,G,me,Le,N,Fe,Q,xe,se,C,Ee,A,Re,Xe;return{c(){d=s("p"),k=o("TensorFlow models and layers in "),m=s("code"),f=o("transformers"),b=o(" accept two formats as input:"),l=p(),u=s("ul"),R=s("li"),ke=o("having all inputs as keyword arguments (like PyTorch models), or"),fe=p(),O=s("li"),ce=o("having all inputs as a list, tuple or dict in the first positional argument."),te=p(),F=s("p"),ve=o(`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),W=s("code"),pe=o("model.fit()"),Ce=o(` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),K=s("code"),ae=o("model.fit()"),re=o(` supports! If, however, you want to use the second
format outside of Keras methods like `),U=s("code"),ie=o("fit()"),ye=o(" and "),B=s("code"),we=o("predict()"),ge=o(`, such as when creating your own layers or models with
the Keras `),D=s("code"),Te=o("Functional"),le=o(` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),oe=p(),z=s("ul"),j=s("li"),he=o("a single Tensor with "),J=s("code"),_e=o("input_ids"),ue=o(" only and nothing else: "),H=s("code"),Me=o("model(input_ids)"),be=p(),q=s("li"),$e=o(`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),V=s("code"),ne=o("model([input_ids, attention_mask])"),de=o(" or "),G=s("code"),me=o("model([input_ids, attention_mask, token_type_ids])"),Le=p(),N=s("li"),Fe=o(`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),Q=s("code"),xe=o('model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),se=p(),C=s("p"),Ee=o(`Note that when creating models and layers with
`),A=s("a"),Re=o("subclassing"),Xe=o(` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),this.h()},l(v){d=a(v,"P",{});var x=r(d);k=n(x,"TensorFlow models and layers in "),m=a(x,"CODE",{});var Qe=r(m);f=n(Qe,"transformers"),Qe.forEach(t),b=n(x," accept two formats as input:"),x.forEach(t),l=h(v),u=a(v,"UL",{});var Z=r(u);R=a(Z,"LI",{});var Ke=r(R);ke=n(Ke,"having all inputs as keyword arguments (like PyTorch models), or"),Ke.forEach(t),fe=h(Z),O=a(Z,"LI",{});var Ve=r(O);ce=n(Ve,"having all inputs as a list, tuple or dict in the first positional argument."),Ve.forEach(t),Z.forEach(t),te=h(v),F=a(v,"P",{});var X=r(F);ve=n(X,`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),W=a(X,"CODE",{});var Je=r(W);pe=n(Je,"model.fit()"),Je.forEach(t),Ce=n(X,` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),K=a(X,"CODE",{});var Ge=r(K);ae=n(Ge,"model.fit()"),Ge.forEach(t),re=n(X,` supports! If, however, you want to use the second
format outside of Keras methods like `),U=a(X,"CODE",{});var We=r(U);ie=n(We,"fit()"),We.forEach(t),ye=n(X," and "),B=a(X,"CODE",{});var qe=r(B);we=n(qe,"predict()"),qe.forEach(t),ge=n(X,`, such as when creating your own layers or models with
the Keras `),D=a(X,"CODE",{});var je=r(D);Te=n(je,"Functional"),je.forEach(t),le=n(X,` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),X.forEach(t),oe=h(v),z=a(v,"UL",{});var P=r(z);j=a(P,"LI",{});var S=r(j);he=n(S,"a single Tensor with "),J=a(S,"CODE",{});var Ye=r(J);_e=n(Ye,"input_ids"),Ye.forEach(t),ue=n(S," only and nothing else: "),H=a(S,"CODE",{});var Se=r(H);Me=n(Se,"model(input_ids)"),Se.forEach(t),S.forEach(t),be=h(P),q=a(P,"LI",{});var Y=r(q);$e=n(Y,`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),V=a(Y,"CODE",{});var Ue=r(V);ne=n(Ue,"model([input_ids, attention_mask])"),Ue.forEach(t),de=n(Y," or "),G=a(Y,"CODE",{});var Pe=r(G);me=n(Pe,"model([input_ids, attention_mask, token_type_ids])"),Pe.forEach(t),Y.forEach(t),Le=h(P),N=a(P,"LI",{});var ze=r(N);Fe=n(ze,`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),Q=a(ze,"CODE",{});var Be=r(Q);xe=n(Be,'model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),Be.forEach(t),ze.forEach(t),P.forEach(t),se=h(v),C=a(v,"P",{});var ee=r(C);Ee=n(ee,`Note that when creating models and layers with
`),A=a(ee,"A",{href:!0,rel:!0});var He=r(A);Re=n(He,"subclassing"),He.forEach(t),Xe=n(ee,` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),ee.forEach(t),this.h()},h(){c(A,"href","https://keras.io/guides/making_new_layers_and_models_via_subclassing/"),c(A,"rel","nofollow")},m(v,x){g(v,d,x),e(d,k),e(d,m),e(m,f),e(d,b),g(v,l,x),g(v,u,x),e(u,R),e(R,ke),e(u,fe),e(u,O),e(O,ce),g(v,te,x),g(v,F,x),e(F,ve),e(F,W),e(W,pe),e(F,Ce),e(F,K),e(K,ae),e(F,re),e(F,U),e(U,ie),e(F,ye),e(F,B),e(B,we),e(F,ge),e(F,D),e(D,Te),e(F,le),g(v,oe,x),g(v,z,x),e(z,j),e(j,he),e(j,J),e(J,_e),e(j,ue),e(j,H),e(H,Me),e(z,be),e(z,q),e(q,$e),e(q,V),e(V,ne),e(q,de),e(q,G),e(G,me),e(z,Le),e(z,N),e(N,Fe),e(N,Q),e(Q,xe),g(v,se,x),g(v,C,x),e(C,Ee),e(C,A),e(A,Re),e(C,Xe)},d(v){v&&t(d),v&&t(l),v&&t(u),v&&t(te),v&&t(F),v&&t(oe),v&&t(z),v&&t(se),v&&t(C)}}}function G8(E){let d,k,m,f,b;return{c(){d=s("p"),k=o("Although the recipe for forward pass needs to be defined within this function, one should call the "),m=s("code"),f=o("Module"),b=o(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Although the recipe for forward pass needs to be defined within this function, one should call the "),m=a(u,"CODE",{});var R=r(m);f=n(R,"Module"),R.forEach(t),b=n(u,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),u.forEach(t)},m(l,u){g(l,d,u),e(d,k),e(d,m),e(m,f),e(d,b)},d(l){l&&t(d)}}}function Y8(E){let d,k,m,f,b;return f=new De({props:{code:`from transformers import AutoTokenizer, TFXLMRobertaModel
import tensorflow as tf

tokenizer = AutoTokenizer.from_pretrained("xlm-roberta-base")
model = TFXLMRobertaModel.from_pretrained("xlm-roberta-base")

inputs = tokenizer("Hello, my dog is cute", return_tensors="tf")
outputs = model(inputs)

last_hidden_states = outputs.last_hidden_state`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, TFXLMRobertaModel
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> tensorflow <span class="hljs-keyword">as</span> tf

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;xlm-roberta-base&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFXLMRobertaModel.from_pretrained(<span class="hljs-string">&quot;xlm-roberta-base&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;tf&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span>last_hidden_states = outputs.last_hidden_state`}}),{c(){d=s("p"),k=o("Example:"),m=p(),y(f.$$.fragment)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Example:"),u.forEach(t),m=h(l),w(f.$$.fragment,l)},m(l,u){g(l,d,u),e(d,k),g(l,m,u),T(f,l,u),b=!0},p:Ie,i(l){b||(M(f.$$.fragment,l),b=!0)},o(l){$(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(m),L(f,l)}}}function Z8(E){let d,k,m,f,b,l,u,R,ke,fe,O,ce,te,F,ve,W,pe,Ce,K,ae,re,U,ie,ye,B,we,ge,D,Te,le,oe,z,j,he,J,_e,ue,H,Me,be,q,$e,V,ne,de,G,me,Le,N,Fe,Q,xe,se,C,Ee,A,Re,Xe;return{c(){d=s("p"),k=o("TensorFlow models and layers in "),m=s("code"),f=o("transformers"),b=o(" accept two formats as input:"),l=p(),u=s("ul"),R=s("li"),ke=o("having all inputs as keyword arguments (like PyTorch models), or"),fe=p(),O=s("li"),ce=o("having all inputs as a list, tuple or dict in the first positional argument."),te=p(),F=s("p"),ve=o(`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),W=s("code"),pe=o("model.fit()"),Ce=o(` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),K=s("code"),ae=o("model.fit()"),re=o(` supports! If, however, you want to use the second
format outside of Keras methods like `),U=s("code"),ie=o("fit()"),ye=o(" and "),B=s("code"),we=o("predict()"),ge=o(`, such as when creating your own layers or models with
the Keras `),D=s("code"),Te=o("Functional"),le=o(` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),oe=p(),z=s("ul"),j=s("li"),he=o("a single Tensor with "),J=s("code"),_e=o("input_ids"),ue=o(" only and nothing else: "),H=s("code"),Me=o("model(input_ids)"),be=p(),q=s("li"),$e=o(`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),V=s("code"),ne=o("model([input_ids, attention_mask])"),de=o(" or "),G=s("code"),me=o("model([input_ids, attention_mask, token_type_ids])"),Le=p(),N=s("li"),Fe=o(`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),Q=s("code"),xe=o('model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),se=p(),C=s("p"),Ee=o(`Note that when creating models and layers with
`),A=s("a"),Re=o("subclassing"),Xe=o(` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),this.h()},l(v){d=a(v,"P",{});var x=r(d);k=n(x,"TensorFlow models and layers in "),m=a(x,"CODE",{});var Qe=r(m);f=n(Qe,"transformers"),Qe.forEach(t),b=n(x," accept two formats as input:"),x.forEach(t),l=h(v),u=a(v,"UL",{});var Z=r(u);R=a(Z,"LI",{});var Ke=r(R);ke=n(Ke,"having all inputs as keyword arguments (like PyTorch models), or"),Ke.forEach(t),fe=h(Z),O=a(Z,"LI",{});var Ve=r(O);ce=n(Ve,"having all inputs as a list, tuple or dict in the first positional argument."),Ve.forEach(t),Z.forEach(t),te=h(v),F=a(v,"P",{});var X=r(F);ve=n(X,`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),W=a(X,"CODE",{});var Je=r(W);pe=n(Je,"model.fit()"),Je.forEach(t),Ce=n(X,` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),K=a(X,"CODE",{});var Ge=r(K);ae=n(Ge,"model.fit()"),Ge.forEach(t),re=n(X,` supports! If, however, you want to use the second
format outside of Keras methods like `),U=a(X,"CODE",{});var We=r(U);ie=n(We,"fit()"),We.forEach(t),ye=n(X," and "),B=a(X,"CODE",{});var qe=r(B);we=n(qe,"predict()"),qe.forEach(t),ge=n(X,`, such as when creating your own layers or models with
the Keras `),D=a(X,"CODE",{});var je=r(D);Te=n(je,"Functional"),je.forEach(t),le=n(X,` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),X.forEach(t),oe=h(v),z=a(v,"UL",{});var P=r(z);j=a(P,"LI",{});var S=r(j);he=n(S,"a single Tensor with "),J=a(S,"CODE",{});var Ye=r(J);_e=n(Ye,"input_ids"),Ye.forEach(t),ue=n(S," only and nothing else: "),H=a(S,"CODE",{});var Se=r(H);Me=n(Se,"model(input_ids)"),Se.forEach(t),S.forEach(t),be=h(P),q=a(P,"LI",{});var Y=r(q);$e=n(Y,`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),V=a(Y,"CODE",{});var Ue=r(V);ne=n(Ue,"model([input_ids, attention_mask])"),Ue.forEach(t),de=n(Y," or "),G=a(Y,"CODE",{});var Pe=r(G);me=n(Pe,"model([input_ids, attention_mask, token_type_ids])"),Pe.forEach(t),Y.forEach(t),Le=h(P),N=a(P,"LI",{});var ze=r(N);Fe=n(ze,`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),Q=a(ze,"CODE",{});var Be=r(Q);xe=n(Be,'model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),Be.forEach(t),ze.forEach(t),P.forEach(t),se=h(v),C=a(v,"P",{});var ee=r(C);Ee=n(ee,`Note that when creating models and layers with
`),A=a(ee,"A",{href:!0,rel:!0});var He=r(A);Re=n(He,"subclassing"),He.forEach(t),Xe=n(ee,` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),ee.forEach(t),this.h()},h(){c(A,"href","https://keras.io/guides/making_new_layers_and_models_via_subclassing/"),c(A,"rel","nofollow")},m(v,x){g(v,d,x),e(d,k),e(d,m),e(m,f),e(d,b),g(v,l,x),g(v,u,x),e(u,R),e(R,ke),e(u,fe),e(u,O),e(O,ce),g(v,te,x),g(v,F,x),e(F,ve),e(F,W),e(W,pe),e(F,Ce),e(F,K),e(K,ae),e(F,re),e(F,U),e(U,ie),e(F,ye),e(F,B),e(B,we),e(F,ge),e(F,D),e(D,Te),e(F,le),g(v,oe,x),g(v,z,x),e(z,j),e(j,he),e(j,J),e(J,_e),e(j,ue),e(j,H),e(H,Me),e(z,be),e(z,q),e(q,$e),e(q,V),e(V,ne),e(q,de),e(q,G),e(G,me),e(z,Le),e(z,N),e(N,Fe),e(N,Q),e(Q,xe),g(v,se,x),g(v,C,x),e(C,Ee),e(C,A),e(A,Re),e(C,Xe)},d(v){v&&t(d),v&&t(l),v&&t(u),v&&t(te),v&&t(F),v&&t(oe),v&&t(z),v&&t(se),v&&t(C)}}}function eq(E){let d,k,m,f,b;return{c(){d=s("p"),k=o("Although the recipe for forward pass needs to be defined within this function, one should call the "),m=s("code"),f=o("Module"),b=o(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Although the recipe for forward pass needs to be defined within this function, one should call the "),m=a(u,"CODE",{});var R=r(m);f=n(R,"Module"),R.forEach(t),b=n(u,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),u.forEach(t)},m(l,u){g(l,d,u),e(d,k),e(d,m),e(m,f),e(d,b)},d(l){l&&t(d)}}}function tq(E){let d,k,m,f,b;return f=new De({props:{code:`from transformers import AutoTokenizer, TFXLMRobertaForCausalLM
import tensorflow as tf

tokenizer = AutoTokenizer.from_pretrained("xlm-roberta-base")
model = TFXLMRobertaForCausalLM.from_pretrained("xlm-roberta-base")

inputs = tokenizer("Hello, my dog is cute", return_tensors="tf")
outputs = model(inputs)
logits = outputs.logits`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, TFXLMRobertaForCausalLM
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> tensorflow <span class="hljs-keyword">as</span> tf

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;xlm-roberta-base&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFXLMRobertaForCausalLM.from_pretrained(<span class="hljs-string">&quot;xlm-roberta-base&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;tf&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(inputs)
<span class="hljs-meta">&gt;&gt;&gt; </span>logits = outputs.logits`}}),{c(){d=s("p"),k=o("Example:"),m=p(),y(f.$$.fragment)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Example:"),u.forEach(t),m=h(l),w(f.$$.fragment,l)},m(l,u){g(l,d,u),e(d,k),g(l,m,u),T(f,l,u),b=!0},p:Ie,i(l){b||(M(f.$$.fragment,l),b=!0)},o(l){$(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(m),L(f,l)}}}function oq(E){let d,k,m,f,b,l,u,R,ke,fe,O,ce,te,F,ve,W,pe,Ce,K,ae,re,U,ie,ye,B,we,ge,D,Te,le,oe,z,j,he,J,_e,ue,H,Me,be,q,$e,V,ne,de,G,me,Le,N,Fe,Q,xe,se,C,Ee,A,Re,Xe;return{c(){d=s("p"),k=o("TensorFlow models and layers in "),m=s("code"),f=o("transformers"),b=o(" accept two formats as input:"),l=p(),u=s("ul"),R=s("li"),ke=o("having all inputs as keyword arguments (like PyTorch models), or"),fe=p(),O=s("li"),ce=o("having all inputs as a list, tuple or dict in the first positional argument."),te=p(),F=s("p"),ve=o(`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),W=s("code"),pe=o("model.fit()"),Ce=o(` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),K=s("code"),ae=o("model.fit()"),re=o(` supports! If, however, you want to use the second
format outside of Keras methods like `),U=s("code"),ie=o("fit()"),ye=o(" and "),B=s("code"),we=o("predict()"),ge=o(`, such as when creating your own layers or models with
the Keras `),D=s("code"),Te=o("Functional"),le=o(` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),oe=p(),z=s("ul"),j=s("li"),he=o("a single Tensor with "),J=s("code"),_e=o("input_ids"),ue=o(" only and nothing else: "),H=s("code"),Me=o("model(input_ids)"),be=p(),q=s("li"),$e=o(`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),V=s("code"),ne=o("model([input_ids, attention_mask])"),de=o(" or "),G=s("code"),me=o("model([input_ids, attention_mask, token_type_ids])"),Le=p(),N=s("li"),Fe=o(`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),Q=s("code"),xe=o('model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),se=p(),C=s("p"),Ee=o(`Note that when creating models and layers with
`),A=s("a"),Re=o("subclassing"),Xe=o(` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),this.h()},l(v){d=a(v,"P",{});var x=r(d);k=n(x,"TensorFlow models and layers in "),m=a(x,"CODE",{});var Qe=r(m);f=n(Qe,"transformers"),Qe.forEach(t),b=n(x," accept two formats as input:"),x.forEach(t),l=h(v),u=a(v,"UL",{});var Z=r(u);R=a(Z,"LI",{});var Ke=r(R);ke=n(Ke,"having all inputs as keyword arguments (like PyTorch models), or"),Ke.forEach(t),fe=h(Z),O=a(Z,"LI",{});var Ve=r(O);ce=n(Ve,"having all inputs as a list, tuple or dict in the first positional argument."),Ve.forEach(t),Z.forEach(t),te=h(v),F=a(v,"P",{});var X=r(F);ve=n(X,`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),W=a(X,"CODE",{});var Je=r(W);pe=n(Je,"model.fit()"),Je.forEach(t),Ce=n(X,` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),K=a(X,"CODE",{});var Ge=r(K);ae=n(Ge,"model.fit()"),Ge.forEach(t),re=n(X,` supports! If, however, you want to use the second
format outside of Keras methods like `),U=a(X,"CODE",{});var We=r(U);ie=n(We,"fit()"),We.forEach(t),ye=n(X," and "),B=a(X,"CODE",{});var qe=r(B);we=n(qe,"predict()"),qe.forEach(t),ge=n(X,`, such as when creating your own layers or models with
the Keras `),D=a(X,"CODE",{});var je=r(D);Te=n(je,"Functional"),je.forEach(t),le=n(X,` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),X.forEach(t),oe=h(v),z=a(v,"UL",{});var P=r(z);j=a(P,"LI",{});var S=r(j);he=n(S,"a single Tensor with "),J=a(S,"CODE",{});var Ye=r(J);_e=n(Ye,"input_ids"),Ye.forEach(t),ue=n(S," only and nothing else: "),H=a(S,"CODE",{});var Se=r(H);Me=n(Se,"model(input_ids)"),Se.forEach(t),S.forEach(t),be=h(P),q=a(P,"LI",{});var Y=r(q);$e=n(Y,`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),V=a(Y,"CODE",{});var Ue=r(V);ne=n(Ue,"model([input_ids, attention_mask])"),Ue.forEach(t),de=n(Y," or "),G=a(Y,"CODE",{});var Pe=r(G);me=n(Pe,"model([input_ids, attention_mask, token_type_ids])"),Pe.forEach(t),Y.forEach(t),Le=h(P),N=a(P,"LI",{});var ze=r(N);Fe=n(ze,`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),Q=a(ze,"CODE",{});var Be=r(Q);xe=n(Be,'model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),Be.forEach(t),ze.forEach(t),P.forEach(t),se=h(v),C=a(v,"P",{});var ee=r(C);Ee=n(ee,`Note that when creating models and layers with
`),A=a(ee,"A",{href:!0,rel:!0});var He=r(A);Re=n(He,"subclassing"),He.forEach(t),Xe=n(ee,` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),ee.forEach(t),this.h()},h(){c(A,"href","https://keras.io/guides/making_new_layers_and_models_via_subclassing/"),c(A,"rel","nofollow")},m(v,x){g(v,d,x),e(d,k),e(d,m),e(m,f),e(d,b),g(v,l,x),g(v,u,x),e(u,R),e(R,ke),e(u,fe),e(u,O),e(O,ce),g(v,te,x),g(v,F,x),e(F,ve),e(F,W),e(W,pe),e(F,Ce),e(F,K),e(K,ae),e(F,re),e(F,U),e(U,ie),e(F,ye),e(F,B),e(B,we),e(F,ge),e(F,D),e(D,Te),e(F,le),g(v,oe,x),g(v,z,x),e(z,j),e(j,he),e(j,J),e(J,_e),e(j,ue),e(j,H),e(H,Me),e(z,be),e(z,q),e(q,$e),e(q,V),e(V,ne),e(q,de),e(q,G),e(G,me),e(z,Le),e(z,N),e(N,Fe),e(N,Q),e(Q,xe),g(v,se,x),g(v,C,x),e(C,Ee),e(C,A),e(A,Re),e(C,Xe)},d(v){v&&t(d),v&&t(l),v&&t(u),v&&t(te),v&&t(F),v&&t(oe),v&&t(z),v&&t(se),v&&t(C)}}}function nq(E){let d,k,m,f,b;return{c(){d=s("p"),k=o("Although the recipe for forward pass needs to be defined within this function, one should call the "),m=s("code"),f=o("Module"),b=o(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Although the recipe for forward pass needs to be defined within this function, one should call the "),m=a(u,"CODE",{});var R=r(m);f=n(R,"Module"),R.forEach(t),b=n(u,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),u.forEach(t)},m(l,u){g(l,d,u),e(d,k),e(d,m),e(m,f),e(d,b)},d(l){l&&t(d)}}}function sq(E){let d,k,m,f,b;return f=new De({props:{code:`from transformers import AutoTokenizer, TFXLMRobertaForMaskedLM
import tensorflow as tf

tokenizer = AutoTokenizer.from_pretrained("xlm-roberta-base")
model = TFXLMRobertaForMaskedLM.from_pretrained("xlm-roberta-base")

inputs = tokenizer("The capital of France is <mask>.", return_tensors="tf")
logits = model(**inputs).logits

# retrieve index of <mask>
mask_token_index = tf.where((inputs.input_ids == tokenizer.mask_token_id)[0])
selected_logits = tf.gather_nd(logits[0], indices=mask_token_index)

predicted_token_id = tf.math.argmax(selected_logits, axis=-1)
tokenizer.decode(predicted_token_id)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, TFXLMRobertaForMaskedLM
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> tensorflow <span class="hljs-keyword">as</span> tf

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;xlm-roberta-base&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFXLMRobertaForMaskedLM.from_pretrained(<span class="hljs-string">&quot;xlm-roberta-base&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;The capital of France is &lt;mask&gt;.&quot;</span>, return_tensors=<span class="hljs-string">&quot;tf&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>logits = model(**inputs).logits

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># retrieve index of &lt;mask&gt;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>mask_token_index = tf.where((inputs.input_ids == tokenizer.mask_token_id)[<span class="hljs-number">0</span>])
<span class="hljs-meta">&gt;&gt;&gt; </span>selected_logits = tf.gather_nd(logits[<span class="hljs-number">0</span>], indices=mask_token_index)

<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_token_id = tf.math.argmax(selected_logits, axis=-<span class="hljs-number">1</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer.decode(predicted_token_id)
<span class="hljs-string">&#x27; Paris&#x27;</span>`}}),{c(){d=s("p"),k=o("Example:"),m=p(),y(f.$$.fragment)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Example:"),u.forEach(t),m=h(l),w(f.$$.fragment,l)},m(l,u){g(l,d,u),e(d,k),g(l,m,u),T(f,l,u),b=!0},p:Ie,i(l){b||(M(f.$$.fragment,l),b=!0)},o(l){$(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(m),L(f,l)}}}function aq(E){let d,k;return d=new De({props:{code:`labels = tokenizer("The capital of France is Paris.", return_tensors="tf")["input_ids"]
# mask labels of non-<mask> tokens
labels = tf.where(inputs.input_ids == tokenizer.mask_token_id, labels, -100)

outputs = model(**inputs, labels=labels)
round(float(outputs.loss), 2)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>labels = tokenizer(<span class="hljs-string">&quot;The capital of France is Paris.&quot;</span>, return_tensors=<span class="hljs-string">&quot;tf&quot;</span>)[<span class="hljs-string">&quot;input_ids&quot;</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># mask labels of non-&lt;mask&gt; tokens</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>labels = tf.where(inputs.input_ids == tokenizer.mask_token_id, labels, -<span class="hljs-number">100</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs, labels=labels)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">round</span>(<span class="hljs-built_in">float</span>(outputs.loss), <span class="hljs-number">2</span>)
<span class="hljs-number">0.1</span>`}}),{c(){y(d.$$.fragment)},l(m){w(d.$$.fragment,m)},m(m,f){T(d,m,f),k=!0},p:Ie,i(m){k||(M(d.$$.fragment,m),k=!0)},o(m){$(d.$$.fragment,m),k=!1},d(m){L(d,m)}}}function rq(E){let d,k,m,f,b,l,u,R,ke,fe,O,ce,te,F,ve,W,pe,Ce,K,ae,re,U,ie,ye,B,we,ge,D,Te,le,oe,z,j,he,J,_e,ue,H,Me,be,q,$e,V,ne,de,G,me,Le,N,Fe,Q,xe,se,C,Ee,A,Re,Xe;return{c(){d=s("p"),k=o("TensorFlow models and layers in "),m=s("code"),f=o("transformers"),b=o(" accept two formats as input:"),l=p(),u=s("ul"),R=s("li"),ke=o("having all inputs as keyword arguments (like PyTorch models), or"),fe=p(),O=s("li"),ce=o("having all inputs as a list, tuple or dict in the first positional argument."),te=p(),F=s("p"),ve=o(`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),W=s("code"),pe=o("model.fit()"),Ce=o(` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),K=s("code"),ae=o("model.fit()"),re=o(` supports! If, however, you want to use the second
format outside of Keras methods like `),U=s("code"),ie=o("fit()"),ye=o(" and "),B=s("code"),we=o("predict()"),ge=o(`, such as when creating your own layers or models with
the Keras `),D=s("code"),Te=o("Functional"),le=o(` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),oe=p(),z=s("ul"),j=s("li"),he=o("a single Tensor with "),J=s("code"),_e=o("input_ids"),ue=o(" only and nothing else: "),H=s("code"),Me=o("model(input_ids)"),be=p(),q=s("li"),$e=o(`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),V=s("code"),ne=o("model([input_ids, attention_mask])"),de=o(" or "),G=s("code"),me=o("model([input_ids, attention_mask, token_type_ids])"),Le=p(),N=s("li"),Fe=o(`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),Q=s("code"),xe=o('model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),se=p(),C=s("p"),Ee=o(`Note that when creating models and layers with
`),A=s("a"),Re=o("subclassing"),Xe=o(` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),this.h()},l(v){d=a(v,"P",{});var x=r(d);k=n(x,"TensorFlow models and layers in "),m=a(x,"CODE",{});var Qe=r(m);f=n(Qe,"transformers"),Qe.forEach(t),b=n(x," accept two formats as input:"),x.forEach(t),l=h(v),u=a(v,"UL",{});var Z=r(u);R=a(Z,"LI",{});var Ke=r(R);ke=n(Ke,"having all inputs as keyword arguments (like PyTorch models), or"),Ke.forEach(t),fe=h(Z),O=a(Z,"LI",{});var Ve=r(O);ce=n(Ve,"having all inputs as a list, tuple or dict in the first positional argument."),Ve.forEach(t),Z.forEach(t),te=h(v),F=a(v,"P",{});var X=r(F);ve=n(X,`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),W=a(X,"CODE",{});var Je=r(W);pe=n(Je,"model.fit()"),Je.forEach(t),Ce=n(X,` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),K=a(X,"CODE",{});var Ge=r(K);ae=n(Ge,"model.fit()"),Ge.forEach(t),re=n(X,` supports! If, however, you want to use the second
format outside of Keras methods like `),U=a(X,"CODE",{});var We=r(U);ie=n(We,"fit()"),We.forEach(t),ye=n(X," and "),B=a(X,"CODE",{});var qe=r(B);we=n(qe,"predict()"),qe.forEach(t),ge=n(X,`, such as when creating your own layers or models with
the Keras `),D=a(X,"CODE",{});var je=r(D);Te=n(je,"Functional"),je.forEach(t),le=n(X,` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),X.forEach(t),oe=h(v),z=a(v,"UL",{});var P=r(z);j=a(P,"LI",{});var S=r(j);he=n(S,"a single Tensor with "),J=a(S,"CODE",{});var Ye=r(J);_e=n(Ye,"input_ids"),Ye.forEach(t),ue=n(S," only and nothing else: "),H=a(S,"CODE",{});var Se=r(H);Me=n(Se,"model(input_ids)"),Se.forEach(t),S.forEach(t),be=h(P),q=a(P,"LI",{});var Y=r(q);$e=n(Y,`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),V=a(Y,"CODE",{});var Ue=r(V);ne=n(Ue,"model([input_ids, attention_mask])"),Ue.forEach(t),de=n(Y," or "),G=a(Y,"CODE",{});var Pe=r(G);me=n(Pe,"model([input_ids, attention_mask, token_type_ids])"),Pe.forEach(t),Y.forEach(t),Le=h(P),N=a(P,"LI",{});var ze=r(N);Fe=n(ze,`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),Q=a(ze,"CODE",{});var Be=r(Q);xe=n(Be,'model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),Be.forEach(t),ze.forEach(t),P.forEach(t),se=h(v),C=a(v,"P",{});var ee=r(C);Ee=n(ee,`Note that when creating models and layers with
`),A=a(ee,"A",{href:!0,rel:!0});var He=r(A);Re=n(He,"subclassing"),He.forEach(t),Xe=n(ee,` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),ee.forEach(t),this.h()},h(){c(A,"href","https://keras.io/guides/making_new_layers_and_models_via_subclassing/"),c(A,"rel","nofollow")},m(v,x){g(v,d,x),e(d,k),e(d,m),e(m,f),e(d,b),g(v,l,x),g(v,u,x),e(u,R),e(R,ke),e(u,fe),e(u,O),e(O,ce),g(v,te,x),g(v,F,x),e(F,ve),e(F,W),e(W,pe),e(F,Ce),e(F,K),e(K,ae),e(F,re),e(F,U),e(U,ie),e(F,ye),e(F,B),e(B,we),e(F,ge),e(F,D),e(D,Te),e(F,le),g(v,oe,x),g(v,z,x),e(z,j),e(j,he),e(j,J),e(J,_e),e(j,ue),e(j,H),e(H,Me),e(z,be),e(z,q),e(q,$e),e(q,V),e(V,ne),e(q,de),e(q,G),e(G,me),e(z,Le),e(z,N),e(N,Fe),e(N,Q),e(Q,xe),g(v,se,x),g(v,C,x),e(C,Ee),e(C,A),e(A,Re),e(C,Xe)},d(v){v&&t(d),v&&t(l),v&&t(u),v&&t(te),v&&t(F),v&&t(oe),v&&t(z),v&&t(se),v&&t(C)}}}function iq(E){let d,k,m,f,b;return{c(){d=s("p"),k=o("Although the recipe for forward pass needs to be defined within this function, one should call the "),m=s("code"),f=o("Module"),b=o(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Although the recipe for forward pass needs to be defined within this function, one should call the "),m=a(u,"CODE",{});var R=r(m);f=n(R,"Module"),R.forEach(t),b=n(u,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),u.forEach(t)},m(l,u){g(l,d,u),e(d,k),e(d,m),e(m,f),e(d,b)},d(l){l&&t(d)}}}function lq(E){let d,k,m,f,b;return f=new De({props:{code:`from transformers import AutoTokenizer, TFXLMRobertaForSequenceClassification
import tensorflow as tf

tokenizer = AutoTokenizer.from_pretrained("cardiffnlp/twitter-roberta-base-emotion")
model = TFXLMRobertaForSequenceClassification.from_pretrained("cardiffnlp/twitter-roberta-base-emotion")

inputs = tokenizer("Hello, my dog is cute", return_tensors="tf")

logits = model(**inputs).logits

predicted_class_id = int(tf.math.argmax(logits, axis=-1)[0])
model.config.id2label[predicted_class_id]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, TFXLMRobertaForSequenceClassification
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> tensorflow <span class="hljs-keyword">as</span> tf

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;cardiffnlp/twitter-roberta-base-emotion&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFXLMRobertaForSequenceClassification.from_pretrained(<span class="hljs-string">&quot;cardiffnlp/twitter-roberta-base-emotion&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;tf&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>logits = model(**inputs).logits

<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_class_id = <span class="hljs-built_in">int</span>(tf.math.argmax(logits, axis=-<span class="hljs-number">1</span>)[<span class="hljs-number">0</span>])
<span class="hljs-meta">&gt;&gt;&gt; </span>model.config.id2label[predicted_class_id]
<span class="hljs-string">&#x27;optimism&#x27;</span>`}}),{c(){d=s("p"),k=o("Example:"),m=p(),y(f.$$.fragment)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Example:"),u.forEach(t),m=h(l),w(f.$$.fragment,l)},m(l,u){g(l,d,u),e(d,k),g(l,m,u),T(f,l,u),b=!0},p:Ie,i(l){b||(M(f.$$.fragment,l),b=!0)},o(l){$(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(m),L(f,l)}}}function dq(E){let d,k;return d=new De({props:{code:'# To train a model on `num_labels` classes, you can pass `num_labels=num_labels` to `.from_pretrained(...)`\nnum_labels = len(model.config.id2label)\nmodel = TFXLMRobertaForSequenceClassification.from_pretrained("cardiffnlp/twitter-roberta-base-emotion", num_labels=num_labels)\n\nlabels = tf.constant(1)\nloss = model(**inputs, labels=labels).loss\nround(float(loss), 2)',highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># To train a model on \`num_labels\` classes, you can pass \`num_labels=num_labels\` to \`.from_pretrained(...)\`</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>num_labels = <span class="hljs-built_in">len</span>(model.config.id2label)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFXLMRobertaForSequenceClassification.from_pretrained(<span class="hljs-string">&quot;cardiffnlp/twitter-roberta-base-emotion&quot;</span>, num_labels=num_labels)

<span class="hljs-meta">&gt;&gt;&gt; </span>labels = tf.constant(<span class="hljs-number">1</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = model(**inputs, labels=labels).loss
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">round</span>(<span class="hljs-built_in">float</span>(loss), <span class="hljs-number">2</span>)
<span class="hljs-number">0.08</span>`}}),{c(){y(d.$$.fragment)},l(m){w(d.$$.fragment,m)},m(m,f){T(d,m,f),k=!0},p:Ie,i(m){k||(M(d.$$.fragment,m),k=!0)},o(m){$(d.$$.fragment,m),k=!1},d(m){L(d,m)}}}function cq(E){let d,k,m,f,b,l,u,R,ke,fe,O,ce,te,F,ve,W,pe,Ce,K,ae,re,U,ie,ye,B,we,ge,D,Te,le,oe,z,j,he,J,_e,ue,H,Me,be,q,$e,V,ne,de,G,me,Le,N,Fe,Q,xe,se,C,Ee,A,Re,Xe;return{c(){d=s("p"),k=o("TensorFlow models and layers in "),m=s("code"),f=o("transformers"),b=o(" accept two formats as input:"),l=p(),u=s("ul"),R=s("li"),ke=o("having all inputs as keyword arguments (like PyTorch models), or"),fe=p(),O=s("li"),ce=o("having all inputs as a list, tuple or dict in the first positional argument."),te=p(),F=s("p"),ve=o(`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),W=s("code"),pe=o("model.fit()"),Ce=o(` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),K=s("code"),ae=o("model.fit()"),re=o(` supports! If, however, you want to use the second
format outside of Keras methods like `),U=s("code"),ie=o("fit()"),ye=o(" and "),B=s("code"),we=o("predict()"),ge=o(`, such as when creating your own layers or models with
the Keras `),D=s("code"),Te=o("Functional"),le=o(` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),oe=p(),z=s("ul"),j=s("li"),he=o("a single Tensor with "),J=s("code"),_e=o("input_ids"),ue=o(" only and nothing else: "),H=s("code"),Me=o("model(input_ids)"),be=p(),q=s("li"),$e=o(`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),V=s("code"),ne=o("model([input_ids, attention_mask])"),de=o(" or "),G=s("code"),me=o("model([input_ids, attention_mask, token_type_ids])"),Le=p(),N=s("li"),Fe=o(`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),Q=s("code"),xe=o('model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),se=p(),C=s("p"),Ee=o(`Note that when creating models and layers with
`),A=s("a"),Re=o("subclassing"),Xe=o(` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),this.h()},l(v){d=a(v,"P",{});var x=r(d);k=n(x,"TensorFlow models and layers in "),m=a(x,"CODE",{});var Qe=r(m);f=n(Qe,"transformers"),Qe.forEach(t),b=n(x," accept two formats as input:"),x.forEach(t),l=h(v),u=a(v,"UL",{});var Z=r(u);R=a(Z,"LI",{});var Ke=r(R);ke=n(Ke,"having all inputs as keyword arguments (like PyTorch models), or"),Ke.forEach(t),fe=h(Z),O=a(Z,"LI",{});var Ve=r(O);ce=n(Ve,"having all inputs as a list, tuple or dict in the first positional argument."),Ve.forEach(t),Z.forEach(t),te=h(v),F=a(v,"P",{});var X=r(F);ve=n(X,`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),W=a(X,"CODE",{});var Je=r(W);pe=n(Je,"model.fit()"),Je.forEach(t),Ce=n(X,` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),K=a(X,"CODE",{});var Ge=r(K);ae=n(Ge,"model.fit()"),Ge.forEach(t),re=n(X,` supports! If, however, you want to use the second
format outside of Keras methods like `),U=a(X,"CODE",{});var We=r(U);ie=n(We,"fit()"),We.forEach(t),ye=n(X," and "),B=a(X,"CODE",{});var qe=r(B);we=n(qe,"predict()"),qe.forEach(t),ge=n(X,`, such as when creating your own layers or models with
the Keras `),D=a(X,"CODE",{});var je=r(D);Te=n(je,"Functional"),je.forEach(t),le=n(X,` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),X.forEach(t),oe=h(v),z=a(v,"UL",{});var P=r(z);j=a(P,"LI",{});var S=r(j);he=n(S,"a single Tensor with "),J=a(S,"CODE",{});var Ye=r(J);_e=n(Ye,"input_ids"),Ye.forEach(t),ue=n(S," only and nothing else: "),H=a(S,"CODE",{});var Se=r(H);Me=n(Se,"model(input_ids)"),Se.forEach(t),S.forEach(t),be=h(P),q=a(P,"LI",{});var Y=r(q);$e=n(Y,`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),V=a(Y,"CODE",{});var Ue=r(V);ne=n(Ue,"model([input_ids, attention_mask])"),Ue.forEach(t),de=n(Y," or "),G=a(Y,"CODE",{});var Pe=r(G);me=n(Pe,"model([input_ids, attention_mask, token_type_ids])"),Pe.forEach(t),Y.forEach(t),Le=h(P),N=a(P,"LI",{});var ze=r(N);Fe=n(ze,`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),Q=a(ze,"CODE",{});var Be=r(Q);xe=n(Be,'model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),Be.forEach(t),ze.forEach(t),P.forEach(t),se=h(v),C=a(v,"P",{});var ee=r(C);Ee=n(ee,`Note that when creating models and layers with
`),A=a(ee,"A",{href:!0,rel:!0});var He=r(A);Re=n(He,"subclassing"),He.forEach(t),Xe=n(ee,` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),ee.forEach(t),this.h()},h(){c(A,"href","https://keras.io/guides/making_new_layers_and_models_via_subclassing/"),c(A,"rel","nofollow")},m(v,x){g(v,d,x),e(d,k),e(d,m),e(m,f),e(d,b),g(v,l,x),g(v,u,x),e(u,R),e(R,ke),e(u,fe),e(u,O),e(O,ce),g(v,te,x),g(v,F,x),e(F,ve),e(F,W),e(W,pe),e(F,Ce),e(F,K),e(K,ae),e(F,re),e(F,U),e(U,ie),e(F,ye),e(F,B),e(B,we),e(F,ge),e(F,D),e(D,Te),e(F,le),g(v,oe,x),g(v,z,x),e(z,j),e(j,he),e(j,J),e(J,_e),e(j,ue),e(j,H),e(H,Me),e(z,be),e(z,q),e(q,$e),e(q,V),e(V,ne),e(q,de),e(q,G),e(G,me),e(z,Le),e(z,N),e(N,Fe),e(N,Q),e(Q,xe),g(v,se,x),g(v,C,x),e(C,Ee),e(C,A),e(A,Re),e(C,Xe)},d(v){v&&t(d),v&&t(l),v&&t(u),v&&t(te),v&&t(F),v&&t(oe),v&&t(z),v&&t(se),v&&t(C)}}}function pq(E){let d,k,m,f,b;return{c(){d=s("p"),k=o("Although the recipe for forward pass needs to be defined within this function, one should call the "),m=s("code"),f=o("Module"),b=o(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Although the recipe for forward pass needs to be defined within this function, one should call the "),m=a(u,"CODE",{});var R=r(m);f=n(R,"Module"),R.forEach(t),b=n(u,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),u.forEach(t)},m(l,u){g(l,d,u),e(d,k),e(d,m),e(m,f),e(d,b)},d(l){l&&t(d)}}}function hq(E){let d,k,m,f,b;return f=new De({props:{code:`from transformers import AutoTokenizer, TFXLMRobertaForMultipleChoice
import tensorflow as tf

tokenizer = AutoTokenizer.from_pretrained("xlm-roberta-base")
model = TFXLMRobertaForMultipleChoice.from_pretrained("xlm-roberta-base")

prompt = "In Italy, pizza served in formal settings, such as at a restaurant, is presented unsliced."
choice0 = "It is eaten with a fork and a knife."
choice1 = "It is eaten while held in the hand."

encoding = tokenizer([prompt, prompt], [choice0, choice1], return_tensors="tf", padding=True)
inputs = {k: tf.expand_dims(v, 0) for k, v in encoding.items()}
outputs = model(inputs)  # batch size is 1

# the linear classifier still needs to be trained
logits = outputs.logits`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, TFXLMRobertaForMultipleChoice
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> tensorflow <span class="hljs-keyword">as</span> tf

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;xlm-roberta-base&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFXLMRobertaForMultipleChoice.from_pretrained(<span class="hljs-string">&quot;xlm-roberta-base&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&quot;In Italy, pizza served in formal settings, such as at a restaurant, is presented unsliced.&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>choice0 = <span class="hljs-string">&quot;It is eaten with a fork and a knife.&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>choice1 = <span class="hljs-string">&quot;It is eaten while held in the hand.&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>encoding = tokenizer([prompt, prompt], [choice0, choice1], return_tensors=<span class="hljs-string">&quot;tf&quot;</span>, padding=<span class="hljs-literal">True</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = {k: tf.expand_dims(v, <span class="hljs-number">0</span>) <span class="hljs-keyword">for</span> k, v <span class="hljs-keyword">in</span> encoding.items()}
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(inputs)  <span class="hljs-comment"># batch size is 1</span>

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># the linear classifier still needs to be trained</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>logits = outputs.logits`}}),{c(){d=s("p"),k=o("Example:"),m=p(),y(f.$$.fragment)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Example:"),u.forEach(t),m=h(l),w(f.$$.fragment,l)},m(l,u){g(l,d,u),e(d,k),g(l,m,u),T(f,l,u),b=!0},p:Ie,i(l){b||(M(f.$$.fragment,l),b=!0)},o(l){$(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(m),L(f,l)}}}function uq(E){let d,k,m,f,b,l,u,R,ke,fe,O,ce,te,F,ve,W,pe,Ce,K,ae,re,U,ie,ye,B,we,ge,D,Te,le,oe,z,j,he,J,_e,ue,H,Me,be,q,$e,V,ne,de,G,me,Le,N,Fe,Q,xe,se,C,Ee,A,Re,Xe;return{c(){d=s("p"),k=o("TensorFlow models and layers in "),m=s("code"),f=o("transformers"),b=o(" accept two formats as input:"),l=p(),u=s("ul"),R=s("li"),ke=o("having all inputs as keyword arguments (like PyTorch models), or"),fe=p(),O=s("li"),ce=o("having all inputs as a list, tuple or dict in the first positional argument."),te=p(),F=s("p"),ve=o(`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),W=s("code"),pe=o("model.fit()"),Ce=o(` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),K=s("code"),ae=o("model.fit()"),re=o(` supports! If, however, you want to use the second
format outside of Keras methods like `),U=s("code"),ie=o("fit()"),ye=o(" and "),B=s("code"),we=o("predict()"),ge=o(`, such as when creating your own layers or models with
the Keras `),D=s("code"),Te=o("Functional"),le=o(` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),oe=p(),z=s("ul"),j=s("li"),he=o("a single Tensor with "),J=s("code"),_e=o("input_ids"),ue=o(" only and nothing else: "),H=s("code"),Me=o("model(input_ids)"),be=p(),q=s("li"),$e=o(`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),V=s("code"),ne=o("model([input_ids, attention_mask])"),de=o(" or "),G=s("code"),me=o("model([input_ids, attention_mask, token_type_ids])"),Le=p(),N=s("li"),Fe=o(`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),Q=s("code"),xe=o('model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),se=p(),C=s("p"),Ee=o(`Note that when creating models and layers with
`),A=s("a"),Re=o("subclassing"),Xe=o(` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),this.h()},l(v){d=a(v,"P",{});var x=r(d);k=n(x,"TensorFlow models and layers in "),m=a(x,"CODE",{});var Qe=r(m);f=n(Qe,"transformers"),Qe.forEach(t),b=n(x," accept two formats as input:"),x.forEach(t),l=h(v),u=a(v,"UL",{});var Z=r(u);R=a(Z,"LI",{});var Ke=r(R);ke=n(Ke,"having all inputs as keyword arguments (like PyTorch models), or"),Ke.forEach(t),fe=h(Z),O=a(Z,"LI",{});var Ve=r(O);ce=n(Ve,"having all inputs as a list, tuple or dict in the first positional argument."),Ve.forEach(t),Z.forEach(t),te=h(v),F=a(v,"P",{});var X=r(F);ve=n(X,`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),W=a(X,"CODE",{});var Je=r(W);pe=n(Je,"model.fit()"),Je.forEach(t),Ce=n(X,` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),K=a(X,"CODE",{});var Ge=r(K);ae=n(Ge,"model.fit()"),Ge.forEach(t),re=n(X,` supports! If, however, you want to use the second
format outside of Keras methods like `),U=a(X,"CODE",{});var We=r(U);ie=n(We,"fit()"),We.forEach(t),ye=n(X," and "),B=a(X,"CODE",{});var qe=r(B);we=n(qe,"predict()"),qe.forEach(t),ge=n(X,`, such as when creating your own layers or models with
the Keras `),D=a(X,"CODE",{});var je=r(D);Te=n(je,"Functional"),je.forEach(t),le=n(X,` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),X.forEach(t),oe=h(v),z=a(v,"UL",{});var P=r(z);j=a(P,"LI",{});var S=r(j);he=n(S,"a single Tensor with "),J=a(S,"CODE",{});var Ye=r(J);_e=n(Ye,"input_ids"),Ye.forEach(t),ue=n(S," only and nothing else: "),H=a(S,"CODE",{});var Se=r(H);Me=n(Se,"model(input_ids)"),Se.forEach(t),S.forEach(t),be=h(P),q=a(P,"LI",{});var Y=r(q);$e=n(Y,`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),V=a(Y,"CODE",{});var Ue=r(V);ne=n(Ue,"model([input_ids, attention_mask])"),Ue.forEach(t),de=n(Y," or "),G=a(Y,"CODE",{});var Pe=r(G);me=n(Pe,"model([input_ids, attention_mask, token_type_ids])"),Pe.forEach(t),Y.forEach(t),Le=h(P),N=a(P,"LI",{});var ze=r(N);Fe=n(ze,`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),Q=a(ze,"CODE",{});var Be=r(Q);xe=n(Be,'model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),Be.forEach(t),ze.forEach(t),P.forEach(t),se=h(v),C=a(v,"P",{});var ee=r(C);Ee=n(ee,`Note that when creating models and layers with
`),A=a(ee,"A",{href:!0,rel:!0});var He=r(A);Re=n(He,"subclassing"),He.forEach(t),Xe=n(ee,` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),ee.forEach(t),this.h()},h(){c(A,"href","https://keras.io/guides/making_new_layers_and_models_via_subclassing/"),c(A,"rel","nofollow")},m(v,x){g(v,d,x),e(d,k),e(d,m),e(m,f),e(d,b),g(v,l,x),g(v,u,x),e(u,R),e(R,ke),e(u,fe),e(u,O),e(O,ce),g(v,te,x),g(v,F,x),e(F,ve),e(F,W),e(W,pe),e(F,Ce),e(F,K),e(K,ae),e(F,re),e(F,U),e(U,ie),e(F,ye),e(F,B),e(B,we),e(F,ge),e(F,D),e(D,Te),e(F,le),g(v,oe,x),g(v,z,x),e(z,j),e(j,he),e(j,J),e(J,_e),e(j,ue),e(j,H),e(H,Me),e(z,be),e(z,q),e(q,$e),e(q,V),e(V,ne),e(q,de),e(q,G),e(G,me),e(z,Le),e(z,N),e(N,Fe),e(N,Q),e(Q,xe),g(v,se,x),g(v,C,x),e(C,Ee),e(C,A),e(A,Re),e(C,Xe)},d(v){v&&t(d),v&&t(l),v&&t(u),v&&t(te),v&&t(F),v&&t(oe),v&&t(z),v&&t(se),v&&t(C)}}}function mq(E){let d,k,m,f,b;return{c(){d=s("p"),k=o("Although the recipe for forward pass needs to be defined within this function, one should call the "),m=s("code"),f=o("Module"),b=o(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Although the recipe for forward pass needs to be defined within this function, one should call the "),m=a(u,"CODE",{});var R=r(m);f=n(R,"Module"),R.forEach(t),b=n(u,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),u.forEach(t)},m(l,u){g(l,d,u),e(d,k),e(d,m),e(m,f),e(d,b)},d(l){l&&t(d)}}}function fq(E){let d,k,m,f,b;return f=new De({props:{code:`from transformers import AutoTokenizer, TFXLMRobertaForTokenClassification
import tensorflow as tf

tokenizer = AutoTokenizer.from_pretrained("ydshieh/roberta-large-ner-english")
model = TFXLMRobertaForTokenClassification.from_pretrained("ydshieh/roberta-large-ner-english")

inputs = tokenizer(
    "HuggingFace is a company based in Paris and New York", add_special_tokens=False, return_tensors="tf"
)

logits = model(**inputs).logits
predicted_token_class_ids = tf.math.argmax(logits, axis=-1)

# Note that tokens are classified rather then input words which means that
# there might be more predicted token classes than words.
# Multiple token classes might account for the same word
predicted_tokens_classes = [model.config.id2label[t] for t in predicted_token_class_ids[0].numpy().tolist()]
predicted_tokens_classes`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, TFXLMRobertaForTokenClassification
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> tensorflow <span class="hljs-keyword">as</span> tf

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;ydshieh/roberta-large-ner-english&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFXLMRobertaForTokenClassification.from_pretrained(<span class="hljs-string">&quot;ydshieh/roberta-large-ner-english&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;HuggingFace is a company based in Paris and New York&quot;</span>, add_special_tokens=<span class="hljs-literal">False</span>, return_tensors=<span class="hljs-string">&quot;tf&quot;</span>
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>logits = model(**inputs).logits
<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_token_class_ids = tf.math.argmax(logits, axis=-<span class="hljs-number">1</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Note that tokens are classified rather then input words which means that</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># there might be more predicted token classes than words.</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Multiple token classes might account for the same word</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_tokens_classes = [model.config.id2label[t] <span class="hljs-keyword">for</span> t <span class="hljs-keyword">in</span> predicted_token_class_ids[<span class="hljs-number">0</span>].numpy().tolist()]
<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_tokens_classes
[<span class="hljs-string">&#x27;O&#x27;</span>, <span class="hljs-string">&#x27;ORG&#x27;</span>, <span class="hljs-string">&#x27;ORG&#x27;</span>, <span class="hljs-string">&#x27;O&#x27;</span>, <span class="hljs-string">&#x27;O&#x27;</span>, <span class="hljs-string">&#x27;O&#x27;</span>, <span class="hljs-string">&#x27;O&#x27;</span>, <span class="hljs-string">&#x27;O&#x27;</span>, <span class="hljs-string">&#x27;LOC&#x27;</span>, <span class="hljs-string">&#x27;O&#x27;</span>, <span class="hljs-string">&#x27;LOC&#x27;</span>, <span class="hljs-string">&#x27;LOC&#x27;</span>]`}}),{c(){d=s("p"),k=o("Example:"),m=p(),y(f.$$.fragment)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Example:"),u.forEach(t),m=h(l),w(f.$$.fragment,l)},m(l,u){g(l,d,u),e(d,k),g(l,m,u),T(f,l,u),b=!0},p:Ie,i(l){b||(M(f.$$.fragment,l),b=!0)},o(l){$(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(m),L(f,l)}}}function gq(E){let d,k;return d=new De({props:{code:`labels = predicted_token_class_ids
loss = tf.math.reduce_mean(model(**inputs, labels=labels).loss)
round(float(loss), 2)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>labels = predicted_token_class_ids
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = tf.math.reduce_mean(model(**inputs, labels=labels).loss)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">round</span>(<span class="hljs-built_in">float</span>(loss), <span class="hljs-number">2</span>)
<span class="hljs-number">0.01</span>`}}),{c(){y(d.$$.fragment)},l(m){w(d.$$.fragment,m)},m(m,f){T(d,m,f),k=!0},p:Ie,i(m){k||(M(d.$$.fragment,m),k=!0)},o(m){$(d.$$.fragment,m),k=!1},d(m){L(d,m)}}}function _q(E){let d,k,m,f,b,l,u,R,ke,fe,O,ce,te,F,ve,W,pe,Ce,K,ae,re,U,ie,ye,B,we,ge,D,Te,le,oe,z,j,he,J,_e,ue,H,Me,be,q,$e,V,ne,de,G,me,Le,N,Fe,Q,xe,se,C,Ee,A,Re,Xe;return{c(){d=s("p"),k=o("TensorFlow models and layers in "),m=s("code"),f=o("transformers"),b=o(" accept two formats as input:"),l=p(),u=s("ul"),R=s("li"),ke=o("having all inputs as keyword arguments (like PyTorch models), or"),fe=p(),O=s("li"),ce=o("having all inputs as a list, tuple or dict in the first positional argument."),te=p(),F=s("p"),ve=o(`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),W=s("code"),pe=o("model.fit()"),Ce=o(` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),K=s("code"),ae=o("model.fit()"),re=o(` supports! If, however, you want to use the second
format outside of Keras methods like `),U=s("code"),ie=o("fit()"),ye=o(" and "),B=s("code"),we=o("predict()"),ge=o(`, such as when creating your own layers or models with
the Keras `),D=s("code"),Te=o("Functional"),le=o(` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),oe=p(),z=s("ul"),j=s("li"),he=o("a single Tensor with "),J=s("code"),_e=o("input_ids"),ue=o(" only and nothing else: "),H=s("code"),Me=o("model(input_ids)"),be=p(),q=s("li"),$e=o(`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),V=s("code"),ne=o("model([input_ids, attention_mask])"),de=o(" or "),G=s("code"),me=o("model([input_ids, attention_mask, token_type_ids])"),Le=p(),N=s("li"),Fe=o(`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),Q=s("code"),xe=o('model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),se=p(),C=s("p"),Ee=o(`Note that when creating models and layers with
`),A=s("a"),Re=o("subclassing"),Xe=o(` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),this.h()},l(v){d=a(v,"P",{});var x=r(d);k=n(x,"TensorFlow models and layers in "),m=a(x,"CODE",{});var Qe=r(m);f=n(Qe,"transformers"),Qe.forEach(t),b=n(x," accept two formats as input:"),x.forEach(t),l=h(v),u=a(v,"UL",{});var Z=r(u);R=a(Z,"LI",{});var Ke=r(R);ke=n(Ke,"having all inputs as keyword arguments (like PyTorch models), or"),Ke.forEach(t),fe=h(Z),O=a(Z,"LI",{});var Ve=r(O);ce=n(Ve,"having all inputs as a list, tuple or dict in the first positional argument."),Ve.forEach(t),Z.forEach(t),te=h(v),F=a(v,"P",{});var X=r(F);ve=n(X,`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),W=a(X,"CODE",{});var Je=r(W);pe=n(Je,"model.fit()"),Je.forEach(t),Ce=n(X,` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),K=a(X,"CODE",{});var Ge=r(K);ae=n(Ge,"model.fit()"),Ge.forEach(t),re=n(X,` supports! If, however, you want to use the second
format outside of Keras methods like `),U=a(X,"CODE",{});var We=r(U);ie=n(We,"fit()"),We.forEach(t),ye=n(X," and "),B=a(X,"CODE",{});var qe=r(B);we=n(qe,"predict()"),qe.forEach(t),ge=n(X,`, such as when creating your own layers or models with
the Keras `),D=a(X,"CODE",{});var je=r(D);Te=n(je,"Functional"),je.forEach(t),le=n(X,` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),X.forEach(t),oe=h(v),z=a(v,"UL",{});var P=r(z);j=a(P,"LI",{});var S=r(j);he=n(S,"a single Tensor with "),J=a(S,"CODE",{});var Ye=r(J);_e=n(Ye,"input_ids"),Ye.forEach(t),ue=n(S," only and nothing else: "),H=a(S,"CODE",{});var Se=r(H);Me=n(Se,"model(input_ids)"),Se.forEach(t),S.forEach(t),be=h(P),q=a(P,"LI",{});var Y=r(q);$e=n(Y,`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),V=a(Y,"CODE",{});var Ue=r(V);ne=n(Ue,"model([input_ids, attention_mask])"),Ue.forEach(t),de=n(Y," or "),G=a(Y,"CODE",{});var Pe=r(G);me=n(Pe,"model([input_ids, attention_mask, token_type_ids])"),Pe.forEach(t),Y.forEach(t),Le=h(P),N=a(P,"LI",{});var ze=r(N);Fe=n(ze,`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),Q=a(ze,"CODE",{});var Be=r(Q);xe=n(Be,'model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),Be.forEach(t),ze.forEach(t),P.forEach(t),se=h(v),C=a(v,"P",{});var ee=r(C);Ee=n(ee,`Note that when creating models and layers with
`),A=a(ee,"A",{href:!0,rel:!0});var He=r(A);Re=n(He,"subclassing"),He.forEach(t),Xe=n(ee,` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),ee.forEach(t),this.h()},h(){c(A,"href","https://keras.io/guides/making_new_layers_and_models_via_subclassing/"),c(A,"rel","nofollow")},m(v,x){g(v,d,x),e(d,k),e(d,m),e(m,f),e(d,b),g(v,l,x),g(v,u,x),e(u,R),e(R,ke),e(u,fe),e(u,O),e(O,ce),g(v,te,x),g(v,F,x),e(F,ve),e(F,W),e(W,pe),e(F,Ce),e(F,K),e(K,ae),e(F,re),e(F,U),e(U,ie),e(F,ye),e(F,B),e(B,we),e(F,ge),e(F,D),e(D,Te),e(F,le),g(v,oe,x),g(v,z,x),e(z,j),e(j,he),e(j,J),e(J,_e),e(j,ue),e(j,H),e(H,Me),e(z,be),e(z,q),e(q,$e),e(q,V),e(V,ne),e(q,de),e(q,G),e(G,me),e(z,Le),e(z,N),e(N,Fe),e(N,Q),e(Q,xe),g(v,se,x),g(v,C,x),e(C,Ee),e(C,A),e(A,Re),e(C,Xe)},d(v){v&&t(d),v&&t(l),v&&t(u),v&&t(te),v&&t(F),v&&t(oe),v&&t(z),v&&t(se),v&&t(C)}}}function bq(E){let d,k,m,f,b;return{c(){d=s("p"),k=o("Although the recipe for forward pass needs to be defined within this function, one should call the "),m=s("code"),f=o("Module"),b=o(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Although the recipe for forward pass needs to be defined within this function, one should call the "),m=a(u,"CODE",{});var R=r(m);f=n(R,"Module"),R.forEach(t),b=n(u,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),u.forEach(t)},m(l,u){g(l,d,u),e(d,k),e(d,m),e(m,f),e(d,b)},d(l){l&&t(d)}}}function kq(E){let d,k,m,f,b;return f=new De({props:{code:`from transformers import AutoTokenizer, TFXLMRobertaForQuestionAnswering
import tensorflow as tf

tokenizer = AutoTokenizer.from_pretrained("ydshieh/roberta-base-squad2")
model = TFXLMRobertaForQuestionAnswering.from_pretrained("ydshieh/roberta-base-squad2")

question, text = "Who was Jim Henson?", "Jim Henson was a nice puppet"

inputs = tokenizer(question, text, return_tensors="tf")
outputs = model(**inputs)

answer_start_index = int(tf.math.argmax(outputs.start_logits, axis=-1)[0])
answer_end_index = int(tf.math.argmax(outputs.end_logits, axis=-1)[0])

predict_answer_tokens = inputs.input_ids[0, answer_start_index : answer_end_index + 1]
tokenizer.decode(predict_answer_tokens)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, TFXLMRobertaForQuestionAnswering
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> tensorflow <span class="hljs-keyword">as</span> tf

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;ydshieh/roberta-base-squad2&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFXLMRobertaForQuestionAnswering.from_pretrained(<span class="hljs-string">&quot;ydshieh/roberta-base-squad2&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>question, text = <span class="hljs-string">&quot;Who was Jim Henson?&quot;</span>, <span class="hljs-string">&quot;Jim Henson was a nice puppet&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(question, text, return_tensors=<span class="hljs-string">&quot;tf&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span>answer_start_index = <span class="hljs-built_in">int</span>(tf.math.argmax(outputs.start_logits, axis=-<span class="hljs-number">1</span>)[<span class="hljs-number">0</span>])
<span class="hljs-meta">&gt;&gt;&gt; </span>answer_end_index = <span class="hljs-built_in">int</span>(tf.math.argmax(outputs.end_logits, axis=-<span class="hljs-number">1</span>)[<span class="hljs-number">0</span>])

<span class="hljs-meta">&gt;&gt;&gt; </span>predict_answer_tokens = inputs.input_ids[<span class="hljs-number">0</span>, answer_start_index : answer_end_index + <span class="hljs-number">1</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer.decode(predict_answer_tokens)
<span class="hljs-string">&#x27; puppet&#x27;</span>`}}),{c(){d=s("p"),k=o("Example:"),m=p(),y(f.$$.fragment)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Example:"),u.forEach(t),m=h(l),w(f.$$.fragment,l)},m(l,u){g(l,d,u),e(d,k),g(l,m,u),T(f,l,u),b=!0},p:Ie,i(l){b||(M(f.$$.fragment,l),b=!0)},o(l){$(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(m),L(f,l)}}}function vq(E){let d,k;return d=new De({props:{code:`# target is "nice puppet"
target_start_index = tf.constant([14])
target_end_index = tf.constant([15])

outputs = model(**inputs, start_positions=target_start_index, end_positions=target_end_index)
loss = tf.math.reduce_mean(outputs.loss)
round(float(loss), 2)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># target is &quot;nice puppet&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>target_start_index = tf.constant([<span class="hljs-number">14</span>])
<span class="hljs-meta">&gt;&gt;&gt; </span>target_end_index = tf.constant([<span class="hljs-number">15</span>])

<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs, start_positions=target_start_index, end_positions=target_end_index)
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = tf.math.reduce_mean(outputs.loss)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">round</span>(<span class="hljs-built_in">float</span>(loss), <span class="hljs-number">2</span>)
<span class="hljs-number">0.86</span>`}}),{c(){y(d.$$.fragment)},l(m){w(d.$$.fragment,m)},m(m,f){T(d,m,f),k=!0},p:Ie,i(m){k||(M(d.$$.fragment,m),k=!0)},o(m){$(d.$$.fragment,m),k=!1},d(m){L(d,m)}}}function yq(E){let d,k,m,f,b;return{c(){d=s("p"),k=o("Although the recipe for forward pass needs to be defined within this function, one should call the "),m=s("code"),f=o("Module"),b=o(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Although the recipe for forward pass needs to be defined within this function, one should call the "),m=a(u,"CODE",{});var R=r(m);f=n(R,"Module"),R.forEach(t),b=n(u,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),u.forEach(t)},m(l,u){g(l,d,u),e(d,k),e(d,m),e(m,f),e(d,b)},d(l){l&&t(d)}}}function wq(E){let d,k,m,f,b;return f=new De({props:{code:`from transformers import AutoTokenizer, FlaxXLMRobertaModel

tokenizer = AutoTokenizer.from_pretrained("xlm-roberta-base")
model = FlaxXLMRobertaModel.from_pretrained("xlm-roberta-base")

inputs = tokenizer("Hello, my dog is cute", return_tensors="jax")
outputs = model(**inputs)

last_hidden_states = outputs.last_hidden_state`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, FlaxXLMRobertaModel

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;xlm-roberta-base&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = FlaxXLMRobertaModel.from_pretrained(<span class="hljs-string">&quot;xlm-roberta-base&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;jax&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span>last_hidden_states = outputs.last_hidden_state`}}),{c(){d=s("p"),k=o("Example:"),m=p(),y(f.$$.fragment)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Example:"),u.forEach(t),m=h(l),w(f.$$.fragment,l)},m(l,u){g(l,d,u),e(d,k),g(l,m,u),T(f,l,u),b=!0},p:Ie,i(l){b||(M(f.$$.fragment,l),b=!0)},o(l){$(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(m),L(f,l)}}}function Tq(E){let d,k,m,f,b;return{c(){d=s("p"),k=o("Although the recipe for forward pass needs to be defined within this function, one should call the "),m=s("code"),f=o("Module"),b=o(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Although the recipe for forward pass needs to be defined within this function, one should call the "),m=a(u,"CODE",{});var R=r(m);f=n(R,"Module"),R.forEach(t),b=n(u,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),u.forEach(t)},m(l,u){g(l,d,u),e(d,k),e(d,m),e(m,f),e(d,b)},d(l){l&&t(d)}}}function Mq(E){let d,k,m,f,b;return f=new De({props:{code:`from transformers import AutoTokenizer, FlaxXLMRobertaForCausalLM

tokenizer = AutoTokenizer.from_pretrained("xlm-roberta-base")
model = FlaxXLMRobertaForCausalLM.from_pretrained("xlm-roberta-base")

inputs = tokenizer("Hello, my dog is cute", return_tensors="np")
outputs = model(**inputs)

# retrieve logts for next token
next_token_logits = outputs.logits[:, -1]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, FlaxXLMRobertaForCausalLM

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;xlm-roberta-base&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = FlaxXLMRobertaForCausalLM.from_pretrained(<span class="hljs-string">&quot;xlm-roberta-base&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;np&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># retrieve logts for next token</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>next_token_logits = outputs.logits[:, -<span class="hljs-number">1</span>]`}}),{c(){d=s("p"),k=o("Example:"),m=p(),y(f.$$.fragment)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Example:"),u.forEach(t),m=h(l),w(f.$$.fragment,l)},m(l,u){g(l,d,u),e(d,k),g(l,m,u),T(f,l,u),b=!0},p:Ie,i(l){b||(M(f.$$.fragment,l),b=!0)},o(l){$(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(m),L(f,l)}}}function $q(E){let d,k,m,f,b;return{c(){d=s("p"),k=o("Although the recipe for forward pass needs to be defined within this function, one should call the "),m=s("code"),f=o("Module"),b=o(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Although the recipe for forward pass needs to be defined within this function, one should call the "),m=a(u,"CODE",{});var R=r(m);f=n(R,"Module"),R.forEach(t),b=n(u,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),u.forEach(t)},m(l,u){g(l,d,u),e(d,k),e(d,m),e(m,f),e(d,b)},d(l){l&&t(d)}}}function Lq(E){let d,k,m,f,b;return f=new De({props:{code:`from transformers import AutoTokenizer, FlaxXLMRobertaForMaskedLM

tokenizer = AutoTokenizer.from_pretrained("xlm-roberta-base")
model = FlaxXLMRobertaForMaskedLM.from_pretrained("xlm-roberta-base")

inputs = tokenizer("The capital of France is [MASK].", return_tensors="jax")

outputs = model(**inputs)
logits = outputs.logits`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, FlaxXLMRobertaForMaskedLM

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;xlm-roberta-base&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = FlaxXLMRobertaForMaskedLM.from_pretrained(<span class="hljs-string">&quot;xlm-roberta-base&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;The capital of France is [MASK].&quot;</span>, return_tensors=<span class="hljs-string">&quot;jax&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)
<span class="hljs-meta">&gt;&gt;&gt; </span>logits = outputs.logits`}}),{c(){d=s("p"),k=o("Example:"),m=p(),y(f.$$.fragment)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Example:"),u.forEach(t),m=h(l),w(f.$$.fragment,l)},m(l,u){g(l,d,u),e(d,k),g(l,m,u),T(f,l,u),b=!0},p:Ie,i(l){b||(M(f.$$.fragment,l),b=!0)},o(l){$(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(m),L(f,l)}}}function Fq(E){let d,k,m,f,b;return{c(){d=s("p"),k=o("Although the recipe for forward pass needs to be defined within this function, one should call the "),m=s("code"),f=o("Module"),b=o(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Although the recipe for forward pass needs to be defined within this function, one should call the "),m=a(u,"CODE",{});var R=r(m);f=n(R,"Module"),R.forEach(t),b=n(u,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),u.forEach(t)},m(l,u){g(l,d,u),e(d,k),e(d,m),e(m,f),e(d,b)},d(l){l&&t(d)}}}function xq(E){let d,k,m,f,b;return f=new De({props:{code:`from transformers import AutoTokenizer, FlaxXLMRobertaForSequenceClassification

tokenizer = AutoTokenizer.from_pretrained("xlm-roberta-base")
model = FlaxXLMRobertaForSequenceClassification.from_pretrained("xlm-roberta-base")

inputs = tokenizer("Hello, my dog is cute", return_tensors="jax")

outputs = model(**inputs)
logits = outputs.logits`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, FlaxXLMRobertaForSequenceClassification

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;xlm-roberta-base&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = FlaxXLMRobertaForSequenceClassification.from_pretrained(<span class="hljs-string">&quot;xlm-roberta-base&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;jax&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)
<span class="hljs-meta">&gt;&gt;&gt; </span>logits = outputs.logits`}}),{c(){d=s("p"),k=o("Example:"),m=p(),y(f.$$.fragment)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Example:"),u.forEach(t),m=h(l),w(f.$$.fragment,l)},m(l,u){g(l,d,u),e(d,k),g(l,m,u),T(f,l,u),b=!0},p:Ie,i(l){b||(M(f.$$.fragment,l),b=!0)},o(l){$(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(m),L(f,l)}}}function Eq(E){let d,k,m,f,b;return{c(){d=s("p"),k=o("Although the recipe for forward pass needs to be defined within this function, one should call the "),m=s("code"),f=o("Module"),b=o(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Although the recipe for forward pass needs to be defined within this function, one should call the "),m=a(u,"CODE",{});var R=r(m);f=n(R,"Module"),R.forEach(t),b=n(u,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),u.forEach(t)},m(l,u){g(l,d,u),e(d,k),e(d,m),e(m,f),e(d,b)},d(l){l&&t(d)}}}function Rq(E){let d,k,m,f,b;return f=new De({props:{code:`from transformers import AutoTokenizer, FlaxXLMRobertaForMultipleChoice

tokenizer = AutoTokenizer.from_pretrained("xlm-roberta-base")
model = FlaxXLMRobertaForMultipleChoice.from_pretrained("xlm-roberta-base")

prompt = "In Italy, pizza served in formal settings, such as at a restaurant, is presented unsliced."
choice0 = "It is eaten with a fork and a knife."
choice1 = "It is eaten while held in the hand."

encoding = tokenizer([prompt, prompt], [choice0, choice1], return_tensors="jax", padding=True)
outputs = model(**{k: v[None, :] for k, v in encoding.items()})

logits = outputs.logits`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, FlaxXLMRobertaForMultipleChoice

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;xlm-roberta-base&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = FlaxXLMRobertaForMultipleChoice.from_pretrained(<span class="hljs-string">&quot;xlm-roberta-base&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&quot;In Italy, pizza served in formal settings, such as at a restaurant, is presented unsliced.&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>choice0 = <span class="hljs-string">&quot;It is eaten with a fork and a knife.&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>choice1 = <span class="hljs-string">&quot;It is eaten while held in the hand.&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>encoding = tokenizer([prompt, prompt], [choice0, choice1], return_tensors=<span class="hljs-string">&quot;jax&quot;</span>, padding=<span class="hljs-literal">True</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**{k: v[<span class="hljs-literal">None</span>, :] <span class="hljs-keyword">for</span> k, v <span class="hljs-keyword">in</span> encoding.items()})

<span class="hljs-meta">&gt;&gt;&gt; </span>logits = outputs.logits`}}),{c(){d=s("p"),k=o("Example:"),m=p(),y(f.$$.fragment)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Example:"),u.forEach(t),m=h(l),w(f.$$.fragment,l)},m(l,u){g(l,d,u),e(d,k),g(l,m,u),T(f,l,u),b=!0},p:Ie,i(l){b||(M(f.$$.fragment,l),b=!0)},o(l){$(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(m),L(f,l)}}}function Xq(E){let d,k,m,f,b;return{c(){d=s("p"),k=o("Although the recipe for forward pass needs to be defined within this function, one should call the "),m=s("code"),f=o("Module"),b=o(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Although the recipe for forward pass needs to be defined within this function, one should call the "),m=a(u,"CODE",{});var R=r(m);f=n(R,"Module"),R.forEach(t),b=n(u,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),u.forEach(t)},m(l,u){g(l,d,u),e(d,k),e(d,m),e(m,f),e(d,b)},d(l){l&&t(d)}}}function zq(E){let d,k,m,f,b;return f=new De({props:{code:`from transformers import AutoTokenizer, FlaxXLMRobertaForTokenClassification

tokenizer = AutoTokenizer.from_pretrained("xlm-roberta-base")
model = FlaxXLMRobertaForTokenClassification.from_pretrained("xlm-roberta-base")

inputs = tokenizer("Hello, my dog is cute", return_tensors="jax")

outputs = model(**inputs)
logits = outputs.logits`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, FlaxXLMRobertaForTokenClassification

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;xlm-roberta-base&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = FlaxXLMRobertaForTokenClassification.from_pretrained(<span class="hljs-string">&quot;xlm-roberta-base&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;jax&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)
<span class="hljs-meta">&gt;&gt;&gt; </span>logits = outputs.logits`}}),{c(){d=s("p"),k=o("Example:"),m=p(),y(f.$$.fragment)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Example:"),u.forEach(t),m=h(l),w(f.$$.fragment,l)},m(l,u){g(l,d,u),e(d,k),g(l,m,u),T(f,l,u),b=!0},p:Ie,i(l){b||(M(f.$$.fragment,l),b=!0)},o(l){$(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(m),L(f,l)}}}function Cq(E){let d,k,m,f,b;return{c(){d=s("p"),k=o("Although the recipe for forward pass needs to be defined within this function, one should call the "),m=s("code"),f=o("Module"),b=o(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Although the recipe for forward pass needs to be defined within this function, one should call the "),m=a(u,"CODE",{});var R=r(m);f=n(R,"Module"),R.forEach(t),b=n(u,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),u.forEach(t)},m(l,u){g(l,d,u),e(d,k),e(d,m),e(m,f),e(d,b)},d(l){l&&t(d)}}}function qq(E){let d,k,m,f,b;return f=new De({props:{code:`from transformers import AutoTokenizer, FlaxXLMRobertaForQuestionAnswering

tokenizer = AutoTokenizer.from_pretrained("xlm-roberta-base")
model = FlaxXLMRobertaForQuestionAnswering.from_pretrained("xlm-roberta-base")

question, text = "Who was Jim Henson?", "Jim Henson was a nice puppet"
inputs = tokenizer(question, text, return_tensors="jax")

outputs = model(**inputs)
start_scores = outputs.start_logits
end_scores = outputs.end_logits`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, FlaxXLMRobertaForQuestionAnswering

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;xlm-roberta-base&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = FlaxXLMRobertaForQuestionAnswering.from_pretrained(<span class="hljs-string">&quot;xlm-roberta-base&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>question, text = <span class="hljs-string">&quot;Who was Jim Henson?&quot;</span>, <span class="hljs-string">&quot;Jim Henson was a nice puppet&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(question, text, return_tensors=<span class="hljs-string">&quot;jax&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)
<span class="hljs-meta">&gt;&gt;&gt; </span>start_scores = outputs.start_logits
<span class="hljs-meta">&gt;&gt;&gt; </span>end_scores = outputs.end_logits`}}),{c(){d=s("p"),k=o("Example:"),m=p(),y(f.$$.fragment)},l(l){d=a(l,"P",{});var u=r(d);k=n(u,"Example:"),u.forEach(t),m=h(l),w(f.$$.fragment,l)},m(l,u){g(l,d,u),e(d,k),g(l,m,u),T(f,l,u),b=!0},p:Ie,i(l){b||(M(f.$$.fragment,l),b=!0)},o(l){$(f.$$.fragment,l),b=!1},d(l){l&&t(d),l&&t(m),L(f,l)}}}function jq(E){let d,k,m,f,b,l,u,R,ke,fe,O,ce,te,F,ve,W,pe,Ce,K,ae,re,U,ie,ye,B,we,ge,D,Te,le,oe,z,j,he,J,_e,ue,H,Me,be,q,$e,V,ne,de,G,me,Le,N,Fe,Q,xe,se,C,Ee,A,Re,Xe,v,x,Qe,Z,Ke,Ve,X,Je,Ge,We,qe,je,P,S,Ye,Se,Y,Ue,Pe,ze,Be,ee,He,gt,Ec,Zb,lr,ek,tk,$o,Rc,ok,nk,dr,sk,ak,cr,rk,ik,lk,Lo,Xc,dk,ck,pr,pk,hk,hr,uk,mk,fk,Fo,zc,gk,_k,ur,bk,kk,mr,vk,yk,wk,Cc,fr,Tk,Mk,$k,zh,qc,Lk,kg,gr,vg,Lt,xo,jc,Fk,xk,_r,Ek,Rk,br,Xk,zk,Ck,Eo,Ac,qk,jk,kr,Ak,Pk,vr,Nk,Ok,Ik,as,Pc,Dk,Sk,yr,Wk,Uk,Bk,Nc,wr,Hk,Qk,Kk,Ch,Oc,Vk,yg,Tr,wg,Ro,Xo,Ic,Jk,Gk,Mr,Yk,Zk,$r,ev,tv,ov,Dc,Lr,nv,sv,av,qh,Sc,rv,Tg,Fr,Mg,Ft,zo,Wc,iv,lv,xr,dv,cv,Er,pv,hv,uv,Co,Uc,mv,fv,Rr,gv,_v,Xr,bv,kv,vv,qo,Bc,yv,wv,zr,Tv,Mv,Cr,$v,Lv,Fv,Hc,qr,xv,Ev,Rv,jh,Qc,Xv,$g,jr,Lg,xt,jo,Kc,zv,Cv,Ar,qv,jv,Pr,Av,Pv,Nv,Ao,Vc,Ov,Iv,Nr,Dv,Sv,Or,Wv,Uv,Bv,rs,Jc,Hv,Qv,Ir,Kv,Vv,Jv,Gc,Dr,Gv,Yv,Zv,Ah,Yc,ey,Fg,Zc,Ph,ty,xg,Po,No,ep,oy,ny,Sr,sy,ay,Wr,ry,iy,ly,Oo,tp,dy,cy,Ur,py,hy,Br,uy,my,fy,Nh,op,gy,Eg,np,_y,Rg,sp,Hr,by,Qr,ky,vy,Xg,ln,is,Oh,Kr,yy,Ih,wy,zg,Wt,Vr,Ty,go,My,ap,$y,Ly,rp,Fy,xy,Jr,Ey,Ry,Xy,dn,zy,ip,Cy,qy,lp,jy,Ay,Py,ls,Cg,cn,ds,Dh,Gr,Ny,Sh,Oy,qg,et,Yr,Iy,_o,Dy,dp,Sy,Wy,cp,Uy,By,Zr,Hy,Qy,Ky,ei,Vy,pp,Jy,Gy,Yy,Io,ti,Zy,Wh,e1,t1,oi,hp,o1,Uh,n1,s1,up,a1,Bh,r1,i1,cs,ni,l1,si,d1,Hh,c1,p1,h1,ps,ai,u1,Qh,m1,f1,mp,ri,jg,pn,hs,Kh,ii,g1,Vh,_1,Ag,bt,li,b1,Ut,k1,Jh,v1,y1,fp,w1,T1,gp,M1,$1,di,L1,F1,x1,ci,E1,_p,R1,X1,z1,Do,pi,C1,Gh,q1,j1,hi,bp,A1,Yh,P1,N1,kp,O1,Zh,I1,D1,us,ui,S1,eu,W1,Pg,hn,ms,tu,mi,U1,ou,B1,Ng,Ze,fi,H1,nu,Q1,K1,gi,V1,vp,J1,G1,Y1,_i,Z1,bi,ew,tw,ow,ki,nw,su,sw,aw,rw,lt,iw,au,lw,dw,ru,cw,pw,iu,hw,uw,lu,mw,fw,du,gw,_w,cu,bw,kw,vw,fs,yw,pu,ww,Tw,vi,Mw,$w,Ht,yi,Lw,un,Fw,yp,xw,Ew,hu,Rw,Xw,zw,gs,Cw,_s,Og,mn,bs,uu,wi,qw,mu,jw,Ig,kt,Ti,Aw,Mi,Pw,fu,Nw,Ow,Iw,$i,Dw,wp,Sw,Ww,Uw,Li,Bw,Fi,Hw,Qw,Kw,Qt,xi,Vw,fn,Jw,Tp,Gw,Yw,gu,Zw,eT,tT,ks,oT,vs,Dg,gn,ys,_u,Ei,nT,bu,sT,Sg,vt,Ri,aT,Xi,rT,ku,iT,lT,dT,zi,cT,Mp,pT,hT,uT,Ci,mT,qi,fT,gT,_T,Kt,ji,bT,_n,kT,$p,vT,yT,vu,wT,TT,MT,ws,$T,Ts,Wg,bn,Ms,yu,Ai,LT,wu,FT,Ug,yt,Pi,xT,Tu,ET,RT,Ni,XT,Lp,zT,CT,qT,Oi,jT,Ii,AT,PT,NT,Et,Di,OT,kn,IT,Fp,DT,ST,Mu,WT,UT,BT,$s,HT,Ls,QT,Fs,Bg,vn,xs,$u,Si,KT,Lu,VT,Hg,wt,Wi,JT,Fu,GT,YT,Ui,ZT,xp,eM,tM,oM,Bi,nM,Hi,sM,aM,rM,Vt,Qi,iM,yn,lM,Ep,dM,cM,xu,pM,hM,uM,Es,mM,Rs,Qg,wn,Xs,Eu,Ki,fM,Ru,gM,Kg,Tt,Vi,_M,Xu,bM,kM,Ji,vM,Rp,yM,wM,TM,Gi,MM,Yi,$M,LM,FM,Jt,Zi,xM,Tn,EM,Xp,RM,XM,zu,zM,CM,qM,zs,jM,Cs,Vg,Mn,qs,Cu,el,AM,qu,PM,Jg,Mt,tl,NM,$n,OM,ju,IM,DM,Au,SM,WM,UM,ol,BM,zp,HM,QM,KM,nl,VM,sl,JM,GM,YM,Gt,al,ZM,Ln,e$,Cp,t$,o$,Pu,n$,s$,a$,js,r$,As,Gg,Fn,Ps,Nu,rl,i$,Ou,l$,Yg,dt,il,d$,Iu,c$,p$,ll,h$,qp,u$,m$,f$,dl,g$,cl,_$,b$,k$,Ns,v$,Yt,pl,y$,xn,w$,jp,T$,M$,Du,$$,L$,F$,Os,x$,Is,Zg,En,Ds,Su,hl,E$,Wu,R$,e_,ct,ul,X$,ml,z$,Uu,C$,q$,j$,fl,A$,Ap,P$,N$,O$,gl,I$,_l,D$,S$,W$,Ss,U$,Zt,bl,B$,Rn,H$,Pp,Q$,K$,Bu,V$,J$,G$,Ws,Y$,Us,t_,Xn,Bs,Hu,kl,Z$,Qu,e2,o_,pt,vl,t2,yl,o2,Ku,n2,s2,a2,wl,r2,Np,i2,l2,d2,Tl,c2,Ml,p2,h2,u2,Hs,m2,Rt,$l,f2,zn,g2,Op,_2,b2,Vu,k2,v2,y2,Qs,w2,Ks,T2,Vs,n_,Cn,Js,Ju,Ll,M2,Gu,$2,s_,ht,Fl,L2,Yu,F2,x2,xl,E2,Ip,R2,X2,z2,El,C2,Rl,q2,j2,A2,Gs,P2,Xt,Xl,N2,qn,O2,Dp,I2,D2,Zu,S2,W2,U2,Ys,B2,Zs,H2,ea,a_,jn,ta,em,zl,Q2,tm,K2,r_,ut,Cl,V2,om,J2,G2,ql,Y2,Sp,Z2,eL,tL,jl,oL,Al,nL,sL,aL,oa,rL,eo,Pl,iL,An,lL,Wp,dL,cL,nm,pL,hL,uL,na,mL,sa,i_,Pn,aa,sm,Nl,fL,am,gL,l_,mt,Ol,_L,rm,bL,kL,Il,vL,Up,yL,wL,TL,Dl,ML,Sl,$L,LL,FL,ra,xL,zt,Wl,EL,Nn,RL,Bp,XL,zL,im,CL,qL,jL,ia,AL,la,PL,da,d_,On,ca,lm,Ul,NL,dm,OL,c_,ft,Bl,IL,In,DL,cm,SL,WL,pm,UL,BL,HL,Hl,QL,Hp,KL,VL,JL,Ql,GL,Kl,YL,ZL,eF,pa,tF,Ct,Vl,oF,Dn,nF,Qp,sF,aF,hm,rF,iF,lF,ha,dF,ua,cF,ma,p_,Sn,fa,um,Jl,pF,mm,hF,h_,tt,Gl,uF,fm,mF,fF,Yl,gF,Kp,_F,bF,kF,Zl,vF,ed,yF,wF,TF,gm,MF,$F,bo,_m,td,LF,FF,bm,od,xF,EF,km,nd,RF,XF,vm,sd,zF,CF,to,ad,qF,Wn,jF,ym,AF,PF,wm,NF,OF,IF,ga,DF,_a,u_,Un,ba,Tm,rd,SF,Mm,WF,m_,ot,id,UF,$m,BF,HF,ld,QF,Vp,KF,VF,JF,dd,GF,cd,YF,ZF,ex,Lm,tx,ox,ko,Fm,pd,nx,sx,xm,hd,ax,rx,Em,ud,ix,lx,Rm,md,dx,cx,oo,fd,px,Bn,hx,Xm,ux,mx,zm,fx,gx,_x,ka,bx,va,f_,Hn,ya,Cm,gd,kx,qm,vx,g_,nt,_d,yx,bd,wx,jm,Tx,Mx,$x,kd,Lx,Jp,Fx,xx,Ex,vd,Rx,yd,Xx,zx,Cx,Am,qx,jx,vo,Pm,wd,Ax,Px,Nm,Td,Nx,Ox,Om,Md,Ix,Dx,Im,$d,Sx,Wx,no,Ld,Ux,Qn,Bx,Dm,Hx,Qx,Sm,Kx,Vx,Jx,wa,Gx,Ta,__,Kn,Ma,Wm,Fd,Yx,Um,Zx,b_,st,xd,e0,Bm,t0,o0,Ed,n0,Gp,s0,a0,r0,Rd,i0,Xd,l0,d0,c0,Hm,p0,h0,yo,Qm,zd,u0,m0,Km,Cd,f0,g0,Vm,qd,_0,b0,Jm,jd,k0,v0,so,Ad,y0,Vn,w0,Gm,T0,M0,Ym,$0,L0,F0,$a,x0,La,k_,Jn,Fa,Zm,Pd,E0,ef,R0,v_,at,Nd,X0,tf,z0,C0,Od,q0,Yp,j0,A0,P0,Id,N0,Dd,O0,I0,D0,of,S0,W0,wo,nf,Sd,U0,B0,sf,Wd,H0,Q0,af,Ud,K0,V0,rf,Bd,J0,G0,ao,Hd,Y0,Gn,Z0,lf,e5,t5,df,o5,n5,s5,xa,a5,Ea,y_,Yn,Ra,cf,Qd,r5,pf,i5,w_,rt,Kd,l5,hf,d5,c5,Vd,p5,Zp,h5,u5,m5,Jd,f5,Gd,g5,_5,b5,uf,k5,v5,To,mf,Yd,y5,w5,ff,Zd,T5,M5,gf,ec,$5,L5,_f,tc,F5,x5,ro,oc,E5,Zn,R5,bf,X5,z5,kf,C5,q5,j5,Xa,A5,za,T_,es,Ca,vf,nc,P5,yf,N5,M_,it,sc,O5,ts,I5,wf,D5,S5,Tf,W5,U5,B5,ac,H5,eh,Q5,K5,V5,rc,J5,ic,G5,Y5,Z5,Mf,eE,tE,Mo,$f,lc,oE,nE,Lf,dc,sE,aE,Ff,cc,rE,iE,xf,pc,lE,dE,io,hc,cE,os,pE,Ef,hE,uE,Rf,mE,fE,gE,qa,_E,ja,$_;return l=new Ne({}),ie=new Ne({}),S=new Ne({}),ee=new bg({props:{pipeline:"text-classification"}}),gr=new bg({props:{pipeline:"token-classification"}}),Tr=new bg({props:{pipeline:"text-generation"}}),Fr=new bg({props:{pipeline:"fill-mask"}}),jr=new bg({props:{pipeline:"question-answering"}}),Kr=new Ne({}),Vr=new I({props:{name:"class transformers.XLMRobertaConfig",anchor:"transformers.XLMRobertaConfig",parameters:[{name:"vocab_size",val:" = 30522"},{name:"hidden_size",val:" = 768"},{name:"num_hidden_layers",val:" = 12"},{name:"num_attention_heads",val:" = 12"},{name:"intermediate_size",val:" = 3072"},{name:"hidden_act",val:" = 'gelu'"},{name:"hidden_dropout_prob",val:" = 0.1"},{name:"attention_probs_dropout_prob",val:" = 0.1"},{name:"max_position_embeddings",val:" = 512"},{name:"type_vocab_size",val:" = 2"},{name:"initializer_range",val:" = 0.02"},{name:"layer_norm_eps",val:" = 1e-12"},{name:"pad_token_id",val:" = 1"},{name:"bos_token_id",val:" = 0"},{name:"eos_token_id",val:" = 2"},{name:"position_embedding_type",val:" = 'absolute'"},{name:"use_cache",val:" = True"},{name:"classifier_dropout",val:" = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.XLMRobertaConfig.vocab_size",description:`<strong>vocab_size</strong> (<code>int</code>, <em>optional</em>, defaults to 30522) &#x2014;
Vocabulary size of the XLM-RoBERTa model. Defines the number of different tokens that can be represented by
the <code>inputs_ids</code> passed when calling <a href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaModel">XLMRobertaModel</a> or <a href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.TFXLMRobertaModel">TFXLMRobertaModel</a>.`,name:"vocab_size"},{anchor:"transformers.XLMRobertaConfig.hidden_size",description:`<strong>hidden_size</strong> (<code>int</code>, <em>optional</em>, defaults to 768) &#x2014;
Dimensionality of the encoder layers and the pooler layer.`,name:"hidden_size"},{anchor:"transformers.XLMRobertaConfig.num_hidden_layers",description:`<strong>num_hidden_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 12) &#x2014;
Number of hidden layers in the Transformer encoder.`,name:"num_hidden_layers"},{anchor:"transformers.XLMRobertaConfig.num_attention_heads",description:`<strong>num_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 12) &#x2014;
Number of attention heads for each attention layer in the Transformer encoder.`,name:"num_attention_heads"},{anchor:"transformers.XLMRobertaConfig.intermediate_size",description:`<strong>intermediate_size</strong> (<code>int</code>, <em>optional</em>, defaults to 3072) &#x2014;
Dimensionality of the &#x201C;intermediate&#x201D; (often named feed-forward) layer in the Transformer encoder.`,name:"intermediate_size"},{anchor:"transformers.XLMRobertaConfig.hidden_act",description:`<strong>hidden_act</strong> (<code>str</code> or <code>Callable</code>, <em>optional</em>, defaults to <code>&quot;gelu&quot;</code>) &#x2014;
The non-linear activation function (function or string) in the encoder and pooler. If string, <code>&quot;gelu&quot;</code>,
<code>&quot;relu&quot;</code>, <code>&quot;silu&quot;</code> and <code>&quot;gelu_new&quot;</code> are supported.`,name:"hidden_act"},{anchor:"transformers.XLMRobertaConfig.hidden_dropout_prob",description:`<strong>hidden_dropout_prob</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
The dropout probability for all fully connected layers in the embeddings, encoder, and pooler.`,name:"hidden_dropout_prob"},{anchor:"transformers.XLMRobertaConfig.attention_probs_dropout_prob",description:`<strong>attention_probs_dropout_prob</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
The dropout ratio for the attention probabilities.`,name:"attention_probs_dropout_prob"},{anchor:"transformers.XLMRobertaConfig.max_position_embeddings",description:`<strong>max_position_embeddings</strong> (<code>int</code>, <em>optional</em>, defaults to 512) &#x2014;
The maximum sequence length that this model might ever be used with. Typically set this to something large
just in case (e.g., 512 or 1024 or 2048).`,name:"max_position_embeddings"},{anchor:"transformers.XLMRobertaConfig.type_vocab_size",description:`<strong>type_vocab_size</strong> (<code>int</code>, <em>optional</em>, defaults to 2) &#x2014;
The vocabulary size of the <code>token_type_ids</code> passed when calling <a href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaModel">XLMRobertaModel</a> or
<a href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.TFXLMRobertaModel">TFXLMRobertaModel</a>.`,name:"type_vocab_size"},{anchor:"transformers.XLMRobertaConfig.initializer_range",description:`<strong>initializer_range</strong> (<code>float</code>, <em>optional</em>, defaults to 0.02) &#x2014;
The standard deviation of the truncated_normal_initializer for initializing all weight matrices.`,name:"initializer_range"},{anchor:"transformers.XLMRobertaConfig.layer_norm_eps",description:`<strong>layer_norm_eps</strong> (<code>float</code>, <em>optional</em>, defaults to 1e-12) &#x2014;
The epsilon used by the layer normalization layers.`,name:"layer_norm_eps"},{anchor:"transformers.XLMRobertaConfig.position_embedding_type",description:`<strong>position_embedding_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;absolute&quot;</code>) &#x2014;
Type of position embedding. Choose one of <code>&quot;absolute&quot;</code>, <code>&quot;relative_key&quot;</code>, <code>&quot;relative_key_query&quot;</code>. For
positional embeddings use <code>&quot;absolute&quot;</code>. For more information on <code>&quot;relative_key&quot;</code>, please refer to
<a href="https://arxiv.org/abs/1803.02155" rel="nofollow">Self-Attention with Relative Position Representations (Shaw et al.)</a>.
For more information on <code>&quot;relative_key_query&quot;</code>, please refer to <em>Method 4</em> in <a href="https://arxiv.org/abs/2009.13658" rel="nofollow">Improve Transformer Models
with Better Relative Position Embeddings (Huang et al.)</a>.`,name:"position_embedding_type"},{anchor:"transformers.XLMRobertaConfig.is_decoder",description:`<strong>is_decoder</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether the model is used as a decoder or not. If <code>False</code>, the model is used as an encoder.`,name:"is_decoder"},{anchor:"transformers.XLMRobertaConfig.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not the model should return the last key/values attentions (not used by all models). Only
relevant if <code>config.is_decoder=True</code>.`,name:"use_cache"},{anchor:"transformers.XLMRobertaConfig.classifier_dropout",description:`<strong>classifier_dropout</strong> (<code>float</code>, <em>optional</em>) &#x2014;
The dropout ratio for the classification head.`,name:"classifier_dropout"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/configuration_xlm_roberta.py#L45"}}),ls=new Oe({props:{anchor:"transformers.XLMRobertaConfig.example",$$slots:{default:[q8]},$$scope:{ctx:E}}}),Gr=new Ne({}),Yr=new I({props:{name:"class transformers.XLMRobertaTokenizer",anchor:"transformers.XLMRobertaTokenizer",parameters:[{name:"vocab_file",val:""},{name:"bos_token",val:" = '<s>'"},{name:"eos_token",val:" = '</s>'"},{name:"sep_token",val:" = '</s>'"},{name:"cls_token",val:" = '<s>'"},{name:"unk_token",val:" = '<unk>'"},{name:"pad_token",val:" = '<pad>'"},{name:"mask_token",val:" = '<mask>'"},{name:"sp_model_kwargs",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.XLMRobertaTokenizer.vocab_file",description:`<strong>vocab_file</strong> (<code>str</code>) &#x2014;
Path to the vocabulary file.`,name:"vocab_file"},{anchor:"transformers.XLMRobertaTokenizer.bos_token",description:`<strong>bos_token</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&lt;s&gt;&quot;</code>) &#x2014;
The beginning of sequence token that was used during pretraining. Can be used a sequence classifier token.</p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						
<p>When building a sequence using special tokens, this is not the token that is used for the beginning of
sequence. The token used is the <code>cls_token</code>.</p>

					</div>`,name:"bos_token"},{anchor:"transformers.XLMRobertaTokenizer.eos_token",description:`<strong>eos_token</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&lt;/s&gt;&quot;</code>) &#x2014;
The end of sequence token.</p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						
<p>When building a sequence using special tokens, this is not the token that is used for the end of sequence.
The token used is the <code>sep_token</code>.</p>

					</div>`,name:"eos_token"},{anchor:"transformers.XLMRobertaTokenizer.sep_token",description:`<strong>sep_token</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&lt;/s&gt;&quot;</code>) &#x2014;
The separator token, which is used when building a sequence from multiple sequences, e.g. two sequences for
sequence classification or for a text and a question for question answering. It is also used as the last
token of a sequence built with special tokens.`,name:"sep_token"},{anchor:"transformers.XLMRobertaTokenizer.cls_token",description:`<strong>cls_token</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&lt;s&gt;&quot;</code>) &#x2014;
The classifier token which is used when doing sequence classification (classification of the whole sequence
instead of per-token classification). It is the first token of the sequence when built with special tokens.`,name:"cls_token"},{anchor:"transformers.XLMRobertaTokenizer.unk_token",description:`<strong>unk_token</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&lt;unk&gt;&quot;</code>) &#x2014;
The unknown token. A token that is not in the vocabulary cannot be converted to an ID and is set to be this
token instead.`,name:"unk_token"},{anchor:"transformers.XLMRobertaTokenizer.pad_token",description:`<strong>pad_token</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&lt;pad&gt;&quot;</code>) &#x2014;
The token used for padding, for example when batching sequences of different lengths.`,name:"pad_token"},{anchor:"transformers.XLMRobertaTokenizer.mask_token",description:`<strong>mask_token</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&lt;mask&gt;&quot;</code>) &#x2014;
The token used for masking values. This is the token used when training this model with masked language
modeling. This is the token which the model will try to predict.`,name:"mask_token"},{anchor:"transformers.XLMRobertaTokenizer.additional_special_tokens",description:`<strong>additional_special_tokens</strong> (<code>List[str]</code>, <em>optional</em>, defaults to <code>[&quot;&lt;s&gt;NOTUSED&quot;, &quot;&lt;/s&gt;NOTUSED&quot;]</code>) &#x2014;
Additional special tokens used by the tokenizer.`,name:"additional_special_tokens"},{anchor:"transformers.XLMRobertaTokenizer.sp_model_kwargs",description:`<strong>sp_model_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Will be passed to the <code>SentencePieceProcessor.__init__()</code> method. The <a href="https://github.com/google/sentencepiece/tree/master/python" rel="nofollow">Python wrapper for
SentencePiece</a> can be used, among other things,
to set:</p>
<ul>
<li>
<p><code>enable_sampling</code>: Enable subword regularization.</p>
</li>
<li>
<p><code>nbest_size</code>: Sampling parameters for unigram. Invalid for BPE-Dropout.</p>
<ul>
<li><code>nbest_size = {0,1}</code>: No sampling is performed.</li>
<li><code>nbest_size &gt; 1</code>: samples from the nbest_size results.</li>
<li><code>nbest_size &lt; 0</code>: assuming that nbest_size is infinite and samples from the all hypothesis (lattice)
using forward-filtering-and-backward-sampling algorithm.</li>
</ul>
</li>
<li>
<p><code>alpha</code>: Smoothing parameter for unigram sampling, and dropout probability of merge operations for
BPE-dropout.</p>
</li>
</ul>`,name:"sp_model_kwargs"},{anchor:"transformers.XLMRobertaTokenizer.sp_model",description:`<strong>sp_model</strong> (<code>SentencePieceProcessor</code>) &#x2014;
The <em>SentencePiece</em> processor that is used for every conversion (string, tokens and IDs).`,name:"sp_model"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/tokenization_xlm_roberta.py#L63"}}),ti=new I({props:{name:"build_inputs_with_special_tokens",anchor:"transformers.XLMRobertaTokenizer.build_inputs_with_special_tokens",parameters:[{name:"token_ids_0",val:": typing.List[int]"},{name:"token_ids_1",val:": typing.Optional[typing.List[int]] = None"}],parametersDescription:[{anchor:"transformers.XLMRobertaTokenizer.build_inputs_with_special_tokens.token_ids_0",description:`<strong>token_ids_0</strong> (<code>List[int]</code>) &#x2014;
List of IDs to which the special tokens will be added.`,name:"token_ids_0"},{anchor:"transformers.XLMRobertaTokenizer.build_inputs_with_special_tokens.token_ids_1",description:`<strong>token_ids_1</strong> (<code>List[int]</code>, <em>optional</em>) &#x2014;
Optional second list of IDs for sequence pairs.`,name:"token_ids_1"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/tokenization_xlm_roberta.py#L202",returnDescription:`
<p>List of <a href="../glossary#input-ids">input IDs</a> with the appropriate special tokens.</p>
`,returnType:`
<p><code>List[int]</code></p>
`}}),ni=new I({props:{name:"get_special_tokens_mask",anchor:"transformers.XLMRobertaTokenizer.get_special_tokens_mask",parameters:[{name:"token_ids_0",val:": typing.List[int]"},{name:"token_ids_1",val:": typing.Optional[typing.List[int]] = None"},{name:"already_has_special_tokens",val:": bool = False"}],parametersDescription:[{anchor:"transformers.XLMRobertaTokenizer.get_special_tokens_mask.token_ids_0",description:`<strong>token_ids_0</strong> (<code>List[int]</code>) &#x2014;
List of IDs.`,name:"token_ids_0"},{anchor:"transformers.XLMRobertaTokenizer.get_special_tokens_mask.token_ids_1",description:`<strong>token_ids_1</strong> (<code>List[int]</code>, <em>optional</em>) &#x2014;
Optional second list of IDs for sequence pairs.`,name:"token_ids_1"},{anchor:"transformers.XLMRobertaTokenizer.get_special_tokens_mask.already_has_special_tokens",description:`<strong>already_has_special_tokens</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not the token list is already formatted with special tokens for the model.`,name:"already_has_special_tokens"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/tokenization_xlm_roberta.py#L228",returnDescription:`
<p>A list of integers in the range [0, 1]: 1 for a special token, 0 for a sequence token.</p>
`,returnType:`
<p><code>List[int]</code></p>
`}}),ai=new I({props:{name:"create_token_type_ids_from_sequences",anchor:"transformers.XLMRobertaTokenizer.create_token_type_ids_from_sequences",parameters:[{name:"token_ids_0",val:": typing.List[int]"},{name:"token_ids_1",val:": typing.Optional[typing.List[int]] = None"}],parametersDescription:[{anchor:"transformers.XLMRobertaTokenizer.create_token_type_ids_from_sequences.token_ids_0",description:`<strong>token_ids_0</strong> (<code>List[int]</code>) &#x2014;
List of IDs.`,name:"token_ids_0"},{anchor:"transformers.XLMRobertaTokenizer.create_token_type_ids_from_sequences.token_ids_1",description:`<strong>token_ids_1</strong> (<code>List[int]</code>, <em>optional</em>) &#x2014;
Optional second list of IDs for sequence pairs.`,name:"token_ids_1"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/tokenization_xlm_roberta.py#L256",returnDescription:`
<p>List of zeros.</p>
`,returnType:`
<p><code>List[int]</code></p>
`}}),ri=new I({props:{name:"save_vocabulary",anchor:"transformers.XLMRobertaTokenizer.save_vocabulary",parameters:[{name:"save_directory",val:": str"},{name:"filename_prefix",val:": typing.Optional[str] = None"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/tokenization_xlm_roberta.py#L313"}}),ii=new Ne({}),li=new I({props:{name:"class transformers.XLMRobertaTokenizerFast",anchor:"transformers.XLMRobertaTokenizerFast",parameters:[{name:"vocab_file",val:" = None"},{name:"tokenizer_file",val:" = None"},{name:"bos_token",val:" = '<s>'"},{name:"eos_token",val:" = '</s>'"},{name:"sep_token",val:" = '</s>'"},{name:"cls_token",val:" = '<s>'"},{name:"unk_token",val:" = '<unk>'"},{name:"pad_token",val:" = '<pad>'"},{name:"mask_token",val:" = '<mask>'"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.XLMRobertaTokenizerFast.vocab_file",description:`<strong>vocab_file</strong> (<code>str</code>) &#x2014;
Path to the vocabulary file.`,name:"vocab_file"},{anchor:"transformers.XLMRobertaTokenizerFast.bos_token",description:`<strong>bos_token</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&lt;s&gt;&quot;</code>) &#x2014;
The beginning of sequence token that was used during pretraining. Can be used a sequence classifier token.</p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						
<p>When building a sequence using special tokens, this is not the token that is used for the beginning of
sequence. The token used is the <code>cls_token</code>.</p>

					</div>`,name:"bos_token"},{anchor:"transformers.XLMRobertaTokenizerFast.eos_token",description:`<strong>eos_token</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&lt;/s&gt;&quot;</code>) &#x2014;
The end of sequence token.</p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						
<p>When building a sequence using special tokens, this is not the token that is used for the end of sequence.
The token used is the <code>sep_token</code>.</p>

					</div>`,name:"eos_token"},{anchor:"transformers.XLMRobertaTokenizerFast.sep_token",description:`<strong>sep_token</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&lt;/s&gt;&quot;</code>) &#x2014;
The separator token, which is used when building a sequence from multiple sequences, e.g. two sequences for
sequence classification or for a text and a question for question answering. It is also used as the last
token of a sequence built with special tokens.`,name:"sep_token"},{anchor:"transformers.XLMRobertaTokenizerFast.cls_token",description:`<strong>cls_token</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&lt;s&gt;&quot;</code>) &#x2014;
The classifier token which is used when doing sequence classification (classification of the whole sequence
instead of per-token classification). It is the first token of the sequence when built with special tokens.`,name:"cls_token"},{anchor:"transformers.XLMRobertaTokenizerFast.unk_token",description:`<strong>unk_token</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&lt;unk&gt;&quot;</code>) &#x2014;
The unknown token. A token that is not in the vocabulary cannot be converted to an ID and is set to be this
token instead.`,name:"unk_token"},{anchor:"transformers.XLMRobertaTokenizerFast.pad_token",description:`<strong>pad_token</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&lt;pad&gt;&quot;</code>) &#x2014;
The token used for padding, for example when batching sequences of different lengths.`,name:"pad_token"},{anchor:"transformers.XLMRobertaTokenizerFast.mask_token",description:`<strong>mask_token</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&lt;mask&gt;&quot;</code>) &#x2014;
The token used for masking values. This is the token used when training this model with masked language
modeling. This is the token which the model will try to predict.`,name:"mask_token"},{anchor:"transformers.XLMRobertaTokenizerFast.additional_special_tokens",description:`<strong>additional_special_tokens</strong> (<code>List[str]</code>, <em>optional</em>, defaults to <code>[&quot;&lt;s&gt;NOTUSED&quot;, &quot;&lt;/s&gt;NOTUSED&quot;]</code>) &#x2014;
Additional special tokens used by the tokenizer.`,name:"additional_special_tokens"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/tokenization_xlm_roberta_fast.py#L82"}}),pi=new I({props:{name:"build_inputs_with_special_tokens",anchor:"transformers.XLMRobertaTokenizerFast.build_inputs_with_special_tokens",parameters:[{name:"token_ids_0",val:": typing.List[int]"},{name:"token_ids_1",val:": typing.Optional[typing.List[int]] = None"}],parametersDescription:[{anchor:"transformers.XLMRobertaTokenizerFast.build_inputs_with_special_tokens.token_ids_0",description:`<strong>token_ids_0</strong> (<code>List[int]</code>) &#x2014;
List of IDs to which the special tokens will be added.`,name:"token_ids_0"},{anchor:"transformers.XLMRobertaTokenizerFast.build_inputs_with_special_tokens.token_ids_1",description:`<strong>token_ids_1</strong> (<code>List[int]</code>, <em>optional</em>) &#x2014;
Optional second list of IDs for sequence pairs.`,name:"token_ids_1"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/tokenization_xlm_roberta_fast.py#L171",returnDescription:`
<p>List of <a href="../glossary#input-ids">input IDs</a> with the appropriate special tokens.</p>
`,returnType:`
<p><code>List[int]</code></p>
`}}),ui=new I({props:{name:"create_token_type_ids_from_sequences",anchor:"transformers.XLMRobertaTokenizerFast.create_token_type_ids_from_sequences",parameters:[{name:"token_ids_0",val:": typing.List[int]"},{name:"token_ids_1",val:": typing.Optional[typing.List[int]] = None"}],parametersDescription:[{anchor:"transformers.XLMRobertaTokenizerFast.create_token_type_ids_from_sequences.token_ids_0",description:`<strong>token_ids_0</strong> (<code>List[int]</code>) &#x2014;
List of IDs.`,name:"token_ids_0"},{anchor:"transformers.XLMRobertaTokenizerFast.create_token_type_ids_from_sequences.token_ids_1",description:`<strong>token_ids_1</strong> (<code>List[int]</code>, <em>optional</em>) &#x2014;
Optional second list of IDs for sequence pairs.`,name:"token_ids_1"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/tokenization_xlm_roberta_fast.py#L197",returnDescription:`
<p>List of zeros.</p>
`,returnType:`
<p><code>List[int]</code></p>
`}}),mi=new Ne({}),fi=new I({props:{name:"class transformers.XLMRobertaModel",anchor:"transformers.XLMRobertaModel",parameters:[{name:"config",val:""},{name:"add_pooling_layer",val:" = True"}],parametersDescription:[{anchor:"transformers.XLMRobertaModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig">XLMRobertaConfig</a>) &#x2014; Model configuration class with all the parameters of the
model. Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_xlm_roberta.py#L700"}}),yi=new I({props:{name:"forward",anchor:"transformers.XLMRobertaModel.forward",parameters:[{name:"input_ids",val:": typing.Optional[torch.Tensor] = None"},{name:"attention_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"token_type_ids",val:": typing.Optional[torch.Tensor] = None"},{name:"position_ids",val:": typing.Optional[torch.Tensor] = None"},{name:"head_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"inputs_embeds",val:": typing.Optional[torch.Tensor] = None"},{name:"encoder_hidden_states",val:": typing.Optional[torch.Tensor] = None"},{name:"encoder_attention_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"past_key_values",val:": typing.Optional[typing.List[torch.FloatTensor]] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.XLMRobertaModel.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.XLMRobertaModel.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.XLMRobertaModel.forward.token_type_ids",description:`<strong>token_type_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.XLMRobertaModel.forward.position_ids",description:`<strong>position_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.</p>
<p><a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.XLMRobertaModel.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.XLMRobertaModel.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.XLMRobertaModel.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.XLMRobertaModel.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.XLMRobertaModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.XLMRobertaModel.forward.encoder_hidden_states",description:`<strong>encoder_hidden_states</strong>  (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Sequence of hidden-states at the output of the last layer of the encoder. Used in the cross-attention if
the model is configured as a decoder.`,name:"encoder_hidden_states"},{anchor:"transformers.XLMRobertaModel.forward.encoder_attention_mask",description:`<strong>encoder_attention_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on the padding token indices of the encoder input. This mask is used in
the cross-attention if the model is configured as a decoder. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>`,name:"encoder_attention_mask"},{anchor:"transformers.XLMRobertaModel.forward.past_key_values",description:`<strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code> of length <code>config.n_layers</code> with each tuple having 4 tensors of shape <code>(batch_size, num_heads, sequence_length - 1, embed_size_per_head)</code>) &#x2014;
Contains precomputed key and value hidden states of the attention blocks. Can be used to speed up decoding.</p>
<p>If <code>past_key_values</code> are used, the user can optionally input only the last <code>decoder_input_ids</code> (those that
don&#x2019;t have their past key value states given to this model) of shape <code>(batch_size, 1)</code> instead of all
<code>decoder_input_ids</code> of shape <code>(batch_size, sequence_length)</code>.`,name:"past_key_values"},{anchor:"transformers.XLMRobertaModel.forward.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set to <code>True</code>, <code>past_key_values</code> key value states are returned and can be used to speed up decoding (see
<code>past_key_values</code>).`,name:"use_cache"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_xlm_roberta.py#L745",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_outputs.BaseModelOutputWithPoolingAndCrossAttentions"
>transformers.modeling_outputs.BaseModelOutputWithPoolingAndCrossAttentions</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig"
>XLMRobertaConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the model.</p>
</li>
<li>
<p><strong>pooler_output</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, hidden_size)</code>) \u2014 Last layer hidden-state of the first token of the sequence (classification token) after further processing
through the layers used for the auxiliary pretraining task. E.g. for BERT-family of models, this returns
the classification token after processing through a linear layer and a tanh activation function. The linear
layer weights are trained from the next sentence prediction (classification) objective during pretraining.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
<li>
<p><strong>cross_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> and <code>config.add_cross_attention=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights of the decoder\u2019s cross-attention layer, after the attention softmax, used to compute the
weighted average in the cross-attention heads.</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 Tuple of <code>tuple(torch.FloatTensor)</code> of length <code>config.n_layers</code>, with each tuple having 2 tensors of shape
<code>(batch_size, num_heads, sequence_length, embed_size_per_head)</code>) and optionally if
<code>config.is_encoder_decoder=True</code> 2 additional tensors of shape <code>(batch_size, num_heads, encoder_sequence_length, embed_size_per_head)</code>.</p>
<p>Contains pre-computed hidden-states (key and values in the self-attention blocks and optionally if
<code>config.is_encoder_decoder=True</code> in the cross-attention blocks) that can be used (see <code>past_key_values</code>
input) to speed up sequential decoding.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_outputs.BaseModelOutputWithPoolingAndCrossAttentions"
>transformers.modeling_outputs.BaseModelOutputWithPoolingAndCrossAttentions</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),gs=new Ae({props:{$$slots:{default:[j8]},$$scope:{ctx:E}}}),_s=new Oe({props:{anchor:"transformers.XLMRobertaModel.forward.example",$$slots:{default:[A8]},$$scope:{ctx:E}}}),wi=new Ne({}),Ti=new I({props:{name:"class transformers.XLMRobertaForCausalLM",anchor:"transformers.XLMRobertaForCausalLM",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.XLMRobertaForCausalLM.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig">XLMRobertaConfig</a>) &#x2014; Model configuration class with all the parameters of the
model. Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_xlm_roberta.py#L887"}}),xi=new I({props:{name:"forward",anchor:"transformers.XLMRobertaForCausalLM.forward",parameters:[{name:"input_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"attention_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"token_type_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"position_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"head_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"inputs_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"encoder_hidden_states",val:": typing.Optional[torch.FloatTensor] = None"},{name:"encoder_attention_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"labels",val:": typing.Optional[torch.LongTensor] = None"},{name:"past_key_values",val:": typing.Tuple[typing.Tuple[torch.FloatTensor]] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.XLMRobertaForCausalLM.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.XLMRobertaForCausalLM.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.XLMRobertaForCausalLM.forward.token_type_ids",description:`<strong>token_type_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.XLMRobertaForCausalLM.forward.position_ids",description:`<strong>position_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.</p>
<p><a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.XLMRobertaForCausalLM.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.XLMRobertaForCausalLM.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.XLMRobertaForCausalLM.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.XLMRobertaForCausalLM.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.XLMRobertaForCausalLM.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.XLMRobertaForCausalLM.forward.encoder_hidden_states",description:`<strong>encoder_hidden_states</strong>  (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Sequence of hidden-states at the output of the last layer of the encoder. Used in the cross-attention if
the model is configured as a decoder.`,name:"encoder_hidden_states"},{anchor:"transformers.XLMRobertaForCausalLM.forward.encoder_attention_mask",description:`<strong>encoder_attention_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on the padding token indices of the encoder input. This mask is used in
the cross-attention if the model is configured as a decoder. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>`,name:"encoder_attention_mask"},{anchor:"transformers.XLMRobertaForCausalLM.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Labels for computing the left-to-right language modeling loss (next word prediction). Indices should be in
<code>[-100, 0, ..., config.vocab_size]</code> (see <code>input_ids</code> docstring) Tokens with indices set to <code>-100</code> are
ignored (masked), the loss is only computed for the tokens with labels in <code>[0, ..., config.vocab_size]</code>`,name:"labels"},{anchor:"transformers.XLMRobertaForCausalLM.forward.past_key_values",description:`<strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code> of length <code>config.n_layers</code> with each tuple having 4 tensors of shape <code>(batch_size, num_heads, sequence_length - 1, embed_size_per_head)</code>) &#x2014;
Contains precomputed key and value hidden states of the attention blocks. Can be used to speed up decoding.</p>
<p>If <code>past_key_values</code> are used, the user can optionally input only the last <code>decoder_input_ids</code> (those that
don&#x2019;t have their past key value states given to this model) of shape <code>(batch_size, 1)</code> instead of all
<code>decoder_input_ids</code> of shape <code>(batch_size, sequence_length)</code>.`,name:"past_key_values"},{anchor:"transformers.XLMRobertaForCausalLM.forward.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set to <code>True</code>, <code>past_key_values</code> key value states are returned and can be used to speed up decoding (see
<code>past_key_values</code>).`,name:"use_cache"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_xlm_roberta.py#L913",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_outputs.CausalLMOutputWithCrossAttentions"
>transformers.modeling_outputs.CausalLMOutputWithCrossAttentions</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig"
>XLMRobertaConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Language modeling loss (for next-token prediction).</p>
</li>
<li>
<p><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head (scores for each vocabulary token before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
<li>
<p><strong>cross_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Cross attentions weights after the attention softmax, used to compute the weighted average in the
cross-attention heads.</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> tuples of length <code>config.n_layers</code>, with each tuple containing the cached key,
value states of the self-attention and the cross-attention layers if model is used in encoder-decoder
setting. Only relevant if <code>config.is_decoder = True</code>.</p>
<p>Contains pre-computed hidden-states (key and values in the attention blocks) that can be used (see
<code>past_key_values</code> input) to speed up sequential decoding.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_outputs.CausalLMOutputWithCrossAttentions"
>transformers.modeling_outputs.CausalLMOutputWithCrossAttentions</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),ks=new Ae({props:{$$slots:{default:[P8]},$$scope:{ctx:E}}}),vs=new Oe({props:{anchor:"transformers.XLMRobertaForCausalLM.forward.example",$$slots:{default:[N8]},$$scope:{ctx:E}}}),Ei=new Ne({}),Ri=new I({props:{name:"class transformers.XLMRobertaForMaskedLM",anchor:"transformers.XLMRobertaForMaskedLM",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.XLMRobertaForMaskedLM.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig">XLMRobertaConfig</a>) &#x2014; Model configuration class with all the parameters of the
model. Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_xlm_roberta.py#L1045"}}),ji=new I({props:{name:"forward",anchor:"transformers.XLMRobertaForMaskedLM.forward",parameters:[{name:"input_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"attention_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"token_type_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"position_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"head_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"inputs_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"encoder_hidden_states",val:": typing.Optional[torch.FloatTensor] = None"},{name:"encoder_attention_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"labels",val:": typing.Optional[torch.LongTensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.XLMRobertaForMaskedLM.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.XLMRobertaForMaskedLM.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.XLMRobertaForMaskedLM.forward.token_type_ids",description:`<strong>token_type_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.XLMRobertaForMaskedLM.forward.position_ids",description:`<strong>position_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.</p>
<p><a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.XLMRobertaForMaskedLM.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.XLMRobertaForMaskedLM.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.XLMRobertaForMaskedLM.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.XLMRobertaForMaskedLM.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.XLMRobertaForMaskedLM.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.XLMRobertaForMaskedLM.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Labels for computing the masked language modeling loss. Indices should be in <code>[-100, 0, ..., config.vocab_size]</code> (see <code>input_ids</code> docstring) Tokens with indices set to <code>-100</code> are ignored (masked), the
loss is only computed for the tokens with labels in <code>[0, ..., config.vocab_size]</code>`,name:"labels"},{anchor:"transformers.XLMRobertaForMaskedLM.forward.kwargs",description:`<strong>kwargs</strong> (<code>Dict[str, any]</code>, optional, defaults to <em>{}</em>) &#x2014;
Used to hide legacy arguments that have been deprecated.`,name:"kwargs"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_xlm_roberta.py#L1074",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_outputs.MaskedLMOutput"
>transformers.modeling_outputs.MaskedLMOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig"
>XLMRobertaConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Masked language modeling (MLM) loss.</p>
</li>
<li>
<p><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head (scores for each vocabulary token before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_outputs.MaskedLMOutput"
>transformers.modeling_outputs.MaskedLMOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),ws=new Ae({props:{$$slots:{default:[O8]},$$scope:{ctx:E}}}),Ts=new Oe({props:{anchor:"transformers.XLMRobertaForMaskedLM.forward.example",$$slots:{default:[I8]},$$scope:{ctx:E}}}),Ai=new Ne({}),Pi=new I({props:{name:"class transformers.XLMRobertaForSequenceClassification",anchor:"transformers.XLMRobertaForSequenceClassification",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.XLMRobertaForSequenceClassification.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig">XLMRobertaConfig</a>) &#x2014; Model configuration class with all the parameters of the
model. Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_xlm_roberta.py#L1183"}}),Di=new I({props:{name:"forward",anchor:"transformers.XLMRobertaForSequenceClassification.forward",parameters:[{name:"input_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"attention_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"token_type_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"position_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"head_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"inputs_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"labels",val:": typing.Optional[torch.LongTensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.XLMRobertaForSequenceClassification.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.XLMRobertaForSequenceClassification.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.XLMRobertaForSequenceClassification.forward.token_type_ids",description:`<strong>token_type_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.XLMRobertaForSequenceClassification.forward.position_ids",description:`<strong>position_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.</p>
<p><a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.XLMRobertaForSequenceClassification.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.XLMRobertaForSequenceClassification.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.XLMRobertaForSequenceClassification.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.XLMRobertaForSequenceClassification.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.XLMRobertaForSequenceClassification.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.XLMRobertaForSequenceClassification.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for computing the sequence classification/regression loss. Indices should be in <code>[0, ..., config.num_labels - 1]</code>. If <code>config.num_labels == 1</code> a regression loss is computed (Mean-Square loss), If
<code>config.num_labels &gt; 1</code> a classification loss is computed (Cross-Entropy).`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_xlm_roberta.py#L1197",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_outputs.SequenceClassifierOutput"
>transformers.modeling_outputs.SequenceClassifierOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig"
>XLMRobertaConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Classification (or regression if config.num_labels==1) loss.</p>
</li>
<li>
<p><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, config.num_labels)</code>) \u2014 Classification (or regression if config.num_labels==1) scores (before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_outputs.SequenceClassifierOutput"
>transformers.modeling_outputs.SequenceClassifierOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),$s=new Ae({props:{$$slots:{default:[D8]},$$scope:{ctx:E}}}),Ls=new Oe({props:{anchor:"transformers.XLMRobertaForSequenceClassification.forward.example",$$slots:{default:[S8]},$$scope:{ctx:E}}}),Fs=new Oe({props:{anchor:"transformers.XLMRobertaForSequenceClassification.forward.example-2",$$slots:{default:[W8]},$$scope:{ctx:E}}}),Si=new Ne({}),Wi=new I({props:{name:"class transformers.XLMRobertaForMultipleChoice",anchor:"transformers.XLMRobertaForMultipleChoice",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.XLMRobertaForMultipleChoice.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig">XLMRobertaConfig</a>) &#x2014; Model configuration class with all the parameters of the
model. Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_xlm_roberta.py#L1285"}}),Qi=new I({props:{name:"forward",anchor:"transformers.XLMRobertaForMultipleChoice.forward",parameters:[{name:"input_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"token_type_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"attention_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"labels",val:": typing.Optional[torch.LongTensor] = None"},{name:"position_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"head_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"inputs_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.XLMRobertaForMultipleChoice.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, num_choices, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.XLMRobertaForMultipleChoice.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_choices, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.XLMRobertaForMultipleChoice.forward.token_type_ids",description:`<strong>token_type_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, num_choices, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.XLMRobertaForMultipleChoice.forward.position_ids",description:`<strong>position_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, num_choices, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.</p>
<p><a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.XLMRobertaForMultipleChoice.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.XLMRobertaForMultipleChoice.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_choices, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.XLMRobertaForMultipleChoice.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.XLMRobertaForMultipleChoice.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.XLMRobertaForMultipleChoice.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.XLMRobertaForMultipleChoice.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for computing the multiple choice classification loss. Indices should be in <code>[0, ..., num_choices-1]</code> where <code>num_choices</code> is the size of the second dimension of the input tensors. (See
<code>input_ids</code> above)`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_xlm_roberta.py#L1298",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_outputs.MultipleChoiceModelOutput"
>transformers.modeling_outputs.MultipleChoiceModelOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig"
>XLMRobertaConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <em>(1,)</em>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Classification loss.</p>
</li>
<li>
<p><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_choices)</code>) \u2014 <em>num_choices</em> is the second dimension of the input tensors. (see <em>input_ids</em> above).</p>
<p>Classification scores (before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_outputs.MultipleChoiceModelOutput"
>transformers.modeling_outputs.MultipleChoiceModelOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),Es=new Ae({props:{$$slots:{default:[U8]},$$scope:{ctx:E}}}),Rs=new Oe({props:{anchor:"transformers.XLMRobertaForMultipleChoice.forward.example",$$slots:{default:[B8]},$$scope:{ctx:E}}}),Ki=new Ne({}),Vi=new I({props:{name:"class transformers.XLMRobertaForTokenClassification",anchor:"transformers.XLMRobertaForTokenClassification",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.XLMRobertaForTokenClassification.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig">XLMRobertaConfig</a>) &#x2014; Model configuration class with all the parameters of the
model. Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_xlm_roberta.py#L1382"}}),Zi=new I({props:{name:"forward",anchor:"transformers.XLMRobertaForTokenClassification.forward",parameters:[{name:"input_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"attention_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"token_type_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"position_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"head_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"inputs_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"labels",val:": typing.Optional[torch.LongTensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.XLMRobertaForTokenClassification.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.XLMRobertaForTokenClassification.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.XLMRobertaForTokenClassification.forward.token_type_ids",description:`<strong>token_type_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.XLMRobertaForTokenClassification.forward.position_ids",description:`<strong>position_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.</p>
<p><a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.XLMRobertaForTokenClassification.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.XLMRobertaForTokenClassification.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.XLMRobertaForTokenClassification.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.XLMRobertaForTokenClassification.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.XLMRobertaForTokenClassification.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.XLMRobertaForTokenClassification.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Labels for computing the token classification loss. Indices should be in <code>[0, ..., config.num_labels - 1]</code>.`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_xlm_roberta.py#L1400",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_outputs.TokenClassifierOutput"
>transformers.modeling_outputs.TokenClassifierOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig"
>XLMRobertaConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided)  \u2014 Classification loss.</p>
</li>
<li>
<p><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, config.num_labels)</code>) \u2014 Classification scores (before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_outputs.TokenClassifierOutput"
>transformers.modeling_outputs.TokenClassifierOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),zs=new Ae({props:{$$slots:{default:[H8]},$$scope:{ctx:E}}}),Cs=new Oe({props:{anchor:"transformers.XLMRobertaForTokenClassification.forward.example",$$slots:{default:[Q8]},$$scope:{ctx:E}}}),el=new Ne({}),tl=new I({props:{name:"class transformers.XLMRobertaForQuestionAnswering",anchor:"transformers.XLMRobertaForQuestionAnswering",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.XLMRobertaForQuestionAnswering.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig">XLMRobertaConfig</a>) &#x2014; Model configuration class with all the parameters of the
model. Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_xlm_roberta.py#L1494"}}),al=new I({props:{name:"forward",anchor:"transformers.XLMRobertaForQuestionAnswering.forward",parameters:[{name:"input_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"attention_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"token_type_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"position_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"head_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"inputs_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"start_positions",val:": typing.Optional[torch.LongTensor] = None"},{name:"end_positions",val:": typing.Optional[torch.LongTensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.XLMRobertaForQuestionAnswering.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.XLMRobertaForQuestionAnswering.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.XLMRobertaForQuestionAnswering.forward.token_type_ids",description:`<strong>token_type_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.XLMRobertaForQuestionAnswering.forward.position_ids",description:`<strong>position_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.</p>
<p><a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.XLMRobertaForQuestionAnswering.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.XLMRobertaForQuestionAnswering.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.XLMRobertaForQuestionAnswering.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.XLMRobertaForQuestionAnswering.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.XLMRobertaForQuestionAnswering.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.XLMRobertaForQuestionAnswering.forward.start_positions",description:`<strong>start_positions</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for position (index) of the start of the labelled span for computing the token classification loss.
Positions are clamped to the length of the sequence (<code>sequence_length</code>). Position outside of the sequence
are not taken into account for computing the loss.`,name:"start_positions"},{anchor:"transformers.XLMRobertaForQuestionAnswering.forward.end_positions",description:`<strong>end_positions</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for position (index) of the end of the labelled span for computing the token classification loss.
Positions are clamped to the length of the sequence (<code>sequence_length</code>). Position outside of the sequence
are not taken into account for computing the loss.`,name:"end_positions"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_xlm_roberta.py#L1508",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_outputs.QuestionAnsweringModelOutput"
>transformers.modeling_outputs.QuestionAnsweringModelOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig"
>XLMRobertaConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Total span extraction loss is the sum of a Cross-Entropy for the start and end positions.</p>
</li>
<li>
<p><strong>start_logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>) \u2014 Span-start scores (before SoftMax).</p>
</li>
<li>
<p><strong>end_logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>) \u2014 Span-end scores (before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_outputs.QuestionAnsweringModelOutput"
>transformers.modeling_outputs.QuestionAnsweringModelOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),js=new Ae({props:{$$slots:{default:[K8]},$$scope:{ctx:E}}}),As=new Oe({props:{anchor:"transformers.XLMRobertaForQuestionAnswering.forward.example",$$slots:{default:[V8]},$$scope:{ctx:E}}}),rl=new Ne({}),il=new I({props:{name:"class transformers.TFXLMRobertaModel",anchor:"transformers.TFXLMRobertaModel",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TFXLMRobertaModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig">XLMRobertaConfig</a>) &#x2014; Model configuration class with all the parameters of the
model. Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_tf_xlm_roberta.py#L915"}}),Ns=new Ae({props:{$$slots:{default:[J8]},$$scope:{ctx:E}}}),pl=new I({props:{name:"call",anchor:"transformers.TFXLMRobertaModel.call",parameters:[{name:"input_ids",val:": typing.Union[typing.List[tensorflow.python.framework.ops.Tensor], typing.List[numpy.ndarray], typing.List[keras.engine.keras_tensor.KerasTensor], typing.Dict[str, tensorflow.python.framework.ops.Tensor], typing.Dict[str, numpy.ndarray], typing.Dict[str, keras.engine.keras_tensor.KerasTensor], tensorflow.python.framework.ops.Tensor, numpy.ndarray, keras.engine.keras_tensor.KerasTensor, NoneType] = None"},{name:"attention_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"token_type_ids",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"position_ids",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"head_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"inputs_embeds",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"encoder_hidden_states",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"encoder_attention_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"past_key_values",val:": typing.Union[typing.Tuple[typing.Tuple[typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor]]], NoneType] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"training",val:": typing.Optional[bool] = False"}],parametersDescription:[{anchor:"transformers.TFXLMRobertaModel.call.input_ids",description:`<strong>input_ids</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary. Indices can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See
<a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> and <a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> for details. <a href="../glossary#input-ids">What are input
IDs?</a>`,name:"input_ids"},{anchor:"transformers.TFXLMRobertaModel.call.attention_mask",description:`<strong>attention_mask</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.
<a href="../glossary#attention-mask">What are attention masks?</a></li>
</ul>`,name:"attention_mask"},{anchor:"transformers.TFXLMRobertaModel.call.token_type_ids",description:`<strong>token_type_ids</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.
<a href="../glossary#token-type-ids">What are token type IDs?</a></li>
</ul>`,name:"token_type_ids"},{anchor:"transformers.TFXLMRobertaModel.call.position_ids",description:`<strong>position_ids</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>. <a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.TFXLMRobertaModel.call.head_mask",description:`<strong>head_mask</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.TFXLMRobertaModel.call.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.TFXLMRobertaModel.call.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail. This argument can be used only in eager mode, in graph mode the value in the
config will be used instead.`,name:"output_attentions"},{anchor:"transformers.TFXLMRobertaModel.call.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail. This argument can be used only in eager mode, in graph mode the value in the config will be
used instead.`,name:"output_hidden_states"},{anchor:"transformers.TFXLMRobertaModel.call.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple. This argument can be used in
eager mode, in graph mode the value will always be set to True.`,name:"return_dict"},{anchor:"transformers.TFXLMRobertaModel.call.training",description:`<strong>training</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to use the model in training mode (some modules like dropout modules have different
behaviors between training and evaluation).`,name:"training"},{anchor:"transformers.TFXLMRobertaModel.call.encoder_hidden_states",description:`<strong>encoder_hidden_states</strong>  (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Sequence of hidden-states at the output of the last layer of the encoder. Used in the cross-attention if
the model is configured as a decoder.`,name:"encoder_hidden_states"},{anchor:"transformers.TFXLMRobertaModel.call.encoder_attention_mask",description:`<strong>encoder_attention_mask</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on the padding token indices of the encoder input. This mask is used in
the cross-attention if the model is configured as a decoder. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>`,name:"encoder_attention_mask"},{anchor:"transformers.TFXLMRobertaModel.call.past_key_values",description:`<strong>past_key_values</strong> (<code>Tuple[Tuple[tf.Tensor]]</code> of length <code>config.n_layers</code>) &#x2014;
contains precomputed key and value hidden states of the attention blocks. Can be used to speed up decoding.
If <code>past_key_values</code> are used, the user can optionally input only the last <code>decoder_input_ids</code> (those that
don&#x2019;t have their past key value states given to this model) of shape <code>(batch_size, 1)</code> instead of all
<code>decoder_input_ids</code> of shape <code>(batch_size, sequence_length)</code>.`,name:"past_key_values"},{anchor:"transformers.TFXLMRobertaModel.call.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
If set to <code>True</code>, <code>past_key_values</code> key value states are returned and can be used to speed up decoding (see
<code>past_key_values</code>). Set to <code>False</code> during training, <code>True</code> during generation`,name:"use_cache"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_tf_xlm_roberta.py#L920",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_tf_outputs.TFBaseModelOutputWithPoolingAndCrossAttentions"
>transformers.modeling_tf_outputs.TFBaseModelOutputWithPoolingAndCrossAttentions</a> or a tuple of <code>tf.Tensor</code> (if
<code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various elements depending on the
configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig"
>XLMRobertaConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>last_hidden_state</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the model.</p>
</li>
<li>
<p><strong>pooler_output</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, hidden_size)</code>) \u2014 Last layer hidden-state of the first token of the sequence (classification token) further processed by a
Linear layer and a Tanh activation function. The Linear layer weights are trained from the next sentence
prediction (classification) objective during pretraining.</p>
<p>This output is usually <em>not</em> a good summary of the semantic content of the input, you\u2019re often better with
averaging or pooling the sequence of hidden-states for the whole input sequence.</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>List[tf.Tensor]</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 List of <code>tf.Tensor</code> of length <code>config.n_layers</code>, with each tensor of shape <code>(2, batch_size, num_heads, sequence_length, embed_size_per_head)</code>).</p>
<p>Contains pre-computed hidden-states (key and values in the attention blocks) that can be used (see
<code>past_key_values</code> input) to speed up sequential decoding.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
<li>
<p><strong>cross_attentions</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights of the decoder\u2019s cross-attention layer, after the attention softmax, used to compute the
weighted average in the cross-attention heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_tf_outputs.TFBaseModelOutputWithPoolingAndCrossAttentions"
>transformers.modeling_tf_outputs.TFBaseModelOutputWithPoolingAndCrossAttentions</a> or <code>tuple(tf.Tensor)</code></p>
`}}),Os=new Ae({props:{$$slots:{default:[G8]},$$scope:{ctx:E}}}),Is=new Oe({props:{anchor:"transformers.TFXLMRobertaModel.call.example",$$slots:{default:[Y8]},$$scope:{ctx:E}}}),hl=new Ne({}),ul=new I({props:{name:"class transformers.TFXLMRobertaForCausalLM",anchor:"transformers.TFXLMRobertaForCausalLM",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TFXLMRobertaForCausalLM.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig">XLMRobertaConfig</a>) &#x2014; Model configuration class with all the parameters of the
model. Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_tf_xlm_roberta.py#L1149"}}),Ss=new Ae({props:{$$slots:{default:[Z8]},$$scope:{ctx:E}}}),bl=new I({props:{name:"call",anchor:"transformers.TFXLMRobertaForCausalLM.call",parameters:[{name:"input_ids",val:": typing.Union[typing.List[tensorflow.python.framework.ops.Tensor], typing.List[numpy.ndarray], typing.List[keras.engine.keras_tensor.KerasTensor], typing.Dict[str, tensorflow.python.framework.ops.Tensor], typing.Dict[str, numpy.ndarray], typing.Dict[str, keras.engine.keras_tensor.KerasTensor], tensorflow.python.framework.ops.Tensor, numpy.ndarray, keras.engine.keras_tensor.KerasTensor, NoneType] = None"},{name:"attention_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"token_type_ids",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"position_ids",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"head_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"inputs_embeds",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"encoder_hidden_states",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"encoder_attention_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"past_key_values",val:": typing.Union[typing.Tuple[typing.Tuple[typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor]]], NoneType] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"labels",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"training",val:": typing.Optional[bool] = False"}],parametersDescription:[{anchor:"transformers.TFXLMRobertaForCausalLM.call.input_ids",description:`<strong>input_ids</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary. Indices can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See
<a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> and <a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> for details. <a href="../glossary#input-ids">What are input
IDs?</a>`,name:"input_ids"},{anchor:"transformers.TFXLMRobertaForCausalLM.call.attention_mask",description:`<strong>attention_mask</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.
<a href="../glossary#attention-mask">What are attention masks?</a></li>
</ul>`,name:"attention_mask"},{anchor:"transformers.TFXLMRobertaForCausalLM.call.token_type_ids",description:`<strong>token_type_ids</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.
<a href="../glossary#token-type-ids">What are token type IDs?</a></li>
</ul>`,name:"token_type_ids"},{anchor:"transformers.TFXLMRobertaForCausalLM.call.position_ids",description:`<strong>position_ids</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>. <a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.TFXLMRobertaForCausalLM.call.head_mask",description:`<strong>head_mask</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.TFXLMRobertaForCausalLM.call.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.TFXLMRobertaForCausalLM.call.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail. This argument can be used only in eager mode, in graph mode the value in the
config will be used instead.`,name:"output_attentions"},{anchor:"transformers.TFXLMRobertaForCausalLM.call.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail. This argument can be used only in eager mode, in graph mode the value in the config will be
used instead.`,name:"output_hidden_states"},{anchor:"transformers.TFXLMRobertaForCausalLM.call.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple. This argument can be used in
eager mode, in graph mode the value will always be set to True.`,name:"return_dict"},{anchor:"transformers.TFXLMRobertaForCausalLM.call.training",description:`<strong>training</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to use the model in training mode (some modules like dropout modules have different
behaviors between training and evaluation).`,name:"training"},{anchor:"transformers.TFXLMRobertaForCausalLM.call.encoder_hidden_states",description:`<strong>encoder_hidden_states</strong>  (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Sequence of hidden-states at the output of the last layer of the encoder. Used in the cross-attention if
the model is configured as a decoder.`,name:"encoder_hidden_states"},{anchor:"transformers.TFXLMRobertaForCausalLM.call.encoder_attention_mask",description:`<strong>encoder_attention_mask</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on the padding token indices of the encoder input. This mask is used in
the cross-attention if the model is configured as a decoder. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>`,name:"encoder_attention_mask"},{anchor:"transformers.TFXLMRobertaForCausalLM.call.past_key_values",description:`<strong>past_key_values</strong> (<code>Tuple[Tuple[tf.Tensor]]</code> of length <code>config.n_layers</code>) &#x2014;
contains precomputed key and value hidden states of the attention blocks. Can be used to speed up decoding.
If <code>past_key_values</code> are used, the user can optionally input only the last <code>decoder_input_ids</code> (those that
don&#x2019;t have their past key value states given to this model) of shape <code>(batch_size, 1)</code> instead of all
<code>decoder_input_ids</code> of shape <code>(batch_size, sequence_length)</code>.`,name:"past_key_values"},{anchor:"transformers.TFXLMRobertaForCausalLM.call.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
If set to <code>True</code>, <code>past_key_values</code> key value states are returned and can be used to speed up decoding (see
<code>past_key_values</code>). Set to <code>False</code> during training, <code>True</code> during generation`,name:"use_cache"},{anchor:"transformers.TFXLMRobertaForCausalLM.call.labels",description:`<strong>labels</strong> (<code>tf.Tensor</code> or <code>np.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Labels for computing the cross entropy classification loss. Indices should be in <code>[0, ..., config.vocab_size - 1]</code>.`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_tf_xlm_roberta.py#L1182",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_tf_outputs.TFCausalLMOutputWithCrossAttentions"
>transformers.modeling_tf_outputs.TFCausalLMOutputWithCrossAttentions</a> or a tuple of <code>tf.Tensor</code> (if
<code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various elements depending on the
configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig"
>XLMRobertaConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>tf.Tensor</code> of shape <code>(n,)</code>, <em>optional</em>, where n is the number of non-masked labels, returned when <code>labels</code> is provided) \u2014 Language modeling loss (for next-token prediction).</p>
</li>
<li>
<p><strong>logits</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head (scores for each vocabulary token before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
<li>
<p><strong>cross_attentions</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights of the decoder\u2019s cross-attention layer, after the attention softmax, used to compute the
weighted average in the cross-attention heads.</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>List[tf.Tensor]</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 List of <code>tf.Tensor</code> of length <code>config.n_layers</code>, with each tensor of shape <code>(2, batch_size, num_heads, sequence_length, embed_size_per_head)</code>).</p>
<p>Contains pre-computed hidden-states (key and values in the attention blocks) that can be used (see
<code>past_key_values</code> input) to speed up sequential decoding.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_tf_outputs.TFCausalLMOutputWithCrossAttentions"
>transformers.modeling_tf_outputs.TFCausalLMOutputWithCrossAttentions</a> or <code>tuple(tf.Tensor)</code></p>
`}}),Ws=new Ae({props:{$$slots:{default:[eq]},$$scope:{ctx:E}}}),Us=new Oe({props:{anchor:"transformers.TFXLMRobertaForCausalLM.call.example",$$slots:{default:[tq]},$$scope:{ctx:E}}}),kl=new Ne({}),vl=new I({props:{name:"class transformers.TFXLMRobertaForMaskedLM",anchor:"transformers.TFXLMRobertaForMaskedLM",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TFXLMRobertaForMaskedLM.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig">XLMRobertaConfig</a>) &#x2014; Model configuration class with all the parameters of the
model. Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_tf_xlm_roberta.py#L1060"}}),Hs=new Ae({props:{$$slots:{default:[oq]},$$scope:{ctx:E}}}),$l=new I({props:{name:"call",anchor:"transformers.TFXLMRobertaForMaskedLM.call",parameters:[{name:"input_ids",val:": typing.Union[typing.List[tensorflow.python.framework.ops.Tensor], typing.List[numpy.ndarray], typing.List[keras.engine.keras_tensor.KerasTensor], typing.Dict[str, tensorflow.python.framework.ops.Tensor], typing.Dict[str, numpy.ndarray], typing.Dict[str, keras.engine.keras_tensor.KerasTensor], tensorflow.python.framework.ops.Tensor, numpy.ndarray, keras.engine.keras_tensor.KerasTensor, NoneType] = None"},{name:"attention_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"token_type_ids",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"position_ids",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"head_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"inputs_embeds",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"labels",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"training",val:": typing.Optional[bool] = False"}],parametersDescription:[{anchor:"transformers.TFXLMRobertaForMaskedLM.call.input_ids",description:`<strong>input_ids</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary. Indices can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See
<a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> and <a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> for details. <a href="../glossary#input-ids">What are input
IDs?</a>`,name:"input_ids"},{anchor:"transformers.TFXLMRobertaForMaskedLM.call.attention_mask",description:`<strong>attention_mask</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.
<a href="../glossary#attention-mask">What are attention masks?</a></li>
</ul>`,name:"attention_mask"},{anchor:"transformers.TFXLMRobertaForMaskedLM.call.token_type_ids",description:`<strong>token_type_ids</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.
<a href="../glossary#token-type-ids">What are token type IDs?</a></li>
</ul>`,name:"token_type_ids"},{anchor:"transformers.TFXLMRobertaForMaskedLM.call.position_ids",description:`<strong>position_ids</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>. <a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.TFXLMRobertaForMaskedLM.call.head_mask",description:`<strong>head_mask</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.TFXLMRobertaForMaskedLM.call.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.TFXLMRobertaForMaskedLM.call.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail. This argument can be used only in eager mode, in graph mode the value in the
config will be used instead.`,name:"output_attentions"},{anchor:"transformers.TFXLMRobertaForMaskedLM.call.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail. This argument can be used only in eager mode, in graph mode the value in the config will be
used instead.`,name:"output_hidden_states"},{anchor:"transformers.TFXLMRobertaForMaskedLM.call.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple. This argument can be used in
eager mode, in graph mode the value will always be set to True.`,name:"return_dict"},{anchor:"transformers.TFXLMRobertaForMaskedLM.call.training",description:`<strong>training</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to use the model in training mode (some modules like dropout modules have different
behaviors between training and evaluation).`,name:"training"},{anchor:"transformers.TFXLMRobertaForMaskedLM.call.labels",description:`<strong>labels</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Labels for computing the masked language modeling loss. Indices should be in <code>[-100, 0, ..., config.vocab_size]</code> (see <code>input_ids</code> docstring) Tokens with indices set to <code>-100</code> are ignored (masked), the
loss is only computed for the tokens with labels in <code>[0, ..., config.vocab_size]</code>`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_tf_xlm_roberta.py#L1077",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_tf_outputs.TFMaskedLMOutput"
>transformers.modeling_tf_outputs.TFMaskedLMOutput</a> or a tuple of <code>tf.Tensor</code> (if
<code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various elements depending on the
configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig"
>XLMRobertaConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>tf.Tensor</code> of shape <code>(n,)</code>, <em>optional</em>, where n is the number of non-masked labels, returned when <code>labels</code> is provided) \u2014 Masked language modeling (MLM) loss.</p>
</li>
<li>
<p><strong>logits</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head (scores for each vocabulary token before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_tf_outputs.TFMaskedLMOutput"
>transformers.modeling_tf_outputs.TFMaskedLMOutput</a> or <code>tuple(tf.Tensor)</code></p>
`}}),Qs=new Ae({props:{$$slots:{default:[nq]},$$scope:{ctx:E}}}),Ks=new Oe({props:{anchor:"transformers.TFXLMRobertaForMaskedLM.call.example",$$slots:{default:[sq]},$$scope:{ctx:E}}}),Vs=new Oe({props:{anchor:"transformers.TFXLMRobertaForMaskedLM.call.example-2",$$slots:{default:[aq]},$$scope:{ctx:E}}}),Ll=new Ne({}),Fl=new I({props:{name:"class transformers.TFXLMRobertaForSequenceClassification",anchor:"transformers.TFXLMRobertaForSequenceClassification",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TFXLMRobertaForSequenceClassification.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig">XLMRobertaConfig</a>) &#x2014; Model configuration class with all the parameters of the
model. Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_tf_xlm_roberta.py#L1322"}}),Gs=new Ae({props:{$$slots:{default:[rq]},$$scope:{ctx:E}}}),Xl=new I({props:{name:"call",anchor:"transformers.TFXLMRobertaForSequenceClassification.call",parameters:[{name:"input_ids",val:": typing.Union[typing.List[tensorflow.python.framework.ops.Tensor], typing.List[numpy.ndarray], typing.List[keras.engine.keras_tensor.KerasTensor], typing.Dict[str, tensorflow.python.framework.ops.Tensor], typing.Dict[str, numpy.ndarray], typing.Dict[str, keras.engine.keras_tensor.KerasTensor], tensorflow.python.framework.ops.Tensor, numpy.ndarray, keras.engine.keras_tensor.KerasTensor, NoneType] = None"},{name:"attention_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"token_type_ids",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"position_ids",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"head_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"inputs_embeds",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"labels",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"training",val:": typing.Optional[bool] = False"}],parametersDescription:[{anchor:"transformers.TFXLMRobertaForSequenceClassification.call.input_ids",description:`<strong>input_ids</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary. Indices can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See
<a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> and <a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> for details. <a href="../glossary#input-ids">What are input
IDs?</a>`,name:"input_ids"},{anchor:"transformers.TFXLMRobertaForSequenceClassification.call.attention_mask",description:`<strong>attention_mask</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.
<a href="../glossary#attention-mask">What are attention masks?</a></li>
</ul>`,name:"attention_mask"},{anchor:"transformers.TFXLMRobertaForSequenceClassification.call.token_type_ids",description:`<strong>token_type_ids</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.
<a href="../glossary#token-type-ids">What are token type IDs?</a></li>
</ul>`,name:"token_type_ids"},{anchor:"transformers.TFXLMRobertaForSequenceClassification.call.position_ids",description:`<strong>position_ids</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>. <a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.TFXLMRobertaForSequenceClassification.call.head_mask",description:`<strong>head_mask</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.TFXLMRobertaForSequenceClassification.call.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.TFXLMRobertaForSequenceClassification.call.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail. This argument can be used only in eager mode, in graph mode the value in the
config will be used instead.`,name:"output_attentions"},{anchor:"transformers.TFXLMRobertaForSequenceClassification.call.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail. This argument can be used only in eager mode, in graph mode the value in the config will be
used instead.`,name:"output_hidden_states"},{anchor:"transformers.TFXLMRobertaForSequenceClassification.call.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple. This argument can be used in
eager mode, in graph mode the value will always be set to True.`,name:"return_dict"},{anchor:"transformers.TFXLMRobertaForSequenceClassification.call.training",description:`<strong>training</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to use the model in training mode (some modules like dropout modules have different
behaviors between training and evaluation).`,name:"training"},{anchor:"transformers.TFXLMRobertaForSequenceClassification.call.labels",description:`<strong>labels</strong> (<code>tf.Tensor</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for computing the sequence classification/regression loss. Indices should be in <code>[0, ..., config.num_labels - 1]</code>. If <code>config.num_labels == 1</code> a regression loss is computed (Mean-Square loss), If
<code>config.num_labels &gt; 1</code> a classification loss is computed (Cross-Entropy).`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_tf_xlm_roberta.py#L1333",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_tf_outputs.TFSequenceClassifierOutput"
>transformers.modeling_tf_outputs.TFSequenceClassifierOutput</a> or a tuple of <code>tf.Tensor</code> (if
<code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various elements depending on the
configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig"
>XLMRobertaConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, )</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Classification (or regression if config.num_labels==1) loss.</p>
</li>
<li>
<p><strong>logits</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, config.num_labels)</code>) \u2014 Classification (or regression if config.num_labels==1) scores (before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_tf_outputs.TFSequenceClassifierOutput"
>transformers.modeling_tf_outputs.TFSequenceClassifierOutput</a> or <code>tuple(tf.Tensor)</code></p>
`}}),Ys=new Ae({props:{$$slots:{default:[iq]},$$scope:{ctx:E}}}),Zs=new Oe({props:{anchor:"transformers.TFXLMRobertaForSequenceClassification.call.example",$$slots:{default:[lq]},$$scope:{ctx:E}}}),ea=new Oe({props:{anchor:"transformers.TFXLMRobertaForSequenceClassification.call.example-2",$$slots:{default:[dq]},$$scope:{ctx:E}}}),zl=new Ne({}),Cl=new I({props:{name:"class transformers.TFXLMRobertaForMultipleChoice",anchor:"transformers.TFXLMRobertaForMultipleChoice",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TFXLMRobertaForMultipleChoice.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig">XLMRobertaConfig</a>) &#x2014; Model configuration class with all the parameters of the
model. Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_tf_xlm_roberta.py#L1406"}}),oa=new Ae({props:{$$slots:{default:[cq]},$$scope:{ctx:E}}}),Pl=new I({props:{name:"call",anchor:"transformers.TFXLMRobertaForMultipleChoice.call",parameters:[{name:"input_ids",val:": typing.Union[typing.List[tensorflow.python.framework.ops.Tensor], typing.List[numpy.ndarray], typing.List[keras.engine.keras_tensor.KerasTensor], typing.Dict[str, tensorflow.python.framework.ops.Tensor], typing.Dict[str, numpy.ndarray], typing.Dict[str, keras.engine.keras_tensor.KerasTensor], tensorflow.python.framework.ops.Tensor, numpy.ndarray, keras.engine.keras_tensor.KerasTensor, NoneType] = None"},{name:"attention_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"token_type_ids",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"position_ids",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"head_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"inputs_embeds",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"labels",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"training",val:": typing.Optional[bool] = False"}],parametersDescription:[{anchor:"transformers.TFXLMRobertaForMultipleChoice.call.input_ids",description:`<strong>input_ids</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, num_choices, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary. Indices can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See
<a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> and <a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> for details. <a href="../glossary#input-ids">What are input
IDs?</a>`,name:"input_ids"},{anchor:"transformers.TFXLMRobertaForMultipleChoice.call.attention_mask",description:`<strong>attention_mask</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, num_choices, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.
<a href="../glossary#attention-mask">What are attention masks?</a></li>
</ul>`,name:"attention_mask"},{anchor:"transformers.TFXLMRobertaForMultipleChoice.call.token_type_ids",description:`<strong>token_type_ids</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, num_choices, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.
<a href="../glossary#token-type-ids">What are token type IDs?</a></li>
</ul>`,name:"token_type_ids"},{anchor:"transformers.TFXLMRobertaForMultipleChoice.call.position_ids",description:`<strong>position_ids</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, num_choices, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>. <a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.TFXLMRobertaForMultipleChoice.call.head_mask",description:`<strong>head_mask</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.TFXLMRobertaForMultipleChoice.call.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, num_choices, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.TFXLMRobertaForMultipleChoice.call.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail. This argument can be used only in eager mode, in graph mode the value in the
config will be used instead.`,name:"output_attentions"},{anchor:"transformers.TFXLMRobertaForMultipleChoice.call.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail. This argument can be used only in eager mode, in graph mode the value in the config will be
used instead.`,name:"output_hidden_states"},{anchor:"transformers.TFXLMRobertaForMultipleChoice.call.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple. This argument can be used in
eager mode, in graph mode the value will always be set to True.`,name:"return_dict"},{anchor:"transformers.TFXLMRobertaForMultipleChoice.call.training",description:`<strong>training</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to use the model in training mode (some modules like dropout modules have different
behaviors between training and evaluation).`,name:"training"},{anchor:"transformers.TFXLMRobertaForMultipleChoice.call.labels",description:`<strong>labels</strong> (<code>tf.Tensor</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for computing the multiple choice classification loss. Indices should be in <code>[0, ..., num_choices]</code>
where <code>num_choices</code> is the size of the second dimension of the input tensors. (See <code>input_ids</code> above)`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_tf_xlm_roberta.py#L1430",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_tf_outputs.TFMultipleChoiceModelOutput"
>transformers.modeling_tf_outputs.TFMultipleChoiceModelOutput</a> or a tuple of <code>tf.Tensor</code> (if
<code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various elements depending on the
configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig"
>XLMRobertaConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>tf.Tensor</code> of shape <em>(batch_size, )</em>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Classification loss.</p>
</li>
<li>
<p><strong>logits</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, num_choices)</code>) \u2014 <em>num_choices</em> is the second dimension of the input tensors. (see <em>input_ids</em> above).</p>
<p>Classification scores (before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_tf_outputs.TFMultipleChoiceModelOutput"
>transformers.modeling_tf_outputs.TFMultipleChoiceModelOutput</a> or <code>tuple(tf.Tensor)</code></p>
`}}),na=new Ae({props:{$$slots:{default:[pq]},$$scope:{ctx:E}}}),sa=new Oe({props:{anchor:"transformers.TFXLMRobertaForMultipleChoice.call.example",$$slots:{default:[hq]},$$scope:{ctx:E}}}),Nl=new Ne({}),Ol=new I({props:{name:"class transformers.TFXLMRobertaForTokenClassification",anchor:"transformers.TFXLMRobertaForTokenClassification",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TFXLMRobertaForTokenClassification.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig">XLMRobertaConfig</a>) &#x2014; Model configuration class with all the parameters of the
model. Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_tf_xlm_roberta.py#L1529"}}),ra=new Ae({props:{$$slots:{default:[uq]},$$scope:{ctx:E}}}),Wl=new I({props:{name:"call",anchor:"transformers.TFXLMRobertaForTokenClassification.call",parameters:[{name:"input_ids",val:": typing.Union[typing.List[tensorflow.python.framework.ops.Tensor], typing.List[numpy.ndarray], typing.List[keras.engine.keras_tensor.KerasTensor], typing.Dict[str, tensorflow.python.framework.ops.Tensor], typing.Dict[str, numpy.ndarray], typing.Dict[str, keras.engine.keras_tensor.KerasTensor], tensorflow.python.framework.ops.Tensor, numpy.ndarray, keras.engine.keras_tensor.KerasTensor, NoneType] = None"},{name:"attention_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"token_type_ids",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"position_ids",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"head_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"inputs_embeds",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"labels",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"training",val:": typing.Optional[bool] = False"}],parametersDescription:[{anchor:"transformers.TFXLMRobertaForTokenClassification.call.input_ids",description:`<strong>input_ids</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary. Indices can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See
<a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> and <a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> for details. <a href="../glossary#input-ids">What are input
IDs?</a>`,name:"input_ids"},{anchor:"transformers.TFXLMRobertaForTokenClassification.call.attention_mask",description:`<strong>attention_mask</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.
<a href="../glossary#attention-mask">What are attention masks?</a></li>
</ul>`,name:"attention_mask"},{anchor:"transformers.TFXLMRobertaForTokenClassification.call.token_type_ids",description:`<strong>token_type_ids</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.
<a href="../glossary#token-type-ids">What are token type IDs?</a></li>
</ul>`,name:"token_type_ids"},{anchor:"transformers.TFXLMRobertaForTokenClassification.call.position_ids",description:`<strong>position_ids</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>. <a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.TFXLMRobertaForTokenClassification.call.head_mask",description:`<strong>head_mask</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.TFXLMRobertaForTokenClassification.call.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.TFXLMRobertaForTokenClassification.call.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail. This argument can be used only in eager mode, in graph mode the value in the
config will be used instead.`,name:"output_attentions"},{anchor:"transformers.TFXLMRobertaForTokenClassification.call.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail. This argument can be used only in eager mode, in graph mode the value in the config will be
used instead.`,name:"output_hidden_states"},{anchor:"transformers.TFXLMRobertaForTokenClassification.call.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple. This argument can be used in
eager mode, in graph mode the value will always be set to True.`,name:"return_dict"},{anchor:"transformers.TFXLMRobertaForTokenClassification.call.training",description:`<strong>training</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to use the model in training mode (some modules like dropout modules have different
behaviors between training and evaluation).`,name:"training"},{anchor:"transformers.TFXLMRobertaForTokenClassification.call.labels",description:`<strong>labels</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Labels for computing the token classification loss. Indices should be in <code>[0, ..., config.num_labels - 1]</code>.`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_tf_xlm_roberta.py#L1547",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_tf_outputs.TFTokenClassifierOutput"
>transformers.modeling_tf_outputs.TFTokenClassifierOutput</a> or a tuple of <code>tf.Tensor</code> (if
<code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various elements depending on the
configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig"
>XLMRobertaConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>tf.Tensor</code> of shape <code>(n,)</code>, <em>optional</em>, where n is the number of unmasked labels, returned when <code>labels</code> is provided)  \u2014 Classification loss.</p>
</li>
<li>
<p><strong>logits</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, config.num_labels)</code>) \u2014 Classification scores (before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_tf_outputs.TFTokenClassifierOutput"
>transformers.modeling_tf_outputs.TFTokenClassifierOutput</a> or <code>tuple(tf.Tensor)</code></p>
`}}),ia=new Ae({props:{$$slots:{default:[mq]},$$scope:{ctx:E}}}),la=new Oe({props:{anchor:"transformers.TFXLMRobertaForTokenClassification.call.example",$$slots:{default:[fq]},$$scope:{ctx:E}}}),da=new Oe({props:{anchor:"transformers.TFXLMRobertaForTokenClassification.call.example-2",$$slots:{default:[gq]},$$scope:{ctx:E}}}),Ul=new Ne({}),Bl=new I({props:{name:"class transformers.TFXLMRobertaForQuestionAnswering",anchor:"transformers.TFXLMRobertaForQuestionAnswering",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TFXLMRobertaForQuestionAnswering.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig">XLMRobertaConfig</a>) &#x2014; Model configuration class with all the parameters of the
model. Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_tf_xlm_roberta.py#L1620"}}),pa=new Ae({props:{$$slots:{default:[_q]},$$scope:{ctx:E}}}),Vl=new I({props:{name:"call",anchor:"transformers.TFXLMRobertaForQuestionAnswering.call",parameters:[{name:"input_ids",val:": typing.Union[typing.List[tensorflow.python.framework.ops.Tensor], typing.List[numpy.ndarray], typing.List[keras.engine.keras_tensor.KerasTensor], typing.Dict[str, tensorflow.python.framework.ops.Tensor], typing.Dict[str, numpy.ndarray], typing.Dict[str, keras.engine.keras_tensor.KerasTensor], tensorflow.python.framework.ops.Tensor, numpy.ndarray, keras.engine.keras_tensor.KerasTensor, NoneType] = None"},{name:"attention_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"token_type_ids",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"position_ids",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"head_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"inputs_embeds",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"start_positions",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"end_positions",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"training",val:": typing.Optional[bool] = False"}],parametersDescription:[{anchor:"transformers.TFXLMRobertaForQuestionAnswering.call.input_ids",description:`<strong>input_ids</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary. Indices can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See
<a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> and <a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> for details. <a href="../glossary#input-ids">What are input
IDs?</a>`,name:"input_ids"},{anchor:"transformers.TFXLMRobertaForQuestionAnswering.call.attention_mask",description:`<strong>attention_mask</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.
<a href="../glossary#attention-mask">What are attention masks?</a></li>
</ul>`,name:"attention_mask"},{anchor:"transformers.TFXLMRobertaForQuestionAnswering.call.token_type_ids",description:`<strong>token_type_ids</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.
<a href="../glossary#token-type-ids">What are token type IDs?</a></li>
</ul>`,name:"token_type_ids"},{anchor:"transformers.TFXLMRobertaForQuestionAnswering.call.position_ids",description:`<strong>position_ids</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>. <a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.TFXLMRobertaForQuestionAnswering.call.head_mask",description:`<strong>head_mask</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.TFXLMRobertaForQuestionAnswering.call.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.TFXLMRobertaForQuestionAnswering.call.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail. This argument can be used only in eager mode, in graph mode the value in the
config will be used instead.`,name:"output_attentions"},{anchor:"transformers.TFXLMRobertaForQuestionAnswering.call.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail. This argument can be used only in eager mode, in graph mode the value in the config will be
used instead.`,name:"output_hidden_states"},{anchor:"transformers.TFXLMRobertaForQuestionAnswering.call.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple. This argument can be used in
eager mode, in graph mode the value will always be set to True.`,name:"return_dict"},{anchor:"transformers.TFXLMRobertaForQuestionAnswering.call.training",description:`<strong>training</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to use the model in training mode (some modules like dropout modules have different
behaviors between training and evaluation).`,name:"training"},{anchor:"transformers.TFXLMRobertaForQuestionAnswering.call.start_positions",description:`<strong>start_positions</strong> (<code>tf.Tensor</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for position (index) of the start of the labelled span for computing the token classification loss.
Positions are clamped to the length of the sequence (<code>sequence_length</code>). Position outside of the sequence
are not taken into account for computing the loss.`,name:"start_positions"},{anchor:"transformers.TFXLMRobertaForQuestionAnswering.call.end_positions",description:`<strong>end_positions</strong> (<code>tf.Tensor</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for position (index) of the end of the labelled span for computing the token classification loss.
Positions are clamped to the length of the sequence (<code>sequence_length</code>). Position outside of the sequence
are not taken into account for computing the loss.`,name:"end_positions"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_tf_xlm_roberta.py#L1633",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_tf_outputs.TFQuestionAnsweringModelOutput"
>transformers.modeling_tf_outputs.TFQuestionAnsweringModelOutput</a> or a tuple of <code>tf.Tensor</code> (if
<code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various elements depending on the
configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig"
>XLMRobertaConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, )</code>, <em>optional</em>, returned when <code>start_positions</code> and <code>end_positions</code> are provided) \u2014 Total span extraction loss is the sum of a Cross-Entropy for the start and end positions.</p>
</li>
<li>
<p><strong>start_logits</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>) \u2014 Span-start scores (before SoftMax).</p>
</li>
<li>
<p><strong>end_logits</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>) \u2014 Span-end scores (before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_tf_outputs.TFQuestionAnsweringModelOutput"
>transformers.modeling_tf_outputs.TFQuestionAnsweringModelOutput</a> or <code>tuple(tf.Tensor)</code></p>
`}}),ha=new Ae({props:{$$slots:{default:[bq]},$$scope:{ctx:E}}}),ua=new Oe({props:{anchor:"transformers.TFXLMRobertaForQuestionAnswering.call.example",$$slots:{default:[kq]},$$scope:{ctx:E}}}),ma=new Oe({props:{anchor:"transformers.TFXLMRobertaForQuestionAnswering.call.example-2",$$slots:{default:[vq]},$$scope:{ctx:E}}}),Jl=new Ne({}),Gl=new I({props:{name:"class transformers.FlaxXLMRobertaModel",anchor:"transformers.FlaxXLMRobertaModel",parameters:[{name:"config",val:": XLMRobertaConfig"},{name:"input_shape",val:": typing.Tuple = (1, 1)"},{name:"seed",val:": int = 0"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"},{name:"_do_init",val:": bool = True"},{name:"gradient_checkpointing",val:": bool = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.FlaxXLMRobertaModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig">XLMRobertaConfig</a>) &#x2014; Model configuration class with all the parameters of the
model. Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_flax_xlm_roberta.py#L1003"}}),ad=new I({props:{name:"__call__",anchor:"transformers.FlaxXLMRobertaModel.__call__",parameters:[{name:"input_ids",val:""},{name:"attention_mask",val:" = None"},{name:"token_type_ids",val:" = None"},{name:"position_ids",val:" = None"},{name:"head_mask",val:" = None"},{name:"encoder_hidden_states",val:" = None"},{name:"encoder_attention_mask",val:" = None"},{name:"params",val:": dict = None"},{name:"dropout_rng",val:": PRNGKey = None"},{name:"train",val:": bool = False"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"past_key_values",val:": dict = None"}],parametersDescription:[{anchor:"transformers.FlaxXLMRobertaModel.__call__.input_ids",description:`<strong>input_ids</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.FlaxXLMRobertaModel.__call__.attention_mask",description:`<strong>attention_mask</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.FlaxXLMRobertaModel.__call__.token_type_ids",description:`<strong>token_type_ids</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.FlaxXLMRobertaModel.__call__.position_ids",description:`<strong>position_ids</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.`,name:"position_ids"},{anchor:"transformers.FlaxXLMRobertaModel.__call__.head_mask",description:`<strong>head_mask</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <code>optional) -- Mask to nullify selected heads of the attention modules. Mask values selected in </code>[0, 1]\`:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.FlaxXLMRobertaModel.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_flax_xlm_roberta.py#L829",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_flax_outputs.FlaxBaseModelOutputWithPooling"
>transformers.modeling_flax_outputs.FlaxBaseModelOutputWithPooling</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig"
>XLMRobertaConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>last_hidden_state</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the model.</p>
</li>
<li>
<p><strong>pooler_output</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, hidden_size)</code>) \u2014 Last layer hidden-state of the first token of the sequence (classification token) further processed by a
Linear layer and a Tanh activation function. The Linear layer weights are trained from the next sentence
prediction (classification) objective during pretraining.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_flax_outputs.FlaxBaseModelOutputWithPooling"
>transformers.modeling_flax_outputs.FlaxBaseModelOutputWithPooling</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),ga=new Ae({props:{$$slots:{default:[yq]},$$scope:{ctx:E}}}),_a=new Oe({props:{anchor:"transformers.FlaxXLMRobertaModel.__call__.example",$$slots:{default:[wq]},$$scope:{ctx:E}}}),rd=new Ne({}),id=new I({props:{name:"class transformers.FlaxXLMRobertaForCausalLM",anchor:"transformers.FlaxXLMRobertaForCausalLM",parameters:[{name:"config",val:": XLMRobertaConfig"},{name:"input_shape",val:": typing.Tuple = (1, 1)"},{name:"seed",val:": int = 0"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"},{name:"_do_init",val:": bool = True"},{name:"gradient_checkpointing",val:": bool = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.FlaxXLMRobertaForCausalLM.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig">XLMRobertaConfig</a>) &#x2014; Model configuration class with all the parameters of the
model. Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_flax_xlm_roberta.py#L1469"}}),fd=new I({props:{name:"__call__",anchor:"transformers.FlaxXLMRobertaForCausalLM.__call__",parameters:[{name:"input_ids",val:""},{name:"attention_mask",val:" = None"},{name:"token_type_ids",val:" = None"},{name:"position_ids",val:" = None"},{name:"head_mask",val:" = None"},{name:"encoder_hidden_states",val:" = None"},{name:"encoder_attention_mask",val:" = None"},{name:"params",val:": dict = None"},{name:"dropout_rng",val:": PRNGKey = None"},{name:"train",val:": bool = False"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"past_key_values",val:": dict = None"}],parametersDescription:[{anchor:"transformers.FlaxXLMRobertaForCausalLM.__call__.input_ids",description:`<strong>input_ids</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.FlaxXLMRobertaForCausalLM.__call__.attention_mask",description:`<strong>attention_mask</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.FlaxXLMRobertaForCausalLM.__call__.token_type_ids",description:`<strong>token_type_ids</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.FlaxXLMRobertaForCausalLM.__call__.position_ids",description:`<strong>position_ids</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.`,name:"position_ids"},{anchor:"transformers.FlaxXLMRobertaForCausalLM.__call__.head_mask",description:`<strong>head_mask</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <code>optional) -- Mask to nullify selected heads of the attention modules. Mask values selected in </code>[0, 1]\`:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.FlaxXLMRobertaForCausalLM.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_flax_xlm_roberta.py#L829",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_flax_outputs.FlaxCausalLMOutputWithCrossAttentions"
>transformers.modeling_flax_outputs.FlaxCausalLMOutputWithCrossAttentions</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig"
>XLMRobertaConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>logits</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head (scores for each vocabulary token before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
<li>
<p><strong>cross_attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Cross attentions weights after the attention softmax, used to compute the weighted average in the
cross-attention heads.</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>tuple(tuple(jnp.ndarray))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> tuples of length <code>config.n_layers</code>, with each tuple containing the cached key, value
states of the self-attention and the cross-attention layers if model is used in encoder-decoder setting.
Only relevant if <code>config.is_decoder = True</code>.</p>
<p>Contains pre-computed hidden-states (key and values in the attention blocks) that can be used (see
<code>past_key_values</code> input) to speed up sequential decoding.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_flax_outputs.FlaxCausalLMOutputWithCrossAttentions"
>transformers.modeling_flax_outputs.FlaxCausalLMOutputWithCrossAttentions</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),ka=new Ae({props:{$$slots:{default:[Tq]},$$scope:{ctx:E}}}),va=new Oe({props:{anchor:"transformers.FlaxXLMRobertaForCausalLM.__call__.example",$$slots:{default:[Mq]},$$scope:{ctx:E}}}),gd=new Ne({}),_d=new I({props:{name:"class transformers.FlaxXLMRobertaForMaskedLM",anchor:"transformers.FlaxXLMRobertaForMaskedLM",parameters:[{name:"config",val:": XLMRobertaConfig"},{name:"input_shape",val:": typing.Tuple = (1, 1)"},{name:"seed",val:": int = 0"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"},{name:"_do_init",val:": bool = True"},{name:"gradient_checkpointing",val:": bool = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.FlaxXLMRobertaForMaskedLM.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig">XLMRobertaConfig</a>) &#x2014; Model configuration class with all the parameters of the
model. Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_flax_xlm_roberta.py#L1070"}}),Ld=new I({props:{name:"__call__",anchor:"transformers.FlaxXLMRobertaForMaskedLM.__call__",parameters:[{name:"input_ids",val:""},{name:"attention_mask",val:" = None"},{name:"token_type_ids",val:" = None"},{name:"position_ids",val:" = None"},{name:"head_mask",val:" = None"},{name:"encoder_hidden_states",val:" = None"},{name:"encoder_attention_mask",val:" = None"},{name:"params",val:": dict = None"},{name:"dropout_rng",val:": PRNGKey = None"},{name:"train",val:": bool = False"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"past_key_values",val:": dict = None"}],parametersDescription:[{anchor:"transformers.FlaxXLMRobertaForMaskedLM.__call__.input_ids",description:`<strong>input_ids</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.FlaxXLMRobertaForMaskedLM.__call__.attention_mask",description:`<strong>attention_mask</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.FlaxXLMRobertaForMaskedLM.__call__.token_type_ids",description:`<strong>token_type_ids</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.FlaxXLMRobertaForMaskedLM.__call__.position_ids",description:`<strong>position_ids</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.`,name:"position_ids"},{anchor:"transformers.FlaxXLMRobertaForMaskedLM.__call__.head_mask",description:`<strong>head_mask</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <code>optional) -- Mask to nullify selected heads of the attention modules. Mask values selected in </code>[0, 1]\`:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.FlaxXLMRobertaForMaskedLM.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_flax_xlm_roberta.py#L829",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_flax_outputs.FlaxBaseModelOutputWithPooling"
>transformers.modeling_flax_outputs.FlaxBaseModelOutputWithPooling</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig"
>XLMRobertaConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>last_hidden_state</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the model.</p>
</li>
<li>
<p><strong>pooler_output</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, hidden_size)</code>) \u2014 Last layer hidden-state of the first token of the sequence (classification token) further processed by a
Linear layer and a Tanh activation function. The Linear layer weights are trained from the next sentence
prediction (classification) objective during pretraining.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_flax_outputs.FlaxBaseModelOutputWithPooling"
>transformers.modeling_flax_outputs.FlaxBaseModelOutputWithPooling</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),wa=new Ae({props:{$$slots:{default:[$q]},$$scope:{ctx:E}}}),Ta=new Oe({props:{anchor:"transformers.FlaxXLMRobertaForMaskedLM.__call__.example",$$slots:{default:[Lq]},$$scope:{ctx:E}}}),Fd=new Ne({}),xd=new I({props:{name:"class transformers.FlaxXLMRobertaForSequenceClassification",anchor:"transformers.FlaxXLMRobertaForSequenceClassification",parameters:[{name:"config",val:": XLMRobertaConfig"},{name:"input_shape",val:": typing.Tuple = (1, 1)"},{name:"seed",val:": int = 0"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"},{name:"_do_init",val:": bool = True"},{name:"gradient_checkpointing",val:": bool = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.FlaxXLMRobertaForSequenceClassification.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig">XLMRobertaConfig</a>) &#x2014; Model configuration class with all the parameters of the
model. Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_flax_xlm_roberta.py#L1143"}}),Ad=new I({props:{name:"__call__",anchor:"transformers.FlaxXLMRobertaForSequenceClassification.__call__",parameters:[{name:"input_ids",val:""},{name:"attention_mask",val:" = None"},{name:"token_type_ids",val:" = None"},{name:"position_ids",val:" = None"},{name:"head_mask",val:" = None"},{name:"encoder_hidden_states",val:" = None"},{name:"encoder_attention_mask",val:" = None"},{name:"params",val:": dict = None"},{name:"dropout_rng",val:": PRNGKey = None"},{name:"train",val:": bool = False"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"past_key_values",val:": dict = None"}],parametersDescription:[{anchor:"transformers.FlaxXLMRobertaForSequenceClassification.__call__.input_ids",description:`<strong>input_ids</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.FlaxXLMRobertaForSequenceClassification.__call__.attention_mask",description:`<strong>attention_mask</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.FlaxXLMRobertaForSequenceClassification.__call__.token_type_ids",description:`<strong>token_type_ids</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.FlaxXLMRobertaForSequenceClassification.__call__.position_ids",description:`<strong>position_ids</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.`,name:"position_ids"},{anchor:"transformers.FlaxXLMRobertaForSequenceClassification.__call__.head_mask",description:`<strong>head_mask</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <code>optional) -- Mask to nullify selected heads of the attention modules. Mask values selected in </code>[0, 1]\`:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.FlaxXLMRobertaForSequenceClassification.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_flax_xlm_roberta.py#L829",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_flax_outputs.FlaxSequenceClassifierOutput"
>transformers.modeling_flax_outputs.FlaxSequenceClassifierOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig"
>XLMRobertaConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>logits</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, config.num_labels)</code>) \u2014 Classification (or regression if config.num_labels==1) scores (before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_flax_outputs.FlaxSequenceClassifierOutput"
>transformers.modeling_flax_outputs.FlaxSequenceClassifierOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),$a=new Ae({props:{$$slots:{default:[Fq]},$$scope:{ctx:E}}}),La=new Oe({props:{anchor:"transformers.FlaxXLMRobertaForSequenceClassification.__call__.example",$$slots:{default:[xq]},$$scope:{ctx:E}}}),Pd=new Ne({}),Nd=new I({props:{name:"class transformers.FlaxXLMRobertaForMultipleChoice",anchor:"transformers.FlaxXLMRobertaForMultipleChoice",parameters:[{name:"config",val:": XLMRobertaConfig"},{name:"input_shape",val:": typing.Tuple = (1, 1)"},{name:"seed",val:": int = 0"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"},{name:"_do_init",val:": bool = True"},{name:"gradient_checkpointing",val:": bool = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.FlaxXLMRobertaForMultipleChoice.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig">XLMRobertaConfig</a>) &#x2014; Model configuration class with all the parameters of the
model. Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_flax_xlm_roberta.py#L1224"}}),Hd=new I({props:{name:"__call__",anchor:"transformers.FlaxXLMRobertaForMultipleChoice.__call__",parameters:[{name:"input_ids",val:""},{name:"attention_mask",val:" = None"},{name:"token_type_ids",val:" = None"},{name:"position_ids",val:" = None"},{name:"head_mask",val:" = None"},{name:"encoder_hidden_states",val:" = None"},{name:"encoder_attention_mask",val:" = None"},{name:"params",val:": dict = None"},{name:"dropout_rng",val:": PRNGKey = None"},{name:"train",val:": bool = False"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"past_key_values",val:": dict = None"}],parametersDescription:[{anchor:"transformers.FlaxXLMRobertaForMultipleChoice.__call__.input_ids",description:`<strong>input_ids</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, num_choices, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.FlaxXLMRobertaForMultipleChoice.__call__.attention_mask",description:`<strong>attention_mask</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, num_choices, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.FlaxXLMRobertaForMultipleChoice.__call__.token_type_ids",description:`<strong>token_type_ids</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, num_choices, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.FlaxXLMRobertaForMultipleChoice.__call__.position_ids",description:`<strong>position_ids</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, num_choices, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.`,name:"position_ids"},{anchor:"transformers.FlaxXLMRobertaForMultipleChoice.__call__.head_mask",description:`<strong>head_mask</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, num_choices, sequence_length)</code>, <code>optional) -- Mask to nullify selected heads of the attention modules. Mask values selected in </code>[0, 1]\`:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.FlaxXLMRobertaForMultipleChoice.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_flax_xlm_roberta.py#L829",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_flax_outputs.FlaxMultipleChoiceModelOutput"
>transformers.modeling_flax_outputs.FlaxMultipleChoiceModelOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig"
>XLMRobertaConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>logits</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, num_choices)</code>) \u2014 <em>num_choices</em> is the second dimension of the input tensors. (see <em>input_ids</em> above).</p>
<p>Classification scores (before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_flax_outputs.FlaxMultipleChoiceModelOutput"
>transformers.modeling_flax_outputs.FlaxMultipleChoiceModelOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),xa=new Ae({props:{$$slots:{default:[Eq]},$$scope:{ctx:E}}}),Ea=new Oe({props:{anchor:"transformers.FlaxXLMRobertaForMultipleChoice.__call__.example",$$slots:{default:[Rq]},$$scope:{ctx:E}}}),Qd=new Ne({}),Kd=new I({props:{name:"class transformers.FlaxXLMRobertaForTokenClassification",anchor:"transformers.FlaxXLMRobertaForTokenClassification",parameters:[{name:"config",val:": XLMRobertaConfig"},{name:"input_shape",val:": typing.Tuple = (1, 1)"},{name:"seed",val:": int = 0"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"},{name:"_do_init",val:": bool = True"},{name:"gradient_checkpointing",val:": bool = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.FlaxXLMRobertaForTokenClassification.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig">XLMRobertaConfig</a>) &#x2014; Model configuration class with all the parameters of the
model. Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_flax_xlm_roberta.py#L1306"}}),oc=new I({props:{name:"__call__",anchor:"transformers.FlaxXLMRobertaForTokenClassification.__call__",parameters:[{name:"input_ids",val:""},{name:"attention_mask",val:" = None"},{name:"token_type_ids",val:" = None"},{name:"position_ids",val:" = None"},{name:"head_mask",val:" = None"},{name:"encoder_hidden_states",val:" = None"},{name:"encoder_attention_mask",val:" = None"},{name:"params",val:": dict = None"},{name:"dropout_rng",val:": PRNGKey = None"},{name:"train",val:": bool = False"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"past_key_values",val:": dict = None"}],parametersDescription:[{anchor:"transformers.FlaxXLMRobertaForTokenClassification.__call__.input_ids",description:`<strong>input_ids</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.FlaxXLMRobertaForTokenClassification.__call__.attention_mask",description:`<strong>attention_mask</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.FlaxXLMRobertaForTokenClassification.__call__.token_type_ids",description:`<strong>token_type_ids</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.FlaxXLMRobertaForTokenClassification.__call__.position_ids",description:`<strong>position_ids</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.`,name:"position_ids"},{anchor:"transformers.FlaxXLMRobertaForTokenClassification.__call__.head_mask",description:`<strong>head_mask</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <code>optional) -- Mask to nullify selected heads of the attention modules. Mask values selected in </code>[0, 1]\`:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.FlaxXLMRobertaForTokenClassification.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_flax_xlm_roberta.py#L829",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_flax_outputs.FlaxTokenClassifierOutput"
>transformers.modeling_flax_outputs.FlaxTokenClassifierOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig"
>XLMRobertaConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>logits</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length, config.num_labels)</code>) \u2014 Classification scores (before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_flax_outputs.FlaxTokenClassifierOutput"
>transformers.modeling_flax_outputs.FlaxTokenClassifierOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),Xa=new Ae({props:{$$slots:{default:[Xq]},$$scope:{ctx:E}}}),za=new Oe({props:{anchor:"transformers.FlaxXLMRobertaForTokenClassification.__call__.example",$$slots:{default:[zq]},$$scope:{ctx:E}}}),nc=new Ne({}),sc=new I({props:{name:"class transformers.FlaxXLMRobertaForQuestionAnswering",anchor:"transformers.FlaxXLMRobertaForQuestionAnswering",parameters:[{name:"config",val:": XLMRobertaConfig"},{name:"input_shape",val:": typing.Tuple = (1, 1)"},{name:"seed",val:": int = 0"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"},{name:"_do_init",val:": bool = True"},{name:"gradient_checkpointing",val:": bool = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.FlaxXLMRobertaForQuestionAnswering.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig">XLMRobertaConfig</a>) &#x2014; Model configuration class with all the parameters of the
model. Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_flax_xlm_roberta.py#L1383"}}),hc=new I({props:{name:"__call__",anchor:"transformers.FlaxXLMRobertaForQuestionAnswering.__call__",parameters:[{name:"input_ids",val:""},{name:"attention_mask",val:" = None"},{name:"token_type_ids",val:" = None"},{name:"position_ids",val:" = None"},{name:"head_mask",val:" = None"},{name:"encoder_hidden_states",val:" = None"},{name:"encoder_attention_mask",val:" = None"},{name:"params",val:": dict = None"},{name:"dropout_rng",val:": PRNGKey = None"},{name:"train",val:": bool = False"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"past_key_values",val:": dict = None"}],parametersDescription:[{anchor:"transformers.FlaxXLMRobertaForQuestionAnswering.__call__.input_ids",description:`<strong>input_ids</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_18559/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.FlaxXLMRobertaForQuestionAnswering.__call__.attention_mask",description:`<strong>attention_mask</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.FlaxXLMRobertaForQuestionAnswering.__call__.token_type_ids",description:`<strong>token_type_ids</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.FlaxXLMRobertaForQuestionAnswering.__call__.position_ids",description:`<strong>position_ids</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.`,name:"position_ids"},{anchor:"transformers.FlaxXLMRobertaForQuestionAnswering.__call__.head_mask",description:`<strong>head_mask</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <code>optional) -- Mask to nullify selected heads of the attention modules. Mask values selected in </code>[0, 1]\`:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.FlaxXLMRobertaForQuestionAnswering.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_18559/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/vr_18559/src/transformers/models/xlm_roberta/modeling_flax_xlm_roberta.py#L829",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_flax_outputs.FlaxQuestionAnsweringModelOutput"
>transformers.modeling_flax_outputs.FlaxQuestionAnsweringModelOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaConfig"
>XLMRobertaConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>start_logits</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length)</code>) \u2014 Span-start scores (before SoftMax).</p>
</li>
<li>
<p><strong>end_logits</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length)</code>) \u2014 Span-end scores (before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_18559/en/main_classes/output#transformers.modeling_flax_outputs.FlaxQuestionAnsweringModelOutput"
>transformers.modeling_flax_outputs.FlaxQuestionAnsweringModelOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),qa=new Ae({props:{$$slots:{default:[Cq]},$$scope:{ctx:E}}}),ja=new Oe({props:{anchor:"transformers.FlaxXLMRobertaForQuestionAnswering.__call__.example",$$slots:{default:[qq]},$$scope:{ctx:E}}}),{c(){d=s("meta"),k=p(),m=s("h1"),f=s("a"),b=s("span"),y(l.$$.fragment),u=p(),R=s("span"),ke=o("XLM-RoBERTa"),fe=p(),O=s("div"),ce=s("a"),te=s("img"),ve=p(),W=s("a"),pe=s("img"),K=p(),ae=s("h2"),re=s("a"),U=s("span"),y(ie.$$.fragment),ye=p(),B=s("span"),we=o("Overview"),ge=p(),D=s("p"),Te=o("The XLM-RoBERTa model was proposed in "),le=s("a"),oe=o("Unsupervised Cross-lingual Representation Learning at Scale"),z=o(` by Alexis Conneau, Kartikay Khandelwal, Naman Goyal, Vishrav Chaudhary, Guillaume
Wenzek, Francisco Guzm\xE1n, Edouard Grave, Myle Ott, Luke Zettlemoyer and Veselin Stoyanov. It is based on Facebook\u2019s
RoBERTa model released in 2019. It is a large multi-lingual language model, trained on 2.5TB of filtered CommonCrawl
data.`),j=p(),he=s("p"),J=o("The abstract from the paper is the following:"),_e=p(),ue=s("p"),H=s("em"),Me=o(`This paper shows that pretraining multilingual language models at scale leads to significant performance gains for a
wide range of cross-lingual transfer tasks. We train a Transformer-based masked language model on one hundred
languages, using more than two terabytes of filtered CommonCrawl data. Our model, dubbed XLM-R, significantly
outperforms multilingual BERT (mBERT) on a variety of cross-lingual benchmarks, including +13.8% average accuracy on
XNLI, +12.3% average F1 score on MLQA, and +2.1% average F1 score on NER. XLM-R performs particularly well on
low-resource languages, improving 11.8% in XNLI accuracy for Swahili and 9.2% for Urdu over the previous XLM model. We
also present a detailed empirical evaluation of the key factors that are required to achieve these gains, including the
trade-offs between (1) positive transfer and capacity dilution and (2) the performance of high and low resource
languages at scale. Finally, we show, for the first time, the possibility of multilingual modeling without sacrificing
per-language performance; XLM-Ris very competitive with strong monolingual models on the GLUE and XNLI benchmarks. We
will make XLM-R code, data, and models publicly available.`),be=p(),q=s("p"),$e=o("Tips:"),V=p(),ne=s("ul"),de=s("li"),G=o(`XLM-RoBERTa is a multilingual model trained on 100 different languages. Unlike some XLM multilingual models, it does
not require `),me=s("code"),Le=o("lang"),N=o(` tensors to understand which language is used, and should be able to determine the correct
language from the input ids.`),Fe=p(),Q=s("li"),xe=o("Uses RoBERTa tricks on the XLM approach, but does not use the translation language modeling objective. It only uses masked language modeling on sentences coming from one language."),se=p(),C=s("li"),Ee=o("This implementation is the same as RoBERTa. Refer to the "),A=s("a"),Re=o("documentation of RoBERTa"),Xe=o(` for usage examples
as well as the information relative to the inputs and outputs.`),v=p(),x=s("p"),Qe=o("This model was contributed by "),Z=s("a"),Ke=o("stefan-it"),Ve=o(". The original code can be found "),X=s("a"),Je=o("here"),Ge=o("."),We=p(),qe=s("h2"),je=s("a"),P=s("span"),y(S.$$.fragment),Ye=p(),Se=s("span"),Y=o("Resources"),Ue=p(),Pe=s("p"),ze=o("A list of official Hugging Face and community (indicated by \u{1F30E}) resources to help you get started with XLM-RoBERTa. If you\u2019re interested in submitting a resource to be included here, please feel free to open a Pull Request and we\u2019ll review it! The resource should ideally demonstrate something new instead of duplicating an existing resource."),Be=p(),y(ee.$$.fragment),He=p(),gt=s("ul"),Ec=s("li"),Zb=o("A blog post on how to "),lr=s("a"),ek=o("finetune XLM RoBERTa for multiclass classification with Habana Gaudi on AWS"),tk=p(),$o=s("li"),Rc=s("a"),ok=o("XLMRobertaForSequenceClassification"),nk=o(" is supported by this "),dr=s("a"),sk=o("example script"),ak=o(" and "),cr=s("a"),rk=o("notebook"),ik=o("."),lk=p(),Lo=s("li"),Xc=s("a"),dk=o("TFXLMRobertaForSequenceClassification"),ck=o(" is supported by this "),pr=s("a"),pk=o("example script"),hk=o(" and "),hr=s("a"),uk=o("notebook"),mk=o("."),fk=p(),Fo=s("li"),zc=s("a"),gk=o("FlaxXLMRobertaForSequenceClassification"),_k=o(" is supported by this "),ur=s("a"),bk=o("example script"),kk=o(" and "),mr=s("a"),vk=o("notebook"),yk=o("."),wk=p(),Cc=s("li"),fr=s("a"),Tk=o("Text classification"),Mk=o(" chapter of the \u{1F917} Hugging Face Task Guides."),$k=p(),zh=s("li"),qc=s("a"),Lk=o("Text classification task guide"),kg=p(),y(gr.$$.fragment),vg=p(),Lt=s("ul"),xo=s("li"),jc=s("a"),Fk=o("XLMRobertaForTokenClassification"),xk=o(" is supported by this "),_r=s("a"),Ek=o("example script"),Rk=o(" and "),br=s("a"),Xk=o("notebook"),zk=o("."),Ck=p(),Eo=s("li"),Ac=s("a"),qk=o("TFXLMRobertaForTokenClassification"),jk=o(" is supported by this "),kr=s("a"),Ak=o("example script"),Pk=o(" and "),vr=s("a"),Nk=o("notebook"),Ok=o("."),Ik=p(),as=s("li"),Pc=s("a"),Dk=o("FlaxXLMRobertaForTokenClassification"),Sk=o(" is supported by this "),yr=s("a"),Wk=o("example script"),Uk=o("."),Bk=p(),Nc=s("li"),wr=s("a"),Hk=o("Token classification"),Qk=o(" chapter of the \u{1F917} Hugging Face Course."),Kk=p(),Ch=s("li"),Oc=s("a"),Vk=o("Token classification task guide"),yg=p(),y(Tr.$$.fragment),wg=p(),Ro=s("ul"),Xo=s("li"),Ic=s("a"),Jk=o("XLMRobertaForCausalLM"),Gk=o(" is supported by this "),Mr=s("a"),Yk=o("example script"),Zk=o(" and "),$r=s("a"),ev=o("notebook"),tv=o("."),ov=p(),Dc=s("li"),Lr=s("a"),nv=o("Causal language modeling"),sv=o(" chapter of the \u{1F917} Hugging Face Task Guides."),av=p(),qh=s("li"),Sc=s("a"),rv=o("Causal language modeling task guide"),Tg=p(),y(Fr.$$.fragment),Mg=p(),Ft=s("ul"),zo=s("li"),Wc=s("a"),iv=o("XLMRobertaForMaskedLM"),lv=o(" is supported by this "),xr=s("a"),dv=o("example script"),cv=o(" and "),Er=s("a"),pv=o("notebook"),hv=o("."),uv=p(),Co=s("li"),Uc=s("a"),mv=o("TFXLMRobertaForMaskedLM"),fv=o(" is supported by this "),Rr=s("a"),gv=o("example script"),_v=o(" and "),Xr=s("a"),bv=o("notebook"),kv=o("."),vv=p(),qo=s("li"),Bc=s("a"),yv=o("FlaxXLMRobertaForMaskedLM"),wv=o(" is supported by this "),zr=s("a"),Tv=o("example script"),Mv=o(" and "),Cr=s("a"),$v=o("notebook"),Lv=o("."),Fv=p(),Hc=s("li"),qr=s("a"),xv=o("Masked language modeling"),Ev=o(" chapter of the \u{1F917} Hugging Face Course."),Rv=p(),jh=s("li"),Qc=s("a"),Xv=o("Masked language modeling"),$g=p(),y(jr.$$.fragment),Lg=p(),xt=s("ul"),jo=s("li"),Kc=s("a"),zv=o("XLMRobertaForQuestionAnswering"),Cv=o(" is supported by this "),Ar=s("a"),qv=o("example script"),jv=o(" and "),Pr=s("a"),Av=o("notebook"),Pv=o("."),Nv=p(),Ao=s("li"),Vc=s("a"),Ov=o("TFXLMRobertaForQuestionAnswering"),Iv=o(" is supported by this "),Nr=s("a"),Dv=o("example script"),Sv=o(" and "),Or=s("a"),Wv=o("notebook"),Uv=o("."),Bv=p(),rs=s("li"),Jc=s("a"),Hv=o("FlaxXLMRobertaForQuestionAnswering"),Qv=o(" is supported by this "),Ir=s("a"),Kv=o("example script"),Vv=o("."),Jv=p(),Gc=s("li"),Dr=s("a"),Gv=o("Question answering"),Yv=o(" chapter of the \u{1F917} Hugging Face Course."),Zv=p(),Ah=s("li"),Yc=s("a"),ey=o("Question answering task guide"),Fg=p(),Zc=s("p"),Ph=s("strong"),ty=o("Multiple choice"),xg=p(),Po=s("ul"),No=s("li"),ep=s("a"),oy=o("XLMRobertaForMultipleChoice"),ny=o(" is supported by this "),Sr=s("a"),sy=o("example script"),ay=o(" and "),Wr=s("a"),ry=o("notebook"),iy=o("."),ly=p(),Oo=s("li"),tp=s("a"),dy=o("TFXLMRobertaForMultipleChoice"),cy=o(" is supported by this "),Ur=s("a"),py=o("example script"),hy=o(" and "),Br=s("a"),uy=o("notebook"),my=o("."),fy=p(),Nh=s("li"),op=s("a"),gy=o("Multiple choice task guide"),Eg=p(),np=s("p"),_y=o("\u{1F680} Deploy"),Rg=p(),sp=s("ul"),Hr=s("li"),by=o("A blog post on how to "),Qr=s("a"),ky=o("Deploy Serverless XLM RoBERTa on AWS Lambda"),vy=o("."),Xg=p(),ln=s("h2"),is=s("a"),Oh=s("span"),y(Kr.$$.fragment),yy=p(),Ih=s("span"),wy=o("XLMRobertaConfig"),zg=p(),Wt=s("div"),y(Vr.$$.fragment),Ty=p(),go=s("p"),My=o("This is the configuration class to store the configuration of a "),ap=s("a"),$y=o("XLMRobertaModel"),Ly=o(" or a "),rp=s("a"),Fy=o("TFXLMRobertaModel"),xy=o(`. It
is used to instantiate a XLM-RoBERTa model according to the specified arguments, defining the model architecture.
Instantiating a configuration with the defaults will yield a similar configuration to that of the XLMRoBERTa
`),Jr=s("a"),Ey=o("xlm-roberta-base"),Ry=o(" architecture."),Xy=p(),dn=s("p"),zy=o("Configuration objects inherit from "),ip=s("a"),Cy=o("PretrainedConfig"),qy=o(` and can be used to control the model outputs. Read the
documentation from `),lp=s("a"),jy=o("PretrainedConfig"),Ay=o(" for more information."),Py=p(),y(ls.$$.fragment),Cg=p(),cn=s("h2"),ds=s("a"),Dh=s("span"),y(Gr.$$.fragment),Ny=p(),Sh=s("span"),Oy=o("XLMRobertaTokenizer"),qg=p(),et=s("div"),y(Yr.$$.fragment),Iy=p(),_o=s("p"),Dy=o("Adapted from "),dp=s("a"),Sy=o("RobertaTokenizer"),Wy=o(" and "),cp=s("a"),Uy=o("XLNetTokenizer"),By=o(`. Based on
`),Zr=s("a"),Hy=o("SentencePiece"),Qy=o("."),Ky=p(),ei=s("p"),Vy=o("This tokenizer inherits from "),pp=s("a"),Jy=o("PreTrainedTokenizer"),Gy=o(` which contains most of the main methods. Users should refer to
this superclass for more information regarding those methods.`),Yy=p(),Io=s("div"),y(ti.$$.fragment),Zy=p(),Wh=s("p"),e1=o(`Build model inputs from a sequence or a pair of sequence for sequence classification tasks by concatenating and
adding special tokens. An XLM-RoBERTa sequence has the following format:`),t1=p(),oi=s("ul"),hp=s("li"),o1=o("single sequence: "),Uh=s("code"),n1=o("<s> X </s>"),s1=p(),up=s("li"),a1=o("pair of sequences: "),Bh=s("code"),r1=o("<s> A </s></s> B </s>"),i1=p(),cs=s("div"),y(ni.$$.fragment),l1=p(),si=s("p"),d1=o(`Retrieve sequence ids from a token list that has no special tokens added. This method is called when adding
special tokens using the tokenizer `),Hh=s("code"),c1=o("prepare_for_model"),p1=o(" method."),h1=p(),ps=s("div"),y(ai.$$.fragment),u1=p(),Qh=s("p"),m1=o(`Create a mask from the two sequences passed to be used in a sequence-pair classification task. XLM-RoBERTa does
not make use of token type ids, therefore a list of zeros is returned.`),f1=p(),mp=s("div"),y(ri.$$.fragment),jg=p(),pn=s("h2"),hs=s("a"),Kh=s("span"),y(ii.$$.fragment),g1=p(),Vh=s("span"),_1=o("XLMRobertaTokenizerFast"),Ag=p(),bt=s("div"),y(li.$$.fragment),b1=p(),Ut=s("p"),k1=o("Construct a \u201Cfast\u201D XLM-RoBERTa tokenizer (backed by HuggingFace\u2019s "),Jh=s("em"),v1=o("tokenizers"),y1=o(` library). Adapted from
`),fp=s("a"),w1=o("RobertaTokenizer"),T1=o(" and "),gp=s("a"),M1=o("XLNetTokenizer"),$1=o(`. Based on
`),di=s("a"),L1=o("BPE"),F1=o("."),x1=p(),ci=s("p"),E1=o("This tokenizer inherits from "),_p=s("a"),R1=o("PreTrainedTokenizerFast"),X1=o(` which contains most of the main methods. Users should
refer to this superclass for more information regarding those methods.`),z1=p(),Do=s("div"),y(pi.$$.fragment),C1=p(),Gh=s("p"),q1=o(`Build model inputs from a sequence or a pair of sequence for sequence classification tasks by concatenating and
adding special tokens. An XLM-RoBERTa sequence has the following format:`),j1=p(),hi=s("ul"),bp=s("li"),A1=o("single sequence: "),Yh=s("code"),P1=o("<s> X </s>"),N1=p(),kp=s("li"),O1=o("pair of sequences: "),Zh=s("code"),I1=o("<s> A </s></s> B </s>"),D1=p(),us=s("div"),y(ui.$$.fragment),S1=p(),eu=s("p"),W1=o(`Create a mask from the two sequences passed to be used in a sequence-pair classification task. XLM-RoBERTa does
not make use of token type ids, therefore a list of zeros is returned.`),Pg=p(),hn=s("h2"),ms=s("a"),tu=s("span"),y(mi.$$.fragment),U1=p(),ou=s("span"),B1=o("XLMRobertaModel"),Ng=p(),Ze=s("div"),y(fi.$$.fragment),H1=p(),nu=s("p"),Q1=o("The bare XLM-RoBERTa Model transformer outputting raw hidden-states without any specific head on top."),K1=p(),gi=s("p"),V1=o("This model inherits from "),vp=s("a"),J1=o("PreTrainedModel"),G1=o(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Y1=p(),_i=s("p"),Z1=o("This model is also a PyTorch "),bi=s("a"),ew=o("torch.nn.Module"),tw=o(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),ow=p(),ki=s("p"),nw=o(`The model can behave as an encoder (with only self-attention) as well as a decoder, in which case a layer of
cross-attention is added between the self-attention layers, following the architecture described in `),su=s("em"),sw=o(`Attention is
all you need`),aw=o(`_ by Ashish Vaswani, Noam Shazeer, Niki Parmar, Jakob Uszkoreit, Llion Jones, Aidan N. Gomez, Lukasz
Kaiser and Illia Polosukhin.`),rw=p(),lt=s("p"),iw=o("To behave as an decoder the model needs to be initialized with the "),au=s("code"),lw=o("is_decoder"),dw=o(` argument of the configuration set
to `),ru=s("code"),cw=o("True"),pw=o(". To be used in a Seq2Seq model, the model needs to initialized with both "),iu=s("code"),hw=o("is_decoder"),uw=o(` argument and
`),lu=s("code"),mw=o("add_cross_attention"),fw=o(" set to "),du=s("code"),gw=o("True"),_w=o("; an "),cu=s("code"),bw=o("encoder_hidden_states"),kw=o(" is then expected as an input to the forward pass."),vw=p(),fs=s("p"),yw=o(".. _"),pu=s("em"),ww=o("Attention is all you need"),Tw=o(": "),vi=s("a"),Mw=o("https://arxiv.org/abs/1706.03762"),$w=p(),Ht=s("div"),y(yi.$$.fragment),Lw=p(),un=s("p"),Fw=o("The "),yp=s("a"),xw=o("XLMRobertaModel"),Ew=o(" forward method, overrides the "),hu=s("code"),Rw=o("__call__"),Xw=o(" special method."),zw=p(),y(gs.$$.fragment),Cw=p(),y(_s.$$.fragment),Og=p(),mn=s("h2"),bs=s("a"),uu=s("span"),y(wi.$$.fragment),qw=p(),mu=s("span"),jw=o("XLMRobertaForCausalLM"),Ig=p(),kt=s("div"),y(Ti.$$.fragment),Aw=p(),Mi=s("p"),Pw=o("XLM-RoBERTa Model with a "),fu=s("code"),Nw=o("language modeling"),Ow=o(" head on top for CLM fine-tuning."),Iw=p(),$i=s("p"),Dw=o("This model inherits from "),wp=s("a"),Sw=o("PreTrainedModel"),Ww=o(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Uw=p(),Li=s("p"),Bw=o("This model is also a PyTorch "),Fi=s("a"),Hw=o("torch.nn.Module"),Qw=o(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),Kw=p(),Qt=s("div"),y(xi.$$.fragment),Vw=p(),fn=s("p"),Jw=o("The "),Tp=s("a"),Gw=o("XLMRobertaForCausalLM"),Yw=o(" forward method, overrides the "),gu=s("code"),Zw=o("__call__"),eT=o(" special method."),tT=p(),y(ks.$$.fragment),oT=p(),y(vs.$$.fragment),Dg=p(),gn=s("h2"),ys=s("a"),_u=s("span"),y(Ei.$$.fragment),nT=p(),bu=s("span"),sT=o("XLMRobertaForMaskedLM"),Sg=p(),vt=s("div"),y(Ri.$$.fragment),aT=p(),Xi=s("p"),rT=o("XLM-RoBERTa Model with a "),ku=s("code"),iT=o("language modeling"),lT=o(" head on top."),dT=p(),zi=s("p"),cT=o("This model inherits from "),Mp=s("a"),pT=o("PreTrainedModel"),hT=o(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),uT=p(),Ci=s("p"),mT=o("This model is also a PyTorch "),qi=s("a"),fT=o("torch.nn.Module"),gT=o(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),_T=p(),Kt=s("div"),y(ji.$$.fragment),bT=p(),_n=s("p"),kT=o("The "),$p=s("a"),vT=o("XLMRobertaForMaskedLM"),yT=o(" forward method, overrides the "),vu=s("code"),wT=o("__call__"),TT=o(" special method."),MT=p(),y(ws.$$.fragment),$T=p(),y(Ts.$$.fragment),Wg=p(),bn=s("h2"),Ms=s("a"),yu=s("span"),y(Ai.$$.fragment),LT=p(),wu=s("span"),FT=o("XLMRobertaForSequenceClassification"),Ug=p(),yt=s("div"),y(Pi.$$.fragment),xT=p(),Tu=s("p"),ET=o(`XLM-RoBERTa Model transformer with a sequence classification/regression head on top (a linear layer on top of the
pooled output) e.g. for GLUE tasks.`),RT=p(),Ni=s("p"),XT=o("This model inherits from "),Lp=s("a"),zT=o("PreTrainedModel"),CT=o(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),qT=p(),Oi=s("p"),jT=o("This model is also a PyTorch "),Ii=s("a"),AT=o("torch.nn.Module"),PT=o(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),NT=p(),Et=s("div"),y(Di.$$.fragment),OT=p(),kn=s("p"),IT=o("The "),Fp=s("a"),DT=o("XLMRobertaForSequenceClassification"),ST=o(" forward method, overrides the "),Mu=s("code"),WT=o("__call__"),UT=o(" special method."),BT=p(),y($s.$$.fragment),HT=p(),y(Ls.$$.fragment),QT=p(),y(Fs.$$.fragment),Bg=p(),vn=s("h2"),xs=s("a"),$u=s("span"),y(Si.$$.fragment),KT=p(),Lu=s("span"),VT=o("XLMRobertaForMultipleChoice"),Hg=p(),wt=s("div"),y(Wi.$$.fragment),JT=p(),Fu=s("p"),GT=o(`XLM-RoBERTa Model with a multiple choice classification head on top (a linear layer on top of the pooled output and
a softmax) e.g. for RocStories/SWAG tasks.`),YT=p(),Ui=s("p"),ZT=o("This model inherits from "),xp=s("a"),eM=o("PreTrainedModel"),tM=o(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),oM=p(),Bi=s("p"),nM=o("This model is also a PyTorch "),Hi=s("a"),sM=o("torch.nn.Module"),aM=o(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),rM=p(),Vt=s("div"),y(Qi.$$.fragment),iM=p(),yn=s("p"),lM=o("The "),Ep=s("a"),dM=o("XLMRobertaForMultipleChoice"),cM=o(" forward method, overrides the "),xu=s("code"),pM=o("__call__"),hM=o(" special method."),uM=p(),y(Es.$$.fragment),mM=p(),y(Rs.$$.fragment),Qg=p(),wn=s("h2"),Xs=s("a"),Eu=s("span"),y(Ki.$$.fragment),fM=p(),Ru=s("span"),gM=o("XLMRobertaForTokenClassification"),Kg=p(),Tt=s("div"),y(Vi.$$.fragment),_M=p(),Xu=s("p"),bM=o(`XLM-RoBERTa Model with a token classification head on top (a linear layer on top of the hidden-states output) e.g.
for Named-Entity-Recognition (NER) tasks.`),kM=p(),Ji=s("p"),vM=o("This model inherits from "),Rp=s("a"),yM=o("PreTrainedModel"),wM=o(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),TM=p(),Gi=s("p"),MM=o("This model is also a PyTorch "),Yi=s("a"),$M=o("torch.nn.Module"),LM=o(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),FM=p(),Jt=s("div"),y(Zi.$$.fragment),xM=p(),Tn=s("p"),EM=o("The "),Xp=s("a"),RM=o("XLMRobertaForTokenClassification"),XM=o(" forward method, overrides the "),zu=s("code"),zM=o("__call__"),CM=o(" special method."),qM=p(),y(zs.$$.fragment),jM=p(),y(Cs.$$.fragment),Vg=p(),Mn=s("h2"),qs=s("a"),Cu=s("span"),y(el.$$.fragment),AM=p(),qu=s("span"),PM=o("XLMRobertaForQuestionAnswering"),Jg=p(),Mt=s("div"),y(tl.$$.fragment),NM=p(),$n=s("p"),OM=o(`XLM-RoBERTa Model with a span classification head on top for extractive question-answering tasks like SQuAD (a
linear layers on top of the hidden-states output to compute `),ju=s("code"),IM=o("span start logits"),DM=o(" and "),Au=s("code"),SM=o("span end logits"),WM=o(")."),UM=p(),ol=s("p"),BM=o("This model inherits from "),zp=s("a"),HM=o("PreTrainedModel"),QM=o(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),KM=p(),nl=s("p"),VM=o("This model is also a PyTorch "),sl=s("a"),JM=o("torch.nn.Module"),GM=o(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),YM=p(),Gt=s("div"),y(al.$$.fragment),ZM=p(),Ln=s("p"),e$=o("The "),Cp=s("a"),t$=o("XLMRobertaForQuestionAnswering"),o$=o(" forward method, overrides the "),Pu=s("code"),n$=o("__call__"),s$=o(" special method."),a$=p(),y(js.$$.fragment),r$=p(),y(As.$$.fragment),Gg=p(),Fn=s("h2"),Ps=s("a"),Nu=s("span"),y(rl.$$.fragment),i$=p(),Ou=s("span"),l$=o("TFXLMRobertaModel"),Yg=p(),dt=s("div"),y(il.$$.fragment),d$=p(),Iu=s("p"),c$=o("The bare XLM RoBERTa Model transformer outputting raw hidden-states without any specific head on top."),p$=p(),ll=s("p"),h$=o("This model inherits from "),qp=s("a"),u$=o("TFPreTrainedModel"),m$=o(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),f$=p(),dl=s("p"),g$=o("This model is also a "),cl=s("a"),_$=o("tf.keras.Model"),b$=o(` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),k$=p(),y(Ns.$$.fragment),v$=p(),Yt=s("div"),y(pl.$$.fragment),y$=p(),xn=s("p"),w$=o("The "),jp=s("a"),T$=o("TFXLMRobertaModel"),M$=o(" forward method, overrides the "),Du=s("code"),$$=o("__call__"),L$=o(" special method."),F$=p(),y(Os.$$.fragment),x$=p(),y(Is.$$.fragment),Zg=p(),En=s("h2"),Ds=s("a"),Su=s("span"),y(hl.$$.fragment),E$=p(),Wu=s("span"),R$=o("TFXLMRobertaForCausalLM"),e_=p(),ct=s("div"),y(ul.$$.fragment),X$=p(),ml=s("p"),z$=o("XLM-RoBERTa Model with a "),Uu=s("code"),C$=o("language modeling"),q$=o(" head on top for CLM fine-tuning."),j$=p(),fl=s("p"),A$=o("This model inherits from "),Ap=s("a"),P$=o("TFPreTrainedModel"),N$=o(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),O$=p(),gl=s("p"),I$=o("This model is also a "),_l=s("a"),D$=o("tf.keras.Model"),S$=o(` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),W$=p(),y(Ss.$$.fragment),U$=p(),Zt=s("div"),y(bl.$$.fragment),B$=p(),Rn=s("p"),H$=o("The "),Pp=s("a"),Q$=o("TFXLMRobertaForCausalLM"),K$=o(" forward method, overrides the "),Bu=s("code"),V$=o("__call__"),J$=o(" special method."),G$=p(),y(Ws.$$.fragment),Y$=p(),y(Us.$$.fragment),t_=p(),Xn=s("h2"),Bs=s("a"),Hu=s("span"),y(kl.$$.fragment),Z$=p(),Qu=s("span"),e2=o("TFXLMRobertaForMaskedLM"),o_=p(),pt=s("div"),y(vl.$$.fragment),t2=p(),yl=s("p"),o2=o("XLM RoBERTa Model with a "),Ku=s("code"),n2=o("language modeling"),s2=o(" head on top."),a2=p(),wl=s("p"),r2=o("This model inherits from "),Np=s("a"),i2=o("TFPreTrainedModel"),l2=o(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),d2=p(),Tl=s("p"),c2=o("This model is also a "),Ml=s("a"),p2=o("tf.keras.Model"),h2=o(` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),u2=p(),y(Hs.$$.fragment),m2=p(),Rt=s("div"),y($l.$$.fragment),f2=p(),zn=s("p"),g2=o("The "),Op=s("a"),_2=o("TFXLMRobertaForMaskedLM"),b2=o(" forward method, overrides the "),Vu=s("code"),k2=o("__call__"),v2=o(" special method."),y2=p(),y(Qs.$$.fragment),w2=p(),y(Ks.$$.fragment),T2=p(),y(Vs.$$.fragment),n_=p(),Cn=s("h2"),Js=s("a"),Ju=s("span"),y(Ll.$$.fragment),M2=p(),Gu=s("span"),$2=o("TFXLMRobertaForSequenceClassification"),s_=p(),ht=s("div"),y(Fl.$$.fragment),L2=p(),Yu=s("p"),F2=o(`XLM RoBERTa Model transformer with a sequence classification/regression head on top (a linear layer on top of the
pooled output) e.g. for GLUE tasks.`),x2=p(),xl=s("p"),E2=o("This model inherits from "),Ip=s("a"),R2=o("TFPreTrainedModel"),X2=o(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),z2=p(),El=s("p"),C2=o("This model is also a "),Rl=s("a"),q2=o("tf.keras.Model"),j2=o(` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),A2=p(),y(Gs.$$.fragment),P2=p(),Xt=s("div"),y(Xl.$$.fragment),N2=p(),qn=s("p"),O2=o("The "),Dp=s("a"),I2=o("TFXLMRobertaForSequenceClassification"),D2=o(" forward method, overrides the "),Zu=s("code"),S2=o("__call__"),W2=o(" special method."),U2=p(),y(Ys.$$.fragment),B2=p(),y(Zs.$$.fragment),H2=p(),y(ea.$$.fragment),a_=p(),jn=s("h2"),ta=s("a"),em=s("span"),y(zl.$$.fragment),Q2=p(),tm=s("span"),K2=o("TFXLMRobertaForMultipleChoice"),r_=p(),ut=s("div"),y(Cl.$$.fragment),V2=p(),om=s("p"),J2=o(`XLM Roberta Model with a multiple choice classification head on top (a linear layer on top of the pooled output and
a softmax) e.g. for RocStories/SWAG tasks.`),G2=p(),ql=s("p"),Y2=o("This model inherits from "),Sp=s("a"),Z2=o("TFPreTrainedModel"),eL=o(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),tL=p(),jl=s("p"),oL=o("This model is also a "),Al=s("a"),nL=o("tf.keras.Model"),sL=o(` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),aL=p(),y(oa.$$.fragment),rL=p(),eo=s("div"),y(Pl.$$.fragment),iL=p(),An=s("p"),lL=o("The "),Wp=s("a"),dL=o("TFXLMRobertaForMultipleChoice"),cL=o(" forward method, overrides the "),nm=s("code"),pL=o("__call__"),hL=o(" special method."),uL=p(),y(na.$$.fragment),mL=p(),y(sa.$$.fragment),i_=p(),Pn=s("h2"),aa=s("a"),sm=s("span"),y(Nl.$$.fragment),fL=p(),am=s("span"),gL=o("TFXLMRobertaForTokenClassification"),l_=p(),mt=s("div"),y(Ol.$$.fragment),_L=p(),rm=s("p"),bL=o(`XLM RoBERTa Model with a token classification head on top (a linear layer on top of the hidden-states output) e.g.
for Named-Entity-Recognition (NER) tasks.`),kL=p(),Il=s("p"),vL=o("This model inherits from "),Up=s("a"),yL=o("TFPreTrainedModel"),wL=o(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),TL=p(),Dl=s("p"),ML=o("This model is also a "),Sl=s("a"),$L=o("tf.keras.Model"),LL=o(` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),FL=p(),y(ra.$$.fragment),xL=p(),zt=s("div"),y(Wl.$$.fragment),EL=p(),Nn=s("p"),RL=o("The "),Bp=s("a"),XL=o("TFXLMRobertaForTokenClassification"),zL=o(" forward method, overrides the "),im=s("code"),CL=o("__call__"),qL=o(" special method."),jL=p(),y(ia.$$.fragment),AL=p(),y(la.$$.fragment),PL=p(),y(da.$$.fragment),d_=p(),On=s("h2"),ca=s("a"),lm=s("span"),y(Ul.$$.fragment),NL=p(),dm=s("span"),OL=o("TFXLMRobertaForQuestionAnswering"),c_=p(),ft=s("div"),y(Bl.$$.fragment),IL=p(),In=s("p"),DL=o(`XLM RoBERTa Model with a span classification head on top for extractive question-answering tasks like SQuAD (a
linear layers on top of the hidden-states output to compute `),cm=s("code"),SL=o("span start logits"),WL=o(" and "),pm=s("code"),UL=o("span end logits"),BL=o(")."),HL=p(),Hl=s("p"),QL=o("This model inherits from "),Hp=s("a"),KL=o("TFPreTrainedModel"),VL=o(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),JL=p(),Ql=s("p"),GL=o("This model is also a "),Kl=s("a"),YL=o("tf.keras.Model"),ZL=o(` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),eF=p(),y(pa.$$.fragment),tF=p(),Ct=s("div"),y(Vl.$$.fragment),oF=p(),Dn=s("p"),nF=o("The "),Qp=s("a"),sF=o("TFXLMRobertaForQuestionAnswering"),aF=o(" forward method, overrides the "),hm=s("code"),rF=o("__call__"),iF=o(" special method."),lF=p(),y(ha.$$.fragment),dF=p(),y(ua.$$.fragment),cF=p(),y(ma.$$.fragment),p_=p(),Sn=s("h2"),fa=s("a"),um=s("span"),y(Jl.$$.fragment),pF=p(),mm=s("span"),hF=o("FlaxXLMRobertaModel"),h_=p(),tt=s("div"),y(Gl.$$.fragment),uF=p(),fm=s("p"),mF=o("The bare XLM RoBERTa Model transformer outputting raw hidden-states without any specific head on top."),fF=p(),Yl=s("p"),gF=o("This model inherits from "),Kp=s("a"),_F=o("FlaxPreTrainedModel"),bF=o(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading, saving and converting weights from PyTorch models)`),kF=p(),Zl=s("p"),vF=o("This model is also a Flax Linen "),ed=s("a"),yF=o("flax.linen.Module"),wF=o(`
subclass. Use it as a regular Flax linen Module and refer to the Flax documentation for all matter related to
general usage and behavior.`),TF=p(),gm=s("p"),MF=o("Finally, this model supports inherent JAX features such as:"),$F=p(),bo=s("ul"),_m=s("li"),td=s("a"),LF=o("Just-In-Time (JIT) compilation"),FF=p(),bm=s("li"),od=s("a"),xF=o("Automatic Differentiation"),EF=p(),km=s("li"),nd=s("a"),RF=o("Vectorization"),XF=p(),vm=s("li"),sd=s("a"),zF=o("Parallelization"),CF=p(),to=s("div"),y(ad.$$.fragment),qF=p(),Wn=s("p"),jF=o("The "),ym=s("code"),AF=o("FlaxXLMRobertaPreTrainedModel"),PF=o(" forward method, overrides the "),wm=s("code"),NF=o("__call__"),OF=o(" special method."),IF=p(),y(ga.$$.fragment),DF=p(),y(_a.$$.fragment),u_=p(),Un=s("h2"),ba=s("a"),Tm=s("span"),y(rd.$$.fragment),SF=p(),Mm=s("span"),WF=o("FlaxXLMRobertaForCausalLM"),m_=p(),ot=s("div"),y(id.$$.fragment),UF=p(),$m=s("p"),BF=o(`XLM Roberta Model with a language modeling head on top (a linear layer on top of the hidden-states output) e.g for
autoregressive tasks.`),HF=p(),ld=s("p"),QF=o("This model inherits from "),Vp=s("a"),KF=o("FlaxPreTrainedModel"),VF=o(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading, saving and converting weights from PyTorch models)`),JF=p(),dd=s("p"),GF=o("This model is also a Flax Linen "),cd=s("a"),YF=o("flax.linen.Module"),ZF=o(`
subclass. Use it as a regular Flax linen Module and refer to the Flax documentation for all matter related to
general usage and behavior.`),ex=p(),Lm=s("p"),tx=o("Finally, this model supports inherent JAX features such as:"),ox=p(),ko=s("ul"),Fm=s("li"),pd=s("a"),nx=o("Just-In-Time (JIT) compilation"),sx=p(),xm=s("li"),hd=s("a"),ax=o("Automatic Differentiation"),rx=p(),Em=s("li"),ud=s("a"),ix=o("Vectorization"),lx=p(),Rm=s("li"),md=s("a"),dx=o("Parallelization"),cx=p(),oo=s("div"),y(fd.$$.fragment),px=p(),Bn=s("p"),hx=o("The "),Xm=s("code"),ux=o("FlaxXLMRobertaPreTrainedModel"),mx=o(" forward method, overrides the "),zm=s("code"),fx=o("__call__"),gx=o(" special method."),_x=p(),y(ka.$$.fragment),bx=p(),y(va.$$.fragment),f_=p(),Hn=s("h2"),ya=s("a"),Cm=s("span"),y(gd.$$.fragment),kx=p(),qm=s("span"),vx=o("FlaxXLMRobertaForMaskedLM"),g_=p(),nt=s("div"),y(_d.$$.fragment),yx=p(),bd=s("p"),wx=o("XLM RoBERTa Model with a "),jm=s("code"),Tx=o("language modeling"),Mx=o(" head on top."),$x=p(),kd=s("p"),Lx=o("This model inherits from "),Jp=s("a"),Fx=o("FlaxPreTrainedModel"),xx=o(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading, saving and converting weights from PyTorch models)`),Ex=p(),vd=s("p"),Rx=o("This model is also a Flax Linen "),yd=s("a"),Xx=o("flax.linen.Module"),zx=o(`
subclass. Use it as a regular Flax linen Module and refer to the Flax documentation for all matter related to
general usage and behavior.`),Cx=p(),Am=s("p"),qx=o("Finally, this model supports inherent JAX features such as:"),jx=p(),vo=s("ul"),Pm=s("li"),wd=s("a"),Ax=o("Just-In-Time (JIT) compilation"),Px=p(),Nm=s("li"),Td=s("a"),Nx=o("Automatic Differentiation"),Ox=p(),Om=s("li"),Md=s("a"),Ix=o("Vectorization"),Dx=p(),Im=s("li"),$d=s("a"),Sx=o("Parallelization"),Wx=p(),no=s("div"),y(Ld.$$.fragment),Ux=p(),Qn=s("p"),Bx=o("The "),Dm=s("code"),Hx=o("FlaxXLMRobertaPreTrainedModel"),Qx=o(" forward method, overrides the "),Sm=s("code"),Kx=o("__call__"),Vx=o(" special method."),Jx=p(),y(wa.$$.fragment),Gx=p(),y(Ta.$$.fragment),__=p(),Kn=s("h2"),Ma=s("a"),Wm=s("span"),y(Fd.$$.fragment),Yx=p(),Um=s("span"),Zx=o("FlaxXLMRobertaForSequenceClassification"),b_=p(),st=s("div"),y(xd.$$.fragment),e0=p(),Bm=s("p"),t0=o(`XLM Roberta Model transformer with a sequence classification/regression head on top (a linear layer on top of the
pooled output) e.g. for GLUE tasks.`),o0=p(),Ed=s("p"),n0=o("This model inherits from "),Gp=s("a"),s0=o("FlaxPreTrainedModel"),a0=o(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading, saving and converting weights from PyTorch models)`),r0=p(),Rd=s("p"),i0=o("This model is also a Flax Linen "),Xd=s("a"),l0=o("flax.linen.Module"),d0=o(`
subclass. Use it as a regular Flax linen Module and refer to the Flax documentation for all matter related to
general usage and behavior.`),c0=p(),Hm=s("p"),p0=o("Finally, this model supports inherent JAX features such as:"),h0=p(),yo=s("ul"),Qm=s("li"),zd=s("a"),u0=o("Just-In-Time (JIT) compilation"),m0=p(),Km=s("li"),Cd=s("a"),f0=o("Automatic Differentiation"),g0=p(),Vm=s("li"),qd=s("a"),_0=o("Vectorization"),b0=p(),Jm=s("li"),jd=s("a"),k0=o("Parallelization"),v0=p(),so=s("div"),y(Ad.$$.fragment),y0=p(),Vn=s("p"),w0=o("The "),Gm=s("code"),T0=o("FlaxXLMRobertaPreTrainedModel"),M0=o(" forward method, overrides the "),Ym=s("code"),$0=o("__call__"),L0=o(" special method."),F0=p(),y($a.$$.fragment),x0=p(),y(La.$$.fragment),k_=p(),Jn=s("h2"),Fa=s("a"),Zm=s("span"),y(Pd.$$.fragment),E0=p(),ef=s("span"),R0=o("FlaxXLMRobertaForMultipleChoice"),v_=p(),at=s("div"),y(Nd.$$.fragment),X0=p(),tf=s("p"),z0=o(`XLM Roberta Model with a multiple choice classification head on top (a linear layer on top of the pooled output and
a softmax) e.g. for RocStories/SWAG tasks.`),C0=p(),Od=s("p"),q0=o("This model inherits from "),Yp=s("a"),j0=o("FlaxPreTrainedModel"),A0=o(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading, saving and converting weights from PyTorch models)`),P0=p(),Id=s("p"),N0=o("This model is also a Flax Linen "),Dd=s("a"),O0=o("flax.linen.Module"),I0=o(`
subclass. Use it as a regular Flax linen Module and refer to the Flax documentation for all matter related to
general usage and behavior.`),D0=p(),of=s("p"),S0=o("Finally, this model supports inherent JAX features such as:"),W0=p(),wo=s("ul"),nf=s("li"),Sd=s("a"),U0=o("Just-In-Time (JIT) compilation"),B0=p(),sf=s("li"),Wd=s("a"),H0=o("Automatic Differentiation"),Q0=p(),af=s("li"),Ud=s("a"),K0=o("Vectorization"),V0=p(),rf=s("li"),Bd=s("a"),J0=o("Parallelization"),G0=p(),ao=s("div"),y(Hd.$$.fragment),Y0=p(),Gn=s("p"),Z0=o("The "),lf=s("code"),e5=o("FlaxXLMRobertaPreTrainedModel"),t5=o(" forward method, overrides the "),df=s("code"),o5=o("__call__"),n5=o(" special method."),s5=p(),y(xa.$$.fragment),a5=p(),y(Ea.$$.fragment),y_=p(),Yn=s("h2"),Ra=s("a"),cf=s("span"),y(Qd.$$.fragment),r5=p(),pf=s("span"),i5=o("FlaxXLMRobertaForTokenClassification"),w_=p(),rt=s("div"),y(Kd.$$.fragment),l5=p(),hf=s("p"),d5=o(`XLM Roberta Model with a token classification head on top (a linear layer on top of the hidden-states output) e.g.
for Named-Entity-Recognition (NER) tasks.`),c5=p(),Vd=s("p"),p5=o("This model inherits from "),Zp=s("a"),h5=o("FlaxPreTrainedModel"),u5=o(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading, saving and converting weights from PyTorch models)`),m5=p(),Jd=s("p"),f5=o("This model is also a Flax Linen "),Gd=s("a"),g5=o("flax.linen.Module"),_5=o(`
subclass. Use it as a regular Flax linen Module and refer to the Flax documentation for all matter related to
general usage and behavior.`),b5=p(),uf=s("p"),k5=o("Finally, this model supports inherent JAX features such as:"),v5=p(),To=s("ul"),mf=s("li"),Yd=s("a"),y5=o("Just-In-Time (JIT) compilation"),w5=p(),ff=s("li"),Zd=s("a"),T5=o("Automatic Differentiation"),M5=p(),gf=s("li"),ec=s("a"),$5=o("Vectorization"),L5=p(),_f=s("li"),tc=s("a"),F5=o("Parallelization"),x5=p(),ro=s("div"),y(oc.$$.fragment),E5=p(),Zn=s("p"),R5=o("The "),bf=s("code"),X5=o("FlaxXLMRobertaPreTrainedModel"),z5=o(" forward method, overrides the "),kf=s("code"),C5=o("__call__"),q5=o(" special method."),j5=p(),y(Xa.$$.fragment),A5=p(),y(za.$$.fragment),T_=p(),es=s("h2"),Ca=s("a"),vf=s("span"),y(nc.$$.fragment),P5=p(),yf=s("span"),N5=o("FlaxXLMRobertaForQuestionAnswering"),M_=p(),it=s("div"),y(sc.$$.fragment),O5=p(),ts=s("p"),I5=o(`XLM Roberta Model with a span classification head on top for extractive question-answering tasks like SQuAD (a
linear layers on top of the hidden-states output to compute `),wf=s("code"),D5=o("span start logits"),S5=o(" and "),Tf=s("code"),W5=o("span end logits"),U5=o(")."),B5=p(),ac=s("p"),H5=o("This model inherits from "),eh=s("a"),Q5=o("FlaxPreTrainedModel"),K5=o(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading, saving and converting weights from PyTorch models)`),V5=p(),rc=s("p"),J5=o("This model is also a Flax Linen "),ic=s("a"),G5=o("flax.linen.Module"),Y5=o(`
subclass. Use it as a regular Flax linen Module and refer to the Flax documentation for all matter related to
general usage and behavior.`),Z5=p(),Mf=s("p"),eE=o("Finally, this model supports inherent JAX features such as:"),tE=p(),Mo=s("ul"),$f=s("li"),lc=s("a"),oE=o("Just-In-Time (JIT) compilation"),nE=p(),Lf=s("li"),dc=s("a"),sE=o("Automatic Differentiation"),aE=p(),Ff=s("li"),cc=s("a"),rE=o("Vectorization"),iE=p(),xf=s("li"),pc=s("a"),lE=o("Parallelization"),dE=p(),io=s("div"),y(hc.$$.fragment),cE=p(),os=s("p"),pE=o("The "),Ef=s("code"),hE=o("FlaxXLMRobertaPreTrainedModel"),uE=o(" forward method, overrides the "),Rf=s("code"),mE=o("__call__"),fE=o(" special method."),gE=p(),y(qa.$$.fragment),_E=p(),y(ja.$$.fragment),this.h()},l(i){const _=z8('[data-svelte="svelte-1phssyn"]',document.head);d=a(_,"META",{name:!0,content:!0}),_.forEach(t),k=h(i),m=a(i,"H1",{class:!0});var uc=r(m);f=a(uc,"A",{id:!0,class:!0,href:!0});var Xf=r(f);b=a(Xf,"SPAN",{});var zf=r(b);w(l.$$.fragment,zf),zf.forEach(t),Xf.forEach(t),u=h(uc),R=a(uc,"SPAN",{});var Cf=r(R);ke=n(Cf,"XLM-RoBERTa"),Cf.forEach(t),uc.forEach(t),fe=h(i),O=a(i,"DIV",{class:!0});var mc=r(O);ce=a(mc,"A",{href:!0});var qf=r(ce);te=a(qf,"IMG",{alt:!0,src:!0}),qf.forEach(t),ve=h(mc),W=a(mc,"A",{href:!0});var jf=r(W);pe=a(jf,"IMG",{alt:!0,src:!0}),jf.forEach(t),mc.forEach(t),K=h(i),ae=a(i,"H2",{class:!0});var fc=r(ae);re=a(fc,"A",{id:!0,class:!0,href:!0});var Af=r(re);U=a(Af,"SPAN",{});var Pf=r(U);w(ie.$$.fragment,Pf),Pf.forEach(t),Af.forEach(t),ye=h(fc),B=a(fc,"SPAN",{});var Nf=r(B);we=n(Nf,"Overview"),Nf.forEach(t),fc.forEach(t),ge=h(i),D=a(i,"P",{});var gc=r(D);Te=n(gc,"The XLM-RoBERTa model was proposed in "),le=a(gc,"A",{href:!0,rel:!0});var Of=r(le);oe=n(Of,"Unsupervised Cross-lingual Representation Learning at Scale"),Of.forEach(t),z=n(gc,` by Alexis Conneau, Kartikay Khandelwal, Naman Goyal, Vishrav Chaudhary, Guillaume
Wenzek, Francisco Guzm\xE1n, Edouard Grave, Myle Ott, Luke Zettlemoyer and Veselin Stoyanov. It is based on Facebook\u2019s
RoBERTa model released in 2019. It is a large multi-lingual language model, trained on 2.5TB of filtered CommonCrawl
data.`),gc.forEach(t),j=h(i),he=a(i,"P",{});var If=r(he);J=n(If,"The abstract from the paper is the following:"),If.forEach(t),_e=h(i),ue=a(i,"P",{});var Df=r(ue);H=a(Df,"EM",{});var Sf=r(H);Me=n(Sf,`This paper shows that pretraining multilingual language models at scale leads to significant performance gains for a
wide range of cross-lingual transfer tasks. We train a Transformer-based masked language model on one hundred
languages, using more than two terabytes of filtered CommonCrawl data. Our model, dubbed XLM-R, significantly
outperforms multilingual BERT (mBERT) on a variety of cross-lingual benchmarks, including +13.8% average accuracy on
XNLI, +12.3% average F1 score on MLQA, and +2.1% average F1 score on NER. XLM-R performs particularly well on
low-resource languages, improving 11.8% in XNLI accuracy for Swahili and 9.2% for Urdu over the previous XLM model. We
also present a detailed empirical evaluation of the key factors that are required to achieve these gains, including the
trade-offs between (1) positive transfer and capacity dilution and (2) the performance of high and low resource
languages at scale. Finally, we show, for the first time, the possibility of multilingual modeling without sacrificing
per-language performance; XLM-Ris very competitive with strong monolingual models on the GLUE and XNLI benchmarks. We
will make XLM-R code, data, and models publicly available.`),Sf.forEach(t),Df.forEach(t),be=h(i),q=a(i,"P",{});var Wf=r(q);$e=n(Wf,"Tips:"),Wf.forEach(t),V=h(i),ne=a(i,"UL",{});var ns=r(ne);de=a(ns,"LI",{});var _c=r(de);G=n(_c,`XLM-RoBERTa is a multilingual model trained on 100 different languages. Unlike some XLM multilingual models, it does
not require `),me=a(_c,"CODE",{});var Uf=r(me);Le=n(Uf,"lang"),Uf.forEach(t),N=n(_c,` tensors to understand which language is used, and should be able to determine the correct
language from the input ids.`),_c.forEach(t),Fe=h(ns),Q=a(ns,"LI",{});var Bf=r(Q);xe=n(Bf,"Uses RoBERTa tricks on the XLM approach, but does not use the translation language modeling objective. It only uses masked language modeling on sentences coming from one language."),Bf.forEach(t),se=h(ns),C=a(ns,"LI",{});var bc=r(C);Ee=n(bc,"This implementation is the same as RoBERTa. Refer to the "),A=a(bc,"A",{href:!0});var Hf=r(A);Re=n(Hf,"documentation of RoBERTa"),Hf.forEach(t),Xe=n(bc,` for usage examples
as well as the information relative to the inputs and outputs.`),bc.forEach(t),ns.forEach(t),v=h(i),x=a(i,"P",{});var ss=r(x);Qe=n(ss,"This model was contributed by "),Z=a(ss,"A",{href:!0,rel:!0});var Qf=r(Z);Ke=n(Qf,"stefan-it"),Qf.forEach(t),Ve=n(ss,". The original code can be found "),X=a(ss,"A",{href:!0,rel:!0});var Kf=r(X);Je=n(Kf,"here"),Kf.forEach(t),Ge=n(ss,"."),ss.forEach(t),We=h(i),qe=a(i,"H2",{class:!0});var kc=r(qe);je=a(kc,"A",{id:!0,class:!0,href:!0});var Vf=r(je);P=a(Vf,"SPAN",{});var Jf=r(P);w(S.$$.fragment,Jf),Jf.forEach(t),Vf.forEach(t),Ye=h(kc),Se=a(kc,"SPAN",{});var Gf=r(Se);Y=n(Gf,"Resources"),Gf.forEach(t),kc.forEach(t),Ue=h(i),Pe=a(i,"P",{});var Yf=r(Pe);ze=n(Yf,"A list of official Hugging Face and community (indicated by \u{1F30E}) resources to help you get started with XLM-RoBERTa. If you\u2019re interested in submitting a resource to be included here, please feel free to open a Pull Request and we\u2019ll review it! The resource should ideally demonstrate something new instead of duplicating an existing resource."),Yf.forEach(t),Be=h(i),w(ee.$$.fragment,i),He=h(i),gt=a(i,"UL",{});var $t=r(gt);Ec=a($t,"LI",{});var th=r(Ec);Zb=n(th,"A blog post on how to "),lr=a(th,"A",{href:!0,rel:!0});var Zf=r(lr);ek=n(Zf,"finetune XLM RoBERTa for multiclass classification with Habana Gaudi on AWS"),Zf.forEach(t),th.forEach(t),tk=h($t),$o=a($t,"LI",{});var So=r($o);Rc=a(So,"A",{href:!0});var eg=r(Rc);ok=n(eg,"XLMRobertaForSequenceClassification"),eg.forEach(t),nk=n(So," is supported by this "),dr=a(So,"A",{href:!0,rel:!0});var tg=r(dr);sk=n(tg,"example script"),tg.forEach(t),ak=n(So," and "),cr=a(So,"A",{href:!0,rel:!0});var og=r(cr);rk=n(og,"notebook"),og.forEach(t),ik=n(So,"."),So.forEach(t),lk=h($t),Lo=a($t,"LI",{});var Wo=r(Lo);Xc=a(Wo,"A",{href:!0});var ng=r(Xc);dk=n(ng,"TFXLMRobertaForSequenceClassification"),ng.forEach(t),ck=n(Wo," is supported by this "),pr=a(Wo,"A",{href:!0,rel:!0});var sg=r(pr);pk=n(sg,"example script"),sg.forEach(t),hk=n(Wo," and "),hr=a(Wo,"A",{href:!0,rel:!0});var ag=r(hr);uk=n(ag,"notebook"),ag.forEach(t),mk=n(Wo,"."),Wo.forEach(t),fk=h($t),Fo=a($t,"LI",{});var Uo=r(Fo);zc=a(Uo,"A",{href:!0});var rg=r(zc);gk=n(rg,"FlaxXLMRobertaForSequenceClassification"),rg.forEach(t),_k=n(Uo," is supported by this "),ur=a(Uo,"A",{href:!0,rel:!0});var ig=r(ur);bk=n(ig,"example script"),ig.forEach(t),kk=n(Uo," and "),mr=a(Uo,"A",{href:!0,rel:!0});var lg=r(mr);vk=n(lg,"notebook"),lg.forEach(t),yk=n(Uo,"."),Uo.forEach(t),wk=h($t),Cc=a($t,"LI",{});var oh=r(Cc);fr=a(oh,"A",{href:!0,rel:!0});var dg=r(fr);Tk=n(dg,"Text classification"),dg.forEach(t),Mk=n(oh," chapter of the \u{1F917} Hugging Face Task Guides."),oh.forEach(t),$k=h($t),zh=a($t,"LI",{});var cg=r(zh);qc=a(cg,"A",{href:!0});var pg=r(qc);Lk=n(pg,"Text classification task guide"),pg.forEach(t),cg.forEach(t),$t.forEach(t),kg=h(i),w(gr.$$.fragment,i),vg=h(i),Lt=a(i,"UL",{});var Bt=r(Lt);xo=a(Bt,"LI",{});var Bo=r(xo);jc=a(Bo,"A",{href:!0});var hg=r(jc);Fk=n(hg,"XLMRobertaForTokenClassification"),hg.forEach(t),xk=n(Bo," is supported by this "),_r=a(Bo,"A",{href:!0,rel:!0});var ug=r(_r);Ek=n(ug,"example script"),ug.forEach(t),Rk=n(Bo," and "),br=a(Bo,"A",{href:!0,rel:!0});var mg=r(br);Xk=n(mg,"notebook"),mg.forEach(t),zk=n(Bo,"."),Bo.forEach(t),Ck=h(Bt),Eo=a(Bt,"LI",{});var vc=r(Eo);Ac=a(vc,"A",{href:!0});var LE=r(Ac);qk=n(LE,"TFXLMRobertaForTokenClassification"),LE.forEach(t),jk=n(vc," is supported by this "),kr=a(vc,"A",{href:!0,rel:!0});var FE=r(kr);Ak=n(FE,"example script"),FE.forEach(t),Pk=n(vc," and "),vr=a(vc,"A",{href:!0,rel:!0});var xE=r(vr);Nk=n(xE,"notebook"),xE.forEach(t),Ok=n(vc,"."),vc.forEach(t),Ik=h(Bt),as=a(Bt,"LI",{});var fg=r(as);Pc=a(fg,"A",{href:!0});var EE=r(Pc);Dk=n(EE,"FlaxXLMRobertaForTokenClassification"),EE.forEach(t),Sk=n(fg," is supported by this "),yr=a(fg,"A",{href:!0,rel:!0});var RE=r(yr);Wk=n(RE,"example script"),RE.forEach(t),Uk=n(fg,"."),fg.forEach(t),Bk=h(Bt),Nc=a(Bt,"LI",{});var bE=r(Nc);wr=a(bE,"A",{href:!0,rel:!0});var XE=r(wr);Hk=n(XE,"Token classification"),XE.forEach(t),Qk=n(bE," chapter of the \u{1F917} Hugging Face Course."),bE.forEach(t),Kk=h(Bt),Ch=a(Bt,"LI",{});var zE=r(Ch);Oc=a(zE,"A",{href:!0});var CE=r(Oc);Vk=n(CE,"Token classification task guide"),CE.forEach(t),zE.forEach(t),Bt.forEach(t),yg=h(i),w(Tr.$$.fragment,i),wg=h(i),Ro=a(i,"UL",{});var nh=r(Ro);Xo=a(nh,"LI",{});var yc=r(Xo);Ic=a(yc,"A",{href:!0});var qE=r(Ic);Jk=n(qE,"XLMRobertaForCausalLM"),qE.forEach(t),Gk=n(yc," is supported by this "),Mr=a(yc,"A",{href:!0,rel:!0});var jE=r(Mr);Yk=n(jE,"example script"),jE.forEach(t),Zk=n(yc," and "),$r=a(yc,"A",{href:!0,rel:!0});var AE=r($r);ev=n(AE,"notebook"),AE.forEach(t),tv=n(yc,"."),yc.forEach(t),ov=h(nh),Dc=a(nh,"LI",{});var kE=r(Dc);Lr=a(kE,"A",{href:!0,rel:!0});var PE=r(Lr);nv=n(PE,"Causal language modeling"),PE.forEach(t),sv=n(kE," chapter of the \u{1F917} Hugging Face Task Guides."),kE.forEach(t),av=h(nh),qh=a(nh,"LI",{});var NE=r(qh);Sc=a(NE,"A",{href:!0});var OE=r(Sc);rv=n(OE,"Causal language modeling task guide"),OE.forEach(t),NE.forEach(t),nh.forEach(t),Tg=h(i),w(Fr.$$.fragment,i),Mg=h(i),Ft=a(i,"UL",{});var Ho=r(Ft);zo=a(Ho,"LI",{});var wc=r(zo);Wc=a(wc,"A",{href:!0});var IE=r(Wc);iv=n(IE,"XLMRobertaForMaskedLM"),IE.forEach(t),lv=n(wc," is supported by this "),xr=a(wc,"A",{href:!0,rel:!0});var DE=r(xr);dv=n(DE,"example script"),DE.forEach(t),cv=n(wc," and "),Er=a(wc,"A",{href:!0,rel:!0});var SE=r(Er);pv=n(SE,"notebook"),SE.forEach(t),hv=n(wc,"."),wc.forEach(t),uv=h(Ho),Co=a(Ho,"LI",{});var Tc=r(Co);Uc=a(Tc,"A",{href:!0});var WE=r(Uc);mv=n(WE,"TFXLMRobertaForMaskedLM"),WE.forEach(t),fv=n(Tc," is supported by this "),Rr=a(Tc,"A",{href:!0,rel:!0});var UE=r(Rr);gv=n(UE,"example script"),UE.forEach(t),_v=n(Tc," and "),Xr=a(Tc,"A",{href:!0,rel:!0});var BE=r(Xr);bv=n(BE,"notebook"),BE.forEach(t),kv=n(Tc,"."),Tc.forEach(t),vv=h(Ho),qo=a(Ho,"LI",{});var Mc=r(qo);Bc=a(Mc,"A",{href:!0});var HE=r(Bc);yv=n(HE,"FlaxXLMRobertaForMaskedLM"),HE.forEach(t),wv=n(Mc," is supported by this "),zr=a(Mc,"A",{href:!0,rel:!0});var QE=r(zr);Tv=n(QE,"example script"),QE.forEach(t),Mv=n(Mc," and "),Cr=a(Mc,"A",{href:!0,rel:!0});var KE=r(Cr);$v=n(KE,"notebook"),KE.forEach(t),Lv=n(Mc,"."),Mc.forEach(t),Fv=h(Ho),Hc=a(Ho,"LI",{});var vE=r(Hc);qr=a(vE,"A",{href:!0,rel:!0});var VE=r(qr);xv=n(VE,"Masked language modeling"),VE.forEach(t),Ev=n(vE," chapter of the \u{1F917} Hugging Face Course."),vE.forEach(t),Rv=h(Ho),jh=a(Ho,"LI",{});var JE=r(jh);Qc=a(JE,"A",{href:!0});var GE=r(Qc);Xv=n(GE,"Masked language modeling"),GE.forEach(t),JE.forEach(t),Ho.forEach(t),$g=h(i),w(jr.$$.fragment,i),Lg=h(i),xt=a(i,"UL",{});var Qo=r(xt);jo=a(Qo,"LI",{});var $c=r(jo);Kc=a($c,"A",{href:!0});var YE=r(Kc);zv=n(YE,"XLMRobertaForQuestionAnswering"),YE.forEach(t),Cv=n($c," is supported by this "),Ar=a($c,"A",{href:!0,rel:!0});var ZE=r(Ar);qv=n(ZE,"example script"),ZE.forEach(t),jv=n($c," and "),Pr=a($c,"A",{href:!0,rel:!0});var eR=r(Pr);Av=n(eR,"notebook"),eR.forEach(t),Pv=n($c,"."),$c.forEach(t),Nv=h(Qo),Ao=a(Qo,"LI",{});var Lc=r(Ao);Vc=a(Lc,"A",{href:!0});var tR=r(Vc);Ov=n(tR,"TFXLMRobertaForQuestionAnswering"),tR.forEach(t),Iv=n(Lc," is supported by this "),Nr=a(Lc,"A",{href:!0,rel:!0});var oR=r(Nr);Dv=n(oR,"example script"),oR.forEach(t),Sv=n(Lc," and "),Or=a(Lc,"A",{href:!0,rel:!0});var nR=r(Or);Wv=n(nR,"notebook"),nR.forEach(t),Uv=n(Lc,"."),Lc.forEach(t),Bv=h(Qo),rs=a(Qo,"LI",{});var gg=r(rs);Jc=a(gg,"A",{href:!0});var sR=r(Jc);Hv=n(sR,"FlaxXLMRobertaForQuestionAnswering"),sR.forEach(t),Qv=n(gg," is supported by this "),Ir=a(gg,"A",{href:!0,rel:!0});var aR=r(Ir);Kv=n(aR,"example script"),aR.forEach(t),Vv=n(gg,"."),gg.forEach(t),Jv=h(Qo),Gc=a(Qo,"LI",{});var yE=r(Gc);Dr=a(yE,"A",{href:!0,rel:!0});var rR=r(Dr);Gv=n(rR,"Question answering"),rR.forEach(t),Yv=n(yE," chapter of the \u{1F917} Hugging Face Course."),yE.forEach(t),Zv=h(Qo),Ah=a(Qo,"LI",{});var iR=r(Ah);Yc=a(iR,"A",{href:!0});var lR=r(Yc);ey=n(lR,"Question answering task guide"),lR.forEach(t),iR.forEach(t),Qo.forEach(t),Fg=h(i),Zc=a(i,"P",{});var dR=r(Zc);Ph=a(dR,"STRONG",{});var cR=r(Ph);ty=n(cR,"Multiple choice"),cR.forEach(t),dR.forEach(t),xg=h(i),Po=a(i,"UL",{});var sh=r(Po);No=a(sh,"LI",{});var Fc=r(No);ep=a(Fc,"A",{href:!0});var pR=r(ep);oy=n(pR,"XLMRobertaForMultipleChoice"),pR.forEach(t),ny=n(Fc," is supported by this "),Sr=a(Fc,"A",{href:!0,rel:!0});var hR=r(Sr);sy=n(hR,"example script"),hR.forEach(t),ay=n(Fc," and "),Wr=a(Fc,"A",{href:!0,rel:!0});var uR=r(Wr);ry=n(uR,"notebook"),uR.forEach(t),iy=n(Fc,"."),Fc.forEach(t),ly=h(sh),Oo=a(sh,"LI",{});var xc=r(Oo);tp=a(xc,"A",{href:!0});var mR=r(tp);dy=n(mR,"TFXLMRobertaForMultipleChoice"),mR.forEach(t),cy=n(xc," is supported by this "),Ur=a(xc,"A",{href:!0,rel:!0});var fR=r(Ur);py=n(fR,"example script"),fR.forEach(t),hy=n(xc," and "),Br=a(xc,"A",{href:!0,rel:!0});var gR=r(Br);uy=n(gR,"notebook"),gR.forEach(t),my=n(xc,"."),xc.forEach(t),fy=h(sh),Nh=a(sh,"LI",{});var _R=r(Nh);op=a(_R,"A",{href:!0});var bR=r(op);gy=n(bR,"Multiple choice task guide"),bR.forEach(t),_R.forEach(t),sh.forEach(t),Eg=h(i),np=a(i,"P",{});var kR=r(np);_y=n(kR,"\u{1F680} Deploy"),kR.forEach(t),Rg=h(i),sp=a(i,"UL",{});var vR=r(sp);Hr=a(vR,"LI",{});var L_=r(Hr);by=n(L_,"A blog post on how to "),Qr=a(L_,"A",{href:!0,rel:!0});var yR=r(Qr);ky=n(yR,"Deploy Serverless XLM RoBERTa on AWS Lambda"),yR.forEach(t),vy=n(L_,"."),L_.forEach(t),vR.forEach(t),Xg=h(i),ln=a(i,"H2",{class:!0});var F_=r(ln);is=a(F_,"A",{id:!0,class:!0,href:!0});var wR=r(is);Oh=a(wR,"SPAN",{});var TR=r(Oh);w(Kr.$$.fragment,TR),TR.forEach(t),wR.forEach(t),yy=h(F_),Ih=a(F_,"SPAN",{});var MR=r(Ih);wy=n(MR,"XLMRobertaConfig"),MR.forEach(t),F_.forEach(t),zg=h(i),Wt=a(i,"DIV",{class:!0});var Aa=r(Wt);w(Vr.$$.fragment,Aa),Ty=h(Aa),go=a(Aa,"P",{});var Pa=r(go);My=n(Pa,"This is the configuration class to store the configuration of a "),ap=a(Pa,"A",{href:!0});var $R=r(ap);$y=n($R,"XLMRobertaModel"),$R.forEach(t),Ly=n(Pa," or a "),rp=a(Pa,"A",{href:!0});var LR=r(rp);Fy=n(LR,"TFXLMRobertaModel"),LR.forEach(t),xy=n(Pa,`. It
is used to instantiate a XLM-RoBERTa model according to the specified arguments, defining the model architecture.
Instantiating a configuration with the defaults will yield a similar configuration to that of the XLMRoBERTa
`),Jr=a(Pa,"A",{href:!0,rel:!0});var FR=r(Jr);Ey=n(FR,"xlm-roberta-base"),FR.forEach(t),Ry=n(Pa," architecture."),Pa.forEach(t),Xy=h(Aa),dn=a(Aa,"P",{});var ah=r(dn);zy=n(ah,"Configuration objects inherit from "),ip=a(ah,"A",{href:!0});var xR=r(ip);Cy=n(xR,"PretrainedConfig"),xR.forEach(t),qy=n(ah,` and can be used to control the model outputs. Read the
documentation from `),lp=a(ah,"A",{href:!0});var ER=r(lp);jy=n(ER,"PretrainedConfig"),ER.forEach(t),Ay=n(ah," for more information."),ah.forEach(t),Py=h(Aa),w(ls.$$.fragment,Aa),Aa.forEach(t),Cg=h(i),cn=a(i,"H2",{class:!0});var x_=r(cn);ds=a(x_,"A",{id:!0,class:!0,href:!0});var RR=r(ds);Dh=a(RR,"SPAN",{});var XR=r(Dh);w(Gr.$$.fragment,XR),XR.forEach(t),RR.forEach(t),Ny=h(x_),Sh=a(x_,"SPAN",{});var zR=r(Sh);Oy=n(zR,"XLMRobertaTokenizer"),zR.forEach(t),x_.forEach(t),qg=h(i),et=a(i,"DIV",{class:!0});var qt=r(et);w(Yr.$$.fragment,qt),Iy=h(qt),_o=a(qt,"P",{});var Na=r(_o);Dy=n(Na,"Adapted from "),dp=a(Na,"A",{href:!0});var CR=r(dp);Sy=n(CR,"RobertaTokenizer"),CR.forEach(t),Wy=n(Na," and "),cp=a(Na,"A",{href:!0});var qR=r(cp);Uy=n(qR,"XLNetTokenizer"),qR.forEach(t),By=n(Na,`. Based on
`),Zr=a(Na,"A",{href:!0,rel:!0});var jR=r(Zr);Hy=n(jR,"SentencePiece"),jR.forEach(t),Qy=n(Na,"."),Na.forEach(t),Ky=h(qt),ei=a(qt,"P",{});var E_=r(ei);Vy=n(E_,"This tokenizer inherits from "),pp=a(E_,"A",{href:!0});var AR=r(pp);Jy=n(AR,"PreTrainedTokenizer"),AR.forEach(t),Gy=n(E_,` which contains most of the main methods. Users should refer to
this superclass for more information regarding those methods.`),E_.forEach(t),Yy=h(qt),Io=a(qt,"DIV",{class:!0});var rh=r(Io);w(ti.$$.fragment,rh),Zy=h(rh),Wh=a(rh,"P",{});var PR=r(Wh);e1=n(PR,`Build model inputs from a sequence or a pair of sequence for sequence classification tasks by concatenating and
adding special tokens. An XLM-RoBERTa sequence has the following format:`),PR.forEach(t),t1=h(rh),oi=a(rh,"UL",{});var R_=r(oi);hp=a(R_,"LI",{});var wE=r(hp);o1=n(wE,"single sequence: "),Uh=a(wE,"CODE",{});var NR=r(Uh);n1=n(NR,"<s> X </s>"),NR.forEach(t),wE.forEach(t),s1=h(R_),up=a(R_,"LI",{});var TE=r(up);a1=n(TE,"pair of sequences: "),Bh=a(TE,"CODE",{});var OR=r(Bh);r1=n(OR,"<s> A </s></s> B </s>"),OR.forEach(t),TE.forEach(t),R_.forEach(t),rh.forEach(t),i1=h(qt),cs=a(qt,"DIV",{class:!0});var X_=r(cs);w(ni.$$.fragment,X_),l1=h(X_),si=a(X_,"P",{});var z_=r(si);d1=n(z_,`Retrieve sequence ids from a token list that has no special tokens added. This method is called when adding
special tokens using the tokenizer `),Hh=a(z_,"CODE",{});var IR=r(Hh);c1=n(IR,"prepare_for_model"),IR.forEach(t),p1=n(z_," method."),z_.forEach(t),X_.forEach(t),h1=h(qt),ps=a(qt,"DIV",{class:!0});var C_=r(ps);w(ai.$$.fragment,C_),u1=h(C_),Qh=a(C_,"P",{});var DR=r(Qh);m1=n(DR,`Create a mask from the two sequences passed to be used in a sequence-pair classification task. XLM-RoBERTa does
not make use of token type ids, therefore a list of zeros is returned.`),DR.forEach(t),C_.forEach(t),f1=h(qt),mp=a(qt,"DIV",{class:!0});var SR=r(mp);w(ri.$$.fragment,SR),SR.forEach(t),qt.forEach(t),jg=h(i),pn=a(i,"H2",{class:!0});var q_=r(pn);hs=a(q_,"A",{id:!0,class:!0,href:!0});var WR=r(hs);Kh=a(WR,"SPAN",{});var UR=r(Kh);w(ii.$$.fragment,UR),UR.forEach(t),WR.forEach(t),g1=h(q_),Vh=a(q_,"SPAN",{});var BR=r(Vh);_1=n(BR,"XLMRobertaTokenizerFast"),BR.forEach(t),q_.forEach(t),Ag=h(i),bt=a(i,"DIV",{class:!0});var Ko=r(bt);w(li.$$.fragment,Ko),b1=h(Ko),Ut=a(Ko,"P",{});var Vo=r(Ut);k1=n(Vo,"Construct a \u201Cfast\u201D XLM-RoBERTa tokenizer (backed by HuggingFace\u2019s "),Jh=a(Vo,"EM",{});var HR=r(Jh);v1=n(HR,"tokenizers"),HR.forEach(t),y1=n(Vo,` library). Adapted from
`),fp=a(Vo,"A",{href:!0});var QR=r(fp);w1=n(QR,"RobertaTokenizer"),QR.forEach(t),T1=n(Vo," and "),gp=a(Vo,"A",{href:!0});var KR=r(gp);M1=n(KR,"XLNetTokenizer"),KR.forEach(t),$1=n(Vo,`. Based on
`),di=a(Vo,"A",{href:!0,rel:!0});var VR=r(di);L1=n(VR,"BPE"),VR.forEach(t),F1=n(Vo,"."),Vo.forEach(t),x1=h(Ko),ci=a(Ko,"P",{});var j_=r(ci);E1=n(j_,"This tokenizer inherits from "),_p=a(j_,"A",{href:!0});var JR=r(_p);R1=n(JR,"PreTrainedTokenizerFast"),JR.forEach(t),X1=n(j_,` which contains most of the main methods. Users should
refer to this superclass for more information regarding those methods.`),j_.forEach(t),z1=h(Ko),Do=a(Ko,"DIV",{class:!0});var ih=r(Do);w(pi.$$.fragment,ih),C1=h(ih),Gh=a(ih,"P",{});var GR=r(Gh);q1=n(GR,`Build model inputs from a sequence or a pair of sequence for sequence classification tasks by concatenating and
adding special tokens. An XLM-RoBERTa sequence has the following format:`),GR.forEach(t),j1=h(ih),hi=a(ih,"UL",{});var A_=r(hi);bp=a(A_,"LI",{});var ME=r(bp);A1=n(ME,"single sequence: "),Yh=a(ME,"CODE",{});var YR=r(Yh);P1=n(YR,"<s> X </s>"),YR.forEach(t),ME.forEach(t),N1=h(A_),kp=a(A_,"LI",{});var $E=r(kp);O1=n($E,"pair of sequences: "),Zh=a($E,"CODE",{});var ZR=r(Zh);I1=n(ZR,"<s> A </s></s> B </s>"),ZR.forEach(t),$E.forEach(t),A_.forEach(t),ih.forEach(t),D1=h(Ko),us=a(Ko,"DIV",{class:!0});var P_=r(us);w(ui.$$.fragment,P_),S1=h(P_),eu=a(P_,"P",{});var e4=r(eu);W1=n(e4,`Create a mask from the two sequences passed to be used in a sequence-pair classification task. XLM-RoBERTa does
not make use of token type ids, therefore a list of zeros is returned.`),e4.forEach(t),P_.forEach(t),Ko.forEach(t),Pg=h(i),hn=a(i,"H2",{class:!0});var N_=r(hn);ms=a(N_,"A",{id:!0,class:!0,href:!0});var t4=r(ms);tu=a(t4,"SPAN",{});var o4=r(tu);w(mi.$$.fragment,o4),o4.forEach(t),t4.forEach(t),U1=h(N_),ou=a(N_,"SPAN",{});var n4=r(ou);B1=n(n4,"XLMRobertaModel"),n4.forEach(t),N_.forEach(t),Ng=h(i),Ze=a(i,"DIV",{class:!0});var _t=r(Ze);w(fi.$$.fragment,_t),H1=h(_t),nu=a(_t,"P",{});var s4=r(nu);Q1=n(s4,"The bare XLM-RoBERTa Model transformer outputting raw hidden-states without any specific head on top."),s4.forEach(t),K1=h(_t),gi=a(_t,"P",{});var O_=r(gi);V1=n(O_,"This model inherits from "),vp=a(O_,"A",{href:!0});var a4=r(vp);J1=n(a4,"PreTrainedModel"),a4.forEach(t),G1=n(O_,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),O_.forEach(t),Y1=h(_t),_i=a(_t,"P",{});var I_=r(_i);Z1=n(I_,"This model is also a PyTorch "),bi=a(I_,"A",{href:!0,rel:!0});var r4=r(bi);ew=n(r4,"torch.nn.Module"),r4.forEach(t),tw=n(I_,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),I_.forEach(t),ow=h(_t),ki=a(_t,"P",{});var D_=r(ki);nw=n(D_,`The model can behave as an encoder (with only self-attention) as well as a decoder, in which case a layer of
cross-attention is added between the self-attention layers, following the architecture described in `),su=a(D_,"EM",{});var i4=r(su);sw=n(i4,`Attention is
all you need`),i4.forEach(t),aw=n(D_,`_ by Ashish Vaswani, Noam Shazeer, Niki Parmar, Jakob Uszkoreit, Llion Jones, Aidan N. Gomez, Lukasz
Kaiser and Illia Polosukhin.`),D_.forEach(t),rw=h(_t),lt=a(_t,"P",{});var jt=r(lt);iw=n(jt,"To behave as an decoder the model needs to be initialized with the "),au=a(jt,"CODE",{});var l4=r(au);lw=n(l4,"is_decoder"),l4.forEach(t),dw=n(jt,` argument of the configuration set
to `),ru=a(jt,"CODE",{});var d4=r(ru);cw=n(d4,"True"),d4.forEach(t),pw=n(jt,". To be used in a Seq2Seq model, the model needs to initialized with both "),iu=a(jt,"CODE",{});var c4=r(iu);hw=n(c4,"is_decoder"),c4.forEach(t),uw=n(jt,` argument and
`),lu=a(jt,"CODE",{});var p4=r(lu);mw=n(p4,"add_cross_attention"),p4.forEach(t),fw=n(jt," set to "),du=a(jt,"CODE",{});var h4=r(du);gw=n(h4,"True"),h4.forEach(t),_w=n(jt,"; an "),cu=a(jt,"CODE",{});var u4=r(cu);bw=n(u4,"encoder_hidden_states"),u4.forEach(t),kw=n(jt," is then expected as an input to the forward pass."),jt.forEach(t),vw=h(_t),fs=a(_t,"P",{});var _g=r(fs);yw=n(_g,".. _"),pu=a(_g,"EM",{});var m4=r(pu);ww=n(m4,"Attention is all you need"),m4.forEach(t),Tw=n(_g,": "),vi=a(_g,"A",{href:!0,rel:!0});var f4=r(vi);Mw=n(f4,"https://arxiv.org/abs/1706.03762"),f4.forEach(t),_g.forEach(t),$w=h(_t),Ht=a(_t,"DIV",{class:!0});var Oa=r(Ht);w(yi.$$.fragment,Oa),Lw=h(Oa),un=a(Oa,"P",{});var lh=r(un);Fw=n(lh,"The "),yp=a(lh,"A",{href:!0});var g4=r(yp);xw=n(g4,"XLMRobertaModel"),g4.forEach(t),Ew=n(lh," forward method, overrides the "),hu=a(lh,"CODE",{});var _4=r(hu);Rw=n(_4,"__call__"),_4.forEach(t),Xw=n(lh," special method."),lh.forEach(t),zw=h(Oa),w(gs.$$.fragment,Oa),Cw=h(Oa),w(_s.$$.fragment,Oa),Oa.forEach(t),_t.forEach(t),Og=h(i),mn=a(i,"H2",{class:!0});var S_=r(mn);bs=a(S_,"A",{id:!0,class:!0,href:!0});var b4=r(bs);uu=a(b4,"SPAN",{});var k4=r(uu);w(wi.$$.fragment,k4),k4.forEach(t),b4.forEach(t),qw=h(S_),mu=a(S_,"SPAN",{});var v4=r(mu);jw=n(v4,"XLMRobertaForCausalLM"),v4.forEach(t),S_.forEach(t),Ig=h(i),kt=a(i,"DIV",{class:!0});var Jo=r(kt);w(Ti.$$.fragment,Jo),Aw=h(Jo),Mi=a(Jo,"P",{});var W_=r(Mi);Pw=n(W_,"XLM-RoBERTa Model with a "),fu=a(W_,"CODE",{});var y4=r(fu);Nw=n(y4,"language modeling"),y4.forEach(t),Ow=n(W_," head on top for CLM fine-tuning."),W_.forEach(t),Iw=h(Jo),$i=a(Jo,"P",{});var U_=r($i);Dw=n(U_,"This model inherits from "),wp=a(U_,"A",{href:!0});var w4=r(wp);Sw=n(w4,"PreTrainedModel"),w4.forEach(t),Ww=n(U_,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),U_.forEach(t),Uw=h(Jo),Li=a(Jo,"P",{});var B_=r(Li);Bw=n(B_,"This model is also a PyTorch "),Fi=a(B_,"A",{href:!0,rel:!0});var T4=r(Fi);Hw=n(T4,"torch.nn.Module"),T4.forEach(t),Qw=n(B_,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),B_.forEach(t),Kw=h(Jo),Qt=a(Jo,"DIV",{class:!0});var Ia=r(Qt);w(xi.$$.fragment,Ia),Vw=h(Ia),fn=a(Ia,"P",{});var dh=r(fn);Jw=n(dh,"The "),Tp=a(dh,"A",{href:!0});var M4=r(Tp);Gw=n(M4,"XLMRobertaForCausalLM"),M4.forEach(t),Yw=n(dh," forward method, overrides the "),gu=a(dh,"CODE",{});var $4=r(gu);Zw=n($4,"__call__"),$4.forEach(t),eT=n(dh," special method."),dh.forEach(t),tT=h(Ia),w(ks.$$.fragment,Ia),oT=h(Ia),w(vs.$$.fragment,Ia),Ia.forEach(t),Jo.forEach(t),Dg=h(i),gn=a(i,"H2",{class:!0});var H_=r(gn);ys=a(H_,"A",{id:!0,class:!0,href:!0});var L4=r(ys);_u=a(L4,"SPAN",{});var F4=r(_u);w(Ei.$$.fragment,F4),F4.forEach(t),L4.forEach(t),nT=h(H_),bu=a(H_,"SPAN",{});var x4=r(bu);sT=n(x4,"XLMRobertaForMaskedLM"),x4.forEach(t),H_.forEach(t),Sg=h(i),vt=a(i,"DIV",{class:!0});var Go=r(vt);w(Ri.$$.fragment,Go),aT=h(Go),Xi=a(Go,"P",{});var Q_=r(Xi);rT=n(Q_,"XLM-RoBERTa Model with a "),ku=a(Q_,"CODE",{});var E4=r(ku);iT=n(E4,"language modeling"),E4.forEach(t),lT=n(Q_," head on top."),Q_.forEach(t),dT=h(Go),zi=a(Go,"P",{});var K_=r(zi);cT=n(K_,"This model inherits from "),Mp=a(K_,"A",{href:!0});var R4=r(Mp);pT=n(R4,"PreTrainedModel"),R4.forEach(t),hT=n(K_,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),K_.forEach(t),uT=h(Go),Ci=a(Go,"P",{});var V_=r(Ci);mT=n(V_,"This model is also a PyTorch "),qi=a(V_,"A",{href:!0,rel:!0});var X4=r(qi);fT=n(X4,"torch.nn.Module"),X4.forEach(t),gT=n(V_,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),V_.forEach(t),_T=h(Go),Kt=a(Go,"DIV",{class:!0});var Da=r(Kt);w(ji.$$.fragment,Da),bT=h(Da),_n=a(Da,"P",{});var ch=r(_n);kT=n(ch,"The "),$p=a(ch,"A",{href:!0});var z4=r($p);vT=n(z4,"XLMRobertaForMaskedLM"),z4.forEach(t),yT=n(ch," forward method, overrides the "),vu=a(ch,"CODE",{});var C4=r(vu);wT=n(C4,"__call__"),C4.forEach(t),TT=n(ch," special method."),ch.forEach(t),MT=h(Da),w(ws.$$.fragment,Da),$T=h(Da),w(Ts.$$.fragment,Da),Da.forEach(t),Go.forEach(t),Wg=h(i),bn=a(i,"H2",{class:!0});var J_=r(bn);Ms=a(J_,"A",{id:!0,class:!0,href:!0});var q4=r(Ms);yu=a(q4,"SPAN",{});var j4=r(yu);w(Ai.$$.fragment,j4),j4.forEach(t),q4.forEach(t),LT=h(J_),wu=a(J_,"SPAN",{});var A4=r(wu);FT=n(A4,"XLMRobertaForSequenceClassification"),A4.forEach(t),J_.forEach(t),Ug=h(i),yt=a(i,"DIV",{class:!0});var Yo=r(yt);w(Pi.$$.fragment,Yo),xT=h(Yo),Tu=a(Yo,"P",{});var P4=r(Tu);ET=n(P4,`XLM-RoBERTa Model transformer with a sequence classification/regression head on top (a linear layer on top of the
pooled output) e.g. for GLUE tasks.`),P4.forEach(t),RT=h(Yo),Ni=a(Yo,"P",{});var G_=r(Ni);XT=n(G_,"This model inherits from "),Lp=a(G_,"A",{href:!0});var N4=r(Lp);zT=n(N4,"PreTrainedModel"),N4.forEach(t),CT=n(G_,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),G_.forEach(t),qT=h(Yo),Oi=a(Yo,"P",{});var Y_=r(Oi);jT=n(Y_,"This model is also a PyTorch "),Ii=a(Y_,"A",{href:!0,rel:!0});var O4=r(Ii);AT=n(O4,"torch.nn.Module"),O4.forEach(t),PT=n(Y_,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),Y_.forEach(t),NT=h(Yo),Et=a(Yo,"DIV",{class:!0});var Zo=r(Et);w(Di.$$.fragment,Zo),OT=h(Zo),kn=a(Zo,"P",{});var ph=r(kn);IT=n(ph,"The "),Fp=a(ph,"A",{href:!0});var I4=r(Fp);DT=n(I4,"XLMRobertaForSequenceClassification"),I4.forEach(t),ST=n(ph," forward method, overrides the "),Mu=a(ph,"CODE",{});var D4=r(Mu);WT=n(D4,"__call__"),D4.forEach(t),UT=n(ph," special method."),ph.forEach(t),BT=h(Zo),w($s.$$.fragment,Zo),HT=h(Zo),w(Ls.$$.fragment,Zo),QT=h(Zo),w(Fs.$$.fragment,Zo),Zo.forEach(t),Yo.forEach(t),Bg=h(i),vn=a(i,"H2",{class:!0});var Z_=r(vn);xs=a(Z_,"A",{id:!0,class:!0,href:!0});var S4=r(xs);$u=a(S4,"SPAN",{});var W4=r($u);w(Si.$$.fragment,W4),W4.forEach(t),S4.forEach(t),KT=h(Z_),Lu=a(Z_,"SPAN",{});var U4=r(Lu);VT=n(U4,"XLMRobertaForMultipleChoice"),U4.forEach(t),Z_.forEach(t),Hg=h(i),wt=a(i,"DIV",{class:!0});var en=r(wt);w(Wi.$$.fragment,en),JT=h(en),Fu=a(en,"P",{});var B4=r(Fu);GT=n(B4,`XLM-RoBERTa Model with a multiple choice classification head on top (a linear layer on top of the pooled output and
a softmax) e.g. for RocStories/SWAG tasks.`),B4.forEach(t),YT=h(en),Ui=a(en,"P",{});var eb=r(Ui);ZT=n(eb,"This model inherits from "),xp=a(eb,"A",{href:!0});var H4=r(xp);eM=n(H4,"PreTrainedModel"),H4.forEach(t),tM=n(eb,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),eb.forEach(t),oM=h(en),Bi=a(en,"P",{});var tb=r(Bi);nM=n(tb,"This model is also a PyTorch "),Hi=a(tb,"A",{href:!0,rel:!0});var Q4=r(Hi);sM=n(Q4,"torch.nn.Module"),Q4.forEach(t),aM=n(tb,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),tb.forEach(t),rM=h(en),Vt=a(en,"DIV",{class:!0});var Sa=r(Vt);w(Qi.$$.fragment,Sa),iM=h(Sa),yn=a(Sa,"P",{});var hh=r(yn);lM=n(hh,"The "),Ep=a(hh,"A",{href:!0});var K4=r(Ep);dM=n(K4,"XLMRobertaForMultipleChoice"),K4.forEach(t),cM=n(hh," forward method, overrides the "),xu=a(hh,"CODE",{});var V4=r(xu);pM=n(V4,"__call__"),V4.forEach(t),hM=n(hh," special method."),hh.forEach(t),uM=h(Sa),w(Es.$$.fragment,Sa),mM=h(Sa),w(Rs.$$.fragment,Sa),Sa.forEach(t),en.forEach(t),Qg=h(i),wn=a(i,"H2",{class:!0});var ob=r(wn);Xs=a(ob,"A",{id:!0,class:!0,href:!0});var J4=r(Xs);Eu=a(J4,"SPAN",{});var G4=r(Eu);w(Ki.$$.fragment,G4),G4.forEach(t),J4.forEach(t),fM=h(ob),Ru=a(ob,"SPAN",{});var Y4=r(Ru);gM=n(Y4,"XLMRobertaForTokenClassification"),Y4.forEach(t),ob.forEach(t),Kg=h(i),Tt=a(i,"DIV",{class:!0});var tn=r(Tt);w(Vi.$$.fragment,tn),_M=h(tn),Xu=a(tn,"P",{});var Z4=r(Xu);bM=n(Z4,`XLM-RoBERTa Model with a token classification head on top (a linear layer on top of the hidden-states output) e.g.
for Named-Entity-Recognition (NER) tasks.`),Z4.forEach(t),kM=h(tn),Ji=a(tn,"P",{});var nb=r(Ji);vM=n(nb,"This model inherits from "),Rp=a(nb,"A",{href:!0});var eX=r(Rp);yM=n(eX,"PreTrainedModel"),eX.forEach(t),wM=n(nb,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),nb.forEach(t),TM=h(tn),Gi=a(tn,"P",{});var sb=r(Gi);MM=n(sb,"This model is also a PyTorch "),Yi=a(sb,"A",{href:!0,rel:!0});var tX=r(Yi);$M=n(tX,"torch.nn.Module"),tX.forEach(t),LM=n(sb,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),sb.forEach(t),FM=h(tn),Jt=a(tn,"DIV",{class:!0});var Wa=r(Jt);w(Zi.$$.fragment,Wa),xM=h(Wa),Tn=a(Wa,"P",{});var uh=r(Tn);EM=n(uh,"The "),Xp=a(uh,"A",{href:!0});var oX=r(Xp);RM=n(oX,"XLMRobertaForTokenClassification"),oX.forEach(t),XM=n(uh," forward method, overrides the "),zu=a(uh,"CODE",{});var nX=r(zu);zM=n(nX,"__call__"),nX.forEach(t),CM=n(uh," special method."),uh.forEach(t),qM=h(Wa),w(zs.$$.fragment,Wa),jM=h(Wa),w(Cs.$$.fragment,Wa),Wa.forEach(t),tn.forEach(t),Vg=h(i),Mn=a(i,"H2",{class:!0});var ab=r(Mn);qs=a(ab,"A",{id:!0,class:!0,href:!0});var sX=r(qs);Cu=a(sX,"SPAN",{});var aX=r(Cu);w(el.$$.fragment,aX),aX.forEach(t),sX.forEach(t),AM=h(ab),qu=a(ab,"SPAN",{});var rX=r(qu);PM=n(rX,"XLMRobertaForQuestionAnswering"),rX.forEach(t),ab.forEach(t),Jg=h(i),Mt=a(i,"DIV",{class:!0});var on=r(Mt);w(tl.$$.fragment,on),NM=h(on),$n=a(on,"P",{});var mh=r($n);OM=n(mh,`XLM-RoBERTa Model with a span classification head on top for extractive question-answering tasks like SQuAD (a
linear layers on top of the hidden-states output to compute `),ju=a(mh,"CODE",{});var iX=r(ju);IM=n(iX,"span start logits"),iX.forEach(t),DM=n(mh," and "),Au=a(mh,"CODE",{});var lX=r(Au);SM=n(lX,"span end logits"),lX.forEach(t),WM=n(mh,")."),mh.forEach(t),UM=h(on),ol=a(on,"P",{});var rb=r(ol);BM=n(rb,"This model inherits from "),zp=a(rb,"A",{href:!0});var dX=r(zp);HM=n(dX,"PreTrainedModel"),dX.forEach(t),QM=n(rb,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),rb.forEach(t),KM=h(on),nl=a(on,"P",{});var ib=r(nl);VM=n(ib,"This model is also a PyTorch "),sl=a(ib,"A",{href:!0,rel:!0});var cX=r(sl);JM=n(cX,"torch.nn.Module"),cX.forEach(t),GM=n(ib,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),ib.forEach(t),YM=h(on),Gt=a(on,"DIV",{class:!0});var Ua=r(Gt);w(al.$$.fragment,Ua),ZM=h(Ua),Ln=a(Ua,"P",{});var fh=r(Ln);e$=n(fh,"The "),Cp=a(fh,"A",{href:!0});var pX=r(Cp);t$=n(pX,"XLMRobertaForQuestionAnswering"),pX.forEach(t),o$=n(fh," forward method, overrides the "),Pu=a(fh,"CODE",{});var hX=r(Pu);n$=n(hX,"__call__"),hX.forEach(t),s$=n(fh," special method."),fh.forEach(t),a$=h(Ua),w(js.$$.fragment,Ua),r$=h(Ua),w(As.$$.fragment,Ua),Ua.forEach(t),on.forEach(t),Gg=h(i),Fn=a(i,"H2",{class:!0});var lb=r(Fn);Ps=a(lb,"A",{id:!0,class:!0,href:!0});var uX=r(Ps);Nu=a(uX,"SPAN",{});var mX=r(Nu);w(rl.$$.fragment,mX),mX.forEach(t),uX.forEach(t),i$=h(lb),Ou=a(lb,"SPAN",{});var fX=r(Ou);l$=n(fX,"TFXLMRobertaModel"),fX.forEach(t),lb.forEach(t),Yg=h(i),dt=a(i,"DIV",{class:!0});var lo=r(dt);w(il.$$.fragment,lo),d$=h(lo),Iu=a(lo,"P",{});var gX=r(Iu);c$=n(gX,"The bare XLM RoBERTa Model transformer outputting raw hidden-states without any specific head on top."),gX.forEach(t),p$=h(lo),ll=a(lo,"P",{});var db=r(ll);h$=n(db,"This model inherits from "),qp=a(db,"A",{href:!0});var _X=r(qp);u$=n(_X,"TFPreTrainedModel"),_X.forEach(t),m$=n(db,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),db.forEach(t),f$=h(lo),dl=a(lo,"P",{});var cb=r(dl);g$=n(cb,"This model is also a "),cl=a(cb,"A",{href:!0,rel:!0});var bX=r(cl);_$=n(bX,"tf.keras.Model"),bX.forEach(t),b$=n(cb,` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),cb.forEach(t),k$=h(lo),w(Ns.$$.fragment,lo),v$=h(lo),Yt=a(lo,"DIV",{class:!0});var Ba=r(Yt);w(pl.$$.fragment,Ba),y$=h(Ba),xn=a(Ba,"P",{});var gh=r(xn);w$=n(gh,"The "),jp=a(gh,"A",{href:!0});var kX=r(jp);T$=n(kX,"TFXLMRobertaModel"),kX.forEach(t),M$=n(gh," forward method, overrides the "),Du=a(gh,"CODE",{});var vX=r(Du);$$=n(vX,"__call__"),vX.forEach(t),L$=n(gh," special method."),gh.forEach(t),F$=h(Ba),w(Os.$$.fragment,Ba),x$=h(Ba),w(Is.$$.fragment,Ba),Ba.forEach(t),lo.forEach(t),Zg=h(i),En=a(i,"H2",{class:!0});var pb=r(En);Ds=a(pb,"A",{id:!0,class:!0,href:!0});var yX=r(Ds);Su=a(yX,"SPAN",{});var wX=r(Su);w(hl.$$.fragment,wX),wX.forEach(t),yX.forEach(t),E$=h(pb),Wu=a(pb,"SPAN",{});var TX=r(Wu);R$=n(TX,"TFXLMRobertaForCausalLM"),TX.forEach(t),pb.forEach(t),e_=h(i),ct=a(i,"DIV",{class:!0});var co=r(ct);w(ul.$$.fragment,co),X$=h(co),ml=a(co,"P",{});var hb=r(ml);z$=n(hb,"XLM-RoBERTa Model with a "),Uu=a(hb,"CODE",{});var MX=r(Uu);C$=n(MX,"language modeling"),MX.forEach(t),q$=n(hb," head on top for CLM fine-tuning."),hb.forEach(t),j$=h(co),fl=a(co,"P",{});var ub=r(fl);A$=n(ub,"This model inherits from "),Ap=a(ub,"A",{href:!0});var $X=r(Ap);P$=n($X,"TFPreTrainedModel"),$X.forEach(t),N$=n(ub,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),ub.forEach(t),O$=h(co),gl=a(co,"P",{});var mb=r(gl);I$=n(mb,"This model is also a "),_l=a(mb,"A",{href:!0,rel:!0});var LX=r(_l);D$=n(LX,"tf.keras.Model"),LX.forEach(t),S$=n(mb,` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),mb.forEach(t),W$=h(co),w(Ss.$$.fragment,co),U$=h(co),Zt=a(co,"DIV",{class:!0});var Ha=r(Zt);w(bl.$$.fragment,Ha),B$=h(Ha),Rn=a(Ha,"P",{});var _h=r(Rn);H$=n(_h,"The "),Pp=a(_h,"A",{href:!0});var FX=r(Pp);Q$=n(FX,"TFXLMRobertaForCausalLM"),FX.forEach(t),K$=n(_h," forward method, overrides the "),Bu=a(_h,"CODE",{});var xX=r(Bu);V$=n(xX,"__call__"),xX.forEach(t),J$=n(_h," special method."),_h.forEach(t),G$=h(Ha),w(Ws.$$.fragment,Ha),Y$=h(Ha),w(Us.$$.fragment,Ha),Ha.forEach(t),co.forEach(t),t_=h(i),Xn=a(i,"H2",{class:!0});var fb=r(Xn);Bs=a(fb,"A",{id:!0,class:!0,href:!0});var EX=r(Bs);Hu=a(EX,"SPAN",{});var RX=r(Hu);w(kl.$$.fragment,RX),RX.forEach(t),EX.forEach(t),Z$=h(fb),Qu=a(fb,"SPAN",{});var XX=r(Qu);e2=n(XX,"TFXLMRobertaForMaskedLM"),XX.forEach(t),fb.forEach(t),o_=h(i),pt=a(i,"DIV",{class:!0});var po=r(pt);w(vl.$$.fragment,po),t2=h(po),yl=a(po,"P",{});var gb=r(yl);o2=n(gb,"XLM RoBERTa Model with a "),Ku=a(gb,"CODE",{});var zX=r(Ku);n2=n(zX,"language modeling"),zX.forEach(t),s2=n(gb," head on top."),gb.forEach(t),a2=h(po),wl=a(po,"P",{});var _b=r(wl);r2=n(_b,"This model inherits from "),Np=a(_b,"A",{href:!0});var CX=r(Np);i2=n(CX,"TFPreTrainedModel"),CX.forEach(t),l2=n(_b,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),_b.forEach(t),d2=h(po),Tl=a(po,"P",{});var bb=r(Tl);c2=n(bb,"This model is also a "),Ml=a(bb,"A",{href:!0,rel:!0});var qX=r(Ml);p2=n(qX,"tf.keras.Model"),qX.forEach(t),h2=n(bb,` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),bb.forEach(t),u2=h(po),w(Hs.$$.fragment,po),m2=h(po),Rt=a(po,"DIV",{class:!0});var nn=r(Rt);w($l.$$.fragment,nn),f2=h(nn),zn=a(nn,"P",{});var bh=r(zn);g2=n(bh,"The "),Op=a(bh,"A",{href:!0});var jX=r(Op);_2=n(jX,"TFXLMRobertaForMaskedLM"),jX.forEach(t),b2=n(bh," forward method, overrides the "),Vu=a(bh,"CODE",{});var AX=r(Vu);k2=n(AX,"__call__"),AX.forEach(t),v2=n(bh," special method."),bh.forEach(t),y2=h(nn),w(Qs.$$.fragment,nn),w2=h(nn),w(Ks.$$.fragment,nn),T2=h(nn),w(Vs.$$.fragment,nn),nn.forEach(t),po.forEach(t),n_=h(i),Cn=a(i,"H2",{class:!0});var kb=r(Cn);Js=a(kb,"A",{id:!0,class:!0,href:!0});var PX=r(Js);Ju=a(PX,"SPAN",{});var NX=r(Ju);w(Ll.$$.fragment,NX),NX.forEach(t),PX.forEach(t),M2=h(kb),Gu=a(kb,"SPAN",{});var OX=r(Gu);$2=n(OX,"TFXLMRobertaForSequenceClassification"),OX.forEach(t),kb.forEach(t),s_=h(i),ht=a(i,"DIV",{class:!0});var ho=r(ht);w(Fl.$$.fragment,ho),L2=h(ho),Yu=a(ho,"P",{});var IX=r(Yu);F2=n(IX,`XLM RoBERTa Model transformer with a sequence classification/regression head on top (a linear layer on top of the
pooled output) e.g. for GLUE tasks.`),IX.forEach(t),x2=h(ho),xl=a(ho,"P",{});var vb=r(xl);E2=n(vb,"This model inherits from "),Ip=a(vb,"A",{href:!0});var DX=r(Ip);R2=n(DX,"TFPreTrainedModel"),DX.forEach(t),X2=n(vb,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),vb.forEach(t),z2=h(ho),El=a(ho,"P",{});var yb=r(El);C2=n(yb,"This model is also a "),Rl=a(yb,"A",{href:!0,rel:!0});var SX=r(Rl);q2=n(SX,"tf.keras.Model"),SX.forEach(t),j2=n(yb,` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),yb.forEach(t),A2=h(ho),w(Gs.$$.fragment,ho),P2=h(ho),Xt=a(ho,"DIV",{class:!0});var sn=r(Xt);w(Xl.$$.fragment,sn),N2=h(sn),qn=a(sn,"P",{});var kh=r(qn);O2=n(kh,"The "),Dp=a(kh,"A",{href:!0});var WX=r(Dp);I2=n(WX,"TFXLMRobertaForSequenceClassification"),WX.forEach(t),D2=n(kh," forward method, overrides the "),Zu=a(kh,"CODE",{});var UX=r(Zu);S2=n(UX,"__call__"),UX.forEach(t),W2=n(kh," special method."),kh.forEach(t),U2=h(sn),w(Ys.$$.fragment,sn),B2=h(sn),w(Zs.$$.fragment,sn),H2=h(sn),w(ea.$$.fragment,sn),sn.forEach(t),ho.forEach(t),a_=h(i),jn=a(i,"H2",{class:!0});var wb=r(jn);ta=a(wb,"A",{id:!0,class:!0,href:!0});var BX=r(ta);em=a(BX,"SPAN",{});var HX=r(em);w(zl.$$.fragment,HX),HX.forEach(t),BX.forEach(t),Q2=h(wb),tm=a(wb,"SPAN",{});var QX=r(tm);K2=n(QX,"TFXLMRobertaForMultipleChoice"),QX.forEach(t),wb.forEach(t),r_=h(i),ut=a(i,"DIV",{class:!0});var uo=r(ut);w(Cl.$$.fragment,uo),V2=h(uo),om=a(uo,"P",{});var KX=r(om);J2=n(KX,`XLM Roberta Model with a multiple choice classification head on top (a linear layer on top of the pooled output and
a softmax) e.g. for RocStories/SWAG tasks.`),KX.forEach(t),G2=h(uo),ql=a(uo,"P",{});var Tb=r(ql);Y2=n(Tb,"This model inherits from "),Sp=a(Tb,"A",{href:!0});var VX=r(Sp);Z2=n(VX,"TFPreTrainedModel"),VX.forEach(t),eL=n(Tb,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Tb.forEach(t),tL=h(uo),jl=a(uo,"P",{});var Mb=r(jl);oL=n(Mb,"This model is also a "),Al=a(Mb,"A",{href:!0,rel:!0});var JX=r(Al);nL=n(JX,"tf.keras.Model"),JX.forEach(t),sL=n(Mb,` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),Mb.forEach(t),aL=h(uo),w(oa.$$.fragment,uo),rL=h(uo),eo=a(uo,"DIV",{class:!0});var Qa=r(eo);w(Pl.$$.fragment,Qa),iL=h(Qa),An=a(Qa,"P",{});var vh=r(An);lL=n(vh,"The "),Wp=a(vh,"A",{href:!0});var GX=r(Wp);dL=n(GX,"TFXLMRobertaForMultipleChoice"),GX.forEach(t),cL=n(vh," forward method, overrides the "),nm=a(vh,"CODE",{});var YX=r(nm);pL=n(YX,"__call__"),YX.forEach(t),hL=n(vh," special method."),vh.forEach(t),uL=h(Qa),w(na.$$.fragment,Qa),mL=h(Qa),w(sa.$$.fragment,Qa),Qa.forEach(t),uo.forEach(t),i_=h(i),Pn=a(i,"H2",{class:!0});var $b=r(Pn);aa=a($b,"A",{id:!0,class:!0,href:!0});var ZX=r(aa);sm=a(ZX,"SPAN",{});var ez=r(sm);w(Nl.$$.fragment,ez),ez.forEach(t),ZX.forEach(t),fL=h($b),am=a($b,"SPAN",{});var tz=r(am);gL=n(tz,"TFXLMRobertaForTokenClassification"),tz.forEach(t),$b.forEach(t),l_=h(i),mt=a(i,"DIV",{class:!0});var mo=r(mt);w(Ol.$$.fragment,mo),_L=h(mo),rm=a(mo,"P",{});var oz=r(rm);bL=n(oz,`XLM RoBERTa Model with a token classification head on top (a linear layer on top of the hidden-states output) e.g.
for Named-Entity-Recognition (NER) tasks.`),oz.forEach(t),kL=h(mo),Il=a(mo,"P",{});var Lb=r(Il);vL=n(Lb,"This model inherits from "),Up=a(Lb,"A",{href:!0});var nz=r(Up);yL=n(nz,"TFPreTrainedModel"),nz.forEach(t),wL=n(Lb,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Lb.forEach(t),TL=h(mo),Dl=a(mo,"P",{});var Fb=r(Dl);ML=n(Fb,"This model is also a "),Sl=a(Fb,"A",{href:!0,rel:!0});var sz=r(Sl);$L=n(sz,"tf.keras.Model"),sz.forEach(t),LL=n(Fb,` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),Fb.forEach(t),FL=h(mo),w(ra.$$.fragment,mo),xL=h(mo),zt=a(mo,"DIV",{class:!0});var an=r(zt);w(Wl.$$.fragment,an),EL=h(an),Nn=a(an,"P",{});var yh=r(Nn);RL=n(yh,"The "),Bp=a(yh,"A",{href:!0});var az=r(Bp);XL=n(az,"TFXLMRobertaForTokenClassification"),az.forEach(t),zL=n(yh," forward method, overrides the "),im=a(yh,"CODE",{});var rz=r(im);CL=n(rz,"__call__"),rz.forEach(t),qL=n(yh," special method."),yh.forEach(t),jL=h(an),w(ia.$$.fragment,an),AL=h(an),w(la.$$.fragment,an),PL=h(an),w(da.$$.fragment,an),an.forEach(t),mo.forEach(t),d_=h(i),On=a(i,"H2",{class:!0});var xb=r(On);ca=a(xb,"A",{id:!0,class:!0,href:!0});var iz=r(ca);lm=a(iz,"SPAN",{});var lz=r(lm);w(Ul.$$.fragment,lz),lz.forEach(t),iz.forEach(t),NL=h(xb),dm=a(xb,"SPAN",{});var dz=r(dm);OL=n(dz,"TFXLMRobertaForQuestionAnswering"),dz.forEach(t),xb.forEach(t),c_=h(i),ft=a(i,"DIV",{class:!0});var fo=r(ft);w(Bl.$$.fragment,fo),IL=h(fo),In=a(fo,"P",{});var wh=r(In);DL=n(wh,`XLM RoBERTa Model with a span classification head on top for extractive question-answering tasks like SQuAD (a
linear layers on top of the hidden-states output to compute `),cm=a(wh,"CODE",{});var cz=r(cm);SL=n(cz,"span start logits"),cz.forEach(t),WL=n(wh," and "),pm=a(wh,"CODE",{});var pz=r(pm);UL=n(pz,"span end logits"),pz.forEach(t),BL=n(wh,")."),wh.forEach(t),HL=h(fo),Hl=a(fo,"P",{});var Eb=r(Hl);QL=n(Eb,"This model inherits from "),Hp=a(Eb,"A",{href:!0});var hz=r(Hp);KL=n(hz,"TFPreTrainedModel"),hz.forEach(t),VL=n(Eb,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Eb.forEach(t),JL=h(fo),Ql=a(fo,"P",{});var Rb=r(Ql);GL=n(Rb,"This model is also a "),Kl=a(Rb,"A",{href:!0,rel:!0});var uz=r(Kl);YL=n(uz,"tf.keras.Model"),uz.forEach(t),ZL=n(Rb,` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),Rb.forEach(t),eF=h(fo),w(pa.$$.fragment,fo),tF=h(fo),Ct=a(fo,"DIV",{class:!0});var rn=r(Ct);w(Vl.$$.fragment,rn),oF=h(rn),Dn=a(rn,"P",{});var Th=r(Dn);nF=n(Th,"The "),Qp=a(Th,"A",{href:!0});var mz=r(Qp);sF=n(mz,"TFXLMRobertaForQuestionAnswering"),mz.forEach(t),aF=n(Th," forward method, overrides the "),hm=a(Th,"CODE",{});var fz=r(hm);rF=n(fz,"__call__"),fz.forEach(t),iF=n(Th," special method."),Th.forEach(t),lF=h(rn),w(ha.$$.fragment,rn),dF=h(rn),w(ua.$$.fragment,rn),cF=h(rn),w(ma.$$.fragment,rn),rn.forEach(t),fo.forEach(t),p_=h(i),Sn=a(i,"H2",{class:!0});var Xb=r(Sn);fa=a(Xb,"A",{id:!0,class:!0,href:!0});var gz=r(fa);um=a(gz,"SPAN",{});var _z=r(um);w(Jl.$$.fragment,_z),_z.forEach(t),gz.forEach(t),pF=h(Xb),mm=a(Xb,"SPAN",{});var bz=r(mm);hF=n(bz,"FlaxXLMRobertaModel"),bz.forEach(t),Xb.forEach(t),h_=h(i),tt=a(i,"DIV",{class:!0});var At=r(tt);w(Gl.$$.fragment,At),uF=h(At),fm=a(At,"P",{});var kz=r(fm);mF=n(kz,"The bare XLM RoBERTa Model transformer outputting raw hidden-states without any specific head on top."),kz.forEach(t),fF=h(At),Yl=a(At,"P",{});var zb=r(Yl);gF=n(zb,"This model inherits from "),Kp=a(zb,"A",{href:!0});var vz=r(Kp);_F=n(vz,"FlaxPreTrainedModel"),vz.forEach(t),bF=n(zb,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading, saving and converting weights from PyTorch models)`),zb.forEach(t),kF=h(At),Zl=a(At,"P",{});var Cb=r(Zl);vF=n(Cb,"This model is also a Flax Linen "),ed=a(Cb,"A",{href:!0,rel:!0});var yz=r(ed);yF=n(yz,"flax.linen.Module"),yz.forEach(t),wF=n(Cb,`
subclass. Use it as a regular Flax linen Module and refer to the Flax documentation for all matter related to
general usage and behavior.`),Cb.forEach(t),TF=h(At),gm=a(At,"P",{});var wz=r(gm);MF=n(wz,"Finally, this model supports inherent JAX features such as:"),wz.forEach(t),$F=h(At),bo=a(At,"UL",{});var Ka=r(bo);_m=a(Ka,"LI",{});var Tz=r(_m);td=a(Tz,"A",{href:!0,rel:!0});var Mz=r(td);LF=n(Mz,"Just-In-Time (JIT) compilation"),Mz.forEach(t),Tz.forEach(t),FF=h(Ka),bm=a(Ka,"LI",{});var $z=r(bm);od=a($z,"A",{href:!0,rel:!0});var Lz=r(od);xF=n(Lz,"Automatic Differentiation"),Lz.forEach(t),$z.forEach(t),EF=h(Ka),km=a(Ka,"LI",{});var Fz=r(km);nd=a(Fz,"A",{href:!0,rel:!0});var xz=r(nd);RF=n(xz,"Vectorization"),xz.forEach(t),Fz.forEach(t),XF=h(Ka),vm=a(Ka,"LI",{});var Ez=r(vm);sd=a(Ez,"A",{href:!0,rel:!0});var Rz=r(sd);zF=n(Rz,"Parallelization"),Rz.forEach(t),Ez.forEach(t),Ka.forEach(t),CF=h(At),to=a(At,"DIV",{class:!0});var Va=r(to);w(ad.$$.fragment,Va),qF=h(Va),Wn=a(Va,"P",{});var Mh=r(Wn);jF=n(Mh,"The "),ym=a(Mh,"CODE",{});var Xz=r(ym);AF=n(Xz,"FlaxXLMRobertaPreTrainedModel"),Xz.forEach(t),PF=n(Mh," forward method, overrides the "),wm=a(Mh,"CODE",{});var zz=r(wm);NF=n(zz,"__call__"),zz.forEach(t),OF=n(Mh," special method."),Mh.forEach(t),IF=h(Va),w(ga.$$.fragment,Va),DF=h(Va),w(_a.$$.fragment,Va),Va.forEach(t),At.forEach(t),u_=h(i),Un=a(i,"H2",{class:!0});var qb=r(Un);ba=a(qb,"A",{id:!0,class:!0,href:!0});var Cz=r(ba);Tm=a(Cz,"SPAN",{});var qz=r(Tm);w(rd.$$.fragment,qz),qz.forEach(t),Cz.forEach(t),SF=h(qb),Mm=a(qb,"SPAN",{});var jz=r(Mm);WF=n(jz,"FlaxXLMRobertaForCausalLM"),jz.forEach(t),qb.forEach(t),m_=h(i),ot=a(i,"DIV",{class:!0});var Pt=r(ot);w(id.$$.fragment,Pt),UF=h(Pt),$m=a(Pt,"P",{});var Az=r($m);BF=n(Az,`XLM Roberta Model with a language modeling head on top (a linear layer on top of the hidden-states output) e.g for
autoregressive tasks.`),Az.forEach(t),HF=h(Pt),ld=a(Pt,"P",{});var jb=r(ld);QF=n(jb,"This model inherits from "),Vp=a(jb,"A",{href:!0});var Pz=r(Vp);KF=n(Pz,"FlaxPreTrainedModel"),Pz.forEach(t),VF=n(jb,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading, saving and converting weights from PyTorch models)`),jb.forEach(t),JF=h(Pt),dd=a(Pt,"P",{});var Ab=r(dd);GF=n(Ab,"This model is also a Flax Linen "),cd=a(Ab,"A",{href:!0,rel:!0});var Nz=r(cd);YF=n(Nz,"flax.linen.Module"),Nz.forEach(t),ZF=n(Ab,`
subclass. Use it as a regular Flax linen Module and refer to the Flax documentation for all matter related to
general usage and behavior.`),Ab.forEach(t),ex=h(Pt),Lm=a(Pt,"P",{});var Oz=r(Lm);tx=n(Oz,"Finally, this model supports inherent JAX features such as:"),Oz.forEach(t),ox=h(Pt),ko=a(Pt,"UL",{});var Ja=r(ko);Fm=a(Ja,"LI",{});var Iz=r(Fm);pd=a(Iz,"A",{href:!0,rel:!0});var Dz=r(pd);nx=n(Dz,"Just-In-Time (JIT) compilation"),Dz.forEach(t),Iz.forEach(t),sx=h(Ja),xm=a(Ja,"LI",{});var Sz=r(xm);hd=a(Sz,"A",{href:!0,rel:!0});var Wz=r(hd);ax=n(Wz,"Automatic Differentiation"),Wz.forEach(t),Sz.forEach(t),rx=h(Ja),Em=a(Ja,"LI",{});var Uz=r(Em);ud=a(Uz,"A",{href:!0,rel:!0});var Bz=r(ud);ix=n(Bz,"Vectorization"),Bz.forEach(t),Uz.forEach(t),lx=h(Ja),Rm=a(Ja,"LI",{});var Hz=r(Rm);md=a(Hz,"A",{href:!0,rel:!0});var Qz=r(md);dx=n(Qz,"Parallelization"),Qz.forEach(t),Hz.forEach(t),Ja.forEach(t),cx=h(Pt),oo=a(Pt,"DIV",{class:!0});var Ga=r(oo);w(fd.$$.fragment,Ga),px=h(Ga),Bn=a(Ga,"P",{});var $h=r(Bn);hx=n($h,"The "),Xm=a($h,"CODE",{});var Kz=r(Xm);ux=n(Kz,"FlaxXLMRobertaPreTrainedModel"),Kz.forEach(t),mx=n($h," forward method, overrides the "),zm=a($h,"CODE",{});var Vz=r(zm);fx=n(Vz,"__call__"),Vz.forEach(t),gx=n($h," special method."),$h.forEach(t),_x=h(Ga),w(ka.$$.fragment,Ga),bx=h(Ga),w(va.$$.fragment,Ga),Ga.forEach(t),Pt.forEach(t),f_=h(i),Hn=a(i,"H2",{class:!0});var Pb=r(Hn);ya=a(Pb,"A",{id:!0,class:!0,href:!0});var Jz=r(ya);Cm=a(Jz,"SPAN",{});var Gz=r(Cm);w(gd.$$.fragment,Gz),Gz.forEach(t),Jz.forEach(t),kx=h(Pb),qm=a(Pb,"SPAN",{});var Yz=r(qm);vx=n(Yz,"FlaxXLMRobertaForMaskedLM"),Yz.forEach(t),Pb.forEach(t),g_=h(i),nt=a(i,"DIV",{class:!0});var Nt=r(nt);w(_d.$$.fragment,Nt),yx=h(Nt),bd=a(Nt,"P",{});var Nb=r(bd);wx=n(Nb,"XLM RoBERTa Model with a "),jm=a(Nb,"CODE",{});var Zz=r(jm);Tx=n(Zz,"language modeling"),Zz.forEach(t),Mx=n(Nb," head on top."),Nb.forEach(t),$x=h(Nt),kd=a(Nt,"P",{});var Ob=r(kd);Lx=n(Ob,"This model inherits from "),Jp=a(Ob,"A",{href:!0});var eC=r(Jp);Fx=n(eC,"FlaxPreTrainedModel"),eC.forEach(t),xx=n(Ob,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading, saving and converting weights from PyTorch models)`),Ob.forEach(t),Ex=h(Nt),vd=a(Nt,"P",{});var Ib=r(vd);Rx=n(Ib,"This model is also a Flax Linen "),yd=a(Ib,"A",{href:!0,rel:!0});var tC=r(yd);Xx=n(tC,"flax.linen.Module"),tC.forEach(t),zx=n(Ib,`
subclass. Use it as a regular Flax linen Module and refer to the Flax documentation for all matter related to
general usage and behavior.`),Ib.forEach(t),Cx=h(Nt),Am=a(Nt,"P",{});var oC=r(Am);qx=n(oC,"Finally, this model supports inherent JAX features such as:"),oC.forEach(t),jx=h(Nt),vo=a(Nt,"UL",{});var Ya=r(vo);Pm=a(Ya,"LI",{});var nC=r(Pm);wd=a(nC,"A",{href:!0,rel:!0});var sC=r(wd);Ax=n(sC,"Just-In-Time (JIT) compilation"),sC.forEach(t),nC.forEach(t),Px=h(Ya),Nm=a(Ya,"LI",{});var aC=r(Nm);Td=a(aC,"A",{href:!0,rel:!0});var rC=r(Td);Nx=n(rC,"Automatic Differentiation"),rC.forEach(t),aC.forEach(t),Ox=h(Ya),Om=a(Ya,"LI",{});var iC=r(Om);Md=a(iC,"A",{href:!0,rel:!0});var lC=r(Md);Ix=n(lC,"Vectorization"),lC.forEach(t),iC.forEach(t),Dx=h(Ya),Im=a(Ya,"LI",{});var dC=r(Im);$d=a(dC,"A",{href:!0,rel:!0});var cC=r($d);Sx=n(cC,"Parallelization"),cC.forEach(t),dC.forEach(t),Ya.forEach(t),Wx=h(Nt),no=a(Nt,"DIV",{class:!0});var Za=r(no);w(Ld.$$.fragment,Za),Ux=h(Za),Qn=a(Za,"P",{});var Lh=r(Qn);Bx=n(Lh,"The "),Dm=a(Lh,"CODE",{});var pC=r(Dm);Hx=n(pC,"FlaxXLMRobertaPreTrainedModel"),pC.forEach(t),Qx=n(Lh," forward method, overrides the "),Sm=a(Lh,"CODE",{});var hC=r(Sm);Kx=n(hC,"__call__"),hC.forEach(t),Vx=n(Lh," special method."),Lh.forEach(t),Jx=h(Za),w(wa.$$.fragment,Za),Gx=h(Za),w(Ta.$$.fragment,Za),Za.forEach(t),Nt.forEach(t),__=h(i),Kn=a(i,"H2",{class:!0});var Db=r(Kn);Ma=a(Db,"A",{id:!0,class:!0,href:!0});var uC=r(Ma);Wm=a(uC,"SPAN",{});var mC=r(Wm);w(Fd.$$.fragment,mC),mC.forEach(t),uC.forEach(t),Yx=h(Db),Um=a(Db,"SPAN",{});var fC=r(Um);Zx=n(fC,"FlaxXLMRobertaForSequenceClassification"),fC.forEach(t),Db.forEach(t),b_=h(i),st=a(i,"DIV",{class:!0});var Ot=r(st);w(xd.$$.fragment,Ot),e0=h(Ot),Bm=a(Ot,"P",{});var gC=r(Bm);t0=n(gC,`XLM Roberta Model transformer with a sequence classification/regression head on top (a linear layer on top of the
pooled output) e.g. for GLUE tasks.`),gC.forEach(t),o0=h(Ot),Ed=a(Ot,"P",{});var Sb=r(Ed);n0=n(Sb,"This model inherits from "),Gp=a(Sb,"A",{href:!0});var _C=r(Gp);s0=n(_C,"FlaxPreTrainedModel"),_C.forEach(t),a0=n(Sb,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading, saving and converting weights from PyTorch models)`),Sb.forEach(t),r0=h(Ot),Rd=a(Ot,"P",{});var Wb=r(Rd);i0=n(Wb,"This model is also a Flax Linen "),Xd=a(Wb,"A",{href:!0,rel:!0});var bC=r(Xd);l0=n(bC,"flax.linen.Module"),bC.forEach(t),d0=n(Wb,`
subclass. Use it as a regular Flax linen Module and refer to the Flax documentation for all matter related to
general usage and behavior.`),Wb.forEach(t),c0=h(Ot),Hm=a(Ot,"P",{});var kC=r(Hm);p0=n(kC,"Finally, this model supports inherent JAX features such as:"),kC.forEach(t),h0=h(Ot),yo=a(Ot,"UL",{});var er=r(yo);Qm=a(er,"LI",{});var vC=r(Qm);zd=a(vC,"A",{href:!0,rel:!0});var yC=r(zd);u0=n(yC,"Just-In-Time (JIT) compilation"),yC.forEach(t),vC.forEach(t),m0=h(er),Km=a(er,"LI",{});var wC=r(Km);Cd=a(wC,"A",{href:!0,rel:!0});var TC=r(Cd);f0=n(TC,"Automatic Differentiation"),TC.forEach(t),wC.forEach(t),g0=h(er),Vm=a(er,"LI",{});var MC=r(Vm);qd=a(MC,"A",{href:!0,rel:!0});var $C=r(qd);_0=n($C,"Vectorization"),$C.forEach(t),MC.forEach(t),b0=h(er),Jm=a(er,"LI",{});var LC=r(Jm);jd=a(LC,"A",{href:!0,rel:!0});var FC=r(jd);k0=n(FC,"Parallelization"),FC.forEach(t),LC.forEach(t),er.forEach(t),v0=h(Ot),so=a(Ot,"DIV",{class:!0});var tr=r(so);w(Ad.$$.fragment,tr),y0=h(tr),Vn=a(tr,"P",{});var Fh=r(Vn);w0=n(Fh,"The "),Gm=a(Fh,"CODE",{});var xC=r(Gm);T0=n(xC,"FlaxXLMRobertaPreTrainedModel"),xC.forEach(t),M0=n(Fh," forward method, overrides the "),Ym=a(Fh,"CODE",{});var EC=r(Ym);$0=n(EC,"__call__"),EC.forEach(t),L0=n(Fh," special method."),Fh.forEach(t),F0=h(tr),w($a.$$.fragment,tr),x0=h(tr),w(La.$$.fragment,tr),tr.forEach(t),Ot.forEach(t),k_=h(i),Jn=a(i,"H2",{class:!0});var Ub=r(Jn);Fa=a(Ub,"A",{id:!0,class:!0,href:!0});var RC=r(Fa);Zm=a(RC,"SPAN",{});var XC=r(Zm);w(Pd.$$.fragment,XC),XC.forEach(t),RC.forEach(t),E0=h(Ub),ef=a(Ub,"SPAN",{});var zC=r(ef);R0=n(zC,"FlaxXLMRobertaForMultipleChoice"),zC.forEach(t),Ub.forEach(t),v_=h(i),at=a(i,"DIV",{class:!0});var It=r(at);w(Nd.$$.fragment,It),X0=h(It),tf=a(It,"P",{});var CC=r(tf);z0=n(CC,`XLM Roberta Model with a multiple choice classification head on top (a linear layer on top of the pooled output and
a softmax) e.g. for RocStories/SWAG tasks.`),CC.forEach(t),C0=h(It),Od=a(It,"P",{});var Bb=r(Od);q0=n(Bb,"This model inherits from "),Yp=a(Bb,"A",{href:!0});var qC=r(Yp);j0=n(qC,"FlaxPreTrainedModel"),qC.forEach(t),A0=n(Bb,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading, saving and converting weights from PyTorch models)`),Bb.forEach(t),P0=h(It),Id=a(It,"P",{});var Hb=r(Id);N0=n(Hb,"This model is also a Flax Linen "),Dd=a(Hb,"A",{href:!0,rel:!0});var jC=r(Dd);O0=n(jC,"flax.linen.Module"),jC.forEach(t),I0=n(Hb,`
subclass. Use it as a regular Flax linen Module and refer to the Flax documentation for all matter related to
general usage and behavior.`),Hb.forEach(t),D0=h(It),of=a(It,"P",{});var AC=r(of);S0=n(AC,"Finally, this model supports inherent JAX features such as:"),AC.forEach(t),W0=h(It),wo=a(It,"UL",{});var or=r(wo);nf=a(or,"LI",{});var PC=r(nf);Sd=a(PC,"A",{href:!0,rel:!0});var NC=r(Sd);U0=n(NC,"Just-In-Time (JIT) compilation"),NC.forEach(t),PC.forEach(t),B0=h(or),sf=a(or,"LI",{});var OC=r(sf);Wd=a(OC,"A",{href:!0,rel:!0});var IC=r(Wd);H0=n(IC,"Automatic Differentiation"),IC.forEach(t),OC.forEach(t),Q0=h(or),af=a(or,"LI",{});var DC=r(af);Ud=a(DC,"A",{href:!0,rel:!0});var SC=r(Ud);K0=n(SC,"Vectorization"),SC.forEach(t),DC.forEach(t),V0=h(or),rf=a(or,"LI",{});var WC=r(rf);Bd=a(WC,"A",{href:!0,rel:!0});var UC=r(Bd);J0=n(UC,"Parallelization"),UC.forEach(t),WC.forEach(t),or.forEach(t),G0=h(It),ao=a(It,"DIV",{class:!0});var nr=r(ao);w(Hd.$$.fragment,nr),Y0=h(nr),Gn=a(nr,"P",{});var xh=r(Gn);Z0=n(xh,"The "),lf=a(xh,"CODE",{});var BC=r(lf);e5=n(BC,"FlaxXLMRobertaPreTrainedModel"),BC.forEach(t),t5=n(xh," forward method, overrides the "),df=a(xh,"CODE",{});var HC=r(df);o5=n(HC,"__call__"),HC.forEach(t),n5=n(xh," special method."),xh.forEach(t),s5=h(nr),w(xa.$$.fragment,nr),a5=h(nr),w(Ea.$$.fragment,nr),nr.forEach(t),It.forEach(t),y_=h(i),Yn=a(i,"H2",{class:!0});var Qb=r(Yn);Ra=a(Qb,"A",{id:!0,class:!0,href:!0});var QC=r(Ra);cf=a(QC,"SPAN",{});var KC=r(cf);w(Qd.$$.fragment,KC),KC.forEach(t),QC.forEach(t),r5=h(Qb),pf=a(Qb,"SPAN",{});var VC=r(pf);i5=n(VC,"FlaxXLMRobertaForTokenClassification"),VC.forEach(t),Qb.forEach(t),w_=h(i),rt=a(i,"DIV",{class:!0});var Dt=r(rt);w(Kd.$$.fragment,Dt),l5=h(Dt),hf=a(Dt,"P",{});var JC=r(hf);d5=n(JC,`XLM Roberta Model with a token classification head on top (a linear layer on top of the hidden-states output) e.g.
for Named-Entity-Recognition (NER) tasks.`),JC.forEach(t),c5=h(Dt),Vd=a(Dt,"P",{});var Kb=r(Vd);p5=n(Kb,"This model inherits from "),Zp=a(Kb,"A",{href:!0});var GC=r(Zp);h5=n(GC,"FlaxPreTrainedModel"),GC.forEach(t),u5=n(Kb,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading, saving and converting weights from PyTorch models)`),Kb.forEach(t),m5=h(Dt),Jd=a(Dt,"P",{});var Vb=r(Jd);f5=n(Vb,"This model is also a Flax Linen "),Gd=a(Vb,"A",{href:!0,rel:!0});var YC=r(Gd);g5=n(YC,"flax.linen.Module"),YC.forEach(t),_5=n(Vb,`
subclass. Use it as a regular Flax linen Module and refer to the Flax documentation for all matter related to
general usage and behavior.`),Vb.forEach(t),b5=h(Dt),uf=a(Dt,"P",{});var ZC=r(uf);k5=n(ZC,"Finally, this model supports inherent JAX features such as:"),ZC.forEach(t),v5=h(Dt),To=a(Dt,"UL",{});var sr=r(To);mf=a(sr,"LI",{});var e8=r(mf);Yd=a(e8,"A",{href:!0,rel:!0});var t8=r(Yd);y5=n(t8,"Just-In-Time (JIT) compilation"),t8.forEach(t),e8.forEach(t),w5=h(sr),ff=a(sr,"LI",{});var o8=r(ff);Zd=a(o8,"A",{href:!0,rel:!0});var n8=r(Zd);T5=n(n8,"Automatic Differentiation"),n8.forEach(t),o8.forEach(t),M5=h(sr),gf=a(sr,"LI",{});var s8=r(gf);ec=a(s8,"A",{href:!0,rel:!0});var a8=r(ec);$5=n(a8,"Vectorization"),a8.forEach(t),s8.forEach(t),L5=h(sr),_f=a(sr,"LI",{});var r8=r(_f);tc=a(r8,"A",{href:!0,rel:!0});var i8=r(tc);F5=n(i8,"Parallelization"),i8.forEach(t),r8.forEach(t),sr.forEach(t),x5=h(Dt),ro=a(Dt,"DIV",{class:!0});var ar=r(ro);w(oc.$$.fragment,ar),E5=h(ar),Zn=a(ar,"P",{});var Eh=r(Zn);R5=n(Eh,"The "),bf=a(Eh,"CODE",{});var l8=r(bf);X5=n(l8,"FlaxXLMRobertaPreTrainedModel"),l8.forEach(t),z5=n(Eh," forward method, overrides the "),kf=a(Eh,"CODE",{});var d8=r(kf);C5=n(d8,"__call__"),d8.forEach(t),q5=n(Eh," special method."),Eh.forEach(t),j5=h(ar),w(Xa.$$.fragment,ar),A5=h(ar),w(za.$$.fragment,ar),ar.forEach(t),Dt.forEach(t),T_=h(i),es=a(i,"H2",{class:!0});var Jb=r(es);Ca=a(Jb,"A",{id:!0,class:!0,href:!0});var c8=r(Ca);vf=a(c8,"SPAN",{});var p8=r(vf);w(nc.$$.fragment,p8),p8.forEach(t),c8.forEach(t),P5=h(Jb),yf=a(Jb,"SPAN",{});var h8=r(yf);N5=n(h8,"FlaxXLMRobertaForQuestionAnswering"),h8.forEach(t),Jb.forEach(t),M_=h(i),it=a(i,"DIV",{class:!0});var St=r(it);w(sc.$$.fragment,St),O5=h(St),ts=a(St,"P",{});var Rh=r(ts);I5=n(Rh,`XLM Roberta Model with a span classification head on top for extractive question-answering tasks like SQuAD (a
linear layers on top of the hidden-states output to compute `),wf=a(Rh,"CODE",{});var u8=r(wf);D5=n(u8,"span start logits"),u8.forEach(t),S5=n(Rh," and "),Tf=a(Rh,"CODE",{});var m8=r(Tf);W5=n(m8,"span end logits"),m8.forEach(t),U5=n(Rh,")."),Rh.forEach(t),B5=h(St),ac=a(St,"P",{});var Gb=r(ac);H5=n(Gb,"This model inherits from "),eh=a(Gb,"A",{href:!0});var f8=r(eh);Q5=n(f8,"FlaxPreTrainedModel"),f8.forEach(t),K5=n(Gb,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading, saving and converting weights from PyTorch models)`),Gb.forEach(t),V5=h(St),rc=a(St,"P",{});var Yb=r(rc);J5=n(Yb,"This model is also a Flax Linen "),ic=a(Yb,"A",{href:!0,rel:!0});var g8=r(ic);G5=n(g8,"flax.linen.Module"),g8.forEach(t),Y5=n(Yb,`
subclass. Use it as a regular Flax linen Module and refer to the Flax documentation for all matter related to
general usage and behavior.`),Yb.forEach(t),Z5=h(St),Mf=a(St,"P",{});var _8=r(Mf);eE=n(_8,"Finally, this model supports inherent JAX features such as:"),_8.forEach(t),tE=h(St),Mo=a(St,"UL",{});var rr=r(Mo);$f=a(rr,"LI",{});var b8=r($f);lc=a(b8,"A",{href:!0,rel:!0});var k8=r(lc);oE=n(k8,"Just-In-Time (JIT) compilation"),k8.forEach(t),b8.forEach(t),nE=h(rr),Lf=a(rr,"LI",{});var v8=r(Lf);dc=a(v8,"A",{href:!0,rel:!0});var y8=r(dc);sE=n(y8,"Automatic Differentiation"),y8.forEach(t),v8.forEach(t),aE=h(rr),Ff=a(rr,"LI",{});var w8=r(Ff);cc=a(w8,"A",{href:!0,rel:!0});var T8=r(cc);rE=n(T8,"Vectorization"),T8.forEach(t),w8.forEach(t),iE=h(rr),xf=a(rr,"LI",{});var M8=r(xf);pc=a(M8,"A",{href:!0,rel:!0});var $8=r(pc);lE=n($8,"Parallelization"),$8.forEach(t),M8.forEach(t),rr.forEach(t),dE=h(St),io=a(St,"DIV",{class:!0});var ir=r(io);w(hc.$$.fragment,ir),cE=h(ir),os=a(ir,"P",{});var Xh=r(os);pE=n(Xh,"The "),Ef=a(Xh,"CODE",{});var L8=r(Ef);hE=n(L8,"FlaxXLMRobertaPreTrainedModel"),L8.forEach(t),uE=n(Xh," forward method, overrides the "),Rf=a(Xh,"CODE",{});var F8=r(Rf);mE=n(F8,"__call__"),F8.forEach(t),fE=n(Xh," special method."),Xh.forEach(t),gE=h(ir),w(qa.$$.fragment,ir),_E=h(ir),w(ja.$$.fragment,ir),ir.forEach(t),St.forEach(t),this.h()},h(){c(d,"name","hf:doc:metadata"),c(d,"content",JSON.stringify(Aq)),c(f,"id","xlmroberta"),c(f,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(f,"href","#xlmroberta"),c(m,"class","relative group"),c(te,"alt","Models"),x8(te.src,F="https://img.shields.io/badge/All_model_pages-xlm--roberta-blueviolet")||c(te,"src",F),c(ce,"href","https://huggingface.co/models?filter=xlm-roberta"),c(pe,"alt","Spaces"),x8(pe.src,Ce="https://img.shields.io/badge/%F0%9F%A4%97%20Hugging%20Face-Spaces-blue")||c(pe,"src",Ce),c(W,"href","https://huggingface.co/spaces/docs-demos/xlm-roberta-base"),c(O,"class","flex flex-wrap space-x-1"),c(re,"id","overview"),c(re,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(re,"href","#overview"),c(ae,"class","relative group"),c(le,"href","https://arxiv.org/abs/1911.02116"),c(le,"rel","nofollow"),c(A,"href","roberta"),c(Z,"href","https://huggingface.co/stefan-it"),c(Z,"rel","nofollow"),c(X,"href","https://github.com/pytorch/fairseq/tree/master/examples/xlmr"),c(X,"rel","nofollow"),c(je,"id","resources"),c(je,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(je,"href","#resources"),c(qe,"class","relative group"),c(lr,"href","https://www.philschmid.de/habana-distributed-training"),c(lr,"rel","nofollow"),c(Rc,"href","/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaForSequenceClassification"),c(dr,"href","https://github.com/huggingface/transformers/tree/main/examples/pytorch/text-classification"),c(dr,"rel","nofollow"),c(cr,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/examples/text_classification.ipynb"),c(cr,"rel","nofollow"),c(Xc,"href","/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.TFXLMRobertaForSequenceClassification"),c(pr,"href","https://github.com/huggingface/transformers/tree/main/examples/tensorflow/text-classification"),c(pr,"rel","nofollow"),c(hr,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/examples/text_classification-tf.ipynb"),c(hr,"rel","nofollow"),c(zc,"href","/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.FlaxXLMRobertaForSequenceClassification"),c(ur,"href","https://github.com/huggingface/transformers/tree/main/examples/flax/text-classification"),c(ur,"rel","nofollow"),c(mr,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/examples/text_classification_flax.ipynb"),c(mr,"rel","nofollow"),c(fr,"href","https://huggingface.co/docs/transformers/tasks/sequence_classification"),c(fr,"rel","nofollow"),c(qc,"href","../tasks/sequence_classification"),c(jc,"href","/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaForTokenClassification"),c(_r,"href","https://github.com/huggingface/transformers/tree/main/examples/pytorch/token-classification"),c(_r,"rel","nofollow"),c(br,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/examples/token_classification.ipynb"),c(br,"rel","nofollow"),c(Ac,"href","/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.TFXLMRobertaForTokenClassification"),c(kr,"href","https://github.com/huggingface/transformers/tree/main/examples/tensorflow/token-classification"),c(kr,"rel","nofollow"),c(vr,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/examples/token_classification-tf.ipynb"),c(vr,"rel","nofollow"),c(Pc,"href","/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.FlaxXLMRobertaForTokenClassification"),c(yr,"href","https://github.com/huggingface/transformers/tree/main/examples/flax/token-classification"),c(yr,"rel","nofollow"),c(wr,"href","https://huggingface.co/course/chapter7/2?fw=pt"),c(wr,"rel","nofollow"),c(Oc,"href","../tasks/token_classification"),c(Ic,"href","/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaForCausalLM"),c(Mr,"href","https://github.com/huggingface/transformers/tree/main/examples/pytorch/language-modeling"),c(Mr,"rel","nofollow"),c($r,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/examples/language_modeling.ipynb"),c($r,"rel","nofollow"),c(Lr,"href","https://huggingface.co/docs/transformers/tasks/language_modeling"),c(Lr,"rel","nofollow"),c(Sc,"href","../tasks/language_modeling"),c(Wc,"href","/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaForMaskedLM"),c(xr,"href","https://github.com/huggingface/transformers/tree/main/examples/pytorch/language-modeling#robertabertdistilbert-and-masked-language-modeling"),c(xr,"rel","nofollow"),c(Er,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/examples/language_modeling.ipynb"),c(Er,"rel","nofollow"),c(Uc,"href","/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.TFXLMRobertaForMaskedLM"),c(Rr,"href","https://github.com/huggingface/transformers/tree/main/examples/tensorflow/language-modeling#run_mlmpy"),c(Rr,"rel","nofollow"),c(Xr,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/examples/language_modeling-tf.ipynb"),c(Xr,"rel","nofollow"),c(Bc,"href","/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.FlaxXLMRobertaForMaskedLM"),c(zr,"href","https://github.com/huggingface/transformers/tree/main/examples/flax/language-modeling#masked-language-modeling"),c(zr,"rel","nofollow"),c(Cr,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/examples/masked_language_modeling_flax.ipynb"),c(Cr,"rel","nofollow"),c(qr,"href","https://huggingface.co/course/chapter7/3?fw=pt"),c(qr,"rel","nofollow"),c(Qc,"href","../tasks/masked_language_modeling"),c(Kc,"href","/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaForQuestionAnswering"),c(Ar,"href","https://github.com/huggingface/transformers/tree/main/examples/pytorch/question-answering"),c(Ar,"rel","nofollow"),c(Pr,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/examples/question_answering.ipynb"),c(Pr,"rel","nofollow"),c(Vc,"href","/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.TFXLMRobertaForQuestionAnswering"),c(Nr,"href","https://github.com/huggingface/transformers/tree/main/examples/tensorflow/question-answering"),c(Nr,"rel","nofollow"),c(Or,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/examples/question_answering-tf.ipynb"),c(Or,"rel","nofollow"),c(Jc,"href","/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.FlaxXLMRobertaForQuestionAnswering"),c(Ir,"href","https://github.com/huggingface/transformers/tree/main/examples/flax/question-answering"),c(Ir,"rel","nofollow"),c(Dr,"href","https://huggingface.co/course/chapter7/7?fw=pt"),c(Dr,"rel","nofollow"),c(Yc,"href","../tasks/question_answering"),c(ep,"href","/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaForMultipleChoice"),c(Sr,"href","https://github.com/huggingface/transformers/tree/main/examples/pytorch/multiple-choice"),c(Sr,"rel","nofollow"),c(Wr,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/examples/multiple_choice.ipynb"),c(Wr,"rel","nofollow"),c(tp,"href","/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.TFXLMRobertaForMultipleChoice"),c(Ur,"href","https://github.com/huggingface/transformers/tree/main/examples/tensorflow/multiple-choice"),c(Ur,"rel","nofollow"),c(Br,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/examples/multiple_choice-tf.ipynb"),c(Br,"rel","nofollow"),c(op,"href","../tasks/multiple_choice"),c(Qr,"href","https://www.philschmid.de/multilingual-serverless-xlm-roberta-with-huggingface"),c(Qr,"rel","nofollow"),c(is,"id","transformers.XLMRobertaConfig"),c(is,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(is,"href","#transformers.XLMRobertaConfig"),c(ln,"class","relative group"),c(ap,"href","/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaModel"),c(rp,"href","/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.TFXLMRobertaModel"),c(Jr,"href","https://huggingface.co/xlm-roberta-base"),c(Jr,"rel","nofollow"),c(ip,"href","/docs/transformers/pr_18559/en/main_classes/configuration#transformers.PretrainedConfig"),c(lp,"href","/docs/transformers/pr_18559/en/main_classes/configuration#transformers.PretrainedConfig"),c(Wt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ds,"id","transformers.XLMRobertaTokenizer"),c(ds,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(ds,"href","#transformers.XLMRobertaTokenizer"),c(cn,"class","relative group"),c(dp,"href","/docs/transformers/pr_18559/en/model_doc/roberta#transformers.RobertaTokenizer"),c(cp,"href","/docs/transformers/pr_18559/en/model_doc/xlnet#transformers.XLNetTokenizer"),c(Zr,"href","https://github.com/google/sentencepiece"),c(Zr,"rel","nofollow"),c(pp,"href","/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizer"),c(Io,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(cs,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ps,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(mp,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(et,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(hs,"id","transformers.XLMRobertaTokenizerFast"),c(hs,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(hs,"href","#transformers.XLMRobertaTokenizerFast"),c(pn,"class","relative group"),c(fp,"href","/docs/transformers/pr_18559/en/model_doc/roberta#transformers.RobertaTokenizer"),c(gp,"href","/docs/transformers/pr_18559/en/model_doc/xlnet#transformers.XLNetTokenizer"),c(di,"href","https://huggingface.co/docs/tokenizers/python/latest/components.html?highlight=BPE#models"),c(di,"rel","nofollow"),c(_p,"href","/docs/transformers/pr_18559/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast"),c(Do,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(us,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(bt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ms,"id","transformers.XLMRobertaModel"),c(ms,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(ms,"href","#transformers.XLMRobertaModel"),c(hn,"class","relative group"),c(vp,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel"),c(bi,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),c(bi,"rel","nofollow"),c(vi,"href","https://arxiv.org/abs/1706.03762"),c(vi,"rel","nofollow"),c(yp,"href","/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaModel"),c(Ht,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Ze,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(bs,"id","transformers.XLMRobertaForCausalLM"),c(bs,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(bs,"href","#transformers.XLMRobertaForCausalLM"),c(mn,"class","relative group"),c(wp,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel"),c(Fi,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),c(Fi,"rel","nofollow"),c(Tp,"href","/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaForCausalLM"),c(Qt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(kt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ys,"id","transformers.XLMRobertaForMaskedLM"),c(ys,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(ys,"href","#transformers.XLMRobertaForMaskedLM"),c(gn,"class","relative group"),c(Mp,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel"),c(qi,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),c(qi,"rel","nofollow"),c($p,"href","/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaForMaskedLM"),c(Kt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(vt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Ms,"id","transformers.XLMRobertaForSequenceClassification"),c(Ms,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Ms,"href","#transformers.XLMRobertaForSequenceClassification"),c(bn,"class","relative group"),c(Lp,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel"),c(Ii,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),c(Ii,"rel","nofollow"),c(Fp,"href","/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaForSequenceClassification"),c(Et,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(yt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(xs,"id","transformers.XLMRobertaForMultipleChoice"),c(xs,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(xs,"href","#transformers.XLMRobertaForMultipleChoice"),c(vn,"class","relative group"),c(xp,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel"),c(Hi,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),c(Hi,"rel","nofollow"),c(Ep,"href","/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaForMultipleChoice"),c(Vt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(wt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Xs,"id","transformers.XLMRobertaForTokenClassification"),c(Xs,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Xs,"href","#transformers.XLMRobertaForTokenClassification"),c(wn,"class","relative group"),c(Rp,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel"),c(Yi,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),c(Yi,"rel","nofollow"),c(Xp,"href","/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaForTokenClassification"),c(Jt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Tt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(qs,"id","transformers.XLMRobertaForQuestionAnswering"),c(qs,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(qs,"href","#transformers.XLMRobertaForQuestionAnswering"),c(Mn,"class","relative group"),c(zp,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.PreTrainedModel"),c(sl,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),c(sl,"rel","nofollow"),c(Cp,"href","/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.XLMRobertaForQuestionAnswering"),c(Gt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Mt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Ps,"id","transformers.TFXLMRobertaModel"),c(Ps,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Ps,"href","#transformers.TFXLMRobertaModel"),c(Fn,"class","relative group"),c(qp,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.TFPreTrainedModel"),c(cl,"href","https://www.tensorflow.org/api_docs/python/tf/keras/Model"),c(cl,"rel","nofollow"),c(jp,"href","/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.TFXLMRobertaModel"),c(Yt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(dt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Ds,"id","transformers.TFXLMRobertaForCausalLM"),c(Ds,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Ds,"href","#transformers.TFXLMRobertaForCausalLM"),c(En,"class","relative group"),c(Ap,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.TFPreTrainedModel"),c(_l,"href","https://www.tensorflow.org/api_docs/python/tf/keras/Model"),c(_l,"rel","nofollow"),c(Pp,"href","/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.TFXLMRobertaForCausalLM"),c(Zt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ct,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Bs,"id","transformers.TFXLMRobertaForMaskedLM"),c(Bs,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Bs,"href","#transformers.TFXLMRobertaForMaskedLM"),c(Xn,"class","relative group"),c(Np,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.TFPreTrainedModel"),c(Ml,"href","https://www.tensorflow.org/api_docs/python/tf/keras/Model"),c(Ml,"rel","nofollow"),c(Op,"href","/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.TFXLMRobertaForMaskedLM"),c(Rt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(pt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Js,"id","transformers.TFXLMRobertaForSequenceClassification"),c(Js,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Js,"href","#transformers.TFXLMRobertaForSequenceClassification"),c(Cn,"class","relative group"),c(Ip,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.TFPreTrainedModel"),c(Rl,"href","https://www.tensorflow.org/api_docs/python/tf/keras/Model"),c(Rl,"rel","nofollow"),c(Dp,"href","/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.TFXLMRobertaForSequenceClassification"),c(Xt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ht,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ta,"id","transformers.TFXLMRobertaForMultipleChoice"),c(ta,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(ta,"href","#transformers.TFXLMRobertaForMultipleChoice"),c(jn,"class","relative group"),c(Sp,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.TFPreTrainedModel"),c(Al,"href","https://www.tensorflow.org/api_docs/python/tf/keras/Model"),c(Al,"rel","nofollow"),c(Wp,"href","/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.TFXLMRobertaForMultipleChoice"),c(eo,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ut,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(aa,"id","transformers.TFXLMRobertaForTokenClassification"),c(aa,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(aa,"href","#transformers.TFXLMRobertaForTokenClassification"),c(Pn,"class","relative group"),c(Up,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.TFPreTrainedModel"),c(Sl,"href","https://www.tensorflow.org/api_docs/python/tf/keras/Model"),c(Sl,"rel","nofollow"),c(Bp,"href","/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.TFXLMRobertaForTokenClassification"),c(zt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(mt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ca,"id","transformers.TFXLMRobertaForQuestionAnswering"),c(ca,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(ca,"href","#transformers.TFXLMRobertaForQuestionAnswering"),c(On,"class","relative group"),c(Hp,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.TFPreTrainedModel"),c(Kl,"href","https://www.tensorflow.org/api_docs/python/tf/keras/Model"),c(Kl,"rel","nofollow"),c(Qp,"href","/docs/transformers/pr_18559/en/model_doc/xlm-roberta#transformers.TFXLMRobertaForQuestionAnswering"),c(Ct,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ft,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(fa,"id","transformers.FlaxXLMRobertaModel"),c(fa,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(fa,"href","#transformers.FlaxXLMRobertaModel"),c(Sn,"class","relative group"),c(Kp,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel"),c(ed,"href","https://flax.readthedocs.io/en/latest/flax.linen.html#module"),c(ed,"rel","nofollow"),c(td,"href","https://jax.readthedocs.io/en/latest/jax.html#just-in-time-compilation-jit"),c(td,"rel","nofollow"),c(od,"href","https://jax.readthedocs.io/en/latest/jax.html#automatic-differentiation"),c(od,"rel","nofollow"),c(nd,"href","https://jax.readthedocs.io/en/latest/jax.html#vectorization-vmap"),c(nd,"rel","nofollow"),c(sd,"href","https://jax.readthedocs.io/en/latest/jax.html#parallelization-pmap"),c(sd,"rel","nofollow"),c(to,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(tt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ba,"id","transformers.FlaxXLMRobertaForCausalLM"),c(ba,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(ba,"href","#transformers.FlaxXLMRobertaForCausalLM"),c(Un,"class","relative group"),c(Vp,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel"),c(cd,"href","https://flax.readthedocs.io/en/latest/flax.linen.html#module"),c(cd,"rel","nofollow"),c(pd,"href","https://jax.readthedocs.io/en/latest/jax.html#just-in-time-compilation-jit"),c(pd,"rel","nofollow"),c(hd,"href","https://jax.readthedocs.io/en/latest/jax.html#automatic-differentiation"),c(hd,"rel","nofollow"),c(ud,"href","https://jax.readthedocs.io/en/latest/jax.html#vectorization-vmap"),c(ud,"rel","nofollow"),c(md,"href","https://jax.readthedocs.io/en/latest/jax.html#parallelization-pmap"),c(md,"rel","nofollow"),c(oo,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ot,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ya,"id","transformers.FlaxXLMRobertaForMaskedLM"),c(ya,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(ya,"href","#transformers.FlaxXLMRobertaForMaskedLM"),c(Hn,"class","relative group"),c(Jp,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel"),c(yd,"href","https://flax.readthedocs.io/en/latest/flax.linen.html#module"),c(yd,"rel","nofollow"),c(wd,"href","https://jax.readthedocs.io/en/latest/jax.html#just-in-time-compilation-jit"),c(wd,"rel","nofollow"),c(Td,"href","https://jax.readthedocs.io/en/latest/jax.html#automatic-differentiation"),c(Td,"rel","nofollow"),c(Md,"href","https://jax.readthedocs.io/en/latest/jax.html#vectorization-vmap"),c(Md,"rel","nofollow"),c($d,"href","https://jax.readthedocs.io/en/latest/jax.html#parallelization-pmap"),c($d,"rel","nofollow"),c(no,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(nt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Ma,"id","transformers.FlaxXLMRobertaForSequenceClassification"),c(Ma,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Ma,"href","#transformers.FlaxXLMRobertaForSequenceClassification"),c(Kn,"class","relative group"),c(Gp,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel"),c(Xd,"href","https://flax.readthedocs.io/en/latest/flax.linen.html#module"),c(Xd,"rel","nofollow"),c(zd,"href","https://jax.readthedocs.io/en/latest/jax.html#just-in-time-compilation-jit"),c(zd,"rel","nofollow"),c(Cd,"href","https://jax.readthedocs.io/en/latest/jax.html#automatic-differentiation"),c(Cd,"rel","nofollow"),c(qd,"href","https://jax.readthedocs.io/en/latest/jax.html#vectorization-vmap"),c(qd,"rel","nofollow"),c(jd,"href","https://jax.readthedocs.io/en/latest/jax.html#parallelization-pmap"),c(jd,"rel","nofollow"),c(so,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(st,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Fa,"id","transformers.FlaxXLMRobertaForMultipleChoice"),c(Fa,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Fa,"href","#transformers.FlaxXLMRobertaForMultipleChoice"),c(Jn,"class","relative group"),c(Yp,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel"),c(Dd,"href","https://flax.readthedocs.io/en/latest/flax.linen.html#module"),c(Dd,"rel","nofollow"),c(Sd,"href","https://jax.readthedocs.io/en/latest/jax.html#just-in-time-compilation-jit"),c(Sd,"rel","nofollow"),c(Wd,"href","https://jax.readthedocs.io/en/latest/jax.html#automatic-differentiation"),c(Wd,"rel","nofollow"),c(Ud,"href","https://jax.readthedocs.io/en/latest/jax.html#vectorization-vmap"),c(Ud,"rel","nofollow"),c(Bd,"href","https://jax.readthedocs.io/en/latest/jax.html#parallelization-pmap"),c(Bd,"rel","nofollow"),c(ao,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(at,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Ra,"id","transformers.FlaxXLMRobertaForTokenClassification"),c(Ra,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Ra,"href","#transformers.FlaxXLMRobertaForTokenClassification"),c(Yn,"class","relative group"),c(Zp,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel"),c(Gd,"href","https://flax.readthedocs.io/en/latest/flax.linen.html#module"),c(Gd,"rel","nofollow"),c(Yd,"href","https://jax.readthedocs.io/en/latest/jax.html#just-in-time-compilation-jit"),c(Yd,"rel","nofollow"),c(Zd,"href","https://jax.readthedocs.io/en/latest/jax.html#automatic-differentiation"),c(Zd,"rel","nofollow"),c(ec,"href","https://jax.readthedocs.io/en/latest/jax.html#vectorization-vmap"),c(ec,"rel","nofollow"),c(tc,"href","https://jax.readthedocs.io/en/latest/jax.html#parallelization-pmap"),c(tc,"rel","nofollow"),c(ro,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(rt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Ca,"id","transformers.FlaxXLMRobertaForQuestionAnswering"),c(Ca,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Ca,"href","#transformers.FlaxXLMRobertaForQuestionAnswering"),c(es,"class","relative group"),c(eh,"href","/docs/transformers/pr_18559/en/main_classes/model#transformers.FlaxPreTrainedModel"),c(ic,"href","https://flax.readthedocs.io/en/latest/flax.linen.html#module"),c(ic,"rel","nofollow"),c(lc,"href","https://jax.readthedocs.io/en/latest/jax.html#just-in-time-compilation-jit"),c(lc,"rel","nofollow"),c(dc,"href","https://jax.readthedocs.io/en/latest/jax.html#automatic-differentiation"),c(dc,"rel","nofollow"),c(cc,"href","https://jax.readthedocs.io/en/latest/jax.html#vectorization-vmap"),c(cc,"rel","nofollow"),c(pc,"href","https://jax.readthedocs.io/en/latest/jax.html#parallelization-pmap"),c(pc,"rel","nofollow"),c(io,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(it,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(i,_){e(document.head,d),g(i,k,_),g(i,m,_),e(m,f),e(f,b),T(l,b,null),e(m,u),e(m,R),e(R,ke),g(i,fe,_),g(i,O,_),e(O,ce),e(ce,te),e(O,ve),e(O,W),e(W,pe),g(i,K,_),g(i,ae,_),e(ae,re),e(re,U),T(ie,U,null),e(ae,ye),e(ae,B),e(B,we),g(i,ge,_),g(i,D,_),e(D,Te),e(D,le),e(le,oe),e(D,z),g(i,j,_),g(i,he,_),e(he,J),g(i,_e,_),g(i,ue,_),e(ue,H),e(H,Me),g(i,be,_),g(i,q,_),e(q,$e),g(i,V,_),g(i,ne,_),e(ne,de),e(de,G),e(de,me),e(me,Le),e(de,N),e(ne,Fe),e(ne,Q),e(Q,xe),e(ne,se),e(ne,C),e(C,Ee),e(C,A),e(A,Re),e(C,Xe),g(i,v,_),g(i,x,_),e(x,Qe),e(x,Z),e(Z,Ke),e(x,Ve),e(x,X),e(X,Je),e(x,Ge),g(i,We,_),g(i,qe,_),e(qe,je),e(je,P),T(S,P,null),e(qe,Ye),e(qe,Se),e(Se,Y),g(i,Ue,_),g(i,Pe,_),e(Pe,ze),g(i,Be,_),T(ee,i,_),g(i,He,_),g(i,gt,_),e(gt,Ec),e(Ec,Zb),e(Ec,lr),e(lr,ek),e(gt,tk),e(gt,$o),e($o,Rc),e(Rc,ok),e($o,nk),e($o,dr),e(dr,sk),e($o,ak),e($o,cr),e(cr,rk),e($o,ik),e(gt,lk),e(gt,Lo),e(Lo,Xc),e(Xc,dk),e(Lo,ck),e(Lo,pr),e(pr,pk),e(Lo,hk),e(Lo,hr),e(hr,uk),e(Lo,mk),e(gt,fk),e(gt,Fo),e(Fo,zc),e(zc,gk),e(Fo,_k),e(Fo,ur),e(ur,bk),e(Fo,kk),e(Fo,mr),e(mr,vk),e(Fo,yk),e(gt,wk),e(gt,Cc),e(Cc,fr),e(fr,Tk),e(Cc,Mk),e(gt,$k),e(gt,zh),e(zh,qc),e(qc,Lk),g(i,kg,_),T(gr,i,_),g(i,vg,_),g(i,Lt,_),e(Lt,xo),e(xo,jc),e(jc,Fk),e(xo,xk),e(xo,_r),e(_r,Ek),e(xo,Rk),e(xo,br),e(br,Xk),e(xo,zk),e(Lt,Ck),e(Lt,Eo),e(Eo,Ac),e(Ac,qk),e(Eo,jk),e(Eo,kr),e(kr,Ak),e(Eo,Pk),e(Eo,vr),e(vr,Nk),e(Eo,Ok),e(Lt,Ik),e(Lt,as),e(as,Pc),e(Pc,Dk),e(as,Sk),e(as,yr),e(yr,Wk),e(as,Uk),e(Lt,Bk),e(Lt,Nc),e(Nc,wr),e(wr,Hk),e(Nc,Qk),e(Lt,Kk),e(Lt,Ch),e(Ch,Oc),e(Oc,Vk),g(i,yg,_),T(Tr,i,_),g(i,wg,_),g(i,Ro,_),e(Ro,Xo),e(Xo,Ic),e(Ic,Jk),e(Xo,Gk),e(Xo,Mr),e(Mr,Yk),e(Xo,Zk),e(Xo,$r),e($r,ev),e(Xo,tv),e(Ro,ov),e(Ro,Dc),e(Dc,Lr),e(Lr,nv),e(Dc,sv),e(Ro,av),e(Ro,qh),e(qh,Sc),e(Sc,rv),g(i,Tg,_),T(Fr,i,_),g(i,Mg,_),g(i,Ft,_),e(Ft,zo),e(zo,Wc),e(Wc,iv),e(zo,lv),e(zo,xr),e(xr,dv),e(zo,cv),e(zo,Er),e(Er,pv),e(zo,hv),e(Ft,uv),e(Ft,Co),e(Co,Uc),e(Uc,mv),e(Co,fv),e(Co,Rr),e(Rr,gv),e(Co,_v),e(Co,Xr),e(Xr,bv),e(Co,kv),e(Ft,vv),e(Ft,qo),e(qo,Bc),e(Bc,yv),e(qo,wv),e(qo,zr),e(zr,Tv),e(qo,Mv),e(qo,Cr),e(Cr,$v),e(qo,Lv),e(Ft,Fv),e(Ft,Hc),e(Hc,qr),e(qr,xv),e(Hc,Ev),e(Ft,Rv),e(Ft,jh),e(jh,Qc),e(Qc,Xv),g(i,$g,_),T(jr,i,_),g(i,Lg,_),g(i,xt,_),e(xt,jo),e(jo,Kc),e(Kc,zv),e(jo,Cv),e(jo,Ar),e(Ar,qv),e(jo,jv),e(jo,Pr),e(Pr,Av),e(jo,Pv),e(xt,Nv),e(xt,Ao),e(Ao,Vc),e(Vc,Ov),e(Ao,Iv),e(Ao,Nr),e(Nr,Dv),e(Ao,Sv),e(Ao,Or),e(Or,Wv),e(Ao,Uv),e(xt,Bv),e(xt,rs),e(rs,Jc),e(Jc,Hv),e(rs,Qv),e(rs,Ir),e(Ir,Kv),e(rs,Vv),e(xt,Jv),e(xt,Gc),e(Gc,Dr),e(Dr,Gv),e(Gc,Yv),e(xt,Zv),e(xt,Ah),e(Ah,Yc),e(Yc,ey),g(i,Fg,_),g(i,Zc,_),e(Zc,Ph),e(Ph,ty),g(i,xg,_),g(i,Po,_),e(Po,No),e(No,ep),e(ep,oy),e(No,ny),e(No,Sr),e(Sr,sy),e(No,ay),e(No,Wr),e(Wr,ry),e(No,iy),e(Po,ly),e(Po,Oo),e(Oo,tp),e(tp,dy),e(Oo,cy),e(Oo,Ur),e(Ur,py),e(Oo,hy),e(Oo,Br),e(Br,uy),e(Oo,my),e(Po,fy),e(Po,Nh),e(Nh,op),e(op,gy),g(i,Eg,_),g(i,np,_),e(np,_y),g(i,Rg,_),g(i,sp,_),e(sp,Hr),e(Hr,by),e(Hr,Qr),e(Qr,ky),e(Hr,vy),g(i,Xg,_),g(i,ln,_),e(ln,is),e(is,Oh),T(Kr,Oh,null),e(ln,yy),e(ln,Ih),e(Ih,wy),g(i,zg,_),g(i,Wt,_),T(Vr,Wt,null),e(Wt,Ty),e(Wt,go),e(go,My),e(go,ap),e(ap,$y),e(go,Ly),e(go,rp),e(rp,Fy),e(go,xy),e(go,Jr),e(Jr,Ey),e(go,Ry),e(Wt,Xy),e(Wt,dn),e(dn,zy),e(dn,ip),e(ip,Cy),e(dn,qy),e(dn,lp),e(lp,jy),e(dn,Ay),e(Wt,Py),T(ls,Wt,null),g(i,Cg,_),g(i,cn,_),e(cn,ds),e(ds,Dh),T(Gr,Dh,null),e(cn,Ny),e(cn,Sh),e(Sh,Oy),g(i,qg,_),g(i,et,_),T(Yr,et,null),e(et,Iy),e(et,_o),e(_o,Dy),e(_o,dp),e(dp,Sy),e(_o,Wy),e(_o,cp),e(cp,Uy),e(_o,By),e(_o,Zr),e(Zr,Hy),e(_o,Qy),e(et,Ky),e(et,ei),e(ei,Vy),e(ei,pp),e(pp,Jy),e(ei,Gy),e(et,Yy),e(et,Io),T(ti,Io,null),e(Io,Zy),e(Io,Wh),e(Wh,e1),e(Io,t1),e(Io,oi),e(oi,hp),e(hp,o1),e(hp,Uh),e(Uh,n1),e(oi,s1),e(oi,up),e(up,a1),e(up,Bh),e(Bh,r1),e(et,i1),e(et,cs),T(ni,cs,null),e(cs,l1),e(cs,si),e(si,d1),e(si,Hh),e(Hh,c1),e(si,p1),e(et,h1),e(et,ps),T(ai,ps,null),e(ps,u1),e(ps,Qh),e(Qh,m1),e(et,f1),e(et,mp),T(ri,mp,null),g(i,jg,_),g(i,pn,_),e(pn,hs),e(hs,Kh),T(ii,Kh,null),e(pn,g1),e(pn,Vh),e(Vh,_1),g(i,Ag,_),g(i,bt,_),T(li,bt,null),e(bt,b1),e(bt,Ut),e(Ut,k1),e(Ut,Jh),e(Jh,v1),e(Ut,y1),e(Ut,fp),e(fp,w1),e(Ut,T1),e(Ut,gp),e(gp,M1),e(Ut,$1),e(Ut,di),e(di,L1),e(Ut,F1),e(bt,x1),e(bt,ci),e(ci,E1),e(ci,_p),e(_p,R1),e(ci,X1),e(bt,z1),e(bt,Do),T(pi,Do,null),e(Do,C1),e(Do,Gh),e(Gh,q1),e(Do,j1),e(Do,hi),e(hi,bp),e(bp,A1),e(bp,Yh),e(Yh,P1),e(hi,N1),e(hi,kp),e(kp,O1),e(kp,Zh),e(Zh,I1),e(bt,D1),e(bt,us),T(ui,us,null),e(us,S1),e(us,eu),e(eu,W1),g(i,Pg,_),g(i,hn,_),e(hn,ms),e(ms,tu),T(mi,tu,null),e(hn,U1),e(hn,ou),e(ou,B1),g(i,Ng,_),g(i,Ze,_),T(fi,Ze,null),e(Ze,H1),e(Ze,nu),e(nu,Q1),e(Ze,K1),e(Ze,gi),e(gi,V1),e(gi,vp),e(vp,J1),e(gi,G1),e(Ze,Y1),e(Ze,_i),e(_i,Z1),e(_i,bi),e(bi,ew),e(_i,tw),e(Ze,ow),e(Ze,ki),e(ki,nw),e(ki,su),e(su,sw),e(ki,aw),e(Ze,rw),e(Ze,lt),e(lt,iw),e(lt,au),e(au,lw),e(lt,dw),e(lt,ru),e(ru,cw),e(lt,pw),e(lt,iu),e(iu,hw),e(lt,uw),e(lt,lu),e(lu,mw),e(lt,fw),e(lt,du),e(du,gw),e(lt,_w),e(lt,cu),e(cu,bw),e(lt,kw),e(Ze,vw),e(Ze,fs),e(fs,yw),e(fs,pu),e(pu,ww),e(fs,Tw),e(fs,vi),e(vi,Mw),e(Ze,$w),e(Ze,Ht),T(yi,Ht,null),e(Ht,Lw),e(Ht,un),e(un,Fw),e(un,yp),e(yp,xw),e(un,Ew),e(un,hu),e(hu,Rw),e(un,Xw),e(Ht,zw),T(gs,Ht,null),e(Ht,Cw),T(_s,Ht,null),g(i,Og,_),g(i,mn,_),e(mn,bs),e(bs,uu),T(wi,uu,null),e(mn,qw),e(mn,mu),e(mu,jw),g(i,Ig,_),g(i,kt,_),T(Ti,kt,null),e(kt,Aw),e(kt,Mi),e(Mi,Pw),e(Mi,fu),e(fu,Nw),e(Mi,Ow),e(kt,Iw),e(kt,$i),e($i,Dw),e($i,wp),e(wp,Sw),e($i,Ww),e(kt,Uw),e(kt,Li),e(Li,Bw),e(Li,Fi),e(Fi,Hw),e(Li,Qw),e(kt,Kw),e(kt,Qt),T(xi,Qt,null),e(Qt,Vw),e(Qt,fn),e(fn,Jw),e(fn,Tp),e(Tp,Gw),e(fn,Yw),e(fn,gu),e(gu,Zw),e(fn,eT),e(Qt,tT),T(ks,Qt,null),e(Qt,oT),T(vs,Qt,null),g(i,Dg,_),g(i,gn,_),e(gn,ys),e(ys,_u),T(Ei,_u,null),e(gn,nT),e(gn,bu),e(bu,sT),g(i,Sg,_),g(i,vt,_),T(Ri,vt,null),e(vt,aT),e(vt,Xi),e(Xi,rT),e(Xi,ku),e(ku,iT),e(Xi,lT),e(vt,dT),e(vt,zi),e(zi,cT),e(zi,Mp),e(Mp,pT),e(zi,hT),e(vt,uT),e(vt,Ci),e(Ci,mT),e(Ci,qi),e(qi,fT),e(Ci,gT),e(vt,_T),e(vt,Kt),T(ji,Kt,null),e(Kt,bT),e(Kt,_n),e(_n,kT),e(_n,$p),e($p,vT),e(_n,yT),e(_n,vu),e(vu,wT),e(_n,TT),e(Kt,MT),T(ws,Kt,null),e(Kt,$T),T(Ts,Kt,null),g(i,Wg,_),g(i,bn,_),e(bn,Ms),e(Ms,yu),T(Ai,yu,null),e(bn,LT),e(bn,wu),e(wu,FT),g(i,Ug,_),g(i,yt,_),T(Pi,yt,null),e(yt,xT),e(yt,Tu),e(Tu,ET),e(yt,RT),e(yt,Ni),e(Ni,XT),e(Ni,Lp),e(Lp,zT),e(Ni,CT),e(yt,qT),e(yt,Oi),e(Oi,jT),e(Oi,Ii),e(Ii,AT),e(Oi,PT),e(yt,NT),e(yt,Et),T(Di,Et,null),e(Et,OT),e(Et,kn),e(kn,IT),e(kn,Fp),e(Fp,DT),e(kn,ST),e(kn,Mu),e(Mu,WT),e(kn,UT),e(Et,BT),T($s,Et,null),e(Et,HT),T(Ls,Et,null),e(Et,QT),T(Fs,Et,null),g(i,Bg,_),g(i,vn,_),e(vn,xs),e(xs,$u),T(Si,$u,null),e(vn,KT),e(vn,Lu),e(Lu,VT),g(i,Hg,_),g(i,wt,_),T(Wi,wt,null),e(wt,JT),e(wt,Fu),e(Fu,GT),e(wt,YT),e(wt,Ui),e(Ui,ZT),e(Ui,xp),e(xp,eM),e(Ui,tM),e(wt,oM),e(wt,Bi),e(Bi,nM),e(Bi,Hi),e(Hi,sM),e(Bi,aM),e(wt,rM),e(wt,Vt),T(Qi,Vt,null),e(Vt,iM),e(Vt,yn),e(yn,lM),e(yn,Ep),e(Ep,dM),e(yn,cM),e(yn,xu),e(xu,pM),e(yn,hM),e(Vt,uM),T(Es,Vt,null),e(Vt,mM),T(Rs,Vt,null),g(i,Qg,_),g(i,wn,_),e(wn,Xs),e(Xs,Eu),T(Ki,Eu,null),e(wn,fM),e(wn,Ru),e(Ru,gM),g(i,Kg,_),g(i,Tt,_),T(Vi,Tt,null),e(Tt,_M),e(Tt,Xu),e(Xu,bM),e(Tt,kM),e(Tt,Ji),e(Ji,vM),e(Ji,Rp),e(Rp,yM),e(Ji,wM),e(Tt,TM),e(Tt,Gi),e(Gi,MM),e(Gi,Yi),e(Yi,$M),e(Gi,LM),e(Tt,FM),e(Tt,Jt),T(Zi,Jt,null),e(Jt,xM),e(Jt,Tn),e(Tn,EM),e(Tn,Xp),e(Xp,RM),e(Tn,XM),e(Tn,zu),e(zu,zM),e(Tn,CM),e(Jt,qM),T(zs,Jt,null),e(Jt,jM),T(Cs,Jt,null),g(i,Vg,_),g(i,Mn,_),e(Mn,qs),e(qs,Cu),T(el,Cu,null),e(Mn,AM),e(Mn,qu),e(qu,PM),g(i,Jg,_),g(i,Mt,_),T(tl,Mt,null),e(Mt,NM),e(Mt,$n),e($n,OM),e($n,ju),e(ju,IM),e($n,DM),e($n,Au),e(Au,SM),e($n,WM),e(Mt,UM),e(Mt,ol),e(ol,BM),e(ol,zp),e(zp,HM),e(ol,QM),e(Mt,KM),e(Mt,nl),e(nl,VM),e(nl,sl),e(sl,JM),e(nl,GM),e(Mt,YM),e(Mt,Gt),T(al,Gt,null),e(Gt,ZM),e(Gt,Ln),e(Ln,e$),e(Ln,Cp),e(Cp,t$),e(Ln,o$),e(Ln,Pu),e(Pu,n$),e(Ln,s$),e(Gt,a$),T(js,Gt,null),e(Gt,r$),T(As,Gt,null),g(i,Gg,_),g(i,Fn,_),e(Fn,Ps),e(Ps,Nu),T(rl,Nu,null),e(Fn,i$),e(Fn,Ou),e(Ou,l$),g(i,Yg,_),g(i,dt,_),T(il,dt,null),e(dt,d$),e(dt,Iu),e(Iu,c$),e(dt,p$),e(dt,ll),e(ll,h$),e(ll,qp),e(qp,u$),e(ll,m$),e(dt,f$),e(dt,dl),e(dl,g$),e(dl,cl),e(cl,_$),e(dl,b$),e(dt,k$),T(Ns,dt,null),e(dt,v$),e(dt,Yt),T(pl,Yt,null),e(Yt,y$),e(Yt,xn),e(xn,w$),e(xn,jp),e(jp,T$),e(xn,M$),e(xn,Du),e(Du,$$),e(xn,L$),e(Yt,F$),T(Os,Yt,null),e(Yt,x$),T(Is,Yt,null),g(i,Zg,_),g(i,En,_),e(En,Ds),e(Ds,Su),T(hl,Su,null),e(En,E$),e(En,Wu),e(Wu,R$),g(i,e_,_),g(i,ct,_),T(ul,ct,null),e(ct,X$),e(ct,ml),e(ml,z$),e(ml,Uu),e(Uu,C$),e(ml,q$),e(ct,j$),e(ct,fl),e(fl,A$),e(fl,Ap),e(Ap,P$),e(fl,N$),e(ct,O$),e(ct,gl),e(gl,I$),e(gl,_l),e(_l,D$),e(gl,S$),e(ct,W$),T(Ss,ct,null),e(ct,U$),e(ct,Zt),T(bl,Zt,null),e(Zt,B$),e(Zt,Rn),e(Rn,H$),e(Rn,Pp),e(Pp,Q$),e(Rn,K$),e(Rn,Bu),e(Bu,V$),e(Rn,J$),e(Zt,G$),T(Ws,Zt,null),e(Zt,Y$),T(Us,Zt,null),g(i,t_,_),g(i,Xn,_),e(Xn,Bs),e(Bs,Hu),T(kl,Hu,null),e(Xn,Z$),e(Xn,Qu),e(Qu,e2),g(i,o_,_),g(i,pt,_),T(vl,pt,null),e(pt,t2),e(pt,yl),e(yl,o2),e(yl,Ku),e(Ku,n2),e(yl,s2),e(pt,a2),e(pt,wl),e(wl,r2),e(wl,Np),e(Np,i2),e(wl,l2),e(pt,d2),e(pt,Tl),e(Tl,c2),e(Tl,Ml),e(Ml,p2),e(Tl,h2),e(pt,u2),T(Hs,pt,null),e(pt,m2),e(pt,Rt),T($l,Rt,null),e(Rt,f2),e(Rt,zn),e(zn,g2),e(zn,Op),e(Op,_2),e(zn,b2),e(zn,Vu),e(Vu,k2),e(zn,v2),e(Rt,y2),T(Qs,Rt,null),e(Rt,w2),T(Ks,Rt,null),e(Rt,T2),T(Vs,Rt,null),g(i,n_,_),g(i,Cn,_),e(Cn,Js),e(Js,Ju),T(Ll,Ju,null),e(Cn,M2),e(Cn,Gu),e(Gu,$2),g(i,s_,_),g(i,ht,_),T(Fl,ht,null),e(ht,L2),e(ht,Yu),e(Yu,F2),e(ht,x2),e(ht,xl),e(xl,E2),e(xl,Ip),e(Ip,R2),e(xl,X2),e(ht,z2),e(ht,El),e(El,C2),e(El,Rl),e(Rl,q2),e(El,j2),e(ht,A2),T(Gs,ht,null),e(ht,P2),e(ht,Xt),T(Xl,Xt,null),e(Xt,N2),e(Xt,qn),e(qn,O2),e(qn,Dp),e(Dp,I2),e(qn,D2),e(qn,Zu),e(Zu,S2),e(qn,W2),e(Xt,U2),T(Ys,Xt,null),e(Xt,B2),T(Zs,Xt,null),e(Xt,H2),T(ea,Xt,null),g(i,a_,_),g(i,jn,_),e(jn,ta),e(ta,em),T(zl,em,null),e(jn,Q2),e(jn,tm),e(tm,K2),g(i,r_,_),g(i,ut,_),T(Cl,ut,null),e(ut,V2),e(ut,om),e(om,J2),e(ut,G2),e(ut,ql),e(ql,Y2),e(ql,Sp),e(Sp,Z2),e(ql,eL),e(ut,tL),e(ut,jl),e(jl,oL),e(jl,Al),e(Al,nL),e(jl,sL),e(ut,aL),T(oa,ut,null),e(ut,rL),e(ut,eo),T(Pl,eo,null),e(eo,iL),e(eo,An),e(An,lL),e(An,Wp),e(Wp,dL),e(An,cL),e(An,nm),e(nm,pL),e(An,hL),e(eo,uL),T(na,eo,null),e(eo,mL),T(sa,eo,null),g(i,i_,_),g(i,Pn,_),e(Pn,aa),e(aa,sm),T(Nl,sm,null),e(Pn,fL),e(Pn,am),e(am,gL),g(i,l_,_),g(i,mt,_),T(Ol,mt,null),e(mt,_L),e(mt,rm),e(rm,bL),e(mt,kL),e(mt,Il),e(Il,vL),e(Il,Up),e(Up,yL),e(Il,wL),e(mt,TL),e(mt,Dl),e(Dl,ML),e(Dl,Sl),e(Sl,$L),e(Dl,LL),e(mt,FL),T(ra,mt,null),e(mt,xL),e(mt,zt),T(Wl,zt,null),e(zt,EL),e(zt,Nn),e(Nn,RL),e(Nn,Bp),e(Bp,XL),e(Nn,zL),e(Nn,im),e(im,CL),e(Nn,qL),e(zt,jL),T(ia,zt,null),e(zt,AL),T(la,zt,null),e(zt,PL),T(da,zt,null),g(i,d_,_),g(i,On,_),e(On,ca),e(ca,lm),T(Ul,lm,null),e(On,NL),e(On,dm),e(dm,OL),g(i,c_,_),g(i,ft,_),T(Bl,ft,null),e(ft,IL),e(ft,In),e(In,DL),e(In,cm),e(cm,SL),e(In,WL),e(In,pm),e(pm,UL),e(In,BL),e(ft,HL),e(ft,Hl),e(Hl,QL),e(Hl,Hp),e(Hp,KL),e(Hl,VL),e(ft,JL),e(ft,Ql),e(Ql,GL),e(Ql,Kl),e(Kl,YL),e(Ql,ZL),e(ft,eF),T(pa,ft,null),e(ft,tF),e(ft,Ct),T(Vl,Ct,null),e(Ct,oF),e(Ct,Dn),e(Dn,nF),e(Dn,Qp),e(Qp,sF),e(Dn,aF),e(Dn,hm),e(hm,rF),e(Dn,iF),e(Ct,lF),T(ha,Ct,null),e(Ct,dF),T(ua,Ct,null),e(Ct,cF),T(ma,Ct,null),g(i,p_,_),g(i,Sn,_),e(Sn,fa),e(fa,um),T(Jl,um,null),e(Sn,pF),e(Sn,mm),e(mm,hF),g(i,h_,_),g(i,tt,_),T(Gl,tt,null),e(tt,uF),e(tt,fm),e(fm,mF),e(tt,fF),e(tt,Yl),e(Yl,gF),e(Yl,Kp),e(Kp,_F),e(Yl,bF),e(tt,kF),e(tt,Zl),e(Zl,vF),e(Zl,ed),e(ed,yF),e(Zl,wF),e(tt,TF),e(tt,gm),e(gm,MF),e(tt,$F),e(tt,bo),e(bo,_m),e(_m,td),e(td,LF),e(bo,FF),e(bo,bm),e(bm,od),e(od,xF),e(bo,EF),e(bo,km),e(km,nd),e(nd,RF),e(bo,XF),e(bo,vm),e(vm,sd),e(sd,zF),e(tt,CF),e(tt,to),T(ad,to,null),e(to,qF),e(to,Wn),e(Wn,jF),e(Wn,ym),e(ym,AF),e(Wn,PF),e(Wn,wm),e(wm,NF),e(Wn,OF),e(to,IF),T(ga,to,null),e(to,DF),T(_a,to,null),g(i,u_,_),g(i,Un,_),e(Un,ba),e(ba,Tm),T(rd,Tm,null),e(Un,SF),e(Un,Mm),e(Mm,WF),g(i,m_,_),g(i,ot,_),T(id,ot,null),e(ot,UF),e(ot,$m),e($m,BF),e(ot,HF),e(ot,ld),e(ld,QF),e(ld,Vp),e(Vp,KF),e(ld,VF),e(ot,JF),e(ot,dd),e(dd,GF),e(dd,cd),e(cd,YF),e(dd,ZF),e(ot,ex),e(ot,Lm),e(Lm,tx),e(ot,ox),e(ot,ko),e(ko,Fm),e(Fm,pd),e(pd,nx),e(ko,sx),e(ko,xm),e(xm,hd),e(hd,ax),e(ko,rx),e(ko,Em),e(Em,ud),e(ud,ix),e(ko,lx),e(ko,Rm),e(Rm,md),e(md,dx),e(ot,cx),e(ot,oo),T(fd,oo,null),e(oo,px),e(oo,Bn),e(Bn,hx),e(Bn,Xm),e(Xm,ux),e(Bn,mx),e(Bn,zm),e(zm,fx),e(Bn,gx),e(oo,_x),T(ka,oo,null),e(oo,bx),T(va,oo,null),g(i,f_,_),g(i,Hn,_),e(Hn,ya),e(ya,Cm),T(gd,Cm,null),e(Hn,kx),e(Hn,qm),e(qm,vx),g(i,g_,_),g(i,nt,_),T(_d,nt,null),e(nt,yx),e(nt,bd),e(bd,wx),e(bd,jm),e(jm,Tx),e(bd,Mx),e(nt,$x),e(nt,kd),e(kd,Lx),e(kd,Jp),e(Jp,Fx),e(kd,xx),e(nt,Ex),e(nt,vd),e(vd,Rx),e(vd,yd),e(yd,Xx),e(vd,zx),e(nt,Cx),e(nt,Am),e(Am,qx),e(nt,jx),e(nt,vo),e(vo,Pm),e(Pm,wd),e(wd,Ax),e(vo,Px),e(vo,Nm),e(Nm,Td),e(Td,Nx),e(vo,Ox),e(vo,Om),e(Om,Md),e(Md,Ix),e(vo,Dx),e(vo,Im),e(Im,$d),e($d,Sx),e(nt,Wx),e(nt,no),T(Ld,no,null),e(no,Ux),e(no,Qn),e(Qn,Bx),e(Qn,Dm),e(Dm,Hx),e(Qn,Qx),e(Qn,Sm),e(Sm,Kx),e(Qn,Vx),e(no,Jx),T(wa,no,null),e(no,Gx),T(Ta,no,null),g(i,__,_),g(i,Kn,_),e(Kn,Ma),e(Ma,Wm),T(Fd,Wm,null),e(Kn,Yx),e(Kn,Um),e(Um,Zx),g(i,b_,_),g(i,st,_),T(xd,st,null),e(st,e0),e(st,Bm),e(Bm,t0),e(st,o0),e(st,Ed),e(Ed,n0),e(Ed,Gp),e(Gp,s0),e(Ed,a0),e(st,r0),e(st,Rd),e(Rd,i0),e(Rd,Xd),e(Xd,l0),e(Rd,d0),e(st,c0),e(st,Hm),e(Hm,p0),e(st,h0),e(st,yo),e(yo,Qm),e(Qm,zd),e(zd,u0),e(yo,m0),e(yo,Km),e(Km,Cd),e(Cd,f0),e(yo,g0),e(yo,Vm),e(Vm,qd),e(qd,_0),e(yo,b0),e(yo,Jm),e(Jm,jd),e(jd,k0),e(st,v0),e(st,so),T(Ad,so,null),e(so,y0),e(so,Vn),e(Vn,w0),e(Vn,Gm),e(Gm,T0),e(Vn,M0),e(Vn,Ym),e(Ym,$0),e(Vn,L0),e(so,F0),T($a,so,null),e(so,x0),T(La,so,null),g(i,k_,_),g(i,Jn,_),e(Jn,Fa),e(Fa,Zm),T(Pd,Zm,null),e(Jn,E0),e(Jn,ef),e(ef,R0),g(i,v_,_),g(i,at,_),T(Nd,at,null),e(at,X0),e(at,tf),e(tf,z0),e(at,C0),e(at,Od),e(Od,q0),e(Od,Yp),e(Yp,j0),e(Od,A0),e(at,P0),e(at,Id),e(Id,N0),e(Id,Dd),e(Dd,O0),e(Id,I0),e(at,D0),e(at,of),e(of,S0),e(at,W0),e(at,wo),e(wo,nf),e(nf,Sd),e(Sd,U0),e(wo,B0),e(wo,sf),e(sf,Wd),e(Wd,H0),e(wo,Q0),e(wo,af),e(af,Ud),e(Ud,K0),e(wo,V0),e(wo,rf),e(rf,Bd),e(Bd,J0),e(at,G0),e(at,ao),T(Hd,ao,null),e(ao,Y0),e(ao,Gn),e(Gn,Z0),e(Gn,lf),e(lf,e5),e(Gn,t5),e(Gn,df),e(df,o5),e(Gn,n5),e(ao,s5),T(xa,ao,null),e(ao,a5),T(Ea,ao,null),g(i,y_,_),g(i,Yn,_),e(Yn,Ra),e(Ra,cf),T(Qd,cf,null),e(Yn,r5),e(Yn,pf),e(pf,i5),g(i,w_,_),g(i,rt,_),T(Kd,rt,null),e(rt,l5),e(rt,hf),e(hf,d5),e(rt,c5),e(rt,Vd),e(Vd,p5),e(Vd,Zp),e(Zp,h5),e(Vd,u5),e(rt,m5),e(rt,Jd),e(Jd,f5),e(Jd,Gd),e(Gd,g5),e(Jd,_5),e(rt,b5),e(rt,uf),e(uf,k5),e(rt,v5),e(rt,To),e(To,mf),e(mf,Yd),e(Yd,y5),e(To,w5),e(To,ff),e(ff,Zd),e(Zd,T5),e(To,M5),e(To,gf),e(gf,ec),e(ec,$5),e(To,L5),e(To,_f),e(_f,tc),e(tc,F5),e(rt,x5),e(rt,ro),T(oc,ro,null),e(ro,E5),e(ro,Zn),e(Zn,R5),e(Zn,bf),e(bf,X5),e(Zn,z5),e(Zn,kf),e(kf,C5),e(Zn,q5),e(ro,j5),T(Xa,ro,null),e(ro,A5),T(za,ro,null),g(i,T_,_),g(i,es,_),e(es,Ca),e(Ca,vf),T(nc,vf,null),e(es,P5),e(es,yf),e(yf,N5),g(i,M_,_),g(i,it,_),T(sc,it,null),e(it,O5),e(it,ts),e(ts,I5),e(ts,wf),e(wf,D5),e(ts,S5),e(ts,Tf),e(Tf,W5),e(ts,U5),e(it,B5),e(it,ac),e(ac,H5),e(ac,eh),e(eh,Q5),e(ac,K5),e(it,V5),e(it,rc),e(rc,J5),e(rc,ic),e(ic,G5),e(rc,Y5),e(it,Z5),e(it,Mf),e(Mf,eE),e(it,tE),e(it,Mo),e(Mo,$f),e($f,lc),e(lc,oE),e(Mo,nE),e(Mo,Lf),e(Lf,dc),e(dc,sE),e(Mo,aE),e(Mo,Ff),e(Ff,cc),e(cc,rE),e(Mo,iE),e(Mo,xf),e(xf,pc),e(pc,lE),e(it,dE),e(it,io),T(hc,io,null),e(io,cE),e(io,os),e(os,pE),e(os,Ef),e(Ef,hE),e(os,uE),e(os,Rf),e(Rf,mE),e(os,fE),e(io,gE),T(qa,io,null),e(io,_E),T(ja,io,null),$_=!0},p(i,[_]){const uc={};_&2&&(uc.$$scope={dirty:_,ctx:i}),ls.$set(uc);const Xf={};_&2&&(Xf.$$scope={dirty:_,ctx:i}),gs.$set(Xf);const zf={};_&2&&(zf.$$scope={dirty:_,ctx:i}),_s.$set(zf);const Cf={};_&2&&(Cf.$$scope={dirty:_,ctx:i}),ks.$set(Cf);const mc={};_&2&&(mc.$$scope={dirty:_,ctx:i}),vs.$set(mc);const qf={};_&2&&(qf.$$scope={dirty:_,ctx:i}),ws.$set(qf);const jf={};_&2&&(jf.$$scope={dirty:_,ctx:i}),Ts.$set(jf);const fc={};_&2&&(fc.$$scope={dirty:_,ctx:i}),$s.$set(fc);const Af={};_&2&&(Af.$$scope={dirty:_,ctx:i}),Ls.$set(Af);const Pf={};_&2&&(Pf.$$scope={dirty:_,ctx:i}),Fs.$set(Pf);const Nf={};_&2&&(Nf.$$scope={dirty:_,ctx:i}),Es.$set(Nf);const gc={};_&2&&(gc.$$scope={dirty:_,ctx:i}),Rs.$set(gc);const Of={};_&2&&(Of.$$scope={dirty:_,ctx:i}),zs.$set(Of);const If={};_&2&&(If.$$scope={dirty:_,ctx:i}),Cs.$set(If);const Df={};_&2&&(Df.$$scope={dirty:_,ctx:i}),js.$set(Df);const Sf={};_&2&&(Sf.$$scope={dirty:_,ctx:i}),As.$set(Sf);const Wf={};_&2&&(Wf.$$scope={dirty:_,ctx:i}),Ns.$set(Wf);const ns={};_&2&&(ns.$$scope={dirty:_,ctx:i}),Os.$set(ns);const _c={};_&2&&(_c.$$scope={dirty:_,ctx:i}),Is.$set(_c);const Uf={};_&2&&(Uf.$$scope={dirty:_,ctx:i}),Ss.$set(Uf);const Bf={};_&2&&(Bf.$$scope={dirty:_,ctx:i}),Ws.$set(Bf);const bc={};_&2&&(bc.$$scope={dirty:_,ctx:i}),Us.$set(bc);const Hf={};_&2&&(Hf.$$scope={dirty:_,ctx:i}),Hs.$set(Hf);const ss={};_&2&&(ss.$$scope={dirty:_,ctx:i}),Qs.$set(ss);const Qf={};_&2&&(Qf.$$scope={dirty:_,ctx:i}),Ks.$set(Qf);const Kf={};_&2&&(Kf.$$scope={dirty:_,ctx:i}),Vs.$set(Kf);const kc={};_&2&&(kc.$$scope={dirty:_,ctx:i}),Gs.$set(kc);const Vf={};_&2&&(Vf.$$scope={dirty:_,ctx:i}),Ys.$set(Vf);const Jf={};_&2&&(Jf.$$scope={dirty:_,ctx:i}),Zs.$set(Jf);const Gf={};_&2&&(Gf.$$scope={dirty:_,ctx:i}),ea.$set(Gf);const Yf={};_&2&&(Yf.$$scope={dirty:_,ctx:i}),oa.$set(Yf);const $t={};_&2&&($t.$$scope={dirty:_,ctx:i}),na.$set($t);const th={};_&2&&(th.$$scope={dirty:_,ctx:i}),sa.$set(th);const Zf={};_&2&&(Zf.$$scope={dirty:_,ctx:i}),ra.$set(Zf);const So={};_&2&&(So.$$scope={dirty:_,ctx:i}),ia.$set(So);const eg={};_&2&&(eg.$$scope={dirty:_,ctx:i}),la.$set(eg);const tg={};_&2&&(tg.$$scope={dirty:_,ctx:i}),da.$set(tg);const og={};_&2&&(og.$$scope={dirty:_,ctx:i}),pa.$set(og);const Wo={};_&2&&(Wo.$$scope={dirty:_,ctx:i}),ha.$set(Wo);const ng={};_&2&&(ng.$$scope={dirty:_,ctx:i}),ua.$set(ng);const sg={};_&2&&(sg.$$scope={dirty:_,ctx:i}),ma.$set(sg);const ag={};_&2&&(ag.$$scope={dirty:_,ctx:i}),ga.$set(ag);const Uo={};_&2&&(Uo.$$scope={dirty:_,ctx:i}),_a.$set(Uo);const rg={};_&2&&(rg.$$scope={dirty:_,ctx:i}),ka.$set(rg);const ig={};_&2&&(ig.$$scope={dirty:_,ctx:i}),va.$set(ig);const lg={};_&2&&(lg.$$scope={dirty:_,ctx:i}),wa.$set(lg);const oh={};_&2&&(oh.$$scope={dirty:_,ctx:i}),Ta.$set(oh);const dg={};_&2&&(dg.$$scope={dirty:_,ctx:i}),$a.$set(dg);const cg={};_&2&&(cg.$$scope={dirty:_,ctx:i}),La.$set(cg);const pg={};_&2&&(pg.$$scope={dirty:_,ctx:i}),xa.$set(pg);const Bt={};_&2&&(Bt.$$scope={dirty:_,ctx:i}),Ea.$set(Bt);const Bo={};_&2&&(Bo.$$scope={dirty:_,ctx:i}),Xa.$set(Bo);const hg={};_&2&&(hg.$$scope={dirty:_,ctx:i}),za.$set(hg);const ug={};_&2&&(ug.$$scope={dirty:_,ctx:i}),qa.$set(ug);const mg={};_&2&&(mg.$$scope={dirty:_,ctx:i}),ja.$set(mg)},i(i){$_||(M(l.$$.fragment,i),M(ie.$$.fragment,i),M(S.$$.fragment,i),M(ee.$$.fragment,i),M(gr.$$.fragment,i),M(Tr.$$.fragment,i),M(Fr.$$.fragment,i),M(jr.$$.fragment,i),M(Kr.$$.fragment,i),M(Vr.$$.fragment,i),M(ls.$$.fragment,i),M(Gr.$$.fragment,i),M(Yr.$$.fragment,i),M(ti.$$.fragment,i),M(ni.$$.fragment,i),M(ai.$$.fragment,i),M(ri.$$.fragment,i),M(ii.$$.fragment,i),M(li.$$.fragment,i),M(pi.$$.fragment,i),M(ui.$$.fragment,i),M(mi.$$.fragment,i),M(fi.$$.fragment,i),M(yi.$$.fragment,i),M(gs.$$.fragment,i),M(_s.$$.fragment,i),M(wi.$$.fragment,i),M(Ti.$$.fragment,i),M(xi.$$.fragment,i),M(ks.$$.fragment,i),M(vs.$$.fragment,i),M(Ei.$$.fragment,i),M(Ri.$$.fragment,i),M(ji.$$.fragment,i),M(ws.$$.fragment,i),M(Ts.$$.fragment,i),M(Ai.$$.fragment,i),M(Pi.$$.fragment,i),M(Di.$$.fragment,i),M($s.$$.fragment,i),M(Ls.$$.fragment,i),M(Fs.$$.fragment,i),M(Si.$$.fragment,i),M(Wi.$$.fragment,i),M(Qi.$$.fragment,i),M(Es.$$.fragment,i),M(Rs.$$.fragment,i),M(Ki.$$.fragment,i),M(Vi.$$.fragment,i),M(Zi.$$.fragment,i),M(zs.$$.fragment,i),M(Cs.$$.fragment,i),M(el.$$.fragment,i),M(tl.$$.fragment,i),M(al.$$.fragment,i),M(js.$$.fragment,i),M(As.$$.fragment,i),M(rl.$$.fragment,i),M(il.$$.fragment,i),M(Ns.$$.fragment,i),M(pl.$$.fragment,i),M(Os.$$.fragment,i),M(Is.$$.fragment,i),M(hl.$$.fragment,i),M(ul.$$.fragment,i),M(Ss.$$.fragment,i),M(bl.$$.fragment,i),M(Ws.$$.fragment,i),M(Us.$$.fragment,i),M(kl.$$.fragment,i),M(vl.$$.fragment,i),M(Hs.$$.fragment,i),M($l.$$.fragment,i),M(Qs.$$.fragment,i),M(Ks.$$.fragment,i),M(Vs.$$.fragment,i),M(Ll.$$.fragment,i),M(Fl.$$.fragment,i),M(Gs.$$.fragment,i),M(Xl.$$.fragment,i),M(Ys.$$.fragment,i),M(Zs.$$.fragment,i),M(ea.$$.fragment,i),M(zl.$$.fragment,i),M(Cl.$$.fragment,i),M(oa.$$.fragment,i),M(Pl.$$.fragment,i),M(na.$$.fragment,i),M(sa.$$.fragment,i),M(Nl.$$.fragment,i),M(Ol.$$.fragment,i),M(ra.$$.fragment,i),M(Wl.$$.fragment,i),M(ia.$$.fragment,i),M(la.$$.fragment,i),M(da.$$.fragment,i),M(Ul.$$.fragment,i),M(Bl.$$.fragment,i),M(pa.$$.fragment,i),M(Vl.$$.fragment,i),M(ha.$$.fragment,i),M(ua.$$.fragment,i),M(ma.$$.fragment,i),M(Jl.$$.fragment,i),M(Gl.$$.fragment,i),M(ad.$$.fragment,i),M(ga.$$.fragment,i),M(_a.$$.fragment,i),M(rd.$$.fragment,i),M(id.$$.fragment,i),M(fd.$$.fragment,i),M(ka.$$.fragment,i),M(va.$$.fragment,i),M(gd.$$.fragment,i),M(_d.$$.fragment,i),M(Ld.$$.fragment,i),M(wa.$$.fragment,i),M(Ta.$$.fragment,i),M(Fd.$$.fragment,i),M(xd.$$.fragment,i),M(Ad.$$.fragment,i),M($a.$$.fragment,i),M(La.$$.fragment,i),M(Pd.$$.fragment,i),M(Nd.$$.fragment,i),M(Hd.$$.fragment,i),M(xa.$$.fragment,i),M(Ea.$$.fragment,i),M(Qd.$$.fragment,i),M(Kd.$$.fragment,i),M(oc.$$.fragment,i),M(Xa.$$.fragment,i),M(za.$$.fragment,i),M(nc.$$.fragment,i),M(sc.$$.fragment,i),M(hc.$$.fragment,i),M(qa.$$.fragment,i),M(ja.$$.fragment,i),$_=!0)},o(i){$(l.$$.fragment,i),$(ie.$$.fragment,i),$(S.$$.fragment,i),$(ee.$$.fragment,i),$(gr.$$.fragment,i),$(Tr.$$.fragment,i),$(Fr.$$.fragment,i),$(jr.$$.fragment,i),$(Kr.$$.fragment,i),$(Vr.$$.fragment,i),$(ls.$$.fragment,i),$(Gr.$$.fragment,i),$(Yr.$$.fragment,i),$(ti.$$.fragment,i),$(ni.$$.fragment,i),$(ai.$$.fragment,i),$(ri.$$.fragment,i),$(ii.$$.fragment,i),$(li.$$.fragment,i),$(pi.$$.fragment,i),$(ui.$$.fragment,i),$(mi.$$.fragment,i),$(fi.$$.fragment,i),$(yi.$$.fragment,i),$(gs.$$.fragment,i),$(_s.$$.fragment,i),$(wi.$$.fragment,i),$(Ti.$$.fragment,i),$(xi.$$.fragment,i),$(ks.$$.fragment,i),$(vs.$$.fragment,i),$(Ei.$$.fragment,i),$(Ri.$$.fragment,i),$(ji.$$.fragment,i),$(ws.$$.fragment,i),$(Ts.$$.fragment,i),$(Ai.$$.fragment,i),$(Pi.$$.fragment,i),$(Di.$$.fragment,i),$($s.$$.fragment,i),$(Ls.$$.fragment,i),$(Fs.$$.fragment,i),$(Si.$$.fragment,i),$(Wi.$$.fragment,i),$(Qi.$$.fragment,i),$(Es.$$.fragment,i),$(Rs.$$.fragment,i),$(Ki.$$.fragment,i),$(Vi.$$.fragment,i),$(Zi.$$.fragment,i),$(zs.$$.fragment,i),$(Cs.$$.fragment,i),$(el.$$.fragment,i),$(tl.$$.fragment,i),$(al.$$.fragment,i),$(js.$$.fragment,i),$(As.$$.fragment,i),$(rl.$$.fragment,i),$(il.$$.fragment,i),$(Ns.$$.fragment,i),$(pl.$$.fragment,i),$(Os.$$.fragment,i),$(Is.$$.fragment,i),$(hl.$$.fragment,i),$(ul.$$.fragment,i),$(Ss.$$.fragment,i),$(bl.$$.fragment,i),$(Ws.$$.fragment,i),$(Us.$$.fragment,i),$(kl.$$.fragment,i),$(vl.$$.fragment,i),$(Hs.$$.fragment,i),$($l.$$.fragment,i),$(Qs.$$.fragment,i),$(Ks.$$.fragment,i),$(Vs.$$.fragment,i),$(Ll.$$.fragment,i),$(Fl.$$.fragment,i),$(Gs.$$.fragment,i),$(Xl.$$.fragment,i),$(Ys.$$.fragment,i),$(Zs.$$.fragment,i),$(ea.$$.fragment,i),$(zl.$$.fragment,i),$(Cl.$$.fragment,i),$(oa.$$.fragment,i),$(Pl.$$.fragment,i),$(na.$$.fragment,i),$(sa.$$.fragment,i),$(Nl.$$.fragment,i),$(Ol.$$.fragment,i),$(ra.$$.fragment,i),$(Wl.$$.fragment,i),$(ia.$$.fragment,i),$(la.$$.fragment,i),$(da.$$.fragment,i),$(Ul.$$.fragment,i),$(Bl.$$.fragment,i),$(pa.$$.fragment,i),$(Vl.$$.fragment,i),$(ha.$$.fragment,i),$(ua.$$.fragment,i),$(ma.$$.fragment,i),$(Jl.$$.fragment,i),$(Gl.$$.fragment,i),$(ad.$$.fragment,i),$(ga.$$.fragment,i),$(_a.$$.fragment,i),$(rd.$$.fragment,i),$(id.$$.fragment,i),$(fd.$$.fragment,i),$(ka.$$.fragment,i),$(va.$$.fragment,i),$(gd.$$.fragment,i),$(_d.$$.fragment,i),$(Ld.$$.fragment,i),$(wa.$$.fragment,i),$(Ta.$$.fragment,i),$(Fd.$$.fragment,i),$(xd.$$.fragment,i),$(Ad.$$.fragment,i),$($a.$$.fragment,i),$(La.$$.fragment,i),$(Pd.$$.fragment,i),$(Nd.$$.fragment,i),$(Hd.$$.fragment,i),$(xa.$$.fragment,i),$(Ea.$$.fragment,i),$(Qd.$$.fragment,i),$(Kd.$$.fragment,i),$(oc.$$.fragment,i),$(Xa.$$.fragment,i),$(za.$$.fragment,i),$(nc.$$.fragment,i),$(sc.$$.fragment,i),$(hc.$$.fragment,i),$(qa.$$.fragment,i),$(ja.$$.fragment,i),$_=!1},d(i){t(d),i&&t(k),i&&t(m),L(l),i&&t(fe),i&&t(O),i&&t(K),i&&t(ae),L(ie),i&&t(ge),i&&t(D),i&&t(j),i&&t(he),i&&t(_e),i&&t(ue),i&&t(be),i&&t(q),i&&t(V),i&&t(ne),i&&t(v),i&&t(x),i&&t(We),i&&t(qe),L(S),i&&t(Ue),i&&t(Pe),i&&t(Be),L(ee,i),i&&t(He),i&&t(gt),i&&t(kg),L(gr,i),i&&t(vg),i&&t(Lt),i&&t(yg),L(Tr,i),i&&t(wg),i&&t(Ro),i&&t(Tg),L(Fr,i),i&&t(Mg),i&&t(Ft),i&&t($g),L(jr,i),i&&t(Lg),i&&t(xt),i&&t(Fg),i&&t(Zc),i&&t(xg),i&&t(Po),i&&t(Eg),i&&t(np),i&&t(Rg),i&&t(sp),i&&t(Xg),i&&t(ln),L(Kr),i&&t(zg),i&&t(Wt),L(Vr),L(ls),i&&t(Cg),i&&t(cn),L(Gr),i&&t(qg),i&&t(et),L(Yr),L(ti),L(ni),L(ai),L(ri),i&&t(jg),i&&t(pn),L(ii),i&&t(Ag),i&&t(bt),L(li),L(pi),L(ui),i&&t(Pg),i&&t(hn),L(mi),i&&t(Ng),i&&t(Ze),L(fi),L(yi),L(gs),L(_s),i&&t(Og),i&&t(mn),L(wi),i&&t(Ig),i&&t(kt),L(Ti),L(xi),L(ks),L(vs),i&&t(Dg),i&&t(gn),L(Ei),i&&t(Sg),i&&t(vt),L(Ri),L(ji),L(ws),L(Ts),i&&t(Wg),i&&t(bn),L(Ai),i&&t(Ug),i&&t(yt),L(Pi),L(Di),L($s),L(Ls),L(Fs),i&&t(Bg),i&&t(vn),L(Si),i&&t(Hg),i&&t(wt),L(Wi),L(Qi),L(Es),L(Rs),i&&t(Qg),i&&t(wn),L(Ki),i&&t(Kg),i&&t(Tt),L(Vi),L(Zi),L(zs),L(Cs),i&&t(Vg),i&&t(Mn),L(el),i&&t(Jg),i&&t(Mt),L(tl),L(al),L(js),L(As),i&&t(Gg),i&&t(Fn),L(rl),i&&t(Yg),i&&t(dt),L(il),L(Ns),L(pl),L(Os),L(Is),i&&t(Zg),i&&t(En),L(hl),i&&t(e_),i&&t(ct),L(ul),L(Ss),L(bl),L(Ws),L(Us),i&&t(t_),i&&t(Xn),L(kl),i&&t(o_),i&&t(pt),L(vl),L(Hs),L($l),L(Qs),L(Ks),L(Vs),i&&t(n_),i&&t(Cn),L(Ll),i&&t(s_),i&&t(ht),L(Fl),L(Gs),L(Xl),L(Ys),L(Zs),L(ea),i&&t(a_),i&&t(jn),L(zl),i&&t(r_),i&&t(ut),L(Cl),L(oa),L(Pl),L(na),L(sa),i&&t(i_),i&&t(Pn),L(Nl),i&&t(l_),i&&t(mt),L(Ol),L(ra),L(Wl),L(ia),L(la),L(da),i&&t(d_),i&&t(On),L(Ul),i&&t(c_),i&&t(ft),L(Bl),L(pa),L(Vl),L(ha),L(ua),L(ma),i&&t(p_),i&&t(Sn),L(Jl),i&&t(h_),i&&t(tt),L(Gl),L(ad),L(ga),L(_a),i&&t(u_),i&&t(Un),L(rd),i&&t(m_),i&&t(ot),L(id),L(fd),L(ka),L(va),i&&t(f_),i&&t(Hn),L(gd),i&&t(g_),i&&t(nt),L(_d),L(Ld),L(wa),L(Ta),i&&t(__),i&&t(Kn),L(Fd),i&&t(b_),i&&t(st),L(xd),L(Ad),L($a),L(La),i&&t(k_),i&&t(Jn),L(Pd),i&&t(v_),i&&t(at),L(Nd),L(Hd),L(xa),L(Ea),i&&t(y_),i&&t(Yn),L(Qd),i&&t(w_),i&&t(rt),L(Kd),L(oc),L(Xa),L(za),i&&t(T_),i&&t(es),L(nc),i&&t(M_),i&&t(it),L(sc),L(hc),L(qa),L(ja)}}}const Aq={local:"xlmroberta",sections:[{local:"overview",title:"Overview"},{local:"resources",title:"Resources"},{local:"transformers.XLMRobertaConfig",title:"XLMRobertaConfig"},{local:"transformers.XLMRobertaTokenizer",title:"XLMRobertaTokenizer"},{local:"transformers.XLMRobertaTokenizerFast",title:"XLMRobertaTokenizerFast"},{local:"transformers.XLMRobertaModel",title:"XLMRobertaModel"},{local:"transformers.XLMRobertaForCausalLM",title:"XLMRobertaForCausalLM"},{local:"transformers.XLMRobertaForMaskedLM",title:"XLMRobertaForMaskedLM"},{local:"transformers.XLMRobertaForSequenceClassification",title:"XLMRobertaForSequenceClassification"},{local:"transformers.XLMRobertaForMultipleChoice",title:"XLMRobertaForMultipleChoice"},{local:"transformers.XLMRobertaForTokenClassification",title:"XLMRobertaForTokenClassification"},{local:"transformers.XLMRobertaForQuestionAnswering",title:"XLMRobertaForQuestionAnswering"},{local:"transformers.TFXLMRobertaModel",title:"TFXLMRobertaModel"},{local:"transformers.TFXLMRobertaForCausalLM",title:"TFXLMRobertaForCausalLM"},{local:"transformers.TFXLMRobertaForMaskedLM",title:"TFXLMRobertaForMaskedLM"},{local:"transformers.TFXLMRobertaForSequenceClassification",title:"TFXLMRobertaForSequenceClassification"},{local:"transformers.TFXLMRobertaForMultipleChoice",title:"TFXLMRobertaForMultipleChoice"},{local:"transformers.TFXLMRobertaForTokenClassification",title:"TFXLMRobertaForTokenClassification"},{local:"transformers.TFXLMRobertaForQuestionAnswering",title:"TFXLMRobertaForQuestionAnswering"},{local:"transformers.FlaxXLMRobertaModel",title:"FlaxXLMRobertaModel"},{local:"transformers.FlaxXLMRobertaForCausalLM",title:"FlaxXLMRobertaForCausalLM"},{local:"transformers.FlaxXLMRobertaForMaskedLM",title:"FlaxXLMRobertaForMaskedLM"},{local:"transformers.FlaxXLMRobertaForSequenceClassification",title:"FlaxXLMRobertaForSequenceClassification"},{local:"transformers.FlaxXLMRobertaForMultipleChoice",title:"FlaxXLMRobertaForMultipleChoice"},{local:"transformers.FlaxXLMRobertaForTokenClassification",title:"FlaxXLMRobertaForTokenClassification"},{local:"transformers.FlaxXLMRobertaForQuestionAnswering",title:"FlaxXLMRobertaForQuestionAnswering"}],title:"XLM-RoBERTa"};function Pq(E){return C8(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Bq extends E8{constructor(d){super();R8(this,d,Pq,jq,X8,{})}}export{Bq as default,Aq as metadata};
